/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ie=function(B){for(var t=[],i=0,y=B.length;i<y;i++)t[i]=re[B[i]];return t};const Ze=this,Xe=typeof global=="object"?global:{};var we;(function(B){B.global=Ze;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=t})(we||(we={}));var we;(function(B){class t{constructor(h,w,g){this.type=h,this.detail=w,this.timestamp=g}}B.LoaderEvent=t;class i{constructor(h){this._events=[new t(1,"",h)]}record(h,w){this._events.push(new t(h,w,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=i;class y{record(h,w){}getEvents(){return[]}}y.INSTANCE=new y,B.NullLoaderEventRecorder=y})(we||(we={}));var we;(function(B){class t{static fileUriToFilePath(y,M){if(M=decodeURI(M).replace(/%23/g,"#"),y){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(y,M){return y.length>=M.length&&y.substr(0,M.length)===M}static endsWith(y,M){return y.length>=M.length&&y.substr(y.length-M.length)===M}static containsQueryString(y){return/^[^\#]*\?/gi.test(y)}static isAbsolutePath(y){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(y)}static forEachProperty(y,M){if(y){let h;for(h in y)y.hasOwnProperty(h)&&M(h,y[h])}}static isEmpty(y){let M=!0;return t.forEachProperty(y,()=>{M=!1}),M}static recursiveClone(y){if(!y||typeof y!="object"||y instanceof RegExp||!Array.isArray(y)&&Object.getPrototypeOf(y)!==Object.prototype)return y;let M=Array.isArray(y)?[]:{};return t.forEachProperty(y,(h,w)=>{w&&typeof w=="object"?M[h]=t.recursiveClone(w):M[h]=w}),M}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(y){return t.startsWith(y,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,B.Utilities=t})(we||(we={}));var we;(function(B){function t(M){if(M instanceof Error)return M;const h=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(h.stack=M.stack),h}B.ensureError=t;class i{static validateConfigurationOptions(h){function w(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=w),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(B.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const g=t(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",h.onError(g),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,w=null){let g=B.Utilities.recursiveClone(w||{});return B.Utilities.forEachProperty(h,(a,u)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(u):a==="paths"&&typeof g.paths<"u"?B.Utilities.forEachProperty(u,(o,N)=>g.paths[o]=N):a==="config"&&typeof g.config<"u"?B.Utilities.forEachProperty(u,(o,N)=>g.config[o]=N):g[a]=B.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(g)}}B.ConfigurationOptionsUtil=i;class y{constructor(h,w){if(this._env=h,this.options=i.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(h,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:h,to:w}):this.sortedPathsRules.push({from:h,to:[w]})}),this.sortedPathsRules.sort((h,w)=>w.from.length-h.from.length)}cloneAndMerge(h){return new y(this._env,i.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let w;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if(w=this.sortedPathsRules[g],B.Utilities.startsWith(h,w.from)){let u=[];for(let o=0,N=w.to.length;o<N;o++)u.push(w.to[o]+h.substr(w.from.length));return u}return[h]}_addUrlArgsToUrl(h){return B.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let w=0,g=h.length;w<g;w++)h[w]=this._addUrlArgsToUrl(h[w]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let w=h,g;if(!B.Utilities.endsWith(w,".js")&&!B.Utilities.isAbsolutePath(w)){g=this._applyPaths(w);for(let a=0,u=g.length;a<u;a++)this.isBuild()&&g[a]==="empty:"||(B.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!B.Utilities.endsWith(g[a],".js")&&!B.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!B.Utilities.endsWith(w,".js")&&!B.Utilities.containsQueryString(w)&&(w=w+".js"),g=[w];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(h){let w=h;return B.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],B.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}B.Configuration=y})(we||(we={}));var we;(function(B){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,o,N,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new i;let b={callback:N,errorback:m};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(b);return}this._callbackMap[o]=[b],this._scriptLoader.load(u,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(u){let o=this._callbackMap[u];delete this._callbackMap[u];for(let N=0;N<o.length;N++)o[N].callback()}triggerErrorback(u,o){let N=this._callbackMap[u];delete this._callbackMap[u];for(let m=0;m<N.length;m++)N[m].errorback(o)}}class i{attachListeners(u,o,N){let m=()=>{u.removeEventListener("load",b),u.removeEventListener("error",e)},b=d=>{m(),o()},e=d=>{m(),N(d)};u.addEventListener("load",b),u.addEventListener("error",e)}load(u,o,N,m){if(/^node\|/.test(o)){let b=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),b.nodeRequire||B.global.nodeRequire),d=o.split("|"),p=null;try{p=e(d[1])}catch(E){m(E);return}u.enqueueDefineAnonymousModule([],()=>p),N()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,N,m);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),b.setAttribute("src",o);const{cspNonce:d}=u.getConfig().getOptionsLiteral();d&&b.setAttribute("nonce",d),document.getElementsByTagName("head")[0].appendChild(b)}}}function y(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=y(u)),this._cachedCanUseEval}load(u,o,N,m){if(/^node\|/.test(o)){const b=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),b.nodeRequire||B.global.nodeRequire),d=o.split("|");let p=null;try{p=e(d[1])}catch(E){m(E);return}u.enqueueDefineAnonymousModule([],function(){return p}),N()}else{const{trustedTypesPolicy:b}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(o).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${o}`,(b?self.eval(b.createScript("",d)):new Function(d)).call(self),N()}).then(void 0,m);return}try{b&&(o=b.createScriptURL(o)),importScripts(o),N()}catch(d){m(d)}}}}class h{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,o){const{nodeCachedData:N}=o.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,b=u("module");function e(d){const p=d.constructor;let E=function(v){try{return d.require(v)}finally{}};return E.resolve=function(v,j){return p._resolveFilename(v,d,!1,j)},E.resolve.paths=function(v){return p._resolveLookupPaths(v,d)},E.main=process.mainModule,E.extensions=p._extensions,E.cache=p._cache,E}b.prototype._compile=function(d,p){const E=b.wrap(d.replace(/^#!.*/,"")),$=o.getRecorder(),v=m._getCachedDataPath(N,p),j={filename:p};let l;try{const R=m._fs.readFileSync(v);l=R.slice(0,16),j.cachedData=R.slice(16),$.record(60,v)}catch{$.record(61,v)}const n=new m._vm.Script(E,j),s=n.runInThisContext(j),f=m._path.dirname(p),c=e(this),L=[this.exports,c,this,p,f,process,Xe,Buffer],A=s.apply(this.exports,L);return m._handleCachedData(n,E,v,!j.cachedData,o),m._verifyCachedData(n,E,v,l,o),A}}load(u,o,N,m){const b=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),b.nodeRequire||B.global.nodeRequire),d=b.nodeInstrumenter||function(E){return E};this._init(e),this._initNodeRequire(e,u);let p=u.getRecorder();if(/^node\|/.test(o)){let E=o.split("|"),$=null;try{$=e(E[1])}catch(v){m(v);return}u.enqueueDefineAnonymousModule([],()=>$),N()}else{o=B.Utilities.fileUriToFilePath(this._env.isWindows,o);const E=this._path.normalize(o),$=this._getElectronRendererScriptPathOrUri(E),v=!!b.nodeCachedData,j=v?this._getCachedDataPath(b.nodeCachedData,o):void 0;this._readSourceAndCachedData(E,j,p,(l,n,s,f)=>{if(l){m(l);return}let c;n.charCodeAt(0)===h._BOM?c=h._PREFIX+n.substring(1)+h._SUFFIX:c=h._PREFIX+n+h._SUFFIX,c=d(c,E);const L={filename:$,cachedData:s},A=this._createAndEvalScript(u,c,L,N,m);this._handleCachedData(A,c,j,v&&!s,u),this._verifyCachedData(A,c,j,f,u)})}}_createAndEvalScript(u,o,N,m,b){const e=u.getRecorder();e.record(31,N.filename);const d=new this._vm.Script(o,N),p=d.runInThisContext(N),E=u.getGlobalAMDDefineFunc();let $=!1;const v=function(){return $=!0,E.apply(null,arguments)};return v.amd=E.amd,p.call(B.global,u.getGlobalAMDRequireFunc(),v,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),$?m():b(new Error(`Didn't receive define call in ${N.filename}!`)),d}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let o=u.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,o){const N=this._crypto.createHash("md5").update(o,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(o).replace(/\.js$/,"");return this._path.join(u.path,`${m}-${N}.code`)}_handleCachedData(u,o,N,m,b){u.cachedDataRejected?this._fs.unlink(N,e=>{b.getRecorder().record(62,N),this._createAndWriteCachedData(u,o,N,b),e&&b.getConfig().onError(e)}):m&&this._createAndWriteCachedData(u,o,N,b)}_createAndWriteCachedData(u,o,N,m){let b=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,d=0,p;const E=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(o,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||d>=5)){if($.length<e){E();return}e=$.length,this._fs.writeFile(N,Buffer.concat([p,$]),v=>{v&&m.getConfig().onError(v),m.getRecorder().record(63,N),E()})}},b*Math.pow(4,d++))};E()}_readSourceAndCachedData(u,o,N,m){if(!o)this._fs.readFile(u,{encoding:"utf8"},m);else{let b,e,d,p=2;const E=$=>{$?m($):--p===0&&m(void 0,b,e,d)};this._fs.readFile(u,{encoding:"utf8"},($,v)=>{b=v,E($)}),this._fs.readFile(o,($,v)=>{!$&&v&&v.length>0?(d=v.slice(0,16),e=v.slice(16),N.record(60,o)):N.record(61,o),E()})}}_verifyCachedData(u,o,N,m,b){m&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();m.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,d=>{d&&b.getConfig().onError(d)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function w(a,u){if(u.__$__isRecorded)return u;const o=function(m){a.record(33,m);try{return u(m)}finally{a.record(34,m)}};return o.__$__isRecorded=!0,o}B.ensureRecordedNodeRequire=w;function g(a){return new t(a)}B.createScriptLoader=g})(we||(we={}));var we;(function(B){class t{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,o;for(o=/\/\.\//;o.test(u);)u=u.replace(o,"/");for(u=u.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(u);)u=u.replace(o,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return B.Utilities.isAbsolutePath(u)||(B.Utilities.startsWith(u,"./")||B.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),B.ModuleIdResolver=t;class i{constructor(a,u,o,N,m,b){this.id=a,this.strId=u,this.dependencies=o,this._callback=N,this._errorback=m,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(B.global,u),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(a,u,o,N){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(o,N):{returnedValue:o.apply(B.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,o,N){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let b=i._invokeFactory(u,this.strId,this._callback,o);m=b.producedError,a.record(22,this.strId),!m&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(m){let b=B.ensureError(m);b.phase="factory",b.moduleId=this.strId,b.neededBy=N(this.id),this.error=b,u.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}B.Module=i;class y{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class M{constructor(a){this.id=a}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),B.RegularDependency=M;class h{constructor(a,u,o){this.id=a,this.pluginId=u,this.pluginParam=o}}B.PluginDependency=h;class w{constructor(a,u,o,N,m=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=m,this._defineFunc=o,this._requireFunc=N,this._moduleIdProvider=new y,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let o=b=>b.replace(/\\/g,"/"),N=o(a),m=u.split(/\n/);for(let b=0;b<m.length;b++){let e=m[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let d=e[1],p=e[2],E=e[3],$=Math.max(d.lastIndexOf(" ")+1,d.lastIndexOf("(")+1);if(d=d.substr($),d=o(d),d===N){let v={line:parseInt(p,10),col:parseInt(E,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let o=0,N=this._modules2.length;o<N;o++){let m=this._modules2[o];if(!m)continue;let b=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,d=this._buildInfoDependencies[m.id];a[u++]={id:m.strId,path:b,defineLocation:b&&e?w._findRelevantLocationInStack(b,e):null,dependencies:d,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:a,callback:u}}defineModule(a,u,o,N,m,b=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let d=new i(e,a,this._normalizeDependencies(u,b),o,N,b);this._modules2[e]=d,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(d.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(d)}_normalizeDependency(a,u){if(a==="exports")return M.EXPORTS;if(a==="module")return M.MODULE;if(a==="require")return M.REQUIRE;let o=a.indexOf("!");if(o>=0){let N=u.resolveModule(a.substr(0,o)),m=u.resolveModule(a.substr(o+1)),b=this._moduleIdProvider.getModuleId(N+"!"+m),e=this._moduleIdProvider.getModuleId(N);return new h(b,e,m)}return new M(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let o=[],N=0;for(let m=0,b=a.length;m<b;m++)o[N++]=this._normalizeDependency(a[m],u);return o}_relativeRequire(a,u,o,N){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(B.Utilities.generateAnonymousModule(),u,o,N,null,a)}synchronousRequire(a,u=new t(a)){let o=this._normalizeDependency(a,u),N=this._modules2[o.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(a,u){let o=this._config.shouldRecordStats();u?this._config=new B.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let o=this._moduleIdProvider.getStrModuleId(a),N=(this._inverseDependencies2[a]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const m=B.ensureError(u);return m.phase="loading",m.moduleId=o,m.neededBy=N,m}_onLoadError(a,u){const o=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new i(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let N=[];for(let e=0,d=this._moduleIdProvider.getMaxModuleId();e<d;e++)N[e]=!1;let m=!1,b=[];for(b.push(a),N[a]=!0;b.length>0;){let e=b.shift(),d=this._modules2[e];d&&(m=d.onDependencyError(o)||m);let p=this._inverseDependencies2[e];if(p)for(let E=0,$=p.length;E<$;E++){let v=p[E];N[v]||(b.push(v),N[v]=!0)}}m||this._config.onError(o)}_hasDependencyPath(a,u){let o=this._modules2[a];if(!o)return!1;let N=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)N[b]=!1;let m=[];for(m.push(o),N[a]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let d=0,p=e.length;d<p;d++){let E=e[d];if(E.id===u)return!0;let $=this._modules2[E.id];$&&!N[E.id]&&(N[E.id]=!0,m.push($))}}return!1}_findCyclePath(a,u,o){if(a===u||o===50)return[a];let N=this._modules2[a];if(!N)return null;let m=N.dependencies;if(m)for(let b=0,e=m.length;b<e;b++){let d=this._findCyclePath(m[b].id,u,o+1);if(d!==null)return d.push(a),d}return null}_createRequire(a){let u=(o,N,m)=>this._relativeRequire(a,o,N,m);return u.toUrl=o=>this._config.requireToUrl(a.resolveModule(o)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(o,N=!1)=>{this.configure(o,N)},u.__$__nodeRequire=B.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),o=this._config.moduleIdToPaths(u),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||N.test(u))&&o.push("node|"+u);let m=-1,b=e=>{if(m++,m>=o.length)this._onLoadError(a,e);else{let d=o[m],p=this.getRecorder();if(this._config.isBuild()&&d==="empty:"){this._buildInfoPath[a]=d,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}p.record(10,d),this._scriptLoader.load(this,d,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=d),p.record(11,d),this._onLoad(a)},E=>{p.record(12,d),b(E)})}};b(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let o=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],N,null,null)};o.error=N=>{this._config.onError(this._createLoadError(u.id,N))},a.load(u.pluginParam,this._createRequire(t.ROOT),o,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let o=0,N=u.length;o<N;o++){let m=u[o];if(m===M.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===M.MODULE){a.unresolvedDependenciesCount--;continue}if(m===M.REQUIRE){a.unresolvedDependenciesCount--;continue}let b=this._modules2[m.id];if(b&&b.isComplete()){if(b.error){a.onDependencyError(b.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,a.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(d=>this._moduleIdProvider.getStrModuleId(d)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof h){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let d=this._inversePluginDependencies2.get(m.pluginId);d||(d=[],this._inversePluginDependencies2.set(m.pluginId,d)),d.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let o=a.dependencies,N=[];if(o)for(let d=0,p=o.length;d<p;d++){let E=o[d];if(E===M.EXPORTS){N[d]=a.exports;continue}if(E===M.MODULE){N[d]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(E===M.REQUIRE){N[d]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[E.id];if($){N[d]=$.exports;continue}N[d]=null}const m=d=>(this._inverseDependencies2[d]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));a.complete(u,this._config,N,m);let b=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,b)for(let d=0,p=b.length;d<p;d++){let E=b[d],$=this._modules2[E];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let d=0,p=e.length;d<p;d++)this._loadPluginDependency(a.exports,e[d])}}}B.ModuleManager=w})(we||(we={}));var ne,we;(function(B){const t=new B.Environment;let i=null;const y=function(g,a,u){typeof g!="string"&&(u=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),g?i.defineModule(g,a,u,null,null):i.enqueueDefineAnonymousModule(a,u)};y.amd={jQuery:!0};const M=function(g,a=!1){i.configure(g,a)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=M,h.getConfig=function(){return i.getConfig().getOptionsLiteral()},h.reset=function(){i=i.reset()},h.getBuildInfo=function(){return i.getBuildInfo()},h.getStats=function(){return i.getLoaderEvents()},h.define=y;function w(){if(typeof B.global.require<"u"||typeof require<"u"){const g=B.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=B.ensureRecordedNodeRequire(i.getRecorder(),g);B.global.nodeRequire=a,h.nodeRequire=a,h.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=h:(t.isElectronRenderer||(B.global.define=y),B.global.require=h)}B.init=w,(typeof B.global.define!="function"||!B.global.define.amd)&&(i=new B.ModuleManager(t,B.createScriptLoader(t),y,h,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&h.config(B.global.require),ne=function(){return y.apply(null,arguments)},ne.amd=y.amd,typeof doNotInitLoader>"u"&&w())})(we||(we={})),ne(re[75],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(g,a,u,o){if(o=o||{},(o["vs/css"]||{}).disabled){u({});return}const m=a.toUrl(g+".css");y(g,m,()=>{u({})},b=>{typeof u.error=="function"&&u.error("Could not find "+m+".")})}function y(g,a,u,o){if(M(g,a)){u();return}h(g,a,u,o)}function M(g,a){const u=window.document.getElementsByTagName("link");for(let o=0,N=u.length;o<N;o++){const m=u[o].getAttribute("data-name"),b=u[o].getAttribute("href");if(m===g||b===a)return!0}return!1}function h(g,a,u,o){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",g),w(g,N,u,o),N.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(N)}function w(g,a,u,o){const N=()=>{a.removeEventListener("load",m),a.removeEventListener("error",b)},m=e=>{N(),u()},b=e=>{N(),o(e)};a.addEventListener("load",m),a.addEventListener("error",b)}}),ne("vs/nls",["require","exports"],function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=o,t.localize2=N,t.getConfiguredDefaultLocale=m,t.setPseudoTranslation=b,t.create=e,t.load=d;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const y="i-default";function M(p,E){let $;return E.length===0?$=p:$=p.replace(/\{(\d+)\}/g,(v,j)=>{const l=j[0],n=E[l];let s=v;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function h(p,E){let $=p[E];return $||($=p["*"],$)?$:null}function w(p){return p.charAt(p.length-1)==="/"?p:p+"/"}async function g(p,E,$){const v=w(p)+w(E)+"vscode/"+w($),j=await fetch(v);if(j.ok)return await j.json();throw new Error(`${j.status} - ${j.statusText}`)}function a(p){return function(E,$){const v=Array.prototype.slice.call(arguments,2);return M(p[E],v)}}function u(p){return(E,$,...v)=>({value:M(p[E],v),original:M($,v)})}function o(p,E,...$){return M(E,$)}function N(p,E,...$){const v=M(E,$);return{value:v,original:v}}function m(p){}function b(p){i=p}function e(p,E){return{localize:a(E[p]),localize2:u(E[p]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??($=>{})}}function d(p,E,$,v){const j=v["vs/nls"]??{};if(!p||p.length===0)return $({localize:o,localize2:N,getConfiguredDefaultLocale:()=>j.availableLanguages?.["*"]});const l=j.availableLanguages?h(j.availableLanguages,p):null,n=l===null||l===y;let s=".nls";n||(s=s+"."+l);const f=c=>{Array.isArray(c)?(c.localize=a(c),c.localize2=u(c)):(c.localize=a(c[p]),c.localize2=u(c[p])),c.getConfiguredDefaultLocale=()=>j.availableLanguages?.["*"],$(c)};typeof j.loadBundle=="function"?j.loadBundle(p,l,(c,L)=>{c?E([p+".nls"],f):f(L)}):j.translationServiceUrl&&!n?(async()=>{try{const c=await g(j.translationServiceUrl,l,p);return f(c)}catch(c){if(!l.includes("-"))return console.error(c),E([p+".nls"],f);try{const L=l.split("-")[0],A=await g(j.translationServiceUrl,L,p);return j.availableLanguages??={},j.availableLanguages["*"]=L,f(A)}catch(L){return console.error(L),E([p+".nls"],f)}}})():E([p+s],f,c=>{if(s===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,c),E([p+".nls"],f)})}}),function(){const B=globalThis.MonacoEnvironment,t=B&&B.baseUrl?B.baseUrl:"../../../";function i(o,N){if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(o,N)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(o,N)}catch(m){console.warn(m);return}}const y=i("amdLoader",{createScriptURL:o=>o,createScript:(o,...N)=>{const m=N.slice(0,-1).join(","),b=N.pop().toString();return`(function anonymous(${m}) { ${b}
})`}});function M(){try{return(y?globalThis.eval(y.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((o,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return o();const m=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(y?globalThis.eval(y.createScript("",e)):new Function(e)).call(globalThis),o()}).then(void 0,N);return}y?importScripts(y.createScriptURL(m)):importScripts(m),o()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function g(o){h().then(()=>{w(),require([o],function(N){setTimeout(function(){const m=N.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>m.onmessage(b.data,b.ports);u.length>0;){const b=u.shift();m.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let a=!0;const u=[];globalThis.onmessage=o=>{if(!a){u.push(o);return}a=!1,g(o.data)}}(),ne(re[8],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=y,t.$hb=M,t.$ib=h,t.$jb=w,t.$kb=g,t.$lb=a,t.$nb=o,t.$ob=N,t.$pb=m,t.$qb=b,t.$rb=e;function i(d,p){const E=y(d,p);if(E!==-1)return d[E]}function y(d,p,E=d.length-1){for(let $=E;$>=0;$--){const v=d[$];if(p(v))return $}return-1}function M(d,p){const E=h(d,p);return E===-1?void 0:d[E]}function h(d,p,E=0,$=d.length){let v=E,j=$;for(;v<j;){const l=Math.floor((v+j)/2);p(d[l])?v=l+1:j=l}return v-1}function w(d,p){const E=g(d,p);return E===d.length?void 0:d[E]}function g(d,p,E=0,$=d.length){let v=E,j=$;for(;v<j;){const l=Math.floor((v+j)/2);p(d[l])?j=l:v=l+1}return v}function a(d,p,E=0,$=d.length){const v=g(d,p,E,$);return v===d.length?-1:v}class u{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!p($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const E=h(this.e,p,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}t.$mb=u;function o(d,p){if(d.length===0)return;let E=d[0];for(let $=1;$<d.length;$++){const v=d[$];p(v,E)>0&&(E=v)}return E}function N(d,p){if(d.length===0)return;let E=d[0];for(let $=1;$<d.length;$++){const v=d[$];p(v,E)>=0&&(E=v)}return E}function m(d,p){return o(d,(E,$)=>-p(E,$))}function b(d,p){if(d.length===0)return-1;let E=0;for(let $=1;$<d.length;$++){const v=d[$];p(v,d[E])>0&&(E=$)}return E}function e(d,p){for(const E of d){const $=p(E);if($!==void 0)return $}}}),ne(re[36],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=y,t.$M=M,t.$N=h;function i(w,g){const a=Object.create(null);for(const u of w){const o=g(u);let N=a[o];N||(N=a[o]=[]),N.push(u)}return a}function y(w,g){const a=[],u=[];for(const o of w)g.has(o)||a.push(o);for(const o of g)w.has(o)||u.push(o);return{removed:a,added:u}}function M(w,g){const a=[],u=[];for(const[o,N]of w)g.has(o)||a.push(N);for(const[o,N]of g)w.has(o)||u.push(N);return{removed:a,added:u}}function h(w,g){const a=new Set;for(const u of g)w.has(u)&&a.add(u);return a}}),ne(re[37],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_t=t.$$t=t.$0t=t.$9t=void 0;function i(g,a){const u=Math.pow(10,a);return Math.round(g*u)/u}class y{constructor(a,u,o,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,o))|0,this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.r===u.r&&a.g===u.g&&a.b===u.b&&a.a===u.a}}t.$9t=y;class M{constructor(a,u,o,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.l===u.l&&a.a===u.a}static fromRGBA(a){const u=a.r/255,o=a.g/255,N=a.b/255,m=a.a,b=Math.max(u,o,N),e=Math.min(u,o,N);let d=0,p=0;const E=(e+b)/2,$=b-e;if($>0){switch(p=Math.min(E<=.5?$/(2*E):$/(2-2*E),1),b){case u:d=(o-N)/$+(o<N?6:0);break;case o:d=(N-u)/$+2;break;case N:d=(u-o)/$+4;break}d*=60,d=Math.round(d)}return new M(d,p,E,m)}static i(a,u,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?a+(u-a)*6*o:o<1/2?u:o<2/3?a+(u-a)*(2/3-o)*6:a}static toRGBA(a){const u=a.h/360,{s:o,l:N,a:m}=a;let b,e,d;if(o===0)b=e=d=N;else{const p=N<.5?N*(1+o):N+o-N*o,E=2*N-p;b=M.i(E,p,u+1/3),e=M.i(E,p,u),d=M.i(E,p,u-1/3)}return new y(Math.round(b*255),Math.round(e*255),Math.round(d*255),m)}}t.$0t=M;class h{constructor(a,u,o,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,N),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.v===u.v&&a.a===u.a}static fromRGBA(a){const u=a.r/255,o=a.g/255,N=a.b/255,m=Math.max(u,o,N),b=Math.min(u,o,N),e=m-b,d=m===0?0:e/m;let p;return e===0?p=0:m===u?p=((o-N)/e%6+6)%6:m===o?p=(N-u)/e+2:p=(u-o)/e+4,new h(Math.round(p*60),d,m,a.a)}static toRGBA(a){const{h:u,s:o,v:N,a:m}=a,b=N*o,e=b*(1-Math.abs(u/60%2-1)),d=N-b;let[p,E,$]=[0,0,0];return u<60?(p=b,E=e):u<120?(p=e,E=b):u<180?(E=b,$=e):u<240?(E=e,$=b):u<300?(p=e,$=b):u<=360&&(p=b,$=e),p=Math.round((p+d)*255),E=Math.round((E+d)*255),$=Math.round(($+d)*255),new y(p,E,$,m)}}t.$$t=h;class w{static fromHex(a){return w.Format.CSS.parseHex(a)||w.red}static equals(a,u){return!a&&!u?!0:!a||!u?!1:a.equals(u)}get hsla(){return this.i?this.i:M.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:h.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof y)this.rgba=a;else if(a instanceof M)this.i=a,this.rgba=M.toRGBA(a);else if(a instanceof h)this.j=a,this.rgba=h.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&y.equals(this.rgba,a.rgba)&&M.equals(this.hsla,a.hsla)&&h.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=w.k(this.rgba.r),u=w.k(this.rgba.g),o=w.k(this.rgba.b),N=.2126*a+.7152*u+.0722*o;return i(N,4)}static k(a){const u=a/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u>o?(u+.05)/(o+.05):(o+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u>o}isDarkerThan(a){const u=this.getRelativeLuminance(),o=a.getRelativeLuminance();return u<o}lighten(a){return new w(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new w(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:u,g:o,b:N,a:m}=this.rgba;return new w(new y(u,o,N,m*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new y(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const u=a.rgba,o=this.rgba.a,N=u.a,m=o+N*(1-o);if(m<1e-6)return w.transparent;const b=this.rgba.r*o/m+u.r*N*(1-o)/m,e=this.rgba.g*o/m+u.g*N*(1-o)/m,d=this.rgba.b*o/m+u.b*N*(1-o)/m;return new w(new y(b,e,d,m))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:u,g:o,b:N,a:m}=this.rgba;return new w(new y(a.rgba.r-m*(a.rgba.r-u),a.rgba.g-m*(a.rgba.g-o),a.rgba.b-m*(a.rgba.b-N),1))}flatten(...a){const u=a.reduceRight((o,N)=>w.o(N,o));return w.o(this,u)}static o(a,u){const o=1-a.rgba.a;return new w(new y(o*u.rgba.r+a.rgba.a*a.rgba.r,o*u.rgba.g+a.rgba.a*a.rgba.g,o*u.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(a,u,o){if(a.isLighterThan(u))return a;o=o||.5;const N=a.getRelativeLuminance(),m=u.getRelativeLuminance();return o=o*(m-N)/m,a.lighten(o)}static getDarkerColor(a,u,o){if(a.isDarkerThan(u))return a;o=o||.5;const N=a.getRelativeLuminance(),m=u.getRelativeLuminance();return o=o*(N-m)/N,a.darken(o)}static{this.white=new w(new y(255,255,255,1))}static{this.black=new w(new y(0,0,0,1))}static{this.red=new w(new y(255,0,0,1))}static{this.blue=new w(new y(0,0,255,1))}static{this.green=new w(new y(0,255,0,1))}static{this.cyan=new w(new y(0,255,255,1))}static{this.lightgrey=new w(new y(211,211,211,1))}static{this.transparent=new w(new y(0,0,0,0))}}t.$_t=w,function(g){let a;(function(u){let o;(function(N){function m(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:g.Format.CSS.formatRGBA(n)}N.formatRGB=m;function b(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}N.formatRGBA=b;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(n)}N.formatHSL=e;function d(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}N.formatHSLA=d;function p(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function E(n){return`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}`}N.formatHex=E;function $(n,s=!1){return s&&n.rgba.a===1?g.Format.CSS.formatHex(n):`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}${p(Math.round(n.rgba.a*255))}`}N.formatHexA=$;function v(n){return n.isOpaque()?g.Format.CSS.formatHex(n):g.Format.CSS.formatRGBA(n)}N.format=v;function j(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),c=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),L=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new g(new y(f,c,L,1))}if(s===9){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),c=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),L=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),A=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new g(new y(f,c,L,A/255))}if(s===4){const f=l(n.charCodeAt(1)),c=l(n.charCodeAt(2)),L=l(n.charCodeAt(3));return new g(new y(16*f+f,16*c+c,16*L+L))}if(s===5){const f=l(n.charCodeAt(1)),c=l(n.charCodeAt(2)),L=l(n.charCodeAt(3)),A=l(n.charCodeAt(4));return new g(new y(16*f+f,16*c+c,16*L+L,(16*A+A)/255))}return null}N.parseHex=j;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(o=u.CSS||(u.CSS={}))})(a=g.Format||(g.Format={}))}(w||(t.$_t=w={}))}),ne(re[38],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dt=void 0;class i{constructor(M,h,w,g){this.originalStart=M,this.originalLength=h,this.modifiedStart=w,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Dt=i}),ne(re[3],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=y,t.$Z=M,t.$1=h,t.$2=w,t.$3=g,t.$4=u,t.$6=N,t.$7=m,t.$8=b,t.$0=d;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?v.isErrorNoTelemetry(n)?new v(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function y(l){t.$X.setUnexpectedErrorHandler(l)}function M(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function h(l){u(l)||t.$X.onUnexpectedError(l)}function w(l){u(l)||t.$X.onUnexpectedExternalError(l)}function g(l){if(l instanceof Error){const{name:n,message:s}=l,f=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:f,noTelemetry:v.isErrorNoTelemetry(l)}}return l}const a="Canceled";function u(l){return l instanceof o?!0:l instanceof Error&&l.name===a&&l.message===a}class o extends Error{constructor(){super(a),this.name=this.message}}t.$5=o;function N(){const l=new Error(a);return l.name=l.message,l}function m(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function b(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function d(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=p;class E extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=E;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class v extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof v)return n;const s=new v;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=v;class j extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,j.prototype)}}t.$cb=j}),ne(re[6],ie([0,1,3,8]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$9b=t.$8b=t.CompareResult=void 0,t.$sb=M,t.$tb=h,t.$ub=w,t.$vb=g,t.$wb=a,t.$xb=u,t.$yb=o,t.$zb=N,t.$Ab=m,t.$Bb=b,t.$Cb=e,t.$Db=d,t.$Eb=p,t.top=E,t.$Gb=$,t.$Hb=j,t.$Ib=l,t.$Jb=n,t.$Kb=s,t.$Lb=f,t.$Mb=c,t.$Nb=L,t.$Ob=A,t.$Pb=R,t.$Qb=P,t.$Rb=k,t.$Sb=S,t.$Tb=I,t.$Ub=D,t.$Vb=q,t.$Wb=H,t.$Xb=W,t.$Yb=U,t.$Zb=Z,t.$1b=X,t.$2b=J,t.$3b=_,t.$4b=K,t.$5b=F,t.$6b=fe,t.$7b=$e,t.$0b=ye;function M(O,V=0){return O[O.length-(1+V)]}function h(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}function w(O,V,C=(Y,ee)=>Y===ee){if(O===V)return!0;if(!O||!V||O.length!==V.length)return!1;for(let Y=0,ee=O.length;Y<ee;Y++)if(!C(O[Y],V[Y]))return!1;return!0}function g(O,V){const C=O.length-1;V<C&&(O[V]=O[C]),O.pop()}function a(O,V,C){return u(O.length,Y=>C(O[Y],V))}function u(O,V){let C=0,Y=O-1;for(;C<=Y;){const ee=(C+Y)/2|0,he=V(ee);if(he<0)C=ee+1;else if(he>0)Y=ee-1;else return ee}return-(C+1)}function o(O,V,C){if(O=O|0,O>=V.length)throw new TypeError("invalid index");const Y=V[Math.floor(V.length*Math.random())],ee=[],he=[],me=[];for(const ve of V){const pe=C(ve,Y);pe<0?ee.push(ve):pe>0?he.push(ve):me.push(ve)}return O<ee.length?o(O,ee,C):O<ee.length+me.length?me[0]:o(O-(ee.length+me.length),he,C)}function N(O,V){const C=[];let Y;for(const ee of O.slice(0).sort(V))!Y||V(Y[0],ee)!==0?(Y=[ee],C.push(Y)):Y.push(ee);return C}function*m(O,V){let C,Y;for(const ee of O)Y!==void 0&&V(Y,ee)?C.push(ee):(C&&(yield C),C=[ee]),Y=ee;C&&(yield C)}function b(O,V){for(let C=0;C<=O.length;C++)V(C===0?void 0:O[C-1],C===O.length?void 0:O[C])}function e(O,V){for(let C=0;C<O.length;C++)V(C===0?void 0:O[C-1],O[C],C+1===O.length?void 0:O[C+1])}function d(O,V,C){const Y=[];function ee(ve,pe,Ee){if(pe===0&&Ee.length===0)return;const se=Y[Y.length-1];se&&se.start+se.deleteCount===ve?(se.deleteCount+=pe,se.toInsert.push(...Ee)):Y.push({start:ve,deleteCount:pe,toInsert:Ee})}let he=0,me=0;for(;;){if(he===O.length){ee(he,0,V.slice(me));break}if(me===V.length){ee(he,O.length-he,[]);break}const ve=O[he],pe=V[me],Ee=C(ve,pe);Ee===0?(he+=1,me+=1):Ee<0?(ee(he,1,[]),he+=1):Ee>0&&(ee(he,0,[pe]),me+=1)}return Y}function p(O,V,C){const Y=d(O,V,C),ee=[],he=[];for(const me of Y)ee.push(...O.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:ee,added:he}}function E(O,V,C){if(C===0)return[];const Y=O.slice(0,C).sort(V);return v(O,V,Y,C,O.length),Y}function $(O,V,C,Y,ee){return C===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const ve=O.length,pe=O.slice(0,C).sort(V);for(let Ee=C,se=Math.min(C+Y,ve);Ee<ve;Ee=se,se=Math.min(se+Y,ve)){if(Ee>C&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new i.$5;v(O,V,pe,Ee,se)}return pe})().then(he,me)})}function v(O,V,C,Y,ee){for(const he=C.length;Y<ee;Y++){const me=O[Y];if(V(me,C[he-1])<0){C.pop();const ve=(0,y.$kb)(C,pe=>V(me,pe)<0);C.splice(ve,0,me)}}}function j(O){return O.filter(V=>!!V)}function l(O){let V=0;for(let C=0;C<O.length;C++)O[C]&&(O[V]=O[C],V+=1);O.length=V}function n(O,V,C){O.splice(C,0,O.splice(V,1)[0])}function s(O){return!Array.isArray(O)||O.length===0}function f(O){return Array.isArray(O)&&O.length>0}function c(O,V=C=>C){const C=new Set;return O.filter(Y=>{const ee=V(Y);return C.has(ee)?!1:(C.add(ee),!0)})}function L(O){const V=new Set;return C=>{const Y=O(C);return V.has(Y)?!1:(V.add(Y),!0)}}function A(O,V){return O.length>0?O[0]:V}function R(O,V){return O.length>0?O[O.length-1]:V}function P(O,V,C=(Y,ee)=>Y===ee){let Y=0;for(let ee=0,he=Math.min(O.length,V.length);ee<he&&C(O[ee],V[ee]);ee++)Y++;return Y}function k(O,V){let C=typeof V=="number"?O:0;typeof V=="number"?C=O:(C=0,V=O);const Y=[];if(C<=V)for(let ee=C;ee<V;ee++)Y.push(ee);else for(let ee=C;ee>V;ee--)Y.push(ee);return Y}function S(O,V,C){return O.reduce((Y,ee)=>(Y[V(ee)]=C?C(ee):ee,Y),Object.create(null))}function I(O,V){return O.push(V),()=>D(O,V)}function D(O,V){const C=O.indexOf(V);if(C>-1)return O.splice(C,1),V}function q(O,V,C){const Y=O.slice(0,V),ee=O.slice(V);return Y.concat(C,ee)}function H(O,V){let C;if(typeof V=="number"){let Y=V;C=()=>{const ee=Math.sin(Y++)*179426549;return ee-Math.floor(ee)}}else C=Math.random;for(let Y=O.length-1;Y>0;Y-=1){const ee=Math.floor(C()*(Y+1)),he=O[Y];O[Y]=O[ee],O[ee]=he}}function W(O,V){const C=O.indexOf(V);C>-1&&(O.splice(C,1),O.unshift(V))}function U(O,V){const C=O.indexOf(V);C>-1&&(O.splice(C,1),O.push(V))}function Z(O,V){for(const C of V)O.push(C)}function X(O,V){return Array.isArray(O)?O.map(V):V(O)}function J(O){return Array.isArray(O)?O:[O]}function _(O){return O[Math.floor(Math.random()*O.length)]}function K(O,V,C){const Y=z(O,V),ee=O.length,he=C.length;O.length=ee+he;for(let me=ee-1;me>=Y;me--)O[me+he]=O[me];for(let me=0;me<he;me++)O[me+Y]=C[me]}function F(O,V,C,Y){const ee=z(O,V);let he=O.splice(ee,C);return he===void 0&&(he=[]),K(O,ee,Y),he}function z(O,V){return V<0?Math.max(V+O.length,0):Math.min(V,O.length)}var oe;(function(O){function V(he){return he<0}O.isLessThan=V;function C(he){return he<=0}O.isLessThanOrEqual=C;function Y(he){return he>0}O.isGreaterThan=Y;function ee(he){return he===0}O.isNeitherLessOrGreaterThan=ee,O.greaterThan=1,O.lessThan=-1,O.neitherLessOrGreaterThan=0})(oe||(t.CompareResult=oe={}));function fe(O,V){return(C,Y)=>V(O(C),O(Y))}function $e(...O){return(V,C)=>{for(const Y of O){const ee=Y(V,C);if(!oe.isNeitherLessOrGreaterThan(ee))return ee}return oe.neitherLessOrGreaterThan}}const r=(O,V)=>O-V;t.$8b=r;const Re=(O,V)=>(0,t.$8b)(O?1:0,V?1:0);t.$9b=Re;function ye(O){return(V,C)=>-O(V,C)}class Ce{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let C=this.c;for(;C<this.g.length&&V(this.g[C]);)C++;const Y=C===this.c?null:this.g.slice(this.c,C);return this.c=C,Y}takeFromEndWhile(V){let C=this.d;for(;C>=0&&V(this.g[C]);)C--;const Y=C===this.d?null:this.g.slice(C+1,this.d+1);return this.d=C,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const C=this.g.slice(this.c,this.c+V);return this.c+=V,C}}t.$$b=Ce;class De{static{this.empty=new De(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(C=>(V(C),!0))}toArray(){const V=[];return this.iterate(C=>(V.push(C),!0)),V}filter(V){return new De(C=>this.iterate(Y=>V(Y)?C(Y):!0))}map(V){return new De(C=>this.iterate(Y=>C(V(Y))))}some(V){let C=!1;return this.iterate(Y=>(C=V(Y),!C)),C}findFirst(V){let C;return this.iterate(Y=>V(Y)?(C=Y,!1):!0),C}findLast(V){let C;return this.iterate(Y=>(V(Y)&&(C=Y),!0)),C}findLastMaxBy(V){let C,Y=!0;return this.iterate(ee=>((Y||oe.isGreaterThan(V(ee,C)))&&(Y=!1,C=ee),!0)),C}}t.$_b=De;class xe{constructor(V){this.c=V}static createSortPermutation(V,C){const Y=Array.from(V.keys()).sort((ee,he)=>C(V[ee],V[he]));return new xe(Y)}apply(V){return V.map((C,Y)=>V[this.c[Y]])}inverse(){const V=this.c.slice();for(let C=0;C<this.c.length;C++)V[this.c[C]]=C;return new xe(V)}}t.$ac=xe}),ne(re[10],ie([0,1,3]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=y,t.$ed=M,t.$fd=h,t.$gd=w,t.$hd=g,t.$id=a;function y(u,o){if(!u)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}function M(u,o="Unreachable"){throw new Error(o)}function h(u,o="unexpected state"){if(!u)throw new i.$cb(`Assertion Failed: ${o}`)}function w(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function g(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function a(u,o){let N=0;for(;N<u.length-1;){const m=u[N],b=u[N+1];if(!o(m,b))return!1;N++}return!0}}),ne(re[20],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(y,M){const h=this;let w=!1,g;return function(){if(w)return g;if(w=!0,M)try{g=y.apply(h,arguments)}finally{M()}else g=y.apply(h,arguments);return g}}}),ne(re[21],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(y){function M(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}y.is=M;const h=Object.freeze([]);function w(){return h}y.empty=w;function*g(n){yield n}y.single=g;function a(n){return M(n)?n:g(n)}y.wrap=a;function u(n){return n||h}y.from=u;function*o(n){for(let s=n.length-1;s>=0;s--)yield n[s]}y.reverse=o;function N(n){return!n||n[Symbol.iterator]().next().done===!0}y.isEmpty=N;function m(n){return n[Symbol.iterator]().next().value}y.first=m;function b(n,s){for(const f of n)if(s(f))return!0;return!1}y.some=b;function e(n,s){for(const f of n)if(s(f))return f}y.find=e;function*d(n,s){for(const f of n)s(f)&&(yield f)}y.filter=d;function*p(n,s){let f=0;for(const c of n)yield s(c,f++)}y.map=p;function*E(...n){for(const s of n)yield*s}y.concat=E;function $(n,s,f){let c=f;for(const L of n)c=s(c,L);return c}y.reduce=$;function*v(n,s,f=n.length){for(s<0&&(s+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);s<f;s++)yield n[s]}y.slice=v;function j(n,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,n];const c=n[Symbol.iterator]();for(let L=0;L<s;L++){const A=c.next();if(A.done)return[f,y.empty()];f.push(A.value)}return[f,{[Symbol.iterator](){return c}}]}y.consume=j;async function l(n){const s=[];for await(const f of n)s.push(f);return Promise.resolve(s)}y.asyncToArray=l})(i||(t.Iterable=i={}))}),ne(re[39],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Jr=t.$Ir=t.$Hr=t.$Gr=t.$Fr=t.ScanCode=t.KeyCode=void 0,t.$Kr=b;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(y||(t.ScanCode=y={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,p){this._keyCodeToStr[d]=p,this._strToKeyCode[p.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const h=new M,w=new M,g=new M;t.$Fr=new Array(230),t.$Gr={};const a=[],u=Object.create(null),o=Object.create(null);t.$Hr={lowerCaseToEnum:e=>o[e]||0,toEnum:e=>u[e]||0,toString:e=>a[e]||"None"},t.$Ir=[],t.$Jr=[];for(let e=0;e<=193;e++)t.$Ir[e]=-1;for(let e=0;e<=132;e++)t.$Jr[e]=-1;(function(){const e="",d=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],p=[],E=[];for(const $ of d){const[v,j,l,n,s,f,c,L,A]=$;if(E[j]||(E[j]=!0,a[j]=l,u[l]=j,o[l.toLowerCase()]=j,v&&(t.$Ir[j]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$Jr[n]=j))),!p[n]){if(p[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);h.define(n,s),w.define(n,L||s),g.define(n,A||L||s)}f&&(t.$Fr[f]=n),c&&(t.$Gr[c]=n)}t.$Jr[3]=46})();var N;(function(e){function d(l){return h.keyCodeToStr(l)}e.toString=d;function p(l){return h.strToKeyCode(l)}e.fromString=p;function E(l){return w.keyCodeToStr(l)}e.toUserSettingsUS=E;function $(l){return g.keyCodeToStr(l)}e.toUserSettingsGeneral=$;function v(l){return w.strToKeyCode(l)||g.strToKeyCode(l)}e.fromUserSettings=v;function j(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(l)}e.toElectronAccelerator=j})(N||(t.KeyCodeUtils=N={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(t.KeyMod=m={}));function b(e,d){const p=(d&65535)<<16>>>0;return(e|p)>>>0}}),ne(re[40],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),ne(re[22],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(h){this.element=h,this.next=i.Undefined,this.prev=i.Undefined}}class y{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let h=this.a;for(;h!==i.Undefined;){const w=h.next;h.prev=i.Undefined,h.next=i.Undefined,h=w}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,w){const g=new i(h);if(this.a===i.Undefined)this.a=g,this.b=g;else if(w){const u=this.b;this.b=g,g.prev=u,u.next=g}else{const u=this.a;this.a=g,g.next=u,u.prev=g}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(g))}}shift(){if(this.a!==i.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==i.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==i.Undefined&&h.next!==i.Undefined){const w=h.prev;w.next=h.next,h.next.prev=w}else h.prev===i.Undefined&&h.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):h.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):h.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==i.Undefined;)yield h.element,h=h.next}}t.$5c=y}),ne(re[14],ie([0,1]),function(B,t){"use strict";var i,y,M;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=h,t.$yc=w,t.$zc=g,t.$Ic=j;function h(l,n,s){let f=l.get(n);return f===void 0&&(f=s,l.set(n,f)),f}function w(l){const n=[];return l.forEach((s,f)=>{n.push(`${f} => ${s}`)}),`Map(${l.size}) {${n.join(", ")}}`}function g(l){const n=[];return l.forEach(s=>{n.push(s)}),`Set(${l.size}) {${n.join(", ")}}`}class a{constructor(n,s){this.uri=n,this.value=s}}function u(l){return Array.isArray(l)}class o{static{this.c=n=>n.toString()}constructor(n,s){if(this[i]="ResourceMap",n instanceof o)this.d=new Map(n.d),this.e=s??o.c;else if(u(n)){this.d=new Map,this.e=s??o.c;for(const[f,c]of n)this.set(f,c)}else this.d=new Map,this.e=n??o.c}set(n,s){return this.d.set(this.e(n),new a(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[f,c]of this.d)n(c.value,c.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}t.$Ac=o;class N{constructor(n,s){this[y]="ResourceSet",!n||typeof n=="function"?this.c=new o(n):(this.c=new o(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((f,c)=>n.call(s,c,c,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=N;var m;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(m||(t.Touch=m={}));class b{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=0){const f=this.c.get(n);if(f)return s!==0&&this.m(f,s),f.value}set(n,s,f=0){let c=this.c.get(n);if(c)c.value=s,f!==0&&this.m(c,f);else{switch(c={key:n,value:s,next:void 0,previous:void 0},f){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(n,c),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const f=this.g;let c=this.d;for(;c;){if(s?n.bind(s)(c.value,c.key,this):n(c.value,c.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.key,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return c}values(){const n=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.value,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return c}entries(){const n=this,s=this.g;let f=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:[f.key,f.value],done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return c}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,f=n.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.d)return;const f=n.next,c=n.previous;n===this.e?(c.next=void 0,this.e=c):(f.previous=c,c.next=f),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===2){if(n===this.e)return;const f=n.next,c=n.previous;n===this.d?(f.previous=void 0,this.d=f):(f.previous=c,c.next=f),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,f)=>{n.push([f,s])}),n}fromJSON(n){this.clear();for(const[s,f]of n)this.set(s,f)}}t.$Cc=b;class e extends b{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends e{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}t.$Dc=d;class p extends e{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}t.$Ec=p;class E{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}t.$Fc=E;class ${constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,f]of n)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((f,c)=>{n.call(s,f,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=$;class v{constructor(){this.c=new Map}add(n,s){let f=this.c.get(n);f||(f=new Set,this.c.set(n,f)),f.add(s)}delete(n,s){const f=this.c.get(n);f&&(f.delete(s),f.size===0&&this.c.delete(n))}forEach(n,s){const f=this.c.get(n);f&&f.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}t.$Hc=v;function j(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[s,f]of l)if(!n.has(s)||n.get(s)!==f)return!1;for(const[s]of n)if(!l.has(s))return!1;return!0}}),ne(re[11],ie([0,1,6,36,14,20,21]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=o,t.$Lc=N,t.$Mc=m,t.$Nc=d,t.$Oc=p,t.$Pc=E,t.$Qc=$,t.$Rc=v,t.$Sc=j,t.$3c=k;const g=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:u.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const H=this.c(D);H.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const H=q.get(D);if(H)return H;const W=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,W),W}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,H])=>H.source!==null&&!this.f(H,D).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(D=10,q){let H;if(q)H=q;else{const J=new Map,_=[...this.b.values()].filter(F=>F.source!==null&&!this.f(F,J).isSingleton);if(_.length===0)return;const K=new Set(_.map(F=>F.value));if(H=_.filter(F=>!(F.parent&&K.has(F.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function W(J){function _(F,z){for(;F.length>0&&z.some(oe=>typeof oe=="string"?oe===F[0]:F[0].match(oe));)F.shift()}const K=J.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return _(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const U=new M.$Hc;for(const J of H){const _=W(J);for(let K=0;K<=_.length;K++)U.add(_.slice(0,K).join(`
`),J)}H.sort((0,i.$6b)(J=>J.idx,i.$8b));let Z="",X=0;for(const J of H.slice(0,D)){X++;const _=W(J),K=[];for(let F=0;F<_.length;F++){let z=_[F];z=`(shared with ${U.get(_.slice(0,F+1).join(`
`)).size}/${H.length} leaks) at ${z}`;const fe=U.get(_.slice(0,F).join(`
`)),$e=(0,y.$K)([...fe].map(r=>W(r)[F]),r=>r);delete $e[_[F]];for(const[r,Re]of Object.entries($e))K.unshift(`    - stacktraces of ${Re.length} other leaks continue with ${r}`);K.unshift(z)}Z+=`


==================== Leaking disposable ${X}/${H.length}: ${J.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return H.length>D&&(Z+=`


... and ${H.length-D} more leaking disposables

`),{leaks:H,details:Z}}}t.$Jc=u;function o(I){a=I}if(g){const I="__is_disposable_tracked__";o(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[I]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==n.None)try{D[I]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[I]=!0}catch{}}markAsSingleton(D){}})}function N(I){return a?.trackDisposable(I),I}function m(I){a?.markAsDisposed(I)}function b(I,D){a?.setParent(I,D)}function e(I,D){if(a)for(const q of I)a.setParent(q,D)}function d(I){return a?.markAsSingleton(I),I}function p(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function E(I){if(w.Iterable.is(I)){const D=[];for(const q of I)if(q)try{q.dispose()}catch(H){D.push(H)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function $(I){for(const D of I)p(D)&&D.dispose();return[]}function v(...I){const D=j(()=>E(I));return e(I,D),D}function j(I){const D=N({dispose:(0,h.$db)(()=>{m(D),I()})});return D}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,N(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return b(D,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),b(D,null))}}t.$Tc=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,N(this),b(this.q,this)}dispose(){m(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Uc=n;class s{constructor(){this.b=!1,N(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&b(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&b(D,null),D}}t.$Vc=s;class f{constructor(D){this.a=new s,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=f;class c{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=c;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,m(this))},this}}t.$Yc=L;class A{constructor(){this.a=new Map}acquire(D,...q){let H=this.a.get(D);H||(H={counter:0,object:this.b(D,...q)},this.a.set(D,H));const{object:W}=H,U=(0,h.$db)(()=>{--H.counter===0&&(this.c(D,H.object),this.a.delete(D))});return H.counter++,{object:W,dispose:U}}}t.$Zc=A;class R{constructor(D){this.a=D}async acquire(D,...q){const H=this.a.acquire(D,...q);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(W){throw H.dispose(),W}}}t.$1c=R;class P{constructor(D){this.object=D}dispose(){}}t.$2c=P;function k(I){const D=new l;try{I(D)}finally{D.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,N(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,H=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=S}),ne(re[23],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class y{static create(h){return new y(h)}constructor(h){this.c=i&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$be=y}),ne(re[12],ie([0,1,3,20,11,22,23]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$de=t.Event=void 0,t.$ee=b;const g=!1,a=!1,u=!1;var o;(function(W){W.None=()=>M.$Uc.None;function U(se){if(u){const{onDidAddListener:te}=se,le=d.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function Z(se,te){return r(se,()=>{},0,void 0,!0,void 0,te)}W.defer=Z;function X(se){return(te,le=null,ue)=>{let ce=!1,ge;return ge=se(be=>{if(!ce)return ge?ge.dispose():ce=!0,te.call(le,be)},null,ue),ce&&ge.dispose(),ge}}W.once=X;function J(se,te,le){return fe((ue,ce=null,ge)=>se(be=>ue.call(ce,te(be)),null,ge),le)}W.map=J;function _(se,te,le){return fe((ue,ce=null,ge)=>se(be=>{te(be),ue.call(ce,be)},null,ge),le)}W.forEach=_;function K(se,te,le){return fe((ue,ce=null,ge)=>se(be=>te(be)&&ue.call(ce,be),null,ge),le)}W.filter=K;function F(se){return se}W.signal=F;function z(...se){return(te,le=null,ue)=>{const ce=(0,M.$Rc)(...se.map(ge=>ge(be=>te.call(le,be))));return $e(ce,ue)}}W.any=z;function oe(se,te,le,ue){let ce=le;return J(se,ge=>(ce=te(ce,ge),ce),ue)}W.reduce=oe;function fe(se,te){let le;const ue={onWillAddFirstListener(){le=se(ce.fire,ce)},onDidRemoveLastListener(){le?.dispose()}};te||U(ue);const ce=new s(ue);return te?.add(ce),ce.event}function $e(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function r(se,te,le=100,ue=!1,ce=!1,ge,be){let Le,Ne,Te,Me=0,qe;const Ve={leakWarningThreshold:ge,onWillAddFirstListener(){Le=se(ze=>{Me++,Ne=te(Ne,ze),ue&&!Te&&(Ue.fire(Ne),Ne=void 0),qe=()=>{const We=Ne;Ne=void 0,Te=void 0,(!ue||Me>1)&&Ue.fire(We),Me=0},typeof le=="number"?(clearTimeout(Te),Te=setTimeout(qe,le)):Te===void 0&&(Te=0,queueMicrotask(qe))})},onWillRemoveListener(){ce&&Me>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,Le.dispose()}};be||U(Ve);const Ue=new s(Ve);return be?.add(Ue),Ue.event}W.debounce=r;function Re(se,te=0,le){return W.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,le)}W.accumulate=Re;function ye(se,te=(ue,ce)=>ue===ce,le){let ue=!0,ce;return K(se,ge=>{const be=ue||!te(ge,ce);return ue=!1,ce=ge,be},le)}W.latch=ye;function Ce(se,te,le){return[W.filter(se,te,le),W.filter(se,ue=>!te(ue),le)]}W.split=Ce;function De(se,te=!1,le=[],ue){let ce=le.slice(),ge=se(Ne=>{ce?ce.push(Ne):Le.fire(Ne)});ue&&ue.add(ge);const be=()=>{ce?.forEach(Ne=>Le.fire(Ne)),ce=null},Le=new s({onWillAddFirstListener(){ge||(ge=se(Ne=>Le.fire(Ne)),ue&&ue.add(ge))},onDidAddFirstListener(){ce&&(te?setTimeout(be):be())},onDidRemoveLastListener(){ge&&ge.dispose(),ge=null}});return ue&&ue.add(Le),Le.event}W.buffer=De;function xe(se,te){return(ue,ce,ge)=>{const be=te(new V);return se(function(Le){const Ne=be.evaluate(Le);Ne!==O&&ue.call(ce,Ne)},void 0,ge)}}W.chain=xe;const O=Symbol("HaltChainable");class V{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(le=>(te(le),le)),this}filter(te){return this.f.push(le=>te(le)?le:O),this}reduce(te,le){let ue=le;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(le,ue)=>le===ue){let le=!0,ue;return this.f.push(ce=>{const ge=le||!te(ce,ue);return le=!1,ue=ce,ge?ce:O}),this}evaluate(te){for(const le of this.f)if(te=le(te),te===O)break;return te}}function C(se,te,le=ue=>ue){const ue=(...Le)=>be.fire(le(...Le)),ce=()=>se.on(te,ue),ge=()=>se.removeListener(te,ue),be=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return be.event}W.fromNodeEventEmitter=C;function Y(se,te,le=ue=>ue){const ue=(...Le)=>be.fire(le(...Le)),ce=()=>se.addEventListener(te,ue),ge=()=>se.removeEventListener(te,ue),be=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return be.event}W.fromDOMEventEmitter=Y;function ee(se){return new Promise(te=>X(se)(te))}W.toPromise=ee;function he(se){const te=new s;return se.then(le=>{te.fire(le)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}W.fromPromise=he;function me(se,te,le){return te(le),se(ue=>te(ue))}W.runAndSubscribe=me;class ve{constructor(te,le){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||U(ue),this.emitter=new s(ue),le&&le.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,le){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(se,te){return new ve(se,te).emitter.event}W.fromObservable=pe;function Ee(se){return(te,le,ue)=>{let ce=0,ge=!1;const be={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),ge&&(ge=!1,te.call(le)))},handlePossibleChange(){},handleChange(){ge=!0}};se.addObserver(be),se.reportChanges();const Le={dispose(){se.removeObserver(be)}};return ue instanceof M.$Tc?ue.add(Le):Array.isArray(ue)&&ue.push(Le),Le}}W.fromObservableLight=Ee})(o||(t.Event=o={}));class N{static{this.all=new Set}static{this.f=0}constructor(U){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${U}_${N.f++}`,N.all.add(this)}start(U){this.g=new w.$be,this.listenerCount=U}stop(){if(this.g){const U=this.g.elapsed();this.durations.push(U),this.elapsedOverall+=U,this.invocationCount+=1,this.g=void 0}}}t.$de=N;let m=-1;function b(W){const U=m;return m=W,{dispose(){m=U}}}class e{constructor(U,Z,X=Math.random().toString(18).slice(2,5)){this.h=U,this.threshold=Z,this.name=X,this.g=0}dispose(){this.f?.clear()}check(U,Z){const X=this.threshold;if(X<=0||Z<X)return;this.f||(this.f=new Map);const J=this.f.get(U.value)||0;if(this.f.set(U.value,J+1),this.g-=1,this.g<=0){this.g=X*.5;const[_,K]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${Z} listeners already. MOST frequent listener (${K}):`;console.warn(F),console.warn(_);const z=new p(F,_);this.h(z)}return()=>{const _=this.f.get(U.value)||0;this.f.set(U.value,_-1)}}getMostFrequentStack(){if(!this.f)return;let U,Z=0;for(const[X,J]of this.f)(!U||Z<J)&&(U=[X,J],Z=J);return U}}class d{static create(){const U=new Error;return new d(U.stack??"")}constructor(U){this.value=U}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p extends Error{constructor(U,Z){super(U),this.name="ListenerLeakError",this.stack=Z}}t.$fe=p;class E extends Error{constructor(U,Z){super(U),this.name="ListenerRefusalError",this.stack=Z}}t.$ge=E;let $=0;class v{constructor(U){this.value=U,this.id=$++}}const j=2,l=(W,U)=>{if(W instanceof v)U(W);else for(let Z=0;Z<W.length;Z++){const X=W[Z];X&&U(X)}},n=g?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class s{constructor(U){this.w=0,this.f=U,this.g=m>0||this.f?.leakWarningThreshold?new e(U?.onListenerError??i.$1,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new N(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const U=this.t;queueMicrotask(()=>{l(U,Z=>Z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(U,Z,X)=>{if(this.g&&this.w>this.g.threshold*3){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(z);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],fe=new E(`${z}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||i.$1)(fe),M.$Uc.None}if(this.m)return M.$Uc.None;Z&&(U=U.bind(Z));const J=new v(U);let _,K;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(J.stack=d.create(),_=this.g.check(J.stack,this.w+1)),a&&(J.stack=K??d.create()),this.t?this.t instanceof v?(this.u??=new c,this.t=[this.t,J]):this.t.push(J):(this.f?.onWillAddFirstListener?.(this),this.t=J,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,M.$Sc)(()=>{n?.unregister(F),_?.(),this.x(J)});if(X instanceof M.$Tc?X.add(F):Array.isArray(X)&&X.push(F),n){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(F,z,F)}return F},this.q}x(U){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const Z=this.t,X=Z.indexOf(U);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,Z[X]=void 0;const J=this.u.current===this;if(this.w*j<=Z.length){let _=0;for(let K=0;K<Z.length;K++)Z[K]?Z[_++]=Z[K]:J&&(this.u.end--,_<this.u.i&&this.u.i--);Z.length=_}}y(U,Z){if(!U)return;const X=this.f?.onListenerError||i.$1;if(!X){U.value(Z);return}try{U.value(Z)}catch(J){X(J)}}z(U){const Z=U.current.t;for(;U.i<U.end;)this.y(Z[U.i++],U.value);U.reset()}fire(U){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof v)this.y(this.t,U);else{const Z=this.u;Z.enqueue(this,U,this.t.length),this.z(Z)}this.j?.stop()}hasListeners(){return this.w>0}}t.$he=s;const f=()=>new c;t.$ie=f;class c{constructor(){this.i=-1,this.end=0}enqueue(U,Z,X){this.i=0,this.end=X,this.current=U,this.value=Z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends s{async fireAsync(U,Z,X){if(this.t)for(this.h||(this.h=new h.$5c),l(this.t,J=>this.h.push([J.value,U]));this.h.size>0&&!Z.isCancellationRequested;){const[J,_]=this.h.shift(),K=[],F={..._,token:Z,waitUntil:z=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");X&&(z=X(z,J)),K.push(z)}};try{J(F)}catch(z){(0,i.$1)(z);continue}Object.freeze(K),await Promise.allSettled(K).then(z=>{for(const oe of z)oe.status==="rejected"&&(0,i.$1)(oe.reason)})}}}t.$je=L;class A extends s{get isPaused(){return this.h!==0}constructor(U){super(U),this.h=0,this.s=new h.$5c,this.A=U?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const U=Array.from(this.s);this.s.clear(),super.fire(this.A(U))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(U){this.w&&(this.h!==0?this.s.push(U):super.fire(U))}}t.$ke=A;class R extends A{constructor(U){super(U),this.k=U.delay??100}fire(U){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(U)}}t.$le=R;class P extends s{constructor(U){super(U),this.h=[],this.k=U?.merge}fire(U){this.hasListeners()&&(this.h.push(U),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Z=>super.fire(Z)),this.h=[]}))}}t.$me=P;class k{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(U){const Z={event:U,listener:null};this.h.push(Z),this.g&&this.m(Z);const X=()=>{this.g&&this.o(Z);const J=this.h.indexOf(Z);this.h.splice(J,1)};return(0,M.$Sc)((0,y.$db)(X))}j(){this.g=!0,this.h.forEach(U=>this.m(U))}k(){this.g=!1,this.h.forEach(U=>this.o(U))}m(U){U.listener=U.event(Z=>this.f.fire(Z))}o(U){U.listener?.dispose(),U.listener=null}dispose(){this.f.dispose();for(const U of this.h)U.listener?.dispose();this.h=[]}}t.$ne=k;class S{constructor(U,Z,X,J){this.f=new M.$Tc;const _=this.f.add(new k),K=this.f.add(new M.$4c);function F(z){K.set(z,_.add(J(z)))}for(const z of U)F(z);this.f.add(Z(z=>{F(z)})),this.f.add(X(z=>{K.deleteAndDispose(z)})),this.event=_.event}dispose(){this.f.dispose()}}t.$oe=S;class I{constructor(){this.f=[]}wrapEvent(U,Z,X){return(J,_,K)=>U(F=>{const z=this.f[this.f.length-1];if(!Z){z?z.buffers.push(()=>J.call(_,F)):J.call(_,F);return}const oe=z;if(!oe){J.call(_,Z(X,F));return}oe.items??=[],oe.items.push(F),oe.buffers.length===0&&z.buffers.push(()=>{oe.reducedResult??=X?oe.items.reduce(Z,X):oe.items.reduce(Z),J.call(_,oe.reducedResult)})},void 0,K)}bufferEvents(U){const Z={buffers:new Array};this.f.push(Z);const X=U();return this.f.pop(),Z.buffers.forEach(J=>J()),X}}t.$pe=I;class D{constructor(){this.f=!1,this.g=o.None,this.h=M.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(U){this.g=U,this.f&&(this.h.dispose(),this.h=U(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$qe=D;class q{static const(U){return new H(U)}constructor(U){this.g=U,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(U){U!==this.g&&(this.g=U,this.f.fire(void 0))}}t.$re=q;class H{constructor(U){this.value=U,this.onDidChange=o.None}}}),ne(re[24],ie([0,1,12]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$se=t.CancellationToken=void 0,t.$te=g;const y=Object.freeze(function(a,u){const o=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(o)}}});var M;(function(a){function u(o){return o===a.None||o===a.Cancelled||o instanceof h?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(M||(t.CancellationToken=M={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?y:(this.b||(this.b=new i.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=M.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=M.None}}t.$se=w;function g(a){const u=new w;return a.add({dispose(){u.cancel()}}),u.token}}),ne(re[41],ie([0,1,24]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8e=t.$7e=t.$5e=void 0,t.$6e=M;class y{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new i.$se,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}t.$5e=y;function M(g){return g}class h{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=M):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}t.$7e=h;class w{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=M):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const o=this.c(a);return this.a.set(a,o),this.b.set(u,o),o}}t.$8e=w}),ne(re[7],ie([0,1,41,40]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_f=t.$$f=t.$0f=t.GraphemeBreakType=t.$Zf=t.$Rf=t.$Kf=t.$Jf=void 0,t.$$e=M,t.$_e=w,t.$af=a,t.$bf=u,t.$cf=o,t.$df=N,t.$ef=m,t.$ff=b,t.$gf=e,t.$hf=d,t.$if=p,t.$jf=E,t.$kf=$,t.$lf=v,t.$mf=j,t.$nf=l,t.$of=n,t.$pf=s,t.$qf=f,t.$rf=c,t.$sf=L,t.$tf=A,t.$uf=R,t.$vf=P,t.$wf=k,t.$xf=S,t.$yf=I,t.$zf=D,t.$Af=q,t.$Bf=H,t.$Cf=W,t.$Df=U,t.$Ef=Z,t.$Ff=X,t.$Gf=J,t.$Hf=_,t.$If=K,t.$Lf=fe,t.$Mf=$e,t.$Nf=r,t.$Of=Re,t.$Pf=De,t.$Qf=O,t.$Sf=V,t.$Tf=C,t.$Uf=Y,t.$Vf=ee,t.$Wf=me,t.$Xf=ve,t.$Yf=Ee,t.$1f=se,t.$2f=te,t.$3f=le,t.$4f=ue,t.$5f=ce,t.$6f=ge,t.$7f=be,t.$8f=Le,t.$9f=Ve;function M(T){return!T||typeof T!="string"?!0:T.trim().length===0}const h=/{(\d+)}/g;function w(T,...x){return x.length===0?T:T.replace(h,function(G,Q){const ae=parseInt(Q,10);return isNaN(ae)||ae<0||ae>=x.length?G:x[ae]})}const g=/{([^}]+)}/g;function a(T,x){return Object.keys(x).length===0?T:T.replace(g,(G,Q)=>x[Q]??G)}function u(T){return T.replace(/[<>"'&]/g,x=>{switch(x){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return x})}function o(T){return T.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}function N(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(T,x){let G=0,Q=T.indexOf(x);for(;Q!==-1;)G++,Q=T.indexOf(x,Q+x.length);return G}function b(T,x,G="\u2026"){return T.length<=x?T:`${T.substr(0,x)}${G}`}function e(T,x,G="\u2026"){if(T.length<=x)return T;const Q=Math.ceil(x/2)-G.length/2,ae=Math.floor(x/2)-G.length/2;return`${T.substr(0,Q)}${G}${T.substr(T.length-ae)}`}function d(T,x=" "){const G=p(T,x);return E(G,x)}function p(T,x){if(!T||!x)return T;const G=x.length;if(G===0||T.length===0)return T;let Q=0;for(;T.indexOf(x,Q)===Q;)Q=Q+G;return T.substring(Q)}function E(T,x){if(!T||!x)return T;const G=x.length,Q=T.length;if(G===0||Q===0)return T;let ae=Q,de=-1;for(;de=T.lastIndexOf(x,ae-1),!(de===-1||de+G!==ae);){if(de===0)return"";ae=de}return T.substring(0,ae)}function $(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(T){return T.replace(/\*/g,"")}function j(T,x,G={}){if(!T)throw new Error("Cannot create regex from empty string");x||(T=N(T)),G.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return G.global&&(Q+="g"),G.matchCase||(Q+="i"),G.multiline&&(Q+="m"),G.unicode&&(Q+="u"),new RegExp(T,Q)}function l(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function n(T){return T.split(/\r\n|\r|\n/)}function s(T){const x=[],G=T.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(G.length/2);Q++)x.push(G[2*Q]+(G[2*Q+1]??""));return x}function f(T){for(let x=0,G=T.length;x<G;x++){const Q=T.charCodeAt(x);if(Q!==32&&Q!==9)return x}return-1}function c(T,x=0,G=T.length){for(let Q=x;Q<G;Q++){const ae=T.charCodeAt(Q);if(ae!==32&&ae!==9)return T.substring(x,Q)}return T.substring(x,G)}function L(T,x=T.length-1){for(let G=x;G>=0;G--){const Q=T.charCodeAt(G);if(Q!==32&&Q!==9)return G}return-1}function A(T,x,G){const Q=[];let ae=0;for(const de of T.matchAll(x)){if(Q.push(T.slice(ae,de.index)),de.index===void 0)throw new Error("match.index should be defined");ae=de.index+de[0].length,Q.push(G(de[0],...de.slice(1),de.index,T,de.groups))}return Q.push(T.slice(ae)),Promise.all(Q).then(de=>de.join(""))}function R(T,x){return T<x?-1:T>x?1:0}function P(T,x,G=0,Q=T.length,ae=0,de=x.length){for(;G<Q&&ae<de;G++,ae++){const Pe=T.charCodeAt(G),Fe=x.charCodeAt(ae);if(Pe<Fe)return-1;if(Pe>Fe)return 1}const je=Q-G,Se=de-ae;return je<Se?-1:je>Se?1:0}function k(T,x){return S(T,x,0,T.length,0,x.length)}function S(T,x,G=0,Q=T.length,ae=0,de=x.length){for(;G<Q&&ae<de;G++,ae++){let Pe=T.charCodeAt(G),Fe=x.charCodeAt(ae);if(Pe===Fe)continue;if(Pe>=128||Fe>=128)return P(T.toLowerCase(),x.toLowerCase(),G,Q,ae,de);D(Pe)&&(Pe-=32),D(Fe)&&(Fe-=32);const Ae=Pe-Fe;if(Ae!==0)return Ae}const je=Q-G,Se=de-ae;return je<Se?-1:je>Se?1:0}function I(T){return T>=48&&T<=57}function D(T){return T>=97&&T<=122}function q(T){return T>=65&&T<=90}function H(T,x){return T.length===x.length&&S(T,x)===0}function W(T,x){const G=x.length;return x.length>T.length?!1:S(T,x,0,G)===0}function U(T,x){const G=Math.min(T.length,x.length);let Q;for(Q=0;Q<G;Q++)if(T.charCodeAt(Q)!==x.charCodeAt(Q))return Q;return G}function Z(T,x){const G=Math.min(T.length,x.length);let Q;const ae=T.length-1,de=x.length-1;for(Q=0;Q<G;Q++)if(T.charCodeAt(ae-Q)!==x.charCodeAt(de-Q))return Q;return G}function X(T){return 55296<=T&&T<=56319}function J(T){return 56320<=T&&T<=57343}function _(T,x){return(T-55296<<10)+(x-56320)+65536}function K(T,x,G){const Q=T.charCodeAt(G);if(X(Q)&&G+1<x){const ae=T.charCodeAt(G+1);if(J(ae))return _(Q,ae)}return Q}function F(T,x){const G=T.charCodeAt(x-1);if(J(G)&&x>1){const Q=T.charCodeAt(x-2);if(X(Q))return _(Q,G)}return G}class z{get offset(){return this.e}constructor(x,G=0){this.c=x,this.d=x.length,this.e=G}setOffset(x){this.e=x}prevCodePoint(){const x=F(this.c,this.e);return this.e-=x>=65536?2:1,x}nextCodePoint(){const x=K(this.c,this.d,this.e);return this.e+=x>=65536?2:1,x}eol(){return this.e>=this.d}}t.$Jf=z;class oe{get offset(){return this.c.offset}constructor(x,G=0){this.c=new z(x,G)}nextGraphemeLength(){const x=Me.getInstance(),G=this.c,Q=G.offset;let ae=x.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const de=G.offset,je=x.getGraphemeBreakType(G.nextCodePoint());if(Ne(ae,je)){G.setOffset(de);break}ae=je}return G.offset-Q}prevGraphemeLength(){const x=Me.getInstance(),G=this.c,Q=G.offset;let ae=x.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const de=G.offset,je=x.getGraphemeBreakType(G.prevCodePoint());if(Ne(je,ae)){G.setOffset(de);break}ae=je}return Q-G.offset}eol(){return this.c.eol()}}t.$Kf=oe;function fe(T,x){return new oe(T,x).nextGraphemeLength()}function $e(T,x){return new oe(T,x).prevGraphemeLength()}function r(T,x){x>0&&J(T.charCodeAt(x))&&x--;const G=x+fe(T,x);return[G-$e(T,G),G]}function Re(T){const x=new oe(T);let G=0;for(;!x.eol();)G++,x.nextGraphemeLength();return G}let ye;function Ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(T){return ye||(ye=Ce()),ye.test(T)}const xe=/^[\t\n\r\x20-\x7E]*$/;function O(T){return xe.test(T)}t.$Rf=/[\u2028\u2029]/;function V(T){return t.$Rf.test(T)}function C(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function Y(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function ee(T,x,G=""){const Q=T.trimStart();if(Q.length<x)return Q;const ae=/\b/g;let de=0;for(;ae.test(Q)&&!(Q.length-ae.lastIndex<x);)de=ae.lastIndex,ae.lastIndex+=1;return de===0?Q:G+Q.substring(de).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(T){let x=0;for(const G of T.matchAll(he))x!==G.index&&(yield{isCode:!1,str:T.substring(x,G.index)}),yield{isCode:!0,str:G[0]},x=G.index+G[0].length;x!==T.length&&(yield{isCode:!1,str:T.substring(x)})}function ve(T){return T&&(T=T.replace(he,"")),T}const pe=/\\\[.*?\\\]/g;function Ee(T){return ve(T).replace(pe,"")}t.$Zf="\uFEFF";function se(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function te(T){return se(T)?T.substr(1):T}function le(T,x){if(!T||!x||T.length<x.length)return!1;const G=x.length,Q=T.toLowerCase();let ae=0,de=-1;for(;ae<G;){const je=Q.indexOf(x[ae],de+1);if(je<0)return!1;de=je,ae++}return!0}function ue(T,x=!1){return T?(x&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function ce(T){return T.charAt(0).toUpperCase()+T.slice(1)}function ge(T,x=1){if(x===0)return"";let G=-1;do G=T.indexOf(`
`,G+1),x--;while(x>0&&G>=0);return G===-1?T:(T[G-1]==="\r"&&G--,T.substr(0,G))}function be(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function Le(T){return Me.getInstance().getGraphemeBreakType(T)}function Ne(T,x){return T===0?x!==5&&x!==7:T===2&&x===3?!1:T===4||T===2||T===3||x===4||x===2||x===3?!0:!(T===8&&(x===8||x===9||x===11||x===12)||(T===11||T===9)&&(x===9||x===10)||(T===12||T===10)&&x===10||x===5||x===13||x===7||T===1||T===13&&x===14||T===6&&x===6)}var Te;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(t.GraphemeBreakType=Te={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=qe()}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const G=this.d,Q=G.length/3;let ae=1;for(;ae<=Q;)if(x<G[3*ae])ae=2*ae;else if(x>G[3*ae+1])ae=2*ae+1;else return G[3*ae+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(T,x){if(T===0)return 0;const G=Ue(T,x);if(G!==void 0)return G;const Q=new z(x,T);return Q.prevCodePoint(),Q.offset}function Ue(T,x){const G=new z(x,T);let Q=G.prevCodePoint();for(;ze(Q)||Q===65039||Q===8419;){if(G.offset===0)return;Q=G.prevCodePoint()}if(!Y(Q))return;let ae=G.offset;return ae>0&&G.prevCodePoint()===8205&&(ae=G.offset),ae}function ze(T){return 127995<=T&&T<=127999}var We;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$0f="\xA0";class Oe{static{this.c=new y.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$7e({getCacheKey:JSON.stringify},x=>{function G(Ae){const Ie=new Map;for(let ke=0;ke<Ae.length;ke+=2)Ie.set(Ae[ke],Ae[ke+1]);return Ie}function Q(Ae,Ie){const ke=new Map(Ae);for(const[He,Ge]of Ie)ke.set(He,Ge);return ke}function ae(Ae,Ie){if(!Ae)return Ie;const ke=new Map;for(const[He,Ge]of Ae)Ie.has(He)&&ke.set(He,Ge);return ke}const de=this.c.value;let je=x.filter(Ae=>!Ae.startsWith("_")&&Ae in de);je.length===0&&(je=["_default"]);let Se;for(const Ae of je){const Ie=G(de[Ae]);Se=ae(Se,Ie)}const Pe=G(de._common),Fe=Q(Pe,Se);return new Oe(Fe)})}static getInstance(x){return Oe.d.get(Array.from(x))}static{this.e=new y.$V(()=>Object.keys(Oe.c.value).filter(x=>!x.startsWith("_")))}static getLocales(){return Oe.e.value}constructor(x){this.f=x}isAmbiguous(x){return this.f.has(x)}containsAmbiguousCharacter(x){for(let G=0;G<x.length;G++){const Q=x.codePointAt(G);if(typeof Q=="number"&&this.isAmbiguous(Q))return!0}return!1}getPrimaryConfusable(x){return this.f.get(x)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$$f=Oe;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(x){return Be.e().has(x)}static containsInvisibleCharacter(x){for(let G=0;G<x.length;G++){const Q=x.codePointAt(G);if(typeof Q=="number"&&Be.isInvisibleCharacter(Q))return!0}return!1}static get codePoints(){return Be.e()}}t.$_f=Be}),ne(re[42],ie([0,1,7]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uj=t.$sj=void 0,t.$oj=y,t.$pj=M,t.$qj=h,t.$rj=g,t.$tj=d;function y(E){return M(E,0)}function M(E,$){switch(typeof E){case"object":return E===null?h(349,$):Array.isArray(E)?a(E,$):u(E,$);case"string":return g(E,$);case"boolean":return w(E,$);case"number":return h(E,$);case"undefined":return h(937,$);default:return h(617,$)}}function h(E,$){return($<<5)-$+E|0}function w(E,$){return h(E?433:863,$)}function g(E,$){$=h(149417,$);for(let v=0,j=E.length;v<j;v++)$=h(E.charCodeAt(v),$);return $}function a(E,$){return $=h(104579,$),E.reduce((v,j)=>M(j,v),$)}function u(E,$){return $=h(181387,$),Object.keys(E).sort().reduce((v,j)=>(v=g(j,v),M(E[j],v)),$)}class o{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=M($,this.g),this.g}}t.$sj=o;var N;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function m(E,$,v=32){const j=v-$,l=~((1<<j)-1);return(E<<$|(l&E)>>>j)>>>0}function b(E,$=0,v=E.byteLength,j=0){for(let l=0;l<v;l++)E[$+l]=j}function e(E,$,v="0"){for(;E.length<$;)E=v+E;return E}function d(E,$=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),$/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const v=$.length;if(v===0)return;const j=this.p;let l=this.r,n=this.u,s,f;for(n!==0?(s=n,f=-1,n=0):(s=$.charCodeAt(0),f=0);;){let c=s;if(i.$Ff(s))if(f+1<v){const L=$.charCodeAt(f+1);i.$Gf(L)?(f++,c=i.$Hf(s,L)):c=65533}else{n=s;break}else i.$Gf(s)&&(c=65533);if(l=this.w(j,l,c),f++,f<v)s=$.charCodeAt(f);else break}this.r=l,this.u=n}w($,v,j){return j<128?$[v++]=j:j<2048?($[v++]=192|(j&1984)>>>6,$[v++]=128|(j&63)>>>0):j<65536?($[v++]=224|(j&61440)>>>12,$[v++]=128|(j&4032)>>>6,$[v++]=128|(j&63)>>>0):($[v++]=240|(j&1835008)>>>18,$[v++]=128|(j&258048)>>>12,$[v++]=128|(j&4032)>>>6,$[v++]=128|(j&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=p.g,v=this.q;for(let R=0;R<64;R+=4)$.setUint32(R,v.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)$.setUint32(R,m($.getUint32(R-12,!1)^$.getUint32(R-32,!1)^$.getUint32(R-56,!1)^$.getUint32(R-64,!1),1),!1);let j=this.h,l=this.l,n=this.m,s=this.n,f=this.o,c,L,A;for(let R=0;R<80;R++)R<20?(c=l&n|~l&s,L=1518500249):R<40?(c=l^n^s,L=1859775393):R<60?(c=l&n|l&s|n&s,L=2400959708):(c=l^n^s,L=3395469782),A=m(j,5)+c+f+L+$.getUint32(R*4,!1)&4294967295,f=s,s=n,n=m(l,30),l=j,j=A;this.h=this.h+j&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}t.$uj=p}),ne(re[25],ie([0,1,38,42]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gt=t.$Et=void 0,t.$Ft=h;class M{constructor(m){this.a=m}getElements(){const m=this.a,b=new Int32Array(m.length);for(let e=0,d=m.length;e<d;e++)b[e]=m.charCodeAt(e);return b}}t.$Et=M;function h(N,m,b){return new o(new M(N),new M(m)).ComputeDiff(b).changes}class w{static Assert(m,b){if(!m)throw new Error(b)}}class g{static Copy(m,b,e,d,p){for(let E=0;E<p;E++)e[d+E]=m[b+E]}static Copy2(m,b,e,d,p){for(let E=0;E<p;E++)e[d+E]=m[b+E]}}var a;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Dt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class o{constructor(m,b,e=null){this.a=e,this.b=m,this.c=b;const[d,p,E]=o.o(m),[$,v,j]=o.o(b);this.d=E&&j,this.e=d,this.f=p,this.g=$,this.h=v,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const b=m.getElements();if(o.n(b)){const e=new Int32Array(b.length);for(let d=0,p=b.length;d<p;d++)e[d]=(0,y.$rj)(b[d],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(m,b){return this.f[m]!==this.h[b]?!1:this.d?this.e[m]===this.g[b]:!0}q(m,b){if(!this.p(m,b))return!1;const e=o.r(this.b,m),d=o.r(this.c,b);return e===d}static r(m,b){return typeof m.getStrictElement=="function"?m.getStrictElement(b):null}s(m,b){return this.f[m]!==this.f[b]?!1:this.d?this.e[m]===this.e[b]:!0}u(m,b){return this.h[m]!==this.h[b]?!1:this.d?this.g[m]===this.g[b]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,b,e,d,p){const E=[!1];let $=this.w(m,b,e,d,E);return p&&($=this.z($)),{quitEarly:E[0],changes:$}}w(m,b,e,d,p){for(p[0]=!1;m<=b&&e<=d&&this.p(m,e);)m++,e++;for(;b>=m&&d>=e&&this.p(b,d);)b--,d--;if(m>b||e>d){let n;return e<=d?(w.Assert(m===b+1,"originalStart should only be one more than originalEnd"),n=[new i.$Dt(m,0,e,d-e+1)]):m<=b?(w.Assert(e===d+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$Dt(m,b-m+1,e,0)]):(w.Assert(m===b+1,"originalStart should only be one more than originalEnd"),w.Assert(e===d+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const E=[0],$=[0],v=this.y(m,b,e,d,E,$,p),j=E[0],l=$[0];if(v!==null)return v;if(!p[0]){const n=this.w(m,j,e,l,p);let s=[];return p[0]?s=[new i.$Dt(j+1,b-(j+1)+1,l+1,d-(l+1)+1)]:s=this.w(j+1,b,l+1,d,p),this.H(n,s)}return[new i.$Dt(m,b-m+1,e,d-e+1)]}x(m,b,e,d,p,E,$,v,j,l,n,s,f,c,L,A,R,P){let k=null,S=null,I=new u,D=b,q=e,H=f[0]-A[0]-d,W=-1073741824,U=this.k.length-1;do{const Z=H+m;Z===D||Z<q&&j[Z-1]<j[Z+1]?(n=j[Z+1],c=n-H-d,n<W&&I.MarkNextChange(),W=n,I.AddModifiedElement(n+1,c),H=Z+1-m):(n=j[Z-1]+1,c=n-H-d,n<W&&I.MarkNextChange(),W=n-1,I.AddOriginalElement(n,c+1),H=Z-1-m),U>=0&&(j=this.k[U],m=j[0],D=1,q=j.length-1)}while(--U>=-1);if(k=I.getReverseChanges(),P[0]){let Z=f[0]+1,X=A[0]+1;if(k!==null&&k.length>0){const J=k[k.length-1];Z=Math.max(Z,J.getOriginalEnd()),X=Math.max(X,J.getModifiedEnd())}S=[new i.$Dt(Z,s-Z+1,X,L-X+1)]}else{I=new u,D=E,q=$,H=f[0]-A[0]-v,W=1073741824,U=R?this.m.length-1:this.m.length-2;do{const Z=H+p;Z===D||Z<q&&l[Z-1]>=l[Z+1]?(n=l[Z+1]-1,c=n-H-v,n>W&&I.MarkNextChange(),W=n+1,I.AddOriginalElement(n+1,c+1),H=Z+1-p):(n=l[Z-1],c=n-H-v,n>W&&I.MarkNextChange(),W=n,I.AddModifiedElement(n+1,c+1),H=Z-1-p),U>=0&&(l=this.m[U],p=l[0],D=1,q=l.length-1)}while(--U>=-1);S=I.getChanges()}return this.H(k,S)}y(m,b,e,d,p,E,$){let v=0,j=0,l=0,n=0,s=0,f=0;m--,e--,p[0]=0,E[0]=0,this.k=[],this.m=[];const c=b-m+(d-e),L=c+1,A=new Int32Array(L),R=new Int32Array(L),P=d-e,k=b-m,S=m-e,I=b-d,q=(k-P)%2===0;A[P]=m,R[k]=b,$[0]=!1;for(let H=1;H<=c/2+1;H++){let W=0,U=0;l=this.J(P-H,H,P,L),n=this.J(P+H,H,P,L);for(let X=l;X<=n;X+=2){X===l||X<n&&A[X-1]<A[X+1]?v=A[X+1]:v=A[X-1]+1,j=v-(X-P)-S;const J=v;for(;v<b&&j<d&&this.p(v+1,j+1);)v++,j++;if(A[X]=v,v+j>W+U&&(W=v,U=j),!q&&Math.abs(X-k)<=H-1&&v>=R[X])return p[0]=v,E[0]=j,J<=R[X]&&1447>0&&H<=1448?this.x(P,l,n,S,k,s,f,I,A,R,v,b,p,j,d,E,q,$):null}const Z=(W-m+(U-e)-H)/2;if(this.a!==null&&!this.a(W,Z))return $[0]=!0,p[0]=W,E[0]=U,Z>0&&1447>0&&H<=1448?this.x(P,l,n,S,k,s,f,I,A,R,v,b,p,j,d,E,q,$):(m++,e++,[new i.$Dt(m,b-m+1,e,d-e+1)]);s=this.J(k-H,H,k,L),f=this.J(k+H,H,k,L);for(let X=s;X<=f;X+=2){X===s||X<f&&R[X-1]>=R[X+1]?v=R[X+1]-1:v=R[X-1],j=v-(X-k)-I;const J=v;for(;v>m&&j>e&&this.p(v,j);)v--,j--;if(R[X]=v,q&&Math.abs(X-P)<=H&&v<=A[X])return p[0]=v,E[0]=j,J>=A[X]&&1447>0&&H<=1448?this.x(P,l,n,S,k,s,f,I,A,R,v,b,p,j,d,E,q,$):null}if(H<=1447){let X=new Int32Array(n-l+2);X[0]=P-l+1,g.Copy2(A,l,X,1,n-l+1),this.k.push(X),X=new Int32Array(f-s+2),X[0]=k-s+1,g.Copy2(R,s,X,1,f-s+1),this.m.push(X)}}return this.x(P,l,n,S,k,s,f,I,A,R,v,b,p,j,d,E,q,$)}z(m){for(let b=0;b<m.length;b++){const e=m[b],d=b<m.length-1?m[b+1].originalStart:this.f.length,p=b<m.length-1?m[b+1].modifiedStart:this.h.length,E=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<d&&e.modifiedStart+e.modifiedLength<p&&(!E||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const j=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!j)break;e.originalStart++,e.modifiedStart++}const v=[null];if(b<m.length-1&&this.I(m[b],m[b+1],v)){m[b]=v[0],m.splice(b+1,1),b--;continue}}for(let b=m.length-1;b>=0;b--){const e=m[b];let d=0,p=0;if(b>0){const n=m[b-1];d=n.originalStart+n.originalLength,p=n.modifiedStart+n.modifiedLength}const E=e.originalLength>0,$=e.modifiedLength>0;let v=0,j=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,f=e.modifiedStart-n;if(s<d||f<p||E&&!this.s(s,s+e.originalLength)||$&&!this.u(f,f+e.modifiedLength))break;const L=(s===d&&f===p?5:0)+this.G(s,e.originalLength,f,e.modifiedLength);L>j&&(j=L,v=n)}e.originalStart-=v,e.modifiedStart-=v;const l=[null];if(b>0&&this.I(m[b-1],m[b],l)){m[b-1]=l[0],m.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=m.length;b<e;b++){const d=m[b-1],p=m[b],E=p.originalStart-d.originalStart-d.originalLength,$=d.originalStart,v=p.originalStart+p.originalLength,j=v-$,l=d.modifiedStart,n=p.modifiedStart+p.modifiedLength,s=n-l;if(E<5&&j<20&&s<20){const f=this.A($,j,l,s,E);if(f){const[c,L]=f;(c!==d.originalStart+d.originalLength||L!==d.modifiedStart+d.modifiedLength)&&(d.originalLength=c-d.originalStart,d.modifiedLength=L-d.modifiedStart,p.originalStart=c+E,p.modifiedStart=L+E,p.originalLength=v-p.originalStart,p.modifiedLength=n-p.modifiedStart)}}}return m}A(m,b,e,d,p){if(b<p||d<p)return null;const E=m+b-p+1,$=e+d-p+1;let v=0,j=0,l=0;for(let n=m;n<E;n++)for(let s=e;s<$;s++){const f=this.B(n,s,p);f>0&&f>v&&(v=f,j=n,l=s)}return v>0?[j,l]:null}B(m,b,e){let d=0;for(let p=0;p<e;p++){if(!this.p(m+p,b+p))return 0;d+=this.e[m+p].length}return d}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,b){if(this.C(m)||this.C(m-1))return!0;if(b>0){const e=m+b;if(this.C(e-1)||this.C(e))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,b){if(this.E(m)||this.E(m-1))return!0;if(b>0){const e=m+b;if(this.E(e-1)||this.E(e))return!0}return!1}G(m,b,e,d){const p=this.D(m,b)?1:0,E=this.F(e,d)?1:0;return p+E}H(m,b){const e=[];if(m.length===0||b.length===0)return b.length>0?b:m;if(this.I(m[m.length-1],b[0],e)){const d=new Array(m.length+b.length-1);return g.Copy(m,0,d,0,m.length-1),d[m.length-1]=e[0],g.Copy(b,1,d,m.length,b.length-1),d}else{const d=new Array(m.length+b.length);return g.Copy(m,0,d,0,m.length),g.Copy(b,0,d,m.length,b.length),d}}I(m,b,e){if(w.Assert(m.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),w.Assert(m.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=b.originalStart||m.modifiedStart+m.modifiedLength>=b.modifiedStart){const d=m.originalStart;let p=m.originalLength;const E=m.modifiedStart;let $=m.modifiedLength;return m.originalStart+m.originalLength>=b.originalStart&&(p=b.originalStart+b.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=b.modifiedStart&&($=b.modifiedStart+b.modifiedLength-m.modifiedStart),e[0]=new i.$Dt(d,p,E,$),!0}else return e[0]=null,!1}J(m,b,e,d){if(m>=0&&m<d)return m;const p=e,E=d-e-1,$=b%2===0;if(m<0){const v=p%2===0;return $===v?0:1}else{const v=E%2===0;return $===v?d-1:d-2}}}t.$Gt=o}),ne(re[26],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=i,t.$bg=y,t.$cg=M,t.$dg=h,t.$eg=w,t.$fg=g,t.$gg=a,t.$hg=u,t.$ig=o,t.$jg=N,t.$kg=m,t.$lg=b,t.$mg=e,t.$ng=p,t.$og=E,t.$pg=$,t.$qg=v,t.$rg=j;function i(l){return typeof l=="string"}function y(l){return Array.isArray(l)&&l.every(n=>i(n))}function M(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function h(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function w(l){return typeof l=="number"&&!isNaN(l)}function g(l){return!!l&&typeof l[Symbol.iterator]=="function"}function a(l){return l===!0||l===!1}function u(l){return typeof l>"u"}function o(l){return!N(l)}function N(l){return u(l)||l===null}function m(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function b(l){if(N(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const f=l[s];if(N(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(f)}return n}const d=Object.prototype.hasOwnProperty;function p(l){if(!M(l))return!1;for(const n in l)if(d.call(l,n))return!1;return!0}function E(l){return typeof l=="function"}function $(...l){return l.length>0&&l.every(E)}function v(l,n){const s=Math.min(l.length,n.length);for(let f=0;f<s;f++)j(l[f],n[f])}function j(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(E(n)){try{if(l instanceof n)return}catch{}if(!N(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(re[27],ie([0,1,26]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=M,t.$Vj=h;const y=Object.create(null);function M(w,g){if((0,i.$ag)(g)){const a=y[g];if(a===void 0)throw new Error(`${w} references an unknown codicon: ${g}`);g=a}return y[w]=g,{id:w}}function h(){return y}}),ne(re[43],ie([0,1,27]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=void 0,t.$Wj={add:(0,i.$Uj)("add",6e4),plus:(0,i.$Uj)("plus",6e4),gistNew:(0,i.$Uj)("gist-new",6e4),repoCreate:(0,i.$Uj)("repo-create",6e4),lightbulb:(0,i.$Uj)("lightbulb",60001),lightBulb:(0,i.$Uj)("light-bulb",60001),repo:(0,i.$Uj)("repo",60002),repoDelete:(0,i.$Uj)("repo-delete",60002),gistFork:(0,i.$Uj)("gist-fork",60003),repoForked:(0,i.$Uj)("repo-forked",60003),gitPullRequest:(0,i.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Uj)("record-keys",60005),keyboard:(0,i.$Uj)("keyboard",60005),tag:(0,i.$Uj)("tag",60006),gitPullRequestLabel:(0,i.$Uj)("git-pull-request-label",60006),tagAdd:(0,i.$Uj)("tag-add",60006),tagRemove:(0,i.$Uj)("tag-remove",60006),person:(0,i.$Uj)("person",60007),personFollow:(0,i.$Uj)("person-follow",60007),personOutline:(0,i.$Uj)("person-outline",60007),personFilled:(0,i.$Uj)("person-filled",60007),gitBranch:(0,i.$Uj)("git-branch",60008),gitBranchCreate:(0,i.$Uj)("git-branch-create",60008),gitBranchDelete:(0,i.$Uj)("git-branch-delete",60008),sourceControl:(0,i.$Uj)("source-control",60008),mirror:(0,i.$Uj)("mirror",60009),mirrorPublic:(0,i.$Uj)("mirror-public",60009),star:(0,i.$Uj)("star",60010),starAdd:(0,i.$Uj)("star-add",60010),starDelete:(0,i.$Uj)("star-delete",60010),starEmpty:(0,i.$Uj)("star-empty",60010),comment:(0,i.$Uj)("comment",60011),commentAdd:(0,i.$Uj)("comment-add",60011),alert:(0,i.$Uj)("alert",60012),warning:(0,i.$Uj)("warning",60012),search:(0,i.$Uj)("search",60013),searchSave:(0,i.$Uj)("search-save",60013),logOut:(0,i.$Uj)("log-out",60014),signOut:(0,i.$Uj)("sign-out",60014),logIn:(0,i.$Uj)("log-in",60015),signIn:(0,i.$Uj)("sign-in",60015),eye:(0,i.$Uj)("eye",60016),eyeUnwatch:(0,i.$Uj)("eye-unwatch",60016),eyeWatch:(0,i.$Uj)("eye-watch",60016),circleFilled:(0,i.$Uj)("circle-filled",60017),primitiveDot:(0,i.$Uj)("primitive-dot",60017),closeDirty:(0,i.$Uj)("close-dirty",60017),debugBreakpoint:(0,i.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Uj)("primitive-square",60018),edit:(0,i.$Uj)("edit",60019),pencil:(0,i.$Uj)("pencil",60019),info:(0,i.$Uj)("info",60020),issueOpened:(0,i.$Uj)("issue-opened",60020),gistPrivate:(0,i.$Uj)("gist-private",60021),gitForkPrivate:(0,i.$Uj)("git-fork-private",60021),lock:(0,i.$Uj)("lock",60021),mirrorPrivate:(0,i.$Uj)("mirror-private",60021),close:(0,i.$Uj)("close",60022),removeClose:(0,i.$Uj)("remove-close",60022),x:(0,i.$Uj)("x",60022),repoSync:(0,i.$Uj)("repo-sync",60023),sync:(0,i.$Uj)("sync",60023),clone:(0,i.$Uj)("clone",60024),desktopDownload:(0,i.$Uj)("desktop-download",60024),beaker:(0,i.$Uj)("beaker",60025),microscope:(0,i.$Uj)("microscope",60025),vm:(0,i.$Uj)("vm",60026),deviceDesktop:(0,i.$Uj)("device-desktop",60026),file:(0,i.$Uj)("file",60027),fileText:(0,i.$Uj)("file-text",60027),more:(0,i.$Uj)("more",60028),ellipsis:(0,i.$Uj)("ellipsis",60028),kebabHorizontal:(0,i.$Uj)("kebab-horizontal",60028),mailReply:(0,i.$Uj)("mail-reply",60029),reply:(0,i.$Uj)("reply",60029),organization:(0,i.$Uj)("organization",60030),organizationFilled:(0,i.$Uj)("organization-filled",60030),organizationOutline:(0,i.$Uj)("organization-outline",60030),newFile:(0,i.$Uj)("new-file",60031),fileAdd:(0,i.$Uj)("file-add",60031),newFolder:(0,i.$Uj)("new-folder",60032),fileDirectoryCreate:(0,i.$Uj)("file-directory-create",60032),trash:(0,i.$Uj)("trash",60033),trashcan:(0,i.$Uj)("trashcan",60033),history:(0,i.$Uj)("history",60034),clock:(0,i.$Uj)("clock",60034),folder:(0,i.$Uj)("folder",60035),fileDirectory:(0,i.$Uj)("file-directory",60035),symbolFolder:(0,i.$Uj)("symbol-folder",60035),logoGithub:(0,i.$Uj)("logo-github",60036),markGithub:(0,i.$Uj)("mark-github",60036),github:(0,i.$Uj)("github",60036),terminal:(0,i.$Uj)("terminal",60037),console:(0,i.$Uj)("console",60037),repl:(0,i.$Uj)("repl",60037),zap:(0,i.$Uj)("zap",60038),symbolEvent:(0,i.$Uj)("symbol-event",60038),error:(0,i.$Uj)("error",60039),stop:(0,i.$Uj)("stop",60039),variable:(0,i.$Uj)("variable",60040),symbolVariable:(0,i.$Uj)("symbol-variable",60040),array:(0,i.$Uj)("array",60042),symbolArray:(0,i.$Uj)("symbol-array",60042),symbolModule:(0,i.$Uj)("symbol-module",60043),symbolPackage:(0,i.$Uj)("symbol-package",60043),symbolNamespace:(0,i.$Uj)("symbol-namespace",60043),symbolObject:(0,i.$Uj)("symbol-object",60043),symbolMethod:(0,i.$Uj)("symbol-method",60044),symbolFunction:(0,i.$Uj)("symbol-function",60044),symbolConstructor:(0,i.$Uj)("symbol-constructor",60044),symbolBoolean:(0,i.$Uj)("symbol-boolean",60047),symbolNull:(0,i.$Uj)("symbol-null",60047),symbolNumeric:(0,i.$Uj)("symbol-numeric",60048),symbolNumber:(0,i.$Uj)("symbol-number",60048),symbolStructure:(0,i.$Uj)("symbol-structure",60049),symbolStruct:(0,i.$Uj)("symbol-struct",60049),symbolParameter:(0,i.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Uj)("symbol-type-parameter",60050),symbolKey:(0,i.$Uj)("symbol-key",60051),symbolText:(0,i.$Uj)("symbol-text",60051),symbolReference:(0,i.$Uj)("symbol-reference",60052),goToFile:(0,i.$Uj)("go-to-file",60052),symbolEnum:(0,i.$Uj)("symbol-enum",60053),symbolValue:(0,i.$Uj)("symbol-value",60053),symbolRuler:(0,i.$Uj)("symbol-ruler",60054),symbolUnit:(0,i.$Uj)("symbol-unit",60054),activateBreakpoints:(0,i.$Uj)("activate-breakpoints",60055),archive:(0,i.$Uj)("archive",60056),arrowBoth:(0,i.$Uj)("arrow-both",60057),arrowDown:(0,i.$Uj)("arrow-down",60058),arrowLeft:(0,i.$Uj)("arrow-left",60059),arrowRight:(0,i.$Uj)("arrow-right",60060),arrowSmallDown:(0,i.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Uj)("arrow-small-up",60064),arrowUp:(0,i.$Uj)("arrow-up",60065),bell:(0,i.$Uj)("bell",60066),bold:(0,i.$Uj)("bold",60067),book:(0,i.$Uj)("book",60068),bookmark:(0,i.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Uj)("briefcase",60076),broadcast:(0,i.$Uj)("broadcast",60077),browser:(0,i.$Uj)("browser",60078),bug:(0,i.$Uj)("bug",60079),calendar:(0,i.$Uj)("calendar",60080),caseSensitive:(0,i.$Uj)("case-sensitive",60081),check:(0,i.$Uj)("check",60082),checklist:(0,i.$Uj)("checklist",60083),chevronDown:(0,i.$Uj)("chevron-down",60084),chevronLeft:(0,i.$Uj)("chevron-left",60085),chevronRight:(0,i.$Uj)("chevron-right",60086),chevronUp:(0,i.$Uj)("chevron-up",60087),chromeClose:(0,i.$Uj)("chrome-close",60088),chromeMaximize:(0,i.$Uj)("chrome-maximize",60089),chromeMinimize:(0,i.$Uj)("chrome-minimize",60090),chromeRestore:(0,i.$Uj)("chrome-restore",60091),circleOutline:(0,i.$Uj)("circle-outline",60092),circle:(0,i.$Uj)("circle",60092),debugBreakpointUnverified:(0,i.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Uj)("circle-slash",60093),circuitBoard:(0,i.$Uj)("circuit-board",60094),clearAll:(0,i.$Uj)("clear-all",60095),clippy:(0,i.$Uj)("clippy",60096),closeAll:(0,i.$Uj)("close-all",60097),cloudDownload:(0,i.$Uj)("cloud-download",60098),cloudUpload:(0,i.$Uj)("cloud-upload",60099),code:(0,i.$Uj)("code",60100),collapseAll:(0,i.$Uj)("collapse-all",60101),colorMode:(0,i.$Uj)("color-mode",60102),commentDiscussion:(0,i.$Uj)("comment-discussion",60103),creditCard:(0,i.$Uj)("credit-card",60105),dash:(0,i.$Uj)("dash",60108),dashboard:(0,i.$Uj)("dashboard",60109),database:(0,i.$Uj)("database",60110),debugContinue:(0,i.$Uj)("debug-continue",60111),debugDisconnect:(0,i.$Uj)("debug-disconnect",60112),debugPause:(0,i.$Uj)("debug-pause",60113),debugRestart:(0,i.$Uj)("debug-restart",60114),debugStart:(0,i.$Uj)("debug-start",60115),debugStepInto:(0,i.$Uj)("debug-step-into",60116),debugStepOut:(0,i.$Uj)("debug-step-out",60117),debugStepOver:(0,i.$Uj)("debug-step-over",60118),debugStop:(0,i.$Uj)("debug-stop",60119),debug:(0,i.$Uj)("debug",60120),deviceCameraVideo:(0,i.$Uj)("device-camera-video",60121),deviceCamera:(0,i.$Uj)("device-camera",60122),deviceMobile:(0,i.$Uj)("device-mobile",60123),diffAdded:(0,i.$Uj)("diff-added",60124),diffIgnored:(0,i.$Uj)("diff-ignored",60125),diffModified:(0,i.$Uj)("diff-modified",60126),diffRemoved:(0,i.$Uj)("diff-removed",60127),diffRenamed:(0,i.$Uj)("diff-renamed",60128),diff:(0,i.$Uj)("diff",60129),diffSidebyside:(0,i.$Uj)("diff-sidebyside",60129),discard:(0,i.$Uj)("discard",60130),editorLayout:(0,i.$Uj)("editor-layout",60131),emptyWindow:(0,i.$Uj)("empty-window",60132),exclude:(0,i.$Uj)("exclude",60133),extensions:(0,i.$Uj)("extensions",60134),eyeClosed:(0,i.$Uj)("eye-closed",60135),fileBinary:(0,i.$Uj)("file-binary",60136),fileCode:(0,i.$Uj)("file-code",60137),fileMedia:(0,i.$Uj)("file-media",60138),filePdf:(0,i.$Uj)("file-pdf",60139),fileSubmodule:(0,i.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Uj)("file-symlink-file",60142),fileZip:(0,i.$Uj)("file-zip",60143),files:(0,i.$Uj)("files",60144),filter:(0,i.$Uj)("filter",60145),flame:(0,i.$Uj)("flame",60146),foldDown:(0,i.$Uj)("fold-down",60147),foldUp:(0,i.$Uj)("fold-up",60148),fold:(0,i.$Uj)("fold",60149),folderActive:(0,i.$Uj)("folder-active",60150),folderOpened:(0,i.$Uj)("folder-opened",60151),gear:(0,i.$Uj)("gear",60152),gift:(0,i.$Uj)("gift",60153),gistSecret:(0,i.$Uj)("gist-secret",60154),gist:(0,i.$Uj)("gist",60155),gitCommit:(0,i.$Uj)("git-commit",60156),gitCompare:(0,i.$Uj)("git-compare",60157),compareChanges:(0,i.$Uj)("compare-changes",60157),gitMerge:(0,i.$Uj)("git-merge",60158),githubAction:(0,i.$Uj)("github-action",60159),githubAlt:(0,i.$Uj)("github-alt",60160),globe:(0,i.$Uj)("globe",60161),grabber:(0,i.$Uj)("grabber",60162),graph:(0,i.$Uj)("graph",60163),gripper:(0,i.$Uj)("gripper",60164),heart:(0,i.$Uj)("heart",60165),home:(0,i.$Uj)("home",60166),horizontalRule:(0,i.$Uj)("horizontal-rule",60167),hubot:(0,i.$Uj)("hubot",60168),inbox:(0,i.$Uj)("inbox",60169),issueReopened:(0,i.$Uj)("issue-reopened",60171),issues:(0,i.$Uj)("issues",60172),italic:(0,i.$Uj)("italic",60173),jersey:(0,i.$Uj)("jersey",60174),json:(0,i.$Uj)("json",60175),kebabVertical:(0,i.$Uj)("kebab-vertical",60176),key:(0,i.$Uj)("key",60177),law:(0,i.$Uj)("law",60178),lightbulbAutofix:(0,i.$Uj)("lightbulb-autofix",60179),linkExternal:(0,i.$Uj)("link-external",60180),link:(0,i.$Uj)("link",60181),listOrdered:(0,i.$Uj)("list-ordered",60182),listUnordered:(0,i.$Uj)("list-unordered",60183),liveShare:(0,i.$Uj)("live-share",60184),loading:(0,i.$Uj)("loading",60185),location:(0,i.$Uj)("location",60186),mailRead:(0,i.$Uj)("mail-read",60187),mail:(0,i.$Uj)("mail",60188),markdown:(0,i.$Uj)("markdown",60189),megaphone:(0,i.$Uj)("megaphone",60190),mention:(0,i.$Uj)("mention",60191),milestone:(0,i.$Uj)("milestone",60192),gitPullRequestMilestone:(0,i.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Uj)("mortar-board",60193),move:(0,i.$Uj)("move",60194),multipleWindows:(0,i.$Uj)("multiple-windows",60195),mute:(0,i.$Uj)("mute",60196),noNewline:(0,i.$Uj)("no-newline",60197),note:(0,i.$Uj)("note",60198),octoface:(0,i.$Uj)("octoface",60199),openPreview:(0,i.$Uj)("open-preview",60200),package:(0,i.$Uj)("package",60201),paintcan:(0,i.$Uj)("paintcan",60202),pin:(0,i.$Uj)("pin",60203),play:(0,i.$Uj)("play",60204),run:(0,i.$Uj)("run",60204),plug:(0,i.$Uj)("plug",60205),preserveCase:(0,i.$Uj)("preserve-case",60206),preview:(0,i.$Uj)("preview",60207),project:(0,i.$Uj)("project",60208),pulse:(0,i.$Uj)("pulse",60209),question:(0,i.$Uj)("question",60210),quote:(0,i.$Uj)("quote",60211),radioTower:(0,i.$Uj)("radio-tower",60212),reactions:(0,i.$Uj)("reactions",60213),references:(0,i.$Uj)("references",60214),refresh:(0,i.$Uj)("refresh",60215),regex:(0,i.$Uj)("regex",60216),remoteExplorer:(0,i.$Uj)("remote-explorer",60217),remote:(0,i.$Uj)("remote",60218),remove:(0,i.$Uj)("remove",60219),replaceAll:(0,i.$Uj)("replace-all",60220),replace:(0,i.$Uj)("replace",60221),repoClone:(0,i.$Uj)("repo-clone",60222),repoForcePush:(0,i.$Uj)("repo-force-push",60223),repoPull:(0,i.$Uj)("repo-pull",60224),repoPush:(0,i.$Uj)("repo-push",60225),report:(0,i.$Uj)("report",60226),requestChanges:(0,i.$Uj)("request-changes",60227),rocket:(0,i.$Uj)("rocket",60228),rootFolderOpened:(0,i.$Uj)("root-folder-opened",60229),rootFolder:(0,i.$Uj)("root-folder",60230),rss:(0,i.$Uj)("rss",60231),ruby:(0,i.$Uj)("ruby",60232),saveAll:(0,i.$Uj)("save-all",60233),saveAs:(0,i.$Uj)("save-as",60234),save:(0,i.$Uj)("save",60235),screenFull:(0,i.$Uj)("screen-full",60236),screenNormal:(0,i.$Uj)("screen-normal",60237),searchStop:(0,i.$Uj)("search-stop",60238),server:(0,i.$Uj)("server",60240),settingsGear:(0,i.$Uj)("settings-gear",60241),settings:(0,i.$Uj)("settings",60242),shield:(0,i.$Uj)("shield",60243),smiley:(0,i.$Uj)("smiley",60244),sortPrecedence:(0,i.$Uj)("sort-precedence",60245),splitHorizontal:(0,i.$Uj)("split-horizontal",60246),splitVertical:(0,i.$Uj)("split-vertical",60247),squirrel:(0,i.$Uj)("squirrel",60248),starFull:(0,i.$Uj)("star-full",60249),starHalf:(0,i.$Uj)("star-half",60250),symbolClass:(0,i.$Uj)("symbol-class",60251),symbolColor:(0,i.$Uj)("symbol-color",60252),symbolConstant:(0,i.$Uj)("symbol-constant",60253),symbolEnumMember:(0,i.$Uj)("symbol-enum-member",60254),symbolField:(0,i.$Uj)("symbol-field",60255),symbolFile:(0,i.$Uj)("symbol-file",60256),symbolInterface:(0,i.$Uj)("symbol-interface",60257),symbolKeyword:(0,i.$Uj)("symbol-keyword",60258),symbolMisc:(0,i.$Uj)("symbol-misc",60259),symbolOperator:(0,i.$Uj)("symbol-operator",60260),symbolProperty:(0,i.$Uj)("symbol-property",60261),wrench:(0,i.$Uj)("wrench",60261),wrenchSubaction:(0,i.$Uj)("wrench-subaction",60261),symbolSnippet:(0,i.$Uj)("symbol-snippet",60262),tasklist:(0,i.$Uj)("tasklist",60263),telescope:(0,i.$Uj)("telescope",60264),textSize:(0,i.$Uj)("text-size",60265),threeBars:(0,i.$Uj)("three-bars",60266),thumbsdown:(0,i.$Uj)("thumbsdown",60267),thumbsup:(0,i.$Uj)("thumbsup",60268),tools:(0,i.$Uj)("tools",60269),triangleDown:(0,i.$Uj)("triangle-down",60270),triangleLeft:(0,i.$Uj)("triangle-left",60271),triangleRight:(0,i.$Uj)("triangle-right",60272),triangleUp:(0,i.$Uj)("triangle-up",60273),twitter:(0,i.$Uj)("twitter",60274),unfold:(0,i.$Uj)("unfold",60275),unlock:(0,i.$Uj)("unlock",60276),unmute:(0,i.$Uj)("unmute",60277),unverified:(0,i.$Uj)("unverified",60278),verified:(0,i.$Uj)("verified",60279),versions:(0,i.$Uj)("versions",60280),vmActive:(0,i.$Uj)("vm-active",60281),vmOutline:(0,i.$Uj)("vm-outline",60282),vmRunning:(0,i.$Uj)("vm-running",60283),watch:(0,i.$Uj)("watch",60284),whitespace:(0,i.$Uj)("whitespace",60285),wholeWord:(0,i.$Uj)("whole-word",60286),window:(0,i.$Uj)("window",60287),wordWrap:(0,i.$Uj)("word-wrap",60288),zoomIn:(0,i.$Uj)("zoom-in",60289),zoomOut:(0,i.$Uj)("zoom-out",60290),listFilter:(0,i.$Uj)("list-filter",60291),listFlat:(0,i.$Uj)("list-flat",60292),listSelection:(0,i.$Uj)("list-selection",60293),selection:(0,i.$Uj)("selection",60293),listTree:(0,i.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Uj)("symbol-string",60301),debugReverseContinue:(0,i.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Uj)("debug-step-back",60303),debugRestartFrame:(0,i.$Uj)("debug-restart-frame",60304),debugAlt:(0,i.$Uj)("debug-alt",60305),callIncoming:(0,i.$Uj)("call-incoming",60306),callOutgoing:(0,i.$Uj)("call-outgoing",60307),menu:(0,i.$Uj)("menu",60308),expandAll:(0,i.$Uj)("expand-all",60309),feedback:(0,i.$Uj)("feedback",60310),gitPullRequestReviewer:(0,i.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Uj)("ungroup-by-ref-type",60312),account:(0,i.$Uj)("account",60313),gitPullRequestAssignee:(0,i.$Uj)("git-pull-request-assignee",60313),bellDot:(0,i.$Uj)("bell-dot",60314),debugConsole:(0,i.$Uj)("debug-console",60315),library:(0,i.$Uj)("library",60316),output:(0,i.$Uj)("output",60317),runAll:(0,i.$Uj)("run-all",60318),syncIgnored:(0,i.$Uj)("sync-ignored",60319),pinned:(0,i.$Uj)("pinned",60320),githubInverted:(0,i.$Uj)("github-inverted",60321),serverProcess:(0,i.$Uj)("server-process",60322),serverEnvironment:(0,i.$Uj)("server-environment",60323),pass:(0,i.$Uj)("pass",60324),issueClosed:(0,i.$Uj)("issue-closed",60324),stopCircle:(0,i.$Uj)("stop-circle",60325),playCircle:(0,i.$Uj)("play-circle",60326),record:(0,i.$Uj)("record",60327),debugAltSmall:(0,i.$Uj)("debug-alt-small",60328),vmConnect:(0,i.$Uj)("vm-connect",60329),cloud:(0,i.$Uj)("cloud",60330),merge:(0,i.$Uj)("merge",60331),export:(0,i.$Uj)("export",60332),graphLeft:(0,i.$Uj)("graph-left",60333),magnet:(0,i.$Uj)("magnet",60334),notebook:(0,i.$Uj)("notebook",60335),redo:(0,i.$Uj)("redo",60336),checkAll:(0,i.$Uj)("check-all",60337),pinnedDirty:(0,i.$Uj)("pinned-dirty",60338),passFilled:(0,i.$Uj)("pass-filled",60339),circleLargeFilled:(0,i.$Uj)("circle-large-filled",60340),circleLarge:(0,i.$Uj)("circle-large",60341),circleLargeOutline:(0,i.$Uj)("circle-large-outline",60341),combine:(0,i.$Uj)("combine",60342),gather:(0,i.$Uj)("gather",60342),table:(0,i.$Uj)("table",60343),variableGroup:(0,i.$Uj)("variable-group",60344),typeHierarchy:(0,i.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Uj)("git-pull-request-create",60348),runAbove:(0,i.$Uj)("run-above",60349),runBelow:(0,i.$Uj)("run-below",60350),notebookTemplate:(0,i.$Uj)("notebook-template",60351),debugRerun:(0,i.$Uj)("debug-rerun",60352),workspaceTrusted:(0,i.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Uj)("workspace-unknown",60355),terminalCmd:(0,i.$Uj)("terminal-cmd",60356),terminalDebian:(0,i.$Uj)("terminal-debian",60357),terminalLinux:(0,i.$Uj)("terminal-linux",60358),terminalPowershell:(0,i.$Uj)("terminal-powershell",60359),terminalTmux:(0,i.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Uj)("terminal-ubuntu",60361),terminalBash:(0,i.$Uj)("terminal-bash",60362),arrowSwap:(0,i.$Uj)("arrow-swap",60363),copy:(0,i.$Uj)("copy",60364),personAdd:(0,i.$Uj)("person-add",60365),filterFilled:(0,i.$Uj)("filter-filled",60366),wand:(0,i.$Uj)("wand",60367),debugLineByLine:(0,i.$Uj)("debug-line-by-line",60368),inspect:(0,i.$Uj)("inspect",60369),layers:(0,i.$Uj)("layers",60370),layersDot:(0,i.$Uj)("layers-dot",60371),layersActive:(0,i.$Uj)("layers-active",60372),compass:(0,i.$Uj)("compass",60373),compassDot:(0,i.$Uj)("compass-dot",60374),compassActive:(0,i.$Uj)("compass-active",60375),azure:(0,i.$Uj)("azure",60376),issueDraft:(0,i.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Uj)("git-pull-request-draft",60379),debugAll:(0,i.$Uj)("debug-all",60380),debugCoverage:(0,i.$Uj)("debug-coverage",60381),runErrors:(0,i.$Uj)("run-errors",60382),folderLibrary:(0,i.$Uj)("folder-library",60383),debugContinueSmall:(0,i.$Uj)("debug-continue-small",60384),beakerStop:(0,i.$Uj)("beaker-stop",60385),graphLine:(0,i.$Uj)("graph-line",60386),graphScatter:(0,i.$Uj)("graph-scatter",60387),pieChart:(0,i.$Uj)("pie-chart",60388),bracket:(0,i.$Uj)("bracket",60175),bracketDot:(0,i.$Uj)("bracket-dot",60389),bracketError:(0,i.$Uj)("bracket-error",60390),lockSmall:(0,i.$Uj)("lock-small",60391),azureDevops:(0,i.$Uj)("azure-devops",60392),verifiedFilled:(0,i.$Uj)("verified-filled",60393),newline:(0,i.$Uj)("newline",60394),layout:(0,i.$Uj)("layout",60395),layoutActivitybarLeft:(0,i.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Uj)("layout-panel-right",60401),layoutPanel:(0,i.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Uj)("layout-statusbar",60405),layoutMenubar:(0,i.$Uj)("layout-menubar",60406),layoutCentered:(0,i.$Uj)("layout-centered",60407),target:(0,i.$Uj)("target",60408),indent:(0,i.$Uj)("indent",60409),recordSmall:(0,i.$Uj)("record-small",60410),errorSmall:(0,i.$Uj)("error-small",60411),terminalDecorationError:(0,i.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Uj)("layout-sidebar-left-off",60418),blank:(0,i.$Uj)("blank",60419),heartFilled:(0,i.$Uj)("heart-filled",60420),map:(0,i.$Uj)("map",60421),mapHorizontal:(0,i.$Uj)("map-horizontal",60421),foldHorizontal:(0,i.$Uj)("fold-horizontal",60421),mapFilled:(0,i.$Uj)("map-filled",60422),mapHorizontalFilled:(0,i.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Uj)("circle-small",60423),bellSlash:(0,i.$Uj)("bell-slash",60424),bellSlashDot:(0,i.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Uj)("search-fuzzy",60429),commentDraft:(0,i.$Uj)("comment-draft",60430),send:(0,i.$Uj)("send",60431),sparkle:(0,i.$Uj)("sparkle",60432),insert:(0,i.$Uj)("insert",60433),mic:(0,i.$Uj)("mic",60434),thumbsdownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Uj)("thumbsup-filled",60436),coffee:(0,i.$Uj)("coffee",60437),snake:(0,i.$Uj)("snake",60438),game:(0,i.$Uj)("game",60439),vr:(0,i.$Uj)("vr",60440),chip:(0,i.$Uj)("chip",60441),piano:(0,i.$Uj)("piano",60442),music:(0,i.$Uj)("music",60443),micFilled:(0,i.$Uj)("mic-filled",60444),repoFetch:(0,i.$Uj)("repo-fetch",60445),copilot:(0,i.$Uj)("copilot",60446),lightbulbSparkle:(0,i.$Uj)("lightbulb-sparkle",60447),robot:(0,i.$Uj)("robot",60448),sparkleFilled:(0,i.$Uj)("sparkle-filled",60449),diffSingle:(0,i.$Uj)("diff-single",60450),diffMultiple:(0,i.$Uj)("diff-multiple",60451),surroundWith:(0,i.$Uj)("surround-with",60452),share:(0,i.$Uj)("share",60453),gitStash:(0,i.$Uj)("git-stash",60454),gitStashApply:(0,i.$Uj)("git-stash-apply",60455),gitStashPop:(0,i.$Uj)("git-stash-pop",60456),vscode:(0,i.$Uj)("vscode",60457),vscodeInsiders:(0,i.$Uj)("vscode-insiders",60458),codeOss:(0,i.$Uj)("code-oss",60459),runCoverage:(0,i.$Uj)("run-coverage",60460),runAllCoverage:(0,i.$Uj)("run-all-coverage",60461),coverage:(0,i.$Uj)("coverage",60462),githubProject:(0,i.$Uj)("github-project",60463),mapVertical:(0,i.$Uj)("map-vertical",60464),foldVertical:(0,i.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Uj)("fold-vertical-filled",60465),goToSearch:(0,i.$Uj)("go-to-search",60466),percentage:(0,i.$Uj)("percentage",60467),sortPercentage:(0,i.$Uj)("sort-percentage",60467),attach:(0,i.$Uj)("attach",60468)}}),ne(re[44],ie([0,1,27,43]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=void 0,t.$Xj=M;function M(){return Object.values(t.$Zj)}t.$Yj={dialogError:(0,i.$Uj)("dialog-error","error"),dialogWarning:(0,i.$Uj)("dialog-warning","warning"),dialogInfo:(0,i.$Uj)("dialog-info","info"),dialogClose:(0,i.$Uj)("dialog-close","close"),treeItemExpanded:(0,i.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Uj)("tree-item-loading","loading"),menuSelection:(0,i.$Uj)("menu-selection","check"),menuSubmenu:(0,i.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Uj)("toolbar-more","more"),quickInputBack:(0,i.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Uj)("drop-down-button",60084),symbolCustomColor:(0,i.$Uj)("symbol-customcolor",60252),exportIcon:(0,i.$Uj)("export",60332),workspaceUnspecified:(0,i.$Uj)("workspace-unspecified",60355),newLine:(0,i.$Uj)("newline",60394),thumbsDownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Uj)("thumbsup-filled",60436),gitFetch:(0,i.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Uj)("debug-breakpoint-pending",60377)},t.$Zj={...y.$Wj,...t.$Yj}}),ne(re[15],ie([0,1,26]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7n=y,t.$8n=M,t.$9n=w,t.$0n=a,t.$$n=u,t.$_n=o,t.$ao=N,t.$bo=m,t.$co=b,t.$do=e,t.$eo=d,t.$fo=p,t.$go=E;function y($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const v=Array.isArray($)?[]:{};return Object.entries($).forEach(([j,l])=>{v[j]=l&&typeof l=="object"?y(l):l}),v}function M($){if(!$||typeof $!="object")return $;const v=[$];for(;v.length>0;){const j=v.shift();Object.freeze(j);for(const l in j)if(h.call(j,l)){const n=j[l];typeof n=="object"&&!Object.isFrozen(n)&&!(0,i.$dg)(n)&&v.push(n)}}return $}const h=Object.prototype.hasOwnProperty;function w($,v){return g($,v,new Set)}function g($,v,j){if((0,i.$jg)($))return $;const l=v($);if(typeof l<"u")return l;if(Array.isArray($)){const n=[];for(const s of $)n.push(g(s,v,j));return n}if((0,i.$cg)($)){if(j.has($))throw new Error("Cannot clone recursive data-structure");j.add($);const n={};for(const s in $)h.call($,s)&&(n[s]=g($[s],v,j));return j.delete($),n}return $}function a($,v,j=!0){return(0,i.$cg)($)?((0,i.$cg)(v)&&Object.keys(v).forEach(l=>{l in $?j&&((0,i.$cg)($[l])&&(0,i.$cg)(v[l])?a($[l],v[l],j):$[l]=v[l]):$[l]=v[l]}),$):v}function u($,v){if($===v)return!0;if($==null||v===null||v===void 0||typeof $!=typeof v||typeof $!="object"||Array.isArray($)!==Array.isArray(v))return!1;let j,l;if(Array.isArray($)){if($.length!==v.length)return!1;for(j=0;j<$.length;j++)if(!u($[j],v[j]))return!1}else{const n=[];for(l in $)n.push(l);n.sort();const s=[];for(l in v)s.push(l);if(s.sort(),!u(n,s))return!1;for(j=0;j<n.length;j++)if(!u($[n[j]],v[n[j]]))return!1}return!0}function o($){const v=new Set;return JSON.stringify($,(j,l)=>{if((0,i.$cg)(l)||Array.isArray(l)){if(v.has(l))return"[Circular]";v.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function N($,v){const j=Object.create(null);return!$||!v||Object.keys(v).forEach(n=>{const s=$[n],f=v[n];u(s,f)||(j[n]=f)}),j}function m($,v){const j=v.toLowerCase(),l=Object.keys($).find(n=>n.toLowerCase()===j);return l?$[l]:$[v]}function b($,v){const j=Object.create(null);for(const[l,n]of Object.entries($))v(l,n)&&(j[l]=n);return j}function e($){let v=[];for(;Object.prototype!==$;)v=v.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return v}function d($){const v=[];for(const j of e($))typeof $[j]=="function"&&v.push(j);return v}function p($,v){const j=n=>function(){const s=Array.prototype.slice.call(arguments,0);return v(n,s)},l={};for(const n of $)l[n]=j(n);return l}function E($,v){const j={};for(const[l,n]of Object.entries($))j[l]=v(n,l);return j}}),ne(re[28],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$9e=y,t.$0e=M;var i;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function y(h){return h<0?0:h>255?255:h|0}function M(h){return h<0?0:h>4294967295?4294967295:h|0}}),ne(re[29],ie([0,1,28]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6t=t.$5t=void 0;class y{constructor(g){const a=(0,i.$9e)(g);this.c=a,this.a=y.d(a),this.b=new Map}static d(g){const a=new Uint8Array(256);return a.fill(g),a}set(g,a){const u=(0,i.$9e)(a);g>=0&&g<256?this.a[g]=u:this.b.set(g,u)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$5t=y;var M;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(M||(M={}));class h{constructor(){this.a=new y(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}t.$6t=h}),ne(re[5],ie([0,1,3]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$It=t.$Ht=void 0;class y{static addRange(w,g){let a=0;for(;a<g.length&&g[a].endExclusive<w.start;)a++;let u=a;for(;u<g.length&&g[u].start<=w.endExclusive;)u++;if(a===u)g.splice(a,0,w);else{const o=Math.min(w.start,g[a].start),N=Math.max(w.endExclusive,g[u-1].endExclusive);g.splice(a,u-a,new y(o,N))}}static tryCreate(w,g){if(!(w>g))return new y(w,g)}static ofLength(w){return new y(0,w)}static ofStartAndLength(w,g){return new y(w,w+g)}constructor(w,g){if(this.start=w,this.endExclusive=g,w>g)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new y(this.start+w,this.endExclusive+w)}deltaStart(w){return new y(this.start+w,this.endExclusive)}deltaEnd(w){return new y(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new y(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const g=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);if(g<=a)return new y(g,a)}intersects(w){const g=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return g<a}intersectsOrTouches(w){const g=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return g<=a}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const g=[];for(let a=this.start;a<this.endExclusive;a++)g.push(w(a));return g}forEach(w){for(let g=this.start;g<this.endExclusive;g++)w(g)}}t.$Ht=y;class M{constructor(){this.a=[]}addRange(w){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<w.start;)g++;let a=g;for(;a<this.a.length&&this.a[a].start<=w.endExclusive;)a++;if(g===a)this.a.splice(g,0,w);else{const u=Math.min(w.start,this.a[g].start),o=Math.max(w.endExclusive,this.a[a-1].endExclusive);this.a.splice(g,a-g,new y(u,o))}}toString(){return this.a.map(w=>w.toString()).join(", ")}intersectsStrict(w){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<=w.start;)g++;return g<this.a.length&&this.a[g].start<w.endExclusive}intersectWithRange(w){const g=new M;for(const a of this.a){const u=a.intersect(w);u&&g.addRange(u)}return g}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this.a.reduce((w,g)=>w+g.length,0)}}t.$It=M}),ne(re[4],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=void 0;class i{constructor(M,h){this.lineNumber=M,this.column=h}with(M=this.lineNumber,h=this.column){return M===this.lineNumber&&h===this.column?this:new i(M,h)}delta(M=0,h=0){return this.with(this.lineNumber+M,this.column+h)}equals(M){return i.equals(this,M)}static equals(M,h){return!M&&!h?!0:!!M&&!!h&&M.lineNumber===h.lineNumber&&M.column===h.column}isBefore(M){return i.isBefore(this,M)}static isBefore(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<h.column}isBeforeOrEqual(M){return i.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,h){return M.lineNumber<h.lineNumber?!0:h.lineNumber<M.lineNumber?!1:M.column<=h.column}static compare(M,h){const w=M.lineNumber|0,g=h.lineNumber|0;if(w===g){const a=M.column|0,u=h.column|0;return a-u}return w-g}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new i(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$zt=i}),ne(re[2],ie([0,1,4]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=void 0;class y{constructor(h,w,g,a){h>g||h===g&&w>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=h,this.endColumn=w):(this.startLineNumber=h,this.startColumn=w,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return y.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return y.containsPosition(this,h)}static containsPosition(h,w){return!(w.lineNumber<h.startLineNumber||w.lineNumber>h.endLineNumber||w.lineNumber===h.startLineNumber&&w.column<h.startColumn||w.lineNumber===h.endLineNumber&&w.column>h.endColumn)}static strictContainsPosition(h,w){return!(w.lineNumber<h.startLineNumber||w.lineNumber>h.endLineNumber||w.lineNumber===h.startLineNumber&&w.column<=h.startColumn||w.lineNumber===h.endLineNumber&&w.column>=h.endColumn)}containsRange(h){return y.containsRange(this,h)}static containsRange(h,w){return!(w.startLineNumber<h.startLineNumber||w.endLineNumber<h.startLineNumber||w.startLineNumber>h.endLineNumber||w.endLineNumber>h.endLineNumber||w.startLineNumber===h.startLineNumber&&w.startColumn<h.startColumn||w.endLineNumber===h.endLineNumber&&w.endColumn>h.endColumn)}strictContainsRange(h){return y.strictContainsRange(this,h)}static strictContainsRange(h,w){return!(w.startLineNumber<h.startLineNumber||w.endLineNumber<h.startLineNumber||w.startLineNumber>h.endLineNumber||w.endLineNumber>h.endLineNumber||w.startLineNumber===h.startLineNumber&&w.startColumn<=h.startColumn||w.endLineNumber===h.endLineNumber&&w.endColumn>=h.endColumn)}plusRange(h){return y.plusRange(this,h)}static plusRange(h,w){let g,a,u,o;return w.startLineNumber<h.startLineNumber?(g=w.startLineNumber,a=w.startColumn):w.startLineNumber===h.startLineNumber?(g=w.startLineNumber,a=Math.min(w.startColumn,h.startColumn)):(g=h.startLineNumber,a=h.startColumn),w.endLineNumber>h.endLineNumber?(u=w.endLineNumber,o=w.endColumn):w.endLineNumber===h.endLineNumber?(u=w.endLineNumber,o=Math.max(w.endColumn,h.endColumn)):(u=h.endLineNumber,o=h.endColumn),new y(g,a,u,o)}intersectRanges(h){return y.intersectRanges(this,h)}static intersectRanges(h,w){let g=h.startLineNumber,a=h.startColumn,u=h.endLineNumber,o=h.endColumn;const N=w.startLineNumber,m=w.startColumn,b=w.endLineNumber,e=w.endColumn;return g<N?(g=N,a=m):g===N&&(a=Math.max(a,m)),u>b?(u=b,o=e):u===b&&(o=Math.min(o,e)),g>u||g===u&&a>o?null:new y(g,a,u,o)}equalsRange(h){return y.equalsRange(this,h)}static equalsRange(h,w){return!h&&!w?!0:!!h&&!!w&&h.startLineNumber===w.startLineNumber&&h.startColumn===w.startColumn&&h.endLineNumber===w.endLineNumber&&h.endColumn===w.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(h){return new i.$zt(h.endLineNumber,h.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(h){return new i.$zt(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,w){return new y(this.startLineNumber,this.startColumn,h,w)}setStartPosition(h,w){return new y(h,w,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(h){return new y(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return y.collapseToEnd(this)}static collapseToEnd(h){return new y(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new y(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,w=h){return new y(h.lineNumber,h.column,w.lineNumber,w.column)}static lift(h){return h?new y(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,w){return!(h.endLineNumber<w.startLineNumber||h.endLineNumber===w.startLineNumber&&h.endColumn<w.startColumn||w.endLineNumber<h.startLineNumber||w.endLineNumber===h.startLineNumber&&w.endColumn<h.startColumn)}static areIntersecting(h,w){return!(h.endLineNumber<w.startLineNumber||h.endLineNumber===w.startLineNumber&&h.endColumn<=w.startColumn||w.endLineNumber<h.startLineNumber||w.endLineNumber===h.startLineNumber&&w.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,w){if(h&&w){const u=h.startLineNumber|0,o=w.startLineNumber|0;if(u===o){const N=h.startColumn|0,m=w.startColumn|0;if(N===m){const b=h.endLineNumber|0,e=w.endLineNumber|0;if(b===e){const d=h.endColumn|0,p=w.endColumn|0;return d-p}return b-e}return N-m}return u-o}return(h?1:0)-(w?1:0)}static compareRangesUsingEnds(h,w){return h.endLineNumber===w.endLineNumber?h.endColumn===w.endColumn?h.startLineNumber===w.startLineNumber?h.startColumn-w.startColumn:h.startLineNumber-w.startLineNumber:h.endColumn-w.endColumn:h.endLineNumber-w.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}t.$At=y}),ne(re[45],ie([0,1,2]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bt=void 0;class y{static insert(h,w){return{range:new i.$At(h.lineNumber,h.column,h.lineNumber,h.column),text:w,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,w){return{range:h,text:w}}static replaceMove(h,w){return{range:h,text:w,forceMoveMarkers:!0}}}t.$Bt=y}),ne(re[13],ie([0,1,3,5,2,8]),function(B,t,i,y,M,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kt=t.$Jt=void 0;class w{static fromRange(u){return new w(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new w(u.startLineNumber,u.endLineNumber+1)}static subtract(u,o){return o?u.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<u.endLineNumberExclusive?[new w(u.startLineNumber,o.startLineNumber),new w(o.endLineNumberExclusive,u.endLineNumberExclusive)]:o.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<u.endLineNumberExclusive?[new w(Math.max(o.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new w(u.startLineNumber,Math.min(o.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let o=new g(u[0].slice());for(let N=1;N<u.length;N++)o=o.getUnion(new g(u[N].slice()));return o.ranges}static join(u){if(u.length===0)throw new i.$cb("lineRanges cannot be empty");let o=u[0].startLineNumber,N=u[0].endLineNumberExclusive;for(let m=1;m<u.length;m++)o=Math.min(o,u[m].startLineNumber),N=Math.max(N,u[m].endLineNumberExclusive);return new w(o,N)}static ofLength(u,o){return new w(u,u+o)}static deserialize(u){return new w(u[0],u[1])}constructor(u,o){if(u>o)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=u,this.endLineNumberExclusive=o}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new w(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new w(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new w(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const o=Math.max(this.startLineNumber,u.startLineNumber),N=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(o<=N)return new w(o,N)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.$At(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.$At(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const o=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)o.push(u(N));return o}forEach(u){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)u(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new y.$Ht(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Jt=w;class g{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const o=(0,h.$kb)(this.c,m=>m.endLineNumberExclusive>=u.startLineNumber),N=(0,h.$ib)(this.c,m=>m.startLineNumber<=u.endLineNumberExclusive)+1;if(o===N)this.c.splice(o,0,u);else if(o===N-1){const m=this.c[o];this.c[o]=m.join(u)}else{const m=this.c[o].join(this.c[N-1]).join(u);this.c.splice(o,N-o,m)}}contains(u){const o=(0,h.$hb)(this.c,N=>N.startLineNumber<=u);return!!o&&o.endLineNumberExclusive>u}intersects(u){const o=(0,h.$hb)(this.c,N=>N.startLineNumber<u.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const o=[];let N=0,m=0,b=null;for(;N<this.c.length||m<u.c.length;){let e=null;if(N<this.c.length&&m<u.c.length){const d=this.c[N],p=u.c[m];d.startLineNumber<p.startLineNumber?(e=d,N++):(e=p,m++)}else N<this.c.length?(e=this.c[N],N++):(e=u.c[m],m++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new w(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(b),b=e)}return b!==null&&o.push(b),new g(o)}subtractFrom(u){const o=(0,h.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),N=(0,h.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(o===N)return new g([u]);const m=[];let b=u.startLineNumber;for(let e=o;e<N;e++){const d=this.c[e];d.startLineNumber>b&&m.push(new w(b,d.startLineNumber)),b=d.endLineNumberExclusive}return b<u.endLineNumberExclusive&&m.push(new w(b,u.endLineNumberExclusive)),new g(m)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const o=[];let N=0,m=0;for(;N<this.c.length&&m<u.c.length;){const b=this.c[N],e=u.c[m],d=b.intersect(e);d&&!d.isEmpty&&o.push(d),b.endLineNumberExclusive<e.endLineNumberExclusive?N++:m++}return new g(o)}getWithDelta(u){return new g(this.c.map(o=>o.delta(u)))}}t.$Kt=g}),ne(re[46],ie([0,1,4,2]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=t.SelectionDirection=void 0;var M;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(M||(t.SelectionDirection=M={}));class h extends y.$At{constructor(g,a,u,o){super(g,a,u,o),this.selectionStartLineNumber=g,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return h.selectionsEqual(this,g)}static selectionsEqual(g,a){return g.selectionStartLineNumber===a.selectionStartLineNumber&&g.selectionStartColumn===a.selectionStartColumn&&g.positionLineNumber===a.positionLineNumber&&g.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,a){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,g,a):new h(g,a,this.startLineNumber,this.startColumn)}getPosition(){return new i.$zt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$zt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,a){return this.getDirection()===0?new h(g,a,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,g,a)}static fromPositions(g,a=g){return new h(g.lineNumber,g.column,a.lineNumber,a.column)}static fromRange(g,a){return a===0?new h(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new h(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new h(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,a){if(g&&!a||!g&&a)return!1;if(!g&&!a)return!0;if(g.length!==a.length)return!1;for(let u=0,o=g.length;u<o;u++)if(!this.selectionsEqual(g[u],a[u]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,a,u,o,N){return N===0?new h(g,a,u,o):new h(u,o,g,a)}}t.$Ct=h}),ne(re[30],ie([0,1,4,2]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lt=void 0;class M{static{this.zero=new M(0,0)}static lengthDiffNonNegative(w,g){return g.isLessThan(w)?M.zero:w.lineCount===g.lineCount?new M(0,g.columnCount-w.columnCount):new M(g.lineCount-w.lineCount,g.columnCount)}static betweenPositions(w,g){return w.lineNumber===g.lineNumber?new M(0,g.column-w.column):new M(g.lineNumber-w.lineNumber,g.column-1)}static ofRange(w){return M.betweenPositions(w.getStartPosition(),w.getEndPosition())}static ofText(w){let g=0,a=0;for(const u of w)u===`
`?(g++,a=0):a++;return new M(g,a)}constructor(w,g){this.lineCount=w,this.columnCount=g}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(w){return this.lineCount!==w.lineCount?this.lineCount<w.lineCount:this.columnCount<w.columnCount}isGreaterThan(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>w.columnCount}isGreaterThanOrEqualTo(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>=w.columnCount}equals(w){return this.lineCount===w.lineCount&&this.columnCount===w.columnCount}compare(w){return this.lineCount!==w.lineCount?this.lineCount-w.lineCount:this.columnCount-w.columnCount}add(w){return w.lineCount===0?new M(this.lineCount,this.columnCount+w.columnCount):new M(this.lineCount+w.lineCount,w.columnCount)}createRange(w){return this.lineCount===0?new y.$At(w.lineNumber,w.column,w.lineNumber,w.column+this.columnCount):new y.$At(w.lineNumber,w.column,w.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new y.$At(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(w){return this.lineCount===0?new i.$zt(w.lineNumber,w.column+this.columnCount):new i.$zt(w.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.$Lt=M}),ne(re[47],ie([0,1,8,5,4,2,30]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mt=void 0;class g{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let o=0;o<u.length;o++)u.charAt(o)===`
`&&this.a.push(o+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new y.$Ht(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const o=(0,i.$ib)(this.a,b=>b<=u),N=o+1,m=u-this.a[o]+1;return new M.$zt(N,m)}getRange(u){return h.$At.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return w.$Lt.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new w.$Lt(u,this.text.length-this.a[u])}}t.$Mt=g}),ne(re[48],ie([0,1,10,3,4,47,2,30]),function(B,t,i,y,M,h,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rt=t.$Qt=t.$Pt=t.$Ot=t.$Nt=void 0;class a{static single(d,p){return new a([new u(d,p)])}constructor(d){this.edits=d,(0,i.$hd)(()=>(0,i.$id)(d,(p,E)=>p.range.getEndPosition().isBeforeOrEqual(E.range.getStartPosition())))}normalize(){const d=[];for(const p of this.edits)if(d.length>0&&d[d.length-1].range.getEndPosition().equals(p.range.getStartPosition())){const E=d[d.length-1];d[d.length-1]=new u(E.range.plusRange(p.range),E.text+p.text)}else p.isEmpty||d.push(p);return new a(d)}mapPosition(d){let p=0,E=0,$=0;for(const v of this.edits){const j=v.range.getStartPosition(),l=v.range.getEndPosition();if(d.isBeforeOrEqual(j))break;const n=g.$Lt.ofText(v.text);if(d.isBefore(l)){const s=new M.$zt(j.lineNumber+p,j.column+(j.lineNumber+p===E?$:0)),f=n.addToPosition(s);return o(s,f)}p+=n.lineCount-(v.range.endLineNumber-v.range.startLineNumber),n.lineCount===0?l.lineNumber!==j.lineNumber?$+=n.columnCount-(l.column-1):$+=n.columnCount-(l.column-j.column):$=n.columnCount,E=l.lineNumber+p}return new M.$zt(d.lineNumber+p,d.column+(d.lineNumber+p===E?$:0))}mapRange(d){function p(j){return j instanceof M.$zt?j:j.getStartPosition()}function E(j){return j instanceof M.$zt?j:j.getEndPosition()}const $=p(this.mapPosition(d.getStartPosition())),v=E(this.mapPosition(d.getEndPosition()));return o($,v)}inverseMapPosition(d,p){return this.inverse(p).mapPosition(d)}inverseMapRange(d,p){return this.inverse(p).mapRange(d)}apply(d){let p="",E=new M.$zt(1,1);for(const v of this.edits){const j=v.range,l=j.getStartPosition(),n=j.getEndPosition(),s=o(E,l);s.isEmpty()||(p+=d.getValueOfRange(s)),p+=v.text,E=n}const $=o(E,d.endPositionExclusive);return $.isEmpty()||(p+=d.getValueOfRange($)),p}applyToString(d){const p=new b(d);return this.apply(p)}inverse(d){const p=this.getNewRanges();return new a(this.edits.map((E,$)=>new u(p[$],d.getValueOfRange(E.range))))}getNewRanges(){const d=[];let p=0,E=0,$=0;for(const v of this.edits){const j=g.$Lt.ofText(v.text),l=M.$zt.lift({lineNumber:v.range.startLineNumber+E,column:v.range.startColumn+(v.range.startLineNumber===p?$:0)}),n=j.createRange(l);d.push(n),E=n.endLineNumber-v.range.endLineNumber,$=n.endColumn-v.range.endColumn,p=v.range.endLineNumber}return d}}t.$Nt=a;class u{constructor(d,p){this.range=d,this.text=p}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(d,p){return d.range.equalsRange(p.range)&&d.text===p.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.$Ot=u;function o(e,d){if(e.lineNumber===d.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return w.$At.fromPositions(d,d);if(!e.isBeforeOrEqual(d))throw new y.$cb("start must be before end");return new w.$At(e.lineNumber,e.column,d.lineNumber,d.column)}class N{get endPositionExclusive(){return this.length.addToPosition(new M.$zt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.$Pt=N;class m extends N{constructor(d,p){(0,i.$fd)(p>=1),super(),this.c=d,this.d=p}getValueOfRange(d){if(d.startLineNumber===d.endLineNumber)return this.c(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);let p=this.c(d.startLineNumber).substring(d.startColumn-1);for(let E=d.startLineNumber+1;E<d.endLineNumber;E++)p+=`
`+this.c(E);return p+=`
`+this.c(d.endLineNumber).substring(0,d.endColumn-1),p}get length(){const d=this.c(this.d);return new g.$Lt(this.d-1,d.length)}}t.$Qt=m;class b extends N{constructor(d){super(),this.value=d,this.c=new h.$Mt(this.value)}getValueOfRange(d){return this.c.getOffsetRange(d).substring(this.value)}get length(){return this.c.textLength}}t.$Rt=b}),ne(re[49],ie([0,1,14,29]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7t=t.WordCharacterClass=void 0,t.$8t=g;var M;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(M||(t.WordCharacterClass=M={}));class h extends y.$5t{constructor(u,o){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=o,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let N=0,m=u.length;N<m;N++)this.set(u.charCodeAt(N),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(u,o){let N=null;for(const m of this.h(u)){if(m.index>o)break;N=m}return N}findNextIntlWordAtOrAfterOffset(u,o){for(const N of this.h(u))if(!(N.index<o))return N;return null}h(u){return this.e?this.f===u?this.g:(this.f=u,this.g=this.j(this.e.segment(u)),this.g):[]}j(u){const o=[];for(const N of u)this.k(N)&&o.push(N);return o}k(u){return!!u.isWordLike}}t.$7t=h;const w=new i.$Dc(10);function g(a,u){const o=`${a}/${u.join(",")}`;let N=w.get(o);return N||(N=new h(a,u),w.set(o,N)),N}}),ne(re[31],ie([0,1,21,11,22]),function(B,t,i,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=void 0,t.$at=w,t.$bt=a,t.$ct=u,t.$$s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(N=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$$s)N.indexOf(b)>=0||(m+="\\"+b);return m+="\\s]+)",new RegExp(m,"g")}t.$_s=h();function w(N){let m=t.$_s;if(N&&N instanceof RegExp)if(N.global)m=N;else{let b="g";N.ignoreCase&&(b+="i"),N.multiline&&(b+="m"),N.unicode&&(b+="u"),m=new RegExp(N.source,b)}return m.lastIndex=0,m}const g=new M.$5c;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(N){const m=g.unshift(N);return(0,y.$Sc)(m)}function u(N,m,b,e,d){if(m=w(m),d||(d=i.Iterable.first(g)),b.length>d.maxLen){let j=N-d.maxLen/2;return j<0?j=0:e+=j,b=b.substring(j,N+d.maxLen/2),u(N,m,b,e,d)}const p=Date.now(),E=N-1-e;let $=-1,v=null;for(let j=1;!(Date.now()-p>=d.timeBudget);j++){const l=E-d.windowSize*j;m.lastIndex=Math.max(0,l);const n=o(m,b,E,$);if(!n&&v||(v=n,l<=0))break;$=l}if(v){const j={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return m.lastIndex=0,j}return null}function o(N,m,b,e){let d;for(;d=N.exec(m);){const p=d.index||0;if(p<=b&&N.lastIndex>=b)return d;if(e>0&&p>e)return null}return null}}),ne(re[9],ie([0,1,6,3,5]),function(B,t,i,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$72=t.$62=t.$52=t.$42=t.$32=void 0;class h{static trivial(N,m){return new h([new w(M.$Ht.ofLength(N.length),M.$Ht.ofLength(m.length))],!1)}static trivialTimedOut(N,m){return new h([new w(M.$Ht.ofLength(N.length),M.$Ht.ofLength(m.length))],!0)}constructor(N,m){this.diffs=N,this.hitTimeout=m}}t.$32=h;class w{static invert(N,m){const b=[];return(0,i.$Bb)(N,(e,d)=>{b.push(w.fromOffsetPairs(e?e.getEndExclusives():g.zero,d?d.getStarts():new g(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),b}static fromOffsetPairs(N,m){return new w(new M.$Ht(N.offset1,m.offset1),new M.$Ht(N.offset2,m.offset2))}constructor(N,m){this.seq1Range=N,this.seq2Range=m}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new w(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new w(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new w(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new w(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const m=this.seq1Range.intersect(N.seq1Range),b=this.seq2Range.intersect(N.seq2Range);if(!(!m||!b))return new w(m,b)}getStarts(){return new g(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new g(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$42=w;class g{static{this.zero=new g(0,0)}static{this.max=new g(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,m){this.offset1=N,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(N){return N===0?this:new g(this.offset1+N,this.offset2+N)}equals(N){return this.offset1===N.offset1&&this.offset2===N.offset2}}t.$52=g;class a{static{this.instance=new a}isValid(){return!0}}t.$62=a;class u{constructor(N){if(this.e=N,this.c=Date.now(),this.d=!0,N<=0)throw new y.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$72=u}),ne(re[32],ie([0,1,5,9]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_2=void 0;class M{compute(u,o,N=y.$62.instance){if(u.length===0||o.length===0)return y.$32.trivial(u,o);const m=u,b=o;function e(s,f){for(;s<m.length&&f<b.length&&m.getElement(s)===b.getElement(f);)s++,f++;return s}let d=0;const p=new w;p.set(0,e(0,0));const E=new g;E.set(0,p.get(0)===0?null:new h(null,0,0,p.get(0)));let $=0;e:for(;;){if(d++,!N.isValid())return y.$32.trivialTimedOut(m,b);const s=-Math.min(d,b.length+d%2),f=Math.min(d,m.length+d%2);for($=s;$<=f;$+=2){let c=0;const L=$===f?-1:p.get($+1),A=$===s?-1:p.get($-1)+1;c++;const R=Math.min(Math.max(L,A),m.length),P=R-$;if(c++,R>m.length||P>b.length)continue;const k=e(R,P);p.set($,k);const S=R===L?E.get($+1):E.get($-1);if(E.set($,k!==R?new h(S,R,P,k-R):S),p.get($)===m.length&&p.get($)-$===b.length)break e}}let v=E.get($);const j=[];let l=m.length,n=b.length;for(;;){const s=v?v.x+v.length:0,f=v?v.y+v.length:0;if((s!==l||f!==n)&&j.push(new y.$42(new i.$Ht(s,l),new i.$Ht(f,n))),!v)break;l=v.x,n=v.y,v=v.prev}return j.reverse(),new y.$32(j,!1)}}t.$_2=M;class h{constructor(u,o,N,m){this.prev=u,this.x=o,this.y=N,this.length=m}}class w{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){if(u<0){if(u=-u-1,u>=this.b.length){const N=this.b;this.b=new Int32Array(N.length*2),this.b.set(N)}this.b[u]=o}else{if(u>=this.a.length){const N=this.a;this.a=new Int32Array(N.length*2),this.a.set(N)}this.a[u]=o}}}class g{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){u<0?(u=-u-1,this.b[u]=o):this.a[u]=o}}}),ne(re[50],ie([0,1,6,5,9]),function(B,t,i,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d3=h,t.$e3=u,t.$f3=o,t.$g3=m,t.$h3=b;function h(e,d,p){let E=p;return E=w(e,d,E),E=w(e,d,E),E=g(e,d,E),E}function w(e,d,p){if(p.length===0)return p;const E=[];E.push(p[0]);for(let v=1;v<p.length;v++){const j=E[E.length-1];let l=p[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-j.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||d.getElement(l.seq2Range.start-s)!==d.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){E[E.length-1]=new M.$42(new y.$Ht(j.seq1Range.start,l.seq1Range.endExclusive-n),new y.$Ht(j.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}E.push(l)}const $=[];for(let v=0;v<E.length-1;v++){const j=E[v+1];let l=E[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=j.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!d.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){E[v+1]=new M.$42(new y.$Ht(l.seq1Range.start+n,j.seq1Range.endExclusive),new y.$Ht(l.seq2Range.start+n,j.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}$.push(l)}return E.length>0&&$.push(E[E.length-1]),$}function g(e,d,p){if(!e.getBoundaryScore||!d.getBoundaryScore)return p;for(let E=0;E<p.length;E++){const $=E>0?p[E-1]:void 0,v=p[E],j=E+1<p.length?p[E+1]:void 0,l=new y.$Ht($?$.seq1Range.endExclusive+1:0,j?j.seq1Range.start-1:e.length),n=new y.$Ht($?$.seq2Range.endExclusive+1:0,j?j.seq2Range.start-1:d.length);v.seq1Range.isEmpty?p[E]=a(v,e,d,l,n):v.seq2Range.isEmpty&&(p[E]=a(v.swap(),d,e,n,l).swap())}return p}function a(e,d,p,E,$){let j=1;for(;e.seq1Range.start-j>=E.start&&e.seq2Range.start-j>=$.start&&p.isStronglyEqual(e.seq2Range.start-j,e.seq2Range.endExclusive-j)&&j<100;)j++;j--;let l=0;for(;e.seq1Range.start+l<E.endExclusive&&e.seq2Range.endExclusive+l<$.endExclusive&&p.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(j===0&&l===0)return e;let n=0,s=-1;for(let f=-j;f<=l;f++){const c=e.seq2Range.start+f,L=e.seq2Range.endExclusive+f,A=e.seq1Range.start+f,R=d.getBoundaryScore(A)+p.getBoundaryScore(c)+p.getBoundaryScore(L);R>s&&(s=R,n=f)}return e.delta(n)}function u(e,d,p){const E=[];for(const $ of p){const v=E[E.length-1];if(!v){E.push($);continue}$.seq1Range.start-v.seq1Range.endExclusive<=2||$.seq2Range.start-v.seq2Range.endExclusive<=2?E[E.length-1]=new M.$42(v.seq1Range.join($.seq1Range),v.seq2Range.join($.seq2Range)):E.push($)}return E}function o(e,d,p){const E=M.$42.invert(p,e.length),$=[];let v=new M.$52(0,0);function j(n,s){if(n.offset1<v.offset1||n.offset2<v.offset2)return;const f=e.findWordContaining(n.offset1),c=d.findWordContaining(n.offset2);if(!f||!c)return;let L=new M.$42(f,c);const A=L.intersect(s);let R=A.seq1Range.length,P=A.seq2Range.length;for(;E.length>0;){const k=E[0];if(!(k.seq1Range.intersects(L.seq1Range)||k.seq2Range.intersects(L.seq2Range)))break;const I=e.findWordContaining(k.seq1Range.start),D=d.findWordContaining(k.seq2Range.start),q=new M.$42(I,D),H=q.intersect(k);if(R+=H.seq1Range.length,P+=H.seq2Range.length,L=L.join(q),L.seq1Range.endExclusive>=k.seq1Range.endExclusive)E.shift();else break}R+P<(L.seq1Range.length+L.seq2Range.length)*2/3&&$.push(L),v=L.getEndExclusives()}for(;E.length>0;){const n=E.shift();n.seq1Range.isEmpty||(j(n.getStarts(),n),j(n.getEndExclusives().delta(-1),n))}return N(p,$)}function N(e,d){const p=[];for(;e.length>0||d.length>0;){const E=e[0],$=d[0];let v;E&&(!$||E.seq1Range.start<$.seq1Range.start)?v=e.shift():v=d.shift(),p.length>0&&p[p.length-1].seq1Range.endExclusive>=v.seq1Range.start?p[p.length-1]=p[p.length-1].join(v):p.push(v)}return p}function m(e,d,p){let E=p;if(E.length===0)return E;let $=0,v;do{v=!1;const j=[E[0]];for(let l=1;l<E.length;l++){let f=function(L,A){const R=new y.$Ht(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(L.seq1Range.length+L.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const n=E[l],s=j[j.length-1];f(s,n)?(v=!0,j[j.length-1]=j[j.length-1].join(n)):j.push(n)}E=j}while($++<10&&v);return E}function b(e,d,p){let E=p;if(E.length===0)return E;let $=0,v;do{v=!1;const l=[E[0]];for(let n=1;n<E.length;n++){let c=function(A,R){const P=new y.$Ht(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const S=e.getText(P).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(A.seq1Range),D=A.seq1Range.length,q=d.countLinesIn(A.seq2Range),H=A.seq2Range.length,W=e.countLinesIn(R.seq1Range),U=R.seq1Range.length,Z=d.countLinesIn(R.seq2Range),X=R.seq2Range.length,J=2*40+50;function _(K){return Math.min(K,J)}return Math.pow(Math.pow(_(I*40+D),1.5)+Math.pow(_(q*40+H),1.5),1.5)+Math.pow(Math.pow(_(W*40+U),1.5)+Math.pow(_(Z*40+X),1.5),1.5)>(J**1.5)**1.5*1.3};const s=E[n],f=l[l.length-1];c(f,s)?(v=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}E=l}while($++<10&&v);const j=[];return(0,i.$Cb)(E,(l,n,s)=>{let f=n;function c(S){return S.length>0&&S.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const L=e.extendToFullLines(n.seq1Range),A=e.getText(new y.$Ht(L.start,n.seq1Range.start));c(A)&&(f=f.deltaStart(-A.length));const R=e.getText(new y.$Ht(n.seq1Range.endExclusive,L.endExclusive));c(R)&&(f=f.deltaEnd(R.length));const P=M.$42.fromOffsetPairs(l?l.getEndExclusives():M.$52.zero,s?s.getStarts():M.$52.max),k=f.intersect(P);j.length>0&&k.getStarts().equals(j[j.length-1].getEndExclusives())?j[j.length-1]=j[j.length-1].join(k):j.push(k)}),j}}),ne(re[51],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c3=void 0;class i{constructor(h,w){this.a=h,this.b=w}getElement(h){return this.a[h]}get length(){return this.a.length}getBoundaryScore(h){const w=h===0?0:y(this.b[h-1]),g=h===this.b.length?0:y(this.b[h]);return 1e3-(w+g)}getText(h){return this.b.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,w){return this.b[h]===this.b[w]}}t.$c3=i;function y(M){let h=0;for(;h<M.length&&(M.charCodeAt(h)===32||M.charCodeAt(h)===9);)h++;return h}}),ne(re[16],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$02=t.$82=void 0,t.$92=y;class i{constructor(w,g){this.width=w,this.height=g,this.a=[],this.a=new Array(w*g)}get(w,g){return this.a[w+g*this.width]}set(w,g,a){this.a[w+g*this.width]=a}}t.$82=i;function y(h){return h===32||h===9}class M{static{this.a=new Map}static b(w){let g=this.a.get(w);return g===void 0&&(g=this.a.size,this.a.set(w,g)),g}constructor(w,g,a){this.range=w,this.lines=g,this.source=a,this.d=[];let u=0;for(let o=w.startLineNumber-1;o<w.endLineNumberExclusive-1;o++){const N=g[o];for(let b=0;b<N.length;b++){u++;const e=N[b],d=M.b(e);this.d[d]=(this.d[d]||0)+1}u++;const m=M.b(`
`);this.d[m]=(this.d[m]||0)+1}this.c=u}computeSimilarity(w){let g=0;const a=Math.max(this.d.length,w.d.length);for(let u=0;u<a;u++)g+=Math.abs((this.d[u]??0)-(w.d[u]??0));return 1-g/(this.c+w.c)}}t.$02=M}),ne(re[52],ie([0,1,5,9,16]),function(B,t,i,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$2=void 0;class h{compute(g,a,u=y.$62.instance,o){if(g.length===0||a.length===0)return y.$32.trivial(g,a);const N=new M.$82(g.length,a.length),m=new M.$82(g.length,a.length),b=new M.$82(g.length,a.length);for(let j=0;j<g.length;j++)for(let l=0;l<a.length;l++){if(!u.isValid())return y.$32.trivialTimedOut(g,a);const n=j===0?0:N.get(j-1,l),s=l===0?0:N.get(j,l-1);let f;g.getElement(j)===a.getElement(l)?(j===0||l===0?f=0:f=N.get(j-1,l-1),j>0&&l>0&&m.get(j-1,l-1)===3&&(f+=b.get(j-1,l-1)),f+=o?o(j,l):1):f=-1;const c=Math.max(n,s,f);if(c===f){const L=j>0&&l>0?b.get(j-1,l-1):0;b.set(j,l,L+1),m.set(j,l,3)}else c===n?(b.set(j,l,0),m.set(j,l,1)):c===s&&(b.set(j,l,0),m.set(j,l,2));N.set(j,l,c)}const e=[];let d=g.length,p=a.length;function E(j,l){(j+1!==d||l+1!==p)&&e.push(new y.$42(new i.$Ht(j+1,d),new i.$Ht(l+1,p))),d=j,p=l}let $=g.length-1,v=a.length-1;for(;$>=0&&v>=0;)m.get($,v)===3?(E($,v),$--,v--):m.get($,v)===1?$--:v--;return E(-1,-1),e.reverse(),new y.$32(e,!1)}}t.$$2=h}),ne(re[33],ie([0,1,8,5,4,2,16]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a3=void 0;class g{constructor(e,d,p){this.lines=e,this.considerWhitespaceChanges=p,this.b=[],this.c=[],this.d=[];let E=!1;d.start>0&&d.endExclusive>=e.length&&(d=new y.$Ht(d.start-1,d.endExclusive),E=!0),this.lineRange=d,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let v=e[$],j=0;if(E)j=v.length,v="",E=!1;else if(!p){const l=v.trimStart();j=v.length-l.length,v=l.trimEnd()}this.d.push(j);for(let l=0;l<v.length;l++)this.b.push(v.charCodeAt(l));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new y.$Ht(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(d=>String.fromCharCode(d)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const d=m(e>0?this.b[e-1]:-1),p=m(e<this.b.length?this.b[e]:-1);if(d===7&&p===8)return 0;if(d===8)return 150;let E=0;return d!==p&&(E+=10,d===0&&p===1&&(E+=1)),E+=N(d),E+=N(p),E}translateOffset(e){if(this.lineRange.isEmpty)return new M.$zt(this.lineRange.start+1,1);const d=(0,i.$ib)(this.c,p=>p<=e);return new M.$zt(this.lineRange.start+d+1,e-this.c[d]+this.d[d]+1)}translateRange(e){return h.$At.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let d=e;for(;d>0&&a(this.b[d-1]);)d--;let p=e;for(;p<this.b.length&&a(this.b[p]);)p++;return new y.$Ht(d,p)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,d){return this.b[e]===this.b[d]}extendToFullLines(e){const d=(0,i.$hb)(this.c,E=>E<=e.start)??0,p=(0,i.$jb)(this.c,E=>e.endExclusive<=E)??this.b.length;return new y.$Ht(d,p)}}t.$a3=g;function a(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var u;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Separator=5]="Separator",b[b.Space=6]="Space",b[b.LineBreakCR=7]="LineBreakCR",b[b.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const o={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function N(b){return o[b]}function m(b){return b===10?8:b===13?7:(0,w.$92)(b)?6:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:b===44||b===59?5:4}}),ne(re[34],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wt=t.$Vt=void 0;class i{constructor(h,w,g){this.changes=h,this.moves=w,this.hitTimeout=g}}t.$Vt=i;class y{constructor(h,w){this.lineRangeMapping=h,this.changes=w}flip(){return new y(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}t.$Wt=y}),ne(re[17],ie([0,1,3,13,2,48]),function(B,t,i,y,M,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ut=t.$Tt=t.$St=void 0;class w{static inverse(o,N,m){const b=[];let e=1,d=1;for(const E of o){const $=new w(new y.$Jt(e,E.original.startLineNumber),new y.$Jt(d,E.modified.startLineNumber));$.modified.isEmpty||b.push($),e=E.original.endLineNumberExclusive,d=E.modified.endLineNumberExclusive}const p=new w(new y.$Jt(e,N+1),new y.$Jt(d,m+1));return p.modified.isEmpty||b.push(p),b}static clip(o,N,m){const b=[];for(const e of o){const d=e.original.intersect(N),p=e.modified.intersect(m);d&&!d.isEmpty&&p&&!p.isEmpty&&b.push(new w(d,p))}return b}constructor(o,N){this.original=o,this.modified=N}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new w(this.modified,this.original)}join(o){return new w(this.original.join(o.original),this.modified.join(o.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const o=this.original.toInclusiveRange(),N=this.modified.toInclusiveRange();if(o&&N)return new a(o,N);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new i.$cb("not a valid diff");return new a(new M.$At(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new M.$At(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new M.$At(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new M.$At(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}t.$St=w;class g extends w{static fromRangeMappings(o){const N=y.$Jt.join(o.map(b=>y.$Jt.fromRangeInclusive(b.originalRange))),m=y.$Jt.join(o.map(b=>y.$Jt.fromRangeInclusive(b.modifiedRange)));return new g(N,m,o)}constructor(o,N,m){super(o,N),this.innerChanges=m}flip(){return new g(this.modified,this.original,this.innerChanges?.map(o=>o.flip()))}withInnerChangesFromLineRanges(){return new g(this.original,this.modified,[this.toRangeMapping()])}}t.$Tt=g;class a{constructor(o,N){this.originalRange=o,this.modifiedRange=N}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(o){const N=o.getValueOfRange(this.modifiedRange);return new h.$Ot(this.originalRange,N)}}t.$Ut=a}),ne(re[53],ie([0,1,9,17,6,8,14,13,5,33,16,32]),function(B,t,i,y,M,h,w,g,a,u,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b3=m;function m(v,j,l,n,s,f){let{moves:c,excludedChanges:L}=e(v,j,l,f);if(!f.isValid())return[];const A=v.filter(P=>!L.has(P)),R=d(A,n,s,j,l,f);return(0,M.$Zb)(c,R),c=E(c),c=c.filter(P=>{const k=P.original.toOffsetRange().slice(j).map(I=>I.trim());return k.join(`
`).length>=15&&b(k,I=>I.length>=2)>=2}),c=$(v,c),c}function b(v,j){let l=0;for(const n of v)j(n)&&l++;return l}function e(v,j,l,n){const s=[],f=v.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new o.$02(A.original,j,A)),c=new Set(v.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new o.$02(A.modified,l,A))),L=new Set;for(const A of f){let R=-1,P;for(const k of c){const S=A.computeSimilarity(k);S>R&&(R=S,P=k)}if(R>.9&&P&&(c.delete(P),s.push(new y.$St(A.range,P.range)),L.add(A.source),L.add(P.source)),!n.isValid())return{moves:s,excludedChanges:L}}return{moves:s,excludedChanges:L}}function d(v,j,l,n,s,f){const c=[],L=new w.$Hc;for(const S of v)for(let I=S.original.startLineNumber;I<S.original.endLineNumberExclusive-2;I++){const D=`${j[I-1]}:${j[I+1-1]}:${j[I+2-1]}`;L.add(D,{range:new g.$Jt(I,I+3)})}const A=[];v.sort((0,M.$6b)(S=>S.modified.startLineNumber,M.$8b));for(const S of v){let I=[];for(let D=S.modified.startLineNumber;D<S.modified.endLineNumberExclusive-2;D++){const q=`${l[D-1]}:${l[D+1-1]}:${l[D+2-1]}`,H=new g.$Jt(D,D+3),W=[];L.forEach(q,({range:U})=>{for(const X of I)if(X.originalLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){X.originalLineRange=new g.$Jt(X.originalLineRange.startLineNumber,U.endLineNumberExclusive),X.modifiedLineRange=new g.$Jt(X.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),W.push(X);return}const Z={modifiedLineRange:H,originalLineRange:U};A.push(Z),W.push(Z)}),I=W}if(!f.isValid())return[]}A.sort((0,M.$0b)((0,M.$6b)(S=>S.modifiedLineRange.length,M.$8b)));const R=new g.$Kt,P=new g.$Kt;for(const S of A){const I=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,D=R.subtractFrom(S.modifiedLineRange),q=P.subtractFrom(S.originalLineRange).getWithDelta(I),H=D.getIntersection(q);for(const W of H.ranges){if(W.length<3)continue;const U=W,Z=W.delta(-I);c.push(new y.$St(Z,U)),R.addRange(U),P.addRange(Z)}}c.sort((0,M.$6b)(S=>S.original.startLineNumber,M.$8b));const k=new h.$mb(v);for(let S=0;S<c.length;S++){const I=c[S],D=k.findLastMonotonous(_=>_.original.startLineNumber<=I.original.startLineNumber),q=(0,h.$hb)(v,_=>_.modified.startLineNumber<=I.modified.startLineNumber),H=Math.max(I.original.startLineNumber-D.original.startLineNumber,I.modified.startLineNumber-q.modified.startLineNumber),W=k.findLastMonotonous(_=>_.original.startLineNumber<I.original.endLineNumberExclusive),U=(0,h.$hb)(v,_=>_.modified.startLineNumber<I.modified.endLineNumberExclusive),Z=Math.max(W.original.endLineNumberExclusive-I.original.endLineNumberExclusive,U.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let X;for(X=0;X<H;X++){const _=I.original.startLineNumber-X-1,K=I.modified.startLineNumber-X-1;if(_>n.length||K>s.length||R.contains(K)||P.contains(_)||!p(n[_-1],s[K-1],f))break}X>0&&(P.addRange(new g.$Jt(I.original.startLineNumber-X,I.original.startLineNumber)),R.addRange(new g.$Jt(I.modified.startLineNumber-X,I.modified.startLineNumber)));let J;for(J=0;J<Z;J++){const _=I.original.endLineNumberExclusive+J,K=I.modified.endLineNumberExclusive+J;if(_>n.length||K>s.length||R.contains(K)||P.contains(_)||!p(n[_-1],s[K-1],f))break}J>0&&(P.addRange(new g.$Jt(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+J)),R.addRange(new g.$Jt(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+J))),(X>0||J>0)&&(c[S]=new y.$St(new g.$Jt(I.original.startLineNumber-X,I.original.endLineNumberExclusive+J),new g.$Jt(I.modified.startLineNumber-X,I.modified.endLineNumberExclusive+J)))}return c}function p(v,j,l){if(v.trim()===j.trim())return!0;if(v.length>300&&j.length>300)return!1;const s=new N.$_2().compute(new u.$a3([v],new a.$Ht(0,1),!1),new u.$a3([j],new a.$Ht(0,1),!1),l);let f=0;const c=i.$42.invert(s.diffs,v.length);for(const P of c)P.seq1Range.forEach(k=>{(0,o.$92)(v.charCodeAt(k))||f++});function L(P){let k=0;for(let S=0;S<v.length;S++)(0,o.$92)(P.charCodeAt(S))||k++;return k}const A=L(v.length>j.length?v:j);return f/A>.6&&A>10}function E(v){if(v.length===0)return v;v.sort((0,M.$6b)(l=>l.original.startLineNumber,M.$8b));const j=[v[0]];for(let l=1;l<v.length;l++){const n=j[j.length-1],s=v[l],f=s.original.startLineNumber-n.original.endLineNumberExclusive,c=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(f>=0&&c>=0&&f+c<=2){j[j.length-1]=n.join(s);continue}j.push(s)}return j}function $(v,j){const l=new h.$mb(v);return j=j.filter(n=>{const s=l.findLastMonotonous(L=>L.original.startLineNumber<n.original.endLineNumberExclusive)||new y.$St(new g.$Jt(1,1),new g.$Jt(1,1)),f=(0,h.$hb)(v,L=>L.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==f}),j}}),ne(re[54],ie([0,1,6,10,13,5,2,9,52,32,53,50,51,33,34,17]),function(B,t,i,y,M,h,w,g,a,u,o,N,m,b,e,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i3=void 0,t.$j3=E,t.$k3=$;class p{constructor(){this.e=new a.$$2,this.f=new u.$_2}computeDiff(j,l,n){if(j.length<=1&&(0,i.$ub)(j,l,(J,_)=>J===_))return new e.$Vt([],[],!1);if(j.length===1&&j[0].length===0||l.length===1&&l[0].length===0)return new e.$Vt([new d.$Tt(new M.$Jt(1,j.length+1),new M.$Jt(1,l.length+1),[new d.$Ut(new w.$At(1,1,j.length,j[j.length-1].length+1),new w.$At(1,1,l.length,l[l.length-1].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?g.$62.instance:new g.$72(n.maxComputationTimeMs),f=!n.ignoreTrimWhitespace,c=new Map;function L(J){let _=c.get(J);return _===void 0&&(_=c.size,c.set(J,_)),_}const A=j.map(J=>L(J.trim())),R=l.map(J=>L(J.trim())),P=new m.$c3(A,j),k=new m.$c3(R,l),S=P.length+k.length<1700?this.e.compute(P,k,s,(J,_)=>j[J]===l[_]?l[_].length===0?.1:1+Math.log(1+l[_].length):.99):this.f.compute(P,k);let I=S.diffs,D=S.hitTimeout;I=(0,N.$d3)(P,k,I),I=(0,N.$g3)(P,k,I);const q=[],H=J=>{if(f)for(let _=0;_<J;_++){const K=W+_,F=U+_;if(j[K]!==l[F]){const z=this.j(j,l,new g.$42(new h.$Ht(K,K+1),new h.$Ht(F,F+1)),s,f);for(const oe of z.mappings)q.push(oe);z.hitTimeout&&(D=!0)}}};let W=0,U=0;for(const J of I){(0,y.$hd)(()=>J.seq1Range.start-W===J.seq2Range.start-U);const _=J.seq1Range.start-W;H(_),W=J.seq1Range.endExclusive,U=J.seq2Range.endExclusive;const K=this.j(j,l,J,s,f);K.hitTimeout&&(D=!0);for(const F of K.mappings)q.push(F)}H(j.length-W);const Z=E(q,j,l);let X=[];return n.computeMoves&&(X=this.h(Z,j,l,A,R,s,f)),(0,y.$hd)(()=>{function J(K,F){if(K.lineNumber<1||K.lineNumber>F.length)return!1;const z=F[K.lineNumber-1];return!(K.column<1||K.column>z.length+1)}function _(K,F){return!(K.startLineNumber<1||K.startLineNumber>F.length+1||K.endLineNumberExclusive<1||K.endLineNumberExclusive>F.length+1)}for(const K of Z){if(!K.innerChanges)return!1;for(const F of K.innerChanges)if(!(J(F.modifiedRange.getStartPosition(),l)&&J(F.modifiedRange.getEndPosition(),l)&&J(F.originalRange.getStartPosition(),j)&&J(F.originalRange.getEndPosition(),j)))return!1;if(!_(K.modified,l)||!_(K.original,j))return!1}return!0}),new e.$Vt(Z,X,D)}h(j,l,n,s,f,c,L){return(0,o.$b3)(j,l,n,s,f,c).map(P=>{const k=this.j(l,n,new g.$42(P.original.toOffsetRange(),P.modified.toOffsetRange()),c,L),S=E(k.mappings,l,n,!0);return new e.$Wt(P,S)})}j(j,l,n,s,f){const c=new b.$a3(j,n.seq1Range,f),L=new b.$a3(l,n.seq2Range,f),A=c.length+L.length<500?this.e.compute(c,L,s):this.f.compute(c,L,s);let R=A.diffs;return R=(0,N.$d3)(c,L,R),R=(0,N.$f3)(c,L,R),R=(0,N.$e3)(c,L,R),R=(0,N.$h3)(c,L,R),{mappings:R.map(k=>new d.$Ut(c.translateRange(k.seq1Range),L.translateRange(k.seq2Range))),hitTimeout:A.hitTimeout}}}t.$i3=p;function E(v,j,l,n=!1){const s=[];for(const f of(0,i.$Ab)(v.map(c=>$(c,j,l)),(c,L)=>c.original.overlapOrTouch(L.original)||c.modified.overlapOrTouch(L.modified))){const c=f[0],L=f[f.length-1];s.push(new d.$Tt(c.original.join(L.original),c.modified.join(L.modified),f.map(A=>A.innerChanges[0])))}return(0,y.$hd)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==j.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,y.$id)(s,(f,c)=>c.original.startLineNumber-f.original.endLineNumberExclusive===c.modified.startLineNumber-f.modified.endLineNumberExclusive&&f.original.endLineNumberExclusive<c.original.startLineNumber&&f.modified.endLineNumberExclusive<c.modified.startLineNumber)),s}function $(v,j,l){let n=0,s=0;v.modifiedRange.endColumn===1&&v.originalRange.endColumn===1&&v.originalRange.startLineNumber+n<=v.originalRange.endLineNumber&&v.modifiedRange.startLineNumber+n<=v.modifiedRange.endLineNumber&&(s=-1),v.modifiedRange.startColumn-1>=l[v.modifiedRange.startLineNumber-1].length&&v.originalRange.startColumn-1>=j[v.originalRange.startLineNumber-1].length&&v.originalRange.startLineNumber<=v.originalRange.endLineNumber+s&&v.modifiedRange.startLineNumber<=v.modifiedRange.endLineNumber+s&&(n=1);const f=new M.$Jt(v.originalRange.startLineNumber+n,v.originalRange.endLineNumber+1+s),c=new M.$Jt(v.modifiedRange.startLineNumber+n,v.modifiedRange.endLineNumber+1+s);return new d.$Tt(f,c,[v])}}),ne(re[35],ie([0,1,25,34,17,7,2,10,13]),function(B,t,i,y,M,h,w,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yt=t.$Xt=void 0;const u=3;class o{computeDiff(n,s,f){const L=new E(n,s,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let R=null;for(const P of L.changes){let k;P.originalEndLineNumber===0?k=new a.$Jt(P.originalStartLineNumber+1,P.originalStartLineNumber+1):k=new a.$Jt(P.originalStartLineNumber,P.originalEndLineNumber+1);let S;P.modifiedEndLineNumber===0?S=new a.$Jt(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):S=new a.$Jt(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let I=new M.$Tt(k,S,P.charChanges?.map(D=>new M.$Ut(new w.$At(D.originalStartLineNumber,D.originalStartColumn,D.originalEndLineNumber,D.originalEndColumn),new w.$At(D.modifiedStartLineNumber,D.modifiedStartColumn,D.modifiedEndLineNumber,D.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new M.$Tt(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),A.pop()),A.push(I),R=I}return(0,g.$hd)(()=>(0,g.$id)(A,(P,k)=>k.original.startLineNumber-P.original.endLineNumberExclusive===k.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<k.original.startLineNumber&&P.modified.endLineNumberExclusive<k.modified.startLineNumber)),new y.$Vt(A,[],L.quitEarly)}}t.$Xt=o;function N(l,n,s,f){return new i.$Gt(l,n,s).ComputeDiff(f)}class m{constructor(n){const s=[],f=[];for(let c=0,L=n.length;c<L;c++)s[c]=$(n[c],1),f[c]=v(n[c],1);this.lines=n,this.a=s,this.b=f}getElements(){const n=[];for(let s=0,f=this.lines.length;s<f;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,f){const c=[],L=[],A=[];let R=0;for(let P=s;P<=f;P++){const k=this.lines[P],S=n?this.a[P]:1,I=n?this.b[P]:k.length+1;for(let D=S;D<I;D++)c[R]=k.charCodeAt(D-1),L[R]=P+1,A[R]=D,R++;!n&&P<f&&(c[R]=10,L[R]=P+1,A[R]=k.length+1,R++)}return new b(c,L,A)}}class b{constructor(n,s,f){this.a=n,this.b=s,this.d=f}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,f,c,L,A,R,P){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=f,this.originalEndColumn=c,this.modifiedStartLineNumber=L,this.modifiedStartColumn=A,this.modifiedEndLineNumber=R,this.modifiedEndColumn=P}static createFromDiffChange(n,s,f){const c=s.getStartLineNumber(n.originalStart),L=s.getStartColumn(n.originalStart),A=s.getEndLineNumber(n.originalStart+n.originalLength-1),R=s.getEndColumn(n.originalStart+n.originalLength-1),P=f.getStartLineNumber(n.modifiedStart),k=f.getStartColumn(n.modifiedStart),S=f.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),I=f.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(c,L,A,R,P,k,S,I)}}function d(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let f=1,c=l.length;f<c;f++){const L=l[f],A=L.originalStart-(s.originalStart+s.originalLength),R=L.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(A,R)<u?(s.originalLength=L.originalStart+L.originalLength-s.originalStart,s.modifiedLength=L.modifiedStart+L.modifiedLength-s.modifiedStart):(n.push(L),s=L)}return n}class p{constructor(n,s,f,c,L){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=c,this.charChanges=L}static createFromDiffResult(n,s,f,c,L,A,R){let P,k,S,I,D;if(s.originalLength===0?(P=f.getStartLineNumber(s.originalStart)-1,k=0):(P=f.getStartLineNumber(s.originalStart),k=f.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(S=c.getStartLineNumber(s.modifiedStart)-1,I=0):(S=c.getStartLineNumber(s.modifiedStart),I=c.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),A&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&L()){const q=f.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),H=c.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(q.getElements().length>0&&H.getElements().length>0){let W=N(q,H,L,!0).changes;R&&(W=d(W)),D=[];for(let U=0,Z=W.length;U<Z;U++)D.push(e.createFromDiffChange(W[U],q,H))}}return new p(P,k,S,I,D)}}class E{constructor(n,s,f){this.a=f.shouldComputeCharChanges,this.b=f.shouldPostProcessCharChanges,this.d=f.shouldIgnoreTrimWhitespace,this.e=f.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new m(n),this.j=new m(s),this.k=j(f.maxComputationTime),this.l=j(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=N(this.h,this.j,this.k,this.e),s=n.changes,f=n.quitEarly;if(this.d){const R=[];for(let P=0,k=s.length;P<k;P++)R.push(p.createFromDiffResult(this.d,s[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:f,changes:R}}const c=[];let L=0,A=0;for(let R=-1,P=s.length;R<P;R++){const k=R+1<P?s[R+1]:null,S=k?k.originalStart:this.f.length,I=k?k.modifiedStart:this.g.length;for(;L<S&&A<I;){const D=this.f[L],q=this.g[A];if(D!==q){{let H=$(D,1),W=$(q,1);for(;H>1&&W>1;){const U=D.charCodeAt(H-2),Z=q.charCodeAt(W-2);if(U!==Z)break;H--,W--}(H>1||W>1)&&this.m(c,L+1,1,H,A+1,1,W)}{let H=v(D,1),W=v(q,1);const U=D.length+1,Z=q.length+1;for(;H<U&&W<Z;){const X=D.charCodeAt(H-1),J=D.charCodeAt(W-1);if(X!==J)break;H++,W++}(H<U||W<Z)&&this.m(c,L+1,H,U,A+1,W,Z)}}L++,A++}k&&(c.push(p.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),L+=k.originalLength,A+=k.modifiedLength)}return{quitEarly:f,changes:c}}m(n,s,f,c,L,A,R){if(this.n(n,s,f,c,L,A,R))return;let P;this.a&&(P=[new e(s,f,s,c,L,A,L,R)]),n.push(new p(s,s,L,L,P))}n(n,s,f,c,L,A,R){const P=n.length;if(P===0)return!1;const k=n[P-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===s&&k.modifiedEndLineNumber===L?(this.a&&k.charChanges&&k.charChanges.push(new e(s,f,s,c,L,A,L,R)),!0):k.originalEndLineNumber+1===s&&k.modifiedEndLineNumber+1===L?(k.originalEndLineNumber=s,k.modifiedEndLineNumber=L,this.a&&k.charChanges&&k.charChanges.push(new e(s,f,s,c,L,A,L,R)),!0):!1}}t.$Yt=E;function $(l,n){const s=h.$qf(l);return s===-1?n:s+1}function v(l,n){const s=h.$sf(l);return s===-1?n:s+2}function j(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),ne(re[55],ie([0,1,35,54]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$l3=void 0,t.$l3={getLegacy:()=>new i.$Xt,getDefault:()=>new y.$i3}}),ne(re[56],ie([0,1,37]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m3=N;function y(m){const b=[];for(const e of m){const d=Number(e);(d||d===0&&e.replace(/\s/g,"")!=="")&&b.push(d)}return b}function M(m,b,e,d){return{red:m/255,blue:e/255,green:b/255,alpha:d}}function h(m,b){const e=b.index,d=b[0].length;if(!e)return;const p=m.positionAt(e);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:p.lineNumber,endColumn:p.column+d}}function w(m,b){if(!m)return;const e=i.$_t.Format.CSS.parseHex(b);if(e)return{range:m,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(m,b,e){if(!m||b.length!==1)return;const p=b[0].values(),E=y(p);return{range:m,color:M(E[0],E[1],E[2],e?E[3]:1)}}function a(m,b,e){if(!m||b.length!==1)return;const p=b[0].values(),E=y(p),$=new i.$_t(new i.$0t(E[0],E[1]/100,E[2]/100,e?E[3]:1));return{range:m,color:M($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(m,b){return typeof m=="string"?[...m.matchAll(b)]:m.findMatches(b)}function o(m){const b=[],d=u(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(d.length>0)for(const p of d){const E=p.filter(l=>l!==void 0),$=E[1],v=E[2];if(!v)continue;let j;if($==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;j=g(h(m,p),u(v,l),!1)}else if($==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;j=g(h(m,p),u(v,l),!0)}else if($==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;j=a(h(m,p),u(v,l),!1)}else if($==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;j=a(h(m,p),u(v,l),!0)}else $==="#"&&(j=w(h(m,p),$+v));j&&b.push(j)}return b}function N(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:o(m)}}),ne(re[57],ie([0,1,29]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$X2=t.$W2=t.State=void 0,t.$Y2=m;var y;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(y||(t.State=y={}));class M{constructor(e,d,p){const E=new Uint8Array(e*d);for(let $=0,v=e*d;$<v;$++)E[$]=p;this.a=E,this.rows=e,this.cols=d}get(e,d){return this.a[e*this.cols+d]}set(e,d,p){this.a[e*this.cols+d]=p}}class h{constructor(e){let d=0,p=0;for(let $=0,v=e.length;$<v;$++){const[j,l,n]=e[$];l>d&&(d=l),j>p&&(p=j),n>p&&(p=n)}d++,p++;const E=new M(p,d,0);for(let $=0,v=e.length;$<v;$++){const[j,l,n]=e[$];E.set(j,l,n)}this.a=E,this.b=d}nextState(e,d){return d<0||d>=this.b?0:this.a.get(e,d)}}t.$W2=h;let w=null;function g(){return w===null&&(w=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let u=null;function o(){if(u===null){u=new i.$5t(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<b.length;d++)u.set(b.charCodeAt(d),1);const e=".,;:";for(let d=0;d<e.length;d++)u.set(e.charCodeAt(d),2)}return u}class N{static a(e,d,p,E,$){let v=$-1;do{const j=d.charCodeAt(v);if(e.get(j)!==2)break;v--}while(v>E);if(E>0){const j=d.charCodeAt(E-1),l=d.charCodeAt(v);(j===40&&l===41||j===91&&l===93||j===123&&l===125)&&v--}return{range:{startLineNumber:p,startColumn:E+1,endLineNumber:p,endColumn:v+2},url:d.substring(E,v+1)}}static computeLinks(e,d=g()){const p=o(),E=[];for(let $=1,v=e.getLineCount();$<=v;$++){const j=e.getLineContent($),l=j.length;let n=0,s=0,f=0,c=1,L=!1,A=!1,R=!1,P=!1;for(;n<l;){let k=!1;const S=j.charCodeAt(n);if(c===13){let I;switch(S){case 40:L=!0,I=0;break;case 41:I=L?0:1;break;case 91:R=!0,A=!0,I=0;break;case 93:R=!1,I=A?0:1;break;case 123:P=!0,I=0;break;case 125:I=P?0:1;break;case 39:case 34:case 96:f===S?I=1:f===39||f===34||f===96?I=0:I=1;break;case 42:I=f===42?1:0;break;case 124:I=f===124?1:0;break;case 32:I=R?0:1;break;default:I=p.get(S)}I===1&&(E.push(N.a(p,j,$,s,n)),k=!0)}else if(c===12){let I;S===91?(A=!0,I=0):I=p.get(S),I===1?k=!0:c=13}else c=d.nextState(c,S),c===0&&(k=!0);k&&(c=1,L=!1,A=!1,P=!1,s=n+1,f=S),n++}c===13&&E.push(N.a(p,j,$,s,l))}return E}}t.$X2=N;function m(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:N.computeLinks(b)}}),ne(re[58],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Z2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(M,h,w,g,a){if(M&&h){const u=this.a(h,a);if(u)return{range:M,value:u}}if(w&&g){const u=this.a(g,a);if(u)return{range:w,value:u}}return null}a(M,h){const w=this.b(M,h);return w!==null?w:this.d(M,h)}b(M,h){const w=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let g=Number(M);const a=parseFloat(M);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!h?null:(g=Math.floor(g*w),g+=h?w:-w,String(g/w)):null}d(M,h){return this.e(this.c,M,h)}e(M,h,w){let g=null;for(let a=0,u=M.length;g===null&&a<u;a++)g=this.f(M[a],h,w);return g}f(M,h,w){let g=M.indexOf(h);return g>=0?(g+=w?1:-1,g<0?g=M.length-1:g%=M.length,M[g]):null}}t.$Z2=i}),ne(re[59],ie([0,1,15]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5v=t.$4v=t.$3v=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$1v=t.$Zv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$2v=e,t.$6v=j;var y;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var M;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(M||(t.GlyphMarginLane=M={}));var h;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(h||(t.MinimapPosition=h={}));var w;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(w||(t.MinimapSectionHeaderStyle=w={}));var g;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(g||(t.InjectedTextCursorStops=g={}));var a;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(a||(t.EndOfLinePreference=a={}));var u;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var o;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(o||(t.EndOfLineSequence=o={}));class N{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,n.indentSize|0),this.a=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this.a===n.a&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,i.$$n)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}t.$Zv=N;class m{constructor(n,s){this._findMatchBrand=void 0,this.range=n,this.matches=s}}t.$1v=m;var b;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function e(l){return l&&typeof l.read=="function"}var d;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(d||(t.PositionAffinity=d={}));var p;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(t.ModelConstants=p={}));class E{constructor(n,s,f,c,L,A){this.identifier=n,this.range=s,this.text=f,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=L,this._isTracked=A}}t.$3v=E;class ${constructor(n,s,f){this.regex=n,this.wordSeparators=s,this.simpleSearch=f}}t.$4v=$;class v{constructor(n,s,f){this.reverseEdits=n,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.$5v=v;function j(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),ne(re[60],ie([0,1,6,28]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$v=t.$0v=t.$9v=void 0;class M{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,y.$0e)(a);const o=this.a,N=this.b,m=u.length;return m===0?!1:(this.a=new Uint32Array(o.length+m),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a),a+m),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(N.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,y.$0e)(a),u=(0,y.$0e)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,y.$0e)(a),u=(0,y.$0e)(u);const o=this.a,N=this.b;if(a>=o.length)return!1;const m=o.length-a;return u>=m&&(u=m),u===0?!1:(this.a=new Uint32Array(o.length-u),this.a.set(o.subarray(0,a),0),this.a.set(o.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(N.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,y.$0e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let o=u;o<=a;o++)this.b[o]=this.b[o-1]+this.a[o];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,o=this.a.length-1,N=0,m=0,b=0;for(;u<=o;)if(N=u+(o-u)/2|0,m=this.b[N],b=m-this.a[N],a<b)o=N-1;else if(a>=m)u=N+1;else break;return new w(N,a-b)}}t.$9v=M;class h{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],o=u>0?this.d[u-1]:0;return new w(u,a-o)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,i.$Vb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const o=this.a[a],N=a>0?this.d[a-1]:0;this.d[a]=N+o;for(let m=0;m<o;m++)this.e[N+m]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}t.$0v=h;class w{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}t.$$v=w}),ne(re[61],ie([0,1,7,4,60]),function(B,t,i,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_v=void 0;class h{constructor(g,a,u,o){this.d=g,this.f=a,this.g=u,this.h=o,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const a=g.changes;for(const u of a)this.o(u.range),this.p(new y.$zt(u.range.startLineNumber,u.range.startColumn),u.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let o=0;o<a;o++)u[o]=this.f[o].length+g;this.j=new M.$9v(u)}}n(g,a){this.f[g]=a,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,a){if(a.length===0)return;const u=(0,i.$of)(a);if(u.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]+this.f[g.lineNumber-1].substring(g.column-1));return}u[u.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]);const o=new Uint32Array(u.length-1);for(let N=1;N<u.length;N++)this.f.splice(g.lineNumber+N-1,0,u[N]),o[N-1]=u[N].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,o)}}t.$_v=h}),ne(re[62],ie([0,1,7,49,4,2,59]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1C=t.$YC=t.$VC=void 0,t.$WC=u,t.$XC=o,t.$ZC=d;const g=999;class a{constructor($,v,j,l){this.searchString=$,this.isRegex=v,this.matchCase=j,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let v=null;try{v=i.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!v)return null;let j=!this.isRegex&&!$;return j&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(j=this.matchCase),new w.$4v(v,this.wordSeparators?(0,y.$8t)(this.wordSeparators,[]):null,j?this.searchString:null)}}t.$VC=a;function u(E){if(!E||E.length===0)return!1;for(let $=0,v=E.length;$<v;$++){const j=E.charCodeAt($);if(j===10)return!0;if(j===92){if($++,$>=v)break;const l=E.charCodeAt($);if(l===110||l===114||l===87)return!0}}return!1}function o(E,$,v){if(!v)return new w.$1v(E,null);const j=[];for(let l=0,n=$.length;l<n;l++)j[l]=$[l];return new w.$1v(E,j)}class N{constructor($){const v=[];let j=0;for(let l=0,n=$.length;l<n;l++)$.charCodeAt(l)===10&&(v[j++]=l);this.a=v}findLineFeedCountBeforeOffset($){const v=this.a;let j=0,l=v.length-1;if(l===-1||$<=v[0])return 0;for(;j<l;){const n=j+((l-j)/2>>0);v[n]>=$?l=n-1:v[n+1]>=$?(j=n,l=n):j=n+1}return j+1}}class m{static findMatches($,v,j,l,n){const s=v.parseSearchRequest();return s?s.regex.multiline?this.b($,j,new p(s.wordSeparators,s.regex),l,n):this.c($,j,s,l,n):[]}static a($,v,j,l,n,s){let f,c=0;l?(c=l.findLineFeedCountBeforeOffset(n),f=v+n+c):f=v+n;let L;if(l){const k=l.findLineFeedCountBeforeOffset(n+s.length)-c;L=f+s.length+k}else L=f+s.length;const A=$.getPositionAt(f),R=$.getPositionAt(L);return new h.$At(A.lineNumber,A.column,R.lineNumber,R.column)}static b($,v,j,l,n){const s=$.getOffsetAt(v.getStartPosition()),f=$.getValueInRange(v,1),c=$.getEOL()===`\r
`?new N(f):null,L=[];let A=0,R;for(j.reset(0);R=j.next(f);)if(L[A++]=o(this.a($,s,f,c,R.index,R[0]),R,l),A>=n)return L;return L}static c($,v,j,l,n){const s=[];let f=0;if(v.startLineNumber===v.endLineNumber){const L=$.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return f=this.d(j,L,v.startLineNumber,v.startColumn-1,f,s,l,n),s}const c=$.getLineContent(v.startLineNumber).substring(v.startColumn-1);f=this.d(j,c,v.startLineNumber,v.startColumn-1,f,s,l,n);for(let L=v.startLineNumber+1;L<v.endLineNumber&&f<n;L++)f=this.d(j,$.getLineContent(L),L,0,f,s,l,n);if(f<n){const L=$.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);f=this.d(j,L,v.endLineNumber,0,f,s,l,n)}return s}static d($,v,j,l,n,s,f,c){const L=$.wordSeparators;if(!f&&$.simpleSearch){const P=$.simpleSearch,k=P.length,S=v.length;let I=-k;for(;(I=v.indexOf(P,I+k))!==-1;)if((!L||d(L,v,S,I,k))&&(s[n++]=new w.$1v(new h.$At(j,I+1+l,j,I+1+k+l),null),n>=c))return n;return n}const A=new p($.wordSeparators,$.regex);let R;A.reset(0);do if(R=A.next(v),R&&(s[n++]=o(new h.$At(j,R.index+1+l,j,R.index+1+R[0].length+l),R,f),n>=c))return n;while(R);return n}static findNextMatch($,v,j,l){const n=v.parseSearchRequest();if(!n)return null;const s=new p(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,j,s,l):this.f($,j,s,l)}static e($,v,j,l){const n=new M.$zt(v.lineNumber,1),s=$.getOffsetAt(n),f=$.getLineCount(),c=$.getValueInRange(new h.$At(n.lineNumber,n.column,f,$.getLineMaxColumn(f)),1),L=$.getEOL()===`\r
`?new N(c):null;j.reset(v.column-1);const A=j.next(c);return A?o(this.a($,s,c,L,A.index,A[0]),A,l):v.lineNumber!==1||v.column!==1?this.e($,new M.$zt(1,1),j,l):null}static f($,v,j,l){const n=$.getLineCount(),s=v.lineNumber,f=$.getLineContent(s),c=this.g(j,f,s,v.column,l);if(c)return c;for(let L=1;L<=n;L++){const A=(s+L-1)%n,R=$.getLineContent(A+1),P=this.g(j,R,A+1,1,l);if(P)return P}return null}static g($,v,j,l,n){$.reset(l-1);const s=$.next(v);return s?o(new h.$At(j,s.index+1,j,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,v,j,l){const n=v.parseSearchRequest();if(!n)return null;const s=new p(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,j,s,l):this.j($,j,s,l)}static h($,v,j,l){const n=this.b($,new h.$At(1,1,v.lineNumber,v.column),j,l,10*g);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return v.lineNumber!==s||v.column!==$.getLineMaxColumn(s)?this.h($,new M.$zt(s,$.getLineMaxColumn(s)),j,l):null}static j($,v,j,l){const n=$.getLineCount(),s=v.lineNumber,f=$.getLineContent(s).substring(0,v.column-1),c=this.k(j,f,s,l);if(c)return c;for(let L=1;L<=n;L++){const A=(n+s-L-1)%n,R=$.getLineContent(A+1),P=this.k(j,R,A+1,l);if(P)return P}return null}static k($,v,j,l){let n=null,s;for($.reset(0);s=$.next(v);)n=o(new h.$At(j,s.index+1,j,s.index+1+s[0].length),s,l);return n}}t.$YC=m;function b(E,$,v,j,l){if(j===0)return!0;const n=$.charCodeAt(j-1);if(E.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(j);if(E.get(s)!==0)return!0}return!1}function e(E,$,v,j,l){if(j+l===v)return!0;const n=$.charCodeAt(j+l);if(E.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(j+l-1);if(E.get(s)!==0)return!0}return!1}function d(E,$,v,j,l){return b(E,$,v,j,l)&&e(E,$,v,j,l)}class p{constructor($,v){this._wordSeparators=$,this.a=v,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const v=$.length;let j;do{if(this.b+this.c===v||(j=this.a.exec($),!j))return null;const l=j.index,n=j[0].length;if(l===this.b&&n===this.c){if(n===0){i.$If($,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=n,!this._wordSeparators||d(this._wordSeparators,$,v,l,n))return j}while(j);return null}}t.$1C=p}),ne(re[63],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n3=M;const i=new RegExp("\\bMARK:\\s*(.*)$","d"),y=/^-+|-+$/g;function M(u,o){let N=[];if(o.findRegionSectionHeaders&&o.foldingRules?.markers){const m=h(u,o);N=N.concat(m)}if(o.findMarkSectionHeaders){const m=w(u);N=N.concat(m)}return N}function h(u,o){const N=[],m=u.getLineCount();for(let b=1;b<=m;b++){const e=u.getLineContent(b),d=e.match(o.foldingRules.markers.start);if(d){const p={startLineNumber:b,startColumn:d[0].length+1,endLineNumber:b,endColumn:e.length+1};if(p.endColumn>p.startColumn){const E={range:p,...a(e.substring(d[0].length)),shouldBeInComments:!1};(E.text||E.hasSeparatorLine)&&N.push(E)}}}return N}function w(u){const o=[],N=u.getLineCount();for(let m=1;m<=N;m++){const b=u.getLineContent(m);g(b,m,o)}return o}function g(u,o,N){i.lastIndex=0;const m=i.exec(u);if(m){const b=m.indices[1][0]+1,e=m.indices[1][1]+1,d={startLineNumber:o,startColumn:b,endLineNumber:o,endColumn:e};if(d.endColumn>d.startColumn){const p={range:d,...a(m[1]),shouldBeInComments:!0};(p.text||p.hasSeparatorLine)&&N.push(p)}}}function a(u){u=u.trim();const o=u.startsWith("-");return u=u.replace(y,""),{text:u,hasSeparatorLine:o}}}),ne(re[64],ie([0,1,2,62,7,10,31]),function(B,t,i,y,M,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$V2=void 0;class g{static computeUnicodeHighlights(e,d,p){const E=p?p.startLineNumber:1,$=p?p.endLineNumber:e.getLineCount(),v=new o(d),j=v.getCandidateCodePoints();let l;j==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(j))}`,"g");const n=new y.$1C(null,l),s=[];let f=!1,c,L=0,A=0,R=0;e:for(let P=E,k=$;P<=k;P++){const S=e.getLineContent(P),I=S.length;n.reset(0);do if(c=n.next(S),c){let D=c.index,q=c.index+c[0].length;if(D>0){const Z=S.charCodeAt(D-1);M.$Ff(Z)&&D--}if(q+1<I){const Z=S.charCodeAt(q-1);M.$Ff(Z)&&q++}const H=S.substring(D,q);let W=(0,w.$ct)(D+1,w.$_s,S,0);W&&W.endColumn<=D+1&&(W=null);const U=v.shouldHighlightNonBasicASCII(H,W?W.word:null);if(U!==0){if(U===3?L++:U===2?A++:U===1?R++:(0,h.$ed)(U),s.length>=1e3){f=!0;break e}s.push(new i.$At(P,D+1,P,q+1))}}while(c)}return{ranges:s,hasMore:f,ambiguousCharacterCount:L,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,d){const p=new o(d);switch(p.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),v=p.ambiguousCharacters.getPrimaryConfusable($),j=M.$$f.getLocales().filter(l=>!M.$$f.getInstance(new Set([...d.allowedLocales,l])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:j}}case 1:return{kind:2}}}}t.$V2=g;function a(b,e){return`[${M.$df(b.map(p=>String.fromCodePoint(p)).join(""))}]`}var u;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class o{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.$$f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const d of M.$_f.codePoints)N(String.fromCodePoint(d))||e.add(d);if(this.b.ambiguousCharacters)for(const d of this.ambiguousCharacters.getConfusableCodePoints())e.add(d);for(const d of this.a)e.delete(d);return e}shouldHighlightNonBasicASCII(e,d){const p=e.codePointAt(0);if(this.a.has(p))return 0;if(this.b.nonBasicASCII)return 1;let E=!1,$=!1;if(d)for(const v of d){const j=v.codePointAt(0),l=M.$Qf(v);E=E||l,!l&&!this.ambiguousCharacters.isAmbiguous(j)&&!M.$_f.isInvisibleCharacter(j)&&($=!0)}return!E&&$?0:this.b.invisibleCharacters&&!N(e)&&M.$_f.isInvisibleCharacter(p)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(p)?3:0}}function N(b){return b===" "||b===`
`||b==="	"}var m;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(m||(m={}))}),ne(re[65],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var y;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var M;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(M||(t.CompletionItemInsertTextRule=M={}));var h;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(h||(t.CompletionItemKind=h={}));var w;(function(r){r[r.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var g;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(t.CompletionTriggerKind=g={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var N;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var m;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(m||(t.EditorAutoIndentStrategy=m={}));var b;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var d;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(d||(t.EndOfLineSequence=d={}));var p;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(p||(t.GlyphMarginLane=p={}));var E;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(E||(t.HoverVerbosityAction=E={}));var $;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})($||(t.IndentAction=$={}));var v;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var j;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(j||(t.InlayHintKind=j={}));var l;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var n;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(n||(t.InlineEditTriggerKind=n={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var c;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(c||(t.MarkerTag=c={}));var L;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var A;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(A||(t.MinimapSectionHeaderStyle=A={}));var R;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(R||(t.MouseTargetType=R={}));var P;(function(r){r[r.AIGenerated=1]="AIGenerated"})(P||(t.NewSymbolNameTag=P={}));var k;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(k||(t.NewSymbolNameTriggerKind=k={}));var S;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(S||(t.OverlayWidgetPositionPreference=S={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(t.OverviewRulerLane=I={}));var D;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(D||(t.PartialAcceptTriggerKind=D={}));var q;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(q||(t.PositionAffinity=q={}));var H;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(H||(t.RenderLineNumbersType=H={}));var W;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(W||(t.RenderMinimap=W={}));var U;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(U||(t.ScrollType=U={}));var Z;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(Z||(t.ScrollbarVisibility=Z={}));var X;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(X||(t.SelectionDirection=X={}));var J;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(J||(t.ShowLightbulbIconMode=J={}));var _;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var K;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(K||(t.SymbolKind=K={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(t.SymbolTag=F={}));var z;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(z||(t.TextEditorCursorBlinkingStyle=z={}));var oe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(oe||(t.TextEditorCursorStyle=oe={}));var fe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(fe||(t.TrackedRangeStickiness=fe={}));var $e;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})($e||(t.WrappingIndent=$e={}))}),ne(re[66],ie([0,1,12,11]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ju=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$he,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,a){return this.a.set(g,a),this.handleChange([g]),(0,y.$Sc)(()=>{this.a.get(g)===a&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,a){this.b.get(g)?.dispose();const u=new h(this,g,a);return this.b.set(g,u),(0,y.$Sc)(()=>{const o=this.b.get(g);!o||o!==u||(this.b.delete(g),o.dispose())})}async getOrCreate(g){const a=this.get(g);if(a)return a;const u=this.b.get(g);return!u||u.isResolved?null:(await u.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const u=this.b.get(g);return!!(!u||u.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$ju=M;class h extends y.$Uc{get isResolved(){return this.c}constructor(g,a,u){super(),this.f=g,this.g=a,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),ne(re[67],ie([68,69]),function(B,t){return B.create("vs/base/common/platform",t)}),ne(re[18],ie([0,1,67]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=P,t.$J=k,t.$g="en";let y=!1,M=!1,h=!1,w=!1,g=!1,a=!1,u=!1,o=!1,N=!1,m=!1,b,e=t.$g,d=t.$g,p,E;const $=globalThis;let v;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?v=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const j=typeof v?.versions?.electron=="string",l=j&&v?.type==="renderer";if(typeof v=="object"){y=v.platform==="win32",M=v.platform==="darwin",h=v.platform==="linux",w=h&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,u=j,N=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.$g,e=t.$g;const S=v.env.VSCODE_NLS_CONFIG;if(S)try{const I=JSON.parse(S),D=I.availableLanguages["*"];b=I.locale,d=I.osLocale,e=D||t.$g,p=I._translationsConfigFile}catch{}g=!0}else typeof navigator=="object"&&!l?(E=navigator.userAgent,y=E.indexOf("Windows")>=0,M=E.indexOf("Macintosh")>=0,o=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=E.indexOf("Linux")>=0,m=E?.indexOf("Mobi")>=0,a=!0,b=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=b,d=navigator.language):console.error("Unable to resolve platform.");var n;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let f=0;M?f=1:y?f=3:h&&(f=2),t.$i=y,t.$j=M,t.$k=h,t.$l=w,t.$m=g,t.$n=u,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=o,t.$s=m,t.$t=N,t.$u=f,t.$v=E,t.$w=e;var c;(function(S){function I(){return t.$w}S.value=I;function D(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=D;function q(){return t.$w==="en"}S.isDefault=q})(c||(t.Language=c={})),t.$x=b,t.$y=d,t.$z=p,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const S=[];$.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let q=0,H=S.length;q<H;q++){const W=S[q];if(W.id===D.data.vscodeScheduleAsyncWork){S.splice(q,1),W.callback();return}}});let I=0;return D=>{const q=++I;S.push({id:q,callback:D}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return S=>setTimeout(S)})();var L;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=M||o?2:y?1:3;let A=!0,R=!1;function P(){if(!R){R=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,A=new Uint16Array(S.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function k(S){return parseFloat(S)>=20}}),ne(re[70],ie([0,1,18]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let y;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const h=M.process;y={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?y={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:y={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=y.cwd,t.env=y.env,t.$dc=y.platform,t.$ec=y.arch}),ne(re[71],ie([0,1,70]),function(B,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const y=65,M=97,h=90,w=122,g=46,a=47,u=92,o=58,N=63;class m extends Error{constructor(s,f,c){let L;typeof f=="string"&&f.indexOf("not ")===0?(L="must not be",f=f.replace(/^not /,"")):L="must be";const A=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${A} ${L} of type ${f}`;R+=`. Received type ${typeof c}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function b(n,s){if(n===null||typeof n!="object")throw new m(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new m(s,"string",n)}const d=i.$dc==="win32";function p(n){return n===a||n===u}function E(n){return n===a}function $(n){return n>=y&&n<=h||n>=M&&n<=w}function v(n,s,f,c){let L="",A=0,R=-1,P=0,k=0;for(let S=0;S<=n.length;++S){if(S<n.length)k=n.charCodeAt(S);else{if(c(k))break;k=a}if(c(k)){if(!(R===S-1||P===1))if(P===2){if(L.length<2||A!==2||L.charCodeAt(L.length-1)!==g||L.charCodeAt(L.length-2)!==g){if(L.length>2){const I=L.lastIndexOf(f);I===-1?(L="",A=0):(L=L.slice(0,I),A=L.length-1-L.lastIndexOf(f)),R=S,P=0;continue}else if(L.length!==0){L="",A=0,R=S,P=0;continue}}s&&(L+=L.length>0?`${f}..`:"..",A=2)}else L.length>0?L+=`${f}${n.slice(R+1,S)}`:L=n.slice(R+1,S),A=S-R-1;R=S,P=0}else k===g&&P!==-1?++P:P=-1}return L}function j(n,s){b(s,"pathObject");const f=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${c}`:`${f}${n}${c}`:c}t.$fc={resolve(...n){let s="",f="",c=!1;for(let L=n.length-1;L>=-1;L--){let A;if(L>=0){if(A=n[L],e(A,"path"),A.length===0)continue}else s.length===0?A=i.cwd():(A=i.env[`=${s}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==s.toLowerCase()&&A.charCodeAt(2)===u)&&(A=`${s}\\`));const R=A.length;let P=0,k="",S=!1;const I=A.charCodeAt(0);if(R===1)p(I)&&(P=1,S=!0);else if(p(I))if(S=!0,p(A.charCodeAt(1))){let D=2,q=D;for(;D<R&&!p(A.charCodeAt(D));)D++;if(D<R&&D!==q){const H=A.slice(q,D);for(q=D;D<R&&p(A.charCodeAt(D));)D++;if(D<R&&D!==q){for(q=D;D<R&&!p(A.charCodeAt(D));)D++;(D===R||D!==q)&&(k=`\\\\${H}\\${A.slice(q,D)}`,P=D)}}}else P=1;else $(I)&&A.charCodeAt(1)===o&&(k=A.slice(0,2),P=2,R>2&&p(A.charCodeAt(2))&&(S=!0,P=3));if(k.length>0)if(s.length>0){if(k.toLowerCase()!==s.toLowerCase())continue}else s=k;if(c){if(s.length>0)break}else if(f=`${A.slice(P)}\\${f}`,c=S,S&&s.length>0)break}return f=v(f,!c,"\\",p),c?`${s}\\${f}`:`${s}${f}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let f=0,c,L=!1;const A=n.charCodeAt(0);if(s===1)return E(A)?"\\":n;if(p(A))if(L=!0,p(n.charCodeAt(1))){let P=2,k=P;for(;P<s&&!p(n.charCodeAt(P));)P++;if(P<s&&P!==k){const S=n.slice(k,P);for(k=P;P<s&&p(n.charCodeAt(P));)P++;if(P<s&&P!==k){for(k=P;P<s&&!p(n.charCodeAt(P));)P++;if(P===s)return`\\\\${S}\\${n.slice(k)}\\`;P!==k&&(c=`\\\\${S}\\${n.slice(k,P)}`,f=P)}}}else f=1;else $(A)&&n.charCodeAt(1)===o&&(c=n.slice(0,2),f=2,s>2&&p(n.charCodeAt(2))&&(L=!0,f=3));let R=f<s?v(n.slice(f),!L,"\\",p):"";return R.length===0&&!L&&(R="."),R.length>0&&p(n.charCodeAt(s-1))&&(R+="\\"),c===void 0?L?`\\${R}`:R:L?`${c}\\${R}`:`${c}${R}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const f=n.charCodeAt(0);return p(f)||s>2&&$(f)&&n.charCodeAt(1)===o&&p(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,f;for(let A=0;A<n.length;++A){const R=n[A];e(R,"path"),R.length>0&&(s===void 0?s=f=R:s+=`\\${R}`)}if(s===void 0)return".";let c=!0,L=0;if(typeof f=="string"&&p(f.charCodeAt(0))){++L;const A=f.length;A>1&&p(f.charCodeAt(1))&&(++L,A>2&&(p(f.charCodeAt(2))?++L:c=!1))}if(c){for(;L<s.length&&p(s.charCodeAt(L));)L++;L>=2&&(s=`\\${s.slice(L)}`)}return t.$fc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const f=t.$fc.resolve(n),c=t.$fc.resolve(s);if(f===c||(n=f.toLowerCase(),s=c.toLowerCase(),n===s))return"";let L=0;for(;L<n.length&&n.charCodeAt(L)===u;)L++;let A=n.length;for(;A-1>L&&n.charCodeAt(A-1)===u;)A--;const R=A-L;let P=0;for(;P<s.length&&s.charCodeAt(P)===u;)P++;let k=s.length;for(;k-1>P&&s.charCodeAt(k-1)===u;)k--;const S=k-P,I=R<S?R:S;let D=-1,q=0;for(;q<I;q++){const W=n.charCodeAt(L+q);if(W!==s.charCodeAt(P+q))break;W===u&&(D=q)}if(q!==I){if(D===-1)return c}else{if(S>I){if(s.charCodeAt(P+q)===u)return c.slice(P+q+1);if(q===2)return c.slice(P+q)}R>I&&(n.charCodeAt(L+q)===u?D=q:q===2&&(D=3)),D===-1&&(D=0)}let H="";for(q=L+D+1;q<=A;++q)(q===A||n.charCodeAt(q)===u)&&(H+=H.length===0?"..":"\\..");return P+=D,H.length>0?`${H}${c.slice(P,k)}`:(c.charCodeAt(P)===u&&++P,c.slice(P,k))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const f=s.charCodeAt(2);if(f!==N&&f!==g)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===o&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let f=-1,c=0;const L=n.charCodeAt(0);if(s===1)return p(L)?n:".";if(p(L)){if(f=c=1,p(n.charCodeAt(1))){let P=2,k=P;for(;P<s&&!p(n.charCodeAt(P));)P++;if(P<s&&P!==k){for(k=P;P<s&&p(n.charCodeAt(P));)P++;if(P<s&&P!==k){for(k=P;P<s&&!p(n.charCodeAt(P));)P++;if(P===s)return n;P!==k&&(f=c=P+1)}}}}else $(L)&&n.charCodeAt(1)===o&&(f=s>2&&p(n.charCodeAt(2))?3:2,c=f);let A=-1,R=!0;for(let P=s-1;P>=c;--P)if(p(n.charCodeAt(P))){if(!R){A=P;break}}else R=!1;if(A===-1){if(f===-1)return".";A=f}return n.slice(0,A)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,c=-1,L=!0,A;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===o&&(f=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,P=-1;for(A=n.length-1;A>=f;--A){const k=n.charCodeAt(A);if(p(k)){if(!L){f=A+1;break}}else P===-1&&(L=!1,P=A+1),R>=0&&(k===s.charCodeAt(R)?--R===-1&&(c=A):(R=-1,c=P))}return f===c?c=P:c===-1&&(c=n.length),n.slice(f,c)}for(A=n.length-1;A>=f;--A)if(p(n.charCodeAt(A))){if(!L){f=A+1;break}}else c===-1&&(L=!1,c=A+1);return c===-1?"":n.slice(f,c)},extname(n){e(n,"path");let s=0,f=-1,c=0,L=-1,A=!0,R=0;n.length>=2&&n.charCodeAt(1)===o&&$(n.charCodeAt(0))&&(s=c=2);for(let P=n.length-1;P>=s;--P){const k=n.charCodeAt(P);if(p(k)){if(!A){c=P+1;break}continue}L===-1&&(A=!1,L=P+1),k===g?f===-1?f=P:R!==1&&(R=1):f!==-1&&(R=-1)}return f===-1||L===-1||R===0||R===1&&f===L-1&&f===c+1?"":n.slice(f,L)},format:j.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.length;let c=0,L=n.charCodeAt(0);if(f===1)return p(L)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(p(L)){if(c=1,p(n.charCodeAt(1))){let D=2,q=D;for(;D<f&&!p(n.charCodeAt(D));)D++;if(D<f&&D!==q){for(q=D;D<f&&p(n.charCodeAt(D));)D++;if(D<f&&D!==q){for(q=D;D<f&&!p(n.charCodeAt(D));)D++;D===f?c=D:D!==q&&(c=D+1)}}}}else if($(L)&&n.charCodeAt(1)===o){if(f<=2)return s.root=s.dir=n,s;if(c=2,p(n.charCodeAt(2))){if(f===3)return s.root=s.dir=n,s;c=3}}c>0&&(s.root=n.slice(0,c));let A=-1,R=c,P=-1,k=!0,S=n.length-1,I=0;for(;S>=c;--S){if(L=n.charCodeAt(S),p(L)){if(!k){R=S+1;break}continue}P===-1&&(k=!1,P=S+1),L===g?A===-1?A=S:I!==1&&(I=1):A!==-1&&(I=-1)}return P!==-1&&(A===-1||I===0||I===1&&A===P-1&&A===R+1?s.base=s.name=n.slice(R,P):(s.name=n.slice(R,A),s.base=n.slice(R,P),s.ext=n.slice(A,P))),R>0&&R!==c?s.dir=n.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(d){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...n){let s="",f=!1;for(let c=n.length-1;c>=-1&&!f;c--){const L=c>=0?n[c]:l();e(L,"path"),L.length!==0&&(s=`${L}/${s}`,f=L.charCodeAt(0)===a)}return s=v(s,!f,"/",E),f?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a,f=n.charCodeAt(n.length-1)===a;return n=v(n,!s,"/",E),n.length===0?s?"/":f?"./":".":(f&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let s;for(let f=0;f<n.length;++f){const c=n[f];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$gc.resolve(n),s=t.$gc.resolve(s),n===s))return"";const f=1,c=n.length,L=c-f,A=1,R=s.length-A,P=L<R?L:R;let k=-1,S=0;for(;S<P;S++){const D=n.charCodeAt(f+S);if(D!==s.charCodeAt(A+S))break;D===a&&(k=S)}if(S===P)if(R>P){if(s.charCodeAt(A+S)===a)return s.slice(A+S+1);if(S===0)return s.slice(A+S)}else L>P&&(n.charCodeAt(f+S)===a?k=S:S===0&&(k=0));let I="";for(S=f+k+1;S<=c;++S)(S===c||n.charCodeAt(S)===a)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(A+k)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a;let f=-1,c=!0;for(let L=n.length-1;L>=1;--L)if(n.charCodeAt(L)===a){if(!c){f=L;break}}else c=!1;return f===-1?s?"/":".":s&&f===1?"//":n.slice(0,f)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,c=-1,L=!0,A;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,P=-1;for(A=n.length-1;A>=0;--A){const k=n.charCodeAt(A);if(k===a){if(!L){f=A+1;break}}else P===-1&&(L=!1,P=A+1),R>=0&&(k===s.charCodeAt(R)?--R===-1&&(c=A):(R=-1,c=P))}return f===c?c=P:c===-1&&(c=n.length),n.slice(f,c)}for(A=n.length-1;A>=0;--A)if(n.charCodeAt(A)===a){if(!L){f=A+1;break}}else c===-1&&(L=!1,c=A+1);return c===-1?"":n.slice(f,c)},extname(n){e(n,"path");let s=-1,f=0,c=-1,L=!0,A=0;for(let R=n.length-1;R>=0;--R){const P=n.charCodeAt(R);if(P===a){if(!L){f=R+1;break}continue}c===-1&&(L=!1,c=R+1),P===g?s===-1?s=R:A!==1&&(A=1):s!==-1&&(A=-1)}return s===-1||c===-1||A===0||A===1&&s===c-1&&s===f+1?"":n.slice(s,c)},format:j.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.charCodeAt(0)===a;let c;f?(s.root="/",c=1):c=0;let L=-1,A=0,R=-1,P=!0,k=n.length-1,S=0;for(;k>=c;--k){const I=n.charCodeAt(k);if(I===a){if(!P){A=k+1;break}continue}R===-1&&(P=!1,R=k+1),I===g?L===-1?L=k:S!==1&&(S=1):L!==-1&&(S=-1)}if(R!==-1){const I=A===0&&f?1:A;L===-1||S===0||S===1&&L===R-1&&L===A+1?s.base=s.name=n.slice(I,R):(s.name=n.slice(I,L),s.base=n.slice(I,R),s.ext=n.slice(L,R))}return A>0?s.dir=n.slice(0,A-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=d?t.$fc.normalize:t.$gc.normalize,t.$ic=d?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=d?t.$fc.join:t.$gc.join,t.$kc=d?t.$fc.resolve:t.$gc.resolve,t.$lc=d?t.$fc.relative:t.$gc.relative,t.$mc=d?t.$fc.dirname:t.$gc.dirname,t.$nc=d?t.$fc.basename:t.$gc.basename,t.$oc=d?t.$fc.extname:t.$gc.extname,t.$pc=d?t.$fc.format:t.$gc.format,t.$qc=d?t.$fc.parse:t.$gc.parse,t.$rc=d?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=d?t.$fc.sep:t.$gc.sep,t.$tc=d?t.$fc.delimiter:t.$gc.delimiter}),ne(re[19],ie([0,1,71,18]),function(B,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=e,t.$wc=j;const M=/^\w[\w\d+.-]*$/,h=/^\//,w=/^\/\//;function g(c,L){if(!c.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!M.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!h.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(c,L){return!c&&!L?"file":c}function u(c,L){switch(c){case"https":case"http":case"file":L?L[0]!==N&&(L=N+L):L=N;break}return L}const o="",N="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(L){return L instanceof b?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,A,R,P,k,S=!1){typeof L=="object"?(this.scheme=L.scheme||o,this.authority=L.authority||o,this.path=L.path||o,this.query=L.query||o,this.fragment=L.fragment||o):(this.scheme=a(L,S),this.authority=A||o,this.path=u(this.scheme,R||o),this.query=P||o,this.fragment=k||o,g(this,S))}get fsPath(){return j(this,!1)}with(L){if(!L)return this;let{scheme:A,authority:R,path:P,query:k,fragment:S}=L;return A===void 0?A=this.scheme:A===null&&(A=o),R===void 0?R=this.authority:R===null&&(R=o),P===void 0?P=this.path:P===null&&(P=o),k===void 0?k=this.query:k===null&&(k=o),S===void 0?S=this.fragment:S===null&&(S=o),A===this.scheme&&R===this.authority&&P===this.path&&k===this.query&&S===this.fragment?this:new p(A,R,P,k,S)}static parse(L,A=!1){const R=m.exec(L);return R?new p(R[2]||o,f(R[4]||o),f(R[5]||o),f(R[7]||o),f(R[9]||o),A):new p(o,o,o,o,o)}static file(L){let A=o;if(y.$i&&(L=L.replace(/\\/g,N)),L[0]===N&&L[1]===N){const R=L.indexOf(N,2);R===-1?(A=L.substring(2),L=N):(A=L.substring(2,R),L=L.substring(R)||N)}return new p("file",A,L,o,o)}static from(L,A){return new p(L.scheme,L.authority,L.path,L.query,L.fragment,A)}static joinPath(L,...A){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return y.$i&&L.scheme==="file"?R=b.file(i.$fc.join(j(L,!0),...A)).path:R=i.$gc.join(L.path,...A),L.with({path:R})}toString(L=!1){return l(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof b)return L;{const A=new p(L);return A._formatted=L.external??null,A._fsPath=L._sep===d?L.fsPath??null:null,A}}else return L}}t.URI=b;function e(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const d=y.$i?1:void 0;class p extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=j(this,!1)),this._fsPath}toString(L=!1){return L?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=d),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const E={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(c,L,A){let R,P=-1;for(let k=0;k<c.length;k++){const S=c.charCodeAt(k);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||L&&S===47||A&&S===91||A&&S===93||A&&S===58)P!==-1&&(R+=encodeURIComponent(c.substring(P,k)),P=-1),R!==void 0&&(R+=c.charAt(k));else{R===void 0&&(R=c.substr(0,k));const I=E[S];I!==void 0?(P!==-1&&(R+=encodeURIComponent(c.substring(P,k)),P=-1),R+=I):P===-1&&(P=k)}}return P!==-1&&(R+=encodeURIComponent(c.substring(P))),R!==void 0?R:c}function v(c){let L;for(let A=0;A<c.length;A++){const R=c.charCodeAt(A);R===35||R===63?(L===void 0&&(L=c.substr(0,A)),L+=E[R]):L!==void 0&&(L+=c[A])}return L!==void 0?L:c}function j(c,L){let A;return c.authority&&c.path.length>1&&c.scheme==="file"?A=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?L?A=c.path.substr(1):A=c.path[1].toLowerCase()+c.path.substr(2):A=c.path,y.$i&&(A=A.replace(/\//g,"\\")),A}function l(c,L){const A=L?v:$;let R="",{scheme:P,authority:k,path:S,query:I,fragment:D}=c;if(P&&(R+=P,R+=":"),(k||P==="file")&&(R+=N,R+=N),k){let q=k.indexOf("@");if(q!==-1){const H=k.substr(0,q);k=k.substr(q+1),q=H.lastIndexOf(":"),q===-1?R+=A(H,!1,!1):(R+=A(H.substr(0,q),!1,!1),R+=":",R+=A(H.substr(q+1),!1,!0)),R+="@"}k=k.toLowerCase(),q=k.lastIndexOf(":"),q===-1?R+=A(k,!1,!0):(R+=A(k.substr(0,q),!1,!0),R+=k.substr(q))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const q=S.charCodeAt(1);q>=65&&q<=90&&(S=`/${String.fromCharCode(q+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const q=S.charCodeAt(0);q>=65&&q<=90&&(S=`${String.fromCharCode(q+32)}:${S.substr(2)}`)}R+=A(S,!0,!1)}return I&&(R+="?",R+=A(I,!1,!1)),D&&(R+="#",R+=L?D:$(D,!1,!1)),R}function n(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+n(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(c){return c.match(s)?c.replace(s,L=>n(L)):c}}),ne(re[76],ie([0,1,3,12,11,15,18,7]),function(B,t,i,y,M,h,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=o,t.create=s;const a="$initialize";let u=!1;function o(f){w.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}var N;(function(f){f[f.Request=0]="Request",f[f.Reply=1]="Reply",f[f.SubscribeEvent=2]="SubscribeEvent",f[f.Event=3]="Event",f[f.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class m{constructor(c,L,A,R){this.vsWorker=c,this.req=L,this.method=A,this.args=R,this.type=0}}class b{constructor(c,L,A,R){this.vsWorker=c,this.seq=L,this.res=A,this.err=R,this.type=1}}class e{constructor(c,L,A,R){this.vsWorker=c,this.req=L,this.eventName=A,this.arg=R,this.type=2}}class d{constructor(c,L,A){this.vsWorker=c,this.req=L,this.event=A,this.type=3}}class p{constructor(c,L){this.vsWorker=c,this.req=L,this.type=4}}class E{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,L){const A=String(++this.b);return new Promise((R,P)=>{this.c[A]={resolve:R,reject:P},this.o(new m(this.a,A,c,L))})}listen(c,L){let A=null;const R=new y.$he({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,R),this.o(new e(this.a,A,c,L))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new p(this.a,A)),A=null}});return R.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[c.seq];if(delete this.c[c.seq],c.err){let A=c.err;c.err.$isError&&(A=new Error,A.name=c.err.name,A.message=c.err.message,A.stack=c.err.stack),L.reject(A);return}L.resolve(c.res)}k(c){const L=c.req;this.g.handleMessage(c.method,c.args).then(R=>{this.o(new b(this.a,L,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,i.$3)(R.detail)),this.o(new b(this.a,L,void 0,(0,i.$3)(R)))})}l(c){const L=c.req,A=this.g.handleEvent(c.eventName,c.arg)(R=>{this.o(new d(this.a,L,R))});this.f.set(L,A)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const L=[];if(c.type===0)for(let A=0;A<c.args.length;A++)c.args[A]instanceof ArrayBuffer&&L.push(c.args[A]);else c.type===1&&c.res instanceof ArrayBuffer&&L.push(c.res);this.g.sendMessage(c,L)}}class $ extends M.$Uc{constructor(c,L,A){super();let R=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{R?.(q)})),this.c=new E({sendMessage:(q,H)=>{this.a.postMessage(q,H)},handleMessage:(q,H)=>{if(typeof A[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(A[q].apply(A,H))}catch(W){return Promise.reject(W)}},handleEvent:(q,H)=>{if(j(q)){const W=A[q].call(A,H);if(typeof W!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return W}if(v(q)){const W=A[q];if(typeof W!="function")throw new Error(`Missing event ${q} on main thread host.`);return W}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?P=k.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const S=(0,h.$eo)(A);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(P)),L,S]);const I=(q,H)=>this.g(q,H),D=(q,H)=>this.c.listen(q,H);this.f=new Promise((q,H)=>{R=H,this.b.then(W=>{q(l(W,I,D))},W=>{H(W),this.h("Worker failed to load "+L,W)})})}getProxyObject(){return this.f}g(c,L){return new Promise((A,R)=>{this.b.then(()=>{this.c.sendMessage(c,L).then(A,R)},R)})}h(c,L){console.error(c),console.info(L)}}t.SimpleWorkerClient=$;function v(f){return f[0]==="o"&&f[1]==="n"&&g.$Af(f.charCodeAt(2))}function j(f){return/^onDynamic/.test(f)&&g.$Af(f.charCodeAt(9))}function l(f,c,L){const A=k=>function(){const S=Array.prototype.slice.call(arguments,0);return c(k,S)},R=k=>function(S){return L(k,S)},P={};for(const k of f){if(j(k)){P[k]=R(k);continue}if(v(k)){P[k]=L(k,void 0);continue}P[k]=A(k)}return P}class n{constructor(c,L){this.a=L,this.b=null,this.c=new E({sendMessage:(A,R)=>{c(A,R)},handleMessage:(A,R)=>this.d(A,R),handleEvent:(A,R)=>this.f(A,R)})}onmessage(c){this.c.handleMessage(c)}d(c,L){if(c===a)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,L))}catch(A){return Promise.reject(A)}}f(c,L){if(!this.b)throw new Error("Missing requestHandler");if(j(c)){const A=this.b[c].call(this.b,L);if(typeof A!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return A}if(v(c)){const A=this.b[c];if(typeof A!="function")throw new Error(`Missing event ${c} on request handler.`);return A}throw new Error(`Malformed event name ${c}`)}g(c,L,A,R){this.c.setWorkerId(c);const S=l(R,(I,D)=>this.c.sendMessage(I,D),(I,D)=>this.c.listen(I,D));return this.a?(this.b=this.a(S),Promise.resolve((0,h.$eo)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((I,D)=>{(globalThis.require||B)([A],H=>{if(this.b=H.create(S),!this.b){D(new Error("No RequestHandler!"));return}I((0,h.$eo)(this.b))},D)}))}}t.SimpleWorkerServer=n;function s(f){return new n(f,null)}}),ne(re[72],ie([68,69]),function(B,t){return B.create("vs/editor/common/languages",t)}),ne(re[73],ie([0,1,44,19,45,2,66,72]),function(B,t,i,y,M,h,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$Bu=t.$Au=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.$zu=t.$yu=t.SymbolKinds=t.SymbolTag=t.$wu=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$uu=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$tu=t.$su=t.$ru=void 0,t.$vu=f,t.$xu=L;class a{constructor(z,oe,fe){this.offset=z,this.type=oe,this.language=fe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ru=a;class u{constructor(z,oe){this.tokens=z,this.endState=oe,this._tokenizationResultBrand=void 0}}t.$su=u;class o{constructor(z,oe){this.tokens=z,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}t.$tu=o;var N;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(N||(t.HoverVerbosityAction=N={}));var m;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(m||(t.CompletionItemKind=m={}));var b;(function(F){const z=new Map;z.set(0,i.$Zj.symbolMethod),z.set(1,i.$Zj.symbolFunction),z.set(2,i.$Zj.symbolConstructor),z.set(3,i.$Zj.symbolField),z.set(4,i.$Zj.symbolVariable),z.set(5,i.$Zj.symbolClass),z.set(6,i.$Zj.symbolStruct),z.set(7,i.$Zj.symbolInterface),z.set(8,i.$Zj.symbolModule),z.set(9,i.$Zj.symbolProperty),z.set(10,i.$Zj.symbolEvent),z.set(11,i.$Zj.symbolOperator),z.set(12,i.$Zj.symbolUnit),z.set(13,i.$Zj.symbolValue),z.set(15,i.$Zj.symbolEnum),z.set(14,i.$Zj.symbolConstant),z.set(15,i.$Zj.symbolEnum),z.set(16,i.$Zj.symbolEnumMember),z.set(17,i.$Zj.symbolKeyword),z.set(27,i.$Zj.symbolSnippet),z.set(18,i.$Zj.symbolText),z.set(19,i.$Zj.symbolColor),z.set(20,i.$Zj.symbolFile),z.set(21,i.$Zj.symbolReference),z.set(22,i.$Zj.symbolCustomColor),z.set(23,i.$Zj.symbolFolder),z.set(24,i.$Zj.symbolTypeParameter),z.set(25,i.$Zj.account),z.set(26,i.$Zj.issues);function oe(r){let Re=z.get(r);return Re||(console.info("No codicon found for CompletionItemKind "+r),Re=i.$Zj.symbolProperty),Re}F.toIcon=oe;const fe=new Map;fe.set("method",0),fe.set("function",1),fe.set("constructor",2),fe.set("field",3),fe.set("variable",4),fe.set("class",5),fe.set("struct",6),fe.set("interface",7),fe.set("module",8),fe.set("property",9),fe.set("event",10),fe.set("operator",11),fe.set("unit",12),fe.set("value",13),fe.set("constant",14),fe.set("enum",15),fe.set("enum-member",16),fe.set("enumMember",16),fe.set("keyword",17),fe.set("snippet",27),fe.set("text",18),fe.set("color",19),fe.set("file",20),fe.set("reference",21),fe.set("customcolor",22),fe.set("folder",23),fe.set("type-parameter",24),fe.set("typeParameter",24),fe.set("account",25),fe.set("issue",26);function $e(r,Re){let ye=fe.get(r);return typeof ye>"u"&&!Re&&(ye=9),ye}F.fromString=$e})(b||(t.CompletionItemKinds=b={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var d;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(d||(t.CompletionItemInsertTextRule=d={}));var p;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(p||(t.PartialAcceptTriggerKind=p={}));var E;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var $;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})($||(t.InlineCompletionTriggerKind=$={}));class v{constructor(z,oe,fe,$e){this.range=z,this.text=oe,this.completionKind=fe,this.isSnippetText=$e}equals(z){return h.$At.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}t.$uu=v;var j;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(j||(t.CodeActionTriggerType=j={}));var l;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(l||(t.DocumentPasteTriggerKind=l={}));var n;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(n||(t.SignatureHelpTriggerKind=n={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(F){return F&&y.URI.isUri(F.uri)&&h.$At.isIRange(F.range)&&(h.$At.isIRange(F.originSelectionRange)||h.$At.isIRange(F.targetSelectionRange))}var c;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(c||(t.SymbolKind=c={})),t.$wu={17:(0,g.localize)(0,null),16:(0,g.localize)(1,null),4:(0,g.localize)(2,null),13:(0,g.localize)(3,null),8:(0,g.localize)(4,null),9:(0,g.localize)(5,null),21:(0,g.localize)(6,null),23:(0,g.localize)(7,null),7:(0,g.localize)(8,null),0:(0,g.localize)(9,null),11:(0,g.localize)(10,null),10:(0,g.localize)(11,null),19:(0,g.localize)(12,null),5:(0,g.localize)(13,null),1:(0,g.localize)(14,null),2:(0,g.localize)(15,null),20:(0,g.localize)(16,null),15:(0,g.localize)(17,null),18:(0,g.localize)(18,null),24:(0,g.localize)(19,null),3:(0,g.localize)(20,null),6:(0,g.localize)(21,null),14:(0,g.localize)(22,null),22:(0,g.localize)(23,null),25:(0,g.localize)(24,null),12:(0,g.localize)(25,null)};function L(F,z){return(0,g.localize)(26,null,F,t.$wu[z])}var A;(function(F){F[F.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var R;(function(F){const z=new Map;z.set(0,i.$Zj.symbolFile),z.set(1,i.$Zj.symbolModule),z.set(2,i.$Zj.symbolNamespace),z.set(3,i.$Zj.symbolPackage),z.set(4,i.$Zj.symbolClass),z.set(5,i.$Zj.symbolMethod),z.set(6,i.$Zj.symbolProperty),z.set(7,i.$Zj.symbolField),z.set(8,i.$Zj.symbolConstructor),z.set(9,i.$Zj.symbolEnum),z.set(10,i.$Zj.symbolInterface),z.set(11,i.$Zj.symbolFunction),z.set(12,i.$Zj.symbolVariable),z.set(13,i.$Zj.symbolConstant),z.set(14,i.$Zj.symbolString),z.set(15,i.$Zj.symbolNumber),z.set(16,i.$Zj.symbolBoolean),z.set(17,i.$Zj.symbolArray),z.set(18,i.$Zj.symbolObject),z.set(19,i.$Zj.symbolKey),z.set(20,i.$Zj.symbolNull),z.set(21,i.$Zj.symbolEnumMember),z.set(22,i.$Zj.symbolStruct),z.set(23,i.$Zj.symbolEvent),z.set(24,i.$Zj.symbolOperator),z.set(25,i.$Zj.symbolTypeParameter);function oe(fe){let $e=z.get(fe);return $e||(console.info("No codicon found for SymbolKind "+fe),$e=i.$Zj.symbolProperty),$e}F.toIcon=oe})(R||(t.SymbolKinds=R={}));class P{static asEditOperation(z){return M.$Bt.replace(h.$At.lift(z.range),z.text)}}t.$yu=P;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(z){switch(z){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(z)}constructor(z){this.value=z}}t.$zu=k;var S;(function(F){F[F.AIGenerated=1]="AIGenerated"})(S||(t.NewSymbolNameTag=S={}));var I;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(I||(t.NewSymbolNameTriggerKind=I={}));var D;(function(F){function z(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}F.is=z})(D||(t.Command=D={}));var q;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(q||(t.CommentThreadCollapsibleState=q={}));var H;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(H||(t.CommentThreadState=H={}));var W;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(W||(t.CommentThreadApplicability=W={}));var U;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(U||(t.CommentMode=U={}));var Z;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Z||(t.CommentState=Z={}));var X;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(X||(t.InlayHintKind=X={}));class J{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Au=J,t.$Bu=new w.$ju;var _;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(_||(t.ExternalUriOpenerPriority=_={}));var K;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(K||(t.InlineEditTriggerKind=K={}))}),ne(re[74],ie([0,1,24,12,39,19,4,2,46,73,65]),function(B,t,i,y,M,h,w,g,a,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$12=void 0,t.$22=m;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,d){return(0,M.$Kr)(e,d)}}t.$12=N;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$se,Emitter:y.$he,KeyCode:o.KeyCode,KeyMod:N,Position:w.$zt,Range:g.$At,Selection:a.$Ct,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:h.URI,Token:u.$ru}}}),ne(re[77],ie([0,1,25,19,4,2,61,31,57,58,74,23,64,35,55,15,3,56,63]),function(B,t,i,y,M,h,w,g,a,u,o,N,m,b,e,d,p,E,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=l;class v extends w.$_v{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const f=[];for(let c=0;c<this.f.length;c++){const L=this.f[c],A=this.offsetAt(new M.$zt(c+1,1)),R=L.matchAll(s);for(const P of R)(P.index||P.index===0)&&(P.index=P.index+A),f.push(P)}return f}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,f){const c=(0,g.$ct)(s.column,(0,g.$at)(f),this.f[s.lineNumber-1],0);return c?new h.$At(s.lineNumber,c.startColumn,s.lineNumber,c.endColumn):null}getWordUntilPosition(s,f){const c=this.getWordAtPosition(s,f);return c?{word:this.f[s.lineNumber-1].substring(c.startColumn-1,s.column-1),startColumn:c.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const f=this.f,c=this.q.bind(this);let L=0,A="",R=0,P=[];return{*[Symbol.iterator](){for(;;)if(R<P.length){const k=A.substring(P[R].start,P[R].end);R+=1,yield k}else if(L<f.length)A=f[L],P=c(A,s),R=0,L+=1;else break}}}getLineWords(s,f){const c=this.f[s-1],L=this.q(c,f),A=[];for(const R of L)A.push({word:c.substring(R.start,R.end),startColumn:R.start+1,endColumn:R.end+1});return A}q(s,f){const c=[];let L;for(f.lastIndex=0;(L=f.exec(s))&&L[0].length!==0;)c.push({start:L.index,end:L.index+L[0].length});return c}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const f=this.g,c=s.startLineNumber-1,L=s.endLineNumber-1,A=[];A.push(this.f[c].substring(s.startColumn-1));for(let R=c+1;R<L;R++)A.push(this.f[R]);return A.push(this.f[L].substring(0,s.endColumn-1)),A.join(f)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const f=this.j.getIndexOf(s),c=this.f[f.index].length;return{lineNumber:1+f.index,column:1+Math.min(f.remainder,c)}}r(s){const f=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),c=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return f.lineNumber!==s.startLineNumber||f.column!==s.startColumn||c.lineNumber!==s.endLineNumber||c.column!==s.endColumn?{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:c.lineNumber,endColumn:c.column}:s}s(s){if(!M.$zt.isIPosition(s))throw new Error("bad position");let{lineNumber:f,column:c}=s,L=!1;if(f<1)f=1,c=1,L=!0;else if(f>this.f.length)f=this.f.length,c=this.f[f-1].length+1,L=!0;else{const A=this.f[f-1].length+1;c<1?(c=1,L=!0):c>A&&(c=A,L=!0)}return L?{lineNumber:f,column:c}:s}}class j{constructor(s,f){this.d=s,this.f=Object.create(null),this.g=f,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(f=>s.push(this.f[f])),s}acceptNewModel(s){this.f[s.url]=new v(y.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,f){if(!this.f[s])return;this.f[s].onEvents(f)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,f,c){const L=this.j(s);return L?m.$V2.computeUnicodeHighlights(L,f,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,f){const c=this.j(s);return c?(0,$.$n3)(c,f):[]}async computeDiff(s,f,c,L){const A=this.j(s),R=this.j(f);return!A||!R?null:j.l(A,R,c,L)}static l(s,f,c,L){const A=L==="advanced"?e.$l3.getDefault():e.$l3.getLegacy(),R=s.getLinesContent(),P=f.getLinesContent(),k=A.computeDiff(R,P,c),S=k.changes.length>0?!1:this.n(s,f);function I(D){return D.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(H=>[H.originalRange.startLineNumber,H.originalRange.startColumn,H.originalRange.endLineNumber,H.originalRange.endColumn,H.modifiedRange.startLineNumber,H.modifiedRange.startColumn,H.modifiedRange.endLineNumber,H.modifiedRange.endColumn])])}return{identical:S,quitEarly:k.hitTimeout,changes:I(k.changes),moves:k.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,I(D.changes)])}}static n(s,f){const c=s.getLineCount(),L=f.getLineCount();if(c!==L)return!1;for(let A=1;A<=c;A++){const R=s.getLineContent(A),P=f.getLineContent(A);if(R!==P)return!1}return!0}async computeDirtyDiff(s,f,c){const L=this.j(s),A=this.j(f);if(!L||!A)return null;const R=L.getLinesContent(),P=A.getLinesContent();return new b.$Yt(R,P,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(s,f,c){const L=this.j(s);if(!L)return f;const A=[];let R;f=f.slice(0).sort((k,S)=>{if(k.range&&S.range)return h.$At.compareRangesUsingStarts(k.range,S.range);const I=k.range?0:1,D=S.range?0:1;return I-D});let P=0;for(let k=1;k<f.length;k++)h.$At.getEndPosition(f[P].range).equals(h.$At.getStartPosition(f[k].range))?(f[P].range=h.$At.fromPositions(h.$At.getStartPosition(f[P].range),h.$At.getEndPosition(f[k].range)),f[P].text+=f[k].text):(P++,f[P]=f[k]);f.length=P+1;for(let{range:k,text:S,eol:I}of f){if(typeof I=="number"&&(R=I),h.$At.isEmpty(k)&&!S)continue;const D=L.getValueInRange(k);if(S=S.replace(/\r\n|\n|\r/g,L.eol),D===S)continue;if(Math.max(S.length,D.length)>j.o){A.push({range:k,text:S});continue}const q=(0,i.$Ft)(D,S,c),H=L.offsetAt(h.$At.lift(k).getStartPosition());for(const W of q){const U=L.positionAt(H+W.originalStart),Z=L.positionAt(H+W.originalStart+W.originalLength),X={text:S.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:Z.lineNumber,endColumn:Z.column}};L.getValueInRange(X.range)!==X.text&&A.push(X)}}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}computeHumanReadableDiff(s,f,c){const L=this.j(s);if(!L)return f;const A=[];let R;f=f.slice(0).sort((P,k)=>{if(P.range&&k.range)return h.$At.compareRangesUsingStarts(P.range,k.range);const S=P.range?0:1,I=k.range?0:1;return S-I});for(let{range:P,text:k,eol:S}of f){let U=function(X,J){return new M.$zt(X.lineNumber+J.lineNumber-1,J.lineNumber===1?X.column+J.column-1:J.column)},Z=function(X,J){const _=[];for(let K=J.startLineNumber;K<=J.endLineNumber;K++){const F=X[K-1];K===J.startLineNumber&&K===J.endLineNumber?_.push(F.substring(J.startColumn-1,J.endColumn-1)):K===J.startLineNumber?_.push(F.substring(J.startColumn-1)):K===J.endLineNumber?_.push(F.substring(0,J.endColumn-1)):_.push(F)}return _};if(typeof S=="number"&&(R=S),h.$At.isEmpty(P)&&!k)continue;const I=L.getValueInRange(P);if(k=k.replace(/\r\n|\n|\r/g,L.eol),I===k)continue;if(Math.max(k.length,I.length)>j.o){A.push({range:P,text:k});continue}const D=I.split(/\r\n|\n|\r/),q=k.split(/\r\n|\n|\r/),H=e.$l3.getDefault().computeDiff(D,q,c),W=h.$At.lift(P).getStartPosition();for(const X of H.changes)if(X.innerChanges)for(const J of X.innerChanges)A.push({range:h.$At.fromPositions(U(W,J.originalRange.getStartPosition()),U(W,J.originalRange.getEndPosition())),text:Z(q,J.modifiedRange).join(L.eol)});else throw new p.$cb("The experimental diff algorithm always produces inner changes")}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}async computeLinks(s){const f=this.j(s);return f?(0,a.$Y2)(f):null}async computeDefaultDocumentColors(s){const f=this.j(s);return f?(0,E.$m3)(f):null}static{this.p=1e4}async textualSuggest(s,f,c,L){const A=new N.$be,R=new RegExp(c,L),P=new Set;e:for(const k of s){const S=this.j(k);if(S){for(const I of S.words(R))if(!(I===f||!isNaN(Number(I)))&&(P.add(I),P.size>j.p))break e}}return{words:Array.from(P),duration:A.elapsed()}}async computeWordRanges(s,f,c,L){const A=this.j(s);if(!A)return Object.create(null);const R=new RegExp(c,L),P=Object.create(null);for(let k=f.startLineNumber;k<f.endLineNumber;k++){const S=A.getLineWords(k,R);for(const I of S){if(!isNaN(Number(I.word)))continue;let D=P[I.word];D||(D=[],P[I.word]=D),D.push({startLineNumber:k,startColumn:I.startColumn,endLineNumber:k,endColumn:I.endColumn})}}return P}async navigateValueSet(s,f,c,L,A){const R=this.j(s);if(!R)return null;const P=new RegExp(L,A);f.startColumn===f.endColumn&&(f={startLineNumber:f.startLineNumber,startColumn:f.startColumn,endLineNumber:f.endLineNumber,endColumn:f.endColumn+1});const k=R.getValueInRange(f),S=R.getWordAtPosition({lineNumber:f.startLineNumber,column:f.startColumn},P);if(!S)return null;const I=R.getValueInRange(S);return u.$Z2.INSTANCE.navigateValueSet(f,k,S,I,c)}loadForeignModule(s,f,c){const L=(P,k)=>this.d.fhr(P,k),R={host:(0,d.$fo)(c,L),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(R,f),Promise.resolve((0,d.$eo)(this.h))):new Promise((P,k)=>{B([s],S=>{this.h=S.create(R,f),P((0,d.$eo)(this.h))},k)})}fmr(s,f){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,f))}catch(c){return Promise.reject(c)}}}t.EditorSimpleWorker=j;function l(n){return new j(n,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,o.$22)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/base/worker/workerMain.js.map
