/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],de=function(oe){for(var e=[],b=0,S=oe.length;b<S;b++)e[b]=fe[oe[b]];return e};define(fe[40],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=b,e.$gb=S,e.$hb=C,e.$ib=D,e.$jb=j,e.$kb=E,e.$lb=h,e.$nb=y,e.$ob=u,e.$pb=k,e.$qb=a,e.$rb=c;function b(m,f){const s=S(m,f);if(s!==-1)return m[s]}function S(m,f,s=m.length-1){for(let n=s;n>=0;n--){const g=m[n];if(f(g))return n}return-1}function C(m,f){const s=D(m,f);return s===-1?void 0:m[s]}function D(m,f,s=0,n=m.length){let g=s,w=n;for(;g<w;){const i=Math.floor((g+w)/2);f(m[i])?g=i+1:w=i}return g-1}function j(m,f){const s=E(m,f);return s===m.length?void 0:m[s]}function E(m,f,s=0,n=m.length){let g=s,w=n;for(;g<w;){const i=Math.floor((g+w)/2);f(m[i])?w=i:g=i+1}return g}function h(m,f,s=0,n=m.length){const g=E(m,f,s,n);return g===m.length?-1:g}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=D(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=r;function y(m,f){if(m.length===0)return;let s=m[0];for(let n=1;n<m.length;n++){const g=m[n];f(g,s)>0&&(s=g)}return s}function u(m,f){if(m.length===0)return;let s=m[0];for(let n=1;n<m.length;n++){const g=m[n];f(g,s)>=0&&(s=g)}return s}function k(m,f){return y(m,(s,n)=>-f(s,n))}function a(m,f){if(m.length===0)return-1;let s=0;for(let n=1;n<m.length;n++){const g=m[n];f(g,m[s])>0&&(s=n)}return s}function c(m,f){for(const s of m){const n=f(s);if(n!==void 0)return n}}}),define(fe[41],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=b,e.$L=S,e.$M=C,e.$N=D;function b(j,E){const h=Object.create(null);for(const r of j){const y=E(r);let u=h[y];u||(u=h[y]=[]),u.push(r)}return h}function S(j,E){const h=[],r=[];for(const y of j)E.has(y)||h.push(y);for(const y of E)j.has(y)||r.push(y);return{removed:h,added:r}}function C(j,E){const h=[],r=[];for(const[y,u]of j)E.has(y)||h.push(u);for(const[y,u]of E)j.has(y)||r.push(u);return{removed:h,added:r}}function D(j,E){const h=new Set;for(const r of E)j.has(r)&&h.add(r);return h}}),define(fe[14],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=S,e.$6h=C,e.$7h=D;function b(j){return(E,h,r)=>{let y=null,u=null;if(typeof r.value=="function"?(y="value",u=r.value):typeof r.get=="function"&&(y="get",u=r.get),!u)throw new Error("not supported");r[y]=j(u,h)}}function S(j,E,h){let r=null,y=null;if(typeof h.value=="function"?(r="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(r="get",y=h.get),!y)throw new Error("not supported");const u=`$memoize$${E}`;h[r]=function(...k){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,k)}),this[u]}}function C(j,E,h){return b((r,y)=>{const u=`$debounce$${y}`,k=`$debounce$result$${y}`;return function(...a){this[k]||(this[k]=h?h():void 0),clearTimeout(this[u]),E&&(this[k]=E(this[k],...a),a=[this[k]]),this[u]=setTimeout(()=>{r.apply(this,a),this[k]=h?h():void 0},j)}})}function D(j,E,h){return b((r,y)=>{const u=`$throttle$timer$${y}`,k=`$throttle$result$${y}`,a=`$throttle$lastRun$${y}`,c=`$throttle$pending$${y}`;return function(...m){if(this[k]||(this[k]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...m)),this[c])return;const f=this[a]+j;f<=Date.now()?(this[a]=Date.now(),r.apply(this,[this[k]]),this[k]=h?h():void 0):(this[c]=!0,this[u]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),r.apply(this,[this[k]]),this[k]=h?h():void 0},f-Date.now()))}})}}),define(fe[7],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=S,e.$Z=C,e.$1=D,e.$2=j,e.$3=E,e.$4=r,e.$6=u,e.$7=k,e.$8=a,e.$0=m;class b{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?g.isErrorNoTelemetry(t)?new g(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=b,e.$X=new b;function S(i){e.$X.setUnexpectedErrorHandler(i)}function C(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(i){r(i)||e.$X.onUnexpectedError(i)}function j(i){r(i)||e.$X.onUnexpectedExternalError(i)}function E(i){if(i instanceof Error){const{name:t,message:o}=i,P=i.stacktrace||i.stack;return{$isError:!0,name:t,message:o,stack:P,noTelemetry:g.isErrorNoTelemetry(i)}}return i}const h="Canceled";function r(i){return i instanceof y?!0:i instanceof Error&&i.name===h&&i.message===h}class y extends Error{constructor(){super(h),this.name=this.message}}e.$5=y;function u(){const i=new Error(h);return i.name=i.message,i}function k(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function a(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class g extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof g)return t;const o=new g;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=g;class w extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$cb=w}),define(fe[16],de([0,1,7,40]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=C,e.$tb=D,e.$ub=j,e.$vb=E,e.$wb=h,e.$xb=r,e.$yb=y,e.$zb=u,e.$Ab=k,e.$Bb=a,e.$Cb=c,e.$Db=m,e.$Eb=f,e.top=s,e.$Gb=n,e.$Hb=w,e.$Ib=i,e.$Jb=t,e.$Kb=o,e.$Lb=P,e.$Mb=p,e.$Nb=L,e.$Ob=v,e.$Pb=$,e.$Qb=T,e.$Rb=Q,e.$Sb=U,e.$Tb=I,e.$Ub=d,e.$Vb=N,e.$Wb=M,e.$Xb=A,e.$Yb=q,e.$Zb=Z,e.$1b=G,e.$2b=_,e.$3b=re,e.$4b=le,e.$5b=X,e.$6b=ee,e.$7b=he,e.$0b=te;function C(R,Y=0){return R[R.length-(1+Y)]}function D(R){if(R.length===0)throw new Error("Invalid tail call");return[R.slice(0,R.length-1),R[R.length-1]]}function j(R,Y,H=(V,O)=>V===O){if(R===Y)return!0;if(!R||!Y||R.length!==Y.length)return!1;for(let V=0,O=R.length;V<O;V++)if(!H(R[V],Y[V]))return!1;return!0}function E(R,Y){const H=R.length-1;Y<H&&(R[Y]=R[H]),R.pop()}function h(R,Y,H){return r(R.length,V=>H(R[V],Y))}function r(R,Y){let H=0,V=R-1;for(;H<=V;){const O=(H+V)/2|0,J=Y(O);if(J<0)H=O+1;else if(J>0)V=O-1;else return O}return-(H+1)}function y(R,Y,H){if(R=R|0,R>=Y.length)throw new TypeError("invalid index");const V=Y[Math.floor(Y.length*Math.random())],O=[],J=[],ie=[];for(const ae of Y){const $e=H(ae,V);$e<0?O.push(ae):$e>0?J.push(ae):ie.push(ae)}return R<O.length?y(R,O,H):R<O.length+ie.length?ie[0]:y(R-(O.length+ie.length),J,H)}function u(R,Y){const H=[];let V;for(const O of R.slice(0).sort(Y))!V||Y(V[0],O)!==0?(V=[O],H.push(V)):V.push(O);return H}function*k(R,Y){let H,V;for(const O of R)V!==void 0&&Y(V,O)?H.push(O):(H&&(yield H),H=[O]),V=O;H&&(yield H)}function a(R,Y){for(let H=0;H<=R.length;H++)Y(H===0?void 0:R[H-1],H===R.length?void 0:R[H])}function c(R,Y){for(let H=0;H<R.length;H++)Y(H===0?void 0:R[H-1],R[H],H+1===R.length?void 0:R[H+1])}function m(R,Y,H){const V=[];function O(ae,$e,Ee){if($e===0&&Ee.length===0)return;const ge=V[V.length-1];ge&&ge.start+ge.deleteCount===ae?(ge.deleteCount+=$e,ge.toInsert.push(...Ee)):V.push({start:ae,deleteCount:$e,toInsert:Ee})}let J=0,ie=0;for(;;){if(J===R.length){O(J,0,Y.slice(ie));break}if(ie===Y.length){O(J,R.length-J,[]);break}const ae=R[J],$e=Y[ie],Ee=H(ae,$e);Ee===0?(J+=1,ie+=1):Ee<0?(O(J,1,[]),J+=1):Ee>0&&(O(J,0,[$e]),ie+=1)}return V}function f(R,Y,H){const V=m(R,Y,H),O=[],J=[];for(const ie of V)O.push(...R.slice(ie.start,ie.start+ie.deleteCount)),J.push(...ie.toInsert);return{removed:O,added:J}}function s(R,Y,H){if(H===0)return[];const V=R.slice(0,H).sort(Y);return g(R,Y,V,H,R.length),V}function n(R,Y,H,V,O){return H===0?Promise.resolve([]):new Promise((J,ie)=>{(async()=>{const ae=R.length,$e=R.slice(0,H).sort(Y);for(let Ee=H,ge=Math.min(H+V,ae);Ee<ae;Ee=ge,ge=Math.min(ge+V,ae)){if(Ee>H&&await new Promise(me=>setTimeout(me)),O&&O.isCancellationRequested)throw new b.$5;g(R,Y,$e,Ee,ge)}return $e})().then(J,ie)})}function g(R,Y,H,V,O){for(const J=H.length;V<O;V++){const ie=R[V];if(Y(ie,H[J-1])<0){H.pop();const ae=(0,S.$kb)(H,$e=>Y(ie,$e)<0);H.splice(ae,0,ie)}}}function w(R){return R.filter(Y=>!!Y)}function i(R){let Y=0;for(let H=0;H<R.length;H++)R[H]&&(R[Y]=R[H],Y+=1);R.length=Y}function t(R,Y,H){R.splice(H,0,R.splice(Y,1)[0])}function o(R){return!Array.isArray(R)||R.length===0}function P(R){return Array.isArray(R)&&R.length>0}function p(R,Y=H=>H){const H=new Set;return R.filter(V=>{const O=Y(V);return H.has(O)?!1:(H.add(O),!0)})}function L(R){const Y=new Set;return H=>{const V=R(H);return Y.has(V)?!1:(Y.add(V),!0)}}function v(R,Y){return R.length>0?R[0]:Y}function $(R,Y){return R.length>0?R[R.length-1]:Y}function T(R,Y,H=(V,O)=>V===O){let V=0;for(let O=0,J=Math.min(R.length,Y.length);O<J&&H(R[O],Y[O]);O++)V++;return V}function Q(R,Y){let H=typeof Y=="number"?R:0;typeof Y=="number"?H=R:(H=0,Y=R);const V=[];if(H<=Y)for(let O=H;O<Y;O++)V.push(O);else for(let O=H;O>Y;O--)V.push(O);return V}function U(R,Y,H){return R.reduce((V,O)=>(V[Y(O)]=H?H(O):O,V),Object.create(null))}function I(R,Y){return R.push(Y),()=>d(R,Y)}function d(R,Y){const H=R.indexOf(Y);if(H>-1)return R.splice(H,1),Y}function N(R,Y,H){const V=R.slice(0,Y),O=R.slice(Y);return V.concat(H,O)}function M(R,Y){let H;if(typeof Y=="number"){let V=Y;H=()=>{const O=Math.sin(V++)*179426549;return O-Math.floor(O)}}else H=Math.random;for(let V=R.length-1;V>0;V-=1){const O=Math.floor(H()*(V+1)),J=R[V];R[V]=R[O],R[O]=J}}function A(R,Y){const H=R.indexOf(Y);H>-1&&(R.splice(H,1),R.unshift(Y))}function q(R,Y){const H=R.indexOf(Y);H>-1&&(R.splice(H,1),R.push(Y))}function Z(R,Y){for(const H of Y)R.push(H)}function G(R,Y){return Array.isArray(R)?R.map(Y):Y(R)}function _(R){return Array.isArray(R)?R:[R]}function re(R){return R[Math.floor(Math.random()*R.length)]}function le(R,Y,H){const V=F(R,Y),O=R.length,J=H.length;R.length=O+J;for(let ie=O-1;ie>=V;ie--)R[ie+J]=R[ie];for(let ie=0;ie<J;ie++)R[ie+V]=H[ie]}function X(R,Y,H,V){const O=F(R,Y);let J=R.splice(O,H);return J===void 0&&(J=[]),le(R,O,V),J}function F(R,Y){return Y<0?Math.max(Y+R.length,0):Math.min(Y,R.length)}var x;(function(R){function Y(J){return J<0}R.isLessThan=Y;function H(J){return J<=0}R.isLessThanOrEqual=H;function V(J){return J>0}R.isGreaterThan=V;function O(J){return J===0}R.isNeitherLessOrGreaterThan=O,R.greaterThan=1,R.lessThan=-1,R.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function ee(R,Y){return(H,V)=>Y(R(H),R(V))}function he(...R){return(Y,H)=>{for(const V of R){const O=V(Y,H);if(!x.isNeitherLessOrGreaterThan(O))return O}return x.neitherLessOrGreaterThan}}const W=(R,Y)=>R-Y;e.$8b=W;const ce=(R,Y)=>(0,e.$8b)(R?1:0,Y?1:0);e.$9b=ce;function te(R){return(Y,H)=>-R(Y,H)}class l{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let H=this.c;for(;H<this.g.length&&Y(this.g[H]);)H++;const V=H===this.c?null:this.g.slice(this.c,H);return this.c=H,V}takeFromEndWhile(Y){let H=this.d;for(;H>=0&&Y(this.g[H]);)H--;const V=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,V}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const H=this.g.slice(this.c,this.c+Y);return this.c+=Y,H}}e.$$b=l;class z{static{this.empty=new z(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(H=>(Y(H),!0))}toArray(){const Y=[];return this.iterate(H=>(Y.push(H),!0)),Y}filter(Y){return new z(H=>this.iterate(V=>Y(V)?H(V):!0))}map(Y){return new z(H=>this.iterate(V=>H(Y(V))))}some(Y){let H=!1;return this.iterate(V=>(H=Y(V),!H)),H}findFirst(Y){let H;return this.iterate(V=>Y(V)?(H=V,!1):!0),H}findLast(Y){let H;return this.iterate(V=>(Y(V)&&(H=V),!0)),H}findLastMaxBy(Y){let H,V=!0;return this.iterate(O=>((V||x.isGreaterThan(Y(O,H)))&&(V=!1,H=O),!0)),H}}e.$_b=z;class ne{constructor(Y){this.c=Y}static createSortPermutation(Y,H){const V=Array.from(Y.keys()).sort((O,J)=>H(Y[O],Y[J]));return new ne(V)}apply(Y){return Y.map((H,V)=>Y[this.c[V]])}inverse(){const Y=this.c.slice();for(let H=0;H<this.c.length;H++)Y[this.c[H]]=H;return new ne(Y)}}e.$ac=ne}),define(fe[42],de([0,1,7]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$ed=C,e.$fd=D,e.$gd=j,e.$hd=E,e.$id=h;function S(r,y){if(!r)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function C(r,y="Unreachable"){throw new Error(y)}function D(r,y="unexpected state"){if(!r)throw new b.$cb(`Assertion Failed: ${y}`)}function j(r){r||(0,b.$1)(new b.$cb("Soft Assertion Failed"))}function E(r){if(!r()){debugger;r(),(0,b.$1)(new b.$cb("Assertion Failed"))}}function h(r,y){let u=0;for(;u<r.length-1;){const k=r[u],a=r[u+1];if(!y(k,a))return!1;u++}return!0}}),define(fe[29],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=b;function b(S,C){const D=this;let j=!1,E;return function(){if(j)return E;if(j=!0,C)try{E=S.apply(D,arguments)}finally{C()}else E=S.apply(D,arguments);return E}}}),define(fe[43],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(S){function C(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}S.is=C;const D=Object.freeze([]);function j(){return D}S.empty=j;function*E(t){yield t}S.single=E;function h(t){return C(t)?t:E(t)}S.wrap=h;function r(t){return t||D}S.from=r;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}S.reverse=y;function u(t){return!t||t[Symbol.iterator]().next().done===!0}S.isEmpty=u;function k(t){return t[Symbol.iterator]().next().value}S.first=k;function a(t,o){for(const P of t)if(o(P))return!0;return!1}S.some=a;function c(t,o){for(const P of t)if(o(P))return P}S.find=c;function*m(t,o){for(const P of t)o(P)&&(yield P)}S.filter=m;function*f(t,o){let P=0;for(const p of t)yield o(p,P++)}S.map=f;function*s(...t){for(const o of t)yield*o}S.concat=s;function n(t,o,P){let p=P;for(const L of t)p=o(p,L);return p}S.reduce=n;function*g(t,o,P=t.length){for(o<0&&(o+=t.length),P<0?P+=t.length:P>t.length&&(P=t.length);o<P;o++)yield t[o]}S.slice=g;function w(t,o=Number.POSITIVE_INFINITY){const P=[];if(o===0)return[P,t];const p=t[Symbol.iterator]();for(let L=0;L<o;L++){const v=p.next();if(v.done)return[P,S.empty()];P.push(v.value)}return[P,{[Symbol.iterator](){return p}}]}S.consume=w;async function i(t){const o=[];for await(const P of t)o.push(P);return Promise.resolve(o)}S.asyncToArray=i})(b||(e.Iterable=b={}))}),define(fe[22],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class b{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=b}),define(fe[44],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class b{static{this.Undefined=new b(void 0)}constructor(D){this.element=D,this.next=b.Undefined,this.prev=b.Undefined}}class S{constructor(){this.a=b.Undefined,this.b=b.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===b.Undefined}clear(){let D=this.a;for(;D!==b.Undefined;){const j=D.next;D.prev=b.Undefined,D.next=b.Undefined,D=j}this.a=b.Undefined,this.b=b.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,j){const E=new b(D);if(this.a===b.Undefined)this.a=E,this.b=E;else if(j){const r=this.b;this.b=E,E.prev=r,r.next=E}else{const r=this.a;this.a=E,E.next=r,r.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==b.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==b.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==b.Undefined&&D.next!==b.Undefined){const j=D.prev;j.next=D.next,D.next.prev=j}else D.prev===b.Undefined&&D.next===b.Undefined?(this.a=b.Undefined,this.b=b.Undefined):D.next===b.Undefined?(this.b=this.b.prev,this.b.next=b.Undefined):D.prev===b.Undefined&&(this.a=this.a.next,this.a.prev=b.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==b.Undefined;)yield D.element,D=D.next}}e.$5c=S}),define(fe[25],de([0,1]),function(oe,e){"use strict";var b,S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=D,e.$yc=j,e.$zc=E,e.$Ic=w;function D(i,t,o){let P=i.get(t);return P===void 0&&(P=o,i.set(t,P)),P}function j(i){const t=[];return i.forEach((o,P)=>{t.push(`${P} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}function E(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}class h{constructor(t,o){this.uri=t,this.value=o}}function r(i){return Array.isArray(i)}class y{static{this.c=t=>t.toString()}constructor(t,o){if(this[b]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=o??y.c;else if(r(t)){this.d=new Map,this.e=o??y.c;for(const[P,p]of t)this.set(P,p)}else this.d=new Map,this.e=t??y.c}set(t,o){return this.d.set(this.e(t),new h(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[P,p]of this.d)t(p.value,p.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=y;class u{constructor(t,o){this[S]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((P,p)=>t.call(o,p,p,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=u;var k;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class a{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=0){const P=this.c.get(t);if(P)return o!==0&&this.m(P,o),P.value}set(t,o,P=0){let p=this.c.get(t);if(p)p.value=o,P!==0&&this.m(p,P);else{switch(p={key:t,value:o,next:void 0,previous:void 0},P){case 0:this.k(p);break;case 1:this.j(p);break;case 2:this.k(p);break;default:this.k(p);break}this.c.set(t,p),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const P=this.g;let p=this.d;for(;p;){if(o?t.bind(o)(p.value,p.key,this):t(p.value,p.key,this),this.g!==P)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,o=this.g;let P=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(P){const L={value:P.key,done:!1};return P=P.next,L}else return{value:void 0,done:!0}}};return p}values(){const t=this,o=this.g;let P=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(P){const L={value:P.value,done:!1};return P=P.next,L}else return{value:void 0,done:!0}}};return p}entries(){const t=this,o=this.g;let P=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(P){const L={value:[P.key,P.value],done:!1};return P=P.next,L}else return{value:void 0,done:!0}}};return p}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,P=this.size;for(;o&&P>t;)this.c.delete(o.key),o=o.next,P--;this.d=o,this.f=P,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,P=this.size;for(;o&&P>t;)this.c.delete(o.key),o=o.previous,P--;this.e=o,this.f=P,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,P=t.previous;if(!o||!P)throw new Error("Invalid list");o.previous=P,P.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.d)return;const P=t.next,p=t.previous;t===this.e?(p.next=void 0,this.e=p):(P.previous=p,p.next=P),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===2){if(t===this.e)return;const P=t.next,p=t.previous;t===this.d?(P.previous=void 0,this.d=P):(P.previous=p,p.next=P),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,P)=>{t.push([P,o])}),t}fromJSON(t){this.clear();for(const[o,P]of t)this.set(o,P)}}e.$Cc=a;class c extends a{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends c{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=m;class f extends c{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=f;class s{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=s;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,P]of t)this.set(o,P)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((P,p)=>{t.call(o,P,p,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class g{constructor(){this.c=new Map}add(t,o){let P=this.c.get(t);P||(P=new Set,this.c.set(t,P)),P.add(o)}delete(t,o){const P=this.c.get(t);P&&(P.delete(o),P.size===0&&this.c.delete(t))}forEach(t,o){const P=this.c.get(t);P&&P.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=g;function w(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[o,P]of i)if(!t.has(o)||t.get(o)!==P)return!1;for(const[o]of t)if(!i.has(o))return!1;return!0}}),define(fe[2],de([0,1,16,41,25,29,43]),function(oe,e,b,S,C,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=y,e.$Lc=u,e.$Mc=k,e.$Nc=m,e.$Oc=f,e.$Pc=s,e.$Qc=n,e.$Rc=g,e.$Sc=w,e.$3c=Q;const E=!1;let h=null;class r{constructor(){this.b=new Map}static{this.a=0}c(d){let N=this.b.get(d);return N||(N={parent:null,source:null,isSingleton:!1,value:d,idx:r.a++},this.b.set(d,N)),N}trackDisposable(d){const N=this.c(d);N.source||(N.source=new Error().stack)}setParent(d,N){const M=this.c(d);M.parent=N}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,N){const M=N.get(d);if(M)return M;const A=d.parent?this.f(this.c(d.parent),N):d;return N.set(d,A),A}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,d).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(d=10,N){let M;if(N)M=N;else{const _=new Map,re=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,_).isSingleton);if(re.length===0)return;const le=new Set(re.map(X=>X.value));if(M=re.filter(X=>!(X.parent&&le.has(X.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function A(_){function re(X,F){for(;X.length>0&&F.some(x=>typeof x=="string"?x===X[0]:X[0].match(x));)X.shift()}const le=_.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return re(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const q=new C.$Hc;for(const _ of M){const re=A(_);for(let le=0;le<=re.length;le++)q.add(re.slice(0,le).join(`
`),_)}M.sort((0,b.$6b)(_=>_.idx,b.$8b));let Z="",G=0;for(const _ of M.slice(0,d)){G++;const re=A(_),le=[];for(let X=0;X<re.length;X++){let F=re[X];F=`(shared with ${q.get(re.slice(0,X+1).join(`
`)).size}/${M.length} leaks) at ${F}`;const ee=q.get(re.slice(0,X).join(`
`)),he=(0,S.$K)([...ee].map(W=>A(W)[X]),W=>W);delete he[re[X]];for(const[W,ce]of Object.entries(he))le.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${W}`);le.unshift(F)}Z+=`


==================== Leaking disposable ${G}/${M.length}: ${_.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return M.length>d&&(Z+=`


... and ${M.length-d} more leaking disposables

`),{leaks:M,details:Z}}}e.$Jc=r;function y(I){h=I}if(E){const I="__is_disposable_tracked__";y(new class{trackDisposable(d){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[I]||console.log(N)},3e3)}setParent(d,N){if(d&&d!==t.None)try{d[I]=!0}catch{}}markAsDisposed(d){if(d&&d!==t.None)try{d[I]=!0}catch{}}markAsSingleton(d){}})}function u(I){return h?.trackDisposable(I),I}function k(I){h?.markAsDisposed(I)}function a(I,d){h?.setParent(I,d)}function c(I,d){if(h)for(const N of I)h.setParent(N,d)}function m(I){return h?.markAsSingleton(I),I}function f(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function s(I){if(j.Iterable.is(I)){const d=[];for(const N of I)if(N)try{N.dispose()}catch(M){d.push(M)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function n(I){for(const d of I)f(d)&&d.dispose();return[]}function g(...I){const d=w(()=>s(I));return c(I,d),d}function w(I){const d=u({dispose:(0,D.$db)(()=>{k(d),I()})});return d}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return a(d,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),a(d,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,u(this),a(this.q,this)}dispose(){k(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Uc=t;class o{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&a(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&a(d,null),d}}e.$Vc=o;class P{constructor(d){this.a=new o,this.b=!1,this.a.value=d}get value(){return this.a.value}set value(d){this.b||d===this.a.value||(this.a.value=d)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=P;class p{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=p;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(d){let N=d;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,k(this))},this}}e.$Yc=L;class v{constructor(){this.a=new Map}acquire(d,...N){let M=this.a.get(d);M||(M={counter:0,object:this.b(d,...N)},this.a.set(d,M));const{object:A}=M,q=(0,D.$db)(()=>{--M.counter===0&&(this.c(d,M.object),this.a.delete(d))});return M.counter++,{object:A,dispose:q}}}e.$Zc=v;class ${constructor(d){this.a=d}async acquire(d,...N){const M=this.a.acquire(d,...N);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(A){throw M.dispose(),A}}}e.$1c=$;class T{constructor(d){this.object=d}dispose(){}}e.$2c=T;function Q(I){const d=new i;try{I(d)}finally{d.dispose()}}class U{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,N,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(d)?.dispose(),this.a.set(d,N)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=U}),define(fe[45],de([0,1,25]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=C,e.$gm=j;const S=new b.$Dc(1e4);function C(r){return h(r,"NFC",S)}const D=new b.$Dc(1e4);function j(r){return h(r,"NFD",D)}const E=/[^\u0000-\u0080]/;function h(r,y,u){if(!r)return r;const k=u.get(r);if(k)return k;let a;return E.test(r)?a=r.normalize(y):a=r,u.set(r,a),a}e.$hm=function(){const r=/[\u0300-\u036f]/g;return function(y){return j(y).replace(r,"")}}()}),function(){function oe(C){const D=[];typeof C=="number"&&D.push("code/timeOrigin",C);function j(h){D.push(h,Date.now())}function E(){const h=[];for(let r=0;r<D.length;r+=2)h.push({name:D[r],startTime:D[r+1]});return h}return{mark:j,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const j of performance.getEntriesByType("mark"))D.push({name:j.name,startTime:Math.round(C+j.startTime)});return D}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function b(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=b(S))}(),define(fe[46],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const b=globalThis.performance&&typeof globalThis.performance.now=="function";class S{static create(D){return new S(D)}constructor(D){this.c=b&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=S}),define(fe[4],de([0,1,7,29,2,44,46]),function(oe,e,b,S,C,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=a;const E=!1,h=!1,r=!1;var y;(function(A){A.None=()=>C.$Uc.None;function q(ge){if(r){const{onDidAddListener:me}=ge,we=m.create();let be=0;ge.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),me?.()}}}function Z(ge,me){return W(ge,()=>{},0,void 0,!0,void 0,me)}A.defer=Z;function G(ge){return(me,we=null,be)=>{let ve=!1,Ce;return Ce=ge(Pe=>{if(!ve)return Ce?Ce.dispose():ve=!0,me.call(we,Pe)},null,be),ve&&Ce.dispose(),Ce}}A.once=G;function _(ge,me,we){return ee((be,ve=null,Ce)=>ge(Pe=>be.call(ve,me(Pe)),null,Ce),we)}A.map=_;function re(ge,me,we){return ee((be,ve=null,Ce)=>ge(Pe=>{me(Pe),be.call(ve,Pe)},null,Ce),we)}A.forEach=re;function le(ge,me,we){return ee((be,ve=null,Ce)=>ge(Pe=>me(Pe)&&be.call(ve,Pe),null,Ce),we)}A.filter=le;function X(ge){return ge}A.signal=X;function F(...ge){return(me,we=null,be)=>{const ve=(0,C.$Rc)(...ge.map(Ce=>Ce(Pe=>me.call(we,Pe))));return he(ve,be)}}A.any=F;function x(ge,me,we,be){let ve=we;return _(ge,Ce=>(ve=me(ve,Ce),ve),be)}A.reduce=x;function ee(ge,me){let we;const be={onWillAddFirstListener(){we=ge(ve.fire,ve)},onDidRemoveLastListener(){we?.dispose()}};me||q(be);const ve=new o(be);return me?.add(ve),ve.event}function he(ge,me){return me instanceof Array?me.push(ge):me&&me.add(ge),ge}function W(ge,me,we=100,be=!1,ve=!1,Ce,Pe){let Se,Le,Re,Me=0,Te;const We={leakWarningThreshold:Ce,onWillAddFirstListener(){Se=ge(Ve=>{Me++,Le=me(Le,Ve),be&&!Re&&(Ue.fire(Le),Le=void 0),Te=()=>{const He=Le;Le=void 0,Re=void 0,(!be||Me>1)&&Ue.fire(He),Me=0},typeof we=="number"?(clearTimeout(Re),Re=setTimeout(Te,we)):Re===void 0&&(Re=0,queueMicrotask(Te))})},onWillRemoveListener(){ve&&Me>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,Se.dispose()}};Pe||q(We);const Ue=new o(We);return Pe?.add(Ue),Ue.event}A.debounce=W;function ce(ge,me=0,we){return A.debounce(ge,(be,ve)=>be?(be.push(ve),be):[ve],me,void 0,!0,void 0,we)}A.accumulate=ce;function te(ge,me=(be,ve)=>be===ve,we){let be=!0,ve;return le(ge,Ce=>{const Pe=be||!me(Ce,ve);return be=!1,ve=Ce,Pe},we)}A.latch=te;function l(ge,me,we){return[A.filter(ge,me,we),A.filter(ge,be=>!me(be),we)]}A.split=l;function z(ge,me=!1,we=[],be){let ve=we.slice(),Ce=ge(Le=>{ve?ve.push(Le):Se.fire(Le)});be&&be.add(Ce);const Pe=()=>{ve?.forEach(Le=>Se.fire(Le)),ve=null},Se=new o({onWillAddFirstListener(){Ce||(Ce=ge(Le=>Se.fire(Le)),be&&be.add(Ce))},onDidAddFirstListener(){ve&&(me?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return be&&be.add(Se),Se.event}A.buffer=z;function ne(ge,me){return(be,ve,Ce)=>{const Pe=me(new Y);return ge(function(Se){const Le=Pe.evaluate(Se);Le!==R&&be.call(ve,Le)},void 0,Ce)}}A.chain=ne;const R=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(me){return this.f.push(me),this}forEach(me){return this.f.push(we=>(me(we),we)),this}filter(me){return this.f.push(we=>me(we)?we:R),this}reduce(me,we){let be=we;return this.f.push(ve=>(be=me(be,ve),be)),this}latch(me=(we,be)=>we===be){let we=!0,be;return this.f.push(ve=>{const Ce=we||!me(ve,be);return we=!1,be=ve,Ce?ve:R}),this}evaluate(me){for(const we of this.f)if(me=we(me),me===R)break;return me}}function H(ge,me,we=be=>be){const be=(...Se)=>Pe.fire(we(...Se)),ve=()=>ge.on(me,be),Ce=()=>ge.removeListener(me,be),Pe=new o({onWillAddFirstListener:ve,onDidRemoveLastListener:Ce});return Pe.event}A.fromNodeEventEmitter=H;function V(ge,me,we=be=>be){const be=(...Se)=>Pe.fire(we(...Se)),ve=()=>ge.addEventListener(me,be),Ce=()=>ge.removeEventListener(me,be),Pe=new o({onWillAddFirstListener:ve,onDidRemoveLastListener:Ce});return Pe.event}A.fromDOMEventEmitter=V;function O(ge){return new Promise(me=>G(ge)(me))}A.toPromise=O;function J(ge){const me=new o;return ge.then(we=>{me.fire(we)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}A.fromPromise=J;function ie(ge,me,we){return me(we),ge(be=>me(be))}A.runAndSubscribe=ie;class ae{constructor(me,we){this._observable=me,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};we||q(be),this.emitter=new o(be),we&&we.add(this.emitter)}beginUpdate(me){this.f++}handlePossibleChange(me){}handleChange(me,we){this.g=!0}endUpdate(me){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(ge,me){return new ae(ge,me).emitter.event}A.fromObservable=$e;function Ee(ge){return(me,we,be)=>{let ve=0,Ce=!1;const Pe={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(ge.reportChanges(),Ce&&(Ce=!1,me.call(we)))},handlePossibleChange(){},handleChange(){Ce=!0}};ge.addObserver(Pe),ge.reportChanges();const Se={dispose(){ge.removeObserver(Pe)}};return be instanceof C.$Tc?be.add(Se):Array.isArray(be)&&be.push(Se),Se}}A.fromObservableLight=Ee})(y||(e.Event=y={}));class u{static{this.all=new Set}static{this.f=0}constructor(q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${q}_${u.f++}`,u.all.add(this)}start(q){this.g=new j.$be,this.listenerCount=q}stop(){if(this.g){const q=this.g.elapsed();this.durations.push(q),this.elapsedOverall+=q,this.invocationCount+=1,this.g=void 0}}}e.$de=u;let k=-1;function a(A){const q=k;return k=A,{dispose(){k=q}}}class c{constructor(q,Z,G=Math.random().toString(18).slice(2,5)){this.h=q,this.threshold=Z,this.name=G,this.g=0}dispose(){this.f?.clear()}check(q,Z){const G=this.threshold;if(G<=0||Z<G)return;this.f||(this.f=new Map);const _=this.f.get(q.value)||0;if(this.f.set(q.value,_+1),this.g-=1,this.g<=0){this.g=G*.5;const[re,le]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${Z} listeners already. MOST frequent listener (${le}):`;console.warn(X),console.warn(re);const F=new f(X,re);this.h(F)}return()=>{const re=this.f.get(q.value)||0;this.f.set(q.value,re-1)}}getMostFrequentStack(){if(!this.f)return;let q,Z=0;for(const[G,_]of this.f)(!q||Z<_)&&(q=[G,_],Z=_);return q}}class m{static create(){const q=new Error;return new m(q.stack??"")}constructor(q){this.value=q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(q,Z){super(q),this.name="ListenerLeakError",this.stack=Z}}e.$fe=f;class s extends Error{constructor(q,Z){super(q),this.name="ListenerRefusalError",this.stack=Z}}e.$ge=s;let n=0;class g{constructor(q){this.value=q,this.id=n++}}const w=2,i=(A,q)=>{if(A instanceof g)q(A);else for(let Z=0;Z<A.length;Z++){const G=A[Z];G&&q(G)}},t=E?new FinalizationRegistry(A=>{typeof A=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(A))}):void 0;class o{constructor(q){this.w=0,this.f=q,this.g=k>0||this.f?.leakWarningThreshold?new c(q?.onListenerError??b.$1,this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const q=this.t;queueMicrotask(()=>{i(q,Z=>Z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(q,Z,G)=>{if(this.g&&this.w>this.g.threshold*3){const F=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(F);const x=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new s(`${F}. HINT: Stack shows most frequent listener (${x[1]}-times)`,x[0]);return(this.f?.onListenerError||b.$1)(ee),C.$Uc.None}if(this.m)return C.$Uc.None;Z&&(q=q.bind(Z));const _=new g(q);let re,le;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(_.stack=m.create(),re=this.g.check(_.stack,this.w+1)),h&&(_.stack=le??m.create()),this.t?this.t instanceof g?(this.u??=new p,this.t=[this.t,_]):this.t.push(_):(this.f?.onWillAddFirstListener?.(this),this.t=_,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,C.$Sc)(()=>{t?.unregister(X),re?.(),this.x(_)});if(G instanceof C.$Tc?G.add(X):Array.isArray(G)&&G.push(X),t){const F=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(X,F,X)}return X},this.q}x(q){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const Z=this.t,G=Z.indexOf(q);if(G===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,Z[G]=void 0;const _=this.u.current===this;if(this.w*w<=Z.length){let re=0;for(let le=0;le<Z.length;le++)Z[le]?Z[re++]=Z[le]:_&&(this.u.end--,re<this.u.i&&this.u.i--);Z.length=re}}y(q,Z){if(!q)return;const G=this.f?.onListenerError||b.$1;if(!G){q.value(Z);return}try{q.value(Z)}catch(_){G(_)}}z(q){const Z=q.current.t;for(;q.i<q.end;)this.y(Z[q.i++],q.value);q.reset()}fire(q){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,q);else{const Z=this.u;Z.enqueue(this,q,this.t.length),this.z(Z)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=o;const P=()=>new p;e.$ie=P;class p{constructor(){this.i=-1,this.end=0}enqueue(q,Z,G){this.i=0,this.end=G,this.current=q,this.value=Z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends o{async fireAsync(q,Z,G){if(this.t)for(this.h||(this.h=new D.$5c),i(this.t,_=>this.h.push([_.value,q]));this.h.size>0&&!Z.isCancellationRequested;){const[_,re]=this.h.shift(),le=[],X={...re,token:Z,waitUntil:F=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");G&&(F=G(F,_)),le.push(F)}};try{_(X)}catch(F){(0,b.$1)(F);continue}Object.freeze(le),await Promise.allSettled(le).then(F=>{for(const x of F)x.status==="rejected"&&(0,b.$1)(x.reason)})}}}e.$je=L;class v extends o{get isPaused(){return this.h!==0}constructor(q){super(q),this.h=0,this.s=new D.$5c,this.A=q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const q=Array.from(this.s);this.s.clear(),super.fire(this.A(q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(q){this.w&&(this.h!==0?this.s.push(q):super.fire(q))}}e.$ke=v;class $ extends v{constructor(q){super(q),this.k=q.delay??100}fire(q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(q)}}e.$le=$;class T extends o{constructor(q){super(q),this.h=[],this.k=q?.merge}fire(q){this.hasListeners()&&(this.h.push(q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Z=>super.fire(Z)),this.h=[]}))}}e.$me=T;class Q{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(q){const Z={event:q,listener:null};this.h.push(Z),this.g&&this.m(Z);const G=()=>{this.g&&this.o(Z);const _=this.h.indexOf(Z);this.h.splice(_,1)};return(0,C.$Sc)((0,S.$db)(G))}j(){this.g=!0,this.h.forEach(q=>this.m(q))}k(){this.g=!1,this.h.forEach(q=>this.o(q))}m(q){q.listener=q.event(Z=>this.f.fire(Z))}o(q){q.listener?.dispose(),q.listener=null}dispose(){this.f.dispose();for(const q of this.h)q.listener?.dispose();this.h=[]}}e.$ne=Q;class U{constructor(q,Z,G,_){this.f=new C.$Tc;const re=this.f.add(new Q),le=this.f.add(new C.$4c);function X(F){le.set(F,re.add(_(F)))}for(const F of q)X(F);this.f.add(Z(F=>{X(F)})),this.f.add(G(F=>{le.deleteAndDispose(F)})),this.event=re.event}dispose(){this.f.dispose()}}e.$oe=U;class I{constructor(){this.f=[]}wrapEvent(q,Z,G){return(_,re,le)=>q(X=>{const F=this.f[this.f.length-1];if(!Z){F?F.buffers.push(()=>_.call(re,X)):_.call(re,X);return}const x=F;if(!x){_.call(re,Z(G,X));return}x.items??=[],x.items.push(X),x.buffers.length===0&&F.buffers.push(()=>{x.reducedResult??=G?x.items.reduce(Z,G):x.items.reduce(Z),_.call(re,x.reducedResult)})},void 0,le)}bufferEvents(q){const Z={buffers:new Array};this.f.push(Z);const G=q();return this.f.pop(),Z.buffers.forEach(_=>_()),G}}e.$pe=I;class d{constructor(){this.f=!1,this.g=y.None,this.h=C.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(q){this.g=q,this.f&&(this.h.dispose(),this.h=q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=d;class N{static const(q){return new M(q)}constructor(q){this.g=q,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(q){q!==this.g&&(this.g=q,this.f.fire(void 0))}}e.$re=N;class M{constructor(q){this.value=q,this.onDidChange=y.None}}}),define(fe[17],de([0,1,4]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=E;const S=Object.freeze(function(h,r){const y=setTimeout(h.bind(r),0);return{dispose(){clearTimeout(y)}}});var C;(function(h){function r(y){return y===h.None||y===h.Cancelled||y instanceof D?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}h.isCancellationToken=r,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(C||(e.CancellationToken=C={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new b.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=C.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=C.None}}e.$se=j;function E(h){const r=new j;return h.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],de([0,1,17]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=C;class S{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new b.$se,r=this.b(h.token);return this.a={promise:r,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$5e=S;function C(E){return E}class D{constructor(h,r){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=C):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);return this.b!==r&&(this.b=r,this.a=this.c(h)),this.a}}e.$7e=D;class j{get cachedValues(){return this.a}constructor(h,r){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=C):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);if(this.b.has(r))return this.b.get(r);const y=this.c(h);return this.a.set(h,y),this.b.set(r,y),y}}e.$8e=j}),define(fe[48],de([0,1,7,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=C,e.$ve=D,e.$we=j,e.$xe=E,e.$ye=r,e.$ze=y,e.$Ae=u,e.$Be=k,e.$Ce=a,e.$De=c,e.$Ee=m,e.$Fe=f,e.$Ge=s,e.$He=n,e.$Ie=g;function C(w){const i=w;return i?typeof i.read=="function":!1}function D(w){const i=w;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(w){const i=w;return i?D(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function E(w,i){return new h(w,i)}class h{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,b.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let o;switch(i){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const P=o.indexOf(t);P>=0&&o.splice(P,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(w,i){const t=[];let o;for(;(o=w.read())!==null;)t.push(o);return i(t)}function y(w,i,t){const o=[];let P;for(;(P=w.read())!==null&&o.length<t;)o.push(P);return P===null&&o.length>0?i(o):{read:()=>{if(o.length>0)return o.shift();if(typeof P<"u"){const p=P;return P=void 0,p}return w.read()}}}function u(w,i){return new Promise((t,o)=>{const P=[];k(w,{onData:p=>{i&&P.push(p)},onError:p=>{i?o(p):t(void 0)},onEnd:()=>{t(i?i(P):void 0)}})})}function k(w,i,t){w.on("error",o=>{t?.isCancellationRequested||i.onError(o)}),w.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),w.on("data",o=>{t?.isCancellationRequested||i.onData(o)})}function a(w,i){return new Promise((t,o)=>{const P=new S.$Tc,p=[],L=T=>{if(p.push(T),p.length>i)return P.dispose(),w.pause(),t({stream:w,buffer:p,ended:!1})},v=T=>(P.dispose(),o(T)),$=()=>(P.dispose(),t({stream:w,buffer:p,ended:!0}));P.add((0,S.$Sc)(()=>w.removeListener("error",v))),w.on("error",v),P.add((0,S.$Sc)(()=>w.removeListener("end",$))),w.on("end",$),P.add((0,S.$Sc)(()=>w.removeListener("data",L))),w.on("data",L)})}function c(w,i){const t=E(i);return t.end(w),t}function m(){const w=E(()=>{throw new Error("not supported")});return w.end(),w}function f(w){let i=!1;return{read:()=>i?null:(i=!0,w)}}function s(w,i,t){const o=E(t);return k(w,{onData:P=>o.write(i.data(P)),onError:P=>o.error(i.error?i.error(P):P),onEnd:()=>o.end()}),o}function n(w,i,t){let o=!1;return{read:()=>{const P=i.read();return o?P:(o=!0,P!==null?t([w,P]):w)}}}function g(w,i,t){let o=!1;const P=E(t);return k(i,{onData:p=>o?P.write(p):(o=!0,P.write(t([w,p]))),onError:p=>P.error(p),onEnd:()=>{o||(o=!0,P.write(w)),P.end()}}),P}}),define(fe[18],de([0,1,22,48]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=r,e.$Le=y,e.$Me=u,e.$Ne=k,e.$Oe=a,e.$Pe=c,e.$Qe=m,e.$Re=f,e.$Se=s,e.$Te=n,e.$Ue=g,e.$Ve=w,e.$We=i,e.$Xe=t,e.$Ye=o,e.$Ze=P,e.$1e=p,e.$2e=L,e.$3e=v,e.$4e=Q;const C=typeof Buffer<"u",D=new b.$V(()=>new Uint8Array(256));let j,E;class h{static alloc(I){return C?new h(Buffer.allocUnsafe(I)):new h(new Uint8Array(I))}static wrap(I){return C&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new h(I)}static fromString(I,d){return!(d?.dontUseNodeBuffer||!1)&&C?new h(Buffer.from(I)):(j||(j=new TextEncoder),new h(j.encode(I)))}static fromByteArray(I){const d=h.alloc(I.length);for(let N=0,M=I.length;N<M;N++)d.buffer[N]=I[N];return d}static concat(I,d){if(typeof d>"u"){d=0;for(let A=0,q=I.length;A<q;A++)d+=I[A].byteLength}const N=h.alloc(d);let M=0;for(let A=0,q=I.length;A<q;A++){const Z=I[A];N.set(Z,M),M+=Z.byteLength}return N}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=h.alloc(this.byteLength);return I.set(this),I}toString(){return C?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(I,d){return new h(this.buffer.subarray(I,d))}set(I,d){if(I instanceof h)this.buffer.set(I.buffer,d);else if(I instanceof Uint8Array)this.buffer.set(I,d);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),d);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return k(this.buffer,I)}writeUInt32BE(I,d){a(this.buffer,I,d)}readUInt32LE(I){return c(this.buffer,I)}writeUInt32LE(I,d){m(this.buffer,I,d)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,d){s(this.buffer,I,d)}indexOf(I,d=0){return r(this.buffer,I instanceof h?I.buffer:I,d)}}e.$Je=h;function r(U,I,d=0){const N=I.byteLength,M=U.byteLength;if(N===0)return 0;if(N===1)return U.indexOf(I[0]);if(N>M-d)return-1;const A=D.value;A.fill(I.length);for(let _=0;_<I.length;_++)A[I[_]]=I.length-_-1;let q=d+I.length-1,Z=q,G=-1;for(;q<M;)if(U[q]===I[Z]){if(Z===0){G=q;break}q--,Z--}else q+=Math.max(I.length-Z,A[U[q]]),Z=I.length-1;return G}function y(U,I){return U[I+0]<<0>>>0|U[I+1]<<8>>>0}function u(U,I,d){U[d+0]=I&255,I=I>>>8,U[d+1]=I&255}function k(U,I){return U[I]*2**24+U[I+1]*2**16+U[I+2]*2**8+U[I+3]}function a(U,I,d){U[d+3]=I,I=I>>>8,U[d+2]=I,I=I>>>8,U[d+1]=I,I=I>>>8,U[d]=I}function c(U,I){return U[I+0]<<0>>>0|U[I+1]<<8>>>0|U[I+2]<<16>>>0|U[I+3]<<24>>>0}function m(U,I,d){U[d+0]=I&255,I=I>>>8,U[d+1]=I&255,I=I>>>8,U[d+2]=I&255,I=I>>>8,U[d+3]=I&255}function f(U,I){return U[I]}function s(U,I,d){U[d]=I}function n(U){return S.$ye(U,I=>h.concat(I))}function g(U){return S.$Fe(U)}function w(U){return S.$Ae(U,I=>h.concat(I))}async function i(U){return U.ended?h.concat(U.buffer):h.concat([...U.buffer,await w(U.stream)])}function t(U){return S.$De(U,I=>h.concat(I))}function o(U){return S.$Ge(U,{data:I=>typeof I=="string"?h.fromString(I):h.wrap(I)},I=>h.concat(I))}function P(U){return S.$xe(I=>h.concat(I),U)}function p(U,I){return S.$He(U,I,d=>h.concat(d))}function L(U,I){return S.$Ie(U,I,d=>h.concat(d))}function v(U){let I=0,d=0,N=0;const M=new Uint8Array(Math.floor(U.length/4*3)),A=Z=>{switch(d){case 3:M[N++]=I|Z,d=0;break;case 2:M[N++]=I|Z>>>2,I=Z<<6,d=3;break;case 1:M[N++]=I|Z>>>4,I=Z<<4,d=2;break;default:I=Z<<2,d=1}};for(let Z=0;Z<U.length;Z++){const G=U.charCodeAt(Z);if(G>=65&&G<=90)A(G-65);else if(G>=97&&G<=122)A(G-97+26);else if(G>=48&&G<=57)A(G-48+52);else if(G===43||G===45)A(62);else if(G===47||G===95)A(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${U[Z]}`)}}const q=N;for(;d>0;)A(0);return h.wrap(M).slice(0,q)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Q({buffer:U},I=!0,d=!1){const N=d?T:$;let M="";const A=U.byteLength%3;let q=0;for(;q<U.byteLength-A;q+=3){const Z=U[q+0],G=U[q+1],_=U[q+2];M+=N[Z>>>2],M+=N[(Z<<4|G>>>4)&63],M+=N[(G<<2|_>>>6)&63],M+=N[_&63]}if(A===1){const Z=U[q+0];M+=N[Z>>>2],M+=N[Z<<4&63],I&&(M+="==")}else if(A===2){const Z=U[q+0],G=U[q+1];M+=N[Z>>>2],M+=N[(Z<<4|G>>>4)&63],M+=N[G<<2&63],I&&(M+="=")}return M}}),define(fe[9],de([0,1,47,22]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=C,e.$_e=j,e.$af=h,e.$bf=r,e.$cf=y,e.$df=u,e.$ef=k,e.$ff=a,e.$gf=c,e.$hf=m,e.$if=f,e.$jf=s,e.$kf=n,e.$lf=g,e.$mf=w,e.$nf=i,e.$of=t,e.$pf=o,e.$qf=P,e.$rf=p,e.$sf=L,e.$tf=v,e.$uf=$,e.$vf=T,e.$wf=Q,e.$xf=U,e.$yf=I,e.$zf=d,e.$Af=N,e.$Bf=M,e.$Cf=A,e.$Df=q,e.$Ef=Z,e.$Ff=G,e.$Gf=_,e.$Hf=re,e.$If=le,e.$Lf=ee,e.$Mf=he,e.$Nf=W,e.$Of=ce,e.$Pf=z,e.$Qf=R,e.$Sf=Y,e.$Tf=H,e.$Uf=V,e.$Vf=O,e.$Wf=ie,e.$Xf=ae,e.$Yf=Ee,e.$1f=ge,e.$2f=me,e.$3f=we,e.$4f=be,e.$5f=ve,e.$6f=Ce,e.$7f=Pe,e.$8f=Se,e.$9f=We;function C(B){return!B||typeof B!="string"?!0:B.trim().length===0}const D=/{(\d+)}/g;function j(B,...K){return K.length===0?B:B.replace(D,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=K.length?se:K[ye]})}const E=/{([^}]+)}/g;function h(B,K){return Object.keys(K).length===0?B:B.replace(E,(se,ue)=>K[ue]??se)}function r(B){return B.replace(/[<>"'&]/g,K=>{switch(K){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return K})}function y(B){return B.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}function u(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(B,K){let se=0,ue=B.indexOf(K);for(;ue!==-1;)se++,ue=B.indexOf(K,ue+K.length);return se}function a(B,K,se="\u2026"){return B.length<=K?B:`${B.substr(0,K)}${se}`}function c(B,K,se="\u2026"){if(B.length<=K)return B;const ue=Math.ceil(K/2)-se.length/2,ye=Math.floor(K/2)-se.length/2;return`${B.substr(0,ue)}${se}${B.substr(B.length-ye)}`}function m(B,K=" "){const se=f(B,K);return s(se,K)}function f(B,K){if(!B||!K)return B;const se=K.length;if(se===0||B.length===0)return B;let ue=0;for(;B.indexOf(K,ue)===ue;)ue=ue+se;return B.substring(ue)}function s(B,K){if(!B||!K)return B;const se=K.length,ue=B.length;if(se===0||ue===0)return B;let ye=ue,ke=-1;for(;ke=B.lastIndexOf(K,ye-1),!(ke===-1||ke+se!==ye);){if(ke===0)return"";ye=ke}return B.substring(0,ye)}function n(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(B){return B.replace(/\*/g,"")}function w(B,K,se={}){if(!B)throw new Error("Cannot create regex from empty string");K||(B=u(B)),se.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(B,ue)}function i(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}function t(B){return B.split(/\r\n|\r|\n/)}function o(B){const K=[],se=B.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)K.push(se[2*ue]+(se[2*ue+1]??""));return K}function P(B){for(let K=0,se=B.length;K<se;K++){const ue=B.charCodeAt(K);if(ue!==32&&ue!==9)return K}return-1}function p(B,K=0,se=B.length){for(let ue=K;ue<se;ue++){const ye=B.charCodeAt(ue);if(ye!==32&&ye!==9)return B.substring(K,ue)}return B.substring(K,se)}function L(B,K=B.length-1){for(let se=K;se>=0;se--){const ue=B.charCodeAt(se);if(ue!==32&&ue!==9)return se}return-1}function v(B,K,se){const ue=[];let ye=0;for(const ke of B.matchAll(K)){if(ue.push(B.slice(ye,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ye=ke.index+ke[0].length,ue.push(se(ke[0],...ke.slice(1),ke.index,B,ke.groups))}return ue.push(B.slice(ye)),Promise.all(ue).then(ke=>ke.join(""))}function $(B,K){return B<K?-1:B>K?1:0}function T(B,K,se=0,ue=B.length,ye=0,ke=K.length){for(;se<ue&&ye<ke;se++,ye++){const Ie=B.charCodeAt(se),Oe=K.charCodeAt(ye);if(Ie<Oe)return-1;if(Ie>Oe)return 1}const Ae=ue-se,Ne=ke-ye;return Ae<Ne?-1:Ae>Ne?1:0}function Q(B,K){return U(B,K,0,B.length,0,K.length)}function U(B,K,se=0,ue=B.length,ye=0,ke=K.length){for(;se<ue&&ye<ke;se++,ye++){let Ie=B.charCodeAt(se),Oe=K.charCodeAt(ye);if(Ie===Oe)continue;if(Ie>=128||Oe>=128)return T(B.toLowerCase(),K.toLowerCase(),se,ue,ye,ke);d(Ie)&&(Ie-=32),d(Oe)&&(Oe-=32);const De=Ie-Oe;if(De!==0)return De}const Ae=ue-se,Ne=ke-ye;return Ae<Ne?-1:Ae>Ne?1:0}function I(B){return B>=48&&B<=57}function d(B){return B>=97&&B<=122}function N(B){return B>=65&&B<=90}function M(B,K){return B.length===K.length&&U(B,K)===0}function A(B,K){const se=K.length;return K.length>B.length?!1:U(B,K,0,se)===0}function q(B,K){const se=Math.min(B.length,K.length);let ue;for(ue=0;ue<se;ue++)if(B.charCodeAt(ue)!==K.charCodeAt(ue))return ue;return se}function Z(B,K){const se=Math.min(B.length,K.length);let ue;const ye=B.length-1,ke=K.length-1;for(ue=0;ue<se;ue++)if(B.charCodeAt(ye-ue)!==K.charCodeAt(ke-ue))return ue;return se}function G(B){return 55296<=B&&B<=56319}function _(B){return 56320<=B&&B<=57343}function re(B,K){return(B-55296<<10)+(K-56320)+65536}function le(B,K,se){const ue=B.charCodeAt(se);if(G(ue)&&se+1<K){const ye=B.charCodeAt(se+1);if(_(ye))return re(ue,ye)}return ue}function X(B,K){const se=B.charCodeAt(K-1);if(_(se)&&K>1){const ue=B.charCodeAt(K-2);if(G(ue))return re(ue,se)}return se}class F{get offset(){return this.e}constructor(K,se=0){this.c=K,this.d=K.length,this.e=se}setOffset(K){this.e=K}prevCodePoint(){const K=X(this.c,this.e);return this.e-=K>=65536?2:1,K}nextCodePoint(){const K=le(this.c,this.d,this.e);return this.e+=K>=65536?2:1,K}eol(){return this.e>=this.d}}e.$Jf=F;class x{get offset(){return this.c.offset}constructor(K,se=0){this.c=new F(K,se)}nextGraphemeLength(){const K=Me.getInstance(),se=this.c,ue=se.offset;let ye=K.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const ke=se.offset,Ae=K.getGraphemeBreakType(se.nextCodePoint());if(Le(ye,Ae)){se.setOffset(ke);break}ye=Ae}return se.offset-ue}prevGraphemeLength(){const K=Me.getInstance(),se=this.c,ue=se.offset;let ye=K.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const ke=se.offset,Ae=K.getGraphemeBreakType(se.prevCodePoint());if(Le(Ae,ye)){se.setOffset(ke);break}ye=Ae}return ue-se.offset}eol(){return this.c.eol()}}e.$Kf=x;function ee(B,K){return new x(B,K).nextGraphemeLength()}function he(B,K){return new x(B,K).prevGraphemeLength()}function W(B,K){K>0&&_(B.charCodeAt(K))&&K--;const se=K+ee(B,K);return[se-he(B,se),se]}function ce(B){const K=new x(B);let se=0;for(;!K.eol();)se++,K.nextGraphemeLength();return se}let te;function l(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(B){return te||(te=l()),te.test(B)}const ne=/^[\t\n\r\x20-\x7E]*$/;function R(B){return ne.test(B)}e.$Rf=/[\u2028\u2029]/;function Y(B){return e.$Rf.test(B)}function H(B){return B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}function V(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129008||B>=129280&&B<=129535||B>=129648&&B<=129782}function O(B,K,se=""){const ue=B.trimStart();if(ue.length<K)return ue;const ye=/\b/g;let ke=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<K);)ke=ye.lastIndex,ye.lastIndex+=1;return ke===0?ue:se+ue.substring(ke).trimStart()}const J=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ie(B){let K=0;for(const se of B.matchAll(J))K!==se.index&&(yield{isCode:!1,str:B.substring(K,se.index)}),yield{isCode:!0,str:se[0]},K=se.index+se[0].length;K!==B.length&&(yield{isCode:!1,str:B.substring(K)})}function ae(B){return B&&(B=B.replace(J,"")),B}const $e=/\\\[.*?\\\]/g;function Ee(B){return ae(B).replace($e,"")}e.$Zf="\uFEFF";function ge(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}function me(B){return ge(B)?B.substr(1):B}function we(B,K){if(!B||!K||B.length<K.length)return!1;const se=K.length,ue=B.toLowerCase();let ye=0,ke=-1;for(;ye<se;){const Ae=ue.indexOf(K[ye],ke+1);if(Ae<0)return!1;ke=Ae,ye++}return!0}function be(B,K=!1){return B?(K&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}function ve(B){return B.charAt(0).toUpperCase()+B.slice(1)}function Ce(B,K=1){if(K===0)return"";let se=-1;do se=B.indexOf(`
`,se+1),K--;while(K>0&&se>=0);return se===-1?B:(B[se-1]==="\r"&&se--,B.substr(0,se))}function Pe(B){return B=B%(2*26),B<26?String.fromCharCode(97+B):String.fromCharCode(65+B-26)}function Se(B){return Me.getInstance().getGraphemeBreakType(B)}function Le(B,K){return B===0?K!==5&&K!==7:B===2&&K===3?!1:B===4||B===2||B===3||K===4||K===2||K===3?!0:!(B===8&&(K===8||K===9||K===11||K===12)||(B===11||B===9)&&(K===9||K===10)||(B===12||B===10)&&K===10||K===5||K===13||K===7||B===1||B===13&&K===14||B===6&&K===6)}var Re;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Te()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(K<se[3*ye])ye=2*ye;else if(K>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(B,K){if(B===0)return 0;const se=Ue(B,K);if(se!==void 0)return se;const ue=new F(K,B);return ue.prevCodePoint(),ue.offset}function Ue(B,K){const se=new F(K,B);let ue=se.prevCodePoint();for(;Ve(ue)||ue===65039||ue===8419;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!V(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===8205&&(ye=se.offset),ye}function Ve(B){return 127995<=B&&B<=127999}var He;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$0f="\xA0";class Be{static{this.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new b.$7e({getCacheKey:JSON.stringify},K=>{function se(De){const Fe=new Map;for(let je=0;je<De.length;je+=2)Fe.set(De[je],De[je+1]);return Fe}function ue(De,Fe){const je=new Map(De);for(const[Ge,Xe]of Fe)je.set(Ge,Xe);return je}function ye(De,Fe){if(!De)return Fe;const je=new Map;for(const[Ge,Xe]of De)Fe.has(Ge)&&je.set(Ge,Xe);return je}const ke=this.c.value;let Ae=K.filter(De=>!De.startsWith("_")&&De in ke);Ae.length===0&&(Ae=["_default"]);let Ne;for(const De of Ae){const Fe=se(ke[De]);Ne=ye(Ne,Fe)}const Ie=se(ke._common),Oe=ue(Ie,Ne);return new Be(Oe)})}static getInstance(K){return Be.d.get(Array.from(K))}static{this.e=new S.$V(()=>Object.keys(Be.c.value).filter(K=>!K.startsWith("_")))}static getLocales(){return Be.e.value}constructor(K){this.f=K}isAmbiguous(K){return this.f.has(K)}containsAmbiguousCharacter(K){for(let se=0;se<K.length;se++){const ue=K.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(K){return this.f.get(K)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Be;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(K){return qe.e().has(K)}static containsInvisibleCharacter(K){for(let se=0;se<K.length;se++){const ue=K.codePointAt(se);if(typeof ue=="number"&&qe.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return qe.e()}}e.$_f=qe}),define(fe[49],de([0,1,9]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=S,e.$pj=C,e.$qj=D,e.$rj=E,e.$tj=m;function S(s){return C(s,0)}function C(s,n){switch(typeof s){case"object":return s===null?D(349,n):Array.isArray(s)?h(s,n):r(s,n);case"string":return E(s,n);case"boolean":return j(s,n);case"number":return D(s,n);case"undefined":return D(937,n);default:return D(617,n)}}function D(s,n){return(n<<5)-n+s|0}function j(s,n){return D(s?433:863,n)}function E(s,n){n=D(149417,n);for(let g=0,w=s.length;g<w;g++)n=D(s.charCodeAt(g),n);return n}function h(s,n){return n=D(104579,n),s.reduce((g,w)=>C(w,g),n)}function r(s,n){return n=D(181387,n),Object.keys(s).sort().reduce((g,w)=>(g=E(w,g),C(s[w],g)),n)}class y{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=C(n,this.g),this.g}}e.$sj=y;var u;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function k(s,n,g=32){const w=g-n,i=~((1<<w)-1);return(s<<n|(i&s)>>>w)>>>0}function a(s,n=0,g=s.byteLength,w=0){for(let i=0;i<g;i++)s[n+i]=w}function c(s,n,g="0"){for(;s.length<n;)s=g+s;return s}function m(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(g=>g.toString(16).padStart(2,"0")).join(""):c((s>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const g=n.length;if(g===0)return;const w=this.p;let i=this.r,t=this.u,o,P;for(t!==0?(o=t,P=-1,t=0):(o=n.charCodeAt(0),P=0);;){let p=o;if(b.$Ff(o))if(P+1<g){const L=n.charCodeAt(P+1);b.$Gf(L)?(P++,p=b.$Hf(o,L)):p=65533}else{t=o;break}else b.$Gf(o)&&(p=65533);if(i=this.w(w,i,p),P++,P<g)o=n.charCodeAt(P);else break}this.r=i,this.u=t}w(n,g,w){return w<128?n[g++]=w:w<2048?(n[g++]=192|(w&1984)>>>6,n[g++]=128|(w&63)>>>0):w<65536?(n[g++]=224|(w&61440)>>>12,n[g++]=128|(w&4032)>>>6,n[g++]=128|(w&63)>>>0):(n[g++]=240|(w&1835008)>>>18,n[g++]=128|(w&258048)>>>12,n[g++]=128|(w&4032)>>>6,n[g++]=128|(w&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,g=this.q;for(let $=0;$<64;$+=4)n.setUint32($,g.getUint32($,!1),!1);for(let $=64;$<320;$+=4)n.setUint32($,k(n.getUint32($-12,!1)^n.getUint32($-32,!1)^n.getUint32($-56,!1)^n.getUint32($-64,!1),1),!1);let w=this.h,i=this.l,t=this.m,o=this.n,P=this.o,p,L,v;for(let $=0;$<80;$++)$<20?(p=i&t|~i&o,L=1518500249):$<40?(p=i^t^o,L=1859775393):$<60?(p=i&t|i&o|t&o,L=2400959708):(p=i^t^o,L=3395469782),v=k(w,5)+p+P+L+n.getUint32($*4,!1)&4294967295,P=o,o=t,t=k(i,30),i=w,w=v;this.h=this.h+w&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+P&4294967295}}e.$uj=f}),define(fe[50],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(fe[51],de([0,1,16,9]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class C{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const c=a.charCodeAt(0),m=this.b.charCodeAt(this.c);return c-m}value(){return this.b[this.c]}}e.$Ci=C;class D{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,S.$vf)(a,this.b,0,a.length,this.c,this.d):(0,S.$xf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=D;class j{constructor(a=!0,c=!0){this.f=a,this.g=c}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let c=a.length-1;c>=0;c--,this.c--){const m=this.b.charCodeAt(c);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,S.$vf)(a,this.b,0,a.length,this.d,this.e):(0,S.$xf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=j;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(a,c){this.f=a,this.g=c,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,S.$wf)(a,this.c.scheme);if(this.d[this.e]===2)return(0,S.$wf)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,S.$uf)(a,this.c.query);if(this.d[this.e]===5)return(0,S.$uf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=h;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(y||(y={}));class u{static forUris(a=()=>!1,c=()=>!1){return new u(new h(a,c))}static forPaths(a=!1){return new u(new j(void 0,!a))}static forStrings(){return new u(new C)}static forConfigKeys(){return new u(new D)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,c){if(c){const m=c.slice(0);(0,b.$Wb)(m);for(const f of m)this.set(f,a)}else{const m=a.slice(0);(0,b.$Wb)(m);for(const f of m)this.set(f[0],f[1])}}set(a,c){const m=this.b.reset(a);let f;this.c||(this.c=new r,this.c.segment=m.value());const s=[];for(f=this.c;;){const g=m.cmp(f.segment);if(g>0)f.left||(f.left=new r,f.left.segment=m.value()),s.push([-1,f]),f=f.left;else if(g<0)f.right||(f.right=new r,f.right.segment=m.value()),s.push([1,f]),f=f.right;else if(m.hasNext())m.next(),f.mid||(f.mid=new r,f.mid.segment=m.value()),s.push([0,f]),f=f.mid;else break}const n=f.value;f.value=c,f.key=a;for(let g=s.length-1;g>=0;g--){const w=s[g][1];w.updateHeight();const i=w.balanceFactor();if(i<-1||i>1){const t=s[g][0],o=s[g+1][0];if(t===1&&o===1)s[g][1]=w.rotateLeft();else if(t===-1&&o===-1)s[g][1]=w.rotateRight();else if(t===1&&o===-1)w.right=s[g+1][1]=s[g+1][1].rotateRight(),s[g][1]=w.rotateLeft();else if(t===-1&&o===1)w.left=s[g+1][1]=s[g+1][1].rotateLeft(),s[g][1]=w.rotateRight();else throw new Error;if(g>0)switch(s[g-1][0]){case-1:s[g-1][1].left=s[g][1];break;case 1:s[g-1][1].right=s[g][1];break;case 0:s[g-1][1].mid=s[g][1];break}else this.c=s[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const c=this.b.reset(a);let m=this.c;for(;m;){const f=c.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else break}return m}has(a){const c=this.d(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,c){const m=this.b.reset(a),f=[];let s=this.c;for(;s;){const n=m.cmp(s.segment);if(n>0)f.push([-1,s]),s=s.left;else if(n<0)f.push([1,s]),s=s.right;else if(m.hasNext())m.next(),f.push([0,s]),s=s.mid;else break}if(s){if(c?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:g,value:w,segment:i}=n;this.e(n.key,!1),s.key=g,s.value=w,s.segment=i}}else{const n=s.left??s.right;if(f.length>0){const[g,w]=f[f.length-1];switch(g){case-1:w.left=n;break;case 0:w.mid=n;break;case 1:w.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const g=f[n][1];g.updateHeight();const w=g.balanceFactor();if(w>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),f[n][1]=g.rotateLeft()):w<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),f[n][1]=g.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this.b.reset(a);let m=this.c,f;for(;m;){const s=c.cmp(m.segment);if(s>0)m=m.left;else if(s<0)m=m.right;else if(c.hasNext())c.next(),f=m.value||f,m=m.mid;else break}return m&&m.value||f}findSuperstr(a){return this.g(a,!1)}g(a,c){const m=this.b.reset(a);let f=this.c;for(;f;){const s=m.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else return f.mid?this.h(f.mid):c?f.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[c,m]of this)a(m,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const c=[];return this.j(a,c),c[Symbol.iterator]()}j(a,c){a&&(a.left&&this.j(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this.j(a.mid,c),a.right&&this.j(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const m=c.balanceFactor();return m<-1||m>1?!1:a(c.left)&&a(c.right)};return a(this.c)}}e.$Gi=u}),define(fe[10],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=b,e.$bg=S,e.$cg=C,e.$dg=D,e.$eg=j,e.$fg=E,e.$gg=h,e.$hg=r,e.$ig=y,e.$jg=u,e.$kg=k,e.$lg=a,e.$mg=c,e.$ng=f,e.$og=s,e.$pg=n,e.$qg=g,e.$rg=w;function b(i){return typeof i=="string"}function S(i){return Array.isArray(i)&&i.every(t=>b(t))}function C(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function D(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function E(i){return!!i&&typeof i[Symbol.iterator]=="function"}function h(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function y(i){return!u(i)}function u(i){return r(i)||i===null}function k(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function a(i){if(u(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const t=[];for(let o=0;o<i.length;o++){const P=i[o];if(u(P))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(P)}return t}const m=Object.prototype.hasOwnProperty;function f(i){if(!C(i))return!1;for(const t in i)if(m.call(i,t))return!1;return!0}function s(i){return typeof i=="function"}function n(...i){return i.length>0&&i.every(s)}function g(i,t){const o=Math.min(i.length,t.length);for(let P=0;P<o;P++)w(i[P],t[P])}function w(i,t){if(b(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(i instanceof t)return}catch{}if(!u(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],de([0,1,10]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=S,e.$8n=C,e.$9n=j,e.$0n=h,e.$$n=r,e.$_n=y,e.$ao=u,e.$bo=k,e.$co=a,e.$do=c,e.$eo=m,e.$fo=f,e.$go=s;function S(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const g=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([w,i])=>{g[w]=i&&typeof i=="object"?S(i):i}),g}function C(n){if(!n||typeof n!="object")return n;const g=[n];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const i in w)if(D.call(w,i)){const t=w[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,b.$dg)(t)&&g.push(t)}}return n}const D=Object.prototype.hasOwnProperty;function j(n,g){return E(n,g,new Set)}function E(n,g,w){if((0,b.$jg)(n))return n;const i=g(n);if(typeof i<"u")return i;if(Array.isArray(n)){const t=[];for(const o of n)t.push(E(o,g,w));return t}if((0,b.$cg)(n)){if(w.has(n))throw new Error("Cannot clone recursive data-structure");w.add(n);const t={};for(const o in n)D.call(n,o)&&(t[o]=E(n[o],g,w));return w.delete(n),t}return n}function h(n,g,w=!0){return(0,b.$cg)(n)?((0,b.$cg)(g)&&Object.keys(g).forEach(i=>{i in n?w&&((0,b.$cg)(n[i])&&(0,b.$cg)(g[i])?h(n[i],g[i],w):n[i]=g[i]):n[i]=g[i]}),n):g}function r(n,g){if(n===g)return!0;if(n==null||g===null||g===void 0||typeof n!=typeof g||typeof n!="object"||Array.isArray(n)!==Array.isArray(g))return!1;let w,i;if(Array.isArray(n)){if(n.length!==g.length)return!1;for(w=0;w<n.length;w++)if(!r(n[w],g[w]))return!1}else{const t=[];for(i in n)t.push(i);t.sort();const o=[];for(i in g)o.push(i);if(o.sort(),!r(t,o))return!1;for(w=0;w<t.length;w++)if(!r(n[t[w]],g[t[w]]))return!1}return!0}function y(n){const g=new Set;return JSON.stringify(n,(w,i)=>{if((0,b.$cg)(i)||Array.isArray(i)){if(g.has(i))return"[Circular]";g.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u(n,g){const w=Object.create(null);return!n||!g||Object.keys(g).forEach(t=>{const o=n[t],P=g[t];r(o,P)||(w[t]=P)}),w}function k(n,g){const w=g.toLowerCase(),i=Object.keys(n).find(t=>t.toLowerCase()===w);return i?n[i]:n[g]}function a(n,g){const w=Object.create(null);for(const[i,t]of Object.entries(n))g(i,t)&&(w[i]=t);return w}function c(n){let g=[];for(;Object.prototype!==n;)g=g.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return g}function m(n){const g=[];for(const w of c(n))typeof n[w]=="function"&&g.push(w);return g}function f(n,g){const w=t=>function(){const o=Array.prototype.slice.call(arguments,0);return g(t,o)},i={};for(const t of n)i[t]=w(t);return i}function s(n,g){const w={};for(const[i,t]of Object.entries(n))w[i]=g(t,i);return w}}),define(fe[52],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=S;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(C){return b.test(C)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const D=new Uint8Array(16),j=[];for(let E=0;E<256;E++)j.push(E.toString(16).padStart(2,"0"));return function(){C(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let h=0,r="";return r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r+="-",r+=j[D[h++]],r+=j[D[h++]],r+="-",r+=j[D[h++]],r+=j[D[h++]],r+="-",r+=j[D[h++]],r+=j[D[h++]],r+="-",r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r+=j[D[h++]],r}}()}),define(fe[31],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yW=b;function b(S){return!!S.parentPort}}),define(fe[53],de([13,11]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(fe[54],de([0,1,53]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=r,e.$7m=y,e.$8m=u;const S=60,C=S*60,D=C*24,j=D*7,E=D*30,h=D*365;function r(k,a,c,m){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,b.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,b.localize)(1,null);let s;return f<S?(s=f,a?s===1?c?(0,b.localize)(2,null,s):(0,b.localize)(3,null,s):c?(0,b.localize)(4,null,s):(0,b.localize)(5,null,s):s===1?c?(0,b.localize)(6,null,s):(0,b.localize)(7,null,s):c?(0,b.localize)(8,null,s):(0,b.localize)(9,null,s)):f<C?(s=Math.floor(f/S),a?s===1?c?(0,b.localize)(10,null,s):(0,b.localize)(11,null,s):c?(0,b.localize)(12,null,s):(0,b.localize)(13,null,s):s===1?c?(0,b.localize)(14,null,s):(0,b.localize)(15,null,s):c?(0,b.localize)(16,null,s):(0,b.localize)(17,null,s)):f<D?(s=Math.floor(f/C),a?s===1?c?(0,b.localize)(18,null,s):(0,b.localize)(19,null,s):c?(0,b.localize)(20,null,s):(0,b.localize)(21,null,s):s===1?c?(0,b.localize)(22,null,s):(0,b.localize)(23,null,s):c?(0,b.localize)(24,null,s):(0,b.localize)(25,null,s)):f<j?(s=Math.floor(f/D),a?s===1?(0,b.localize)(26,null,s):(0,b.localize)(27,null,s):s===1?(0,b.localize)(28,null,s):(0,b.localize)(29,null,s)):f<E?(s=Math.floor(f/j),a?s===1?c?(0,b.localize)(30,null,s):(0,b.localize)(31,null,s):c?(0,b.localize)(32,null,s):(0,b.localize)(33,null,s):s===1?c?(0,b.localize)(34,null,s):(0,b.localize)(35,null,s):c?(0,b.localize)(36,null,s):(0,b.localize)(37,null,s)):f<h?(s=Math.floor(f/E),a?s===1?c?(0,b.localize)(38,null,s):(0,b.localize)(39,null,s):c?(0,b.localize)(40,null,s):(0,b.localize)(41,null,s):s===1?c?(0,b.localize)(42,null,s):(0,b.localize)(43,null,s):c?(0,b.localize)(44,null,s):(0,b.localize)(45,null,s)):(s=Math.floor(f/h),a?s===1?c?(0,b.localize)(46,null,s):(0,b.localize)(47,null,s):c?(0,b.localize)(48,null,s):(0,b.localize)(49,null,s):s===1?c?(0,b.localize)(50,null,s):(0,b.localize)(51,null,s):c?(0,b.localize)(52,null,s):(0,b.localize)(53,null,s))}function y(k,a){const c=Math.abs(k/1e3);return c<1?a?(0,b.localize)(54,null,k):(0,b.localize)(55,null,k):c<S?a?(0,b.localize)(56,null,Math.round(k)/1e3):(0,b.localize)(57,null,Math.round(k)/1e3):c<C?a?(0,b.localize)(58,null,Math.round(k/(1e3*S))):(0,b.localize)(59,null,Math.round(k/(1e3*S))):c<D?a?(0,b.localize)(60,null,Math.round(k/(1e3*C))):(0,b.localize)(61,null,Math.round(k/(1e3*C))):(0,b.localize)(62,null,Math.round(k/(1e3*D)))}function u(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],de([13,11]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(fe[56],de([0,1,16,10,55]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=h,e.$mj=r,e.$nj=y;function D(u,k){return k&&(u.stack||u.stacktrace)?C.localize(0,null,E(u),j(u.stack)||j(u.stacktrace)):E(u)}function j(u){return Array.isArray(u)?u.join(`
`):u}function E(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?C.localize(1,null,u.message):u.message||C.localize(2,null)}function h(u=null,k=!1){if(!u)return C.localize(3,null);if(Array.isArray(u)){const a=b.$Hb(u),c=h(a[0],k);return a.length>1?C.localize(4,null,c,a.length):c}if(S.$ag(u))return u;if(u.detail){const a=u.detail;if(a.error)return D(a.error,k);if(a.exception)return D(a.exception,k)}return u.stack?D(u,k):u.message?u.message:C.localize(5,null)}function r(u){const k=u;return k instanceof Error&&Array.isArray(k.actions)}function y(u,k){let a;return typeof u=="string"?a=new Error(u):a=u,a.actions=k,a}}),define(fe[57],de([13,11]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(fe[3],de([0,1,57]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=T,e.$J=Q,e.$g="en";let S=!1,C=!1,D=!1,j=!1,E=!1,h=!1,r=!1,y=!1,u=!1,k=!1,a,c=e.$g,m=e.$g,f,s;const n=globalThis;let g;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?g=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const w=typeof g?.versions?.electron=="string",i=w&&g?.type==="renderer";if(typeof g=="object"){S=g.platform==="win32",C=g.platform==="darwin",D=g.platform==="linux",j=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,r=w,u=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=e.$g,c=e.$g;const U=g.env.VSCODE_NLS_CONFIG;if(U)try{const I=JSON.parse(U),d=I.availableLanguages["*"];a=I.locale,m=I.osLocale,c=d||e.$g,f=I._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!i?(s=navigator.userAgent,S=s.indexOf("Windows")>=0,C=s.indexOf("Macintosh")>=0,y=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,k=s?.indexOf("Mobi")>=0,h=!0,a=b.getConfiguredDefaultLocale(b.localize(0,null))||e.$g,c=a,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(U){U[U.Web=0]="Web",U[U.Mac=1]="Mac",U[U.Linux=2]="Linux",U[U.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(U){switch(U){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let P=0;C?P=1:S?P=3:D&&(P=2),e.$i=S,e.$j=C,e.$k=D,e.$l=j,e.$m=E,e.$n=r,e.$o=h,e.$p=h&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=y,e.$s=k,e.$t=u,e.$u=P,e.$v=s,e.$w=c;var p;(function(U){function I(){return e.$w}U.value=I;function d(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}U.isDefaultVariant=d;function N(){return e.$w==="en"}U.isDefault=N})(p||(e.Language=p={})),e.$x=a,e.$y=m,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const U=[];n.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let N=0,M=U.length;N<M;N++){const A=U[N];if(A.id===d.data.vscodeScheduleAsyncWork){U.splice(N,1),A.callback();return}}});let I=0;return d=>{const N=++I;U.push({id:N,callback:d}),n.postMessage({vscodeScheduleAsyncWork:N},"*")}}return U=>setTimeout(U)})();var L;(function(U){U[U.Windows=1]="Windows",U[U.Macintosh=2]="Macintosh",U[U.Linux=3]="Linux"})(L||(e.OperatingSystem=L={})),e.OS=C||y?2:S?1:3;let v=!0,$=!1;function T(){if(!$){$=!0;const U=new Uint8Array(2);U[0]=1,U[1]=2,v=new Uint16Array(U.buffer)[0]===513}return v}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Q(U){return parseFloat(U)>=20}}),define(fe[15],de([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let S;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const D=C.process;S={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return b.$i?"win32":b.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.$dc=S.platform,e.$ec=S.arch}),define(fe[5],de([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const S=65,C=97,D=90,j=122,E=46,h=47,r=92,y=58,u=63;class k extends Error{constructor(o,P,p){let L;typeof P=="string"&&P.indexOf("not ")===0?(L="must not be",P=P.replace(/^not /,"")):L="must be";const v=o.indexOf(".")!==-1?"property":"argument";let $=`The "${o}" ${v} ${L} of type ${P}`;$+=`. Received type ${typeof p}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function a(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function c(t,o){if(typeof t!="string")throw new k(o,"string",t)}const m=b.$dc==="win32";function f(t){return t===h||t===r}function s(t){return t===h}function n(t){return t>=S&&t<=D||t>=C&&t<=j}function g(t,o,P,p){let L="",v=0,$=-1,T=0,Q=0;for(let U=0;U<=t.length;++U){if(U<t.length)Q=t.charCodeAt(U);else{if(p(Q))break;Q=h}if(p(Q)){if(!($===U-1||T===1))if(T===2){if(L.length<2||v!==2||L.charCodeAt(L.length-1)!==E||L.charCodeAt(L.length-2)!==E){if(L.length>2){const I=L.lastIndexOf(P);I===-1?(L="",v=0):(L=L.slice(0,I),v=L.length-1-L.lastIndexOf(P)),$=U,T=0;continue}else if(L.length!==0){L="",v=0,$=U,T=0;continue}}o&&(L+=L.length>0?`${P}..`:"..",v=2)}else L.length>0?L+=`${P}${t.slice($+1,U)}`:L=t.slice($+1,U),v=U-$-1;$=U,T=0}else Q===E&&T!==-1?++T:T=-1}return L}function w(t,o){a(o,"pathObject");const P=o.dir||o.root,p=o.base||`${o.name||""}${o.ext||""}`;return P?P===o.root?`${P}${p}`:`${P}${t}${p}`:p}e.$fc={resolve(...t){let o="",P="",p=!1;for(let L=t.length-1;L>=-1;L--){let v;if(L>=0){if(v=t[L],c(v,"path"),v.length===0)continue}else o.length===0?v=b.cwd():(v=b.env[`=${o}`]||b.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==o.toLowerCase()&&v.charCodeAt(2)===r)&&(v=`${o}\\`));const $=v.length;let T=0,Q="",U=!1;const I=v.charCodeAt(0);if($===1)f(I)&&(T=1,U=!0);else if(f(I))if(U=!0,f(v.charCodeAt(1))){let d=2,N=d;for(;d<$&&!f(v.charCodeAt(d));)d++;if(d<$&&d!==N){const M=v.slice(N,d);for(N=d;d<$&&f(v.charCodeAt(d));)d++;if(d<$&&d!==N){for(N=d;d<$&&!f(v.charCodeAt(d));)d++;(d===$||d!==N)&&(Q=`\\\\${M}\\${v.slice(N,d)}`,T=d)}}}else T=1;else n(I)&&v.charCodeAt(1)===y&&(Q=v.slice(0,2),T=2,$>2&&f(v.charCodeAt(2))&&(U=!0,T=3));if(Q.length>0)if(o.length>0){if(Q.toLowerCase()!==o.toLowerCase())continue}else o=Q;if(p){if(o.length>0)break}else if(P=`${v.slice(T)}\\${P}`,p=U,U&&o.length>0)break}return P=g(P,!p,"\\",f),p?`${o}\\${P}`:`${o}${P}`||"."},normalize(t){c(t,"path");const o=t.length;if(o===0)return".";let P=0,p,L=!1;const v=t.charCodeAt(0);if(o===1)return s(v)?"\\":t;if(f(v))if(L=!0,f(t.charCodeAt(1))){let T=2,Q=T;for(;T<o&&!f(t.charCodeAt(T));)T++;if(T<o&&T!==Q){const U=t.slice(Q,T);for(Q=T;T<o&&f(t.charCodeAt(T));)T++;if(T<o&&T!==Q){for(Q=T;T<o&&!f(t.charCodeAt(T));)T++;if(T===o)return`\\\\${U}\\${t.slice(Q)}\\`;T!==Q&&(p=`\\\\${U}\\${t.slice(Q,T)}`,P=T)}}}else P=1;else n(v)&&t.charCodeAt(1)===y&&(p=t.slice(0,2),P=2,o>2&&f(t.charCodeAt(2))&&(L=!0,P=3));let $=P<o?g(t.slice(P),!L,"\\",f):"";return $.length===0&&!L&&($="."),$.length>0&&f(t.charCodeAt(o-1))&&($+="\\"),p===void 0?L?`\\${$}`:$:L?`${p}\\${$}`:`${p}${$}`},isAbsolute(t){c(t,"path");const o=t.length;if(o===0)return!1;const P=t.charCodeAt(0);return f(P)||o>2&&n(P)&&t.charCodeAt(1)===y&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,P;for(let v=0;v<t.length;++v){const $=t[v];c($,"path"),$.length>0&&(o===void 0?o=P=$:o+=`\\${$}`)}if(o===void 0)return".";let p=!0,L=0;if(typeof P=="string"&&f(P.charCodeAt(0))){++L;const v=P.length;v>1&&f(P.charCodeAt(1))&&(++L,v>2&&(f(P.charCodeAt(2))?++L:p=!1))}if(p){for(;L<o.length&&f(o.charCodeAt(L));)L++;L>=2&&(o=`\\${o.slice(L)}`)}return e.$fc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o)return"";const P=e.$fc.resolve(t),p=e.$fc.resolve(o);if(P===p||(t=P.toLowerCase(),o=p.toLowerCase(),t===o))return"";let L=0;for(;L<t.length&&t.charCodeAt(L)===r;)L++;let v=t.length;for(;v-1>L&&t.charCodeAt(v-1)===r;)v--;const $=v-L;let T=0;for(;T<o.length&&o.charCodeAt(T)===r;)T++;let Q=o.length;for(;Q-1>T&&o.charCodeAt(Q-1)===r;)Q--;const U=Q-T,I=$<U?$:U;let d=-1,N=0;for(;N<I;N++){const A=t.charCodeAt(L+N);if(A!==o.charCodeAt(T+N))break;A===r&&(d=N)}if(N!==I){if(d===-1)return p}else{if(U>I){if(o.charCodeAt(T+N)===r)return p.slice(T+N+1);if(N===2)return p.slice(T+N)}$>I&&(t.charCodeAt(L+N)===r?d=N:N===2&&(d=3)),d===-1&&(d=0)}let M="";for(N=L+d+1;N<=v;++N)(N===v||t.charCodeAt(N)===r)&&(M+=M.length===0?"..":"\\..");return T+=d,M.length>0?`${M}${p.slice(T,Q)}`:(p.charCodeAt(T)===r&&++T,p.slice(T,Q))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===r){if(o.charCodeAt(1)===r){const P=o.charCodeAt(2);if(P!==u&&P!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(n(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===r)return`\\\\?\\${o}`;return t},dirname(t){c(t,"path");const o=t.length;if(o===0)return".";let P=-1,p=0;const L=t.charCodeAt(0);if(o===1)return f(L)?t:".";if(f(L)){if(P=p=1,f(t.charCodeAt(1))){let T=2,Q=T;for(;T<o&&!f(t.charCodeAt(T));)T++;if(T<o&&T!==Q){for(Q=T;T<o&&f(t.charCodeAt(T));)T++;if(T<o&&T!==Q){for(Q=T;T<o&&!f(t.charCodeAt(T));)T++;if(T===o)return t;T!==Q&&(P=p=T+1)}}}}else n(L)&&t.charCodeAt(1)===y&&(P=o>2&&f(t.charCodeAt(2))?3:2,p=P);let v=-1,$=!0;for(let T=o-1;T>=p;--T)if(f(t.charCodeAt(T))){if(!$){v=T;break}}else $=!1;if(v===-1){if(P===-1)return".";v=P}return t.slice(0,v)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let P=0,p=-1,L=!0,v;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(P=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let $=o.length-1,T=-1;for(v=t.length-1;v>=P;--v){const Q=t.charCodeAt(v);if(f(Q)){if(!L){P=v+1;break}}else T===-1&&(L=!1,T=v+1),$>=0&&(Q===o.charCodeAt($)?--$===-1&&(p=v):($=-1,p=T))}return P===p?p=T:p===-1&&(p=t.length),t.slice(P,p)}for(v=t.length-1;v>=P;--v)if(f(t.charCodeAt(v))){if(!L){P=v+1;break}}else p===-1&&(L=!1,p=v+1);return p===-1?"":t.slice(P,p)},extname(t){c(t,"path");let o=0,P=-1,p=0,L=-1,v=!0,$=0;t.length>=2&&t.charCodeAt(1)===y&&n(t.charCodeAt(0))&&(o=p=2);for(let T=t.length-1;T>=o;--T){const Q=t.charCodeAt(T);if(f(Q)){if(!v){p=T+1;break}continue}L===-1&&(v=!1,L=T+1),Q===E?P===-1?P=T:$!==1&&($=1):P!==-1&&($=-1)}return P===-1||L===-1||$===0||$===1&&P===L-1&&P===p+1?"":t.slice(P,L)},format:w.bind(null,"\\"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const P=t.length;let p=0,L=t.charCodeAt(0);if(P===1)return f(L)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(f(L)){if(p=1,f(t.charCodeAt(1))){let d=2,N=d;for(;d<P&&!f(t.charCodeAt(d));)d++;if(d<P&&d!==N){for(N=d;d<P&&f(t.charCodeAt(d));)d++;if(d<P&&d!==N){for(N=d;d<P&&!f(t.charCodeAt(d));)d++;d===P?p=d:d!==N&&(p=d+1)}}}}else if(n(L)&&t.charCodeAt(1)===y){if(P<=2)return o.root=o.dir=t,o;if(p=2,f(t.charCodeAt(2))){if(P===3)return o.root=o.dir=t,o;p=3}}p>0&&(o.root=t.slice(0,p));let v=-1,$=p,T=-1,Q=!0,U=t.length-1,I=0;for(;U>=p;--U){if(L=t.charCodeAt(U),f(L)){if(!Q){$=U+1;break}continue}T===-1&&(Q=!1,T=U+1),L===E?v===-1?v=U:I!==1&&(I=1):v!==-1&&(I=-1)}return T!==-1&&(v===-1||I===0||I===1&&v===T-1&&v===$+1?o.base=o.name=t.slice($,T):(o.name=t.slice($,v),o.base=t.slice($,T),o.ext=t.slice(v,T))),$>0&&$!==p?o.dir=t.slice(0,$-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(m){const t=/\\/g;return()=>{const o=b.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>b.cwd()})();e.$gc={resolve(...t){let o="",P=!1;for(let p=t.length-1;p>=-1&&!P;p--){const L=p>=0?t[p]:i();c(L,"path"),L.length!==0&&(o=`${L}/${o}`,P=L.charCodeAt(0)===h)}return o=g(o,!P,"/",s),P?`/${o}`:o.length>0?o:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,P=t.charCodeAt(t.length-1)===h;return t=g(t,!o,"/",s),t.length===0?o?"/":P?"./":".":(P&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let P=0;P<t.length;++P){const p=t[P];c(p,"path"),p.length>0&&(o===void 0?o=p:o+=`/${p}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const P=1,p=t.length,L=p-P,v=1,$=o.length-v,T=L<$?L:$;let Q=-1,U=0;for(;U<T;U++){const d=t.charCodeAt(P+U);if(d!==o.charCodeAt(v+U))break;d===h&&(Q=U)}if(U===T)if($>T){if(o.charCodeAt(v+U)===h)return o.slice(v+U+1);if(U===0)return o.slice(v+U)}else L>T&&(t.charCodeAt(P+U)===h?Q=U:U===0&&(Q=0));let I="";for(U=P+Q+1;U<=p;++U)(U===p||t.charCodeAt(U)===h)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(v+Q)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let P=-1,p=!0;for(let L=t.length-1;L>=1;--L)if(t.charCodeAt(L)===h){if(!p){P=L;break}}else p=!1;return P===-1?o?"/":".":o&&P===1?"//":t.slice(0,P)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let P=0,p=-1,L=!0,v;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let $=o.length-1,T=-1;for(v=t.length-1;v>=0;--v){const Q=t.charCodeAt(v);if(Q===h){if(!L){P=v+1;break}}else T===-1&&(L=!1,T=v+1),$>=0&&(Q===o.charCodeAt($)?--$===-1&&(p=v):($=-1,p=T))}return P===p?p=T:p===-1&&(p=t.length),t.slice(P,p)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===h){if(!L){P=v+1;break}}else p===-1&&(L=!1,p=v+1);return p===-1?"":t.slice(P,p)},extname(t){c(t,"path");let o=-1,P=0,p=-1,L=!0,v=0;for(let $=t.length-1;$>=0;--$){const T=t.charCodeAt($);if(T===h){if(!L){P=$+1;break}continue}p===-1&&(L=!1,p=$+1),T===E?o===-1?o=$:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||p===-1||v===0||v===1&&o===p-1&&o===P+1?"":t.slice(o,p)},format:w.bind(null,"/"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const P=t.charCodeAt(0)===h;let p;P?(o.root="/",p=1):p=0;let L=-1,v=0,$=-1,T=!0,Q=t.length-1,U=0;for(;Q>=p;--Q){const I=t.charCodeAt(Q);if(I===h){if(!T){v=Q+1;break}continue}$===-1&&(T=!1,$=Q+1),I===E?L===-1?L=Q:U!==1&&(U=1):L!==-1&&(U=-1)}if($!==-1){const I=v===0&&P?1:v;L===-1||U===0||U===1&&L===$-1&&L===v+1?o.base=o.name=t.slice(I,$):(o.name=t.slice(I,L),o.base=t.slice(I,$),o.ext=t.slice(L,$))}return v>0?o.dir=t.slice(0,v-1):P&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(fe[32],de([0,1,5,3,9,10]),function(oe,e,b,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=j,e.$tg=E,e.$ug=h,e.$vg=r,e.$wg=y,e.$xg=c,e.$yg=m,e.$zg=f,e.$Ag=s,e.$Bg=n,e.$Cg=g,e.$Dg=w,e.$Eg=i,e.$Fg=t,e.$Gg=o,e.$Hg=P,e.$Ig=v;function j($){return $===47||$===92}function E($){return $.replace(/[\\/]/g,b.$gc.sep)}function h($){return $.indexOf("/")===-1&&($=E($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function r($,T=b.$gc.sep){if(!$)return"";const Q=$.length,U=$.charCodeAt(0);if(j(U)){if(j($.charCodeAt(1))&&!j($.charCodeAt(2))){let d=3;const N=d;for(;d<Q&&!j($.charCodeAt(d));d++);if(N!==d&&!j($.charCodeAt(d+1))){for(d+=1;d<Q;d++)if(j($.charCodeAt(d)))return $.slice(0,d+1).replace(/[\\/]/g,T)}}return T}else if(s(U)&&$.charCodeAt(1)===58)return j($.charCodeAt(2))?$.slice(0,2)+T:$.slice(0,2);let I=$.indexOf("://");if(I!==-1){for(I+=3;I<Q;I++)if(j($.charCodeAt(I)))return $.slice(0,I+1)}return""}function y($){if(!S.$i||!$||$.length<5)return!1;let T=$.charCodeAt(0);if(T!==92||(T=$.charCodeAt(1),T!==92))return!1;let Q=2;const U=Q;for(;Q<$.length&&(T=$.charCodeAt(Q),T!==92);Q++);return!(U===Q||(T=$.charCodeAt(Q+1),isNaN(T)||T===92))}const u=/[\\/:\*\?"<>\|]/g,k=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c($,T=S.$i){const Q=T?u:k;return!(!$||$.length===0||/^\s+$/.test($)||(Q.lastIndex=0,Q.test($))||T&&a.test($)||$==="."||$===".."||T&&$[$.length-1]==="."||T&&$.length!==$.trim().length||$.length>255)}function m($,T,Q){const U=$===T;return!Q||U?U:!$||!T?!1:(0,C.$Bf)($,T)}function f($,T,Q,U=b.sep){if($===T)return!0;if(!$||!T||T.length>$.length)return!1;if(Q){if(!(0,C.$Cf)($,T))return!1;if(T.length===$.length)return!0;let d=T.length;return T.charAt(T.length-1)===U&&d--,$.charAt(d)===U}return T.charAt(T.length-1)!==U&&(T+=U),$.indexOf(T)===0}function s($){return $>=65&&$<=90||$>=97&&$<=122}function n($,T){return S.$i&&$.endsWith(":")&&($+=b.sep),(0,b.$ic)($)||($=(0,b.$jc)(T,$)),$=(0,b.$hc)($),g($)}function g($){return S.$i?($=(0,C.$jf)($,b.sep),$.endsWith(":")&&($+=b.sep)):($=(0,C.$jf)($,b.sep),$||($=b.sep)),$}function w($){const T=(0,b.$hc)($);return S.$i?$.length>3?!1:i(T)&&($.length===2||T.charCodeAt(2)===92):T===b.$gc.sep}function i($,T=S.$i){return T?s($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function t($,T=S.$i){return i($,T)?$[0]:void 0}function o($,T,Q){return T.length>$.length?-1:$===T?0:(Q&&($=$.toLowerCase(),T=T.toLowerCase()),$.indexOf(T))}function P($){const T=$.split(":");let Q,U,I;for(const d of T){const N=Number(d);(0,D.$eg)(N)?U===void 0?U=N:I===void 0&&(I=N):Q=Q?[Q,d].join(":"):d}if(!Q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:Q,line:U!==void 0?U:void 0,column:I!==void 0?I:U!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v($,T,Q=8){let U="";for(let d=0;d<Q;d++){let N;d===0&&S.$i&&!T&&(Q===3||Q===4)?N=L:N=p,U+=N.charAt(Math.floor(Math.random()*N.length))}let I;return T?I=`${T}-${U}`:I=U,$?(0,b.$jc)($,I):I}}),define(fe[33],de([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=D,e.$rm=j;var S;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(S||(e.Source=S={}));var C;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function D(E,...h){const r=h.reduce((k,a)=>(k[a]=!0,k),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!r[k]).forEach(k=>{for(let a=0;a<y.length;a++)if(k.search(y[a])!==-1){delete E[k];break}})}function j(E){E&&(delete E.DEBUG,b.$j&&delete E.DYLD_LIBRARY_PATH,b.$k&&delete E.LD_PRELOAD)}}),define(fe[6],de([0,1,5,3]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=w;const C=/^\w[\w\d+.-]*$/,D=/^\//,j=/^\/\//;function E(p,L){if(!p.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${p.authority}", path: "${p.path}", query: "${p.query}", fragment: "${p.fragment}"}`);if(p.scheme&&!C.test(p.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(p.path){if(p.authority){if(!D.test(p.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(p.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(p,L){return!p&&!L?"file":p}function r(p,L){switch(p){case"https":case"http":case"file":L?L[0]!==u&&(L=u+L):L=u;break}return L}const y="",u="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(L){return L instanceof a?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,v,$,T,Q,U=!1){typeof L=="object"?(this.scheme=L.scheme||y,this.authority=L.authority||y,this.path=L.path||y,this.query=L.query||y,this.fragment=L.fragment||y):(this.scheme=h(L,U),this.authority=v||y,this.path=r(this.scheme,$||y),this.query=T||y,this.fragment=Q||y,E(this,U))}get fsPath(){return w(this,!1)}with(L){if(!L)return this;let{scheme:v,authority:$,path:T,query:Q,fragment:U}=L;return v===void 0?v=this.scheme:v===null&&(v=y),$===void 0?$=this.authority:$===null&&($=y),T===void 0?T=this.path:T===null&&(T=y),Q===void 0?Q=this.query:Q===null&&(Q=y),U===void 0?U=this.fragment:U===null&&(U=y),v===this.scheme&&$===this.authority&&T===this.path&&Q===this.query&&U===this.fragment?this:new f(v,$,T,Q,U)}static parse(L,v=!1){const $=k.exec(L);return $?new f($[2]||y,P($[4]||y),P($[5]||y),P($[7]||y),P($[9]||y),v):new f(y,y,y,y,y)}static file(L){let v=y;if(S.$i&&(L=L.replace(/\\/g,u)),L[0]===u&&L[1]===u){const $=L.indexOf(u,2);$===-1?(v=L.substring(2),L=u):(v=L.substring(2,$),L=L.substring($)||u)}return new f("file",v,L,y,y)}static from(L,v){return new f(L.scheme,L.authority,L.path,L.query,L.fragment,v)}static joinPath(L,...v){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return S.$i&&L.scheme==="file"?$=a.file(b.$fc.join(w(L,!0),...v)).path:$=b.$gc.join(L.path,...v),L.with({path:$})}toString(L=!1){return i(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof a)return L;{const v=new f(L);return v._formatted=L.external??null,v._fsPath=L._sep===m?L.fsPath??null:null,v}}else return L}}e.URI=a;function c(p){return!p||typeof p!="object"?!1:typeof p.scheme=="string"&&(typeof p.authority=="string"||typeof p.authority>"u")&&(typeof p.path=="string"||typeof p.path>"u")&&(typeof p.query=="string"||typeof p.query>"u")&&(typeof p.fragment=="string"||typeof p.fragment>"u")}const m=S.$i?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(L=!1){return L?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=m),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const s={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(p,L,v){let $,T=-1;for(let Q=0;Q<p.length;Q++){const U=p.charCodeAt(Q);if(U>=97&&U<=122||U>=65&&U<=90||U>=48&&U<=57||U===45||U===46||U===95||U===126||L&&U===47||v&&U===91||v&&U===93||v&&U===58)T!==-1&&($+=encodeURIComponent(p.substring(T,Q)),T=-1),$!==void 0&&($+=p.charAt(Q));else{$===void 0&&($=p.substr(0,Q));const I=s[U];I!==void 0?(T!==-1&&($+=encodeURIComponent(p.substring(T,Q)),T=-1),$+=I):T===-1&&(T=Q)}}return T!==-1&&($+=encodeURIComponent(p.substring(T))),$!==void 0?$:p}function g(p){let L;for(let v=0;v<p.length;v++){const $=p.charCodeAt(v);$===35||$===63?(L===void 0&&(L=p.substr(0,v)),L+=s[$]):L!==void 0&&(L+=p[v])}return L!==void 0?L:p}function w(p,L){let v;return p.authority&&p.path.length>1&&p.scheme==="file"?v=`//${p.authority}${p.path}`:p.path.charCodeAt(0)===47&&(p.path.charCodeAt(1)>=65&&p.path.charCodeAt(1)<=90||p.path.charCodeAt(1)>=97&&p.path.charCodeAt(1)<=122)&&p.path.charCodeAt(2)===58?L?v=p.path.substr(1):v=p.path[1].toLowerCase()+p.path.substr(2):v=p.path,S.$i&&(v=v.replace(/\//g,"\\")),v}function i(p,L){const v=L?g:n;let $="",{scheme:T,authority:Q,path:U,query:I,fragment:d}=p;if(T&&($+=T,$+=":"),(Q||T==="file")&&($+=u,$+=u),Q){let N=Q.indexOf("@");if(N!==-1){const M=Q.substr(0,N);Q=Q.substr(N+1),N=M.lastIndexOf(":"),N===-1?$+=v(M,!1,!1):($+=v(M.substr(0,N),!1,!1),$+=":",$+=v(M.substr(N+1),!1,!0)),$+="@"}Q=Q.toLowerCase(),N=Q.lastIndexOf(":"),N===-1?$+=v(Q,!1,!0):($+=v(Q.substr(0,N),!1,!0),$+=Q.substr(N))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const N=U.charCodeAt(1);N>=65&&N<=90&&(U=`/${String.fromCharCode(N+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const N=U.charCodeAt(0);N>=65&&N<=90&&(U=`${String.fromCharCode(N+32)}:${U.substr(2)}`)}$+=v(U,!0,!1)}return I&&($+="?",$+=v(I,!1,!1)),d&&($+="#",$+=L?d:n(d,!1,!1)),$}function t(p){try{return decodeURIComponent(p)}catch{return p.length>3?p.substr(0,3)+t(p.substr(3)):p}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function P(p){return p.match(o)?p.replace(o,L=>t(L)):p}}),define(fe[58],de([0,1,6]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=S,e.$3q=C,e.$4q=D,e.log=E;function S(r){const y=r;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function C(r){const y=[];let u;try{const k=JSON.parse(r.arguments),a=k[k.length-1];a&&a.__$stack&&(k.pop(),u=a.__$stack),y.push(...k)}catch{y.push("Unable to log remote console arguments",r.arguments)}return{args:y,stack:u}}function D(r){if(typeof r!="string")return D(C(r).stack);const y=r;if(y){const u=j(y),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(k&&k.length===4)return{uri:b.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function j(r){if(!r)return r;const y=r.indexOf(`
`);return y===-1?r:r.substring(0,y)}function E(r,y){const{args:u,stack:k}=C(r),a=typeof u[0]=="string"&&u.length===1;let c=j(k);c&&(c=`(${c.trim()})`);let m=[];if(typeof u[0]=="string"?c&&a?m=[`%c[${y}] %c${u[0]} %c${c}`,h("blue"),h(""),h("grey")]:m=[`%c[${y}] %c${u[0]}`,h("blue"),h(""),...u.slice(1)]:m=[`%c[${y}]%`,h("blue"),...u],c&&!a&&m.push(c),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,m)}function h(r){return`color: ${r}`}}),define(fe[59],de([0,1,18,6]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=C,e.$9h=D,e.$0h=E;function C(h){return JSON.stringify(h,j)}function D(h){let r=JSON.parse(h);return r=E(r),r}function j(h,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function E(h,r=0){if(!h||r>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return S.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof b.$Je||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let y=0;y<h.length;++y)h[y]=E(h[y],r+1);else for(const y in h)Object.hasOwnProperty.call(h,y)&&(h[y]=E(h[y],r+1))}return h}}),define(fe[19],de([0,1,7,3,9,6,5]),function(oe,e,b,S,C,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=h,e.$Kg=r,e.$Og=u;var E;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(c,m){return D.URI.isUri(c)?(0,C.$Bf)(c.scheme,m):(0,C.$Cf)(c,m+":")}function r(c,...m){return m.some(f=>h(c,f))}e.$Lg="vscode-tkn",e.$Mg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,f){this.f=u(m,f)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,E.vscodeRemoteResource)}set(m,f,s){this.a[m]=f,this.b[m]=s}setConnectionToken(m,f){this.c[m]=f}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(i){return b.$1(i),m}const f=m.authority;let s=this.a[f];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[f],g=this.c[f];let w=`path=${encodeURIComponent(m.path)}`;return typeof g=="string"&&(w+=`&${e.$Mg}=${encodeURIComponent(g)}`),D.URI.from({scheme:S.$o?this.d:E.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:w})}}e.$Ng=new y;function u(c,m){return j.$gc.join(m??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class k{static{this.a=e.$Tg}asBrowserUri(m){const f=this.b(m,oe);return this.uriToBrowserUri(f)}uriToBrowserUri(m){return m.scheme===E.vscodeRemote?e.$Ng.rewrite(m):m.scheme===E.file&&(S.$m||S.$q===`${E.vscodeFileResource}://${k.a}`)?m.with({scheme:E.vscodeFileResource,authority:m.authority||k.a,query:null,fragment:null}):m}asFileUri(m){const f=this.b(m,oe);return this.uriToFileUri(f)}uriToFileUri(m){return m.scheme===E.vscodeFileResource?m.with({scheme:E.file,authority:m.authority!==k.a?m.authority:null,query:null,fragment:null}):m}b(m,f){return D.URI.isUri(m)?m:D.URI.parse(f.toUrl(m))}}e.$Ug=new k;var a;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const f="vscode-coi";function s(g){let w;typeof g=="string"?w=new URL(g).searchParams:g instanceof URL?w=g.searchParams:D.URI.isUri(g)&&(w=new URL(g.toString(!0)).searchParams);const i=w?.get(f);if(i)return m.get(i)}c.getHeadersFromQuery=s;function n(g,w,i){if(!globalThis.crossOriginIsolated)return;const t=w&&i?"3":i?"2":"1";g instanceof URLSearchParams?g.set(f,t):g[f]=t}c.addSearchParam=n})(a||(e.COI=a={}))}),define(fe[23],de([0,1,32,19,5,3,9,6]),function(oe,e,b,S,C,D,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=h,e.$kh=y,e.$lh=k;function h(a){return(0,E.$wc)(a,!0)}class r{constructor(c){this.a=c}compare(c,m,f=!1){return c===m?0:(0,j.$uf)(this.getComparisonKey(c,f),this.getComparisonKey(m,f))}isEqual(c,m,f=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,f)===this.getComparisonKey(m,f)}getComparisonKey(c,m=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,m,f=!1){if(c.scheme===m.scheme){if(c.scheme===S.Schemas.file)return b.$zg(h(c),h(m),this.a(c))&&c.query===m.query&&(f||c.fragment===m.fragment);if((0,e.$gh)(c.authority,m.authority))return b.$zg(c.path,m.path,this.a(c),"/")&&c.query===m.query&&(f||c.fragment===m.fragment)}return!1}joinPath(c,...m){return E.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.$$g)(c)||c.authority}basename(c){return C.$gc.basename(c.path)}extname(c){return C.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===S.Schemas.file?m=E.URI.file(C.$mc(h(c))).path:(m=C.$gc.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===S.Schemas.file?m=E.URI.file(C.$hc(h(c))).path:m=C.$gc.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.$gh)(c.authority,m.authority))return;if(c.scheme===S.Schemas.file){const n=C.$lc(h(c),h(m));return D.$i?b.$tg(n):n}let f=c.path||"/";const s=m.path||"/";if(this.a(c)){let n=0;for(const g=Math.min(f.length,s.length);n<g&&!(f.charCodeAt(n)!==s.charCodeAt(n)&&f.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);f=s.substr(0,n)+f.substr(n)}return C.$gc.relative(f,s)}resolvePath(c,m){if(c.scheme===S.Schemas.file){const f=E.URI.file(C.$kc(h(c),m));return c.with({authority:f.authority,path:f.path})}return m=b.$ug(m),c.with({path:C.$gc.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||c!==void 0&&m!==void 0&&(0,j.$Bf)(c,m)}hasTrailingPathSeparator(c,m=C.sep){if(c.scheme===S.Schemas.file){const f=h(c);return f.length>b.$vg(f).length&&f[f.length-1]===m}else{const f=c.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=C.sep){return(0,e.$hh)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=C.sep){let f=!1;if(c.scheme===S.Schemas.file){const s=h(c);f=s!==void 0&&s.length===b.$vg(s).length&&s[s.length-1]===m}else{m="/";const s=c.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$hh)(c,m)?c.with({path:c.path+"/"}):c}}e.$3g=r,e.$4g=new r(()=>!1),e.$5g=new r(a=>a.scheme===S.Schemas.file?!D.$k:!0),e.$6g=new r(a=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(a,c){const m=[];for(let f=0;f<a.length;f++){const s=c(a[f]);a.some((n,g)=>g===f?!1:(0,e.$8g)(s,c(n)))||m.push(a[f])}return m}var u;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function c(m){const f=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[w,i]=g.split(":");w&&i&&f.set(w,i)});const n=m.path.substring(0,m.path.indexOf(";"));return n&&f.set(a.META_DATA_MIME,n),f}a.parseMetaData=c})(u||(e.DataUri=u={}));function k(a,c,m){if(c){let f=a.path;return f&&f[0]!==C.$gc.sep&&(f=C.$gc.sep+f),a.with({scheme:m,authority:c,path:f})}return a.with({scheme:m})}}),define(fe[12],de([0,1,17,7,4,2,23,3,50,22]),function(oe,e,b,S,C,D,j,E,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=y,e.$nh=u,e.$oh=k,e.$ph=a,e.$qh=c,e.$rh=m,e.$sh=f,e.$th=s,e.$Bh=v,e.$Ch=$,e.$Dh=T,e.$Eh=Q,e.$Fh=U,e.$Uh=F,e.$3h=Y;function y(V){return!!V&&typeof V.then=="function"}function u(V){const O=new b.$se,J=V(O.token),ie=new Promise((ae,$e)=>{const Ee=O.token.onCancellationRequested(()=>{Ee.dispose(),$e(new S.$5)});Promise.resolve(J).then(ge=>{Ee.dispose(),O.dispose(),ae(ge)},ge=>{Ee.dispose(),O.dispose(),$e(ge)})});return new class{cancel(){O.cancel(),O.dispose()}then(ae,$e){return ie.then(ae,$e)}catch(ae){return this.then(void 0,ae)}finally(ae){return ie.finally(ae)}}}function k(V,O,J){return new Promise((ie,ae)=>{const $e=O.onCancellationRequested(()=>{$e.dispose(),ie(J)});V.then(ie,ae).finally(()=>$e.dispose())})}function a(V,O){return new Promise((J,ie)=>{const ae=O.onCancellationRequested(()=>{ae.dispose(),ie(new S.$5)});V.then(J,ie).finally(()=>ae.dispose())})}async function c(V){let O=-1;const J=V.map((ie,ae)=>ie.then($e=>(O=ae,$e)));try{return await Promise.race(J)}finally{V.forEach((ie,ae)=>{ae!==O&&ie.cancel()})}}function m(V,O,J){let ie;const ae=setTimeout(()=>{ie?.(void 0),J?.()},O);return Promise.race([V.finally(()=>clearTimeout(ae)),new Promise($e=>ie=$e)])}function f(V){return new Promise((O,J)=>{const ie=V();y(ie)?ie.then(O,J):O(ie)})}function s(){let V,O;return{promise:new Promise((ie,ae)=>{V=ie,O=ae}),resolve:V,reject:O}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const J=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(J,J).then(ie)})}return new Promise((J,ie)=>{this.b.then(J,ie)})}return this.a=O(),new Promise((J,ie)=>{this.a.then(ae=>{this.a=null,J(ae)},ae=>{this.a=null,ie(ae)})})}dispose(){this.f=!0}}e.$uh=n;class g{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$vh=g;class w{constructor(){this.a=new Map}queue(O,J){const ae=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(O)===ae&&this.a.delete(O)});return this.a.set(O,ae),ae}}e.$wh=w;const i=(V,O)=>{let J=!0;const ie=setTimeout(()=>{J=!1,O()},V);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ie),J=!1}}},t=V=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,V())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class o{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,J=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((ae,$e)=>{this.d=ae,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=J===h.$ce?t(ie):i(J,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=o;class P{constructor(O){this.a=new o(O),this.b=new n}trigger(O,J){return this.a.trigger(()=>this.b.queue(O),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=P;class p{constructor(){this.a=!1,this.b=new Promise((O,J)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=p;class L extends p{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$Ah=L;function v(V,O){return O?new Promise((J,ie)=>{const ae=setTimeout(()=>{$e.dispose(),J()},V),$e=O.onCancellationRequested(()=>{clearTimeout(ae),$e.dispose(),ie(new S.$5)})}):u(J=>v(V,J))}function $(V,O=0,J){const ie=setTimeout(()=>{V(),J&&ae.dispose()},O),ae=(0,D.$Sc)(()=>{clearTimeout(ie),J?.deleteAndLeak(ae)});return J?.add(ae),ae}function T(V){const O=[];let J=0;const ie=V.length;function ae(){return J<ie?V[J++]():null}function $e(Ee){Ee!=null&&O.push(Ee);const ge=ae();return ge?ge.then($e):Promise.resolve(O)}return Promise.resolve(null).then($e)}function Q(V,O=ie=>!!ie,J=null){let ie=0;const ae=V.length,$e=()=>{if(ie>=ae)return Promise.resolve(J);const Ee=V[ie++];return Promise.resolve(Ee()).then(me=>O(me)?Promise.resolve(me):$e())};return $e()}function U(V,O=ie=>!!ie,J=null){if(V.length===0)return Promise.resolve(J);let ie=V.length;const ae=()=>{ie=-1;for(const $e of V)$e.cancel?.()};return new Promise(($e,Ee)=>{for(const ge of V)ge.then(me=>{--ie>=0&&O(me)?(ae(),$e(me)):ie===0&&$e(J)}).catch(me=>{--ie>=0&&(ae(),Ee(me))})})}class I{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new C.$he}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((J,ie)=>{this.g.push({factory:O,c:J,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const J=O.factory();J.then(O.c,O.e),J.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=I;class d extends I{constructor(){super(1)}}e.$Hh=d;class N{constructor(){this.a=new x,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$Ih=N;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new W;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,J=j.$4g){const ie=J.getComparisonKey(O);return this.a.get(ie)?.size??0}queueFor(O,J,ie=j.$4g){const ae=ie.getComparisonKey(O);let $e=this.a.get(ae);if(!$e){$e=new d;const Ee=this.f++,ge=C.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(Ee,ge),this.a.set(ae,$e)}return $e.queue(J)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=M;class A{constructor(O,J){this.a=-1,typeof O=="function"&&typeof J=="number"&&this.setIfNotSet(O,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},J)}setIfNotSet(O,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},J))}}e.$Kh=A;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,J,ie=globalThis){this.cancel();const ae=ie.setInterval(()=>{O()},J);this.d=(0,D.$Sc)(()=>{ie.clearInterval(ae),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=q;class Z{constructor(O,J){this.b=-1,this.a=O,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=Z;class G{constructor(O,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=O,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=G;class _ extends Z{constructor(O,J){super(O,J),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$Oh=_;class re extends D.$Uc{constructor(O,J){super(),this.g=O,this.h=J,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of O)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(V,O)=>{(0,E.$B)(()=>{if(J)return;const ie=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Rh=(V,O,J)=>{const ie=V.requestIdleCallback(O,typeof J=="number"?{timeout:J}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,V.cancelIdleCallback(ie))}}},e.$Qh=V=>(0,e.$Rh)(globalThis,V)}();class le{constructor(O,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$Rh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=le;class X extends le{constructor(O){super(globalThis,O)}}e.$Th=X;async function F(V,O,J){let ie;for(let ae=0;ae<J;ae++)try{return await V()}catch($e){ie=$e,await v(O)}throw ie}class x{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,J,ie){return this.a={taskId:O,cancel:()=>ie?.(),promise:J},J.then(()=>this.d(O),()=>this.d(O)),J}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{const{promise:J,resolve:ie,reject:ae}=s();this.b={run:O,promise:J,promiseResolve:ie,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=x;class ee{constructor(O,J=()=>Date.now()){this.d=O,this.f=J,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$Wh=ee;var he;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(he||(he={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((O,J)=>{this.a=O,this.b=J})}complete(O){return new Promise(J=>{this.a(O),this.d={outcome:0,value:O},J()})}error(O){return new Promise(J=>{this.b(O),this.d={outcome:1,value:O},J()})}cancel(){return this.error(new S.$5)}}e.$Xh=W;var ce;(function(V){async function O(ie){let ae;const $e=await Promise.all(ie.map(Ee=>Ee.then(ge=>ge,ge=>{ae||(ae=ge)})));if(typeof ae<"u")throw ae;return $e}V.settled=O;function J(ie){return new Promise(async(ae,$e)=>{try{await ie(ae,$e)}catch(Ee){$e(Ee)}})}V.withAsyncBody=J})(ce||(e.Promises=ce={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=te;class l{constructor(O){this.b=O,this.a=new r.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=l;var z;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(O){return new ne(J=>{J.emitMany(O)})}static fromPromise(O){return new ne(async J=>{J.emitMany(await O)})}static fromPromises(O){return new ne(async J=>{await Promise.all(O.map(async ie=>J.emitOne(await ie)))})}static merge(O){return new ne(async J=>{await Promise.all(O.map(async ie=>{for await(const ae of ie)J.emitOne(ae)}))})}static{this.EMPTY=ne.fromArray([])}constructor(O,J){this.a=0,this.b=[],this.d=null,this.f=J,this.g=new C.$he,queueMicrotask(async()=>{const ie={emitOne:ae=>this.h(ae),emitMany:ae=>this.j(ae),reject:ae=>this.l(ae)};try{await Promise.resolve(O(ie)),this.k()}catch(ae){this.l(ae)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(O,J){return new ne(async ie=>{for await(const ae of O)ie.emitOne(J(ae))})}map(O){return ne.map(this,O)}static filter(O,J){return new ne(async ie=>{for await(const ae of O)J(ae)&&ie.emitOne(ae)})}filter(O){return ne.filter(this,O)}static coalesce(O){return ne.filter(O,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(O){const J=[];for await(const ie of O)J.push(ie);return J}toPromise(){return ne.toPromise(this)}h(O){this.a===0&&(this.b.push(O),this.g.fire())}j(O){this.a===0&&(this.b=this.b.concat(O),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(O){this.a===0&&(this.a=2,this.d=O,this.g.fire())}}e.$1h=ne;class R extends ne{constructor(O,J){super(J),this.m=O}cancel(){this.m.cancel()}}e.$2h=R;function Y(V){const O=new b.$se,J=V(O.token);return new R(O,async ie=>{const ae=O.token.onCancellationRequested(()=>{ae.dispose(),O.dispose(),ie.reject(new S.$5)});try{for await(const $e of J){if(O.token.isCancellationRequested)return;ie.emitOne($e)}ae.dispose(),O.dispose()}catch($e){ae.dispose(),O.dispose(),ie.reject($e)}})}class H{constructor(O){this.a=new W,this.b=new ne(ae=>{if(J){ae.reject(J);return}return ie&&ae.emitMany(ie),this.d=$e=>ae.reject($e),this.f=$e=>ae.emitOne($e),this.a.p},O);let J,ie;this.f=ae=>{ie||(ie=[]),ie.push(ae)},this.d=ae=>{J||(J=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$4h=H}),define(fe[60],de([0,1,18,6]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=E,e.$Fn=r,e.$Gn=y;function C(u){return u.toJSON()}class D{constructor(k){this.a=k}transformIncoming(k){const a=this.a.transformIncoming(k);return a===k?k:C(S.URI.from(a))}transformOutgoing(k){const a=this.a.transformOutgoing(k);return a===k?k:C(S.URI.from(a))}transformOutgoingURI(k){const a=this.a.transformOutgoing(k);return a===k?k:S.URI.from(a)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Cn=D,e.$Dn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function j(u,k,a){if(!u||a>200)return null;if(typeof u=="object"){if(u instanceof S.URI)return k.transformOutgoing(u);for(const c in u)if(Object.hasOwnProperty.call(u,c)){const m=j(u[c],k,a+1);m!==null&&(u[c]=m)}}return null}function E(u,k){const a=j(u,k,0);return a===null?u:a}function h(u,k,a,c){if(!u||c>200)return null;if(typeof u=="object"){if(u.$mid===1)return a?S.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof b.$Je)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const f=h(u[m],k,a,c+1);f!==null&&(u[m]=f)}}return null}function r(u,k){const a=h(u,k,!1,0);return a===null?u:a}function y(u,k){const a=h(u,k,!0,0);return a===null?u:a}}),define(fe[24],de([0,1,106,20,107,12,32,45,5,3,23,6]),function(oe,e,b,S,C,D,j,E,h,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=g,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=T;var k;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function a(G,_=k.UNLINK,re){if((0,j.$Dg)(G))throw new Error("rimraf - will refuse to recursively delete root");return _===k.UNLINK?m(G):c(G,re)}async function c(G,_=(0,j.$Ig)((0,S.tmpdir)())){try{try{await b.promises.rename(G,_)}catch(re){return re.code==="ENOENT"?void 0:m(G)}m(_).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function m(G){return(0,C.promisify)(b.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function f(G){if((0,j.$Dg)(G))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function s(G,_){return w(await(_?n(G):(0,C.promisify)(b.readdir)(G)))}async function n(G){try{return await(0,C.promisify)(b.readdir)(G,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const _=[],re=await s(G);for(const le of re){let X=!1,F=!1,x=!1;try{const ee=await e.Promises.lstat((0,h.$jc)(G,le));X=ee.isFile(),F=ee.isDirectory(),x=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}_.push({name:le,isFile:()=>X,isDirectory:()=>F,isSymbolicLink:()=>x})}return _}function g(G){return w(b.readdirSync(G))}function w(G){return G.map(_=>typeof _=="string"?r.$j?(0,E.$fm)(_):_:(_.name=r.$j?(0,E.$fm)(_.name):_.name,_))}async function i(G){const _=await s(G),re=[];for(const le of _)await o.existsDirectory((0,h.$jc)(G,le))&&re.push(le);return re}function t(G,_=1e3){return new Promise(re=>{let le=!1;const X=setInterval(()=>{le||(le=!0,b.access(G,F=>{le=!1,F&&(clearInterval(X),re(void 0))}))},_)})}var o;(function(G){async function _(X){let F;try{if(F=await e.Promises.lstat(X),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(r.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw ee}throw x}}G.stat=_;async function re(X){try{const{stat:F,symbolicLink:x}=await G.stat(X);return F.isFile()&&x?.dangling!==!0}catch{}return!1}G.existsFile=re;async function le(X){try{const{stat:F,symbolicLink:x}=await G.stat(X);return F.isDirectory()&&x?.dangling!==!0}catch{}return!1}G.existsDirectory=le})(o||(e.SymlinkSupport=o={}));const P=new D.$Jh;function p(G,_,re){return P.queueFor(u.URI.file(G),()=>{const le=Q(re);return new Promise((X,F)=>$(G,_,le,x=>x?F(x):X()))},y.$5g)}let L=!0;function v(G){L=G}function $(G,_,re,le){if(!L)return b.writeFile(G,_,{mode:re.mode,flag:re.flag},le);b.open(G,re.flag,re.mode,(X,F)=>{if(X)return le(X);b.writeFile(F,_,x=>{if(x)return b.close(F,()=>le(x));b.fdatasync(F,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),v(!1)),b.close(F,he=>le(he))))})})}function T(G,_,re){const le=Q(re);if(!L)return b.writeFileSync(G,_,{mode:le.mode,flag:le.flag});const X=b.openSync(G,le.flag,le.mode);try{b.writeFileSync(X,_);try{b.fdatasyncSync(X)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),v(!1)}}finally{b.closeSync(X)}}function Q(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function U(G,_,re=6e4){if(G!==_)try{r.$i&&typeof re=="number"?await I(G,_,Date.now(),re):await(0,C.promisify)(b.rename)(G,_)}catch(le){if(G.toLowerCase()!==_.toLowerCase()&&le.code==="EXDEV"||G.endsWith("."))await d(G,_,{preserveSymlinks:!1}),await a(G,k.MOVE);else throw le}}async function I(G,_,re,le,X=0){try{return await(0,C.promisify)(b.rename)(G,_)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-re>=le)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${F}`),F;if(X===0){let x=!1;try{const{stat:ee}=await o.stat(_);ee.isFile()||(x=!0)}catch{}if(x)throw F}return await(0,D.$Bh)(Math.min(100,X*10)),I(G,_,re,le,X+1)}}async function d(G,_,re){return M(G,_,{root:{source:G,target:_},options:re,handledSourcePaths:new Set})}const N=511;async function M(G,_,re){if(re.handledSourcePaths.has(G))return;re.handledSourcePaths.add(G);const{stat:le,symbolicLink:X}=await o.stat(G);if(X){if(re.options.preserveSymlinks)try{return await Z(G,_,re)}catch{}if(X.dangling)return}return le.isDirectory()?A(G,_,le.mode&N,re):q(G,_,le.mode&N)}async function A(G,_,re,le){await e.Promises.mkdir(_,{recursive:!0,mode:re});const X=await s(G);for(const F of X)await M((0,h.$jc)(G,F),(0,h.$jc)(_,F),le)}async function q(G,_,re){await e.Promises.copyFile(G,_),await e.Promises.chmod(_,re)}async function Z(G,_,re){let le=await e.Promises.readlink(G);(0,j.$zg)(le,re.root.source,!r.$k)&&(le=(0,h.$jc)(re.root.target,le.substr(re.root.source.length+1))),await e.Promises.symlink(le,_)}e.Promises=new class{get access(){return(0,C.promisify)(b.access)}get stat(){return(0,C.promisify)(b.stat)}get lstat(){return(0,C.promisify)(b.lstat)}get utimes(){return(0,C.promisify)(b.utimes)}get read(){return(G,_,re,le,X)=>new Promise((F,x)=>{b.read(G,_,re,le,X,(ee,he,W)=>ee?x(ee):F({bytesRead:he,buffer:W}))})}get readFile(){return(0,C.promisify)(b.readFile)}get write(){return(G,_,re,le,X)=>new Promise((F,x)=>{b.write(G,_,re,le,X,(ee,he,W)=>ee?x(ee):F({bytesWritten:he,buffer:W}))})}get appendFile(){return(0,C.promisify)(b.appendFile)}get fdatasync(){return(0,C.promisify)(b.fdatasync)}get truncate(){return(0,C.promisify)(b.truncate)}get copyFile(){return(0,C.promisify)(b.copyFile)}get open(){return(0,C.promisify)(b.open)}get close(){return(0,C.promisify)(b.close)}get symlink(){return(0,C.promisify)(b.symlink)}get readlink(){return(0,C.promisify)(b.readlink)}get chmod(){return(0,C.promisify)(b.chmod)}get mkdir(){return(0,C.promisify)(b.mkdir)}get unlink(){return(0,C.promisify)(b.unlink)}get rmdir(){return(0,C.promisify)(b.rmdir)}get realpath(){return(0,C.promisify)(b.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return i}get writeFile(){return p}get rm(){return a}get rename(){return U}get copy(){return d}}}),define(fe[61],de([0,1,20,5,24]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=n,e.$pm=g;const D=/^\d+$/,j=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(h||(h={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class u{constructor(i,t,o){this.exePath=i,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:w=!1}={}){return w?r===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function a({useAlternateBitness:w=!1,findPreview:i=!1}={}){const t=k({useAlternateBitness:w});if(!t)return null;const o=S.$jc(t,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(o))return null;let P=-1,p=null;for(const $ of await C.Promises.readdir(o)){let T=-1;if(i){const U=$.indexOf("-");if(U<0)continue;const I=$.substring(0,U);if(!D.test(I)||$.substring(U+1)!=="preview")continue;T=parseInt(I,10)}else{if(!D.test($))continue;T=parseInt($,10)}if(T<=P)continue;const Q=S.$jc(o,$,"pwsh.exe");await C.SymlinkSupport.existsFile(Q)&&(p=Q,P=T)}if(!p)return null;const L=t.includes("x86")?" (x86)":"",v=i?" Preview":"";return new u(p,`PowerShell${v}${L}`,!0)}async function c({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const i=S.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=w?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const P of await C.Promises.readdir(i))if(t.test(P)){const p=S.$jc(i,P,"pwsh.exe");return new u(p,o)}return null}function m(){const w=S.$jc(b.homedir(),".dotnet","tools","pwsh.exe");return new u(w,".NET Core PowerShell Global Tool")}function f(){const w=S.$jc(process.env.windir,r===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(w,"Windows PowerShell",!0)}async function*s(){let w=await a();w&&(yield w),w=await a({useAlternateBitness:!0}),w&&(yield w),w=await c(),w&&(yield w),w=m(),w&&(yield w),w=await a({findPreview:!0}),w&&(yield w),w=await c({findPreview:!0}),w&&(yield w),w=await a({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=f(),w&&(yield w)}async function*n(){for await(const w of s())await w.exists()&&(yield w)}async function g(){for await(const w of n())return w;return null}}),define(fe[34],de([0,1,5,3,15,33,10,24]),function(oe,e,b,S,C,D,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=h,e.$tm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function h(u=C.env){return u.comspec||"cmd.exe"}function r(u){let k=[],a=!1;const c=function(m){if(a){k.push(m);return}(!u.send(m,s=>{if(s&&console.error(s),a=!1,k.length>0){const n=k.slice(0);k=[],n.forEach(g=>c(g))}})||S.$i)&&(a=!0)};return{send:c}}var y;(function(u){async function k(a,c,m){if(b.$ic(a))return a;if(c===void 0&&(c=C.cwd()),b.$mc(a)!=="."||(m===void 0&&j.$ag(C.env.PATH)&&(m=C.env.PATH.split(b.$tc)),m===void 0||m.length===0))return b.$jc(c,a);async function s(n){if(await E.Promises.exists(n)){let g;try{g=await E.Promises.stat(n)}catch(w){w.message.startsWith("EACCES")&&(g=await E.Promises.lstat(n))}return g?!g.isDirectory():!1}return!1}for(const n of m){let g;if(b.$ic(n)?g=b.$jc(n,a):g=b.$jc(c,n,a),await s(g))return g;let w=g+".com";if(await s(w)||(w=g+".exe",await s(w)))return w}return b.$jc(c,a)}u.findExecutable=k})(y||(e.win32=y={}))}),define(fe[62],de([0,1,26,19]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=C;function C(j){return new Promise((E,h)=>{let r;const y=new Map;function u(a,c,m,f,s){const n=y.get(c);if(a===j||n){const g={name:k(m),cmd:m,pid:a,ppid:c,load:f,mem:s};y.set(a,g),a===j&&(r=g),n&&(n.children||(n.children=[]),n.children.push(g),n.children.length>1&&(n.children=n.children.sort((w,i)=>w.pid-i.pid)))}}function k(a){const c=/--utility-sub-type=network/i,m=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,s=/conhost\.exe.+--headless/i,n=/--type=([a-zA-Z-]+)/;if(m.exec(a))return"electron-crash-reporter";if(f.exec(a))return"winpty-agent";if(s.exec(a))return"conpty-agent";let g=n.exec(a);if(g&&g.length===2)return g[1]==="renderer"?"window":g[1]==="utility"?c.exec(a)?"utility-network-service":"utility-process":g[1]==="extensionHost"?"extension-host":g[1];const w=/[a-zA-Z-]+\.js/g;let i="";do g=w.exec(a),g&&(i+=g+" ");while(g);return i&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron-nodejs (${i})`:a}if(process.platform==="win32"){const a=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,m)=>{oe(["@vscode/windows-process-tree"],c,m)}).then(c=>{c.getProcessList(j,m=>{if(!m){h(new Error(`Root process ${j} not found`));return}c.getProcessCpuUsage(m,f=>{const s=new Map;f.forEach(n=>{const g=a(n.commandLine||"");s.set(n.pid,{name:k(g),cmd:g,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),r=s.get(j),r?(s.forEach(n=>{const g=s.get(n.ppid);g&&(g.children||(g.children=[]),g.children.push(n))}),s.forEach(n=>{n.children&&(n.children=n.children.sort((g,w)=>g.pid-w.pid))}),E(r)):h(new Error(`Root process ${j} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let a=function(){let c=[r];const m=[];for(;c.length;){const s=c.shift();s&&(m.push(s.pid),s.children&&(c=c.concat(s.children)))}let f=JSON.stringify(S.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+m.join(" "),(0,b.exec)(f,{},(s,n,g)=>{if(s||g)h(s||new Error(g.toString()));else{const w=n.toString().split(`
`);for(let i=0;i<m.length;i++){const t=y.get(m[i]);t.load=parseFloat(w[i])}if(!r){h(new Error(`Root process ${j} not found`));return}E(r)}})};(0,b.exec)("which ps",{},(c,m,f)=>{if(c||f)if(process.platform!=="linux")h(c||new Error(f.toString()));else{const s=JSON.stringify(S.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,b.exec)(s,{},(n,g,w)=>{n||w?h(n||new Error(w.toString())):(D(g,u),a())})}else{const s=m.toString().trim();(0,b.exec)(`${s} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,w,i)=>{g||i&&!i.includes("screen size is bogus")?h(g||new Error(i.toString())):(D(w,u),process.platform==="linux"?a():r?E(r):h(new Error(`Root process ${j} not found`)))})}})}})}function D(j,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const y of r){const u=h.exec(y.trim());u&&u.length===6&&E(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(fe[63],de([0,1,20,3,61,34]),function(oe,e,b,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=j;async function j(u,k){return u===1?S.$i?y():D.$sm(k):h(u,k)}let E=null;function h(u,k){if(S.$k&&u===2||S.$j&&u===3)return"/bin/bash";if(!E){let a;if(S.$i)a="/bin/bash";else{if(a=k.SHELL,!a)try{a=(0,b.userInfo)().shell}catch{}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}E=a}return E}let r=null;async function y(){return r||(r=(await(0,C.$pm)()).exePath),r}});var pe=this&&this.__decorate||function(oe,e,b,S){var C=arguments.length,D=C<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,b):S,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(oe,e,b,S);else for(var E=oe.length-1;E>=0;E--)(j=oe[E])&&(D=(C<3?j(D):C>3?j(e,b,D):j(e,b))||D);return C>3&&D&&Object.defineProperty(e,b,D),D};define(fe[27],de([0,1,16,12,18,17,14,7,4,2,59,9,10]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=v,e.$bi=$,e.$gi=N,e.$hi=M;var a;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(a||(a={}));function c(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(m||(m={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(s||(s={}));function n(X){let F=0;for(let x=0;;x+=7){const ee=X.read(1);if(F|=(ee.buffer[0]&127)<<x,!(ee.buffer[0]&128))return F}}const g=P(0);function w(X,F){if(F===0){X.write(g);return}let x=0;for(let he=F;he!==0;he=he>>>7)x++;const ee=C.$Je.alloc(x);for(let he=0;F!==0;he++)ee.buffer[he]=F&127,F=F>>>7,F>0&&(ee.buffer[he]|=128);X.write(ee)}class i{constructor(F){this.b=F,this.a=0}read(F){const x=this.b.slice(this.a,this.a+F);return this.a+=x.byteLength,x}}e.$$h=i;class t{constructor(){this.a=[]}get buffer(){return C.$Je.concat(this.a)}write(F){this.a.push(F)}}e.$_h=t;var o;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(o||(o={}));function P(X){const F=C.$Je.alloc(1);return F.writeUInt8(X,0),F}const p={Undefined:P(o.Undefined),String:P(o.String),Buffer:P(o.Buffer),VSBuffer:P(o.VSBuffer),Array:P(o.Array),Object:P(o.Object),Uint:P(o.Int)},L=typeof Buffer<"u";function v(X,F){if(typeof F>"u")X.write(p.Undefined);else if(typeof F=="string"){const x=C.$Je.fromString(F);X.write(p.String),w(X,x.byteLength),X.write(x)}else if(L&&Buffer.isBuffer(F)){const x=C.$Je.wrap(F);X.write(p.Buffer),w(X,x.byteLength),X.write(x)}else if(F instanceof C.$Je)X.write(p.VSBuffer),w(X,F.byteLength),X.write(F);else if(Array.isArray(F)){X.write(p.Array),w(X,F.length);for(const x of F)v(X,x)}else if(typeof F=="number"&&(F|0)===F)X.write(p.Uint),w(X,F);else{const x=C.$Je.fromString(JSON.stringify(F));X.write(p.Object),w(X,x.byteLength),X.write(x)}}function $(X){switch(X.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return X.read(n(X)).toString();case o.Buffer:return X.read(n(X)).buffer;case o.VSBuffer:return X.read(n(X));case o.Array:{const x=n(X),ee=[];for(let he=0;he<x;he++)ee.push($(X));return ee}case o.Object:return JSON.parse(X.read(n(X)).toString());case o.Int:return n(X)}}class T{constructor(F,x,ee=null,he=1e3){this.h=F,this.j=x,this.k=ee,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:200})}registerChannel(F,x){this.b.set(F,x),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const x=this.o([F.type]);this.k?.logOutgoing(x,0,1,f(F.type));return}case 201:case 202:case 204:case 203:{const x=this.o([F.type,F.id],F.data);this.k?.logOutgoing(x,F.id,1,f(F.type),F.data);return}}}o(F,x=void 0){const ee=new t;return v(ee,F),v(ee,x),this.p(ee.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const x=new i(F),ee=$(x),he=$(x),W=ee[0];switch(W){case 100:return this.k?.logIncoming(F.byteLength,ee[1],1,`${c(W)}: ${ee[2]}.${ee[3]}`,he),this.s({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case 102:return this.k?.logIncoming(F.byteLength,ee[1],1,`${c(W)}: ${ee[2]}.${ee[3]}`,he),this.t({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:he});case 101:return this.k?.logIncoming(F.byteLength,ee[1],1,`${c(W)}`),this.u({type:W,id:ee[1]});case 103:return this.k?.logIncoming(F.byteLength,ee[1],1,`${c(W)}`),this.u({type:W,id:ee[1]})}}s(F){const x=this.b.get(F.channelName);if(!x){this.v(F);return}const ee=new D.$se;let he;try{he=x.call(this.j,F.name,F.arg,ee.token)}catch(te){he=Promise.reject(te)}const W=F.id;he.then(te=>{this.m({id:W,data:te,type:201})},te=>{te instanceof Error?this.m({id:W,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:W,data:te,type:203})}).finally(()=>{ce.dispose(),this.d.delete(F.id)});const ce=(0,r.$Sc)(()=>ee.cancel());this.d.set(F.id,ce)}t(F){const x=this.b.get(F.channelName);if(!x){this.v(F);return}const ee=F.id,W=x.listen(this.j,F.name,F.arg)(ce=>this.m({id:ee,data:ce,type:204}));this.d.set(F.id,W)}u(F){const x=this.d.get(F.id);x&&(x.dispose(),this.d.delete(F.id))}v(F){let x=this.g.get(F.channelName);x||(x=[],this.g.set(F.channelName,x));const ee=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:F,timeoutTimer:ee})}w(F){const x=this.g.get(F);if(x){for(const ee of x)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$ci=T;var Q;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(Q||(e.RequestInitiator=Q={}));class U{constructor(F,x=null){this.l=F,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=x}getChannel(F){const x=this;return{call(ee,he,W){return x.a?Promise.reject(new E.$5):x.m(F,ee,he,W)},listen(ee,he){return x.a?h.Event.None:x.o(F,ee,he)}}}m(F,x,ee,he=D.CancellationToken.None){const W=this.g++,te={id:W,type:100,channelName:F,name:x,arg:ee};if(he.isCancellationRequested)return Promise.reject(new E.$5);let l;return new Promise((ne,R)=>{if(he.isCancellationRequested)return R(new E.$5);const Y=()=>{const J=ie=>{switch(ie.type){case 201:this.f.delete(W),ne(ie.data);break;case 202:{this.f.delete(W);const ae=new Error(ie.data.message);ae.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ae.name=ie.data.name,R(ae);break}case 203:this.f.delete(W),R(ie.data);break}};this.f.set(W,J),this.p(te)};let H=null;this.b===s.Idle?Y():(H=(0,S.$nh)(J=>this.u()),H.then(()=>{H=null,Y()}));const V=()=>{H?(H.cancel(),H=null):this.p({id:W,type:101}),R(new E.$5)},O=he.onCancellationRequested(V);l=(0,r.$Rc)((0,r.$Sc)(V),O),this.d.add(l)}).finally(()=>{l.dispose(),this.d.delete(l)})}o(F,x,ee){const he=this.g++,ce={id:he,type:102,channelName:F,name:x,arg:ee};let te=null;const l=new h.$he({onWillAddFirstListener:()=>{te=(0,S.$nh)(ne=>this.u()),te.then(()=>{te=null,this.d.add(l),this.p(ce)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(l),this.p({id:he,type:103}))}}),z=ne=>l.fire(ne.data);return this.f.set(he,z),l.event}p(F){switch(F.type){case 100:case 102:{const x=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(x,F.id,0,`${c(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const x=this.q([F.type,F.id]);this.j?.logOutgoing(x,F.id,0,c(F.type));return}}}q(F,x=void 0){const ee=new t;return v(ee,F),v(ee,x),this.r(ee.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const x=new i(F),ee=$(x),he=$(x),W=ee[0];switch(W){case 200:return this.j?.logIncoming(F.byteLength,0,0,f(W)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,ee[1],0,f(W),he),this.t({type:ee[0],id:ee[1],data:he})}}t(F){if(F.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$di=U,pe([j.$5h],U.prototype,"onDidInitializePromise",null);class I{get connections(){const F=[];return this.f.forEach(x=>F.push(x)),F}constructor(F,x,ee){this.a=new Map,this.f=new Set,this.g=new h.$he,this.onDidAddConnection=this.g.event,this.h=new h.$he,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(F(({protocol:he,onDidClientDisconnect:W})=>{const ce=h.Event.once(he.onMessage);this.j.add(ce(te=>{const l=new i(te),z=$(l),ne=new T(he,z,x,ee),R=new U(he,x);this.a.forEach((H,V)=>ne.registerChannel(V,H));const Y={channelServer:ne,channelClient:R,ctx:z};this.f.add(Y),this.g.fire(Y),this.j.add(W(()=>{ne.dispose(),R.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(F,x){const ee=this;return{call(he,W,ce){let te;if((0,k.$og)(x)){const z=(0,b.$3b)(ee.connections.filter(x));te=z?Promise.resolve(z):h.Event.toPromise(h.Event.filter(ee.onDidAddConnection,x))}else te=x.routeCall(ee,he,W);const l=te.then(z=>z.channelClient.getChannel(F));return N(l).call(he,W,ce)},listen(he,W){if((0,k.$og)(x))return ee.k(F,x,he,W);const ce=x.routeEvent(ee,he,W).then(te=>te.channelClient.getChannel(F));return N(ce).listen(he,W)}}}k(F,x,ee,he){const W=this;let ce;const te=new h.$he({onWillAddFirstListener:()=>{ce=new r.$Tc;const l=new h.$ne,z=new Map,ne=Y=>{const V=Y.channelClient.getChannel(F).listen(ee,he),O=l.add(V);z.set(Y,O)},R=Y=>{const H=z.get(Y);H&&(H.dispose(),z.delete(Y))};W.connections.filter(x).forEach(ne),h.Event.filter(W.onDidAddConnection,x)(ne,void 0,ce),W.onDidRemoveConnection(R,void 0,ce),l.event(te.fire,te,ce),ce.add(l)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return te.event}registerChannel(F,x){this.a.set(F,x);for(const ee of this.f)ee.channelServer.registerChannel(F,x)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=I;class d{constructor(F,x,ee=null){const he=new t;v(he,x),F.send(he.buffer),this.a=new U(F,ee),this.d=new T(F,x,ee)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,x){this.d.registerChannel(F,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=d;function N(X){return{call(F,x,ee){return X.then(he=>he.call(F,x,ee))},listen(F,x){const ee=new h.$qe;return X.then(he=>ee.input=he.listen(F,x)),ee.event}}}function M(X){let F=!1;return{call(x,ee,he){return F?X.call(x,ee,he):(0,S.$Bh)(0).then(()=>F=!0).then(()=>X.call(x,ee,he))},listen(x,ee){if(F)return X.listen(x,ee);const he=new h.$qe;return(0,S.$Bh)(0).then(()=>F=!0).then(()=>he.input=X.listen(x,ee)),he.event}}}class A{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const x of F.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await h.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$ii=A;var q;(function(X){function F(W,ce,te){const l=W,z=te&&te.disableMarshalling,ne=new Map;for(const R in l)ee(R)&&ne.set(R,h.Event.buffer(l[R],!0,void 0,ce));return new class{listen(R,Y,H){const V=ne.get(Y);if(V)return V;const O=l[Y];if(typeof O=="function"){if(he(Y))return O.call(l,H);if(ee(Y))return ne.set(Y,h.Event.buffer(l[Y],!0,void 0,ce)),ne.get(Y)}throw new E.$bb(`Event not found: ${Y}`)}call(R,Y,H){const V=l[Y];if(typeof V=="function"){if(!z&&Array.isArray(H))for(let J=0;J<H.length;J++)H[J]=(0,y.$0h)(H[J]);let O=V.apply(l,H);return O instanceof Promise||(O=Promise.resolve(O)),O}throw new E.$bb(`Method not found: ${Y}`)}}}X.fromService=F;function x(W,ce){const te=ce&&ce.disableMarshalling;return new Proxy({},{get(l,z){if(typeof z=="string")return ce?.properties?.has(z)?ce.properties.get(z):he(z)?function(ne){return W.listen(z,ne)}:ee(z)?W.listen(z):async function(...ne){let R;ce&&!(0,k.$jg)(ce.context)?R=[ce.context,...ne]:R=ne;const Y=await W.call(z,R);return te?Y:(0,y.$0h)(Y)};throw new E.$bb(`Property not found: ${String(z)}`)}})}X.toService=x;function ee(W){return W[0]==="o"&&W[1]==="n"&&u.$Af(W.charCodeAt(2))}function he(W){return/^onDynamic/.test(W)&&u.$Af(W.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const F=X.toString();if(F!=="[object Object]")return F}return X}function _(X){return Array.isArray(X)?X.map(G):G(X)}function re(X,F,x,ee,he,W,ce){ce=_(ce);const te=Z[he],l=te[ee%te.length];let z=[`%c[${X}]%c[${String(F).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${l}`];/\($/.test(W)?(z=z.concat(ce),z.push(")")):z.push(ce),console.log.apply(console,z)}class le{constructor(F,x){this.d=F,this.f=x,this.a=0,this.b=0}logOutgoing(F,x,ee,he,W){this.b+=F,re(this.d,this.b,F,x,ee,he,W)}logIncoming(F,x,ee,he,W){this.a+=F,re(this.f,this.a,F,x,ee,he,W)}}e.$ji=le}),define(fe[64],de([0,1,26,12,18,17,58,7,4,2,30,34,33,27]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class c extends a.$ci{constructor(s){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",n=>C.$Je.wrap(Buffer.from(n,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$6q=c;class m{constructor(s,n){this.i=s,this.j=n,this.c=new Set,this.g=new Map,this.h=new h.$he,this.onDidProcessExit=this.h.event;const g=n&&n.timeout?n.timeout:6e4;this.b=new S.$xh(g),this.d=null,this.f=null}getChannel(s){const n=this;return{call(g,w,i){return n.k(s,g,w,i)},listen(g,w){return n.l(s,g,w)}}}k(s,n,g,w=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const i=this.n(s),t=(0,S.$nh)(p=>i.call(n,g,p)),o=w.onCancellationRequested(()=>t.cancel()),P=(0,r.$Sc)(()=>t.cancel());return this.c.add(P),t.finally(()=>{o.dispose(),this.c.delete(P),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,n,g){if(!this.b)return h.Event.None;this.b.cancel();let w;const i=new h.$he({onWillAddFirstListener:()=>{w=this.n(s).listen(n,g)(i.fire,i),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,y.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,k.$rm)(n.env),this.d=(0,b.fork)(this.i,s,n);const g=new h.$he,i=h.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,j.$2q)(v)){(0,j.log)(v,`IPC Library: ${this.j.serverName}`);return}g.fire(C.$Je.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,u.$tm)(this.d):this.d,o=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),P=g.event,p={send:o,onMessage:P};this.f=new a.$di(p);const L=()=>this.o();process.once("exit",L),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,$)=>{process.removeListener("exit",L),i.dispose(),this.c.forEach(T=>(0,r.$Pc)(T)),this.c.clear(),v!==0&&$!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+$),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:$})})}return this.f}n(s){let n=this.g.get(s);return n||(n=this.m.getChannel(s),this.g.set(s,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=m}),define(fe[65],de([0,1,31,18,27,4,10,16]),function(oe,e,b,S,C,D,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=void 0,e.$AW=y;class h{constructor(k){this.a=k,this.onMessage=D.Event.fromNodeEventEmitter(this.a,"message",a=>a.data?S.$Je.wrap(a.data):S.$Je.alloc(0)),k.start()}send(k){this.a.postMessage(k.buffer)}disconnect(){this.a.close()}}class r extends C.$ei{static b(k){(0,j.$kg)((0,b.$yW)(process),"Electron Utility Process");const a=new D.$he;return process.parentPort.on("message",c=>{if(k?.handledClientConnection(c))return;const m=(0,E.$Ob)(c.ports);m&&a.fire(m)}),D.Event.map(a.event,c=>({protocol:new h(c),onDidClientDisconnect:D.Event.fromNodeEventEmitter(c,"close")}))}constructor(k){super(r.b(k))}}e.$zW=r;function y(u,k,a){const c=m=>{m.data===k&&(u.removeListener("message",c),a())};u.on("message",c)}}),define(fe[66],de([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],de([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],de([13,11]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(fe[69],de([13,11]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(fe[70],de([13,11]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(fe[71],de([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],de([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],de([0,1,7,67]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var C;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(C||(e.TokenType=C={}));function D(...r){switch(r.length){case 1:return(0,S.localize)(0,null,r[0]);case 2:return(0,S.localize)(1,null,r[0],r[1]);case 3:return(0,S.localize)(2,null,r[0],r[1],r[2]);default:return}}const j=(0,S.localize)(3,null),E=(0,S.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,b.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const u=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:u})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const u=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:u})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,k=this.c.substring(this.d,this.e),a={type:19,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),k=h.b.get(u);k?this.k(k):this.f.push({type:17,lexeme:u,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,k=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(E);return}const c=this.c.charCodeAt(y);if(u)u=!1;else if(c===47&&!k){y++;break}else c===91?k=!0:c===92?u=!0:c===93&&(k=!1);y++}for(;y<this.c.length&&h.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=h}),define(fe[74],de([0,1,54,14,19,5,15,23,6]),function(oe,e,b,S,C,D,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=y,e.$_m=u,e.$9m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,D.$mc)(C.$Ug.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,D.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const a=(0,b.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$jc)(this.userDataPath,"logs",a)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$bh)(h.URI.file((0,D.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=j.env.VSCODE_PORTABLE;return a?h.URI.file((0,D.$jc)(a,"argv.json")):(0,E.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,D.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,D.$kc)(a):(0,D.$hc)((0,D.$jc)(C.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const a=this.args["extensions-download-dir"];return a?h.URI.file((0,D.$kc)(a)):h.URI.file((0,D.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,D.$kc)(a);const c=j.env.VSCODE_EXTENSIONS;if(c)return c;const m=j.env.VSCODE_PORTABLE;return m?(0,D.$jc)(m,"extensions"):(0,E.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?h.URI.parse(c):h.URI.file((0,D.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?h.URI.parse(a):h.URI.file((0,D.$hc)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(a=>!e.$9m.test(a))}get extensionLogLevel(){const a=[];for(const c of this.args.log||[]){const m=e.$9m.exec(c);m&&m[1]&&m[2]&&a.push([m[1],m[2]])}return a.length?a:void 0}get serviceMachineIdResource(){return(0,E.$bh)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const a=j.env.VSCODE_PORTABLE;return a?h.URI.file((0,D.$jc)(a,"policy.json")):(0,E.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(a){this.args.continueOn=a}get args(){return this.a}constructor(a,c,m){this.a=a,this.b=c,this.c=m,this.editSessionId=this.args.editSessionId}}e.$0m=r,pe([S.$5h],r.prototype,"appRoot",null),pe([S.$5h],r.prototype,"userHome",null),pe([S.$5h],r.prototype,"userDataPath",null),pe([S.$5h],r.prototype,"appSettingsHome",null),pe([S.$5h],r.prototype,"tmpDir",null),pe([S.$5h],r.prototype,"cacheHome",null),pe([S.$5h],r.prototype,"stateResource",null),pe([S.$5h],r.prototype,"userRoamingDataHome",null),pe([S.$5h],r.prototype,"userDataSyncHome",null),pe([S.$5h],r.prototype,"sync",null),pe([S.$5h],r.prototype,"machineSettingsResource",null),pe([S.$5h],r.prototype,"workspaceStorageHome",null),pe([S.$5h],r.prototype,"localHistoryHome",null),pe([S.$5h],r.prototype,"keyboardLayoutResource",null),pe([S.$5h],r.prototype,"argvResource",null),pe([S.$5h],r.prototype,"isExtensionDevelopment",null),pe([S.$5h],r.prototype,"untitledWorkspacesHome",null),pe([S.$5h],r.prototype,"builtinExtensionsPath",null),pe([S.$5h],r.prototype,"extensionsPath",null),pe([S.$5h],r.prototype,"extensionDevelopmentLocationURI",null),pe([S.$5h],r.prototype,"extensionDevelopmentKind",null),pe([S.$5h],r.prototype,"extensionTestsLocationURI",null),pe([S.$5h],r.prototype,"debugExtensionHost",null),pe([S.$5h],r.prototype,"logLevel",null),pe([S.$5h],r.prototype,"extensionLogLevel",null),pe([S.$5h],r.prototype,"serviceMachineIdResource",null),pe([S.$5h],r.prototype,"disableTelemetry",null),pe([S.$5h],r.prototype,"disableWorkspaceTrust",null),pe([S.$5h],r.prototype,"useInMemorySecretStorage",null),pe([S.$5h],r.prototype,"policyFile",null);function y(k,a){return u(k["inspect-extensions"],k["inspect-brk-extensions"],5870,a,k.debugId,k.extensionEnvironment)}function u(k,a,c,m,f,s){const g=Number(a||k)||(m?null:c),w=g?!!a:!1;let i;if(s)try{i=JSON.parse(s)}catch{}return{port:g,break:w,debugId:f,env:i}}}),define(fe[75],de([0,1,108,3,68]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$xm=E,e.$ym=r,e.$zm=a,e.$Am=c;const D={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.$vm=["tunnel","serve-web"],e.$wm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,C.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,C.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(m,f,s=j){const n=m.find(v=>v.length>0&&v[0]!=="-"),g={},w=["_"],i=[],t={};let o;for(const v in f){const $=f[v];$.type==="subcommand"?v===n&&(o=$):($.alias&&(g[v]=$.alias),$.type==="string"||$.type==="string[]"?(w.push(v),$.deprecates&&w.push(...$.deprecates)):$.type==="boolean"&&(i.push(v),$.deprecates&&i.push(...$.deprecates)),$.global&&(t[v]=$))}if(o&&n){const v=t;for(const U in o.options)v[U]=o.options[U];const $=m.filter(U=>U!==n),T=s.getSubcommandReporter?s.getSubcommandReporter(n):void 0,Q=E($,v,T);return{[n]:Q,_:[]}}const P=b(m,{string:w,boolean:i,alias:g}),p={},L=P;p._=P._.map(v=>String(v)).filter(v=>v.length>0),delete L._;for(const v in f){const $=f[v];if($.type==="subcommand")continue;$.alias&&delete L[$.alias];let T=L[v];if($.deprecates)for(const Q of $.deprecates)L.hasOwnProperty(Q)&&(T||(T=L[Q],T&&s.onDeprecatedOption(Q,$.deprecationMessage||(0,C.localize)(39,null,v))),delete L[Q]);if(typeof T<"u"){if($.type==="string[]"){if(Array.isArray(T)||(T=[T]),!$.allowEmptyValue){const Q=T.filter(U=>U.length>0);Q.length!==T.length&&(s.onEmptyValue(v),T=Q.length>0?Q:void 0)}}else $.type==="string"&&(Array.isArray(T)?(T=T.pop(),s.onMultipleValues(v,T)):!T&&!$.allowEmptyValue&&(s.onEmptyValue(v),T=void 0));p[v]=T,$.deprecationMessage&&s.onDeprecatedOption(v,$.deprecationMessage)}delete L[v]}for(const v in L)s.onUnknownOption(v);return p}function h(m,f){let s="";return f.args&&(Array.isArray(f.args)?s=` <${f.args.join("> <")}>`:s=` <${f.args}>`),f.alias?`-${f.alias} --${m}${s}`:`--${m}${s}`}function r(m,f){const s=[];for(const n in m){const g=m[n],w=h(n,g);s.push([w,g.description])}return y(s,f)}function y(m,f){const n=m.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-n<25)return m.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=f-n-1,w=[];for(const i of m){const t=i[0],o=k(i[1],g),P=u(n-t.length-2);w.push("  "+t+P+o[0]);for(let p=1;p<o.length;p++)w.push(u(n)+o[p])}return w}function u(m){return" ".repeat(m)}function k(m,f){const s=[];for(;m.length;){const n=m.length<f?m.length:m.lastIndexOf(" ",f),g=m.slice(0,n).trim();m=m.slice(n),s.push(g)}return s}function a(m,f,s,n,g){const w=process.stdout.isTTY&&process.stdout.columns||80,i=g?.noInputFiles!==!0?`[${(0,C.localize)(40,null)}...]`:"",t=[`${m} ${s}`];t.push(""),t.push(`${(0,C.localize)(41,null)}: ${f} [${(0,C.localize)(42,null)}]${i}`),t.push(""),g?.noPipe!==!0&&(S.$i?t.push((0,C.localize)(43,null,f)):t.push((0,C.localize)(44,null,f)),t.push(""));const o={},P=[];for(const p in n){const L=n[p];if(L.type==="subcommand")L.description&&P.push({command:p,description:L.description});else if(L.description&&L.cat){let v=o[L.cat];v||(o[L.cat]=v={}),v[p]=L}}for(const p in o){const L=p,v=o[L];v&&(t.push(D[L]),t.push(...r(v,w)),t.push(""))}return P.length&&(t.push((0,C.localize)(45,null)),t.push(...y(P.map(p=>[p.command,p.description]),w)),t.push("")),t.join(`
`)}function c(m,f){return`${m||(0,C.localize)(46,null)}
${f||(0,C.localize)(47,null)}
${process.arch}`}}),function(){"use strict";function oe(e,b,S){function C(j,E){const h=D(j,E),r=[h];return e.isAbsolute(h)||r.unshift(S),e.resolve(...r)}function D(j,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,E);const y=j["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(u,"AppData","Roaming")}break;case"darwin":r=e.join(b.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,E)}return{getUserDataPath:C}}if(typeof define=="function")define(fe[76],de([77,20,15]),function(e,b,S){return oe(e,b,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("os");module.exports=oe(e,b,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],de([0,1,20,74,76]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=j,e.$cn=E;class D extends S.$0m{constructor(r,y){super(r,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,C.getUserDataPath)(r,y.nameShort)},y)}}e.$an=D;function j(h,r){return(0,S.$_m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,r,h.extensionEnvironment)}function E(h,r){return(0,S.$_m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,r,h.extensionEnvironment)}}),define(fe[21],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=C,e.$Bi=D;var b;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=E})(b||(e._util=b={})),e.$zi=C("instantiationService");function S(j,E,h){E[b.DI_TARGET]===E?E[b.DI_DEPENDENCIES].push({id:j,index:h}):(E[b.DI_DEPENDENCIES]=[{id:j,index:h}],E[b.DI_TARGET]=E)}function C(j){if(b.serviceIds.has(j))return b.serviceIds.get(j);const E=function(h,r,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(E,h,y)};return E.toString=()=>j,b.serviceIds.set(j,E),E}function D(j){return j}}),define(fe[35],de([0,1,3,9,73,21,66,7]),function(oe,e,b,S,C,D,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=r,e.$zj=o,e.$Aj=P,e.$Tj=he;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",b.$j),h.set("isLinux",b.$k),h.set("isWindows",b.$i),h.set("isWeb",b.$o),h.set("isMacNative",b.$j&&!b.$o),h.set("isEdge",b.$H),h.set("isFirefox",b.$F),h.set("isChrome",b.$E),h.set("isSafari",b.$G);function r(te,l){if(h.get(te)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(te,l)}const y=Object.prototype.hasOwnProperty;var u;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},a=(0,j.localize)(0,null),c=(0,j.localize)(1,null),m=(0,j.localize)(2,null),f=(0,j.localize)(3,null),s=(0,j.localize)(4,null),n=(0,j.localize)(5,null),g=(0,j.localize)(6,null),w=(0,j.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(l=k){this.k=l,this.d=new C.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(l){if(l===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(l).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const ne=this.D(),R=ne.type===17?n:void 0;throw this.h.push({message:s,offset:ne.offset,lexeme:C.$vj.getLexeme(ne),additionalInfo:R}),i.c}return z}catch(z){if(z!==i.c)throw z;return}}l(){return this.m()}m(){const l=[this.o()];for(;this.y(16);){const z=this.o();l.push(z)}return l.length===1?l[0]:t.or(...l)}o(){const l=[this.s()];for(;this.y(15);){const z=this.s();l.push(z)}return l.length===1?l[0]:t.and(...l)}s(){if(this.y(2)){const l=this.D();switch(l.type){case 11:return this.z(),L.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,f),z?.negate()}case 17:return this.z(),d.create(l.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",l)}}return this.t()}t(){const l=this.D();switch(l.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,f),z}case 17:{const z=l.lexeme;if(this.z(),this.y(9)){const R=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),R.type!==10)throw this.B("REGEX",R);const Y=R.lexeme,H=Y.lastIndexOf("/"),V=H===Y.length-1?void 0:this.w(Y.substring(H+1));let O;try{O=new RegExp(Y.substring(1,H),V)}catch{throw this.B("REGEX",R)}return G.create(z,O)}switch(R.type){case 10:case 19:{const Y=[R.lexeme];this.z();let H=this.D(),V=0;for(let $e=0;$e<R.lexeme.length;$e++)R.lexeme.charCodeAt($e)===40?V++:R.lexeme.charCodeAt($e)===41&&V--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let $e=0;$e<H.lexeme.length;$e++)H.lexeme.charCodeAt($e)===40?V++:R.lexeme.charCodeAt($e)===41&&V--}if(V<0)break;Y.push(C.$vj.getLexeme(H)),this.z(),H=this.D()}const O=Y.join(""),J=O.lastIndexOf("/"),ie=J===O.length-1?void 0:this.w(O.substring(J+1));let ae;try{ae=new RegExp(O.substring(1,J),ie)}catch{throw this.B("REGEX",R)}return t.regex(z,ae)}case 18:{const Y=R.lexeme;this.z();let H=null;if(!(0,S.$$e)(Y)){const V=Y.indexOf("/"),O=Y.lastIndexOf("/");if(V!==O&&V>=0){const J=Y.slice(V+1,O),ie=Y[O+1]==="i"?"i":"";try{H=new RegExp(J,ie)}catch{throw this.B("REGEX",R)}}}if(H===null)throw this.B("REGEX",R);return G.create(z,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const R=this.u();return t.notIn(z,R)}switch(this.D().type){case 3:{this.z();const R=this.u();if(this.x().type===18)return t.equals(z,R);switch(R){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,R)}}case 4:{this.z();const R=this.u();if(this.x().type===18)return t.notEquals(z,R);switch(R){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,R)}}case 5:return this.z(),q.create(z,this.u());case 6:return this.z(),Z.create(z,this.u());case 7:return this.z(),M.create(z,this.u());case 8:return this.z(),A.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:g,offset:l.offset,lexeme:"",additionalInfo:w}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const l=this.D();switch(l.type){case 17:case 18:return this.z(),l.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(l){return l.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(l){return this.C(l)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(l,z){if(this.C(l))return this.z();throw this.B(z,this.D())}B(l,z,ne){const R=(0,j.localize)(8,null,l,C.$vj.getLexeme(z)),Y=z.offset,H=C.$vj.getLexeme(z);return this.h.push({message:R,offset:Y,lexeme:H,additionalInfo:ne}),i.c}C(l){return this.D().type===l}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=i;class t{static false(){return L.INSTANCE}static true(){return v.INSTANCE}static has(l){return $.create(l)}static equals(l,z){return T.create(l,z)}static notEquals(l,z){return I.create(l,z)}static regex(l,z){return G.create(l,z)}static in(l,z){return Q.create(l,z)}static notIn(l,z){return U.create(l,z)}static not(l){return d.create(l)}static and(...l){return le.create(l,null,!0)}static or(...l){return X.create(l,null,!0)}static greater(l,z){return M.create(l,z)}static greaterEquals(l,z){return A.create(l,z)}static smaller(l,z){return q.create(l,z)}static smallerEquals(l,z){return Z.create(l,z)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(l){return l==null?void 0:this.c.parse(l)}}e.$yj=t;function o(te){const l=new i({regexParsingWithErrorRecovery:!1});return te.map(z=>(l.parse(z),l.lexingErrors.length>0?l.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,j.localize)(9,null,ne.additionalInfo):(0,j.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):l.parsingErrors.length>0?l.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}function P(te,l){const z=te?te.substituteConstants():void 0,ne=l?l.substituteConstants():void 0;return!z&&!ne?!0:!z||!ne?!1:z.equals(ne)}function p(te,l){return te.cmp(l)}class L{static{this.INSTANCE=new L}constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}substituteConstants(){return this}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return v.INSTANCE}}e.$Bj=L;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}substituteConstants(){return this}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return L.INSTANCE}}e.$Cj=v;class ${static create(l,z=null){const ne=h.get(l);return typeof ne=="boolean"?ne?v.INSTANCE:L.INSTANCE:new $(l,z)}constructor(l,z){this.key=l,this.c=z,this.type=2}cmp(l){return l.type!==this.type?this.type-l.type:x(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}substituteConstants(){const l=h.get(this.key);return typeof l=="boolean"?l?v.INSTANCE:L.INSTANCE:this}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.$Dj=$;class T{static create(l,z,ne=null){if(typeof z=="boolean")return z?$.create(l,ne):d.create(l,ne);const R=h.get(l);return typeof R=="boolean"?z===(R?"true":"false")?v.INSTANCE:L.INSTANCE:new T(l,z,ne)}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=4}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){const l=h.get(this.c);if(typeof l=="boolean"){const z=l?"true":"false";return this.d===z?v.INSTANCE:L.INSTANCE}return this}evaluate(l){return l.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(l){return l.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ej=T;class Q{static create(l,z){return new Q(l,z)}constructor(l,z){this.d=l,this.f=z,this.type=10,this.c=null}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.d,this.f,l.d,l.f)}equals(l){return l.type===this.type?this.d===l.d&&this.f===l.f:!1}substituteConstants(){return this}evaluate(l){const z=l.getValue(this.f),ne=l.getValue(this.d);return Array.isArray(z)?z.includes(ne):typeof ne=="string"&&typeof z=="object"&&z!==null?y.call(z,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(l){return l.mapIn(this.d,this.f)}negate(){return this.c||(this.c=U.create(this.d,this.f)),this.c}}e.$Fj=Q;class U{static create(l,z){return new U(l,z)}constructor(l,z){this.d=l,this.f=z,this.type=11,this.c=Q.create(l,z)}cmp(l){return l.type!==this.type?this.type-l.type:this.c.cmp(l.c)}equals(l){return l.type===this.type?this.c.equals(l.c):!1}substituteConstants(){return this}evaluate(l){return!this.c.evaluate(l)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(l){return l.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=U;class I{static create(l,z,ne=null){if(typeof z=="boolean")return z?d.create(l,ne):$.create(l,ne);const R=h.get(l);return typeof R=="boolean"?z===(R?"true":"false")?L.INSTANCE:v.INSTANCE:new I(l,z,ne)}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=5}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){const l=h.get(this.c);if(typeof l=="boolean"){const z=l?"true":"false";return this.d===z?L.INSTANCE:v.INSTANCE}return this}evaluate(l){return l.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(l){return l.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=I;class d{static create(l,z=null){const ne=h.get(l);return typeof ne=="boolean"?ne?L.INSTANCE:v.INSTANCE:new d(l,z)}constructor(l,z){this.c=l,this.d=z,this.type=3}cmp(l){return l.type!==this.type?this.type-l.type:x(this.c,l.c)}equals(l){return l.type===this.type?this.c===l.c:!1}substituteConstants(){const l=h.get(this.c);return typeof l=="boolean"?l?L.INSTANCE:v.INSTANCE:this}evaluate(l){return!l.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(l){return l.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Ij=d;function N(te,l){if(typeof te=="string"){const z=parseFloat(te);isNaN(z)||(te=z)}return typeof te=="string"||typeof te=="number"?l(te):L.INSTANCE}class M{static create(l,z,ne=null){return N(z,R=>new M(l,R,ne))}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=12}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){return this}evaluate(l){return typeof this.d=="string"?!1:parseFloat(l.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(l){return l.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Jj=M;class A{static create(l,z,ne=null){return N(z,R=>new A(l,R,ne))}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=13}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){return this}evaluate(l){return typeof this.d=="string"?!1:parseFloat(l.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(l){return l.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Kj=A;class q{static create(l,z,ne=null){return N(z,R=>new q(l,R,ne))}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=14}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){return this}evaluate(l){return typeof this.d=="string"?!1:parseFloat(l.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(l){return l.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Lj=q;class Z{static create(l,z,ne=null){return N(z,R=>new Z(l,R,ne))}constructor(l,z,ne){this.c=l,this.d=z,this.f=ne,this.type=15}cmp(l){return l.type!==this.type?this.type-l.type:ee(this.c,this.d,l.c,l.d)}equals(l){return l.type===this.type?this.c===l.c&&this.d===l.d:!1}substituteConstants(){return this}evaluate(l){return typeof this.d=="string"?!1:parseFloat(l.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(l){return l.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Mj=Z;class G{static create(l,z){return new G(l,z)}constructor(l,z){this.d=l,this.f=z,this.type=7,this.c=null}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.d<l.d)return-1;if(this.d>l.d)return 1;const z=this.f?this.f.source:"",ne=l.f?l.f.source:"";return z<ne?-1:z>ne?1:0}equals(l){if(l.type===this.type){const z=this.f?this.f.source:"",ne=l.f?l.f.source:"";return this.d===l.d&&z===ne}return!1}substituteConstants(){return this}evaluate(l){const z=l.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const l=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${l}`}keys(){return[this.d]}map(l){return l.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Nj=G;class _{static create(l){return new _(l)}constructor(l){this.c=l,this.type=8}cmp(l){return l.type!==this.type?this.type-l.type:this.c.cmp(l.c)}equals(l){return l.type===this.type?this.c.equals(l.c):!1}substituteConstants(){return this}evaluate(l){return!this.c.evaluate(l)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(l){return new _(this.c.map(l))}negate(){return this.c}}e.$Oj=_;function re(te){let l=null;for(let z=0,ne=te.length;z<ne;z++){const R=te[z].substituteConstants();if(te[z]!==R&&l===null){l=[];for(let Y=0;Y<z;Y++)l[Y]=te[Y]}l!==null&&(l[z]=R)}return l===null?te:l}class le{static create(l,z,ne){return le.d(l,z,ne)}constructor(l,z){this.expr=l,this.c=z,this.type=6}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const R=p(this.expr[z],l.expr[z]);if(R!==0)return R}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(l.expr[z]))return!1;return!0}return!1}substituteConstants(){const l=re(this.expr);return l===this.expr?this:le.create(l,this.c,!1)}evaluate(l){for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].evaluate(l))return!1;return!0}static d(l,z,ne){const R=[];let Y=!1;for(const H of l)if(H){if(H.type===1){Y=!0;continue}if(H.type===0)return L.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&Y)return v.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];R.sort(p);for(let H=1;H<R.length;H++)R[H-1].equals(R[H])&&(R.splice(H,1),H--);if(R.length===1)return R[0];for(;R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const V=R.pop(),O=R.length===0,J=X.create(H.expr.map(ie=>le.create([ie,V],null,ne)),null,O);J&&(R.push(J),R.sort(p))}if(R.length===1)return R[0];if(ne){for(let H=0;H<R.length;H++)for(let V=H+1;V<R.length;V++)if(R[H].negate().equals(R[V]))return L.INSTANCE;if(R.length===1)return R[0]}return new le(R,z)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(const z of this.expr)l.push(...z.keys());return l}map(l){return new le(this.expr.map(z=>z.map(l)),null)}negate(){if(!this.c){const l=[];for(const z of this.expr)l.push(z.negate());this.c=X.create(l,this,!0)}return this.c}}e.$Pj=le;class X{static create(l,z,ne){return X.d(l,z,ne)}constructor(l,z){this.expr=l,this.c=z,this.type=9}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const R=p(this.expr[z],l.expr[z]);if(R!==0)return R}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(l.expr[z]))return!1;return!0}return!1}substituteConstants(){const l=re(this.expr);return l===this.expr?this:X.create(l,this.c,!1)}evaluate(l){for(let z=0,ne=this.expr.length;z<ne;z++)if(this.expr[z].evaluate(l))return!0;return!1}static d(l,z,ne){let R=[],Y=!1;if(l){for(let H=0,V=l.length;H<V;H++){const O=l[H];if(O){if(O.type===0){Y=!0;continue}if(O.type===1)return v.INSTANCE;if(O.type===9){R=R.concat(O.expr);continue}R.push(O)}}if(R.length===0&&Y)return L.INSTANCE;R.sort(p)}if(R.length!==0){if(R.length===1)return R[0];for(let H=1;H<R.length;H++)R[H-1].equals(R[H])&&(R.splice(H,1),H--);if(R.length===1)return R[0];if(ne){for(let H=0;H<R.length;H++)for(let V=H+1;V<R.length;V++)if(R[H].negate().equals(R[V]))return v.INSTANCE;if(R.length===1)return R[0]}return new X(R,z)}}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(const z of this.expr)l.push(...z.keys());return l}map(l){return new X(this.expr.map(z=>z.map(l)),null)}negate(){if(!this.c){const l=[];for(const z of this.expr)l.push(z.negate());for(;l.length>1;){const z=l.shift(),ne=l.shift(),R=[];for(const Y of ce(z))for(const H of ce(ne))R.push(le.create([Y,H],null,!1));l.unshift(X.create(R,null,!1))}this.c=X.create(l,this,!0)}return this.c}}e.$Qj=X;class F extends ${static{this.d=[]}static all(){return F.d.values()}constructor(l,z,ne){super(l,null),this.f=z,typeof ne=="object"?F.d.push({...ne,key:l}):ne!==!0&&F.d.push({key:l,description:ne,type:z!=null?typeof z:void 0})}bindTo(l){return l.createKey(this.key,this.f)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(l){return T.create(this.key,l)}notEqualsTo(l){return I.create(this.key,l)}}e.$Rj=F,e.$Sj=(0,D.$Ai)("contextKeyService");function x(te,l){return te<l?-1:te>l?1:0}function ee(te,l,z,ne){return te<z?-1:te>z?1:l<ne?-1:l>ne?1:0}function he(te,l){if(te.type===0||l.type===1)return!0;if(te.type===9)return l.type===9?W(te.expr,l.expr):!1;if(l.type===9){for(const z of l.expr)if(he(te,z))return!0;return!1}if(te.type===6){if(l.type===6)return W(l.expr,te.expr);for(const z of te.expr)if(he(z,l))return!0;return!1}return te.equals(l)}function W(te,l){let z=0,ne=0;for(;z<te.length&&ne<l.length;){const R=te[z].cmp(l[ne]);if(R<0)return!1;R===0&&z++,ne++}return z===te.length}function ce(te){return te.type===9?te.expr:[te]}}),define(fe[79],de([0,1,51,5,9,10,6,69,21,3,19,22]),function(oe,e,b,S,C,D,j,E,h,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=k,e.$9k=f,e.$0k=n,e.$$k=g,e.$_k=w,e.$al=i,e.$bl=t,e.$cl=o,e.$dl=P,e.$el=p,e.$fl=L,e.$hl=T,e.$il=Q,e.$jl=U,e.$kl=I,e.$ll=d,e.$ol=Z,e.$Al=F,e.$Bl=x,e.$Dl=he,e.$7k=(0,h.$Ai)("fileService");function k(W){return W.create===!0}var a;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var m;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function f(W){const ce=W;return!!ce&&typeof ce.onDidChange=="function"}var s;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function n(W){return!!(W.capabilities&2)}function g(W){return!!(W.capabilities&8)}function w(W){return!!(W.capabilities&131072)}function i(W){return!!(W.capabilities&4)}function t(W){return!!(W.capabilities&16)}function o(W){return n(W)?!!(W.capabilities&16384):!1}function P(W){return n(W)?!!(W.capabilities&32768):!1}function p(W){return!!(W.capabilities&65536)}function L(W){return!!(W.capabilities&2048)}var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class $ extends Error{static create(ce,te){const l=new $(ce.toString(),te);return U(l,te),l}constructor(ce,te){super(ce),this.code=te}}e.$gl=$;function T(W,ce){return $.create(W,ce)}function Q(W){return W||T((0,E.localize)(0,null),v.Unknown)}function U(W,ce){return W.name=ce?`${ce} (FileSystemError)`:"FileSystemError",W}function I(W){if(!W)return v.Unknown;if(W instanceof $)return W.code;const ce=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ce)return v.Unknown;switch(ce[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function d(W){if(W instanceof G)return W.fileOperationResult;switch(I(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var N;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class M{constructor(ce,te,l){this.resource=ce,this.operation=te,this.target=l}isOperation(ce){return this.operation===ce}}e.$ml=M;var A;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class q{static{this.a=null}constructor(ce,te){this.c=te,this.b=void 0,this.d=new u.$V(()=>{const l=b.$Gi.forUris(()=>this.c);return l.fill(this.rawAdded.map(z=>[z,!0])),l}),this.f=new u.$V(()=>{const l=b.$Gi.forUris(()=>this.c);return l.fill(this.rawUpdated.map(z=>[z,!0])),l}),this.g=new u.$V(()=>{const l=b.$Gi.forUris(()=>this.c);return l.fill(this.rawDeleted.map(z=>[z,!0])),l}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const l of ce){switch(l.type){case 1:this.rawAdded.push(l.resource);break;case 0:this.rawUpdated.push(l.resource);break;case 2:this.rawDeleted.push(l.resource);break}this.b!==q.a&&(typeof l.cId=="number"?this.b===void 0?this.b=l.cId:this.b!==l.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(ce,...te){return this.h(ce,{includeChildren:!1},...te)}affects(ce,...te){return this.h(ce,{includeChildren:!0},...te)}h(ce,te,...l){if(!ce)return!1;const z=l.length>0;return!!((!z||l.includes(1))&&(this.d.value.get(ce)||te.includeChildren&&this.d.value.findSuperstr(ce))||(!z||l.includes(0))&&(this.f.value.get(ce)||te.includeChildren&&this.f.value.findSuperstr(ce))||(!z||l.includes(2))&&(this.g.value.findSubstr(ce)||te.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$nl=q;function Z(W,ce,te){return!W||!ce||W===ce||ce.length>W.length?!1:(ce.charAt(ce.length-1)!==S.sep&&(ce+=S.sep),te?(0,C.$Cf)(W,ce):W.indexOf(ce)===0)}class G extends Error{constructor(ce,te,l){super(ce),this.fileOperationResult=te,this.options=l}}e.$pl=G;class _ extends G{constructor(ce,te,l,z){super(ce,te,z),this.fileOperationResult=te,this.size=l}}e.$ql=_;class re extends G{constructor(ce,te,l){super(ce,2,l),this.stat=te}}e.$rl=re;var le;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var X;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$zl="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function x(W,ce){if(!ce.hasProvider(j.URI.from({scheme:W.scheme})))return new Promise(te=>{const l=ce.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===W.scheme&&z.added&&(l.dispose(),te())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ce){return(0,D.$eg)(ce)||(ce=0),ce<ee.KB?(0,E.localize)(1,null,ce.toFixed(0)):ce<ee.MB?(0,E.localize)(2,null,(ce/ee.KB).toFixed(2)):ce<ee.GB?(0,E.localize)(3,null,(ce/ee.MB).toFixed(2)):ce<ee.TB?(0,E.localize)(4,null,(ce/ee.GB).toFixed(2)):(0,E.localize)(5,null,(ce/ee.TB).toFixed(2))}}e.$Cl=ee;function he(W){const ce=typeof W=="string"||W?.scheme===y.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===y.Schemas.file?1024*ee.MB:ce?10*ee.MB:r.$o?50*ee.MB:1024*ee.MB}}),define(fe[8],de([0,1,70,56,4,49,2,25,3,23,10,6,35,21]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=m,e.log=s,e.$ik=$,e.$jk=T,e.$kk=Q,e.$lk=U,e.$7j=(0,a.$Ai)("logService"),e.$8j=(0,a.$Ai)("loggerService");function c(){return new Date().toISOString()}function m(I){return(0,y.$eg)(I)}var f;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$0j=f.Info;function s(I,d,N){switch(d){case f.Trace:I.trace(N);break;case f.Debug:I.debug(N);break;case f.Info:I.info(N);break;case f.Warning:I.warn(N);break;case f.Error:I.error(N);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function n(I,d=!1){let N="";for(let M=0;M<I.length;M++){let A=I[M];if(A instanceof Error&&(A=(0,S.$lj)(A,d)),typeof A=="object")try{A=JSON.stringify(A)}catch{}N+=(M>0?" ":"")+A}return N}class g extends j.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new C.$he),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$_j=g;class w extends g{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...N){this.f(f.Trace)&&this.g(f.Trace,n([d,...N],!0))}debug(d,...N){this.f(f.Debug)&&this.g(f.Debug,n([d,...N]))}info(d,...N){this.f(f.Info)&&this.g(f.Info,n([d,...N]))}warn(d,...N){this.f(f.Warning)&&this.g(f.Warning,n([d,...N]))}error(d,...N){if(this.f(f.Error))if(d instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=d.stack,this.g(f.Error,n(M))}else this.g(f.Error,n([d,...N]))}flush(){}}e.$ak=w;class i extends g{constructor(d=e.$0j){super(),this.setLevel(d),this.g=!h.$i}trace(d,...N){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}debug(d,...N){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}info(d,...N){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}warn(d,...N){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,d,...N):console.warn(`[main ${c()}]`,d,...N))}error(d,...N){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,d,...N):console.error(`[main ${c()}]`,d,...N))}flush(){}}e.$bk=i;class t extends g{constructor(d=e.$0j,N=!0){super(),this.g=N,this.setLevel(d)}trace(d,...N){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...N):console.log(d,...N))}debug(d,...N){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...N):console.log(d,...N))}info(d,...N){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...N):console.log(d,...N))}warn(d,...N){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...N):console.log(d,...N))}error(d,...N){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...N):console.error(d,...N))}flush(){}}e.$ck=t;class o extends g{constructor(d,N=e.$0j){super(),this.g=d,this.setLevel(N)}trace(d,...N){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...N])}debug(d,...N){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...N])}info(d,...N){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...N])}warn(d,...N){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...N])}error(d,...N){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...N])}h(d){return typeof d=="string"?d:(0,S.$lj)(d,this.f(f.Trace))}flush(){}}e.$dk=o;class P extends g{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const N of this.g)N.setLevel(d);super.setLevel(d)}trace(d,...N){for(const M of this.g)M.trace(d,...N)}debug(d,...N){for(const M of this.g)M.debug(d,...N)}info(d,...N){for(const M of this.g)M.info(d,...N)}warn(d,...N){for(const M of this.g)M.warn(d,...N)}error(d,...N){for(const M of this.g)M.error(d,...N)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose();super.dispose()}}e.$ek=P;class p extends j.$Uc{constructor(d,N,M){if(super(),this.h=d,this.j=N,this.b=new E.$Ac,this.c=this.B(new C.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$he),this.onDidChangeVisibility=this.g.event,M)for(const A of M)this.b.set(A.resource,{logger:void 0,info:A})}m(d){return(0,y.$ag)(d)?[...this.b.values()].find(N=>N.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,N){const M=this.n(d),A=(0,y.$ag)(d)?d:N?.id??(0,D.$oj)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const Z=N?.logLevel==="always"?f.Trace:N?.logLevel;q||(q=this.s(M,Z??this.getLogLevel(M)??this.h,{...N,id:A}));const G={logger:q,info:{resource:M,id:A,logLevel:Z,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(G.info),this.b.set(M,G),q}n(d){return(0,y.$ag)(d)?(0,r.$bh)(this.j,`${d}.log`):d}setLogLevel(d,N){if(u.URI.isUri(d)){const M=d,A=N,q=this.b.get(M);q&&A!==q.info.logLevel&&(q.info.logLevel=A===this.h?void 0:A,q.logger?.setLevel(A),this.b.set(q.info.resource,q),this.f.fire([M,A]))}else{this.h=d;for(const[M,A]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&A.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,N){const M=this.m(d);M&&N!==!M.info.hidden&&(M.info.hidden=!N,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,N]))}getLogLevel(d){let N;return d&&(N=this.b.get(d)?.info.logLevel),N??this.h}registerLogger(d){const N=this.b.get(d.resource);N?N.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const N=this.b.get(d);N&&(N.logger&&N.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=p;class L{constructor(){this.onDidChangeLogLevel=new C.$he().event}setLevel(d){}getLevel(){return f.Info}trace(d,...N){}debug(d,...N){}info(d,...N){}warn(d,...N){}error(d,...N){}critical(d,...N){}dispose(){}flush(){}}e.$gk=L;class v extends L{}e.$hk=v;function $(I){if(I.verbose)return f.Trace;if(typeof I.logLevel=="string"){const d=U(I.logLevel.toLowerCase());if(d!==void 0)return d}return e.$0j}function T(I){switch(I){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function Q(I){switch(I){case f.Trace:return{original:"Trace",value:b.localize(0,null)};case f.Debug:return{original:"Debug",value:b.localize(1,null)};case f.Info:return{original:"Info",value:b.localize(2,null)};case f.Warning:return{original:"Warning",value:b.localize(3,null)};case f.Error:return{original:"Error",value:b.localize(4,null)};case f.Off:return{original:"Off",value:b.localize(5,null)}}}function U(I){switch(I){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$mk=new k.$Rj("logLevel",T(f.Info))}),define(fe[80],de([0,1,6,4,8,2]),function(oe,e,b,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0;class j extends C.$fk{constructor(u,k,a,c,m){super(k,a,c),this.r=u,this.t=m,this.B(m.listen("onDidChangeLogLevel",u)(f=>{(0,C.$9j)(f)?super.setLogLevel(f):super.setLogLevel(b.URI.revive(f[0]),f[1])})),this.B(m.listen("onDidChangeVisibility",u)(([f,s])=>super.setVisibility(b.URI.revive(f),s))),this.B(m.listen("onDidChangeLoggers",u)(({added:f,removed:s})=>{for(const n of f)super.registerLogger({...n,resource:b.URI.revive(n.resource)});for(const n of s)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new C.$dk({log:(u,k)=>{this.t.call("consoleLog",[u,k])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,k){super.setLogLevel(u,k),this.t.call("setLogLevel",[u,k])}setVisibility(u,k){super.setVisibility(u,k),this.t.call("setVisibility",[this.n(u),k])}s(u,k,a){return new E(this.t,u,k,a,this.r)}static setLogLevel(u,k,a){return u.call("setLogLevel",[k,a])}}e.$fs=j;class E extends C.$ak{constructor(u,k,a,c,m){super(c?.logLevel==="always"),this.r=u,this.s=k,this.m=!1,this.n=[],this.setLevel(a),this.r.call("createLogger",[k,c,m]).then(()=>{this.u(this.n),this.m=!0})}g(u,k){const a=[[u,k]];this.m?this.u(a):this.n.push(...a)}u(u){this.r.call("log",[this.s,u])}}class h{constructor(u,k){this.a=u,this.b=k}listen(u,k){const a=this.b(u);switch(k){case"onDidChangeLoggers":return S.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(m=>this.c(m,a)),removed:[...c.removed].map(m=>this.c(m,a))}));case"onDidChangeVisibility":return S.Event.map(this.a.onDidChangeVisibility,c=>[a.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return S.Event.map(this.a.onDidChangeLogLevel,c=>(0,C.$9j)(c)?c:[a.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${k}`)}async call(u,k,a){const c=this.b(u);switch(k){case"setLogLevel":return(0,C.$9j)(a[0])?this.a.setLogLevel(a[0]):this.a.setLogLevel(b.URI.revive(c.transformIncoming(a[0][0])),a[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,c)))}throw new Error(`Call not found: ${k}`)}c(u,k){return{...u,resource:k.transformOutgoingURI(u.resource)}}}e.$gs=h;class r extends D.$Uc{constructor(u,k){super(),k.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(a=>k.call("setLogLevel",[a]))),k.call("getRegisteredLoggers").then(a=>{for(const c of a)u.registerLogger({...c,resource:b.URI.revive(c.resource)})}),this.B(k.listen("onDidChangeVisibility")(([a,c])=>u.setVisibility(b.URI.revive(a),c))),this.B(k.listen("onDidChangeLoggers")(({added:a,removed:c})=>{for(const m of a)u.registerLogger({...m,resource:b.URI.revive(m.resource)});for(const m of c)u.deregisterLogger(m.resource)}))}}e.$hs=r}),define(fe[81],de([0,1,2,8]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class C extends b.$Uc{constructor(j,E=[]){super(),this.a=new S.$ek([j,...E]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...E){this.a.trace(j,...E)}debug(j,...E){this.a.debug(j,...E)}info(j,...E){this.a.info(j,...E)}warn(j,...E){this.a.warn(j,...E)}error(j,...E){this.a.error(j,...E)}flush(){this.a.flush()}}e.$fQ=C}),define(fe[82],de([0,1,79,8]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var C;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(C||(C={}));async function D(r,y,u,k,a){try{const c=await new Promise((f,s)=>{oe(["@vscode/spdlog"],f,s)});c.setFlushOn(C.Trace);const m=await c.createAsyncRotatingLogger(r,y,u,k);return a?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(c){console.error(c)}return null}function j(r,y,u){switch(y){case S.LogLevel.Trace:r.trace(u);break;case S.LogLevel.Debug:r.debug(u);break;case S.LogLevel.Info:r.info(u);break;case S.LogLevel.Warning:r.warn(u);break;case S.LogLevel.Error:r.error(u);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function E(r,y){switch(y){case S.LogLevel.Trace:r.setLevel(C.Trace);break;case S.LogLevel.Debug:r.setLevel(C.Debug);break;case S.LogLevel.Info:r.setLevel(C.Info);break;case S.LogLevel.Warning:r.setLevel(C.Warning);break;case S.LogLevel.Error:r.setLevel(C.Error);break;case S.LogLevel.Off:r.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class h extends S.$ak{constructor(y,u,k,a,c){super(),this.m=[],this.setLevel(c),this.n=this.s(y,u,k,a),this.B(this.onDidChangeLogLevel(m=>{this.r&&E(this.r,m)}))}async s(y,u,k,a){const c=k?6:1,m=30/c*b.$Cl.MB,f=await D(y,u,m,c,a);if(f){this.r=f,E(this.r,this.getLevel());for(const{level:s,message:n}of this.m)j(this.r,s,n);this.m=[]}}g(y,u){this.r?j(this.r,y,u):this.getLevel()<=y&&this.m.push({level:y,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=h}),define(fe[83],de([0,1,52,8,82]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;class D extends S.$fk{s(E,h,r){return new C.$7P((0,b.$Wg)(),E.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,h)}}e.$8P=D}),define(fe[84],de([0,1,15]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const D=C.context.configuration();if(D)S=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(S=globalThis._VSCODE_PRODUCT_JSON,b.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),!S.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(S,{version:D.version})}}else S={nameShort:"Code - Insiders",nameLong:"Visual Studio Code - Insiders",applicationName:"code-insiders",win32x64AppId:"{{1287CAD5-7C8D-410D-88B9-0D1EE4A83FF2}",win32arm64AppId:"{{0AEDB616-9614-463B-97D7-119DD86CCA64}",win32x64UserAppId:"{{217B4C08-948D-4276-BFBB-BEE930AE5A2C}",win32arm64UserAppId:"{{69BD8F7B-65EB-4C6F-A14E-44CFA83712C0}",win32NameVersion:"Microsoft Visual Studio Code Insiders",win32DirName:"Microsoft VS Code Insiders",win32SetupExeBasename:"VSCodeInsidersSetup",win32AppUserModelId:"Microsoft.VisualStudioCodeInsiders",win32ShellNameShort:"Code Insiders",win32MutexName:"vscodeinsiders",win32RegValueName:"VSCodeInsiders",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCodeInsiders",darwinExecutable:"VSCodeInsiders",linuxIconName:"vscode-insiders",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server-insiders",urlProtocol:"vscode-insiders",dataFolderName:".vscode-insiders",serverDataFolderName:".vscode-server-insiders",downloadUrl:"https://code.visualstudio.com/insiders",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://insiders.vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"insider",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",searchUrl:"https://marketplace.visualstudio.com/_apis/public/gallery/searchrelevancy/extensionquery",servicePPEUrl:"https://marketplace.vsallin.net/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code-insiders?aid=f047834f-d0e1-4aef-8870-5805ee483b2d","win32-arm64":"appcenter://code-insiders?aid=fb1c1670-432e-43dc-a88e-8c5ed7293213","linux-x64":"appcenter://code-insiders?aid=a04472a4-f4ea-4854-bf12-95bb0f2dd01a",darwin:"appcenter://code-insiders?aid=5e4c15d3-0a3c-4c3b-a294-2a40850616a2","darwin-arm64":"appcenter://code-insiders?aid=d6599f8f-6aee-4013-b47c-1e1269faa19a","darwin-universal":"appcenter://code-insiders?aid=9198980f-302c-4143-9ddf-29914b57be2e"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkId=724002",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=761088",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions","interactive","terminalDataWriteEvent"],"GitHub.copilot-nightly":["inlineCompletionsAdditions","interactive","terminalDataWriteEvent"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatProvider","chatParticipant","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"GitHub.copilot-nes":["inlineEdit"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipant","chatParticipantAdditions","embeddings","languageModels","languageModelSystem"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatParticipant","languageModels"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.git","vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.git","vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["vscode.git","ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["vscode.git","ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync-insiders.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!0,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},enableSyncingProfiles:!0,"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel-insiders",tunnelApplicationConfig:{editorWebUrl:"https://insiders.vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscodeinsiders-tunnelservice",win32TunnelMutex:"vscodeinsiders-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to GitHub Copilot, an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://code.visualstudio.com/docs/copilot/overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%2C%7B%22installPreReleaseVersion%22%3Atrue%7D%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.90.0-insider",commit:"f209ce35ef894bd32c12057724e8d1f1139c433f",date:"2024-05-17T17:05:01.315Z"},Object.keys(S).length===0&&Object.assign(S,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=S}),define(fe[85],de([0,1,21]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,b.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(fe[86],de([0,1,42,10]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class C{constructor(){this.a=new Map}add(j,E){b.ok(S.$ag(j)),b.ok(S.$cg(E)),b.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,E)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$ho=new C}),define(fe[87],de([0,1,4,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gvb=void 0;class C extends S.$Uc{constructor(j){super(),this.f=j,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new b.$he),this.onMarkAdded=this.c.event}*markers(){for(const j of this.a.values())yield j;for(const j of this.b.values())yield j}addMark(j){const E=j?.marker||this.f.registerMarker(),h=j?.id;E&&(h?(this.a.set(h,E),E.onDispose(()=>this.a.delete(h))):(this.b.set(E.id,E),E.onDispose(()=>this.b.delete(E.id))),this.c.fire({marker:E,id:h,hidden:j?.hidden,hoverMessage:j?.hoverMessage}))}getMark(j){return this.a.get(j)}}e.$gvb=C});var ze=this&&this.__param||function(oe,e){return function(b,S){e(b,S,oe)}};define(fe[88],de([0,1,4,2,8,14]),function(oe,e,b,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;var j;(function(h){h[h.Unknown=0]="Unknown",h[h.Input=1]="Input",h[h.Execute=2]="Execute"})(j||(j={}));let E=class extends S.$Uc{get value(){return this.j}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,y,u,k){super(),this.w=r,this.z=k,this.a=0,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new b.$he),this.onDidStartInput=this.r.event,this.s=this.B(new b.$he),this.onDidChangeInput=this.s.event,this.t=this.B(new b.$he),this.onDidFinishInput=this.t.event,this.u=this.B(new b.$he),this.onDidInterrupt=this.u.event,this.B(b.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(a=>this.I(a))),this.B(y(a=>this.D(a))),this.B(u(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===C.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let y=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(y+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,y+=`${r.substring(this.ghostTextIndex)}]`):y+=r.substring(this.cursorIndex),y}D(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===2)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=2,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const y=this.w.buffer.active;let u=y.getLine(r);const k=u?.translateToString(!0,this.c);if(!u||k===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const a=y.baseY+y.cursorY;let c=k,m=a===r?this.O(this.c,y,u):k.trimEnd().length+1,f=-1;a===r&&y.cursorX>1&&(f=this.J(y,u,m));for(let s=r+1;s<=a;s++){u=y.getLine(s);const n=u?.translateToString(!0);if(n&&u)if(this.g===void 0||this.M(n)){const g=this.L(n);if(c+=`
${g}`,a===s){const w=this.N(u,n),i=this.O(w,y,u);m+=i}else m+=g.length+1}else break}for(let s=a+1;s<y.baseY+this.w.rows;s++){u=y.getLine(s);const n=u?.translateToString(!0);if(n&&u)if(this.g===void 0||this.M(n))c+=`
${this.L(n)}`;else break;else break}this.z.getLevel()===C.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let s=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",m===this.m-1&&(this.j.trimEnd().length>c.trimEnd().length&&c.trimEnd().length<=m?s=Math.max(this.j.length-1-c.trimEnd().length,0):s=Math.max(s-1,0))),this.h==="\x1B[3~"&&(this.h="",m===this.m&&(s=Math.max(s-1,0)));const n=c.split(`
`),g=n.length>1,w=c.trimEnd();if(!g){w.length<c.length&&(this.h===" "&&(this.h="",m>w.length&&m>this.m&&s++),s=Math.max(m-w.length,s,0));const i=m===0?"":c[m-1];s>0&&m===this.m+1&&this.h!==""&&i!==" "&&(s=this.j.length-this.m)}if(g){n[n.length-1]=n.at(-1)?.trimEnd()??"";const i=(n.length-1)*(this.g?.length??0);s=Math.max(0,m-c.length-i)}c=n.map(i=>i.trimEnd()).join(`
`)+" ".repeat(s)}(this.j!==c||this.m!==m||this.n!==f)&&(this.j=c,this.m=m,this.n=f,this.s.fire(this.Q()))}I(r){this.h=r}J(r,y,u){let k=-1,a=!1,c=r.cursorX;for(;c>0;){const m=y.getCell(--c);if(!m)break;if(m.getChars().trim().length>0){a=!this.P(m);break}}if(a){let m=0,f=r.cursorX;for(;f<y.length;){const s=y.getCell(f++);if(!s||s.getCode()===0)break;if(this.P(s)){k=u+m;break}m+=s.getChars().length}}return k}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,y){if(!this.g||!y.startsWith(this.g))return 0;let u="",k=0;for(;u!==this.g;)u+=r.getCell(k++).getChars();return k}O(r,y,u){return u?.translateToString(!0,r,y.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$9r=E,pe([(0,D.$7h)(0)],E.prototype,"G",null),e.$9r=E=pe([ze(3,C.$7j)],E)}),define(fe[89],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0;class b{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(y){this.b.endMarker=y}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(y,u){this.a=y,this.b=u}static deserialize(y,u,k){const a=y.buffer.normal,c=u.startLine!==void 0?y.registerMarker(u.startLine-(a.baseY+a.cursorY)):void 0;if(!c)return;const m=u.promptStartLine!==void 0?y.registerMarker(u.promptStartLine-(a.baseY+a.cursorY)):void 0,f=u.endLine!==void 0?y.registerMarker(u.endLine-(a.baseY+a.cursorY)):void 0,s=u.executedLine!==void 0?y.registerMarker(u.executedLine-(a.baseY+a.cursorY)):void 0;return new b(y,{command:k?"":u.command,commandLineConfidence:u.commandLineConfidence??"low",isTrusted:u.isTrusted,promptStartMarker:m,marker:c,startX:u.startX,endMarker:f,executedMarker:s,executedX:u.executedX,timestamp:u.timestamp,duration:u.duration,cwd:u.cwd,commandStartLineContent:u.commandStartLineContent,exitCode:u.exitCode,markProperties:u.markProperties,aliases:void 0,wasReplayed:!0})}serialize(y){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:y?"":this.command,commandLineConfidence:y?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return C(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const y=this.executedMarker.line,u=this.endMarker.line;if(y===u)return;let k="",a;for(let c=y;c<u;c++)a=this.a.buffer.active.getLine(c),a&&(k+=a.translateToString(!a.isWrapped)+(a.isWrapped?"":`
`));return k===""?void 0:k}getOutputMatch(y){if(!this.executedMarker||!this.endMarker)return;const u=this.endMarker.line;if(u===-1)return;const k=this.a.buffer.active,a=Math.max(this.executedMarker.line,0),c=y.lineMatcher,m=typeof c=="string"?1:y.length||j(c),f=[];let s;if(y.anchor==="bottom")for(let n=u-(y.offset||0);n>=a;n--){let g=n;const w=n;for(;g>=a&&k.getLine(g)?.isWrapped;)g--;if(n=g,f.unshift(D(k,g,w,this.a.cols)),s||(s=f[0].match(c)),f.length>=m)break}else for(let n=a+(y.offset||0);n<u;n++){const g=n;let w=n;for(;w+1<u&&k.getLine(w+1)?.isWrapped;)w++;if(n=w,f.push(D(k,g,w,this.a.cols)),s||(s=f[f.length-1].match(c)),f.length>=m)break}return s?{regexMatch:s,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return E(this,this.a.buffer.active)}getCommandRowCount(){return h(this)}}e.$0r=b;class S{constructor(y){this.c=y}serialize(y){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:y,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(y,u,k,a){if(u===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||k)return new b(this.c,{command:k?"":this.command||"",commandLineConfidence:k?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:y,exitCode:u,commandStartLineContent:this.commandStartLineContent,markProperties:a})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return C(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return E(this,this.c.buffer.active)}getCommandRowCount(){return h(this)}}e.$$r=S;function C(r,y,u,k,a,c){if(!u||!a||k===void 0||c===void 0)return"";let m="";for(let f=u.line;f<=a.line;f++){const s=r.getLine(f);s&&(m+=s.translateToString(!0,f===u.line?k:0,f===a.line?c:y))}return m}function D(r,y,u,k){const a=Math.max(2048/k*2);u=Math.min(u,y+a);let c="";for(let m=y;m<=u;m++){const f=r.getLine(m);f&&(c+=f.translateToString(!0,0,k))}return c}function j(r){if(!r.multiline)return 1;const y=r.source;let u=1,k=y.indexOf("\\n");for(;k!==-1;)u++,k=y.indexOf("\\n",k+1);return u}function E(r,y){const u="hasOutput"in r?r.marker:r.commandStartMarker;if(!u||!r.promptStartMarker)return 1;let k=1,a=r.promptStartMarker.line;for(;a<u.line&&(y.getLine(a)?.translateToString(!0)??"").length===0;)a++;return k=u.line-a+1,k}function h(r){const y="hasOutput"in r?r.marker:r.commandStartMarker,u="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!y||!u)return 1;let a=Math.max(u.line,y.line)-y.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&a--,a}}),define(fe[90],de([0,1,12,14,4,2,8,89,88]),function(oe,e,b,S,C,D,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cvb=void 0,e.$dvb=a;let r=class extends D.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}get D(){return!!(this.n.commandStartMarker&&!this.n.commandExecutedMarker)}get hasInput(){if(!(!this.D||!this.n?.commandStartMarker)){if(this.M.buffer.active.baseY+this.M.buffer.active.cursorY===this.n.commandStartMarker?.line){const s=this.M.buffer.active.getLine(this.M.buffer.active.cursorY)?.translateToString(!0,this.n.commandStartX);return s===void 0?void 0:s.length>0}return!0}}constructor(s,n){super(),this.M=s,this.N=n,this.type=2,this.f=[],this.n=new E.$$r(this.M),this.r=[],this.t=!1,this.F=this.B(new C.$he),this.onCommandStarted=this.F.event,this.G=this.B(new C.$he),this.onBeforeCommandFinished=this.G.event,this.H=this.B(new C.$he),this.onCommandFinished=this.H.event,this.I=this.B(new C.$he),this.onCommandExecuted=this.I.event,this.J=this.B(new C.$he),this.onCommandInvalidated=this.J.event,this.L=this.B(new C.$he),this.onCurrentCommandInvalidated=this.L.event,this.c=this.B(new h.$9r(this.M,this.onCommandStarted,this.onCommandExecuted,this.N)),this.B(this.onCommandExecuted(w=>{if(w.commandLineConfidence!=="high"){const i=w;w.command=i.extractCommandLine(),w.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&w.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(w.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&w.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(w.commandLineConfidence="medium")}}));const g=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return g.L}get onCommandStartedEmitter(){return g.F}get onCommandExecutedEmitter(){return g.I}get dimensions(){return g.s}get isCommandStorageDisabled(){return g.t}get commandMarkers(){return g.r}set commandMarkers(w){g.r=w}get clearCommandsInViewport(){return g.Q.bind(g)}commitCommandFinished(){g.w?.flush(),g.w=void 0}},this.C=this.B(new D.$Wc(new y(this.M,this,this.z,this.N))),this.s={cols:this.M.cols,rows:this.M.rows},this.B(this.M.onResize(w=>this.O(w))),this.B(this.M.onCursorMove(()=>this.P()))}O(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}P(){this.M.buffer.active===this.M.buffer.normal&&this.n.commandStartMarker&&this.M.buffer.active.baseY+this.M.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.Q(),this.n.isInvalid=!0,this.L.fire({reason:"windows"}))}Q(){let s=0;for(let n=this.f.length-1;n>=0;n--){const g=this.f[n].marker?.line;if(g&&g<this.M.buffer.active.baseY)break;s++}s>0&&this.J.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,n){this.N.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(n)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof k)){const n=this;this.C.value=new k(this.M,this,new class{get onCurrentCommandInvalidatedEmitter(){return n.L}get onCommandStartedEmitter(){return n.F}get onCommandExecutedEmitter(){return n.I}get dimensions(){return n.s}get isCommandStorageDisabled(){return n.t}get commandMarkers(){return n.r}set commandMarkers(g){n.r=g}get clearCommandsInViewport(){return n.Q.bind(n)}commitCommandFinished(){n.w?.flush(),n.w=void 0}},this.N)}else!s&&!(this.C.value instanceof y)&&(this.C.value=new y(this.M,this,this.z,this.N))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let n=this.commands.length-1;n>=0;n--)if((this.commands[n].promptStartMarker??this.commands[n].marker).line<=s)return this.commands[n]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const n=this.getCommandForLine(s);if(n&&"cwd"in n)return n.cwd}handlePromptStart(s){const n=this.commands.at(-1);n?.endMarker&&n?.executedMarker&&n.endMarker.line===n.executedMarker.line&&(this.N.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${n.endMarker.line} -> ${n.executedMarker.line+1}`),n.endMarker=m(this.M,n.executedMarker,1)),this.n.promptStartMarker=s?.marker||(n?.endMarker?m(this.M,n.endMarker):this.M.registerMarker(0)),this.N.debug("CommandDetectionCapability#handlePromptStart",this.M.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.M.registerMarker(0),this.N.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.N.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.M.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.N.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.M.buffer.active.cursorY){this.n.commandStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,n){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.N.debug("CommandDetectionCapability#handleCommandFinished",this.M.buffer.active.cursorX,n?.marker?.line,this.n.command,this.n),s===void 0){const w=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&w?.command===this.n.command&&(s=w.exitCode)}if(this.n.commandStartMarker===void 0||!this.M.buffer.active)return;this.n.commandFinishedMarker=n?.marker||this.M.registerMarker(0),this.C.value.postHandleCommandFinished?.();const g=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,n?.markProperties);g&&(this.f.push(g),this.w=new b.$Mh(()=>{this.G.fire(g),this.n.isInvalid||(this.N.debug("CommandDetectionCapability#onCommandFinished",g),this.H.fire(g))},50),this.w.schedule()),this.n=new E.$$r(this.M),this.u=void 0}setCommandLine(s,n){this.N.debug("CommandDetectionCapability#setCommandLine",s,n),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=n,n&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map(g=>g.serialize(this.t)),n=this.n.serialize(this.g);return n&&s.push(n),{isWindowsPty:this.C.value instanceof k,commands:s}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const n=this.M.buffer.normal;for(const g of s.commands){if(!g.endLine){const i=g.startLine!==void 0?this.M.registerMarker(g.startLine-(n.baseY+n.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=g.startLine!==void 0?this.M.registerMarker(g.startLine-(n.baseY+n.cursorY)):void 0,this.n.commandStartX=g.startX,this.n.promptStartMarker=g.promptStartLine!==void 0?this.M.registerMarker(g.promptStartLine-(n.baseY+n.cursorY)):void 0,this.g=g.cwd,this.F.fire({marker:i});continue}const w=E.$0r.deserialize(this.M,g,this.t);w&&(this.f.push(w),this.N.debug("CommandDetectionCapability#onCommandFinished",w),this.H.fire(w))}}};e.$cvb=r,pe([(0,S.$6h)(500)],r.prototype,"P",null),e.$cvb=r=pe([ze(1,j.$7j)],r);class y extends D.$Uc{constructor(s,n,g,w){super(),this.c=s,this.f=n,this.g=g,this.h=w,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&g.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const n=this.f.currentCommand;n.commandStartX=this.c.buffer.active.cursorX,n.commandStartMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedMarker?.dispose(),n.commandExecutedMarker=void 0,n.commandExecutedX=void 0;for(const g of this.g.commandMarkers)g.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||n.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",n.commandStartX,n.commandStartMarker?.line)}handleCommandExecuted(s){const n=this.f.currentCommand;if(n.commandExecutedMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",n.commandExecutedX,n.commandExecutedMarker?.line),!n.commandStartMarker||!n.commandExecutedMarker||n.commandStartX===void 0)return;n.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(n.commandStartMarker.line)?.translateToString(!0,n.commandStartX,n.commandRightPromptStartX).trim();let g=n.commandStartMarker.line+1;const w=n.commandExecutedMarker.line;for(;g<w;g++){const i=this.c.buffer.active.getLine(g);if(i){const t=n.continuations?.find(P=>P.marker.line===g);t&&(n.command+=`
`);const o=t?.end??0;n.command+=i.translateToString(!0,o)}}g===w&&(n.command+=this.c.buffer.active.getLine(w)?.translateToString(!0,void 0,n.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(n)}}var u;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(u||(u={}));let k=class extends D.$Uc{constructor(s,n,g,w){super(),this.n=s,this.r=n,this.s=g,this.t=w,this.c=this.B(new D.$Vc),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(s){const n=this.n.buffer.active.baseY,g=s.rows-this.s.dimensions.rows;g>0&&this.D().then(()=>{const w=Math.min(g,n);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<n||t.commandStartLineContent===void 0)break;const o=this.n.buffer.active.getLine(t.marker.line);if(!o||o.translateToString(!0)===t.commandStartLineContent)continue;const P=t.marker.line-w;this.n.buffer.active.getLine(P)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:w})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?m(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new b.$Mh(()=>this.u(s),20),this.f.schedule()}u(s){if(this.q.isDisposed)return;const n=this.n.buffer.active;let g=this.g;for(;g<10&&s.line+g<n.baseY+this.n.rows;){if(this.C()){const w=this.F(s.line+g);if(w){const i=typeof w=="string"?w:w.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof w=="object"&&w.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=m(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=m(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}g++}g<10?(this.g=g,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,n=s.command,g=s.commandStartMarker?.line,w=s.commandExecutedMarker?.line;if(!n||n.length===0||g===void 0||g===-1||w===void 0||w===-1)return;let i=0,t=!1;for(let o=g;o<=w;o++){const P=this.n.buffer.active.getLine(o);if(!P)break;const p=P.translateToString(!0);for(let L=0;L<p.length;L++){for(;n.length<i&&n[i]===" ";)i++;if(p[L]===n[i]&&i++,i===n.length){const v=L>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(o-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(v?1:0)),s.commandExecutedX=v?0:L+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,n)=>s.line-n.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,g=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return n>g}D(){const s=this.n.buffer.active.cursorX,n=this.n.buffer.active.cursorY;let g=0;return new Promise((w,i)=>{const t=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||n!==this.n.buffer.active.cursorY){w(),clearInterval(t);return}g+=10,g>1e3&&(clearInterval(t),w())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const n=this.n.buffer.active.getLine(s);if(!n)return;const g=n.translateToString(!0);if(!g)return;const w=g.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(w){const p=this.G(w,g,">");if(p)return{prompt:p,likelySingleLine:!0}}const i=g.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const p=this.G(i,g,"\u276F");if(p)return p}const t=g.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const p=this.G(t,g,"$");if(p)return p}const o=g.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(o)return{prompt:o,likelySingleLine:!0};if(this.r.promptTerminator&&g.trim().endsWith(this.r.promptTerminator)){const p=this.G(g,g,this.r.promptTerminator);if(p)return p}const P=g.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return P?.groups?.prompt?{prompt:P.groups.prompt,likelySingleLine:!0}:void 0}G(s,n,g){if(s)return n===s&&s.endsWith(g)&&(s+=" "),s}};k=pe([ze(3,j.$7j)],k);function a(f,s,n,g){if(!g)return;const w=s.executedMarker,i=s.endMarker;if(!w||!i)return;const t=w.line,o=i.line,P=g.length,p=[];if(g.anchor==="bottom")for(let L=o-(g.offset||0);L>=t;L--){let v=L;const $=L;for(;v>=t&&f.getLine(v)?.isWrapped;)v--;L=v,p.unshift(c(f,v,$,n)),p.length>P&&p.pop()}else for(let L=t+(g.offset||0);L<o;L++){const v=L;let $=L;for(;$+1<o&&f.getLine($+1)?.isWrapped;)$++;L=$,p.push(c(f,v,$,n)),p.length===P&&p.shift()}return p}function c(f,s,n,g){const w=Math.max(2048/g*2);n=Math.min(n,s+w);let i="";for(let t=s;t<=n;t++){const o=f.getLine(t);o&&(i+=o.translateToString(!0,0,g))}return i}function m(f,s,n=0){return f.registerMarker(s.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+n)}}),define(fe[91],de([0,1,4,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$evb=void 0;class C extends S.$Uc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new b.$he),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(j){const E=this.a!==j;this.a=j;const h=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,h+1),E&&this.c.fire(j)}}e.$evb=C}),define(fe[92],de([0,1,4,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fvb=void 0;var C;(function(j){j[j.MinimumPromptLength=2]="MinimumPromptLength"})(C||(C={}));class D extends S.$Tc{get commands(){return this.a}constructor(E){super(),this.c=E,this.type=3,this.a=[],this.b=this.add(new b.$he),this.onCommandFinished=this.b.event,this.add(this.c.onData(h=>this.h(h))),this.add(this.c.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this.m(),!1)))}h(E){E==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const E=this.c.registerMarker(0);E&&(this.a.push(E),this.b.fire(E))}}m(){let E=0;for(let h=this.a.length-1;h>=0&&!(this.a[h].line<this.c.buffer.active.baseY);h--)E++;this.a.splice(this.a.length-E,E)}}e.$fvb=D}),define(fe[93],de([0,1,4,2]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bvb=e.$avb=void 0;class C extends S.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new b.$he),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new b.$he),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new b.$he),this.onDidRemoveCapability=this.g.event,this.h=this.B(new b.$he),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(E,h){this.a.set(E,h),this.f.fire(E),this.h.fire({id:E,capability:h})}get(E){return this.a.get(E)}remove(E){const h=this.a.get(E);h&&(this.a.delete(E),this.b.fire(E),this.h.fire({id:E,capability:h}))}has(E){return this.a.has(E)}}e.$avb=C;class D extends S.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new b.$he),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new b.$he),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new b.$he),this.onDidRemoveCapability=this.f.event,this.g=this.B(new b.$he),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const E of this._stores)for(const h of E.items)yield h}has(E){for(const h of this._stores)for(const r of h.items)if(r===E)return!0;return!1}get(E){for(const h of this._stores){const r=h.get(E);if(r)return r}}add(E){this._stores.push(E);for(const h of E.items)this.b.fire(h),this.g.fire({id:h,capability:E.get(h)});this.B(E.onDidAddCapabilityType(h=>this.b.fire(h))),this.B(E.onDidAddCapability(h=>this.g.fire(h))),this.B(E.onDidRemoveCapabilityType(h=>this.a.fire(h))),this.B(E.onDidRemoveCapability(h=>this.f.fire(h)))}}e.$bvb=D}),define(fe[36],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var b;(function(S){S[S.Replace=1]="Replace",S[S.Append=2]="Append",S[S.Prepend=3]="Prepend"})(b||(e.EnvironmentVariableMutatorType=b={}))}),define(fe[94],de([0,1,3,36]),function(oe,e,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;const C=new Map([[S.EnvironmentVariableMutatorType.Append,"APPEND"],[S.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[S.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((u,k)=>{this.d(u,k);const a=u.map.entries();let c=a.next();for(;!c.done;){const m=c.value[1],f=c.value[0];let s=this.a.get(f);if(s||(s=[],this.a.set(f,s)),s.length>0&&s[0].type===S.EnvironmentVariableMutatorType.Replace){c=a.next();continue}const n={extensionIdentifier:k,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};n.scope||delete n.scope,s.unshift(n),c=a.next()}})}async applyToProcessEnvironment(y,u,k){let a;b.$i&&(a={},Object.keys(y).forEach(c=>a[c.toLowerCase()]=c));for(const[c,m]of this.getVariableMap(u)){const f=b.$i&&a[c.toLowerCase()]||c;for(const s of m){const n=k?await k(s.value):s.value;if(s.options?.applyAtProcessCreation??!0)switch(s.type){case S.EnvironmentVariableMutatorType.Append:y[f]=(y[f]||"")+n;break;case S.EnvironmentVariableMutatorType.Prepend:y[f]=n+(y[f]||"");break;case S.EnvironmentVariableMutatorType.Replace:y[f]=n;break}if(s.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${C.get(s.type)}`;y[g]=(y[g]?y[g]+":":"")+c+"="+this.c(n)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,u){const k=new Map,a=new Map,c=new Map;if(y.getVariableMap(u).forEach((m,f)=>{const s=this.getVariableMap(u).get(f),n=E(m,s);n&&k.set(f,n)}),this.getVariableMap(u).forEach((m,f)=>{const s=y.getVariableMap(u).get(f),n=E(m,s);n&&c.set(f,n)}),this.getVariableMap(u).forEach((m,f)=>{const s=y.getVariableMap(u).get(f),n=h(m,s);n&&a.set(f,n)}),!(k.size===0&&a.size===0&&c.size===0))return{added:k,changed:a,removed:c}}getVariableMap(y){const u=new Map;for(const k of this.a.values()){const a=k.filter(c=>j(c,y));a.length>0&&u.set(a[0].variable,a)}return u}getDescriptionMap(y){const u=new Map;for(const k of this.b.values()){const a=k.filter(c=>j(c,y,!0));for(const c of a)u.set(c.extensionIdentifier,c.description)}return u}d(y,u){if(!y.descriptionMap)return;const k=y.descriptionMap.entries();let a=k.next();for(;!a.done;){const c=a.value[1],m=a.value[0];let f=this.b.get(m);f||(f=[],this.b.set(m,f));const s={extensionIdentifier:u,scope:c.scope,description:c.description};s.scope||delete s.scope,f.push(s),a=k.next()}}}e.$xs=D;function j(r,y,u=!1){return r.scope?!!(r.scope.workspaceFolder&&y?.workspaceFolder&&r.scope.workspaceFolder.index===y.workspaceFolder.index):u?y===r.scope:!0}function E(r,y){if(!y)return r;const u=new Set;y.forEach(a=>u.add(a.extensionIdentifier));const k=[];return r.forEach(a=>{u.has(a.extensionIdentifier)||k.push(a)}),k.length===0?void 0:k}function h(r,y){if(!y)return;const u=new Map;y.forEach(a=>u.set(a.extensionIdentifier,a));const k=[];return r.forEach(a=>{const c=u.get(a.extensionIdentifier);c&&(a.type!==c.type||a.value!==c.value||a.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&k.push(c)}),k.length===0?void 0:k}}),define(fe[95],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=b,e.$ss=S,e.$ts=C,e.$us=D,e.$vs=j,e.$ws=E;function b(h){return[...h.entries()]}function S(h){return h?[...h.entries()]:[]}function C(h){return new Map(h)}function D(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(r=>[r[0],b(r[1].map),S(r[1].descriptionMap)])}function E(h){return new Map(h.map(r=>[r[0],{map:C(r[1]),descriptionMap:D(r[2])}]))}}),define(fe[96],de([0,1,12,17,4,2,8]),function(oe,e,b,S,C,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;let E=class extends D.$Uc{constructor(r,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new C.$he),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,D.$Sc)(()=>{for(const u of this.f.values())(0,D.$Pc)(u)}))}createRequest(r){return new Promise((y,u)=>{const k=++this.a;this.c.set(k,y),this.g.fire({requestId:k,...r});const a=new S.$se;(0,b.$Bh)(this.b,a.token).then(()=>u(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,D.$Sc)(()=>a.cancel())])})}acceptReply(r,y){const u=this.c.get(r);u?(this.c.delete(r),(0,D.$Pc)(this.f.get(r)||[]),this.f.delete(r),u(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$is=E,e.$is=E=pe([ze(1,j.$7j)],E)}),define(fe[28],de([0,1,21,35,86]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$bs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$as=void 0,e.$as=new S.$Rj("terminalTabFocusMode",!1,!0);var D;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var E;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(h||(e.WindowsShellType=h={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var y;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$bs=(0,b.$Ai)("ptyService");var k;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var a;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(a||(e.TerminalLocation=a={}));var c;(function(i){i.TerminalView="view",i.Editor="editor"})(c||(e.TerminalLocationString=c={}));var m;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var s;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var n;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var g;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$cs={Backend:"workbench.contributions.terminal.processBackend"};class w{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}C.$ho.add(e.$cs.Backend,new w),e.$ds=(0,b.$Ai)("localPtyService"),e.$es=(0,b.$Ai)("terminalLogService")}),define(fe[97],de([0,1,12,2,3]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class D extends S.$Uc{constructor(E,h,r,y){super(),this.a=0,this.b=!1,this.c=!1,this.B(E.onProcessData(u=>{if(this.b||this.c)return;const k=typeof u=="string"?u:u.data;for(let a=0;a<k.length;a++)k[a]===h[this.a]?this.a++:this.f(),this.a===h.length&&(y.debug(`Auto reply match: "${h}", response: "${r}"`),E.input(r),this.c=!0,(0,b.$Bh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){C.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$Ejc=D}),define(fe[98],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=void 0;class b{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,D,j=5){const E=D(h=>{const r=typeof h=="string"?h:h.data;let y=this.a.get(C);if(y){y.data.push(r);return}const u=setTimeout(()=>this.flushBuffer(C),j);y={data:[r],timeoutId:u,dispose:()=>{clearTimeout(u),this.flushBuffer(C),E.dispose()}},this.a.set(C,y)});return E}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const D=this.a.get(C);D&&(this.a.delete(C),this.b(C,D.data.join("")))}}e.$qwb=b}),define(fe[37],de([0,1,3]),function(oe,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=S,e.$IP=C,e.$JP=D,e.$KP=j;function S(E){let h=E;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(r,""),`'${h}'`}function C(E,h,r){if(!E)return"";if(!h)return E;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const y=E.replace(/\\/g,"/").toLowerCase(),u=h.replace(/\\/g,"/").toLowerCase();return y.includes(u)?`~${r}${E.slice(h.length+1)}`:E}function D(E){return E.match(/^['"].*['"]$/)&&(E=E.substring(1,E.length-1)),b.OS===1&&E&&E[1]===":"?E[0].toUpperCase()+E.substring(1):E}function j(E){return!E.strictEnv}}),define(fe[99],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=S;var b;(function(C){C[C.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(b||(b={}));function S(C){const D=[];let j=0;for(let E=0;E<C.length-1;E++)(E-j+1>=50||C[E+1]==="\x1B")&&(D.push(C.substring(j,E+1)),j=E+1,E++);return j!==C.length&&D.push(C.substring(j)),D}}),define(fe[100],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rVb=b;function b(S,C={}){let D="";return C.excludeLeadingNewLine||(D+=`\r
`),D+="\x1B[0m\x1B[7m * ",C.loudFormatting?D+="\x1B[0;104m":D+="\x1B[0m",D+=` ${S} \x1B[0m
\r`,D}}),define(fe[101],de([0,1,2,93,90,91,92,4,87,6,37,9]),function(oe,e,b,S,C,D,j,E,h,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hvb=e.ShellIntegrationOscPs=void 0,e.$ivb=s,e.$jvb=n,e.$kvb=g;var k;(function(w){w[w.FinalTerm=133]="FinalTerm",w[w.VSCode=633]="VSCode",w[w.ITerm=1337]="ITerm",w[w.SetCwd=7]="SetCwd",w[w.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(k||(e.ShellIntegrationOscPs=k={}));var a;(function(w){w.PromptStart="A",w.CommandStart="B",w.CommandExecuted="C",w.CommandFinished="D"})(a||(a={}));var c;(function(w){w.PromptStart="A",w.CommandStart="B",w.CommandExecuted="C",w.CommandFinished="D",w.CommandLine="E",w.ContinuationStart="F",w.ContinuationEnd="G",w.RightPromptStart="H",w.RightPromptEnd="I",w.Property="P",w.SetMark="SetMark"})(c||(c={}));var m;(function(w){w.SetMark="SetMark",w.CurrentDir="CurrentDir"})(m||(m={}));class f extends b.$Uc{get status(){return this.g}constructor(i,t,o,P){super(),this.j=i,this.m=t,this.n=o,this.r=P,this.capabilities=this.B(new S.$avb),this.b=!1,this.f=[],this.g=0,this.h=new E.$he,this.onDidChangeStatus=this.h.event,this.B((0,b.$Sc)(()=>{this.z(),this.s()}))}s(){(0,b.$Pc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(3,this.B(new j.$fvb(this.a))),this.B(i.parser.registerOscHandler(633,t=>this.w(t))),this.B(i.parser.registerOscHandler(1337,t=>this.H(t))),this.f.push(i.parser.registerOscHandler(133,t=>this.t(t))),this.B(i.parser.registerOscHandler(7,t=>this.J(t))),this.B(i.parser.registerOscHandler(9,t=>this.I(t))),this.y()}getMarkerId(i,t){this.N(i).getMark(t)}t(i){const t=this.u(i);return this.g===0&&(this.g=1,this.h.fire(this.g)),t}u(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const P=o.length===1?parseInt(o[0]):void 0;return this.M(this.a).handleCommandFinished(P),!0}}return!1}w(i){const t=this.C(i);return!this.b&&t&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),t}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const t=i.indexOf(";"),o=t===-1?i:i.substring(0,t),P=t===-1?[]:i.substring(t+1).split(";");switch(o){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart(),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const p=P[0],L=p!==void 0?parseInt(p):void 0;return this.M(this.a).handleCommandFinished(L),!0}case"E":{const p=P[0],L=P[1];let v;return p!==void 0?v=s(p):v="",this.M(this.a).setCommandLine(v,L===this.j),!0}case"F":return this.M(this.a).handleContinuationStart(),!0;case"G":return this.M(this.a).handleContinuationEnd(),!0;case"H":return this.M(this.a).handleRightPromptStart(),!0;case"I":return this.M(this.a).handleRightPromptEnd(),!0;case"P":{const p=P[0],L=p!==void 0?s(p):"",{key:v,value:$}=n(L);if($===void 0)return!0;switch(v){case"ContinuationPrompt":return this.D((0,u.$Yf)($)),!0;case"Cwd":return this.G($),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty($==="True"),!0;case"Prompt":{const T=$.replace(/\x1b\[[0-9;]*m/g,"");return this.F(T),!0}case"Task":return this.N(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.N(this.a).addMark(g(P)),!0}return!1}D(i){this.a&&this.M(this.a).setContinuationPrompt(i)}F(i){if(!this.a)return;const t=i.substring(i.lastIndexOf(`
`)+1),o=t.substring(t.lastIndexOf(" "));o&&this.M(this.a).setPromptTerminator(o,t)}G(i){i=(0,y.$JP)(i),this.L().updateCwd(i),this.capabilities.get(2)?.setCwd(i)}H(i){if(!this.a)return!1;const[t]=i.split(";");switch(t){case"SetMark":this.N(this.a).addMark();default:{const{key:o,value:P}=n(t);if(P===void 0)return!0;switch(o){case"CurrentDir":return this.G(P),!0}}}return!1}I(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"9":return o.length&&this.G(o[0]),!0}return!1}J(i){if(!this.a)return!1;const[t]=i.split(";");if(t.match(/^file:\/\/.*\//)){const o=r.URI.parse(t);if(o.path&&o.path.length>0)return this.G(o.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.M(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(i)}L(){let i=this.capabilities.get(0);return i||(i=this.B(new D.$evb),this.capabilities.add(0,i)),i}M(i){let t=this.capabilities.get(2);return t||(t=this.B(new C.$cvb(i,this.r)),this.capabilities.add(2,t)),t}N(i){let t=this.capabilities.get(4);return t||(t=this.B(new h.$gvb(i)),this.capabilities.add(4,t)),t}}e.$hvb=f;function s(w){return w.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,t,o)=>o?String.fromCharCode(parseInt(o,16)):t)}function n(w){const i=w.indexOf("=");return i===-1?{key:w,value:void 0}:{key:w.substring(0,i),value:w.substring(1+i)}}function g(w){let i,t=!1;for(const o of w)o!==void 0&&(o==="Hidden"&&(t=!0),o.startsWith("Id=")&&(i=o.substring(3)));return{id:i,hidden:t}}}),define(fe[38],de([0,1,5,14,4,2,62,8]),function(oe,e,b,S,C,D,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=void 0;var h;(function(y){y[y.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",y[y.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.$Fjc=[];let r=class extends D.$Uc{set hasChildProcesses(u){this.a!==u&&(this.a=u,this.f.debug("ChildProcessMonitor: Has child processes changed",u),this.b.fire(u))}get hasChildProcesses(){return this.a}constructor(u,k){super(),this.c=u,this.f=k,this.a=!1,this.b=this.B(new C.$he),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const u=await(0,j.$Js)(this.c);this.hasChildProcesses=this.j(u)}catch(u){this.f.debug("ChildProcessMonitor: Fetching process tree failed",u)}}h(){this.g()}j(u){if(!u.children)return!1;if(u.children.length===1){const k=u.children[0];let a;if(k.cmd.startsWith('"'))a=k.cmd.substring(1,k.cmd.indexOf('"',1));else{const c=k.cmd.indexOf(" ");c===-1?a=k.cmd:a=k.cmd.substring(0,c)}return e.$Fjc.indexOf((0,b.$qc)(a).name)===-1}return u.children.length>0}};e.$Gjc=r,pe([(0,S.$6h)(1e3)],r.prototype,"g",null),pe([(0,S.$7h)(5e3)],r.prototype,"h",null),e.$Gjc=r=pe([ze(1,E.$7j)],r)}),define(fe[102],de([0,1,4,2,28]),function(oe,e,b,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class D extends S.$Uc{constructor(){super(),this.a=this.B(new b.$he),this.onBeat=this.a.event;const E=setInterval(()=>{this.a.fire()},C.HeartbeatConstants.BeatInterval);this.B((0,S.$Sc)(()=>clearInterval(E)))}}e.$Hjc=D}),define(fe[39],de([0,1,20,19,30,5,3,15,9,10,24,36,95,94]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=c,e.$zs=m,e.$As=f;function c(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let $=0;return v&&v.length===4&&($=parseInt(v[3])),$}async function m(v,$,T,Q=E.env,U=y.Promises.exists){if(D.$ic(v))return await U(v)?v:void 0;if($===void 0&&($=E.cwd()),D.$mc(v)!=="."){const M=D.$jc($,v);return await U(M)?M:void 0}const d=(0,C.$bo)(Q,"PATH");if(T===void 0&&(0,r.$ag)(d)&&(T=d.split(D.$tc)),T===void 0||T.length===0){const M=D.$jc($,v);return await U(M)?M:void 0}for(const M of T){let A;if(D.$ic(M)?A=D.$jc(M,v):A=D.$jc($,M,v),await U(A))return A;if(j.$i){let q=A+".com";if(await U(q)||(q=A+".exe",await U(q)))return q}}const N=D.$jc($,v);return await U(N)?N:void 0}function f(v,$,T,Q,U){const I=j.$i&&(!$.windowsEnableConpty||c()<18309);if(!$.shellIntegration.enabled||!v.executable||v.isFeatureTerminal&&!v.forceShellIntegration||v.ignoreShellIntegration||I)return;const d=v.args,N=E.$dc==="win32"?D.$nc(v.executable).toLowerCase():D.$nc(v.executable),M=D.$mc(S.$Ug.asFileUri("").fsPath);let A;const q={VSCODE_INJECTION:"1"};if($.shellIntegration.nonce&&(q.VSCODE_NONCE=$.shellIntegration.nonce),j.$i){if(N==="pwsh.exe"||N==="powershell.exe")return!d||p(d)?A=g.get(n.WindowsPwsh):P(d)&&(A=g.get(n.WindowsPwshLogin)),A?(A=[...A],A[A.length-1]=(0,h.$_e)(A[A.length-1],M,""),$.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),{newArgs:A,envMixin:q}):void 0;if(N==="bash.exe")return!d||d.length===0?A=g.get(n.Bash):L(d)&&(q.VSCODE_SHELL_LOGIN="1",s($,q),A=g.get(n.Bash)),A?(A=[...A],A[A.length-1]=(0,h.$_e)(A[A.length-1],M),{newArgs:A,envMixin:q}):void 0;Q.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args);return}switch(N){case"bash":return!d||d.length===0?A=g.get(n.Bash):L(d)&&(q.VSCODE_SHELL_LOGIN="1",s($,q),A=g.get(n.Bash)),A?(A=[...A],A[A.length-1]=(0,h.$_e)(A[A.length-1],M),{newArgs:A,envMixin:q}):void 0;case"fish":{const Z=T?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=D.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${Z}:${G}`,s($,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!d||p(d)?A=g.get(n.Pwsh):P(d)&&(A=g.get(n.PwshLogin)),A?($.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),A=[...A],A[A.length-1]=(0,h.$_e)(A[A.length-1],M,""),{newArgs:A,envMixin:q}):void 0;case"zsh":{if(!d||d.length===0?A=g.get(n.Zsh):L(d)?(A=g.get(n.ZshLogin),s($,q)):(d===g.get(n.Zsh)||d===g.get(n.ZshLogin))&&(A=d),!A)return;A=[...A],A[A.length-1]=(0,h.$_e)(A[A.length-1],M);let Z;try{Z=b.userInfo().username}catch{Z="unknown"}const G=D.$jc(b.tmpdir(),`${Z}-${U.applicationName}-zsh`);q.ZDOTDIR=G;const _=T?.ZDOTDIR??b.homedir()??"~";q.USER_ZDOTDIR=_;const re=[];return re.push({source:D.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$jc(G,".zshrc")}),re.push({source:D.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$jc(G,".zprofile")}),re.push({source:D.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$jc(G,".zshenv")}),re.push({source:D.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$jc(G,".zlogin")}),{newArgs:A,envMixin:q,filesToCopy:re}}}Q.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args)}function s(v,$){if(j.$j&&v.environmentVariableCollections){const T=(0,k.$ws)(v.environmentVariableCollections),U=new a.$xs(T).getVariableMap({workspaceFolder:v.workspaceFolder}).get("PATH"),I=[];if(U)for(const d of U)d.type===u.EnvironmentVariableMutatorType.Prepend&&I.push(d.value);I.length>0&&($.VSCODE_PATH_PREFIX=I.join(""))}}var n;(function(v){v.WindowsPwsh="windows-pwsh",v.WindowsPwshLogin="windows-pwsh-login",v.Pwsh="pwsh",v.PwshLogin="pwsh-login",v.Zsh="zsh",v.ZshLogin="zsh-login",v.Bash="bash"})(n||(n={}));const g=new Map;g.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(n.Zsh,["-i"]),g.set(n.ZshLogin,["-il"]),g.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function P(v){return typeof v=="string"?w.includes(v.toLowerCase()):v.length===1&&w.includes(v[0].toLowerCase())||v.length===2&&(w.includes(v[0].toLowerCase())||w.includes(v[1].toLowerCase()))&&(o.includes(v[0].toLowerCase())||o.includes(v[1].toLowerCase()))}function p(v){return typeof v=="string"?o.includes(v.toLowerCase()):v.length===0||v?.length===1&&o.includes(v[0].toLowerCase())}function L(v){return typeof v!="string"&&(v=v.filter($=>!t.includes($.toLowerCase()))),v==="string"&&i.includes(v.toLowerCase())||typeof v!="string"&&v.length===1&&i.includes(v[0].toLowerCase())}}),define(fe[103],de([0,1,12,14,4,2,3]),function(oe,e,b,S,C,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;const E=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class r extends D.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(u){if(super(),this.h=u,this.c="",this.f=new C.$he,this.g=new C.$he,!j.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$i&&(await(0,b.$Bh)(300),this.getShellName().then(u=>{const k=this.getShellType(u);k!==this.b&&(this.g.fire(k),this.f.fire(u),this.b=k,this.c=u)}))}m(u){if(!u)return"";if(E.indexOf(u.name)===-1||!u.children||u.children.length===0)return u.name;let k=0;for(;k<u.children.length;k++){const a=u.children[k];if(!a.children||a.children.length===0||a.children[0].name!=="conhost.exe")break}return k>=u.children.length?u.name:this.m(u.children[k])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(h||(h=await new Promise((u,k)=>{oe(["@vscode/windows-process-tree"],u,k)})),this.a=new Promise(u=>{h.getProcessTree(this.h,k=>{const a=this.m(k);this.a=void 0,u(a)})}),this.a)}getShellType(u){switch(u.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return u.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$Ijc=r,pe([(0,S.$6h)(500)],r.prototype,"checkShell",null)}),define(fe[104],de([0,1,26,12,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a,c,m,f,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;var g;(function(P){P[P.DataFlushTimeout=250]="DataFlushTimeout",P[P.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(g||(g={}));var w;(function(P){P[P.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",P[P.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",P[P.WriteInterval=5]="WriteInterval"})(w||(w={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends D.$Uc{static{n=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return E.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(p,L,v,$,T,Q,U,I,d){super(),this.shellLaunchConfig=p,this.N=Q,this.O=U,this.P=I,this.Q=d,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new C.$he),this.onProcessData=this.I.event,this.J=this.B(new C.$he),this.onProcessReady=this.J.event,this.L=this.B(new C.$he),this.onDidChangeProperty=this.L.event,this.M=this.B(new C.$he),this.onProcessExit=this.M.event;let N;E.$i?N=j.$nc(this.shellLaunchConfig.executable||""):N="xterm-256color",this.D=L,this.a.initialCwd=this.D,this.a.cwd=this.D;const M=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,c.$ys)()>=18309;this.F={name:N,cwd:L,env:T,cols:v,rows:$,useConpty:M,conptyInheritCursor:M&&!!p.initialText},E.$i&&(M&&v===0&&$===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new o,this.B(this.C.onTrigger(A=>{this.C?.dispose(),this.C=void 0,A.cols&&A.rows&&this.resize(A.cols,A.rows)}))),this.onProcessReady(A=>{this.t=this.B(new m.$Ijc(A.pid)),this.B(this.t.onShellTypeChanged(q=>this.L.fire({type:"shellType",value:q}))),this.B(this.t.onShellNameChanged(q=>this.L.fire({type:"title",value:q})))})),this.B((0,D.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const L=(await Promise.all([this.R(),this.S()])).find($=>$!==void 0);if(L)return L;let v;if(this.O.shellIntegration.enabled)if(v=(0,c.$As)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),v){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),v.envMixin)for(const[$,T]of Object.entries(v.envMixin))this.F.env||={},this.F.env[$]=T;if(v.filesToCopy)for(const $ of v.filesToCopy){await r.Promises.mkdir(j.$mc($.dest),{recursive:!0});try{await r.Promises.copyFile($.source,$.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,v),v?.newArgs?{injectedArgs:v.newArgs}:void 0}catch($){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",$),{message:`A native exception occurred during launch (${$.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,y.localize)(0,null,this.D.toString())}}catch(p){if(p?.code==="ENOENT")return{message:(0,y.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const p=this.shellLaunchConfig;if(!p.executable)throw new Error("IShellLaunchConfig.executable not set");const L=p.cwd instanceof h.URI?p.cwd.path:p.cwd,v=p.env&&p.env.PATH?p.env.PATH.split(j.$tc):void 0,$=await(0,c.$zs)(p.executable,L,v,this.N);if(!$)return{message:(0,y.localize)(2,null,p.executable)};try{const T=await r.Promises.stat($);if(!T.isFile()&&!T.isSymbolicLink())return{message:(0,y.localize)(3,null,p.executable)};p.executable=$}catch(T){if(T?.code!=="EACCES")throw T}}async U(p,L,v){const $=v?.newArgs||p.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",p.executable,$,L);const T=(0,f.spawn)(p.executable,$,L);this.m=T,this.u=this.B(new a.$Gjc(T.pid,this.P)),this.u.onDidChangeHasChildProcesses(Q=>this.L.fire({type:"hasChildProcesses",value:Q})),this.s=new Promise(Q=>{this.onProcessReady(()=>Q())}),T.onData(Q=>{this.H+=Q.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,T.pause()),this.P.trace("node-pty.IPty#onData",Q),this.I.fire(Q),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),T.onExit(Q=>{this.g=Q.exitCode,this.X()}),this.$(T.pid),this.W(T)}W(p){setTimeout(()=>this.ab(p)),E.$i||(this.w=setInterval(()=>{this.n!==p.process&&this.ab(p)},200))}X(){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!E.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-n.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,S.$Bh)(250-(Date.now()-n.b)+50);n.b=Date.now()}}$(p){this.J.fire({pid:p,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(p){if(this.q.isDisposed)return;this.n=p.process,this.L.fire({type:"title",value:this.n});const L=this.currentTitle.replace(/ \(figterm\)$/g,"");L.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(L)})}shutdown(p){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),p&&!E.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(p,L=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$_r)(p).map(v=>({isBinary:L,data:v}))),this.bb())}async processBinary(p){this.input(p,!0)}async refreshProperty(p){switch(p){case"cwd":{const L=await this.getCwd();return L!==this.a.cwd&&(this.a.cwd=L,this.L.fire({type:"cwd",value:this.a.cwd})),L}case"initialCwd":{const L=await this.getInitialCwd();return L!==this.a.initialCwd&&(this.a.initialCwd=L,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),L}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(p,L){p==="fixedDimensions"&&(this.a.fixedDimensions=L)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const p=this.y.shift();this.P.trace("node-pty.IPty#write",p.data),p.isBinary?this.m.write(Buffer.from(p.data,"binary")):this.m.write(p.data),this.u?.handleInput()}resize(p,L){if(!this.q.isDisposed&&!(typeof p!="number"||typeof L!="number"||isNaN(p)||isNaN(L))&&this.m){if(p=Math.max(p,1),L=Math.max(L,1),this.C){this.C.cols=p,this.C.rows=L;return}this.P.trace("node-pty.IPty#resize",p,L);try{this.m.resize(p,L)}catch(v){if(this.P.trace("node-pty.IPty#resize exception "+v.message),this.g!==void 0&&v.message!=="ioctl(2) failed, EBADF"&&v.message!=="Cannot resize a pty that has already exited")throw v}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(p){this.H=Math.max(this.H-p,0),this.P.trace(`Flow control: Ack ${p} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(E.$j)return new Promise(p=>{if(!this.m){p(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,b.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(L,v,$)=>{!L&&v!==""?p(v.substring(v.indexOf("/"),v.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",L,v,$),p(this.D))})});if(E.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return E.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,c.$ys)()}:void 0}};e.$Jjc=t,e.$Jjc=t=n=pe([ze(7,u.$7j),ze(8,k.$nk)],t);class o extends D.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new C.$he),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,D.$Sc)(()=>clearTimeout(this.a)))}}}),define(fe[105],de([0,1,26,12,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a,c,m,f,s,n,g,w,i,t,o,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0,e.$Kjc=p;function p(N,M,A){if(typeof A.value!="function")throw new Error("not supported");const q="value",Z=A.value;A[q]=async function(...G){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Z.name}(${G.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,S.$Bh)(this.traceRpcArgs.simulatedLatency);let _;try{_=await Z.apply(this,G)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Z.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Z.name}`,_),_}}let L,v;class $ extends D.$Uc{H(M,A){return A(q=>{this.I.getLevel()===h.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${M}.fire(${JSON.stringify(q)})`)}),A}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(M,A,q,Z){super(),this.I=M,this.J=A,this.L=q,this.M=Z,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new C.$he),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new C.$he),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new C.$he),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new C.$he),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new C.$he),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new C.$he),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new C.$he),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new C.$he),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,D.$Sc)(()=>{for(const G of this.a.values())G.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$is(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(M){s.$Fjc.length=0,s.$Fjc.push(...M)}async requestDetachInstance(M,A){return this.f.createRequest({workspaceId:M,instanceId:A})}async acceptDetachInstanceReply(M,A){let q;const Z=this.a.get(A);Z&&(q=await this.S(A,Z)),this.f.acceptReply(M,q)}async freePortKillProcess(M){const q=(await new Promise((Z,G)=>{(0,b.exec)(j.$i?`netstat -ano | findstr "${M}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${M}`,{},(_,re)=>{if(_)return G("Problem occurred when listing active processes");Z(re)})})).split(/\r?\n/).filter(Z=>!!Z.trim());if(q.length>=1){const Z=/\s+(\d+)(?:\s+|$)/,G=q[0].match(Z)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${M} were not found`);return{port:M,processId:G}}throw new Error(`Could not kill process with port ${M}`)}async serializeTerminalState(M){const A=[];for(const[Z,G]of this.a.entries())G.hasWrittenData&&M.indexOf(Z)!==-1&&A.push(S.Promises.withAsyncBody(async _=>{_({id:Z,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this.S(Z,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const q={version:1,state:await Promise.all(A)};return JSON.stringify(q)}async reviveTerminalProcesses(M,A,q){const Z=[];for(const G of A)Z.push(this.N(M,G));await Promise.all(Z)}async N(M,A){const q=(0,f.localize)(0,null),Z=await this.createProcess({...A.shellLaunchConfig,cwd:A.processDetails.cwd,color:A.processDetails.color,icon:A.processDetails.icon,name:A.processDetails.titleSource===y.TitleEventSource.Api?A.processDetails.title:void 0,initialText:A.replayEvent.events[0].data+(0,i.$rVb)(q,{loudFormatting:!0})},A.processDetails.cwd,A.replayEvent.events[0].cols,A.replayEvent.events[0].rows,A.unicodeVersion,A.processLaunchConfig.env,A.processLaunchConfig.executableEnv,A.processLaunchConfig.options,!0,A.processDetails.workspaceId,A.processDetails.workspaceName,!0,A.replayEvent.events[0].data),G=this.R(M,A.id);this.g.set(G,{newId:Z,state:A}),this.I.info(`Revived process, old id ${G} -> new id ${Z}`)}async shutdownAll(){this.dispose()}async createProcess(M,A,q,Z,G,_,re,le,X,F,x,ee,he){if(M.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const W=++this.n,ce=new m.$Jjc(M,A,q,Z,_,re,le,this.I,this.J),te={env:_,executableEnv:re,options:le},l=new Q(W,ce,F,x,X,q,Z,te,G,this.L,this.I,ee&&typeof M.initialText=="string"?M.initialText:void 0,he,M.icon,M.color,M.name,M.fixedDimensions);return ce.onProcessExit(z=>{l.dispose(),this.a.delete(W),this.C.fire({id:W,event:z})}),l.onProcessData(z=>this.w.fire({id:W,event:z})),l.onProcessReplay(z=>this.y.fire({id:W,event:z})),l.onProcessReady(z=>this.z.fire({id:W,event:z})),l.onProcessOrphanQuestion(()=>this.D.fire({id:W})),l.onDidChangeProperty(z=>this.G.fire({id:W,property:z})),l.onPersistentProcessReady(()=>{for(const z of this.j.entries())l.installAutoReply(z[0],z[1])}),this.a.set(W,l),W}async attachToProcess(M){try{await this.U(M).attach(),this.I.info(`Persistent process reconnection "${M}"`)}catch(A){throw this.I.warn(`Persistent process reconnection "${M}" failed`,A.message),A}}async updateTitle(M,A,q){this.U(M).setTitle(A,q)}async updateIcon(M,A,q,Z){this.U(M).setIcon(A,q,Z)}async clearBuffer(M){this.U(M).clearBuffer()}async refreshProperty(M,A){return this.U(M).refreshProperty(A)}async updateProperty(M,A,q){return this.U(M).updateProperty(A,q)}async detachFromProcess(M,A){return this.U(M).detach(A)}async reduceConnectionGraceTime(){for(const M of this.a.values())M.reduceGraceTime()}async listProcesses(){const M=Array.from(this.a.entries()).filter(([Z,G])=>G.shouldPersistTerminal);this.I.info(`Listing ${M.length} persistent terminals, ${this.a.size} total terminals`);const A=M.map(async([Z,G])=>this.S(Z,G));return(await Promise.all(A)).filter(Z=>Z.isOrphan)}async getPerformanceMarks(){return P.getMarks()}async start(M){const A=this.a.get(M);return A?A.start():{message:`Could not find pty with id "${M}"`}}async shutdown(M,A){return this.a.get(M)?.shutdown(A)}async input(M,A){return this.U(M).input(A)}async processBinary(M,A){return this.U(M).writeBinary(A)}async resize(M,A,q){return this.U(M).resize(A,q)}async getInitialCwd(M){return this.U(M).getInitialCwd()}async getCwd(M){return this.U(M).getCwd()}async acknowledgeDataEvent(M,A){return this.U(M).acknowledgeDataEvent(A)}async setUnicodeVersion(M,A){return this.U(M).setUnicodeVersion(A)}async getLatency(){return[]}async orphanQuestionReply(M){return this.U(M).orphanQuestionReply()}async installAutoReply(M,A){this.j.set(M,A);for(const q of this.a.values())q.installAutoReply(M,A)}async uninstallAllAutoReplies(){for(const M of this.j.keys())for(const A of this.a.values())A.uninstallAutoReply(M)}async uninstallAutoReply(M){for(const A of this.a.values())A.uninstallAutoReply(M)}async getDefaultSystemShell(M=j.OS){return(0,E.$um)(M,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(M,A){if(A==="win-to-unix"){if(!j.$i)return M;if((0,c.$ys)()<17063)return M.replace(/\\/g,"/");const q=this.O();return q?new Promise(Z=>{(0,b.execFile)(q,["-e","wslpath",M],{},(_,re,le)=>{Z(_?M:(0,k.$HP)(re.trim()))}).stdin.end()}):M}if(A==="unix-to-win"&&j.$i){if((0,c.$ys)()<17063)return M;const q=this.O();return q?new Promise(Z=>{(0,b.execFile)(q,["-e","wslpath","-w",M],{},(_,re,le)=>{Z(_?M:re.trim())}).stdin.end()}):M}return M}O(){const M=(0,c.$ys)()>=16299,A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=process.env.SystemRoot;if(q)return(0,t.join)(q,A?"Sysnative":"System32",M?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(M,A){try{return this.g.get(this.R(M,A))?.newId}catch(q){this.I.warn(`Couldn't find terminal ID ${M}-${A}`,q.message)}}async setTerminalLayoutInfo(M){this.b.set(M.workspaceId,M)}async getTerminalLayoutInfo(M){P.mark("code/willGetTerminalLayoutInfo");const A=this.b.get(M.workspaceId);if(A){const q=new Set,G=(await Promise.all(A.tabs.map(async _=>this.P(M.workspaceId,_,q)))).filter(_=>_.terminals.length>0);return P.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}P.mark("code/didGetTerminalLayoutInfo")}async P(M,A,q){const G=(await Promise.all(A.terminals.map(_=>this.Q(M,_,q)))).filter(_=>_.terminal!==null);return{isActive:A.isActive,activePersistentProcessId:A.activePersistentProcessId,terminals:G}}async Q(M,A,q){try{const Z=this.R(M,A.terminal),G=this.g.get(Z)?.newId;this.I.info(`Expanding terminal instance, old id ${Z} -> new id ${G}`),this.g.delete(Z);const _=G??A.terminal;if(q.has(_))throw new Error(`Terminal ${_} has already been expanded`);q.add(_);const re=this.U(_);return{terminal:{...re&&await this.S(A.terminal,re,G!==void 0),id:_},relativeSize:A.relativeSize}}catch(Z){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",Z.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",A),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:A.relativeSize}}}R(M,A){return`${M}-${A}`}async S(M,A,q=!1){P.mark(`code/willBuildProcessDetails/${M}`);const[Z,G]=await Promise.all([A.getCwd(),q?!0:A.isOrphaned()]),_={id:M,title:A.title,titleSource:A.titleSource,pid:A.pid,workspaceId:A.workspaceId,workspaceName:A.workspaceName,cwd:Z,isOrphan:G,icon:A.icon,color:A.color,fixedDimensions:A.fixedDimensions,environmentVariableCollections:A.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:A.shellLaunchConfig.reconnectionProperties,waitOnExit:A.shellLaunchConfig.waitOnExit,hideFromUser:A.shellLaunchConfig.hideFromUser,isFeatureTerminal:A.shellLaunchConfig.isFeatureTerminal,type:A.shellLaunchConfig.type,hasChildProcesses:A.hasChildProcesses,shellIntegrationNonce:A.processLaunchOptions.options.shellIntegration.nonce};return P.mark(`code/didBuildProcessDetails/${M}`),_}U(M){const A=this.a.get(M);if(!A)throw new g.$bb("Could not find pty on pty host");return A}}e.$Ljc=$,pe([o.$5h],$.prototype,"traceRpcArgs",null),pe([p],$.prototype,"refreshIgnoreProcessNames",null),pe([p],$.prototype,"requestDetachInstance",null),pe([p],$.prototype,"acceptDetachInstanceReply",null),pe([p],$.prototype,"freePortKillProcess",null),pe([p],$.prototype,"serializeTerminalState",null),pe([p],$.prototype,"reviveTerminalProcesses",null),pe([p],$.prototype,"shutdownAll",null),pe([p],$.prototype,"createProcess",null),pe([p],$.prototype,"attachToProcess",null),pe([p],$.prototype,"updateTitle",null),pe([p],$.prototype,"updateIcon",null),pe([p],$.prototype,"clearBuffer",null),pe([p],$.prototype,"refreshProperty",null),pe([p],$.prototype,"updateProperty",null),pe([p],$.prototype,"detachFromProcess",null),pe([p],$.prototype,"reduceConnectionGraceTime",null),pe([p],$.prototype,"listProcesses",null),pe([p],$.prototype,"getPerformanceMarks",null),pe([p],$.prototype,"start",null),pe([p],$.prototype,"shutdown",null),pe([p],$.prototype,"input",null),pe([p],$.prototype,"processBinary",null),pe([p],$.prototype,"resize",null),pe([p],$.prototype,"getInitialCwd",null),pe([p],$.prototype,"getCwd",null),pe([p],$.prototype,"acknowledgeDataEvent",null),pe([p],$.prototype,"setUnicodeVersion",null),pe([p],$.prototype,"getLatency",null),pe([p],$.prototype,"orphanQuestionReply",null),pe([p],$.prototype,"installAutoReply",null),pe([p],$.prototype,"uninstallAllAutoReplies",null),pe([p],$.prototype,"uninstallAutoReply",null),pe([p],$.prototype,"getDefaultSystemShell",null),pe([p],$.prototype,"getEnvironment",null),pe([p],$.prototype,"getWslPath",null),pe([p],$.prototype,"getRevivedPtyNewId",null),pe([p],$.prototype,"setTerminalLayoutInfo",null),pe([p],$.prototype,"getTerminalLayoutInfo",null);var T;(function(N){N.None="None",N.ReplayOnly="ReplayOnly",N.Session="Session"})(T||(T={}));class Q extends D.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(M,A){A===y.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=M,this.O=A}setIcon(M,A,q){(!this.Y||"id"in A&&"id"in this.Y&&A.id!==this.Y.id||!this.color||q!==this.Z)&&(this.P.freeRawReviveBuffer(),M&&this.j.setValue("Session","setIcon")),this.Y=A,this.Z=q}S(M){this.R=M}constructor(M,A,q,Z,G,_,re,le,X,F,x,ee,he,W,ce,te,l){super(),this.U=M,this.W=A,this.workspaceId=q,this.workspaceName=Z,this.shouldPersistTerminal=G,this.processLaunchOptions=le,this.unicodeVersion=X,this.X=x,this.Y=W,this.Z=ce,this.b=new Map,this.f=new Map,this.g=!1,this.w=new S.$Hh,this.C=this.B(new C.$he),this.onProcessReplay=this.C.event,this.D=this.B(new C.$he),this.onProcessReady=this.D.event,this.F=this.B(new C.$he),this.onPersistentProcessReady=this.F.event,this.G=this.B(new C.$he),this.onProcessData=this.G.event,this.H=this.B(new C.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new C.$he),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=y.TitleEventSource.Process,this.j=new U(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=ee!==void 0,this.P=new I(_,re,F.scrollback,X,ee,le.options.shellIntegration.nonce,G?he:void 0,this.X),te&&this.setTitle(te,y.TitleEventSource.Api),this.R=l,this.n=null,this.u=0,this.y=this.B(new S.$Nh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${d(F.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},F.graceTime)),this.z=this.B(new S.$Nh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${d(F.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},F.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(z=>{this.L=z.pid,this.M=z.cwd,this.D.fire(z)})),this.B(this.W.onDidChangeProperty(z=>{this.I.fire(z)})),this.a=new u.$qwb((z,ne)=>this.G.fire(ne)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(z=>this.P.handleData(z))),this.B((0,D.$Sc)(()=>{for(const z of this.b.values())z.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(M){this.shouldPersistTerminal&&(this.j.value!=="None"||M)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(M){return this.W.refreshProperty(M)}async updateProperty(M,A){if(M==="fixedDimensions")return this.S(A)}async start(){if(!this.g){const M=await this.W.start();return M&&"message"in M||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),M}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(M){return this.W.shutdown(M)}input(M){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const A of this.b.values())A.handleInput();return this.W.input(M)}}writeBinary(M){return this.W.processBinary(M)}resize(M,A){if(!this.J){this.P.handleResize(M,A),this.a.flushBuffer(this.U);for(const q of this.b.values())q.handleResize();return this.W.resize(M,A)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(M){this.unicodeVersion=M,this.P.setUnicodeVersion?.(M)}acknowledgeDataEvent(M){if(!this.J)return this.W.acknowledgeDataEvent(M)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const M=await this.P.generateReplayEvent();let A=0;for(const q of M.events)A+=q.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${A} chars and ${M.events.length} size events`),this.C.fire(M),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(M,A){this.b.get(M)?.dispose(),this.b.set(M,new n.$Ejc(this.W,M,A,this.X))}uninstallAutoReply(M){this.b.get(M)?.dispose(),this.b.delete(M)}sendCommandResult(M,A,q){this.f.get(M)&&this.f.delete(M)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const M=this.n;this.n=null,M.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new S.$Ah(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class U{get value(){return this.b}setValue(M,A){this.b!==M&&(this.b=M,this.f(A))}constructor(M,A,q){this.a=M,this.b=A,this.d=q,this.f("initialized")}f(M){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${M}`)}}class I{constructor(M,A,q,Z,G,_,re,le){this.f=re,this.a=new a.Terminal({cols:M,rows:A,scrollback:q,allowProposedApi:!0}),G&&this.a.writeln(G),this.setUnicodeVersion(Z),this.b=new w.$hvb(_,!0,void 0,le),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(M){this.a.write(M)}handleResize(M,A){this.a.resize(M,A)}clearBuffer(){this.a.clear()}async generateReplayEvent(M,A){const q=new(await this._getSerializeConstructor());this.a.loadAddon(q);const Z={scrollback:this.a.options.scrollback};M&&(Z.excludeAltBuffer=!0,Z.excludeModes=!0);let G;return A&&this.f?G=this.f:G=q.serialize(Z),{events:[{cols:this.a.cols,rows:this.a.rows,data:G}],commands:this.b.serialize()}}async setUnicodeVersion(M){this.a.unicode.activeVersion!==M&&(M==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=M)}async _getUnicode11Constructor(){return v||(v=(await new Promise((M,A)=>{oe(["@xterm/addon-unicode11"],M,A)})).Unicode11Addon),v}async _getSerializeConstructor(){return L||(L=(await new Promise((M,A)=>{oe(["@xterm/addon-serialize"],M,A)})).SerializeAddon),L}}function d(N){let M=0,A=0,q=0;N>=1e3&&(q=Math.floor(N/1e3),N-=q*1e3),q>=60&&(A=Math.floor(q/60),q-=A*60),A>=60&&(M=Math.floor(A/60),A-=M*60);const Z=M?`${M}h`:"",G=A?`${A}m`:"",_=q?`${q}s`:"",re=N?`${N}ms`:"";return`${Z}${G}${_}${re}`}}),define(fe[112],de([0,1,60,27,64,65,11,75,78,8,80,81,83,84,28,102,105,31,12,2]),function(oe,e,b,S,C,D,j,E,h,r,y,u,k,a,c,m,f,s,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w();async function w(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),o={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,n.$Bh)(i);const P=(0,s.$yW)(process);let p;P?p=new D.$zW:p=new C.$6q(c.TerminalIpcChannels.PtyHost);const L={_serviceBrand:void 0,...a.default},v=new h.$an((0,E.$xm)(process.argv,E.$wm),L),$=new k.$8P((0,r.$ik)(v),v.logsHome);p.registerChannel(c.TerminalIpcChannels.Logger,new y.$gs($,()=>b.$Dn));const T=$.createLogger("ptyhost",{name:(0,j.localize)(0,null)}),Q=new u.$fQ(T);i&&Q.warn(`Pty Host startup is delayed ${i}ms`),t&&Q.warn(`Pty host is simulating ${t}ms latency`);const U=new g.$Tc,I=new m.$Hjc;p.registerChannel(c.TerminalIpcChannels.Heartbeat,S.ProxyChannel.fromService(I,U));const d=new f.$Ljc(Q,L,o,t),N=S.ProxyChannel.fromService(d,U);p.registerChannel(c.TerminalIpcChannels.PtyHost,N),P&&p.registerChannel(c.TerminalIpcChannels.PtyHostWindow,N),process.once("exit",()=>{Q.trace("Pty host exiting"),Q.dispose(),I.dispose(),d.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/platform/terminal/node/ptyHostMain.js.map
