/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/base/common/iterator","vs/platform/request/common/request","vs/base/common/json","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],Ee=function(fe){for(var e=[],s=0,j=fe.length;s<j;s++)e[s]=ye[fe[s]];return e};define(ye[97],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class s{static get(){const I=new Map,D=new Map,S=new Map,P=new Map;function b(m,l){m.has(l.detail)||m.set(l.detail,-l.timestamp)}function $(m,l){const c=m.get(l.detail);c&&(c>=0||m.set(l.detail,c+l.timestamp))}let y=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(y=fe.getStats().slice(0).sort((m,l)=>m.timestamp-l.timestamp));for(const m of y)switch(m.type){case 10:b(I,m);break;case 11:case 12:$(I,m);break;case 21:b(D,m);break;case 22:$(D,m);break;case 33:b(S,m);break;case 34:$(S,m);break;case 31:b(P,m);break;case 32:$(P,m);break}let w=0;S.forEach(m=>w+=m);function v(m){const l=[];return m.forEach((c,u)=>l.push([u,c])),l}return{amdLoad:v(I),amdInvoke:v(D),nodeRequire:v(S),nodeEval:v(P),nodeRequireTotal:w}}static toMarkdownTable(I,D){let S="";const P=[];return I.forEach((b,$)=>{P[$]=b.length}),D.forEach(b=>{b.forEach(($,y)=>{typeof $>"u"&&($=b[y]="-");const w=$.toString().length;P[y]=Math.max(w,P[y])})}),I.forEach((b,$)=>{S+=`| ${b+" ".repeat(P[$]-b.toString().length)} `}),S+=`|
`,I.forEach((b,$)=>{S+=`| ${"-".repeat(P[$])} `}),S+=`|
`,D.forEach(b=>{b.forEach(($,y)=>{typeof $<"u"&&(S+=`| ${$+" ".repeat(P[y]-$.toString().length)} `)}),S+=`|
`}),S}}e.$U=s}),define(ye[147],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=s,e.$gb=j,e.$hb=I,e.$ib=D,e.$jb=S,e.$kb=P,e.$lb=b,e.$nb=y,e.$ob=w,e.$pb=v,e.$qb=m,e.$rb=l;function s(c,u){const h=j(c,u);if(h!==-1)return c[h]}function j(c,u,h=c.length-1){for(let g=h;g>=0;g--){const d=c[g];if(u(d))return g}return-1}function I(c,u){const h=D(c,u);return h===-1?void 0:c[h]}function D(c,u,h=0,g=c.length){let d=h,E=g;for(;d<E;){const f=Math.floor((d+E)/2);u(c[f])?d=f+1:E=f}return d-1}function S(c,u){const h=P(c,u);return h===c.length?void 0:c[h]}function P(c,u,h=0,g=c.length){let d=h,E=g;for(;d<E;){const f=Math.floor((d+E)/2);u(c[f])?E=f:d=f+1}return d}function b(c,u,h=0,g=c.length){const d=P(c,u,h,g);return d===c.length?-1:d}class ${static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if($.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!u(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const h=D(this.e,u,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=$;function y(c,u){if(c.length===0)return;let h=c[0];for(let g=1;g<c.length;g++){const d=c[g];u(d,h)>0&&(h=d)}return h}function w(c,u){if(c.length===0)return;let h=c[0];for(let g=1;g<c.length;g++){const d=c[g];u(d,h)>=0&&(h=d)}return h}function v(c,u){return y(c,(h,g)=>-u(h,g))}function m(c,u){if(c.length===0)return-1;let h=0;for(let g=1;g<c.length;g++){const d=c[g];u(d,c[h])>0&&(h=g)}return h}function l(c,u){for(const h of c){const g=u(h);if(g!==void 0)return g}}}),define(ye[148],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=s,e.$L=j,e.$M=I,e.$N=D;function s(S,P){const b=Object.create(null);for(const $ of S){const y=P($);let w=b[y];w||(w=b[y]=[]),w.push($)}return b}function j(S,P){const b=[],$=[];for(const y of S)P.has(y)||b.push(y);for(const y of P)S.has(y)||$.push(y);return{removed:b,added:$}}function I(S,P){const b=[],$=[];for(const[y,w]of S)P.has(y)||b.push(w);for(const[y,w]of P)S.has(y)||$.push(w);return{removed:b,added:$}}function D(S,P){const b=new Set;for(const $ of P)S.has($)&&b.add($);return b}}),define(ye[74],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=j,e.$6h=I,e.$7h=D;function s(S){return(P,b,$)=>{let y=null,w=null;if(typeof $.value=="function"?(y="value",w=$.value):typeof $.get=="function"&&(y="get",w=$.get),!w)throw new Error("not supported");$[y]=S(w,b)}}function j(S,P,b){let $=null,y=null;if(typeof b.value=="function"?($="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",y=b.get),!y)throw new Error("not supported");const w=`$memoize$${P}`;b[$]=function(...v){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,v)}),this[w]}}function I(S,P,b){return s(($,y)=>{const w=`$debounce$${y}`,v=`$debounce$result$${y}`;return function(...m){this[v]||(this[v]=b?b():void 0),clearTimeout(this[w]),P&&(this[v]=P(this[v],...m),m=[this[v]]),this[w]=setTimeout(()=>{$.apply(this,m),this[v]=b?b():void 0},S)}})}function D(S,P,b){return s(($,y)=>{const w=`$throttle$timer$${y}`,v=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,l=`$throttle$pending$${y}`;return function(...c){if(this[v]||(this[v]=b?b():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...c)),this[l])return;const u=this[m]+S;u<=Date.now()?(this[m]=Date.now(),$.apply(this,[this[v]]),this[v]=b?b():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),$.apply(this,[this[v]]),this[v]=b?b():void 0},u-Date.now()))}})}}),define(ye[11],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=j,e.$Z=I,e.$1=D,e.$2=S,e.$3=P,e.$4=$,e.$6=w,e.$7=v,e.$8=m,e.$0=c;class s{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=s,e.$X=new s;function j(f){e.$X.setUnexpectedErrorHandler(f)}function I(f){if(!f||typeof f!="object")return!1;const t=f;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(f){$(f)||e.$X.onUnexpectedError(f)}function S(f){$(f)||e.$X.onUnexpectedExternalError(f)}function P(f){if(f instanceof Error){const{name:t,message:o}=f,r=f.stacktrace||f.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:d.isErrorNoTelemetry(f)}}return f}const b="Canceled";function $(f){return f instanceof y?!0:f instanceof Error&&f.name===b&&f.message===b}class y extends Error{constructor(){super(b),this.name=this.message}}e.$5=y;function w(){const f=new Error(b);return f.name=f.message,f}function v(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}function m(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}class l extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=l;function c(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=u;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ye[18],Ee([1,0,11,147]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=I,e.$tb=D,e.$ub=S,e.$vb=P,e.$wb=b,e.$xb=$,e.$yb=y,e.$zb=w,e.$Ab=v,e.$Bb=m,e.$Cb=l,e.$Db=c,e.$Eb=u,e.top=h,e.$Gb=g,e.$Hb=E,e.$Ib=f,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=n,e.$Nb=a,e.$Ob=i,e.$Pb=p,e.$Qb=k,e.$Rb=C,e.$Sb=A,e.$Tb=O,e.$Ub=N,e.$Vb=V,e.$Wb=ie,e.$Xb=ae,e.$Yb=te,e.$Zb=ee,e.$1b=K,e.$2b=B,e.$3b=Z,e.$4b=Y,e.$5b=M,e.$6b=se,e.$7b=_,e.$0b=le;function I(x,Q=0){return x[x.length-(1+Q)]}function D(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function S(x,Q,G=(J,T)=>J===T){if(x===Q)return!0;if(!x||!Q||x.length!==Q.length)return!1;for(let J=0,T=x.length;J<T;J++)if(!G(x[J],Q[J]))return!1;return!0}function P(x,Q){const G=x.length-1;Q<G&&(x[Q]=x[G]),x.pop()}function b(x,Q,G){return $(x.length,J=>G(x[J],Q))}function $(x,Q){let G=0,J=x-1;for(;G<=J;){const T=(G+J)/2|0,W=Q(T);if(W<0)G=T+1;else if(W>0)J=T-1;else return T}return-(G+1)}function y(x,Q,G){if(x=x|0,x>=Q.length)throw new TypeError("invalid index");const J=Q[Math.floor(Q.length*Math.random())],T=[],W=[],ce=[];for(const ue of Q){const we=G(ue,J);we<0?T.push(ue):we>0?W.push(ue):ce.push(ue)}return x<T.length?y(x,T,G):x<T.length+ce.length?ce[0]:y(x-(T.length+ce.length),W,G)}function w(x,Q){const G=[];let J;for(const T of x.slice(0).sort(Q))!J||Q(J[0],T)!==0?(J=[T],G.push(J)):J.push(T);return G}function*v(x,Q){let G,J;for(const T of x)J!==void 0&&Q(J,T)?G.push(T):(G&&(yield G),G=[T]),J=T;G&&(yield G)}function m(x,Q){for(let G=0;G<=x.length;G++)Q(G===0?void 0:x[G-1],G===x.length?void 0:x[G])}function l(x,Q){for(let G=0;G<x.length;G++)Q(G===0?void 0:x[G-1],x[G],G+1===x.length?void 0:x[G+1])}function c(x,Q,G){const J=[];function T(ue,we,de){if(we===0&&de.length===0)return;const ge=J[J.length-1];ge&&ge.start+ge.deleteCount===ue?(ge.deleteCount+=we,ge.toInsert.push(...de)):J.push({start:ue,deleteCount:we,toInsert:de})}let W=0,ce=0;for(;;){if(W===x.length){T(W,0,Q.slice(ce));break}if(ce===Q.length){T(W,x.length-W,[]);break}const ue=x[W],we=Q[ce],de=G(ue,we);de===0?(W+=1,ce+=1):de<0?(T(W,1,[]),W+=1):de>0&&(T(W,0,[we]),ce+=1)}return J}function u(x,Q,G){const J=c(x,Q,G),T=[],W=[];for(const ce of J)T.push(...x.slice(ce.start,ce.start+ce.deleteCount)),W.push(...ce.toInsert);return{removed:T,added:W}}function h(x,Q,G){if(G===0)return[];const J=x.slice(0,G).sort(Q);return d(x,Q,J,G,x.length),J}function g(x,Q,G,J,T){return G===0?Promise.resolve([]):new Promise((W,ce)=>{(async()=>{const ue=x.length,we=x.slice(0,G).sort(Q);for(let de=G,ge=Math.min(G+J,ue);de<ue;de=ge,ge=Math.min(ge+J,ue)){if(de>G&&await new Promise($e=>setTimeout($e)),T&&T.isCancellationRequested)throw new s.$5;d(x,Q,we,de,ge)}return we})().then(W,ce)})}function d(x,Q,G,J,T){for(const W=G.length;J<T;J++){const ce=x[J];if(Q(ce,G[W-1])<0){G.pop();const ue=(0,j.$kb)(G,we=>Q(ce,we)<0);G.splice(ue,0,ce)}}}function E(x){return x.filter(Q=>!!Q)}function f(x){let Q=0;for(let G=0;G<x.length;G++)x[G]&&(x[Q]=x[G],Q+=1);x.length=Q}function t(x,Q,G){x.splice(G,0,x.splice(Q,1)[0])}function o(x){return!Array.isArray(x)||x.length===0}function r(x){return Array.isArray(x)&&x.length>0}function n(x,Q=G=>G){const G=new Set;return x.filter(J=>{const T=Q(J);return G.has(T)?!1:(G.add(T),!0)})}function a(x){const Q=new Set;return G=>{const J=x(G);return Q.has(J)?!1:(Q.add(J),!0)}}function i(x,Q){return x.length>0?x[0]:Q}function p(x,Q){return x.length>0?x[x.length-1]:Q}function k(x,Q,G=(J,T)=>J===T){let J=0;for(let T=0,W=Math.min(x.length,Q.length);T<W&&G(x[T],Q[T]);T++)J++;return J}function C(x,Q){let G=typeof Q=="number"?x:0;typeof Q=="number"?G=x:(G=0,Q=x);const J=[];if(G<=Q)for(let T=G;T<Q;T++)J.push(T);else for(let T=G;T>Q;T--)J.push(T);return J}function A(x,Q,G){return x.reduce((J,T)=>(J[Q(T)]=G?G(T):T,J),Object.create(null))}function O(x,Q){return x.push(Q),()=>N(x,Q)}function N(x,Q){const G=x.indexOf(Q);if(G>-1)return x.splice(G,1),Q}function V(x,Q,G){const J=x.slice(0,Q),T=x.slice(Q);return J.concat(G,T)}function ie(x,Q){let G;if(typeof Q=="number"){let J=Q;G=()=>{const T=Math.sin(J++)*179426549;return T-Math.floor(T)}}else G=Math.random;for(let J=x.length-1;J>0;J-=1){const T=Math.floor(G()*(J+1)),W=x[J];x[J]=x[T],x[T]=W}}function ae(x,Q){const G=x.indexOf(Q);G>-1&&(x.splice(G,1),x.unshift(Q))}function te(x,Q){const G=x.indexOf(Q);G>-1&&(x.splice(G,1),x.push(Q))}function ee(x,Q){for(const G of Q)x.push(G)}function K(x,Q){return Array.isArray(x)?x.map(Q):Q(x)}function B(x){return Array.isArray(x)?x:[x]}function Z(x){return x[Math.floor(Math.random()*x.length)]}function Y(x,Q,G){const J=z(x,Q),T=x.length,W=G.length;x.length=T+W;for(let ce=T-1;ce>=J;ce--)x[ce+W]=x[ce];for(let ce=0;ce<W;ce++)x[ce+J]=G[ce]}function M(x,Q,G,J){const T=z(x,Q);let W=x.splice(T,G);return W===void 0&&(W=[]),Y(x,T,J),W}function z(x,Q){return Q<0?Math.max(Q+x.length,0):Math.min(Q,x.length)}var oe;(function(x){function Q(W){return W<0}x.isLessThan=Q;function G(W){return W<=0}x.isLessThanOrEqual=G;function J(W){return W>0}x.isGreaterThan=J;function T(W){return W===0}x.isNeitherLessOrGreaterThan=T,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function se(x,Q){return(G,J)=>Q(x(G),x(J))}function _(...x){return(Q,G)=>{for(const J of x){const T=J(Q,G);if(!oe.isNeitherLessOrGreaterThan(T))return T}return oe.neitherLessOrGreaterThan}}const H=(x,Q)=>x-Q;e.$8b=H;const ne=(x,Q)=>(0,e.$8b)(x?1:0,Q?1:0);e.$9b=ne;function le(x){return(Q,G)=>-x(Q,G)}class F{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let G=this.c;for(;G<this.g.length&&Q(this.g[G]);)G++;const J=G===this.c?null:this.g.slice(this.c,G);return this.c=G,J}takeFromEndWhile(Q){let G=this.d;for(;G>=0&&Q(this.g[G]);)G--;const J=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const G=this.g.slice(this.c,this.c+Q);return this.c+=Q,G}}e.$$b=F;class U{static{this.empty=new U(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(G=>(Q(G),!0))}toArray(){const Q=[];return this.iterate(G=>(Q.push(G),!0)),Q}filter(Q){return new U(G=>this.iterate(J=>Q(J)?G(J):!0))}map(Q){return new U(G=>this.iterate(J=>G(Q(J))))}some(Q){let G=!1;return this.iterate(J=>(G=Q(J),!G)),G}findFirst(Q){let G;return this.iterate(J=>Q(J)?(G=J,!1):!0),G}findLast(Q){let G;return this.iterate(J=>(Q(J)&&(G=J),!0)),G}findLastMaxBy(Q){let G,J=!0;return this.iterate(T=>((J||oe.isGreaterThan(Q(T,G)))&&(J=!1,G=T),!0)),G}}e.$_b=U;class X{constructor(Q){this.c=Q}static createSortPermutation(Q,G){const J=Array.from(Q.keys()).sort((T,W)=>G(Q[T],Q[W]));return new X(J)}apply(Q){return Q.map((G,J)=>Q[this.c[J]])}inverse(){const Q=this.c.slice();for(let G=0;G<this.c.length;G++)Q[this.c[G]]=G;return new X(Q)}}e.$ac=X}),define(ye[98],Ee([1,0,11]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$ed=I,e.$fd=D,e.$gd=S,e.$hd=P,e.$id=b;function j($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function I($,y="Unreachable"){throw new Error(y)}function D($,y="unexpected state"){if(!$)throw new s.$cb(`Assertion Failed: ${y}`)}function S($){$||(0,s.$1)(new s.$cb("Soft Assertion Failed"))}function P($){if(!$()){debugger;$(),(0,s.$1)(new s.$cb("Assertion Failed"))}}function b($,y){let w=0;for(;w<$.length-1;){const v=$[w],m=$[w+1];if(!y(v,m))return!1;w++}return!0}}),define(ye[149],Ee([1,0,18]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=I,e.$8c=D,e.$9c=S,e.$0c=P,e.$$c=b,e.$_c=$;const j=(m,l)=>m===l;e.$6c=j;function I(m=e.$6c){return(l,c)=>s.$ub(l,c,m)}function D(){return(m,l)=>JSON.stringify(m)===JSON.stringify(l)}function S(){return(m,l)=>m.equals(l)}function P(m,l,c){return!m||!l?m===l:c(m,l)}function b(m,l){if(m===l)return!0;if(Array.isArray(m)&&Array.isArray(l)){if(m.length!==l.length)return!1;for(let c=0;c<m.length;c++)if(!b(m[c],l[c]))return!1;return!0}if(m&&typeof m=="object"&&l&&typeof l=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(l)===Object.prototype){const c=m,u=l,h=Object.keys(c),g=Object.keys(u),d=new Set(g);if(h.length!==g.length)return!1;for(const E of h)if(!d.has(E)||!b(c[E],u[E]))return!1;return!0}return!1}function $(m){return JSON.stringify(v(m))}let y=0;const w=new WeakMap;function v(m){if(Array.isArray(m))return m.map(v);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const l=m,c=Object.create(null);for(const u of Object.keys(l).sort())c[u]=v(l[u]);return c}else{let l=w.get(m);return l===void 0&&(l=y++,w.set(m,l)),l+"----2b76a038c20c4bcc"}return m}}),define(ye[75],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=s;function s(j,I){const D=this;let S=!1,P;return function(){if(S)return P;if(S=!0,I)try{P=j.apply(D,arguments)}finally{I()}else P=j.apply(D,arguments);return P}}}),define(ye[41],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(j){function I(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}j.is=I;const D=Object.freeze([]);function S(){return D}j.empty=S;function*P(t){yield t}j.single=P;function b(t){return I(t)?t:P(t)}j.wrap=b;function $(t){return t||D}j.from=$;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}j.reverse=y;function w(t){return!t||t[Symbol.iterator]().next().done===!0}j.isEmpty=w;function v(t){return t[Symbol.iterator]().next().value}j.first=v;function m(t,o){for(const r of t)if(o(r))return!0;return!1}j.some=m;function l(t,o){for(const r of t)if(o(r))return r}j.find=l;function*c(t,o){for(const r of t)o(r)&&(yield r)}j.filter=c;function*u(t,o){let r=0;for(const n of t)yield o(n,r++)}j.map=u;function*h(...t){for(const o of t)yield*o}j.concat=h;function g(t,o,r){let n=r;for(const a of t)n=o(n,a);return n}j.reduce=g;function*d(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}j.slice=d;function E(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const n=t[Symbol.iterator]();for(let a=0;a<o;a++){const i=n.next();if(i.done)return[r,j.empty()];r.push(i.value)}return[r,{[Symbol.iterator](){return n}}]}j.consume=E;async function f(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}j.asyncToArray=f})(s||(e.Iterable=s={}))}),define(ye[43],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=S,e.$Mn=w,e.$Nn=v,e.$On=m,e.$Pn=l,e.$Qn=c,e.$Rn=u,e.$Sn=h,e.$Tn=g,e.$Un=d,e.$Vn=E,e.$Wn=f;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function S(t,o=!1){let r=0;const n=t.length;let a="",i=0,p=16,k=0;function C(te){let ee=0,K=0;for(;ee<te;){const B=t.charCodeAt(r);if(B>=48&&B<=57)K=K*16+B-48;else if(B>=65&&B<=70)K=K*16+B-65+10;else if(B>=97&&B<=102)K=K*16+B-97+10;else break;r++,ee++}return ee<te&&(K=-1),K}function A(te){r=te,a="",i=0,p=16,k=0}function O(){const te=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&$(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&$(t.charCodeAt(r)))for(r++;r<t.length&&$(t.charCodeAt(r));)r++;else return k=3,t.substring(te,r);let ee=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&$(t.charCodeAt(r))){for(r++;r<t.length&&$(t.charCodeAt(r));)r++;ee=r}else k=3;return t.substring(te,ee)}function N(){let te="",ee=r;for(;;){if(r>=n){te+=t.substring(ee,r),k=2;break}const K=t.charCodeAt(r);if(K===34){te+=t.substring(ee,r),r++;break}if(K===92){if(te+=t.substring(ee,r),r++,r>=n){k=2;break}switch(t.charCodeAt(r++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const Z=C(4);Z>=0?te+=String.fromCharCode(Z):k=4;break}default:k=5}ee=r;continue}if(K>=0&&K<=31)if(b(K)){te+=t.substring(ee,r),k=2;break}else k=6;r++}return te}function V(){if(a="",k=0,i=r,r>=n)return i=n,p=17;let te=t.charCodeAt(r);if(P(te)){do r++,a+=String.fromCharCode(te),te=t.charCodeAt(r);while(P(te));return p=15}if(b(te))return r++,a+=String.fromCharCode(te),te===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),p=14;switch(te){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,a=N(),p=10;case 47:{const ee=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!b(t.charCodeAt(r));)r++;return a=t.substring(ee,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const K=n-1;let B=!1;for(;r<K;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,k=1),a=t.substring(ee,r),p=13}return a+=String.fromCharCode(te),r++,p=16}case 45:if(a+=String.fromCharCode(te),r++,r===n||!$(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),p=11;default:for(;r<n&&ie(te);)r++,te=t.charCodeAt(r);if(i!==r){switch(a=t.substring(i,r),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(te),r++,p=16}}function ie(te){if(P(te)||b(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let te;do te=V();while(te>=12&&te<=15);return te}return{setPosition:A,getPosition:()=>r,scan:o?ae:V,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>i,getTokenLength:()=>r-i,getTokenError:()=>k}}function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function w(t,o){const r=[],n=new Object;let a;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function k(C,A,O,N){i.value=C,i.offset=A,i.length=O,i.type=N,i.colonOffset=void 0,a=i}try{d(t,{onObjectBegin:(C,A)=>{if(o<=C)throw n;a=void 0,p=o>C,r.push("")},onObjectProperty:(C,A,O)=>{if(o<A||(k(C,A,O,"property"),r[r.length-1]=C,o<=A+O))throw n},onObjectEnd:(C,A)=>{if(o<=C)throw n;a=void 0,r.pop()},onArrayBegin:(C,A)=>{if(o<=C)throw n;a=void 0,r.push(0)},onArrayEnd:(C,A)=>{if(o<=C)throw n;a=void 0,r.pop()},onLiteralValue:(C,A,O)=>{if(o<A||(k(C,A,O,f(C)),o<=A+O))throw n},onSeparator:(C,A,O)=>{if(o<=A)throw n;if(C===":"&&a&&a.type==="property")a.colonOffset=A,p=!1,a=void 0;else if(C===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(p=!0,r[r.length-1]=""),a=void 0}}})}catch(C){if(C!==n)throw C}return{path:r,previousNode:a,isAtPropertyKey:p,matches:C=>{let A=0;for(let O=0;A<C.length&&O<r.length;O++)if(C[A]===r[O]||C[A]==="*")A++;else if(C[A]!=="**")return!1;return A===C.length}}}function v(t,o=[],r=D.DEFAULT){let n=null,a=[];const i=[];function p(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}return d(t,{onObjectBegin:()=>{const C={};p(C),i.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=i.pop()},onArrayBegin:()=>{const C=[];p(C),i.push(a),a=C,n=null},onArrayEnd:()=>{a=i.pop()},onLiteralValue:p,onError:(C,A,O)=>{o.push({error:C,offset:A,length:O})}},r),a[0]}function m(t,o=[],r=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function i(C){return n.children.push(C),C}d(t,{onObjectBegin:C=>{n=i({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,A,O)=>{n=i({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:A,length:O,parent:n})},onObjectEnd:(C,A)=>{n.length=C+A-n.offset,n=n.parent,a(C+A)},onArrayBegin:(C,A)=>{n=i({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,A)=>{n.length=C+A-n.offset,n=n.parent,a(C+A)},onLiteralValue:(C,A,O)=>{i({type:f(C),offset:A,length:O,parent:n,value:C}),a(A+O)},onSeparator:(C,A,O)=>{n.type==="property"&&(C===":"?n.colonOffset=A:C===","&&a(A))},onError:(C,A,O)=>{o.push({error:C,offset:A,length:O})}},r);const k=n.children[0];return k&&delete k.parent,k}function l(t,o){if(!t)return;let r=t;for(const n of o)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const i of r.children)if(Array.isArray(i.children)&&i.children[0].value===n){r=i.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}function c(t){if(!t.parent||!t.parent.children)return[];const o=c(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const o=Object.create(null);for(const r of t.children){const n=r.children[1];n&&(o[r.children[0].value]=u(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function h(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function g(t,o,r=!1){if(h(t,o,r)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=o;a++){const i=g(n[a],o,r);if(i)return i}return t}}function d(t,o,r=D.DEFAULT){const n=S(t,!1);function a(_){return _?()=>_(n.getTokenOffset(),n.getTokenLength()):()=>!0}function i(_){return _?H=>_(H,n.getTokenOffset(),n.getTokenLength()):()=>!0}const p=a(o.onObjectBegin),k=i(o.onObjectProperty),C=a(o.onObjectEnd),A=a(o.onArrayBegin),O=a(o.onArrayEnd),N=i(o.onLiteralValue),V=i(o.onSeparator),ie=a(o.onComment),ae=i(o.onError),te=r&&r.disallowComments,ee=r&&r.allowTrailingComma;function K(){for(;;){const _=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(_){case 12:case 13:te?B(10):ie();break;case 16:B(1);break;case 15:case 14:break;default:return _}}}function B(_,H=[],ne=[]){if(ae(_),H.length+ne.length>0){let le=n.getToken();for(;le!==17;){if(H.indexOf(le)!==-1){K();break}else if(ne.indexOf(le)!==-1)break;le=K()}}}function Z(_){const H=n.getTokenValue();return _?N(H):k(H),K(),!0}function Y(){switch(n.getToken()){case 11:{let _=0;try{_=JSON.parse(n.getTokenValue()),typeof _!="number"&&(B(2),_=0)}catch{B(2)}N(_);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return K(),!0}function M(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(Z(!1),n.getToken()===6?(V(":"),K(),se()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function z(){p(),K();let _=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(_||B(4,[],[]),V(","),K(),n.getToken()===2&&ee)break}else _&&B(6,[],[]);M()||B(4,[],[2,5]),_=!0}return C(),n.getToken()!==2?B(7,[2],[]):K(),!0}function oe(){A(),K();let _=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(_||B(4,[],[]),V(","),K(),n.getToken()===4&&ee)break}else _&&B(6,[],[]);se()||B(4,[],[4,5]),_=!0}return O(),n.getToken()!==4?B(8,[4],[]):K(),!0}function se(){switch(n.getToken()){case 3:return oe();case 1:return z();case 10:return Z(!0);default:return Y()}}return K(),n.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):se()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function E(t,o){const r=S(t),n=[];let a,i=0,p;do switch(p=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:i!==p&&n.push(t.substring(i,p)),o!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,o)),i=r.getPosition();break}while(a!==17);return n.join("")}function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[150],Ee([1,0,43]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=j,e.$Yn=I,e.$Zn=P,e.$1n=b;function j($,y,w){let v,m,l,c,u;if(y){for(c=y.offset,u=c+y.length,l=c;l>0&&!b($,l-1);)l--;let p=u;for(;p<$.length&&!b($,p);)p++;m=$.substring(l,p),v=S(m,w)}else m=$,v=0,l=0,c=0,u=$.length;const h=P(w,$);let g=!1,d=0,E;w.insertSpaces?E=D(" ",w.tabSize||4):E="	";const f=(0,s.$Ln)(m,!1);let t=!1;function o(){return h+D(E,v+d)}function r(){let p=f.scan();for(g=!1;p===15||p===14;)g=g||p===14,p=f.scan();return t=p===16||f.getTokenError()!==0,p}const n=[];function a(p,k,C){!t&&k<u&&C>c&&$.substring(k,C)!==p&&n.push({offset:k,length:C-k,content:p})}let i=r();if(i!==17){const p=f.getTokenOffset()+l,k=D(E,v);a(k,l,p)}for(;i!==17;){let p=f.getTokenOffset()+f.getTokenLength()+l,k=r(),C="";for(;!g&&(k===12||k===13);){const O=f.getTokenOffset()+l;a(" ",p,O),p=f.getTokenOffset()+f.getTokenLength()+l,C=k===12?o():"",k=r()}if(k===2)i!==1&&(d--,C=o());else if(k===4)i!==3&&(d--,C=o());else{switch(i){case 3:case 1:d++,C=o();break;case 5:case 12:C=o();break;case 13:g?C=o():C=" ";break;case 6:C=" ";break;case 10:if(k===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?C=" ":k!==5&&k!==17&&(t=!0);break;case 16:t=!0;break}g&&(k===12||k===13)&&(C=o())}const A=f.getTokenOffset()+l;a(C,p,A),i=k}return n}function I($,y){const w=JSON.stringify($,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?w.replace(/\r\n|\r|\n/g,y.eol):w}function D($,y){let w="";for(let v=0;v<y;v++)w+=$;return w}function S($,y){let w=0,v=0;const m=y.tabSize||4;for(;w<$.length;){const l=$.charAt(w);if(l===" ")v++;else if(l==="	")v+=m;else break;w++}return Math.floor(v/m)}function P($,y){for(let w=0;w<y.length;w++){const v=y.charAt(w);if(v==="\r")return w+1<y.length&&y.charAt(w+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return $&&$.eol||`
`}function b($,y){return`\r
`.indexOf($.charAt(y))!==-1}}),define(ye[151],Ee([1,0,43,150]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=I,e.$3n=D,e.$4n=S,e.$5n=P,e.$6n=b;function I($,y,w){return D($,y,void 0,w)}function D($,y,w,v,m){const l=y.slice(),c=[],u=(0,s.$On)($,c);let h,g;for(;l.length>0&&(g=l.pop(),h=(0,s.$Pn)(u,l),h===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const d=(0,s.$Pn)(h,[g]);if(d!==void 0)if(w===void 0){if(!d.parent)throw new Error("Malformed AST");const E=h.children.indexOf(d.parent);let f,t=d.parent.offset+d.parent.length;if(E>0){const o=h.children[E-1];f=o.offset+o.length}else f=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return S($,{offset:f,length:t-f,content:""},v)}else return S($,{offset:d.offset,length:d.length,content:JSON.stringify(w)},v);else{if(w===void 0)return[];const E=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,f=m?m(h.children.map(o=>o.children[0].value)):h.children.length;let t;if(f>0){const o=h.children[f-1];t={offset:o.offset+o.length,length:0,content:","+E}}else h.children.length===0?t={offset:h.offset+1,length:0,content:E}:t={offset:h.offset+1,length:0,content:E+","};return S($,t,v)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(w!==void 0){const d=`${JSON.stringify(w)}`;let E;if(h.children.length===0||g===0)E={offset:h.offset+1,length:0,content:h.children.length===0?d:d+","};else{const f=g===-1||g>h.children.length?h.children.length:g,t=h.children[f-1];E={offset:t.offset+t.length,length:0,content:","+d}}return S($,E,v)}else{const d=g,E=h.children[d];let f;if(h.children.length===1)f={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===d){const t=h.children[d-1],o=t.offset+t.length,r=h.offset+h.length;f={offset:o,length:r-2-o,content:""}}else f={offset:E.offset,length:h.children[d+1].offset-E.offset,content:""};return S($,f,v)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else return w===void 0?[]:S($,{offset:u?u.offset:0,length:u?u.length:0,content:JSON.stringify(w)},v)}function S($,y,w){let v=P($,y),m=y.offset,l=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,j.$1n)(v,m-1);)m--;for(;l<v.length&&!(0,j.$1n)(v,l);)l++}const c=(0,j.$Xn)(v,{offset:m,length:l-m},w);for(let h=c.length-1;h>=0;h--){const g=c[h];v=P(v,g),m=Math.min(m,g.offset),l=Math.max(l,g.offset+g.length),l+=g.content.length-g.length}const u=$.length-(v.length-l)-m;return[{offset:m,length:u,content:v.substring(m,l)}]}function P($,y){return $.substring(0,y.offset)+y.content+$.substring(y.offset+y.length)}function b($,y){const w=y.slice(0).sort((m,l)=>{const c=m.offset-l.offset;return c===0?m.length-l.length:c});let v=$.length;for(let m=w.length-1;m>=0;m--){const l=w[m];if(l.offset+l.length<=v)$=P($,l);else throw new Error("Overlapping edit");v=l.offset}return $}}),define(ye[60],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class s{constructor(I){this.d=I,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=s}),define(ye[99],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class s{static{this.Undefined=new s(void 0)}constructor(D){this.element=D,this.next=s.Undefined,this.prev=s.Undefined}}class j{constructor(){this.a=s.Undefined,this.b=s.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===s.Undefined}clear(){let D=this.a;for(;D!==s.Undefined;){const S=D.next;D.prev=s.Undefined,D.next=s.Undefined,D=S}this.a=s.Undefined,this.b=s.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,S){const P=new s(D);if(this.a===s.Undefined)this.a=P,this.b=P;else if(S){const $=this.b;this.b=P,P.prev=$,$.next=P}else{const $=this.a;this.a=P,P.next=$,$.prev=P}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(P))}}shift(){if(this.a!==s.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==s.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==s.Undefined&&D.next!==s.Undefined){const S=D.prev;S.next=D.next,D.next.prev=S}else D.prev===s.Undefined&&D.next===s.Undefined?(this.a=s.Undefined,this.b=s.Undefined):D.next===s.Undefined?(this.b=this.b.prev,this.b.next=s.Undefined):D.prev===s.Undefined&&(this.a=this.a.next,this.a.prev=s.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==s.Undefined;)yield D.element,D=D.next}}e.$5c=j}),define(ye[24],Ee([1,0]),function(fe,e){"use strict";var s,j,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=D,e.$yc=S,e.$zc=P,e.$Ic=E;function D(f,t,o){let r=f.get(t);return r===void 0&&(r=o,f.set(t,r)),r}function S(f){const t=[];return f.forEach((o,r)=>{t.push(`${r} => ${o}`)}),`Map(${f.size}) {${t.join(", ")}}`}function P(f){const t=[];return f.forEach(o=>{t.push(o)}),`Set(${f.size}) {${t.join(", ")}}`}class b{constructor(t,o){this.uri=t,this.value=o}}function $(f){return Array.isArray(f)}class y{static{this.c=t=>t.toString()}constructor(t,o){if(this[s]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=o??y.c;else if($(t)){this.d=new Map,this.e=o??y.c;for(const[r,n]of t)this.set(r,n)}else this.d=new Map,this.e=t??y.c}set(t,o){return this.d.set(this.e(t),new b(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[r,n]of this.d)t(n.value,n.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=y;class w{constructor(t,o){this[j]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((r,n)=>t.call(o,n,n,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=w;var v;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class m{constructor(){this[I]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=0){const r=this.c.get(t);if(r)return o!==0&&this.m(r,o),r.value}set(t,o,r=0){let n=this.c.get(t);if(n)n.value=o,r!==0&&this.m(n,r);else{switch(n={key:t,value:o,next:void 0,previous:void 0},r){case 0:this.k(n);break;case 1:this.j(n);break;case 2:this.k(n);break;default:this.k(n);break}this.c.set(t,n),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const r=this.g;let n=this.d;for(;n;){if(o?t.bind(o)(n.value,n.key,this):t(n.value,n.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const t=this,o=this.g;let r=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.key,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return n}values(){const t=this,o=this.g;let r=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:r.value,done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return n}entries(){const t=this,o=this.g;let r=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(r){const a={value:[r.key,r.value],done:!1};return r=r.next,a}else return{value:void 0,done:!0}}};return n}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,r=this.size;for(;o&&r>t;)this.c.delete(o.key),o=o.next,r--;this.d=o,this.f=r,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,r=this.size;for(;o&&r>t;)this.c.delete(o.key),o=o.previous,r--;this.e=o,this.f=r,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,r=t.previous;if(!o||!r)throw new Error("Invalid list");o.previous=r,r.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.d)return;const r=t.next,n=t.previous;t===this.e?(n.next=void 0,this.e=n):(r.previous=n,n.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===2){if(t===this.e)return;const r=t.next,n=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=n,n.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,r)=>{t.push([r,o])}),t}fromJSON(t){this.clear();for(const[o,r]of t)this.set(o,r)}}e.$Cc=m;class l extends m{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends l{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=c;class u extends l{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=u;class h{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=h;class g{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,r]of t)this.set(o,r)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((r,n)=>{t.call(o,r,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class d{constructor(){this.c=new Map}add(t,o){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(o)}delete(t,o){const r=this.c.get(t);r&&(r.delete(o),r.size===0&&this.c.delete(t))}forEach(t,o){const r=this.c.get(t);r&&r.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=d;function E(f,t){if(f===t)return!0;if(f.size!==t.size)return!1;for(const[o,r]of f)if(!t.has(o)||t.get(o)!==r)return!1;for(const[o]of t)if(!f.has(o))return!1;return!0}}),define(ye[2],Ee([1,0,18,148,24,75,41]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=y,e.$Lc=w,e.$Mc=v,e.$Nc=c,e.$Oc=u,e.$Pc=h,e.$Qc=g,e.$Rc=d,e.$Sc=E,e.$3c=C;const P=!1;let b=null;class ${constructor(){this.b=new Map}static{this.a=0}c(N){let V=this.b.get(N);return V||(V={parent:null,source:null,isSingleton:!1,value:N,idx:$.a++},this.b.set(N,V)),V}trackDisposable(N){const V=this.c(N);V.source||(V.source=new Error().stack)}setParent(N,V){const ie=this.c(N);ie.parent=V}markAsDisposed(N){this.b.delete(N)}markAsSingleton(N){this.c(N).isSingleton=!0}f(N,V){const ie=V.get(N);if(ie)return ie;const ae=N.parent?this.f(this.c(N.parent),V):N;return V.set(N,ae),ae}getTrackedDisposables(){const N=new Map;return[...this.b.entries()].filter(([,ie])=>ie.source!==null&&!this.f(ie,N).isSingleton).flatMap(([ie])=>ie)}computeLeakingDisposables(N=10,V){let ie;if(V)ie=V;else{const B=new Map,Z=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,B).isSingleton);if(Z.length===0)return;const Y=new Set(Z.map(M=>M.value));if(ie=Z.filter(M=>!(M.parent&&Y.has(M.parent))),ie.length===0)throw new Error("There are cyclic diposable chains!")}if(!ie)return;function ae(B){function Z(M,z){for(;M.length>0&&z.some(oe=>typeof oe=="string"?oe===M[0]:M[0].match(oe));)M.shift()}const Y=B.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return Z(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const te=new I.$Hc;for(const B of ie){const Z=ae(B);for(let Y=0;Y<=Z.length;Y++)te.add(Z.slice(0,Y).join(`
`),B)}ie.sort((0,s.$6b)(B=>B.idx,s.$8b));let ee="",K=0;for(const B of ie.slice(0,N)){K++;const Z=ae(B),Y=[];for(let M=0;M<Z.length;M++){let z=Z[M];z=`(shared with ${te.get(Z.slice(0,M+1).join(`
`)).size}/${ie.length} leaks) at ${z}`;const se=te.get(Z.slice(0,M).join(`
`)),_=(0,j.$K)([...se].map(H=>ae(H)[M]),H=>H);delete _[Z[M]];for(const[H,ne]of Object.entries(_))Y.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${H}`);Y.unshift(z)}ee+=`


==================== Leaking disposable ${K}/${ie.length}: ${B.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return ie.length>N&&(ee+=`


... and ${ie.length-N} more leaking disposables

`),{leaks:ie,details:ee}}}e.$Jc=$;function y(O){b=O}if(P){const O="__is_disposable_tracked__";y(new class{trackDisposable(N){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{N[O]||console.log(V)},3e3)}setParent(N,V){if(N&&N!==t.None)try{N[O]=!0}catch{}}markAsDisposed(N){if(N&&N!==t.None)try{N[O]=!0}catch{}}markAsSingleton(N){}})}function w(O){return b?.trackDisposable(O),O}function v(O){b?.markAsDisposed(O)}function m(O,N){b?.setParent(O,N)}function l(O,N){if(b)for(const V of O)b.setParent(V,N)}function c(O){return b?.markAsSingleton(O),O}function u(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function h(O){if(S.Iterable.is(O)){const N=[];for(const V of O)if(V)try{V.dispose()}catch(ie){N.push(ie)}if(N.length===1)throw N[0];if(N.length>1)throw new AggregateError(N,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function g(O){for(const N of O)u(N)&&N.dispose();return[]}function d(...O){const N=E(()=>h(O));return l(O,N),N}function E(O){const N=w({dispose:(0,D.$db)(()=>{v(N),O()})});return N}class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(N){if(!N)return N;if(N===this)throw new Error("Cannot register a disposable on itself!");return m(N,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(N),N}delete(N){if(N){if(N===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(N),N.dispose()}}deleteAndLeak(N){N&&this.f.has(N)&&(this.f.delete(N),m(N,null))}}e.$Tc=f;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,w(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(N){if(N===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(N)}}e.$Uc=t;class o{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(N){this.b||N===this.a||(this.a?.dispose(),N&&m(N,this),this.a=N)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const N=this.a;return this.a=void 0,N&&m(N,null),N}}e.$Vc=o;class r{constructor(N){this.a=new o,this.b=!1,this.a.value=N}get value(){return this.a.value}set value(N){this.b||N===this.a.value||(this.a.value=N)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class n{constructor(N){this.b=N,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(N){let V=N;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,v(this))},this}}e.$Yc=a;class i{constructor(){this.a=new Map}acquire(N,...V){let ie=this.a.get(N);ie||(ie={counter:0,object:this.b(N,...V)},this.a.set(N,ie));const{object:ae}=ie,te=(0,D.$db)(()=>{--ie.counter===0&&(this.c(N,ie.object),this.a.delete(N))});return ie.counter++,{object:ae,dispose:te}}}e.$Zc=i;class p{constructor(N){this.a=N}async acquire(N,...V){const ie=this.a.acquire(N,...V);try{return{object:await ie.object,dispose:()=>ie.dispose()}}catch(ae){throw ie.dispose(),ae}}}e.$1c=p;class k{constructor(N){this.object=N}dispose(){}}e.$2c=k;function C(O){const N=new f;try{O(N)}finally{N.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(N){return this.a.has(N)}get size(){return this.a.size}get(N){return this.a.get(N)}set(N,V,ie=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ie||this.a.get(N)?.dispose(),this.a.set(N,V)}deleteAndDispose(N){this.a.get(N)?.dispose(),this.a.delete(N)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=A}),function(fe,e){typeof define=="function"&&define.amd?define(ye[152],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Q,G){for(var J=0;J<G.length;J++){var T=G[J];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(Q,T.key,T)}}function s(Q,G,J){return G&&e(Q.prototype,G),J&&e(Q,J),Object.defineProperty(Q,"prototype",{writable:!1}),Q}function j(Q,G){if(Q){if(typeof Q=="string")return I(Q,G);var J=Object.prototype.toString.call(Q).slice(8,-1);if(J==="Object"&&Q.constructor&&(J=Q.constructor.name),J==="Map"||J==="Set")return Array.from(Q);if(J==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))return I(Q,G)}}function I(Q,G){(G==null||G>Q.length)&&(G=Q.length);for(var J=0,T=new Array(G);J<G;J++)T[J]=Q[J];return T}function D(Q,G){var J=typeof Symbol<"u"&&Q[Symbol.iterator]||Q["@@iterator"];if(J)return(J=J.call(Q)).next.bind(J);if(Array.isArray(Q)||(J=j(Q))||G&&Q&&typeof Q.length=="number"){J&&(Q=J);var T=0;return function(){return T>=Q.length?{done:!0}:{done:!1,value:Q[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=S();function P(Q){fe.defaults=Q}var b=/[&<>"']/,$=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(G){return v[G]};function l(Q,G){if(G){if(b.test(Q))return Q.replace($,m)}else if(y.test(Q))return Q.replace(w,m);return Q}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Q){return Q.replace(c,function(G,J){return J=J.toLowerCase(),J==="colon"?":":J.charAt(0)==="#"?J.charAt(1)==="x"?String.fromCharCode(parseInt(J.substring(2),16)):String.fromCharCode(+J.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(Q,G){Q=typeof Q=="string"?Q:Q.source,G=G||"";var J={replace:function(W,ce){return ce=ce.source||ce,ce=ce.replace(h,"$1"),Q=Q.replace(W,ce),J},getRegex:function(){return new RegExp(Q,G)}};return J}var d=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(Q,G,J){if(Q){var T;try{T=decodeURIComponent(u(J)).replace(d,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}G&&!E.test(J)&&(J=a(G,J));try{J=encodeURI(J).replace(/%25/g,"%")}catch{return null}return J}var t={},o=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Q,G){t[" "+Q]||(o.test(Q)?t[" "+Q]=Q+"/":t[" "+Q]=C(Q,"/",!0)),Q=t[" "+Q];var J=Q.indexOf(":")===-1;return G.substring(0,2)==="//"?J?G:Q.replace(r,"$1")+G:G.charAt(0)==="/"?J?G:Q.replace(n,"$1")+G:Q+G}var i={exec:function(){}};function p(Q){for(var G=1,J,T;G<arguments.length;G++){J=arguments[G];for(T in J)Object.prototype.hasOwnProperty.call(J,T)&&(Q[T]=J[T])}return Q}function k(Q,G){var J=Q.replace(/\|/g,function(ce,ue,we){for(var de=!1,ge=ue;--ge>=0&&we[ge]==="\\";)de=!de;return de?"|":" |"}),T=J.split(/ \|/),W=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>G)T.splice(G);else for(;T.length<G;)T.push("");for(;W<T.length;W++)T[W]=T[W].trim().replace(/\\\|/g,"|");return T}function C(Q,G,J){var T=Q.length;if(T===0)return"";for(var W=0;W<T;){var ce=Q.charAt(T-W-1);if(ce===G&&!J)W++;else if(ce!==G&&J)W++;else break}return Q.slice(0,T-W)}function A(Q,G){if(Q.indexOf(G[1])===-1)return-1;for(var J=Q.length,T=0,W=0;W<J;W++)if(Q[W]==="\\")W++;else if(Q[W]===G[0])T++;else if(Q[W]===G[1]&&(T--,T<0))return W;return-1}function O(Q){Q&&Q.sanitize&&!Q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Q,G){if(G<1)return"";for(var J="";G>1;)G&1&&(J+=Q),G>>=1,Q+=Q;return J+Q}function V(Q,G,J,T){var W=G.href,ce=G.title?l(G.title):null,ue=Q[1].replace(/\\([\[\]])/g,"$1");if(Q[0].charAt(0)!=="!"){T.state.inLink=!0;var we={type:"link",raw:J,href:W,title:ce,text:ue,tokens:T.inlineTokens(ue)};return T.state.inLink=!1,we}return{type:"image",raw:J,href:W,title:ce,text:l(ue)}}function ie(Q,G){var J=Q.match(/^(\s+)(?:```)/);if(J===null)return G;var T=J[1];return G.split(`
`).map(function(W){var ce=W.match(/^\s+/);if(ce===null)return W;var ue=ce[0];return ue.length>=T.length?W.slice(T.length):W}).join(`
`)}var ae=function(){function Q(J){this.options=J||fe.defaults}var G=Q.prototype;return G.space=function(T){var W=this.rules.block.newline.exec(T);if(W&&W[0].length>0)return{type:"space",raw:W[0]}},G.code=function(T){var W=this.rules.block.code.exec(T);if(W){var ce=W[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:W[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:C(ce,`
`)}}},G.fences=function(T){var W=this.rules.block.fences.exec(T);if(W){var ce=W[0],ue=ie(ce,W[3]||"");return{type:"code",raw:ce,lang:W[2]?W[2].trim():W[2],text:ue}}},G.heading=function(T){var W=this.rules.block.heading.exec(T);if(W){var ce=W[2].trim();if(/#$/.test(ce)){var ue=C(ce,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(ce=ue.trim())}return{type:"heading",raw:W[0],depth:W[1].length,text:ce,tokens:this.lexer.inline(ce)}}},G.hr=function(T){var W=this.rules.block.hr.exec(T);if(W)return{type:"hr",raw:W[0]}},G.blockquote=function(T){var W=this.rules.block.blockquote.exec(T);if(W){var ce=W[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:W[0],tokens:this.lexer.blockTokens(ce,[]),text:ce}}},G.list=function(T){var W=this.rules.block.list.exec(T);if(W){var ce,ue,we,de,ge,$e,Ce,Ae,he,De,ke,Me,Fe=W[1].trim(),He=Fe.length>1,Be={type:"list",raw:"",ordered:He,start:He?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=He?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=He?Fe:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Me=!1,!(!(W=Ge.exec(T))||this.rules.block.hr.test(T)));){if(ce=W[0],T=T.substring(ce.length),Ae=W[2].split(`
`,1)[0],he=T.split(`
`,1)[0],this.options.pedantic?(de=2,ke=Ae.trimLeft()):(de=W[2].search(/[^ ]/),de=de>4?1:de,ke=Ae.slice(de),de+=W[1].length),$e=!1,!Ae&&/^ *$/.test(he)&&(ce+=he+`
`,T=T.substring(he.length+1),Me=!0),!Me)for(var Ze=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),Qe=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");T&&(De=T.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(Ae)||Qe.test(Ae)||Ze.test(Ae)||_e.test(T)));){if(Ae.search(/[^ ]/)>=de||!Ae.trim())ke+=`
`+Ae.slice(de);else if(!$e)ke+=`
`+Ae;else break;!$e&&!Ae.trim()&&($e=!0),ce+=De+`
`,T=T.substring(De.length+1)}Be.loose||(Ce?Be.loose=!0:/\n *\n *$/.test(ce)&&(Ce=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(ke),ue&&(we=ue[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:ce,task:!!ue,checked:we,loose:!1,text:ke}),Be.raw+=ce}Be.items[Be.items.length-1].raw=ce.trimRight(),Be.items[Be.items.length-1].text=ke.trimRight(),Be.raw=Be.raw.trimRight();var Je=Be.items.length;for(ge=0;ge<Je;ge++){this.lexer.state.top=!1,Be.items[ge].tokens=this.lexer.blockTokens(Be.items[ge].text,[]);var xe=Be.items[ge].tokens.filter(function(Pe){return Pe.type==="space"}),pe=xe.every(function(Pe){for(var je=Pe.raw.split(""),Ne=0,Ue=D(je),Ve;!(Ve=Ue()).done;){var nt=Ve.value;if(nt===`
`&&(Ne+=1),Ne>1)return!0}return!1});!Be.loose&&xe.length&&pe&&(Be.loose=!0,Be.items[ge].loose=!0)}return Be}},G.html=function(T){var W=this.rules.block.html.exec(T);if(W){var ce={type:"html",raw:W[0],pre:!this.options.sanitizer&&(W[1]==="pre"||W[1]==="script"||W[1]==="style"),text:W[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(W[0]):l(W[0]);ce.type="paragraph",ce.text=ue,ce.tokens=this.lexer.inline(ue)}return ce}},G.def=function(T){var W=this.rules.block.def.exec(T);if(W){W[3]&&(W[3]=W[3].substring(1,W[3].length-1));var ce=W[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ce,raw:W[0],href:W[2],title:W[3]}}},G.table=function(T){var W=this.rules.block.table.exec(T);if(W){var ce={type:"table",header:k(W[1]).map(function(Ce){return{text:Ce}}),align:W[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:W[3]&&W[3].trim()?W[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=W[0];var ue=ce.align.length,we,de,ge,$e;for(we=0;we<ue;we++)/^ *-+: *$/.test(ce.align[we])?ce.align[we]="right":/^ *:-+: *$/.test(ce.align[we])?ce.align[we]="center":/^ *:-+ *$/.test(ce.align[we])?ce.align[we]="left":ce.align[we]=null;for(ue=ce.rows.length,we=0;we<ue;we++)ce.rows[we]=k(ce.rows[we],ce.header.length).map(function(Ce){return{text:Ce}});for(ue=ce.header.length,de=0;de<ue;de++)ce.header[de].tokens=this.lexer.inline(ce.header[de].text);for(ue=ce.rows.length,de=0;de<ue;de++)for($e=ce.rows[de],ge=0;ge<$e.length;ge++)$e[ge].tokens=this.lexer.inline($e[ge].text);return ce}}},G.lheading=function(T){var W=this.rules.block.lheading.exec(T);if(W)return{type:"heading",raw:W[0],depth:W[2].charAt(0)==="="?1:2,text:W[1],tokens:this.lexer.inline(W[1])}},G.paragraph=function(T){var W=this.rules.block.paragraph.exec(T);if(W){var ce=W[1].charAt(W[1].length-1)===`
`?W[1].slice(0,-1):W[1];return{type:"paragraph",raw:W[0],text:ce,tokens:this.lexer.inline(ce)}}},G.text=function(T){var W=this.rules.block.text.exec(T);if(W)return{type:"text",raw:W[0],text:W[0],tokens:this.lexer.inline(W[0])}},G.escape=function(T){var W=this.rules.inline.escape.exec(T);if(W)return{type:"escape",raw:W[0],text:l(W[1])}},G.tag=function(T){var W=this.rules.inline.tag.exec(T);if(W)return!this.lexer.state.inLink&&/^<a /i.test(W[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(W[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(W[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(W[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:W[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):l(W[0]):W[0]}},G.link=function(T){var W=this.rules.inline.link.exec(T);if(W){var ce=W[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var ue=C(ce.slice(0,-1),"\\");if((ce.length-ue.length)%2===0)return}else{var we=A(W[2],"()");if(we>-1){var de=W[0].indexOf("!")===0?5:4,ge=de+W[1].length+we;W[2]=W[2].substring(0,we),W[0]=W[0].substring(0,ge).trim(),W[3]=""}}var $e=W[2],Ce="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec($e);Ae&&($e=Ae[1],Ce=Ae[3])}else Ce=W[3]?W[3].slice(1,-1):"";return $e=$e.trim(),/^</.test($e)&&(this.options.pedantic&&!/>$/.test(ce)?$e=$e.slice(1):$e=$e.slice(1,-1)),V(W,{href:$e&&$e.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},W[0],this.lexer)}},G.reflink=function(T,W){var ce;if((ce=this.rules.inline.reflink.exec(T))||(ce=this.rules.inline.nolink.exec(T))){var ue=(ce[2]||ce[1]).replace(/\s+/g," ");if(ue=W[ue.toLowerCase()],!ue||!ue.href){var we=ce[0].charAt(0);return{type:"text",raw:we,text:we}}return V(ce,ue,ce[0],this.lexer)}},G.emStrong=function(T,W,ce){ce===void 0&&(ce="");var ue=this.rules.inline.emStrong.lDelim.exec(T);if(ue&&!(ue[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=ue[1]||ue[2]||"";if(!we||we&&(ce===""||this.rules.inline.punctuation.exec(ce))){var de=ue[0].length-1,ge,$e,Ce=de,Ae=0,he=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,W=W.slice(-1*T.length+de);(ue=he.exec(W))!=null;)if(ge=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!ge){if($e=ge.length,ue[3]||ue[4]){Ce+=$e;continue}else if((ue[5]||ue[6])&&de%3&&!((de+$e)%3)){Ae+=$e;continue}if(Ce-=$e,!(Ce>0)){if($e=Math.min($e,$e+Ce+Ae),Math.min(de,$e)%2){var De=T.slice(1,de+ue.index+$e);return{type:"em",raw:T.slice(0,de+ue.index+$e+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=T.slice(2,de+ue.index+$e-1);return{type:"strong",raw:T.slice(0,de+ue.index+$e+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},G.codespan=function(T){var W=this.rules.inline.code.exec(T);if(W){var ce=W[2].replace(/\n/g," "),ue=/[^ ]/.test(ce),we=/^ /.test(ce)&&/ $/.test(ce);return ue&&we&&(ce=ce.substring(1,ce.length-1)),ce=l(ce,!0),{type:"codespan",raw:W[0],text:ce}}},G.br=function(T){var W=this.rules.inline.br.exec(T);if(W)return{type:"br",raw:W[0]}},G.del=function(T){var W=this.rules.inline.del.exec(T);if(W)return{type:"del",raw:W[0],text:W[2],tokens:this.lexer.inlineTokens(W[2])}},G.autolink=function(T,W){var ce=this.rules.inline.autolink.exec(T);if(ce){var ue,we;return ce[2]==="@"?(ue=l(this.options.mangle?W(ce[1]):ce[1]),we="mailto:"+ue):(ue=l(ce[1]),we=ue),{type:"link",raw:ce[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},G.url=function(T,W){var ce;if(ce=this.rules.inline.url.exec(T)){var ue,we;if(ce[2]==="@")ue=l(this.options.mangle?W(ce[0]):ce[0]),we="mailto:"+ue;else{var de;do de=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(de!==ce[0]);ue=l(ce[0]),ce[1]==="www."?we="http://"+ue:we=ue}return{type:"link",raw:ce[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},G.inlineText=function(T,W){var ce=this.rules.inline.text.exec(T);if(ce){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):l(ce[0]):ce[0]:ue=l(this.options.smartypants?W(ce[0]):ce[0]),{type:"text",raw:ce[0],text:ue}}},Q}(),te={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};te._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,te._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,te.def=g(te.def).replace("label",te._label).replace("title",te._title).getRegex(),te.bullet=/(?:[*+-]|\d{1,9}[.)])/,te.listItemStart=g(/^( *)(bull) */).replace("bull",te.bullet).getRegex(),te.list=g(te.list).replace(/bull/g,te.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+te.def.source+")").getRegex(),te._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",te._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,te.html=g(te.html,"i").replace("comment",te._comment).replace("tag",te._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),te.paragraph=g(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.blockquote=g(te.blockquote).replace("paragraph",te.paragraph).getRegex(),te.normal=p({},te),te.gfm=p({},te.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),te.gfm.table=g(te.gfm.table).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.gfm.paragraph=g(te._paragraph).replace("hr",te.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",te.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",te._tag).getRegex(),te.pedantic=p({},te.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",te._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:g(te.normal._paragraph).replace("hr",te.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",te.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=g(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=g(te._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=g(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=g(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=g(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=g(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=g(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=g(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=g(ee.reflink).replace("label",ee._label).replace("ref",te._label).getRegex(),ee.nolink=g(ee.nolink).replace("ref",te._label).getRegex(),ee.reflinkSearch=g(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=p({},ee),ee.pedantic=p({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=p({},ee.normal,{escape:g(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=g(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=p({},ee.gfm,{br:g(ee.br).replace("{2,}","*").getRegex(),text:g(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Q){return Q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Q){var G="",J,T,W=Q.length;for(J=0;J<W;J++)T=Q.charCodeAt(J),Math.random()>.5&&(T="x"+T.toString(16)),G+="&#"+T+";";return G}var Z=function(){function Q(J){this.tokens=[],this.tokens.links=Object.create(null),this.options=J||fe.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:te.normal,inline:ee.normal};this.options.pedantic?(T.block=te.pedantic,T.inline=ee.pedantic):this.options.gfm&&(T.block=te.gfm,this.options.breaks?T.inline=ee.breaks:T.inline=ee.gfm),this.tokenizer.rules=T}Q.lex=function(T,W){var ce=new Q(W);return ce.lex(T)},Q.lexInline=function(T,W){var ce=new Q(W);return ce.inlineTokens(T)};var G=Q.prototype;return G.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var W;W=this.inlineQueue.shift();)this.inlineTokens(W.src,W.tokens);return this.tokens},G.blockTokens=function(T,W){var ce=this;W===void 0&&(W=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(Ce,Ae,he){return Ae+"    ".repeat(he.length)});for(var ue,we,de,ge;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(ue=Ce.call({lexer:ce},T,W))?(T=T.substring(ue.raw.length),W.push(ue),!0):!1}))){if(ue=this.tokenizer.space(T)){T=T.substring(ue.raw.length),ue.raw.length===1&&W.length>0?W[W.length-1].raw+=`
`:W.push(ue);continue}if(ue=this.tokenizer.code(T)){T=T.substring(ue.raw.length),we=W[W.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):W.push(ue);continue}if(ue=this.tokenizer.fences(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.heading(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.hr(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.blockquote(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.list(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.html(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.def(T)){T=T.substring(ue.raw.length),we=W[W.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.lheading(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(de=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,Ae=T.slice(1),he=void 0;ce.options.extensions.startBlock.forEach(function(De){he=De.call({lexer:this},Ae),typeof he=="number"&&he>=0&&(Ce=Math.min(Ce,he))}),Ce<1/0&&Ce>=0&&(de=T.substring(0,Ce+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){we=W[W.length-1],ge&&we.type==="paragraph"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):W.push(ue),ge=de.length!==T.length,T=T.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(T)){T=T.substring(ue.raw.length),we=W[W.length-1],we&&we.type==="text"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):W.push(ue);continue}if(T){var $e="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return this.state.top=!0,W},G.inline=function(T,W){return W===void 0&&(W=[]),this.inlineQueue.push({src:T,tokens:W}),W},G.inlineTokens=function(T,W){var ce=this;W===void 0&&(W=[]);var ue,we,de,ge=T,$e,Ce,Ae;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;($e=this.tokenizer.rules.inline.reflinkSearch.exec(ge))!=null;)he.includes($e[0].slice($e[0].lastIndexOf("[")+1,-1))&&(ge=ge.slice(0,$e.index)+"["+N("a",$e[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;($e=this.tokenizer.rules.inline.blockSkip.exec(ge))!=null;)ge=ge.slice(0,$e.index)+"["+N("a",$e[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;($e=this.tokenizer.rules.inline.escapedEmSt.exec(ge))!=null;)ge=ge.slice(0,$e.index)+"++"+ge.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(Ce||(Ae=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(ue=ke.call({lexer:ce},T,W))?(T=T.substring(ue.raw.length),W.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.tag(T)){T=T.substring(ue.raw.length),we=W[W.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):W.push(ue);continue}if(ue=this.tokenizer.link(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(ue.raw.length),we=W[W.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):W.push(ue);continue}if(ue=this.tokenizer.emStrong(T,ge,Ae)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.codespan(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.br(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.del(T)){T=T.substring(ue.raw.length),W.push(ue);continue}if(ue=this.tokenizer.autolink(T,B)){T=T.substring(ue.raw.length),W.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(T,B))){T=T.substring(ue.raw.length),W.push(ue);continue}if(de=T,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Me=T.slice(1),Fe=void 0;ce.options.extensions.startInline.forEach(function(He){Fe=He.call({lexer:this},Me),typeof Fe=="number"&&Fe>=0&&(ke=Math.min(ke,Fe))}),ke<1/0&&ke>=0&&(de=T.substring(0,ke+1))}(),ue=this.tokenizer.inlineText(de,K)){T=T.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Ae=ue.raw.slice(-1)),Ce=!0,we=W[W.length-1],we&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):W.push(ue);continue}if(T){var De="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return W},s(Q,null,[{key:"rules",get:function(){return{block:te,inline:ee}}}]),Q}(),Y=function(){function Q(J){this.options=J||fe.defaults}var G=Q.prototype;return G.code=function(T,W,ce){var ue=(W||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(T,ue);we!=null&&we!==T&&(ce=!0,T=we)}return T=T.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+l(ue,!0)+'">'+(ce?T:l(T,!0))+`</code></pre>
`:"<pre><code>"+(ce?T:l(T,!0))+`</code></pre>
`},G.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},G.html=function(T){return T},G.heading=function(T,W,ce,ue){if(this.options.headerIds){var we=this.options.headerPrefix+ue.slug(ce);return"<h"+W+' id="'+we+'">'+T+"</h"+W+`>
`}return"<h"+W+">"+T+"</h"+W+`>
`},G.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},G.list=function(T,W,ce){var ue=W?"ol":"ul",we=W&&ce!==1?' start="'+ce+'"':"";return"<"+ue+we+`>
`+T+"</"+ue+`>
`},G.listitem=function(T){return"<li>"+T+`</li>
`},G.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},G.paragraph=function(T){return"<p>"+T+`</p>
`},G.table=function(T,W){return W&&(W="<tbody>"+W+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+W+`</table>
`},G.tablerow=function(T){return`<tr>
`+T+`</tr>
`},G.tablecell=function(T,W){var ce=W.header?"th":"td",ue=W.align?"<"+ce+' align="'+W.align+'">':"<"+ce+">";return ue+T+("</"+ce+`>
`)},G.strong=function(T){return"<strong>"+T+"</strong>"},G.em=function(T){return"<em>"+T+"</em>"},G.codespan=function(T){return"<code>"+T+"</code>"},G.br=function(){return this.options.xhtml?"<br/>":"<br>"},G.del=function(T){return"<del>"+T+"</del>"},G.link=function(T,W,ce){if(T=f(this.options.sanitize,this.options.baseUrl,T),T===null)return ce;var ue='<a href="'+l(T)+'"';return W&&(ue+=' title="'+W+'"'),ue+=">"+ce+"</a>",ue},G.image=function(T,W,ce){if(T=f(this.options.sanitize,this.options.baseUrl,T),T===null)return ce;var ue='<img src="'+T+'" alt="'+ce+'"';return W&&(ue+=' title="'+W+'"'),ue+=this.options.xhtml?"/>":">",ue},G.text=function(T){return T},Q}(),M=function(){function Q(){}var G=Q.prototype;return G.strong=function(T){return T},G.em=function(T){return T},G.codespan=function(T){return T},G.del=function(T){return T},G.html=function(T){return T},G.text=function(T){return T},G.link=function(T,W,ce){return""+ce},G.image=function(T,W,ce){return""+ce},G.br=function(){return""},Q}(),z=function(){function Q(){this.seen={}}var G=Q.prototype;return G.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},G.getNextSafeSlug=function(T,W){var ce=T,ue=0;if(this.seen.hasOwnProperty(ce)){ue=this.seen[T];do ue++,ce=T+"-"+ue;while(this.seen.hasOwnProperty(ce))}return W||(this.seen[T]=ue,this.seen[ce]=0),ce},G.slug=function(T,W){W===void 0&&(W={});var ce=this.serialize(T);return this.getNextSafeSlug(ce,W.dryrun)},Q}(),oe=function(){function Q(J){this.options=J||fe.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new z}Q.parse=function(T,W){var ce=new Q(W);return ce.parse(T)},Q.parseInline=function(T,W){var ce=new Q(W);return ce.parseInline(T)};var G=Q.prototype;return G.parse=function(T,W){W===void 0&&(W=!0);var ce="",ue,we,de,ge,$e,Ce,Ae,he,De,ke,Me,Fe,He,Be,Ge,Ze,_e,tt,Qe,Je=T.length;for(ue=0;ue<Je;ue++){if(ke=T[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Qe=this.options.extensions.renderers[ke.type].call({parser:this},ke),Qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ce+=Qe||"";continue}switch(ke.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,u(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(he="",Ae="",ge=ke.header.length,we=0;we<ge;we++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[we].tokens),{header:!0,align:ke.align[we]});for(he+=this.renderer.tablerow(Ae),De="",ge=ke.rows.length,we=0;we<ge;we++){for(Ce=ke.rows[we],Ae="",$e=Ce.length,de=0;de<$e;de++)Ae+=this.renderer.tablecell(this.parseInline(Ce[de].tokens),{header:!1,align:ke.align[de]});De+=this.renderer.tablerow(Ae)}ce+=this.renderer.table(he,De);continue}case"blockquote":{De=this.parse(ke.tokens),ce+=this.renderer.blockquote(De);continue}case"list":{for(Me=ke.ordered,Fe=ke.start,He=ke.loose,ge=ke.items.length,De="",we=0;we<ge;we++)Ge=ke.items[we],Ze=Ge.checked,_e=Ge.task,Be="",Ge.task&&(tt=this.renderer.checkbox(Ze),He?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=tt+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=tt+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Ge.tokens,He),De+=this.renderer.listitem(Be,_e,Ze);ce+=this.renderer.list(De,Me,Fe);continue}case"html":{ce+=this.renderer.html(ke.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;ue+1<Je&&T[ue+1].type==="text";)ke=T[++ue],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ce+=W?this.renderer.paragraph(De):De;continue}default:{var xe='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}}return ce},G.parseInline=function(T,W){W=W||this.renderer;var ce="",ue,we,de,ge=T.length;for(ue=0;ue<ge;ue++){if(we=T[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(de=this.options.extensions.renderers[we.type].call({parser:this},we),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){ce+=de||"";continue}switch(we.type){case"escape":{ce+=W.text(we.text);break}case"html":{ce+=W.html(we.text);break}case"link":{ce+=W.link(we.href,we.title,this.parseInline(we.tokens,W));break}case"image":{ce+=W.image(we.href,we.title,we.text);break}case"strong":{ce+=W.strong(this.parseInline(we.tokens,W));break}case"em":{ce+=W.em(this.parseInline(we.tokens,W));break}case"codespan":{ce+=W.codespan(we.text);break}case"br":{ce+=W.br();break}case"del":{ce+=W.del(this.parseInline(we.tokens,W));break}case"text":{ce+=W.text(we.text);break}default:{var $e='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return ce},Q}();function se(Q,G,J){if(typeof Q>"u"||Q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");if(typeof G=="function"&&(J=G,G=null),G=p({},se.defaults,G||{}),O(G),J){var T=G.highlight,W;try{W=Z.lex(Q,G)}catch(ge){return J(ge)}var ce=function($e){var Ce;if(!$e)try{G.walkTokens&&se.walkTokens(W,G.walkTokens),Ce=oe.parse(W,G)}catch(Ae){$e=Ae}return G.highlight=T,$e?J($e):J(null,Ce)};if(!T||T.length<3||(delete G.highlight,!W.length))return ce();var ue=0;se.walkTokens(W,function(ge){ge.type==="code"&&(ue++,setTimeout(function(){T(ge.text,ge.lang,function($e,Ce){if($e)return ce($e);Ce!=null&&Ce!==ge.text&&(ge.text=Ce,ge.escaped=!0),ue--,ue===0&&ce()})},0))}),ue===0&&ce();return}function we(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+l(ge.message+"",!0)+"</pre>";throw ge}try{var de=Z.lex(Q,G);if(G.walkTokens){if(G.async)return Promise.all(se.walkTokens(de,G.walkTokens)).then(function(){return oe.parse(de,G)}).catch(we);se.walkTokens(de,G.walkTokens)}return oe.parse(de,G)}catch(ge){we(ge)}}se.options=se.setOptions=function(Q){return p(se.defaults,Q),P(se.defaults),se},se.getDefaults=S,se.defaults=fe.defaults,se.use=function(){for(var Q=arguments.length,G=new Array(Q),J=0;J<Q;J++)G[J]=arguments[J];var T=p.apply(void 0,[{}].concat(G)),W=se.defaults.extensions||{renderers:{},childTokens:{}},ce;G.forEach(function(ue){if(ue.extensions&&(ce=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var ge=W.renderers?W.renderers[de.name]:null;ge?W.renderers[de.name]=function(){for(var $e=arguments.length,Ce=new Array($e),Ae=0;Ae<$e;Ae++)Ce[Ae]=arguments[Ae];var he=de.renderer.apply(this,Ce);return he===!1&&(he=ge.apply(this,Ce)),he}:W.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");W[de.level]?W[de.level].unshift(de.tokenizer):W[de.level]=[de.tokenizer],de.start&&(de.level==="block"?W.startBlock?W.startBlock.push(de.start):W.startBlock=[de.start]:de.level==="inline"&&(W.startInline?W.startInline.push(de.start):W.startInline=[de.start]))}de.childTokens&&(W.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=se.defaults.renderer||new Y,ge=function(Ae){var he=de[Ae];de[Ae]=function(){for(var De=arguments.length,ke=new Array(De),Me=0;Me<De;Me++)ke[Me]=arguments[Me];var Fe=ue.renderer[Ae].apply(de,ke);return Fe===!1&&(Fe=he.apply(de,ke)),Fe}};for(var $e in ue.renderer)ge($e);T.renderer=de}(),ue.tokenizer&&function(){var de=se.defaults.tokenizer||new ae,ge=function(Ae){var he=de[Ae];de[Ae]=function(){for(var De=arguments.length,ke=new Array(De),Me=0;Me<De;Me++)ke[Me]=arguments[Me];var Fe=ue.tokenizer[Ae].apply(de,ke);return Fe===!1&&(Fe=he.apply(de,ke)),Fe}};for(var $e in ue.tokenizer)ge($e);T.tokenizer=de}(),ue.walkTokens){var we=se.defaults.walkTokens;T.walkTokens=function(de){var ge=[];return ge.push(ue.walkTokens.call(this,de)),we&&(ge=ge.concat(we.call(this,de))),ge}}ce&&(T.extensions=W),se.setOptions(T)})},se.walkTokens=function(Q,G){for(var J=[],T=function(){var we=ce.value;switch(J=J.concat(G.call(se,we)),we.type){case"table":{for(var de=D(we.header),ge;!(ge=de()).done;){var $e=ge.value;J=J.concat(se.walkTokens($e.tokens,G))}for(var Ce=D(we.rows),Ae;!(Ae=Ce()).done;)for(var he=Ae.value,De=D(he),ke;!(ke=De()).done;){var Me=ke.value;J=J.concat(se.walkTokens(Me.tokens,G))}break}case"list":{J=J.concat(se.walkTokens(we.items,G));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[we.type]?se.defaults.extensions.childTokens[we.type].forEach(function(Fe){J=J.concat(se.walkTokens(we[Fe],G))}):we.tokens&&(J=J.concat(se.walkTokens(we.tokens,G)))}},W=D(Q),ce;!(ce=W()).done;)T();return J},se.parseInline=function(Q,G){if(typeof Q>"u"||Q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Q)+", string expected");G=p({},se.defaults,G||{}),O(G);try{var J=Z.lexInline(Q,G);return G.walkTokens&&se.walkTokens(J,G.walkTokens),oe.parseInline(J,G)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+l(T.message+"",!0)+"</pre>";throw T}},se.Parser=oe,se.parser=oe.parse,se.Renderer=Y,se.TextRenderer=M,se.Lexer=Z,se.lexer=Z.lex,se.Tokenizer=ae,se.Slugger=z,se.parse=se;var _=se.options,H=se.setOptions,ne=se.use,le=se.walkTokens,F=se.parseInline,U=se,X=oe.parse,x=Z.lex;fe.Lexer=Z,fe.Parser=oe,fe.Renderer=Y,fe.Slugger=z,fe.TextRenderer=M,fe.Tokenizer=ae,fe.getDefaults=S,fe.lexer=x,fe.marked=se,fe.options=_,fe.parse=U,fe.parseInline=F,fe.parser=X,fe.setOptions=H,fe.use=ne,fe.walkTokens=le,Object.defineProperty(fe,"__esModule",{value:!0})}),define(ye[153],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=s;function s(c){const u=D(c);if(u&&u.length>0)return new Uint32Array(u)}let j=0;const I=new Uint32Array(10);function D(c){if(j=0,S(c,w,4352),j>0||(S(c,v,4449),j>0)||(S(c,m,4520),j>0)||(S(c,l,12593),j))return I.subarray(0,j);if(c>=44032&&c<=55203){const u=c-44032,h=u%588,g=Math.floor(u/588),d=Math.floor(h/28),E=h%28-1;if(g<w.length?S(g,w,0):4352+g-12593<l.length&&S(4352+g,l,12593),d<v.length?S(d,v,0):4449+d-12593<l.length&&S(4449+d-12593,l,12593),E>=0&&(E<m.length?S(E,m,0):4520+E-12593<l.length&&S(4520+E-12593,l,12593)),j>0)return I.subarray(0,j)}}function S(c,u,h){c>=h&&c<h+u.length&&P(u[c-h])}function P(c){c!==0&&(I[j++]=c&255,c>>8&&(I[j++]=c>>8&255),c>>16&&(I[j++]=c>>16&255))}var b;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})($||($={}));var y;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(y||(y={}));const w=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),l=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[100],Ee([1,0,24]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=I,e.$gm=S;const j=new s.$Dc(1e4);function I($){return b($,"NFC",j)}const D=new s.$Dc(1e4);function S($){return b($,"NFD",D)}const P=/[^\u0000-\u0080]/;function b($,y,w){if(!$)return $;const v=w.get($);if(v)return v;let m;return P.test($)?m=$.normalize(y):m=$,w.set($,m),m}e.$hm=function(){const $=/[\u0300-\u036f]/g;return function(y){return S(y).replace($,"")}}()}),define(ye[154],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0,e.$Fm=s,e.rot=j;function s(P,b,$){return Math.min(Math.max(P,b),$)}function j(P,b){return(b+P%b)%b}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Hm=I;class D{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Im=D;class S{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jm=S}),define(ye[155],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=D,e.$cd=v;class s{constructor(l,c,u){this.owner=l,this.debugNameSource=c,this.referenceFn=u}getDebugName(l){return D(l,this)}}e.$ad=s;const j=new Map,I=new WeakMap;function D(m,l){const c=I.get(m);if(c)return c;const u=S(m,l);if(u){let h=j.get(u)??0;h++,j.set(u,h);const g=h===1?u:`${u}#${h}`;return I.set(m,g),g}}function S(m,l){const c=I.get(m);if(c)return c;const u=l.owner?y(l.owner)+".":"";let h;const g=l.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(h=g(),h!==void 0)return u+h}else return u+g;const d=l.referenceFn;if(d!==void 0&&(h=v(d),h!==void 0))return u+h;if(l.owner!==void 0){const E=P(l.owner,m);if(E!==void 0)return u+E}}function P(m,l){for(const c in m)if(m[c]===l)return c}const b=new Map,$=new WeakMap;function y(m){const l=$.get(m);if(l)return l;const c=w(m);let u=b.get(c)??0;u++,b.set(c,u);const h=u===1?c:`${c}#${u}`;return $.set(m,h),h}function w(m){const l=m.constructor;return l?l.name:"Object"}function v(m){const l=m.toString(),u=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(l);return(u?u[1]:void 0)?.trim()}}),define(ye[156],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=j,e.$Id=I;let s;function j(c){s=c}function I(){return s}class D{constructor(){this.a=0,this.d=new WeakMap}b(u){return S([P(m("|  ",this.a)),u])}c(u){return u.hadValue?u.didChange?[P(" "),$(y(u.oldValue,70),{color:"red",strikeThrough:!0}),P(" "),$(y(u.newValue,60),{color:"green"})]:[P(" (unchanged)")]:[P(" "),$(y(u.newValue,60),{color:"green"}),P(" (initial)")]}handleObservableChanged(u,h){console.log(...this.b([b("observable value changed"),$(u.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(u){if(u.size!==0)return $(" (changed deps: "+[...u].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(u){const h=u.handleChange;this.d.set(u,new Set),u.handleChange=(g,d)=>(this.d.get(u).add(g),h.apply(u,[g,d]))}handleDerivedRecomputed(u,h){const g=this.d.get(u);console.log(...this.b([b("derived recomputed"),$(u.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(g),{data:[{fn:u._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(u,h){console.log(...this.b([b("observable from event triggered"),$(u.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:u._getValue}]}]))}handleAutorunCreated(u){const h=u.handleChange;this.d.set(u,new Set),u.handleChange=(g,d)=>(this.d.get(u).add(g),h.apply(u,[g,d]))}handleAutorunTriggered(u){const h=this.d.get(u);console.log(...this.b([b("autorun"),$(u.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:u._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(u){this.a--}handleBeginTransaction(u){let h=u.getDebugName();h===void 0&&(h=""),console.log(...this.b([b("transaction"),$(h,{color:"BlueViolet"}),{data:[{fn:u._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=D;function S(c){const u=new Array,h=[];let g="";function d(f){if("length"in f)for(const t of f)t&&d(t);else"text"in f?(g+=`%c${f.text}`,u.push(f.style),f.data&&h.push(...f.data)):"data"in f&&h.push(...f.data)}d(c);const E=[g,...u];return E.push(...h),E}function P(c){return $(c,{color:"black"})}function b(c){return $(l(`${c}: `,10),{color:"black",bold:!0})}function $(c,u={color:"black"}){function h(d){return Object.entries(d).reduce((E,[f,t])=>`${E}${f}:${t};`,"")}const g={color:u.color};return u.strikeThrough&&(g["text-decoration"]="line-through"),u.bold&&(g["font-weight"]="bold"),{text:c,style:h(g)}}function y(c,u){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=u?`"${c}"`:`"${c.substr(0,u-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?w(c,u):v(c,u);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function w(c,u){let h="[ ",g=!0;for(const d of c){if(g||(h+=", "),h.length-5>u){h+="...";break}g=!1,h+=`${y(d,u-h.length)}`}return h+=" ]",h}function v(c,u){let h="{ ",g=!0;for(const[d,E]of Object.entries(c)){if(g||(h+=", "),h.length-5>u){h+="...";break}g=!1,h+=`${d}: ${y(E,u-h.length)}`}return h+=" }",h}function m(c,u){let h="";for(let g=1;g<=u;g++)h+=c;return h}function l(c,u){for(;c.length<u;)c+=" ";return c}}),define(ye[157],Ee([1,0,149,155,156]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=S,e.$Td=b,e.$Ud=y,e.$Xd=m,e.$Yd=c,e.$Zd=u,e.$1d=h,e.$3d=d,e.$4d=E,e.$6d=t;let D;function S(r){D=r}let P;function b(r){P=r}let $;function y(r){$=r}class w{get TChange(){return null}reportChanges(){this.get()}read(n){return n?n.readObservable(this):this.get()}map(n,a){const i=a===void 0?void 0:n,p=a===void 0?n:a;return $({owner:i,debugName:()=>{const k=(0,j.$cd)(p);if(k!==void 0)return k;const A=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(p.toString());if(A)return`${this.debugName}.${A[2]}`;if(!i)return`${this.debugName} (mapped)`},debugReferenceFn:p},k=>p(this.read(k),k))}recomputeInitiallyAndOnChange(n,a){return n.add(D(this,a)),this}keepObserved(n){return n.add(P(this)),this}get a(){return this.get()}}e.$Vd=w;class v extends w{constructor(){super(...arguments),this.b=new Set}addObserver(n){const a=this.b.size;this.b.add(n),a===0&&this.c()}removeObserver(n){this.b.delete(n)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=v;function m(r,n){const a=new g(r,n);try{r(a)}finally{a.finish()}}let l;function c(r){if(l)r(l);else{const n=new g(r,void 0);l=n;try{r(n)}finally{n.finish(),l=void 0}}}async function u(r,n){const a=new g(r,n);try{await r(a)}finally{a.finish()}}function h(r,n,a){r?n(r):m(n,a)}class g{constructor(n,a){this._fn=n,this.b=a,this.a=[],(0,I.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,j.$cd)(this._fn)}updateObserver(n,a){this.a.push({observer:n,observable:a}),n.beginUpdate(a)}finish(){const n=this.a;for(let a=0;a<n.length;a++){const{observer:i,observable:p}=n[a];i.endUpdate(p)}this.a=null,(0,I.$Id)()?.handleEndTransaction()}}e.$2d=g;function d(r,n){let a;return typeof r=="string"?a=new j.$ad(void 0,r,void 0):a=new j.$ad(r,void 0,void 0),new f(a,n,s.$6c)}function E(r,n){return new f(new j.$ad(r.owner,r.debugName,void 0),n,r.equalsFn??s.$6c)}class f extends v{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(n,a,i){super(),this.e=n,this.g=i,this.d=a}get(){return this.d}set(n,a,i){if(i===void 0&&this.g(this.d,n))return;let p;a||(a=p=new g(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(n),(0,I.$Id)()?.handleObservableChanged(this,{oldValue:k,newValue:n,change:i,didChange:!0,hadValue:!0});for(const C of this.b)a.updateObserver(C,this),C.handleChange(this,i)}finally{p&&p.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(n){this.d=n}}e.$5d=f;function t(r,n){let a;return typeof r=="string"?a=new j.$ad(void 0,r,void 0):a=new j.$ad(r,void 0,void 0),new o(a,n,s.$6c)}class o extends f{h(n){this.d!==n&&(this.d&&this.d.dispose(),this.d=n)}dispose(){this.d?.dispose()}}e.$7d=o}),function(){function fe(I){const D=[];typeof I=="number"&&D.push("code/timeOrigin",I);function S(b){D.push(b,Date.now())}function P(){const b=[];for(let $=0;$<D.length;$+=2)b.push({name:D[$],startTime:D[$+1]});return b}return{mark:S,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const S of performance.getEntriesByType("mark"))D.push({name:S.name,startTime:Math.round(I+S.startTime)});return D}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function s(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=s(j))}(),define(ye[158],Ee([1,0,41]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=void 0;const j=Symbol("unset");class I{constructor(){this.a=new S,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||s.Iterable.empty()}insert(b,$,y){this.d(b,w=>w._value=$,y)}mutate(b,$){this.d(b,y=>y._value=$(y._value===j?void 0:y._value))}mutatePath(b,$){this.d(b,()=>{},y=>$(y))}delete(b){const $=this.c(b);if(!$)return;let y=$.length-1;const w=$[y].node._value;if(w!==j){for(this.b--,$[y].node._value=j;y>0;y--){const{node:v,part:m}=$[y];if(v.children?.size||v._value!==j)break;$[y-1].node.children.delete(m)}return w}}*deleteRecursive(b){const $=this.c(b);if(!$)return;const y=$[$.length-1].node;for(let w=$.length-1;w>0;w--){const v=$[w-1];if(v.node.children.delete($[w].part),v.node.children.size>0||v.node._value!==j)break}for(const w of D(y))w._value!==j&&(this.b--,yield w._value)}find(b){let $=this.a;for(const y of b){const w=$.children?.get(y);if(!w)return;$=w}return $._value===j?void 0:$._value}hasKeyOrParent(b){let $=this.a;for(const y of b){const w=$.children?.get(y);if(!w)return!1;if(w._value!==j)return!0;$=w}return!1}hasKeyOrChildren(b){let $=this.a;for(const y of b){const w=$.children?.get(y);if(!w)return!1;$=w}return!0}hasKey(b){let $=this.a;for(const y of b){const w=$.children?.get(y);if(!w)return!1;$=w}return $._value!==j}c(b){const $=[{part:"",node:this.a}];let y=0;for(const w of b){const v=$[y].node.children?.get(w);if(!v)return;$.push({part:w,node:v}),y++}return $}d(b,$,y){let w=this.a;for(const l of b){if(w.children)if(w.children.has(l))w=w.children.get(l);else{const c=new S;w.children.set(l,c),w=c}else{const c=new S;w.children=new Map([[l,c]]),w=c}y?.(w)}const v=w._value===j?0:1;$(w);const m=w._value===j?0:1;this.b+=m-v}*values(){for(const{_value:b}of D(this.a))b!==j&&(yield b)}}e.$GO=I;function*D(P){const b=[P];for(;b.length>0;){const $=b.pop();if(yield $,$.children)for(const y of $.children.values())b.push(y)}}class S{constructor(){this._value=j}get value(){return this._value===j?void 0:this._value}set value(b){this._value=b===void 0?j:b}}}),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var j in s)(typeof exports=="object"?exports:fe)[j]=s[j]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function s(j){if(e[j])return e[j].exports;var I=e[j]={i:j,l:!1,exports:{}};return fe[j].call(I.exports,I,I.exports,s),I.l=!0,I.exports}return s.m=fe,s.c=e,s.d=function(j,I,D){s.o(j,I)||Object.defineProperty(j,I,{enumerable:!0,get:D})},s.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},s.t=function(j,I){if(1&I&&(j=s(j)),8&I||4&I&&typeof j=="object"&&j&&j.__esModule)return j;var D=Object.create(null);if(s.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:j}),2&I&&typeof j!="string")for(var S in j)s.d(D,S,function(P){return j[P]}.bind(null,S));return D},s.n=function(j){var I=j&&j.__esModule?function(){return j.default}:function(){return j};return s.d(I,"a",I),I},s.o=function(j,I){return Object.prototype.hasOwnProperty.call(j,I)},s.p="",s(s.s=0)}([function(fe,e,s){(function(j){var I;e=fe.exports=ne,I=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],$=0,y=$++;b[y]="0|[1-9]\\d*";var w=$++;b[w]="[0-9]+";var v=$++;b[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=$++;b[m]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var l=$++;b[l]="("+b[w]+")\\.("+b[w]+")\\.("+b[w]+")";var c=$++;b[c]="(?:"+b[y]+"|"+b[v]+")";var u=$++;b[u]="(?:"+b[w]+"|"+b[v]+")";var h=$++;b[h]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var g=$++;b[g]="(?:-?("+b[u]+"(?:\\."+b[u]+")*))";var d=$++;b[d]="[0-9A-Za-z-]+";var E=$++;b[E]="(?:\\+("+b[d]+"(?:\\."+b[d]+")*))";var f=$++,t="v?"+b[m]+b[h]+"?"+b[E]+"?";b[f]="^"+t+"$";var o="[v=\\s]*"+b[l]+b[g]+"?"+b[E]+"?",r=$++;b[r]="^"+o+"$";var n=$++;b[n]="((?:<|>)?=?)";var a=$++;b[a]=b[w]+"|x|X|\\*";var i=$++;b[i]=b[y]+"|x|X|\\*";var p=$++;b[p]="[v=\\s]*("+b[i]+")(?:\\.("+b[i]+")(?:\\.("+b[i]+")(?:"+b[h]+")?"+b[E]+"?)?)?";var k=$++;b[k]="[v=\\s]*("+b[a]+")(?:\\.("+b[a]+")(?:\\.("+b[a]+")(?:"+b[g]+")?"+b[E]+"?)?)?";var C=$++;b[C]="^"+b[n]+"\\s*"+b[p]+"$";var A=$++;b[A]="^"+b[n]+"\\s*"+b[k]+"$";var O=$++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=$++;b[N]="(?:~>?)";var V=$++;b[V]="(\\s*)"+b[N]+"\\s+",P[V]=new RegExp(b[V],"g");var ie=$++;b[ie]="^"+b[N]+b[p]+"$";var ae=$++;b[ae]="^"+b[N]+b[k]+"$";var te=$++;b[te]="(?:\\^)";var ee=$++;b[ee]="(\\s*)"+b[te]+"\\s+",P[ee]=new RegExp(b[ee],"g");var K=$++;b[K]="^"+b[te]+b[p]+"$";var B=$++;b[B]="^"+b[te]+b[k]+"$";var Z=$++;b[Z]="^"+b[n]+"\\s*("+o+")$|^$";var Y=$++;b[Y]="^"+b[n]+"\\s*("+t+")$|^$";var M=$++;b[M]="(\\s*)"+b[n]+"\\s*("+o+"|"+b[p]+")",P[M]=new RegExp(b[M],"g");var z=$++;b[z]="^\\s*("+b[p]+")\\s+-\\s+("+b[p]+")\\s*$";var oe=$++;b[oe]="^\\s*("+b[k]+")\\s+-\\s+("+b[k]+")\\s*$";var se=$++;b[se]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)I(_,b[_]),P[_]||(P[_]=new RegExp(b[_]));function H(he,De){if(he instanceof ne)return he;if(typeof he!="string"||he.length>D||!(De?P[r]:P[f]).test(he))return null;try{return new ne(he,De)}catch{return null}}function ne(he,De){if(he instanceof ne){if(he.loose===De)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ne))return new ne(he,De);I("SemVer",he,De),this.loose=De;var ke=he.trim().match(De?P[r]:P[f]);if(!ke)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Fe=+Me;if(Fe>=0&&Fe<S)return Fe}return Me}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=H,e.valid=function(he,De){var ke=H(he,De);return ke?ke.version:null},e.clean=function(he,De){var ke=H(he.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(he){return I("SemVer.compare",this.version,this.loose,he),he instanceof ne||(he=new ne(he,this.loose)),this.compareMain(he)||this.comparePre(he)},ne.prototype.compareMain=function(he){return he instanceof ne||(he=new ne(he,this.loose)),F(this.major,he.major)||F(this.minor,he.minor)||F(this.patch,he.patch)},ne.prototype.comparePre=function(he){if(he instanceof ne||(he=new ne(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],Me=he.prerelease[De];if(I("prerelease compare",De,ke,Me),ke===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ke===void 0)return-1;if(ke!==Me)return F(ke,Me)}while(++De)},ne.prototype.inc=function(he,De){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,De,ke,Me){typeof ke=="string"&&(Me=ke,ke=void 0);try{return new ne(he,ke).inc(De,Me).version}catch{return null}},e.diff=function(he,De){if(Q(he,De))return null;var ke=H(he),Me=H(De);if(ke.prerelease.length||Me.prerelease.length){for(var Fe in ke)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&ke[Fe]!==Me[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in ke)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&ke[Fe]!==Me[Fe])return Fe},e.compareIdentifiers=F;var le=/^[0-9]+$/;function F(he,De){var ke=le.test(he),Me=le.test(De);return ke&&Me&&(he=+he,De=+De),ke&&!Me?-1:Me&&!ke?1:he<De?-1:he>De?1:0}function U(he,De,ke){return new ne(he,ke).compare(new ne(De,ke))}function X(he,De,ke){return U(he,De,ke)>0}function x(he,De,ke){return U(he,De,ke)<0}function Q(he,De,ke){return U(he,De,ke)===0}function G(he,De,ke){return U(he,De,ke)!==0}function J(he,De,ke){return U(he,De,ke)>=0}function T(he,De,ke){return U(he,De,ke)<=0}function W(he,De,ke,Me){var Fe;switch(De){case"===":typeof he=="object"&&(he=he.version),typeof ke=="object"&&(ke=ke.version),Fe=he===ke;break;case"!==":typeof he=="object"&&(he=he.version),typeof ke=="object"&&(ke=ke.version),Fe=he!==ke;break;case"":case"=":case"==":Fe=Q(he,ke,Me);break;case"!=":Fe=G(he,ke,Me);break;case">":Fe=X(he,ke,Me);break;case">=":Fe=J(he,ke,Me);break;case"<":Fe=x(he,ke,Me);break;case"<=":Fe=T(he,ke,Me);break;default:throw new TypeError("Invalid operator: "+De)}return Fe}function ce(he,De){if(he instanceof ce){if(he.loose===De)return he;he=he.value}if(!(this instanceof ce))return new ce(he,De);I("comparator",he,De),this.loose=De,this.parse(he),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(he,De){return F(De,he)},e.major=function(he,De){return new ne(he,De).major},e.minor=function(he,De){return new ne(he,De).minor},e.patch=function(he,De){return new ne(he,De).patch},e.compare=U,e.compareLoose=function(he,De){return U(he,De,!0)},e.rcompare=function(he,De,ke){return U(De,he,ke)},e.sort=function(he,De){return he.sort(function(ke,Me){return e.compare(ke,Me,De)})},e.rsort=function(he,De){return he.sort(function(ke,Me){return e.rcompare(ke,Me,De)})},e.gt=X,e.lt=x,e.eq=Q,e.neq=G,e.gte=J,e.lte=T,e.cmp=W,e.Comparator=ce;var ue={};function we(he,De){if(he instanceof we)return he.loose===De?he:new we(he.raw,De);if(he instanceof ce)return new we(he.value,De);if(!(this instanceof we))return new we(he,De);if(this.loose=De,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function de(he){return!he||he.toLowerCase()==="x"||he==="*"}function ge(he,De,ke,Me,Fe,He,Be,Ge,Ze,_e,tt,Qe,Je){return((De=de(ke)?"":de(Me)?">="+ke+".0.0":de(Fe)?">="+ke+"."+Me+".0":">="+De)+" "+(Ge=de(Ze)?"":de(_e)?"<"+(+Ze+1)+".0.0":de(tt)?"<"+Ze+"."+(+_e+1)+".0":Qe?"<="+Ze+"."+_e+"."+tt+"-"+Qe:"<="+Ge)).trim()}function $e(he,De){for(var ke=0;ke<he.length;ke++)if(!he[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<he.length;ke++)if(I(he[ke].semver),he[ke].semver!==ue&&he[ke].semver.prerelease.length>0){var Me=he[ke].semver;if(Me.major===De.major&&Me.minor===De.minor&&Me.patch===De.patch)return!0}return!1}return!0}function Ce(he,De,ke){try{De=new we(De,ke)}catch{return!1}return De.test(he)}function Ae(he,De,ke,Me){var Fe,He,Be,Ge,Ze;switch(he=new ne(he,Me),De=new we(De,Me),ke){case">":Fe=X,He=T,Be=x,Ge=">",Ze=">=";break;case"<":Fe=x,He=J,Be=X,Ge="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(he,De,Me))return!1;for(var _e=0;_e<De.set.length;++_e){var tt=De.set[_e],Qe=null,Je=null;if(tt.forEach(function(xe){xe.semver===ue&&(xe=new ce(">=0.0.0")),Qe=Qe||xe,Je=Je||xe,Fe(xe.semver,Qe.semver,Me)?Qe=xe:Be(xe.semver,Je.semver,Me)&&(Je=xe)}),Qe.operator===Ge||Qe.operator===Ze||(!Je.operator||Je.operator===Ge)&&He(he,Je.semver)||Je.operator===Ze&&Be(he,Je.semver))return!1}return!0}ce.prototype.parse=function(he){var De=this.loose?P[Z]:P[Y],ke=he.match(De);if(!ke)throw new TypeError("Invalid comparator: "+he);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new ne(ke[2],this.loose):this.semver=ue},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(he){return I("Comparator.test",he,this.loose),this.semver===ue||(typeof he=="string"&&(he=new ne(he,this.loose)),W(he,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(he,De){if(!(he instanceof ce))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new we(he.value,De),Ce(this.value,ke,De);if(he.operator==="")return ke=new we(this.value,De),Ce(he.semver,ke,De);var Me=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),He=this.semver.version===he.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Ge=W(this.semver,"<",he.semver,De)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Ze=W(this.semver,">",he.semver,De)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Me||Fe||He&&Be||Ge||Ze},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(he){var De=this.loose;he=he.trim(),I("range",he,De);var ke=De?P[oe]:P[z];he=he.replace(ke,ge),I("hyphen replace",he),he=he.replace(P[M],"$1$2$3"),I("comparator trim",he,P[M]),he=(he=(he=he.replace(P[V],"$1~")).replace(P[ee],"$1^")).split(/\s+/).join(" ");var Me=De?P[Z]:P[Y],Fe=he.split(" ").map(function(He){return function(Be,Ge){return I("comp",Be),Be=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(tt){return function(Qe,Je){I("caret",Qe,Je);var xe=Je?P[B]:P[K];return Qe.replace(xe,function(pe,Pe,je,Ne,Ue){var Ve;return I("caret",Qe,pe,Pe,je,Ne,Ue),de(Pe)?Ve="":de(je)?Ve=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Ne)?Ve=Pe==="0"?">="+Pe+"."+je+".0 <"+Pe+"."+(+je+1)+".0":">="+Pe+"."+je+".0 <"+(+Pe+1)+".0.0":Ue?(I("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ve=Pe==="0"?je==="0"?">="+Pe+"."+je+"."+Ne+Ue+" <"+Pe+"."+je+"."+(+Ne+1):">="+Pe+"."+je+"."+Ne+Ue+" <"+Pe+"."+(+je+1)+".0":">="+Pe+"."+je+"."+Ne+Ue+" <"+(+Pe+1)+".0.0"):(I("no pr"),Ve=Pe==="0"?je==="0"?">="+Pe+"."+je+"."+Ne+" <"+Pe+"."+je+"."+(+Ne+1):">="+Pe+"."+je+"."+Ne+" <"+Pe+"."+(+je+1)+".0":">="+Pe+"."+je+"."+Ne+" <"+(+Pe+1)+".0.0"),I("caret return",Ve),Ve})}(tt,_e)}).join(" ")}(Be,Ge),I("caret",Be),Be=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(tt){return function(Qe,Je){var xe=Je?P[ae]:P[ie];return Qe.replace(xe,function(pe,Pe,je,Ne,Ue){var Ve;return I("tilde",Qe,pe,Pe,je,Ne,Ue),de(Pe)?Ve="":de(je)?Ve=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Ne)?Ve=">="+Pe+"."+je+".0 <"+Pe+"."+(+je+1)+".0":Ue?(I("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ve=">="+Pe+"."+je+"."+Ne+Ue+" <"+Pe+"."+(+je+1)+".0"):Ve=">="+Pe+"."+je+"."+Ne+" <"+Pe+"."+(+je+1)+".0",I("tilde return",Ve),Ve})}(tt,_e)}).join(" ")}(Be,Ge),I("tildes",Be),Be=function(Ze,_e){return I("replaceXRanges",Ze,_e),Ze.split(/\s+/).map(function(tt){return function(Qe,Je){Qe=Qe.trim();var xe=Je?P[A]:P[C];return Qe.replace(xe,function(pe,Pe,je,Ne,Ue,Ve){I("xRange",Qe,pe,Pe,je,Ne,Ue,Ve);var nt=de(je),Ye=nt||de(Ne),it=Ye||de(Ue);return Pe==="="&&it&&(Pe=""),nt?pe=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&it?(Ye&&(Ne=0),it&&(Ue=0),Pe===">"?(Pe=">=",Ye?(je=+je+1,Ne=0,Ue=0):it&&(Ne=+Ne+1,Ue=0)):Pe==="<="&&(Pe="<",Ye?je=+je+1:Ne=+Ne+1),pe=Pe+je+"."+Ne+"."+Ue):Ye?pe=">="+je+".0.0 <"+(+je+1)+".0.0":it&&(pe=">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0"),I("xRange return",pe),pe})}(tt,_e)}).join(" ")}(Be,Ge),I("xrange",Be),Be=function(Ze,_e){return I("replaceStars",Ze,_e),Ze.trim().replace(P[se],"")}(Be,Ge),I("stars",Be),Be}(He,De)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(He){return!!He.match(Me)})),Fe=Fe.map(function(He){return new ce(He,De)})},we.prototype.intersects=function(he,De){if(!(he instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(Me){return he.set.some(function(Fe){return Fe.every(function(He){return Me.intersects(He,De)})})})})},e.toComparators=function(he,De){return new we(he,De).set.map(function(ke){return ke.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},we.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new ne(he,this.loose));for(var De=0;De<this.set.length;De++)if($e(this.set[De],he))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(he,De,ke){var Me=null,Fe=null;try{var He=new we(De,ke)}catch{return null}return he.forEach(function(Be){He.test(Be)&&(Me&&Fe.compare(Be)!==-1||(Fe=new ne(Me=Be,ke)))}),Me},e.minSatisfying=function(he,De,ke){var Me=null,Fe=null;try{var He=new we(De,ke)}catch{return null}return he.forEach(function(Be){He.test(Be)&&(Me&&Fe.compare(Be)!==1||(Fe=new ne(Me=Be,ke)))}),Me},e.validRange=function(he,De){try{return new we(he,De).range||"*"}catch{return null}},e.ltr=function(he,De,ke){return Ae(he,De,"<",ke)},e.gtr=function(he,De,ke){return Ae(he,De,">",ke)},e.outside=Ae,e.prerelease=function(he,De){var ke=H(he,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(he,De,ke){return he=new we(he,ke),De=new we(De,ke),he.intersects(De)},e.coerce=function(he){if(he instanceof ne)return he;if(typeof he!="string")return null;var De=he.match(P[O]);return De==null?null:H((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,s(1))},function(fe,e){var s,j,I=fe.exports={};function D(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function P(u){if(s===setTimeout)return setTimeout(u,0);if((s===D||!s)&&setTimeout)return s=setTimeout,setTimeout(u,0);try{return s(u,0)}catch{try{return s.call(null,u,0)}catch{return s.call(this,u,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:D}catch{s=D}try{j=typeof clearTimeout=="function"?clearTimeout:S}catch{j=S}})();var b,$=[],y=!1,w=-1;function v(){y&&b&&(y=!1,b.length?$=b.concat($):w=-1,$.length&&m())}function m(){if(!y){var u=P(v);y=!0;for(var h=$.length;h;){for(b=$,$=[];++w<h;)b&&b[w].run();w=-1,h=$.length}b=null,y=!1,function(g){if(j===clearTimeout)return clearTimeout(g);if((j===S||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(g);try{j(g)}catch{try{return j.call(null,g)}catch{return j.call(this,g)}}}(u)}}function l(u,h){this.fun=u,this.array=h}function c(){}I.nextTick=function(u){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];$.push(new l(u,h)),$.length!==1||y||P(m)},l.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=c,I.addListener=c,I.once=c,I.off=c,I.removeListener=c,I.removeAllListeners=c,I.emit=c,I.prependListener=c,I.prependOnceListener=c,I.listeners=function(u){return[]},I.binding=function(u){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(u){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(ye[159],Ee([1,0]),function(fe,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class j{constructor(P,b,$){this.level=P,this.key=b,this.value=$,this.forward=[]}}const I=void 0;class D{constructor(P,b=2**16){this.comparator=P,this[s]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new j(this.c,I,I)}get size(){return this.f}clear(){this.e=new j(this.c,I,I),this.f=0}has(P){return!!D.g(this,P,this.comparator)}get(P){return D.g(this,P,this.comparator)?.value}set(P,b){return D.h(this,P,b,this.comparator)&&(this.f+=1),this}delete(P){const b=D.k(this,P,this.comparator);return b&&(this.f-=1),b}forEach(P,b){let $=this.e.forward[0];for(;$;)P.call(b,$.value,$.key,this),$=$.forward[0]}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",b=this.e.forward[0];for(;b;)P+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return P}static g(P,b,$){let y=P.e;for(let w=P.d-1;w>=0;w--)for(;y.forward[w]&&$(y.forward[w].key,b)<0;)y=y.forward[w];if(y=y.forward[0],y&&$(y.key,b)===0)return y}static h(P,b,$,y){const w=[];let v=P.e;for(let m=P.d-1;m>=0;m--){for(;v.forward[m]&&y(v.forward[m].key,b)<0;)v=v.forward[m];w[m]=v}if(v=v.forward[0],v&&y(v.key,b)===0)return v.value=$,!1;{const m=D.j(P);if(m>P.d){for(let l=P.d;l<m;l++)w[l]=P.e;P.d=m}v=new j(m,b,$);for(let l=0;l<m;l++)v.forward[l]=w[l].forward[l],w[l].forward[l]=v;return!0}}static j(P,b=.5){let $=1;for(;Math.random()<b&&$<P.c;)$+=1;return $}static k(P,b,$){const y=[];let w=P.e;for(let v=P.d-1;v>=0;v--){for(;w.forward[v]&&$(w.forward[v].key,b)<0;)w=w.forward[v];y[v]=w}if(w=w.forward[0],!w||$(w.key,b)!==0)return!1;for(let v=0;v<P.d&&y[v].forward[v]===w;v++)y[v].forward[v]=w.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===I;)P.d-=1;return!0}}e.$Fs=D}),define(ye[61],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class j{static create(D){return new j(D)}constructor(D){this.c=s&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=j}),define(ye[6],Ee([1,0,11,75,2,99,61]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=m;const P=!1,b=!1,$=!1;var y;(function(ae){ae.None=()=>I.$Uc.None;function te(ge){if($){const{onDidAddListener:$e}=ge,Ce=c.create();let Ae=0;ge.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ce.print()),$e?.()}}}function ee(ge,$e){return H(ge,()=>{},0,void 0,!0,void 0,$e)}ae.defer=ee;function K(ge){return($e,Ce=null,Ae)=>{let he=!1,De;return De=ge(ke=>{if(!he)return De?De.dispose():he=!0,$e.call(Ce,ke)},null,Ae),he&&De.dispose(),De}}ae.once=K;function B(ge,$e,Ce){return se((Ae,he=null,De)=>ge(ke=>Ae.call(he,$e(ke)),null,De),Ce)}ae.map=B;function Z(ge,$e,Ce){return se((Ae,he=null,De)=>ge(ke=>{$e(ke),Ae.call(he,ke)},null,De),Ce)}ae.forEach=Z;function Y(ge,$e,Ce){return se((Ae,he=null,De)=>ge(ke=>$e(ke)&&Ae.call(he,ke),null,De),Ce)}ae.filter=Y;function M(ge){return ge}ae.signal=M;function z(...ge){return($e,Ce=null,Ae)=>{const he=(0,I.$Rc)(...ge.map(De=>De(ke=>$e.call(Ce,ke))));return _(he,Ae)}}ae.any=z;function oe(ge,$e,Ce,Ae){let he=Ce;return B(ge,De=>(he=$e(he,De),he),Ae)}ae.reduce=oe;function se(ge,$e){let Ce;const Ae={onWillAddFirstListener(){Ce=ge(he.fire,he)},onDidRemoveLastListener(){Ce?.dispose()}};$e||te(Ae);const he=new o(Ae);return $e?.add(he),he.event}function _(ge,$e){return $e instanceof Array?$e.push(ge):$e&&$e.add(ge),ge}function H(ge,$e,Ce=100,Ae=!1,he=!1,De,ke){let Me,Fe,He,Be=0,Ge;const Ze={leakWarningThreshold:De,onWillAddFirstListener(){Me=ge(tt=>{Be++,Fe=$e(Fe,tt),Ae&&!He&&(_e.fire(Fe),Fe=void 0),Ge=()=>{const Qe=Fe;Fe=void 0,He=void 0,(!Ae||Be>1)&&_e.fire(Qe),Be=0},typeof Ce=="number"?(clearTimeout(He),He=setTimeout(Ge,Ce)):He===void 0&&(He=0,queueMicrotask(Ge))})},onWillRemoveListener(){he&&Be>0&&Ge?.()},onDidRemoveLastListener(){Ge=void 0,Me.dispose()}};ke||te(Ze);const _e=new o(Ze);return ke?.add(_e),_e.event}ae.debounce=H;function ne(ge,$e=0,Ce){return ae.debounce(ge,(Ae,he)=>Ae?(Ae.push(he),Ae):[he],$e,void 0,!0,void 0,Ce)}ae.accumulate=ne;function le(ge,$e=(Ae,he)=>Ae===he,Ce){let Ae=!0,he;return Y(ge,De=>{const ke=Ae||!$e(De,he);return Ae=!1,he=De,ke},Ce)}ae.latch=le;function F(ge,$e,Ce){return[ae.filter(ge,$e,Ce),ae.filter(ge,Ae=>!$e(Ae),Ce)]}ae.split=F;function U(ge,$e=!1,Ce=[],Ae){let he=Ce.slice(),De=ge(Fe=>{he?he.push(Fe):Me.fire(Fe)});Ae&&Ae.add(De);const ke=()=>{he?.forEach(Fe=>Me.fire(Fe)),he=null},Me=new o({onWillAddFirstListener(){De||(De=ge(Fe=>Me.fire(Fe)),Ae&&Ae.add(De))},onDidAddFirstListener(){he&&($e?setTimeout(ke):ke())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Ae&&Ae.add(Me),Me.event}ae.buffer=U;function X(ge,$e){return(Ae,he,De)=>{const ke=$e(new Q);return ge(function(Me){const Fe=ke.evaluate(Me);Fe!==x&&Ae.call(he,Fe)},void 0,De)}}ae.chain=X;const x=Symbol("HaltChainable");class Q{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(Ce=>($e(Ce),Ce)),this}filter($e){return this.f.push(Ce=>$e(Ce)?Ce:x),this}reduce($e,Ce){let Ae=Ce;return this.f.push(he=>(Ae=$e(Ae,he),Ae)),this}latch($e=(Ce,Ae)=>Ce===Ae){let Ce=!0,Ae;return this.f.push(he=>{const De=Ce||!$e(he,Ae);return Ce=!1,Ae=he,De?he:x}),this}evaluate($e){for(const Ce of this.f)if($e=Ce($e),$e===x)break;return $e}}function G(ge,$e,Ce=Ae=>Ae){const Ae=(...Me)=>ke.fire(Ce(...Me)),he=()=>ge.on($e,Ae),De=()=>ge.removeListener($e,Ae),ke=new o({onWillAddFirstListener:he,onDidRemoveLastListener:De});return ke.event}ae.fromNodeEventEmitter=G;function J(ge,$e,Ce=Ae=>Ae){const Ae=(...Me)=>ke.fire(Ce(...Me)),he=()=>ge.addEventListener($e,Ae),De=()=>ge.removeEventListener($e,Ae),ke=new o({onWillAddFirstListener:he,onDidRemoveLastListener:De});return ke.event}ae.fromDOMEventEmitter=J;function T(ge){return new Promise($e=>K(ge)($e))}ae.toPromise=T;function W(ge){const $e=new o;return ge.then(Ce=>{$e.fire(Ce)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}ae.fromPromise=W;function ce(ge,$e,Ce){return $e(Ce),ge(Ae=>$e(Ae))}ae.runAndSubscribe=ce;class ue{constructor($e,Ce){this._observable=$e,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};Ce||te(Ae),this.emitter=new o(Ae),Ce&&Ce.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,Ce){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ge,$e){return new ue(ge,$e).emitter.event}ae.fromObservable=we;function de(ge){return($e,Ce,Ae)=>{let he=0,De=!1;const ke={beginUpdate(){he++},endUpdate(){he--,he===0&&(ge.reportChanges(),De&&(De=!1,$e.call(Ce)))},handlePossibleChange(){},handleChange(){De=!0}};ge.addObserver(ke),ge.reportChanges();const Me={dispose(){ge.removeObserver(ke)}};return Ae instanceof I.$Tc?Ae.add(Me):Array.isArray(Ae)&&Ae.push(Me),Me}}ae.fromObservableLight=de})(y||(e.Event=y={}));class w{static{this.all=new Set}static{this.f=0}constructor(te){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${te}_${w.f++}`,w.all.add(this)}start(te){this.g=new S.$be,this.listenerCount=te}stop(){if(this.g){const te=this.g.elapsed();this.durations.push(te),this.elapsedOverall+=te,this.invocationCount+=1,this.g=void 0}}}e.$de=w;let v=-1;function m(ae){const te=v;return v=ae,{dispose(){v=te}}}class l{constructor(te,ee,K=Math.random().toString(18).slice(2,5)){this.h=te,this.threshold=ee,this.name=K,this.g=0}dispose(){this.f?.clear()}check(te,ee){const K=this.threshold;if(K<=0||ee<K)return;this.f||(this.f=new Map);const B=this.f.get(te.value)||0;if(this.f.set(te.value,B+1),this.g-=1,this.g<=0){this.g=K*.5;const[Z,Y]=this.getMostFrequentStack(),M=`[${this.name}] potential listener LEAK detected, having ${ee} listeners already. MOST frequent listener (${Y}):`;console.warn(M),console.warn(Z);const z=new u(M,Z);this.h(z)}return()=>{const Z=this.f.get(te.value)||0;this.f.set(te.value,Z-1)}}getMostFrequentStack(){if(!this.f)return;let te,ee=0;for(const[K,B]of this.f)(!te||ee<B)&&(te=[K,B],ee=B);return te}}class c{static create(){const te=new Error;return new c(te.stack??"")}constructor(te){this.value=te}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u extends Error{constructor(te,ee){super(te),this.name="ListenerLeakError",this.stack=ee}}e.$fe=u;class h extends Error{constructor(te,ee){super(te),this.name="ListenerRefusalError",this.stack=ee}}e.$ge=h;let g=0;class d{constructor(te){this.value=te,this.id=g++}}const E=2,f=(ae,te)=>{if(ae instanceof d)te(ae);else for(let ee=0;ee<ae.length;ee++){const K=ae[ee];K&&te(K)}},t=P?new FinalizationRegistry(ae=>{typeof ae=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(ae))}):void 0;class o{constructor(te){this.w=0,this.f=te,this.g=v>0||this.f?.leakWarningThreshold?new l(te?.onListenerError??s.$1,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const te=this.t;queueMicrotask(()=>{f(te,ee=>ee.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(te,ee,K)=>{if(this.g&&this.w>this.g.threshold*3){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(z);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],se=new h(`${z}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||s.$1)(se),I.$Uc.None}if(this.m)return I.$Uc.None;ee&&(te=te.bind(ee));const B=new d(te);let Z,Y;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=c.create(),Z=this.g.check(B.stack,this.w+1)),b&&(B.stack=Y??c.create()),this.t?this.t instanceof d?(this.u??=new n,this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const M=(0,I.$Sc)(()=>{t?.unregister(M),Z?.(),this.x(B)});if(K instanceof I.$Tc?K.add(M):Array.isArray(K)&&K.push(M),t){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(M,z,M)}return M},this.q}x(te){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ee=this.t,K=ee.indexOf(te);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ee[K]=void 0;const B=this.u.current===this;if(this.w*E<=ee.length){let Z=0;for(let Y=0;Y<ee.length;Y++)ee[Y]?ee[Z++]=ee[Y]:B&&(this.u.end--,Z<this.u.i&&this.u.i--);ee.length=Z}}y(te,ee){if(!te)return;const K=this.f?.onListenerError||s.$1;if(!K){te.value(ee);return}try{te.value(ee)}catch(B){K(B)}}z(te){const ee=te.current.t;for(;te.i<te.end;)this.y(ee[te.i++],te.value);te.reset()}fire(te){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,te);else{const ee=this.u;ee.enqueue(this,te,this.t.length),this.z(ee)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=o;const r=()=>new n;e.$ie=r;class n{constructor(){this.i=-1,this.end=0}enqueue(te,ee,K){this.i=0,this.end=K,this.current=te,this.value=ee}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends o{async fireAsync(te,ee,K){if(this.t)for(this.h||(this.h=new D.$5c),f(this.t,B=>this.h.push([B.value,te]));this.h.size>0&&!ee.isCancellationRequested;){const[B,Z]=this.h.shift(),Y=[],M={...Z,token:ee,waitUntil:z=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");K&&(z=K(z,B)),Y.push(z)}};try{B(M)}catch(z){(0,s.$1)(z);continue}Object.freeze(Y),await Promise.allSettled(Y).then(z=>{for(const oe of z)oe.status==="rejected"&&(0,s.$1)(oe.reason)})}}}e.$je=a;class i extends o{get isPaused(){return this.h!==0}constructor(te){super(te),this.h=0,this.s=new D.$5c,this.A=te?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const te=Array.from(this.s);this.s.clear(),super.fire(this.A(te))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(te){this.w&&(this.h!==0?this.s.push(te):super.fire(te))}}e.$ke=i;class p extends i{constructor(te){super(te),this.k=te.delay??100}fire(te){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(te)}}e.$le=p;class k extends o{constructor(te){super(te),this.h=[],this.k=te?.merge}fire(te){this.hasListeners()&&(this.h.push(te),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ee=>super.fire(ee)),this.h=[]}))}}e.$me=k;class C{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(te){const ee={event:te,listener:null};this.h.push(ee),this.g&&this.m(ee);const K=()=>{this.g&&this.o(ee);const B=this.h.indexOf(ee);this.h.splice(B,1)};return(0,I.$Sc)((0,j.$db)(K))}j(){this.g=!0,this.h.forEach(te=>this.m(te))}k(){this.g=!1,this.h.forEach(te=>this.o(te))}m(te){te.listener=te.event(ee=>this.f.fire(ee))}o(te){te.listener?.dispose(),te.listener=null}dispose(){this.f.dispose();for(const te of this.h)te.listener?.dispose();this.h=[]}}e.$ne=C;class A{constructor(te,ee,K,B){this.f=new I.$Tc;const Z=this.f.add(new C),Y=this.f.add(new I.$4c);function M(z){Y.set(z,Z.add(B(z)))}for(const z of te)M(z);this.f.add(ee(z=>{M(z)})),this.f.add(K(z=>{Y.deleteAndDispose(z)})),this.event=Z.event}dispose(){this.f.dispose()}}e.$oe=A;class O{constructor(){this.f=[]}wrapEvent(te,ee,K){return(B,Z,Y)=>te(M=>{const z=this.f[this.f.length-1];if(!ee){z?z.buffers.push(()=>B.call(Z,M)):B.call(Z,M);return}const oe=z;if(!oe){B.call(Z,ee(K,M));return}oe.items??=[],oe.items.push(M),oe.buffers.length===0&&z.buffers.push(()=>{oe.reducedResult??=K?oe.items.reduce(ee,K):oe.items.reduce(ee),B.call(Z,oe.reducedResult)})},void 0,Y)}bufferEvents(te){const ee={buffers:new Array};this.f.push(ee);const K=te();return this.f.pop(),ee.buffers.forEach(B=>B()),K}}e.$pe=O;class N{constructor(){this.f=!1,this.g=y.None,this.h=I.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(te){this.g=te,this.f&&(this.h.dispose(),this.h=te(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=N;class V{static const(te){return new ie(te)}constructor(te){this.g=te,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(te){te!==this.g&&(this.g=te,this.f.fire(void 0))}}e.$re=V;class ie{constructor(te){this.value=te,this.onDidChange=y.None}}}),define(ye[20],Ee([1,0,6]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=P;const j=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var I;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof D?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:j})})(I||(e.CancellationToken=I={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?j:(this.b||(this.b=new s.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=I.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=I.None}}e.$se=S;function P(b){const $=new S;return b.add({dispose(){$.cancel()}}),$.token}}),define(ye[160],Ee([1,0,20]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=I;class j{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new s.$se,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$5e=j;function I(P){return P}class D{constructor(b,$){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=I):(this.c=$,this.d=b.getCacheKey)}get(b){const $=this.d(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$7e=D;class S{get cachedValues(){return this.a}constructor(b,$){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=I):(this.c=$,this.d=b.getCacheKey)}get(b){const $=this.d(b);if(this.b.has($))return this.b.get($);const y=this.c(b);return this.a.set(b,y),this.b.set($,y),y}}e.$8e=S}),define(ye[53],Ee([1,0,11,2]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=I,e.$ve=D,e.$we=S,e.$xe=P,e.$ye=$,e.$ze=y,e.$Ae=w,e.$Be=v,e.$Ce=m,e.$De=l,e.$Ee=c,e.$Fe=u,e.$Ge=h,e.$He=g,e.$Ie=d;function I(E){const f=E;return f?typeof f.read=="function":!1}function D(E){const f=E;return f?[f.on,f.pause,f.resume,f.destroy].every(t=>typeof t=="function"):!1}function S(E){const f=E;return f?D(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}function P(E,f){return new b(E,f)}class b{constructor(f,t){this.e=f,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(t=>t(f))}h(f){this.c.error.length===0?(0,s.$1)(f):this.c.error.slice(0).forEach(t=>t(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,t){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(f,t){if(this.a.destroyed)return;let o;switch(f){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(E,f){const t=[];let o;for(;(o=E.read())!==null;)t.push(o);return f(t)}function y(E,f,t){const o=[];let r;for(;(r=E.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const n=r;return r=void 0,n}return E.read()}}}function w(E,f){return new Promise((t,o)=>{const r=[];v(E,{onData:n=>{f&&r.push(n)},onError:n=>{f?o(n):t(void 0)},onEnd:()=>{t(f?f(r):void 0)}})})}function v(E,f,t){E.on("error",o=>{t?.isCancellationRequested||f.onError(o)}),E.on("end",()=>{t?.isCancellationRequested||f.onEnd()}),E.on("data",o=>{t?.isCancellationRequested||f.onData(o)})}function m(E,f){return new Promise((t,o)=>{const r=new j.$Tc,n=[],a=k=>{if(n.push(k),n.length>f)return r.dispose(),E.pause(),t({stream:E,buffer:n,ended:!1})},i=k=>(r.dispose(),o(k)),p=()=>(r.dispose(),t({stream:E,buffer:n,ended:!0}));r.add((0,j.$Sc)(()=>E.removeListener("error",i))),E.on("error",i),r.add((0,j.$Sc)(()=>E.removeListener("end",p))),E.on("end",p),r.add((0,j.$Sc)(()=>E.removeListener("data",a))),E.on("data",a)})}function l(E,f){const t=P(f);return t.end(E),t}function c(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}function u(E){let f=!1;return{read:()=>f?null:(f=!0,E)}}function h(E,f,t){const o=P(t);return v(E,{onData:r=>o.write(f.data(r)),onError:r=>o.error(f.error?f.error(r):r),onEnd:()=>o.end()}),o}function g(E,f,t){let o=!1;return{read:()=>{const r=f.read();return o?r:(o=!0,r!==null?t([E,r]):E)}}}function d(E,f,t){let o=!1;const r=P(t);return v(f,{onData:n=>o?r.write(n):(o=!0,r.write(t([E,n]))),onError:n=>r.error(n),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}}),define(ye[15],Ee([1,0,60,53]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=$,e.$Le=y,e.$Me=w,e.$Ne=v,e.$Oe=m,e.$Pe=l,e.$Qe=c,e.$Re=u,e.$Se=h,e.$Te=g,e.$Ue=d,e.$Ve=E,e.$We=f,e.$Xe=t,e.$Ye=o,e.$Ze=r,e.$1e=n,e.$2e=a,e.$3e=i,e.$4e=C;const I=typeof Buffer<"u",D=new s.$V(()=>new Uint8Array(256));let S,P;class b{static alloc(O){return I?new b(Buffer.allocUnsafe(O)):new b(new Uint8Array(O))}static wrap(O){return I&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new b(O)}static fromString(O,N){return!(N?.dontUseNodeBuffer||!1)&&I?new b(Buffer.from(O)):(S||(S=new TextEncoder),new b(S.encode(O)))}static fromByteArray(O){const N=b.alloc(O.length);for(let V=0,ie=O.length;V<ie;V++)N.buffer[V]=O[V];return N}static concat(O,N){if(typeof N>"u"){N=0;for(let ae=0,te=O.length;ae<te;ae++)N+=O[ae].byteLength}const V=b.alloc(N);let ie=0;for(let ae=0,te=O.length;ae<te;ae++){const ee=O[ae];V.set(ee,ie),ie+=ee.byteLength}return V}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=b.alloc(this.byteLength);return O.set(this),O}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(O,N){return new b(this.buffer.subarray(O,N))}set(O,N){if(O instanceof b)this.buffer.set(O.buffer,N);else if(O instanceof Uint8Array)this.buffer.set(O,N);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),N);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,N){m(this.buffer,O,N)}readUInt32LE(O){return l(this.buffer,O)}writeUInt32LE(O,N){c(this.buffer,O,N)}readUInt8(O){return u(this.buffer,O)}writeUInt8(O,N){h(this.buffer,O,N)}indexOf(O,N=0){return $(this.buffer,O instanceof b?O.buffer:O,N)}}e.$Je=b;function $(A,O,N=0){const V=O.byteLength,ie=A.byteLength;if(V===0)return 0;if(V===1)return A.indexOf(O[0]);if(V>ie-N)return-1;const ae=D.value;ae.fill(O.length);for(let B=0;B<O.length;B++)ae[O[B]]=O.length-B-1;let te=N+O.length-1,ee=te,K=-1;for(;te<ie;)if(A[te]===O[ee]){if(ee===0){K=te;break}te--,ee--}else te+=Math.max(O.length-ee,ae[A[te]]),ee=O.length-1;return K}function y(A,O){return A[O+0]<<0>>>0|A[O+1]<<8>>>0}function w(A,O,N){A[N+0]=O&255,O=O>>>8,A[N+1]=O&255}function v(A,O){return A[O]*2**24+A[O+1]*2**16+A[O+2]*2**8+A[O+3]}function m(A,O,N){A[N+3]=O,O=O>>>8,A[N+2]=O,O=O>>>8,A[N+1]=O,O=O>>>8,A[N]=O}function l(A,O){return A[O+0]<<0>>>0|A[O+1]<<8>>>0|A[O+2]<<16>>>0|A[O+3]<<24>>>0}function c(A,O,N){A[N+0]=O&255,O=O>>>8,A[N+1]=O&255,O=O>>>8,A[N+2]=O&255,O=O>>>8,A[N+3]=O&255}function u(A,O){return A[O]}function h(A,O,N){A[N]=O}function g(A){return j.$ye(A,O=>b.concat(O))}function d(A){return j.$Fe(A)}function E(A){return j.$Ae(A,O=>b.concat(O))}async function f(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await E(A.stream)])}function t(A){return j.$De(A,O=>b.concat(O))}function o(A){return j.$Ge(A,{data:O=>typeof O=="string"?b.fromString(O):b.wrap(O)},O=>b.concat(O))}function r(A){return j.$xe(O=>b.concat(O),A)}function n(A,O){return j.$He(A,O,N=>b.concat(N))}function a(A,O){return j.$Ie(A,O,N=>b.concat(N))}function i(A){let O=0,N=0,V=0;const ie=new Uint8Array(Math.floor(A.length/4*3)),ae=ee=>{switch(N){case 3:ie[V++]=O|ee,N=0;break;case 2:ie[V++]=O|ee>>>2,O=ee<<6,N=3;break;case 1:ie[V++]=O|ee>>>4,O=ee<<4,N=2;break;default:O=ee<<2,N=1}};for(let ee=0;ee<A.length;ee++){const K=A.charCodeAt(ee);if(K>=65&&K<=90)ae(K-65);else if(K>=97&&K<=122)ae(K-97+26);else if(K>=48&&K<=57)ae(K-48+52);else if(K===43||K===45)ae(62);else if(K===47||K===95)ae(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${A[ee]}`)}}const te=V;for(;N>0;)ae(0);return b.wrap(ie).slice(0,te)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:A},O=!0,N=!1){const V=N?k:p;let ie="";const ae=A.byteLength%3;let te=0;for(;te<A.byteLength-ae;te+=3){const ee=A[te+0],K=A[te+1],B=A[te+2];ie+=V[ee>>>2],ie+=V[(ee<<4|K>>>4)&63],ie+=V[(K<<2|B>>>6)&63],ie+=V[B&63]}if(ae===1){const ee=A[te+0];ie+=V[ee>>>2],ie+=V[ee<<4&63],O&&(ie+="==")}else if(ae===2){const ee=A[te+0],K=A[te+1];ie+=V[ee>>>2],ie+=V[(ee<<4|K>>>4)&63],ie+=V[K<<2&63],O&&(ie+="=")}return ie}}),define(ye[17],Ee([1,0,160,60]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=I,e.$_e=S,e.$af=b,e.$bf=$,e.$cf=y,e.$df=w,e.$ef=v,e.$ff=m,e.$gf=l,e.$hf=c,e.$if=u,e.$jf=h,e.$kf=g,e.$lf=d,e.$mf=E,e.$nf=f,e.$of=t,e.$pf=o,e.$qf=r,e.$rf=n,e.$sf=a,e.$tf=i,e.$uf=p,e.$vf=k,e.$wf=C,e.$xf=A,e.$yf=O,e.$zf=N,e.$Af=V,e.$Bf=ie,e.$Cf=ae,e.$Df=te,e.$Ef=ee,e.$Ff=K,e.$Gf=B,e.$Hf=Z,e.$If=Y,e.$Lf=se,e.$Mf=_,e.$Nf=H,e.$Of=ne,e.$Pf=U,e.$Qf=x,e.$Sf=Q,e.$Tf=G,e.$Uf=J,e.$Vf=T,e.$Wf=ce,e.$Xf=ue,e.$Yf=de,e.$1f=ge,e.$2f=$e,e.$3f=Ce,e.$4f=Ae,e.$5f=he,e.$6f=De,e.$7f=ke,e.$8f=Me,e.$9f=Ze;function I(pe){return!pe||typeof pe!="string"?!0:pe.trim().length===0}const D=/{(\d+)}/g;function S(pe,...Pe){return Pe.length===0?pe:pe.replace(D,function(je,Ne){const Ue=parseInt(Ne,10);return isNaN(Ue)||Ue<0||Ue>=Pe.length?je:Pe[Ue]})}const P=/{([^}]+)}/g;function b(pe,Pe){return Object.keys(Pe).length===0?pe:pe.replace(P,(je,Ne)=>Pe[Ne]??je)}function $(pe){return pe.replace(/[<>"'&]/g,Pe=>{switch(Pe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Pe})}function y(pe){return pe.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}function w(pe){return pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(pe,Pe){let je=0,Ne=pe.indexOf(Pe);for(;Ne!==-1;)je++,Ne=pe.indexOf(Pe,Ne+Pe.length);return je}function m(pe,Pe,je="\u2026"){return pe.length<=Pe?pe:`${pe.substr(0,Pe)}${je}`}function l(pe,Pe,je="\u2026"){if(pe.length<=Pe)return pe;const Ne=Math.ceil(Pe/2)-je.length/2,Ue=Math.floor(Pe/2)-je.length/2;return`${pe.substr(0,Ne)}${je}${pe.substr(pe.length-Ue)}`}function c(pe,Pe=" "){const je=u(pe,Pe);return h(je,Pe)}function u(pe,Pe){if(!pe||!Pe)return pe;const je=Pe.length;if(je===0||pe.length===0)return pe;let Ne=0;for(;pe.indexOf(Pe,Ne)===Ne;)Ne=Ne+je;return pe.substring(Ne)}function h(pe,Pe){if(!pe||!Pe)return pe;const je=Pe.length,Ne=pe.length;if(je===0||Ne===0)return pe;let Ue=Ne,Ve=-1;for(;Ve=pe.lastIndexOf(Pe,Ue-1),!(Ve===-1||Ve+je!==Ue);){if(Ve===0)return"";Ue=Ve}return pe.substring(0,Ue)}function g(pe){return pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(pe){return pe.replace(/\*/g,"")}function E(pe,Pe,je={}){if(!pe)throw new Error("Cannot create regex from empty string");Pe||(pe=w(pe)),je.wholeWord&&(/\B/.test(pe.charAt(0))||(pe="\\b"+pe),/\B/.test(pe.charAt(pe.length-1))||(pe=pe+"\\b"));let Ne="";return je.global&&(Ne+="g"),je.matchCase||(Ne+="i"),je.multiline&&(Ne+="m"),je.unicode&&(Ne+="u"),new RegExp(pe,Ne)}function f(pe){return pe.source==="^"||pe.source==="^$"||pe.source==="$"||pe.source==="^\\s*$"?!1:!!(pe.exec("")&&pe.lastIndex===0)}function t(pe){return pe.split(/\r\n|\r|\n/)}function o(pe){const Pe=[],je=pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(je.length/2);Ne++)Pe.push(je[2*Ne]+(je[2*Ne+1]??""));return Pe}function r(pe){for(let Pe=0,je=pe.length;Pe<je;Pe++){const Ne=pe.charCodeAt(Pe);if(Ne!==32&&Ne!==9)return Pe}return-1}function n(pe,Pe=0,je=pe.length){for(let Ne=Pe;Ne<je;Ne++){const Ue=pe.charCodeAt(Ne);if(Ue!==32&&Ue!==9)return pe.substring(Pe,Ne)}return pe.substring(Pe,je)}function a(pe,Pe=pe.length-1){for(let je=Pe;je>=0;je--){const Ne=pe.charCodeAt(je);if(Ne!==32&&Ne!==9)return je}return-1}function i(pe,Pe,je){const Ne=[];let Ue=0;for(const Ve of pe.matchAll(Pe)){if(Ne.push(pe.slice(Ue,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Ue=Ve.index+Ve[0].length,Ne.push(je(Ve[0],...Ve.slice(1),Ve.index,pe,Ve.groups))}return Ne.push(pe.slice(Ue)),Promise.all(Ne).then(Ve=>Ve.join(""))}function p(pe,Pe){return pe<Pe?-1:pe>Pe?1:0}function k(pe,Pe,je=0,Ne=pe.length,Ue=0,Ve=Pe.length){for(;je<Ne&&Ue<Ve;je++,Ue++){const it=pe.charCodeAt(je),at=Pe.charCodeAt(Ue);if(it<at)return-1;if(it>at)return 1}const nt=Ne-je,Ye=Ve-Ue;return nt<Ye?-1:nt>Ye?1:0}function C(pe,Pe){return A(pe,Pe,0,pe.length,0,Pe.length)}function A(pe,Pe,je=0,Ne=pe.length,Ue=0,Ve=Pe.length){for(;je<Ne&&Ue<Ve;je++,Ue++){let it=pe.charCodeAt(je),at=Pe.charCodeAt(Ue);if(it===at)continue;if(it>=128||at>=128)return k(pe.toLowerCase(),Pe.toLowerCase(),je,Ne,Ue,Ve);N(it)&&(it-=32),N(at)&&(at-=32);const ot=it-at;if(ot!==0)return ot}const nt=Ne-je,Ye=Ve-Ue;return nt<Ye?-1:nt>Ye?1:0}function O(pe){return pe>=48&&pe<=57}function N(pe){return pe>=97&&pe<=122}function V(pe){return pe>=65&&pe<=90}function ie(pe,Pe){return pe.length===Pe.length&&A(pe,Pe)===0}function ae(pe,Pe){const je=Pe.length;return Pe.length>pe.length?!1:A(pe,Pe,0,je)===0}function te(pe,Pe){const je=Math.min(pe.length,Pe.length);let Ne;for(Ne=0;Ne<je;Ne++)if(pe.charCodeAt(Ne)!==Pe.charCodeAt(Ne))return Ne;return je}function ee(pe,Pe){const je=Math.min(pe.length,Pe.length);let Ne;const Ue=pe.length-1,Ve=Pe.length-1;for(Ne=0;Ne<je;Ne++)if(pe.charCodeAt(Ue-Ne)!==Pe.charCodeAt(Ve-Ne))return Ne;return je}function K(pe){return 55296<=pe&&pe<=56319}function B(pe){return 56320<=pe&&pe<=57343}function Z(pe,Pe){return(pe-55296<<10)+(Pe-56320)+65536}function Y(pe,Pe,je){const Ne=pe.charCodeAt(je);if(K(Ne)&&je+1<Pe){const Ue=pe.charCodeAt(je+1);if(B(Ue))return Z(Ne,Ue)}return Ne}function M(pe,Pe){const je=pe.charCodeAt(Pe-1);if(B(je)&&Pe>1){const Ne=pe.charCodeAt(Pe-2);if(K(Ne))return Z(Ne,je)}return je}class z{get offset(){return this.e}constructor(Pe,je=0){this.c=Pe,this.d=Pe.length,this.e=je}setOffset(Pe){this.e=Pe}prevCodePoint(){const Pe=M(this.c,this.e);return this.e-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=Y(this.c,this.d,this.e);return this.e+=Pe>=65536?2:1,Pe}eol(){return this.e>=this.d}}e.$Jf=z;class oe{get offset(){return this.c.offset}constructor(Pe,je=0){this.c=new z(Pe,je)}nextGraphemeLength(){const Pe=Be.getInstance(),je=this.c,Ne=je.offset;let Ue=Pe.getGraphemeBreakType(je.nextCodePoint());for(;!je.eol();){const Ve=je.offset,nt=Pe.getGraphemeBreakType(je.nextCodePoint());if(Fe(Ue,nt)){je.setOffset(Ve);break}Ue=nt}return je.offset-Ne}prevGraphemeLength(){const Pe=Be.getInstance(),je=this.c,Ne=je.offset;let Ue=Pe.getGraphemeBreakType(je.prevCodePoint());for(;je.offset>0;){const Ve=je.offset,nt=Pe.getGraphemeBreakType(je.prevCodePoint());if(Fe(nt,Ue)){je.setOffset(Ve);break}Ue=nt}return Ne-je.offset}eol(){return this.c.eol()}}e.$Kf=oe;function se(pe,Pe){return new oe(pe,Pe).nextGraphemeLength()}function _(pe,Pe){return new oe(pe,Pe).prevGraphemeLength()}function H(pe,Pe){Pe>0&&B(pe.charCodeAt(Pe))&&Pe--;const je=Pe+se(pe,Pe);return[je-_(pe,je),je]}function ne(pe){const Pe=new oe(pe);let je=0;for(;!Pe.eol();)je++,Pe.nextGraphemeLength();return je}let le;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(pe){return le||(le=F()),le.test(pe)}const X=/^[\t\n\r\x20-\x7E]*$/;function x(pe){return X.test(pe)}e.$Rf=/[\u2028\u2029]/;function Q(pe){return e.$Rf.test(pe)}function G(pe){return pe>=11904&&pe<=55215||pe>=63744&&pe<=64255||pe>=65281&&pe<=65374}function J(pe){return pe>=127462&&pe<=127487||pe===8986||pe===8987||pe===9200||pe===9203||pe>=9728&&pe<=10175||pe===11088||pe===11093||pe>=127744&&pe<=128591||pe>=128640&&pe<=128764||pe>=128992&&pe<=129008||pe>=129280&&pe<=129535||pe>=129648&&pe<=129782}function T(pe,Pe,je=""){const Ne=pe.trimStart();if(Ne.length<Pe)return Ne;const Ue=/\b/g;let Ve=0;for(;Ue.test(Ne)&&!(Ne.length-Ue.lastIndex<Pe);)Ve=Ue.lastIndex,Ue.lastIndex+=1;return Ve===0?Ne:je+Ne.substring(Ve).trimStart()}const W=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ce(pe){let Pe=0;for(const je of pe.matchAll(W))Pe!==je.index&&(yield{isCode:!1,str:pe.substring(Pe,je.index)}),yield{isCode:!0,str:je[0]},Pe=je.index+je[0].length;Pe!==pe.length&&(yield{isCode:!1,str:pe.substring(Pe)})}function ue(pe){return pe&&(pe=pe.replace(W,"")),pe}const we=/\\\[.*?\\\]/g;function de(pe){return ue(pe).replace(we,"")}e.$Zf="\uFEFF";function ge(pe){return!!(pe&&pe.length>0&&pe.charCodeAt(0)===65279)}function $e(pe){return ge(pe)?pe.substr(1):pe}function Ce(pe,Pe){if(!pe||!Pe||pe.length<Pe.length)return!1;const je=Pe.length,Ne=pe.toLowerCase();let Ue=0,Ve=-1;for(;Ue<je;){const nt=Ne.indexOf(Pe[Ue],Ve+1);if(nt<0)return!1;Ve=nt,Ue++}return!0}function Ae(pe,Pe=!1){return pe?(Pe&&(pe=pe.replace(/\\./g,"")),pe.toLowerCase()!==pe):!1}function he(pe){return pe.charAt(0).toUpperCase()+pe.slice(1)}function De(pe,Pe=1){if(Pe===0)return"";let je=-1;do je=pe.indexOf(`
`,je+1),Pe--;while(Pe>0&&je>=0);return je===-1?pe:(pe[je-1]==="\r"&&je--,pe.substr(0,je))}function ke(pe){return pe=pe%(2*26),pe<26?String.fromCharCode(97+pe):String.fromCharCode(65+pe-26)}function Me(pe){return Be.getInstance().getGraphemeBreakType(pe)}function Fe(pe,Pe){return pe===0?Pe!==5&&Pe!==7:pe===2&&Pe===3?!1:pe===4||pe===2||pe===3||Pe===4||Pe===2||Pe===3?!0:!(pe===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(pe===11||pe===9)&&(Pe===9||Pe===10)||(pe===12||pe===10)&&Pe===10||Pe===5||Pe===13||Pe===7||pe===1||pe===13&&Pe===14||pe===6&&Pe===6)}var He;(function(pe){pe[pe.Other=0]="Other",pe[pe.Prepend=1]="Prepend",pe[pe.CR=2]="CR",pe[pe.LF=3]="LF",pe[pe.Control=4]="Control",pe[pe.Extend=5]="Extend",pe[pe.Regional_Indicator=6]="Regional_Indicator",pe[pe.SpacingMark=7]="SpacingMark",pe[pe.L=8]="L",pe[pe.V=9]="V",pe[pe.T=10]="T",pe[pe.LV=11]="LV",pe[pe.LVT=12]="LVT",pe[pe.ZWJ=13]="ZWJ",pe[pe.Extended_Pictographic=14]="Extended_Pictographic"})(He||(e.GraphemeBreakType=He={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const je=this.d,Ne=je.length/3;let Ue=1;for(;Ue<=Ne;)if(Pe<je[3*Ue])Ue=2*Ue;else if(Pe>je[3*Ue+1])Ue=2*Ue+1;else return je[3*Ue+2];return 0}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ze(pe,Pe){if(pe===0)return 0;const je=_e(pe,Pe);if(je!==void 0)return je;const Ne=new z(Pe,pe);return Ne.prevCodePoint(),Ne.offset}function _e(pe,Pe){const je=new z(Pe,pe);let Ne=je.prevCodePoint();for(;tt(Ne)||Ne===65039||Ne===8419;){if(je.offset===0)return;Ne=je.prevCodePoint()}if(!J(Ne))return;let Ue=je.offset;return Ue>0&&je.prevCodePoint()===8205&&(Ue=je.offset),Ue}function tt(pe){return 127995<=pe&&pe<=127999}var Qe;(function(pe){pe[pe.zwj=8205]="zwj",pe[pe.emojiVariantSelector=65039]="emojiVariantSelector",pe[pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$0f="\xA0";class Je{static{this.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new s.$7e({getCacheKey:JSON.stringify},Pe=>{function je(ot){const ct=new Map;for(let lt=0;lt<ot.length;lt+=2)ct.set(ot[lt],ot[lt+1]);return ct}function Ne(ot,ct){const lt=new Map(ot);for(const[ft,$t]of ct)lt.set(ft,$t);return lt}function Ue(ot,ct){if(!ot)return ct;const lt=new Map;for(const[ft,$t]of ot)ct.has(ft)&&lt.set(ft,$t);return lt}const Ve=this.c.value;let nt=Pe.filter(ot=>!ot.startsWith("_")&&ot in Ve);nt.length===0&&(nt=["_default"]);let Ye;for(const ot of nt){const ct=je(Ve[ot]);Ye=Ue(Ye,ct)}const it=je(Ve._common),at=Ne(it,Ye);return new Je(at)})}static getInstance(Pe){return Je.d.get(Array.from(Pe))}static{this.e=new j.$V(()=>Object.keys(Je.c.value).filter(Pe=>!Pe.startsWith("_")))}static getLocales(){return Je.e.value}constructor(Pe){this.f=Pe}isAmbiguous(Pe){return this.f.has(Pe)}containsAmbiguousCharacter(Pe){for(let je=0;je<Pe.length;je++){const Ne=Pe.codePointAt(je);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Pe){return this.f.get(Pe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Je;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(Pe){return xe.e().has(Pe)}static containsInvisibleCharacter(Pe){for(let je=0;je<Pe.length;je++){const Ne=Pe.codePointAt(je);if(typeof Ne=="number"&&xe.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return xe.e()}}e.$_f=xe}),define(ye[161],Ee([1,0,24,153,17]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=D,e.$Dk=P,e.$Ek=b,e.$Fk=w,e.$Gk=i,e.$Hk=p,e.$Ik=V,e.$Jk=ie,e.$Kk=ae,e.$Lk=te,e.$Mk=U,e.$Ok=G,e.$Pk=W,e.$Qk=ce;function D(...de){return function(ge,$e){for(let Ce=0,Ae=de.length;Ce<Ae;Ce++){const he=de[Ce](ge,$e);if(he)return he}return null}}e.$Bk=S.bind(void 0,!1),e.$Ck=S.bind(void 0,!0);function S(de,ge,$e){if(!$e||$e.length<ge.length)return null;let Ce;return de?Ce=I.$Cf($e,ge):Ce=$e.indexOf(ge)===0,Ce?ge.length>0?[{start:0,end:ge.length}]:[]:null}function P(de,ge){const $e=ge.toLowerCase().indexOf(de.toLowerCase());return $e===-1?null:[{start:$e,end:$e+de.length}]}function b(de,ge){return $(de.toLowerCase(),ge.toLowerCase(),0,0)}function $(de,ge,$e,Ce){if($e===de.length)return[];if(Ce===ge.length)return null;if(de[$e]===ge[Ce]){let Ae=null;return(Ae=$(de,ge,$e+1,Ce+1))?E({start:Ce,end:Ce+1},Ae):null}return $(de,ge,$e,Ce+1)}function y(de){return 97<=de&&de<=122}function w(de){return 65<=de&&de<=90}function v(de){return 48<=de&&de<=57}function m(de){return de===32||de===9||de===10||de===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>l.add(de.charCodeAt(0)));function c(de){return m(de)||l.has(de)}function u(de,ge){return de===ge||c(de)&&c(ge)}const h=new Map;function g(de){if(h.has(de))return h.get(de);let ge;const $e=(0,j.$zk)(de);return $e&&(ge=$e),h.set(de,ge),ge}function d(de){return y(de)||w(de)||v(de)}function E(de,ge){return ge.length===0?ge=[de]:de.end===ge[0].start?ge[0].start=de.start:ge.unshift(de),ge}function f(de,ge){for(let $e=ge;$e<de.length;$e++){const Ce=de.charCodeAt($e);if(w(Ce)||v(Ce)||$e>0&&!d(de.charCodeAt($e-1)))return $e}return de.length}function t(de,ge,$e,Ce){if($e===de.length)return[];if(Ce===ge.length)return null;if(de[$e]!==ge[Ce].toLowerCase())return null;{let Ae=null,he=Ce+1;for(Ae=t(de,ge,$e+1,Ce+1);!Ae&&(he=f(ge,he))<ge.length;)Ae=t(de,ge,$e+1,he),he++;return Ae===null?null:E({start:Ce,end:Ce+1},Ae)}}function o(de){let ge=0,$e=0,Ce=0,Ae=0,he=0;for(let He=0;He<de.length;He++)he=de.charCodeAt(He),w(he)&&ge++,y(he)&&$e++,d(he)&&Ce++,v(he)&&Ae++;const De=ge/de.length,ke=$e/de.length,Me=Ce/de.length,Fe=Ae/de.length;return{upperPercent:De,lowerPercent:ke,alphaPercent:Me,numericPercent:Fe}}function r(de){const{upperPercent:ge,lowerPercent:$e}=de;return $e===0&&ge>.6}function n(de){const{upperPercent:ge,lowerPercent:$e,alphaPercent:Ce,numericPercent:Ae}=de;return $e>.2&&ge<.8&&Ce>.6&&Ae<.2}function a(de){let ge=0,$e=0,Ce=0,Ae=0;for(let he=0;he<de.length;he++)Ce=de.charCodeAt(he),w(Ce)&&ge++,y(Ce)&&$e++,m(Ce)&&Ae++;return(ge===0||$e===0)&&Ae===0?de.length<=30:ge<=5}function i(de,ge){if(!ge||(ge=ge.trim(),ge.length===0)||!a(de))return null;ge.length>60&&(ge=ge.substring(0,60));const $e=o(ge);if(!n($e)){if(!r($e))return null;ge=ge.toLowerCase()}let Ce=null,Ae=0;for(de=de.toLowerCase();Ae<ge.length&&(Ce=t(de,ge,0,Ae))===null;)Ae=f(ge,Ae+1);return Ce}function p(de,ge,$e=!1){if(!ge||ge.length===0)return null;let Ce=null,Ae=0;for(de=de.toLowerCase(),ge=ge.toLowerCase();Ae<ge.length&&(Ce=k(de,ge,0,Ae,$e),Ce===null);)Ae=C(ge,Ae+1);return Ce}function k(de,ge,$e,Ce,Ae){let he=0;if($e===de.length)return[];if(Ce===ge.length)return null;if(!u(de.charCodeAt($e),ge.charCodeAt(Ce))){const Me=g(de.charCodeAt($e));if(!Me)return null;for(let Fe=0;Fe<Me.length;Fe++)if(!u(Me[Fe],ge.charCodeAt(Ce+Fe)))return null;he+=Me.length-1}let De=null,ke=Ce+he+1;if(De=k(de,ge,$e+1,ke,Ae),!Ae)for(;!De&&(ke=C(ge,ke))<ge.length;)De=k(de,ge,$e+1,ke,Ae),ke++;if(!De)return null;if(de.charCodeAt($e)!==ge.charCodeAt(Ce)){const Me=g(de.charCodeAt($e));if(!Me)return De;for(let Fe=0;Fe<Me.length;Fe++)if(Me[Fe]!==ge.charCodeAt(Ce+Fe))return De}return E({start:Ce,end:Ce+he+1},De)}function C(de,ge){for(let $e=ge;$e<de.length;$e++)if(c(de.charCodeAt($e))||$e>0&&c(de.charCodeAt($e-1)))return $e;return de.length}const A=D(e.$Ck,i,P),O=D(e.$Ck,i,b),N=new s.$Dc(1e4);function V(de,ge,$e=!1){if(typeof de!="string"||typeof ge!="string")return null;let Ce=N.get(de);Ce||(Ce=new RegExp(I.$kf(de),"i"),N.set(de,Ce));const Ae=Ce.exec(ge);return Ae?[{start:Ae.index,end:Ae.index+Ae[0].length}]:$e?O(de,ge):A(de,ge)}function ie(de,ge){const $e=G(de,de.toLowerCase(),0,ge,ge.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?te($e):null}function ae(de,ge,$e,Ce,Ae,he){const De=Math.min(13,de.length);for(;$e<De;$e++){const ke=G(de,ge,$e,Ce,Ae,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,he]}function te(de){if(typeof de>"u")return[];const ge=[],$e=de[1];for(let Ce=de.length-1;Ce>1;Ce--){const Ae=de[Ce]+$e,he=ge[ge.length-1];he&&he.end===Ae?he.end=Ae+1:ge.push({start:Ae,end:Ae+1})}return ge}const ee=128;function K(){const de=[],ge=[];for(let $e=0;$e<=ee;$e++)ge[$e]=0;for(let $e=0;$e<=ee;$e++)de.push(ge.slice(0));return de}function B(de){const ge=[];for(let $e=0;$e<=de;$e++)ge[$e]=0;return ge}const Z=B(2*ee),Y=B(2*ee),M=K(),z=K(),oe=K(),se=!1;function _(de,ge,$e,Ce,Ae){function he(ke,Me,Fe=" "){for(;ke.length<Me;)ke=Fe+ke;return ke}let De=` |   |${Ce.split("").map(ke=>he(ke,3)).join("|")}
`;for(let ke=0;ke<=$e;ke++)ke===0?De+=" |":De+=`${ge[ke-1]}|`,De+=de[ke].slice(0,Ae+1).map(Me=>he(Me.toString(),3)).join("|")+`
`;return De}function H(de,ge,$e,Ce){de=de.substr(ge),$e=$e.substr(Ce),console.log(_(z,de,de.length,$e,$e.length)),console.log(_(oe,de,de.length,$e,$e.length)),console.log(_(M,de,de.length,$e,$e.length))}function ne(de,ge){if(ge<0||ge>=de.length)return!1;const $e=de.codePointAt(ge);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$Uf($e)}}function le(de,ge){if(ge<0||ge>=de.length)return!1;switch(de.charCodeAt(ge)){case 32:case 9:return!0;default:return!1}}function F(de,ge,$e){return ge[de]!==$e[de]}function U(de,ge,$e,Ce,Ae,he,De=!1){for(;ge<$e&&Ae<he;)de[ge]===Ce[Ae]&&(De&&(Z[ge]=Ae),ge+=1),Ae+=1;return ge===$e}var X;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(X||(X={}));var x;(function(de){de.Default=[-100,0];function ge($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}de.isDefault=ge})(x||(e.FuzzyScore=x={}));class Q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ge,$e){this.firstMatchCanBeWeak=ge,this.boostFullMatch=$e}}e.$Nk=Q;function G(de,ge,$e,Ce,Ae,he,De=Q.default){const ke=de.length>ee?ee:de.length,Me=Ce.length>ee?ee:Ce.length;if($e>=ke||he>=Me||ke-$e>Me-he||!U(ge,$e,ke,Ae,he,Me,!0))return;J(ke,Me,$e,he,ge,Ae);let Fe=1,He=1,Be=$e,Ge=he;const Ze=[!1];for(Fe=1,Be=$e;Be<ke;Fe++,Be++){const xe=Z[Be],pe=Y[Be],Pe=Be+1<ke?Y[Be+1]:Me;for(He=xe-he+1,Ge=xe;Ge<Pe;He++,Ge++){let je=Number.MIN_SAFE_INTEGER,Ne=!1;Ge<=pe&&(je=T(de,ge,Be,$e,Ce,Ae,Ge,Me,he,M[Fe-1][He-1]===0,Ze));let Ue=0;je!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ue=je+z[Fe-1][He-1]);const Ve=Ge>xe,nt=Ve?z[Fe][He-1]+(M[Fe][He-1]>0?-5:0):0,Ye=Ge>xe+1&&M[Fe][He-1]>0,it=Ye?z[Fe][He-2]+(M[Fe][He-2]>0?-5:0):0;if(Ye&&(!Ve||it>=nt)&&(!Ne||it>=Ue))z[Fe][He]=it,oe[Fe][He]=3,M[Fe][He]=0;else if(Ve&&(!Ne||nt>=Ue))z[Fe][He]=nt,oe[Fe][He]=2,M[Fe][He]=0;else if(Ne)z[Fe][He]=Ue,oe[Fe][He]=1,M[Fe][He]=M[Fe-1][He-1]+1;else throw new Error("not possible")}}if(se&&H(de,$e,Ce,he),!Ze[0]&&!De.firstMatchCanBeWeak)return;Fe--,He--;const _e=[z[Fe][He],he];let tt=0,Qe=0;for(;Fe>=1;){let xe=He;do{const pe=oe[Fe][xe];if(pe===3)xe=xe-2;else if(pe===2)xe=xe-1;else break}while(xe>=1);tt>1&&ge[$e+Fe-1]===Ae[he+He-1]&&!F(xe+he-1,Ce,Ae)&&tt+1>M[Fe][xe]&&(xe=He),xe===He?tt++:tt=1,Qe||(Qe=xe),Fe--,He=xe-1,_e.push(He)}Me-he===ke&&De.boostFullMatch&&(_e[0]+=2);const Je=Qe-ke;return _e[0]-=Je,_e}function J(de,ge,$e,Ce,Ae,he){let De=de-1,ke=ge-1;for(;De>=$e&&ke>=Ce;)Ae[De]===he[ke]&&(Y[De]=ke,De--),ke--}function T(de,ge,$e,Ce,Ae,he,De,ke,Me,Fe,He){if(ge[$e]!==he[De])return Number.MIN_SAFE_INTEGER;let Be=1,Ge=!1;return De===$e-Ce?Be=de[$e]===Ae[De]?7:5:F(De,Ae,he)&&(De===0||!F(De-1,Ae,he))?(Be=de[$e]===Ae[De]?7:5,Ge=!0):ne(he,De)&&(De===0||!ne(he,De-1))?Be=5:(ne(he,De-1)||le(he,De-1))&&(Be=5,Ge=!0),Be>1&&$e===Ce&&(He[0]=!0),Ge||(Ge=F(De,Ae,he)||ne(he,De-1)||le(he,De-1)),$e===Ce?De>Me&&(Be-=Ge?3:5):Fe?Be+=Ge?2:0:Be+=Ge?0:1,De+1===ke&&(Be-=Ge?3:5),Be}function W(de,ge,$e,Ce,Ae,he,De){return ue(de,ge,$e,Ce,Ae,he,!0,De)}function ce(de,ge,$e,Ce,Ae,he,De){return ue(de,ge,$e,Ce,Ae,he,!1,De)}function ue(de,ge,$e,Ce,Ae,he,De,ke){let Me=G(de,ge,$e,Ce,Ae,he,ke);if(Me&&!De)return Me;if(de.length>=3){const Fe=Math.min(7,de.length-1);for(let He=$e+1;He<Fe;He++){const Be=we(de,He);if(Be){const Ge=G(Be,Be.toLowerCase(),$e,Ce,Ae,he,ke);Ge&&(Ge[0]-=3,(!Me||Ge[0]>Me[0])&&(Me=Ge))}}}return Me}function we(de,ge){if(ge+1>=de.length)return;const $e=de[ge],Ce=de[ge+1];if($e!==Ce)return de.slice(0,ge)+Ce+$e+de.slice(ge+2)}}),define(ye[62],Ee([1,0,17]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=j,e.$pj=I,e.$qj=D,e.$rj=P,e.$tj=c;function j(h){return I(h,0)}function I(h,g){switch(typeof h){case"object":return h===null?D(349,g):Array.isArray(h)?b(h,g):$(h,g);case"string":return P(h,g);case"boolean":return S(h,g);case"number":return D(h,g);case"undefined":return D(937,g);default:return D(617,g)}}function D(h,g){return(g<<5)-g+h|0}function S(h,g){return D(h?433:863,g)}function P(h,g){g=D(149417,g);for(let d=0,E=h.length;d<E;d++)g=D(h.charCodeAt(d),g);return g}function b(h,g){return g=D(104579,g),h.reduce((d,E)=>I(E,d),g)}function $(h,g){return g=D(181387,g),Object.keys(h).sort().reduce((d,E)=>(d=P(E,d),I(h[E],d)),g)}class y{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=I(g,this.g),this.g}}e.$sj=y;var w;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function v(h,g,d=32){const E=d-g,f=~((1<<E)-1);return(h<<g|(f&h)>>>E)>>>0}function m(h,g=0,d=h.byteLength,E=0){for(let f=0;f<d;f++)h[g+f]=E}function l(h,g,d="0"){for(;h.length<g;)h=d+h;return h}function c(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((h>>>0).toString(16),g/4)}class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const d=g.length;if(d===0)return;const E=this.p;let f=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=g.charCodeAt(0),r=0);;){let n=o;if(s.$Ff(o))if(r+1<d){const a=g.charCodeAt(r+1);s.$Gf(a)?(r++,n=s.$Hf(o,a)):n=65533}else{t=o;break}else s.$Gf(o)&&(n=65533);if(f=this.w(E,f,n),r++,r<d)o=g.charCodeAt(r);else break}this.r=f,this.u=t}w(g,d,E){return E<128?g[d++]=E:E<2048?(g[d++]=192|(E&1984)>>>6,g[d++]=128|(E&63)>>>0):E<65536?(g[d++]=224|(E&61440)>>>12,g[d++]=128|(E&4032)>>>6,g[d++]=128|(E&63)>>>0):(g[d++]=240|(E&1835008)>>>18,g[d++]=128|(E&258048)>>>12,g[d++]=128|(E&4032)>>>6,g[d++]=128|(E&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=u.g,d=this.q;for(let p=0;p<64;p+=4)g.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)g.setUint32(p,v(g.getUint32(p-12,!1)^g.getUint32(p-32,!1)^g.getUint32(p-56,!1)^g.getUint32(p-64,!1),1),!1);let E=this.h,f=this.l,t=this.m,o=this.n,r=this.o,n,a,i;for(let p=0;p<80;p++)p<20?(n=f&t|~f&o,a=1518500249):p<40?(n=f^t^o,a=1859775393):p<60?(n=f&t|f&o|t&o,a=2400959708):(n=f^t^o,a=3395469782),i=v(E,5)+n+r+a+g.getUint32(p*4,!1)&4294967295,r=o,o=t,t=v(f,30),f=E,E=i;this.h=this.h+E&4294967295,this.l=this.l+f&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$uj=u}),define(ye[63],Ee([1,0,17]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(j||(j={})),function(I){const D="error",S="warning",P="warn",b="info",$="ignore";function y(v){return v?s.$Bf(D,v)?I.Error:s.$Bf(S,v)||s.$Bf(P,v)?I.Warning:s.$Bf(b,v)?I.Info:I.Ignore:I.Ignore}I.fromValue=y;function w(v){switch(v){case I.Error:return D;case I.Warning:return S;case I.Info:return b;default:return $}}I.toString=w}(j||(j={})),e.default=j}),define(ye[162],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ye[64],Ee([1,0,18,17]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class I{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const l=m.charCodeAt(0),c=this.b.charCodeAt(this.c);return l-c}value(){return this.b[this.c]}}e.$Ci=I;class D{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,j.$vf)(m,this.b,0,m.length,this.c,this.d):(0,j.$xf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=D;class S{constructor(m=!0,l=!0){this.f=m,this.g=l}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let l=m.length-1;l>=0;l--,this.c--){const c=this.b.charCodeAt(l);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const l=this.b.charCodeAt(this.e);if(l===47||this.f&&l===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,j.$vf)(m,this.b,0,m.length,this.d,this.e):(0,j.$xf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=S;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class b{constructor(m,l){this.f=m,this.g=l,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,j.$wf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,j.$wf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,j.$uf)(m,this.c.query);if(this.d[this.e]===5)return(0,j.$uf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(y||(y={}));class w{static forUris(m=()=>!1,l=()=>!1){return new w(new b(m,l))}static forPaths(m=!1){return new w(new S(void 0,!m))}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new D)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,l){if(l){const c=l.slice(0);(0,s.$Wb)(c);for(const u of c)this.set(u,m)}else{const c=m.slice(0);(0,s.$Wb)(c);for(const u of c)this.set(u[0],u[1])}}set(m,l){const c=this.b.reset(m);let u;this.c||(this.c=new $,this.c.segment=c.value());const h=[];for(u=this.c;;){const d=c.cmp(u.segment);if(d>0)u.left||(u.left=new $,u.left.segment=c.value()),h.push([-1,u]),u=u.left;else if(d<0)u.right||(u.right=new $,u.right.segment=c.value()),h.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new $,u.mid.segment=c.value()),h.push([0,u]),u=u.mid;else break}const g=u.value;u.value=l,u.key=m;for(let d=h.length-1;d>=0;d--){const E=h[d][1];E.updateHeight();const f=E.balanceFactor();if(f<-1||f>1){const t=h[d][0],o=h[d+1][0];if(t===1&&o===1)h[d][1]=E.rotateLeft();else if(t===-1&&o===-1)h[d][1]=E.rotateRight();else if(t===1&&o===-1)E.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=E.rotateLeft();else if(t===-1&&o===1)E.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=E.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return g}get(m){return this.d(m)?.value}d(m){const l=this.b.reset(m);let c=this.c;for(;c;){const u=l.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(l.hasNext())l.next(),c=c.mid;else break}return c}has(m){const l=this.d(m);return!(l?.value===void 0&&l?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,l){const c=this.b.reset(m),u=[];let h=this.c;for(;h;){const g=c.cmp(h.segment);if(g>0)u.push([-1,h]),h=h.left;else if(g<0)u.push([1,h]),h=h.right;else if(c.hasNext())c.next(),u.push([0,h]),h=h.mid;else break}if(h){if(l?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:d,value:E,segment:f}=g;this.e(g.key,!1),h.key=d,h.value=E,h.segment=f}}else{const g=h.left??h.right;if(u.length>0){const[d,E]=u[u.length-1];switch(d){case-1:E.left=g;break;case 0:E.mid=g;break;case 1:E.right=g;break}}else this.c=g}for(let g=u.length-1;g>=0;g--){const d=u[g][1];d.updateHeight();const E=d.balanceFactor();if(E>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),u[g][1]=d.rotateLeft()):E<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),u[g][1]=d.rotateRight()),g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const l=this.b.reset(m);let c=this.c,u;for(;c;){const h=l.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(l.hasNext())l.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(m){return this.g(m,!1)}g(m,l){const c=this.b.reset(m);let u=this.c;for(;u;){const h=c.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(c.hasNext())c.next(),u=u.mid;else return u.mid?this.h(u.mid):l?u.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[l,c]of this)m(c,l)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const l=[];return this.j(m,l),l[Symbol.iterator]()}j(m,l){m&&(m.left&&this.j(m.left,l),m.value&&l.push([m.key,m.value]),m.mid&&this.j(m.mid,l),m.right&&this.j(m.right,l))}_isBalanced(){const m=l=>{if(!l)return!0;const c=l.balanceFactor();return c<-1||c>1?!1:m(l.left)&&m(l.right)};return m(this.c)}}e.$Gi=w}),define(ye[10],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=s,e.$bg=j,e.$cg=I,e.$dg=D,e.$eg=S,e.$fg=P,e.$gg=b,e.$hg=$,e.$ig=y,e.$jg=w,e.$kg=v,e.$lg=m,e.$mg=l,e.$ng=u,e.$og=h,e.$pg=g,e.$qg=d,e.$rg=E;function s(f){return typeof f=="string"}function j(f){return Array.isArray(f)&&f.every(t=>s(t))}function I(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function D(f){const t=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof t}function S(f){return typeof f=="number"&&!isNaN(f)}function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}function b(f){return f===!0||f===!1}function $(f){return typeof f>"u"}function y(f){return!w(f)}function w(f){return $(f)||f===null}function v(f,t){if(!f)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(f){if(w(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function l(...f){const t=[];for(let o=0;o<f.length;o++){const r=f[o];if(w(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const c=Object.prototype.hasOwnProperty;function u(f){if(!I(f))return!1;for(const t in f)if(c.call(f,t))return!1;return!0}function h(f){return typeof f=="function"}function g(...f){return f.length>0&&f.every(h)}function d(f,t){const o=Math.min(f.length,t.length);for(let r=0;r<o;r++)E(f[r],t[r])}function E(f,t){if(s(t)){if(typeof f!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(f instanceof t)return}catch{}if(!w(f)&&f.constructor===t||t.length===1&&t.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[101],Ee([1,0,10]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=I,e.$Vj=D;const j=Object.create(null);function I(S,P){if((0,s.$ag)(P)){const b=j[P];if(b===void 0)throw new Error(`${S} references an unknown codicon: ${P}`);P=b}return j[S]=P,{id:S}}function D(){return j}}),define(ye[163],Ee([1,0,101]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,s.$Uj)("add",6e4),plus:(0,s.$Uj)("plus",6e4),gistNew:(0,s.$Uj)("gist-new",6e4),repoCreate:(0,s.$Uj)("repo-create",6e4),lightbulb:(0,s.$Uj)("lightbulb",60001),lightBulb:(0,s.$Uj)("light-bulb",60001),repo:(0,s.$Uj)("repo",60002),repoDelete:(0,s.$Uj)("repo-delete",60002),gistFork:(0,s.$Uj)("gist-fork",60003),repoForked:(0,s.$Uj)("repo-forked",60003),gitPullRequest:(0,s.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,s.$Uj)("record-keys",60005),keyboard:(0,s.$Uj)("keyboard",60005),tag:(0,s.$Uj)("tag",60006),gitPullRequestLabel:(0,s.$Uj)("git-pull-request-label",60006),tagAdd:(0,s.$Uj)("tag-add",60006),tagRemove:(0,s.$Uj)("tag-remove",60006),person:(0,s.$Uj)("person",60007),personFollow:(0,s.$Uj)("person-follow",60007),personOutline:(0,s.$Uj)("person-outline",60007),personFilled:(0,s.$Uj)("person-filled",60007),gitBranch:(0,s.$Uj)("git-branch",60008),gitBranchCreate:(0,s.$Uj)("git-branch-create",60008),gitBranchDelete:(0,s.$Uj)("git-branch-delete",60008),sourceControl:(0,s.$Uj)("source-control",60008),mirror:(0,s.$Uj)("mirror",60009),mirrorPublic:(0,s.$Uj)("mirror-public",60009),star:(0,s.$Uj)("star",60010),starAdd:(0,s.$Uj)("star-add",60010),starDelete:(0,s.$Uj)("star-delete",60010),starEmpty:(0,s.$Uj)("star-empty",60010),comment:(0,s.$Uj)("comment",60011),commentAdd:(0,s.$Uj)("comment-add",60011),alert:(0,s.$Uj)("alert",60012),warning:(0,s.$Uj)("warning",60012),search:(0,s.$Uj)("search",60013),searchSave:(0,s.$Uj)("search-save",60013),logOut:(0,s.$Uj)("log-out",60014),signOut:(0,s.$Uj)("sign-out",60014),logIn:(0,s.$Uj)("log-in",60015),signIn:(0,s.$Uj)("sign-in",60015),eye:(0,s.$Uj)("eye",60016),eyeUnwatch:(0,s.$Uj)("eye-unwatch",60016),eyeWatch:(0,s.$Uj)("eye-watch",60016),circleFilled:(0,s.$Uj)("circle-filled",60017),primitiveDot:(0,s.$Uj)("primitive-dot",60017),closeDirty:(0,s.$Uj)("close-dirty",60017),debugBreakpoint:(0,s.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,s.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,s.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,s.$Uj)("primitive-square",60018),edit:(0,s.$Uj)("edit",60019),pencil:(0,s.$Uj)("pencil",60019),info:(0,s.$Uj)("info",60020),issueOpened:(0,s.$Uj)("issue-opened",60020),gistPrivate:(0,s.$Uj)("gist-private",60021),gitForkPrivate:(0,s.$Uj)("git-fork-private",60021),lock:(0,s.$Uj)("lock",60021),mirrorPrivate:(0,s.$Uj)("mirror-private",60021),close:(0,s.$Uj)("close",60022),removeClose:(0,s.$Uj)("remove-close",60022),x:(0,s.$Uj)("x",60022),repoSync:(0,s.$Uj)("repo-sync",60023),sync:(0,s.$Uj)("sync",60023),clone:(0,s.$Uj)("clone",60024),desktopDownload:(0,s.$Uj)("desktop-download",60024),beaker:(0,s.$Uj)("beaker",60025),microscope:(0,s.$Uj)("microscope",60025),vm:(0,s.$Uj)("vm",60026),deviceDesktop:(0,s.$Uj)("device-desktop",60026),file:(0,s.$Uj)("file",60027),fileText:(0,s.$Uj)("file-text",60027),more:(0,s.$Uj)("more",60028),ellipsis:(0,s.$Uj)("ellipsis",60028),kebabHorizontal:(0,s.$Uj)("kebab-horizontal",60028),mailReply:(0,s.$Uj)("mail-reply",60029),reply:(0,s.$Uj)("reply",60029),organization:(0,s.$Uj)("organization",60030),organizationFilled:(0,s.$Uj)("organization-filled",60030),organizationOutline:(0,s.$Uj)("organization-outline",60030),newFile:(0,s.$Uj)("new-file",60031),fileAdd:(0,s.$Uj)("file-add",60031),newFolder:(0,s.$Uj)("new-folder",60032),fileDirectoryCreate:(0,s.$Uj)("file-directory-create",60032),trash:(0,s.$Uj)("trash",60033),trashcan:(0,s.$Uj)("trashcan",60033),history:(0,s.$Uj)("history",60034),clock:(0,s.$Uj)("clock",60034),folder:(0,s.$Uj)("folder",60035),fileDirectory:(0,s.$Uj)("file-directory",60035),symbolFolder:(0,s.$Uj)("symbol-folder",60035),logoGithub:(0,s.$Uj)("logo-github",60036),markGithub:(0,s.$Uj)("mark-github",60036),github:(0,s.$Uj)("github",60036),terminal:(0,s.$Uj)("terminal",60037),console:(0,s.$Uj)("console",60037),repl:(0,s.$Uj)("repl",60037),zap:(0,s.$Uj)("zap",60038),symbolEvent:(0,s.$Uj)("symbol-event",60038),error:(0,s.$Uj)("error",60039),stop:(0,s.$Uj)("stop",60039),variable:(0,s.$Uj)("variable",60040),symbolVariable:(0,s.$Uj)("symbol-variable",60040),array:(0,s.$Uj)("array",60042),symbolArray:(0,s.$Uj)("symbol-array",60042),symbolModule:(0,s.$Uj)("symbol-module",60043),symbolPackage:(0,s.$Uj)("symbol-package",60043),symbolNamespace:(0,s.$Uj)("symbol-namespace",60043),symbolObject:(0,s.$Uj)("symbol-object",60043),symbolMethod:(0,s.$Uj)("symbol-method",60044),symbolFunction:(0,s.$Uj)("symbol-function",60044),symbolConstructor:(0,s.$Uj)("symbol-constructor",60044),symbolBoolean:(0,s.$Uj)("symbol-boolean",60047),symbolNull:(0,s.$Uj)("symbol-null",60047),symbolNumeric:(0,s.$Uj)("symbol-numeric",60048),symbolNumber:(0,s.$Uj)("symbol-number",60048),symbolStructure:(0,s.$Uj)("symbol-structure",60049),symbolStruct:(0,s.$Uj)("symbol-struct",60049),symbolParameter:(0,s.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,s.$Uj)("symbol-type-parameter",60050),symbolKey:(0,s.$Uj)("symbol-key",60051),symbolText:(0,s.$Uj)("symbol-text",60051),symbolReference:(0,s.$Uj)("symbol-reference",60052),goToFile:(0,s.$Uj)("go-to-file",60052),symbolEnum:(0,s.$Uj)("symbol-enum",60053),symbolValue:(0,s.$Uj)("symbol-value",60053),symbolRuler:(0,s.$Uj)("symbol-ruler",60054),symbolUnit:(0,s.$Uj)("symbol-unit",60054),activateBreakpoints:(0,s.$Uj)("activate-breakpoints",60055),archive:(0,s.$Uj)("archive",60056),arrowBoth:(0,s.$Uj)("arrow-both",60057),arrowDown:(0,s.$Uj)("arrow-down",60058),arrowLeft:(0,s.$Uj)("arrow-left",60059),arrowRight:(0,s.$Uj)("arrow-right",60060),arrowSmallDown:(0,s.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,s.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,s.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,s.$Uj)("arrow-small-up",60064),arrowUp:(0,s.$Uj)("arrow-up",60065),bell:(0,s.$Uj)("bell",60066),bold:(0,s.$Uj)("bold",60067),book:(0,s.$Uj)("book",60068),bookmark:(0,s.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.$Uj)("briefcase",60076),broadcast:(0,s.$Uj)("broadcast",60077),browser:(0,s.$Uj)("browser",60078),bug:(0,s.$Uj)("bug",60079),calendar:(0,s.$Uj)("calendar",60080),caseSensitive:(0,s.$Uj)("case-sensitive",60081),check:(0,s.$Uj)("check",60082),checklist:(0,s.$Uj)("checklist",60083),chevronDown:(0,s.$Uj)("chevron-down",60084),chevronLeft:(0,s.$Uj)("chevron-left",60085),chevronRight:(0,s.$Uj)("chevron-right",60086),chevronUp:(0,s.$Uj)("chevron-up",60087),chromeClose:(0,s.$Uj)("chrome-close",60088),chromeMaximize:(0,s.$Uj)("chrome-maximize",60089),chromeMinimize:(0,s.$Uj)("chrome-minimize",60090),chromeRestore:(0,s.$Uj)("chrome-restore",60091),circleOutline:(0,s.$Uj)("circle-outline",60092),circle:(0,s.$Uj)("circle",60092),debugBreakpointUnverified:(0,s.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,s.$Uj)("circle-slash",60093),circuitBoard:(0,s.$Uj)("circuit-board",60094),clearAll:(0,s.$Uj)("clear-all",60095),clippy:(0,s.$Uj)("clippy",60096),closeAll:(0,s.$Uj)("close-all",60097),cloudDownload:(0,s.$Uj)("cloud-download",60098),cloudUpload:(0,s.$Uj)("cloud-upload",60099),code:(0,s.$Uj)("code",60100),collapseAll:(0,s.$Uj)("collapse-all",60101),colorMode:(0,s.$Uj)("color-mode",60102),commentDiscussion:(0,s.$Uj)("comment-discussion",60103),creditCard:(0,s.$Uj)("credit-card",60105),dash:(0,s.$Uj)("dash",60108),dashboard:(0,s.$Uj)("dashboard",60109),database:(0,s.$Uj)("database",60110),debugContinue:(0,s.$Uj)("debug-continue",60111),debugDisconnect:(0,s.$Uj)("debug-disconnect",60112),debugPause:(0,s.$Uj)("debug-pause",60113),debugRestart:(0,s.$Uj)("debug-restart",60114),debugStart:(0,s.$Uj)("debug-start",60115),debugStepInto:(0,s.$Uj)("debug-step-into",60116),debugStepOut:(0,s.$Uj)("debug-step-out",60117),debugStepOver:(0,s.$Uj)("debug-step-over",60118),debugStop:(0,s.$Uj)("debug-stop",60119),debug:(0,s.$Uj)("debug",60120),deviceCameraVideo:(0,s.$Uj)("device-camera-video",60121),deviceCamera:(0,s.$Uj)("device-camera",60122),deviceMobile:(0,s.$Uj)("device-mobile",60123),diffAdded:(0,s.$Uj)("diff-added",60124),diffIgnored:(0,s.$Uj)("diff-ignored",60125),diffModified:(0,s.$Uj)("diff-modified",60126),diffRemoved:(0,s.$Uj)("diff-removed",60127),diffRenamed:(0,s.$Uj)("diff-renamed",60128),diff:(0,s.$Uj)("diff",60129),diffSidebyside:(0,s.$Uj)("diff-sidebyside",60129),discard:(0,s.$Uj)("discard",60130),editorLayout:(0,s.$Uj)("editor-layout",60131),emptyWindow:(0,s.$Uj)("empty-window",60132),exclude:(0,s.$Uj)("exclude",60133),extensions:(0,s.$Uj)("extensions",60134),eyeClosed:(0,s.$Uj)("eye-closed",60135),fileBinary:(0,s.$Uj)("file-binary",60136),fileCode:(0,s.$Uj)("file-code",60137),fileMedia:(0,s.$Uj)("file-media",60138),filePdf:(0,s.$Uj)("file-pdf",60139),fileSubmodule:(0,s.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,s.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,s.$Uj)("file-symlink-file",60142),fileZip:(0,s.$Uj)("file-zip",60143),files:(0,s.$Uj)("files",60144),filter:(0,s.$Uj)("filter",60145),flame:(0,s.$Uj)("flame",60146),foldDown:(0,s.$Uj)("fold-down",60147),foldUp:(0,s.$Uj)("fold-up",60148),fold:(0,s.$Uj)("fold",60149),folderActive:(0,s.$Uj)("folder-active",60150),folderOpened:(0,s.$Uj)("folder-opened",60151),gear:(0,s.$Uj)("gear",60152),gift:(0,s.$Uj)("gift",60153),gistSecret:(0,s.$Uj)("gist-secret",60154),gist:(0,s.$Uj)("gist",60155),gitCommit:(0,s.$Uj)("git-commit",60156),gitCompare:(0,s.$Uj)("git-compare",60157),compareChanges:(0,s.$Uj)("compare-changes",60157),gitMerge:(0,s.$Uj)("git-merge",60158),githubAction:(0,s.$Uj)("github-action",60159),githubAlt:(0,s.$Uj)("github-alt",60160),globe:(0,s.$Uj)("globe",60161),grabber:(0,s.$Uj)("grabber",60162),graph:(0,s.$Uj)("graph",60163),gripper:(0,s.$Uj)("gripper",60164),heart:(0,s.$Uj)("heart",60165),home:(0,s.$Uj)("home",60166),horizontalRule:(0,s.$Uj)("horizontal-rule",60167),hubot:(0,s.$Uj)("hubot",60168),inbox:(0,s.$Uj)("inbox",60169),issueReopened:(0,s.$Uj)("issue-reopened",60171),issues:(0,s.$Uj)("issues",60172),italic:(0,s.$Uj)("italic",60173),jersey:(0,s.$Uj)("jersey",60174),json:(0,s.$Uj)("json",60175),kebabVertical:(0,s.$Uj)("kebab-vertical",60176),key:(0,s.$Uj)("key",60177),law:(0,s.$Uj)("law",60178),lightbulbAutofix:(0,s.$Uj)("lightbulb-autofix",60179),linkExternal:(0,s.$Uj)("link-external",60180),link:(0,s.$Uj)("link",60181),listOrdered:(0,s.$Uj)("list-ordered",60182),listUnordered:(0,s.$Uj)("list-unordered",60183),liveShare:(0,s.$Uj)("live-share",60184),loading:(0,s.$Uj)("loading",60185),location:(0,s.$Uj)("location",60186),mailRead:(0,s.$Uj)("mail-read",60187),mail:(0,s.$Uj)("mail",60188),markdown:(0,s.$Uj)("markdown",60189),megaphone:(0,s.$Uj)("megaphone",60190),mention:(0,s.$Uj)("mention",60191),milestone:(0,s.$Uj)("milestone",60192),gitPullRequestMilestone:(0,s.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,s.$Uj)("mortar-board",60193),move:(0,s.$Uj)("move",60194),multipleWindows:(0,s.$Uj)("multiple-windows",60195),mute:(0,s.$Uj)("mute",60196),noNewline:(0,s.$Uj)("no-newline",60197),note:(0,s.$Uj)("note",60198),octoface:(0,s.$Uj)("octoface",60199),openPreview:(0,s.$Uj)("open-preview",60200),package:(0,s.$Uj)("package",60201),paintcan:(0,s.$Uj)("paintcan",60202),pin:(0,s.$Uj)("pin",60203),play:(0,s.$Uj)("play",60204),run:(0,s.$Uj)("run",60204),plug:(0,s.$Uj)("plug",60205),preserveCase:(0,s.$Uj)("preserve-case",60206),preview:(0,s.$Uj)("preview",60207),project:(0,s.$Uj)("project",60208),pulse:(0,s.$Uj)("pulse",60209),question:(0,s.$Uj)("question",60210),quote:(0,s.$Uj)("quote",60211),radioTower:(0,s.$Uj)("radio-tower",60212),reactions:(0,s.$Uj)("reactions",60213),references:(0,s.$Uj)("references",60214),refresh:(0,s.$Uj)("refresh",60215),regex:(0,s.$Uj)("regex",60216),remoteExplorer:(0,s.$Uj)("remote-explorer",60217),remote:(0,s.$Uj)("remote",60218),remove:(0,s.$Uj)("remove",60219),replaceAll:(0,s.$Uj)("replace-all",60220),replace:(0,s.$Uj)("replace",60221),repoClone:(0,s.$Uj)("repo-clone",60222),repoForcePush:(0,s.$Uj)("repo-force-push",60223),repoPull:(0,s.$Uj)("repo-pull",60224),repoPush:(0,s.$Uj)("repo-push",60225),report:(0,s.$Uj)("report",60226),requestChanges:(0,s.$Uj)("request-changes",60227),rocket:(0,s.$Uj)("rocket",60228),rootFolderOpened:(0,s.$Uj)("root-folder-opened",60229),rootFolder:(0,s.$Uj)("root-folder",60230),rss:(0,s.$Uj)("rss",60231),ruby:(0,s.$Uj)("ruby",60232),saveAll:(0,s.$Uj)("save-all",60233),saveAs:(0,s.$Uj)("save-as",60234),save:(0,s.$Uj)("save",60235),screenFull:(0,s.$Uj)("screen-full",60236),screenNormal:(0,s.$Uj)("screen-normal",60237),searchStop:(0,s.$Uj)("search-stop",60238),server:(0,s.$Uj)("server",60240),settingsGear:(0,s.$Uj)("settings-gear",60241),settings:(0,s.$Uj)("settings",60242),shield:(0,s.$Uj)("shield",60243),smiley:(0,s.$Uj)("smiley",60244),sortPrecedence:(0,s.$Uj)("sort-precedence",60245),splitHorizontal:(0,s.$Uj)("split-horizontal",60246),splitVertical:(0,s.$Uj)("split-vertical",60247),squirrel:(0,s.$Uj)("squirrel",60248),starFull:(0,s.$Uj)("star-full",60249),starHalf:(0,s.$Uj)("star-half",60250),symbolClass:(0,s.$Uj)("symbol-class",60251),symbolColor:(0,s.$Uj)("symbol-color",60252),symbolConstant:(0,s.$Uj)("symbol-constant",60253),symbolEnumMember:(0,s.$Uj)("symbol-enum-member",60254),symbolField:(0,s.$Uj)("symbol-field",60255),symbolFile:(0,s.$Uj)("symbol-file",60256),symbolInterface:(0,s.$Uj)("symbol-interface",60257),symbolKeyword:(0,s.$Uj)("symbol-keyword",60258),symbolMisc:(0,s.$Uj)("symbol-misc",60259),symbolOperator:(0,s.$Uj)("symbol-operator",60260),symbolProperty:(0,s.$Uj)("symbol-property",60261),wrench:(0,s.$Uj)("wrench",60261),wrenchSubaction:(0,s.$Uj)("wrench-subaction",60261),symbolSnippet:(0,s.$Uj)("symbol-snippet",60262),tasklist:(0,s.$Uj)("tasklist",60263),telescope:(0,s.$Uj)("telescope",60264),textSize:(0,s.$Uj)("text-size",60265),threeBars:(0,s.$Uj)("three-bars",60266),thumbsdown:(0,s.$Uj)("thumbsdown",60267),thumbsup:(0,s.$Uj)("thumbsup",60268),tools:(0,s.$Uj)("tools",60269),triangleDown:(0,s.$Uj)("triangle-down",60270),triangleLeft:(0,s.$Uj)("triangle-left",60271),triangleRight:(0,s.$Uj)("triangle-right",60272),triangleUp:(0,s.$Uj)("triangle-up",60273),twitter:(0,s.$Uj)("twitter",60274),unfold:(0,s.$Uj)("unfold",60275),unlock:(0,s.$Uj)("unlock",60276),unmute:(0,s.$Uj)("unmute",60277),unverified:(0,s.$Uj)("unverified",60278),verified:(0,s.$Uj)("verified",60279),versions:(0,s.$Uj)("versions",60280),vmActive:(0,s.$Uj)("vm-active",60281),vmOutline:(0,s.$Uj)("vm-outline",60282),vmRunning:(0,s.$Uj)("vm-running",60283),watch:(0,s.$Uj)("watch",60284),whitespace:(0,s.$Uj)("whitespace",60285),wholeWord:(0,s.$Uj)("whole-word",60286),window:(0,s.$Uj)("window",60287),wordWrap:(0,s.$Uj)("word-wrap",60288),zoomIn:(0,s.$Uj)("zoom-in",60289),zoomOut:(0,s.$Uj)("zoom-out",60290),listFilter:(0,s.$Uj)("list-filter",60291),listFlat:(0,s.$Uj)("list-flat",60292),listSelection:(0,s.$Uj)("list-selection",60293),selection:(0,s.$Uj)("selection",60293),listTree:(0,s.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,s.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,s.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,s.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,s.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,s.$Uj)("symbol-string",60301),debugReverseContinue:(0,s.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,s.$Uj)("debug-step-back",60303),debugRestartFrame:(0,s.$Uj)("debug-restart-frame",60304),debugAlt:(0,s.$Uj)("debug-alt",60305),callIncoming:(0,s.$Uj)("call-incoming",60306),callOutgoing:(0,s.$Uj)("call-outgoing",60307),menu:(0,s.$Uj)("menu",60308),expandAll:(0,s.$Uj)("expand-all",60309),feedback:(0,s.$Uj)("feedback",60310),gitPullRequestReviewer:(0,s.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,s.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,s.$Uj)("ungroup-by-ref-type",60312),account:(0,s.$Uj)("account",60313),gitPullRequestAssignee:(0,s.$Uj)("git-pull-request-assignee",60313),bellDot:(0,s.$Uj)("bell-dot",60314),debugConsole:(0,s.$Uj)("debug-console",60315),library:(0,s.$Uj)("library",60316),output:(0,s.$Uj)("output",60317),runAll:(0,s.$Uj)("run-all",60318),syncIgnored:(0,s.$Uj)("sync-ignored",60319),pinned:(0,s.$Uj)("pinned",60320),githubInverted:(0,s.$Uj)("github-inverted",60321),serverProcess:(0,s.$Uj)("server-process",60322),serverEnvironment:(0,s.$Uj)("server-environment",60323),pass:(0,s.$Uj)("pass",60324),issueClosed:(0,s.$Uj)("issue-closed",60324),stopCircle:(0,s.$Uj)("stop-circle",60325),playCircle:(0,s.$Uj)("play-circle",60326),record:(0,s.$Uj)("record",60327),debugAltSmall:(0,s.$Uj)("debug-alt-small",60328),vmConnect:(0,s.$Uj)("vm-connect",60329),cloud:(0,s.$Uj)("cloud",60330),merge:(0,s.$Uj)("merge",60331),export:(0,s.$Uj)("export",60332),graphLeft:(0,s.$Uj)("graph-left",60333),magnet:(0,s.$Uj)("magnet",60334),notebook:(0,s.$Uj)("notebook",60335),redo:(0,s.$Uj)("redo",60336),checkAll:(0,s.$Uj)("check-all",60337),pinnedDirty:(0,s.$Uj)("pinned-dirty",60338),passFilled:(0,s.$Uj)("pass-filled",60339),circleLargeFilled:(0,s.$Uj)("circle-large-filled",60340),circleLarge:(0,s.$Uj)("circle-large",60341),circleLargeOutline:(0,s.$Uj)("circle-large-outline",60341),combine:(0,s.$Uj)("combine",60342),gather:(0,s.$Uj)("gather",60342),table:(0,s.$Uj)("table",60343),variableGroup:(0,s.$Uj)("variable-group",60344),typeHierarchy:(0,s.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,s.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.$Uj)("git-pull-request-create",60348),runAbove:(0,s.$Uj)("run-above",60349),runBelow:(0,s.$Uj)("run-below",60350),notebookTemplate:(0,s.$Uj)("notebook-template",60351),debugRerun:(0,s.$Uj)("debug-rerun",60352),workspaceTrusted:(0,s.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,s.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,s.$Uj)("workspace-unknown",60355),terminalCmd:(0,s.$Uj)("terminal-cmd",60356),terminalDebian:(0,s.$Uj)("terminal-debian",60357),terminalLinux:(0,s.$Uj)("terminal-linux",60358),terminalPowershell:(0,s.$Uj)("terminal-powershell",60359),terminalTmux:(0,s.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,s.$Uj)("terminal-ubuntu",60361),terminalBash:(0,s.$Uj)("terminal-bash",60362),arrowSwap:(0,s.$Uj)("arrow-swap",60363),copy:(0,s.$Uj)("copy",60364),personAdd:(0,s.$Uj)("person-add",60365),filterFilled:(0,s.$Uj)("filter-filled",60366),wand:(0,s.$Uj)("wand",60367),debugLineByLine:(0,s.$Uj)("debug-line-by-line",60368),inspect:(0,s.$Uj)("inspect",60369),layers:(0,s.$Uj)("layers",60370),layersDot:(0,s.$Uj)("layers-dot",60371),layersActive:(0,s.$Uj)("layers-active",60372),compass:(0,s.$Uj)("compass",60373),compassDot:(0,s.$Uj)("compass-dot",60374),compassActive:(0,s.$Uj)("compass-active",60375),azure:(0,s.$Uj)("azure",60376),issueDraft:(0,s.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,s.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.$Uj)("git-pull-request-draft",60379),debugAll:(0,s.$Uj)("debug-all",60380),debugCoverage:(0,s.$Uj)("debug-coverage",60381),runErrors:(0,s.$Uj)("run-errors",60382),folderLibrary:(0,s.$Uj)("folder-library",60383),debugContinueSmall:(0,s.$Uj)("debug-continue-small",60384),beakerStop:(0,s.$Uj)("beaker-stop",60385),graphLine:(0,s.$Uj)("graph-line",60386),graphScatter:(0,s.$Uj)("graph-scatter",60387),pieChart:(0,s.$Uj)("pie-chart",60388),bracket:(0,s.$Uj)("bracket",60175),bracketDot:(0,s.$Uj)("bracket-dot",60389),bracketError:(0,s.$Uj)("bracket-error",60390),lockSmall:(0,s.$Uj)("lock-small",60391),azureDevops:(0,s.$Uj)("azure-devops",60392),verifiedFilled:(0,s.$Uj)("verified-filled",60393),newline:(0,s.$Uj)("newline",60394),layout:(0,s.$Uj)("layout",60395),layoutActivitybarLeft:(0,s.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,s.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,s.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,s.$Uj)("layout-panel-right",60401),layoutPanel:(0,s.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,s.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,s.$Uj)("layout-statusbar",60405),layoutMenubar:(0,s.$Uj)("layout-menubar",60406),layoutCentered:(0,s.$Uj)("layout-centered",60407),target:(0,s.$Uj)("target",60408),indent:(0,s.$Uj)("indent",60409),recordSmall:(0,s.$Uj)("record-small",60410),errorSmall:(0,s.$Uj)("error-small",60411),terminalDecorationError:(0,s.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,s.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,s.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,s.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,s.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.$Uj)("layout-sidebar-left-off",60418),blank:(0,s.$Uj)("blank",60419),heartFilled:(0,s.$Uj)("heart-filled",60420),map:(0,s.$Uj)("map",60421),mapHorizontal:(0,s.$Uj)("map-horizontal",60421),foldHorizontal:(0,s.$Uj)("fold-horizontal",60421),mapFilled:(0,s.$Uj)("map-filled",60422),mapHorizontalFilled:(0,s.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,s.$Uj)("circle-small",60423),bellSlash:(0,s.$Uj)("bell-slash",60424),bellSlashDot:(0,s.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,s.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.$Uj)("search-fuzzy",60429),commentDraft:(0,s.$Uj)("comment-draft",60430),send:(0,s.$Uj)("send",60431),sparkle:(0,s.$Uj)("sparkle",60432),insert:(0,s.$Uj)("insert",60433),mic:(0,s.$Uj)("mic",60434),thumbsdownFilled:(0,s.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,s.$Uj)("thumbsup-filled",60436),coffee:(0,s.$Uj)("coffee",60437),snake:(0,s.$Uj)("snake",60438),game:(0,s.$Uj)("game",60439),vr:(0,s.$Uj)("vr",60440),chip:(0,s.$Uj)("chip",60441),piano:(0,s.$Uj)("piano",60442),music:(0,s.$Uj)("music",60443),micFilled:(0,s.$Uj)("mic-filled",60444),repoFetch:(0,s.$Uj)("repo-fetch",60445),copilot:(0,s.$Uj)("copilot",60446),lightbulbSparkle:(0,s.$Uj)("lightbulb-sparkle",60447),robot:(0,s.$Uj)("robot",60448),sparkleFilled:(0,s.$Uj)("sparkle-filled",60449),diffSingle:(0,s.$Uj)("diff-single",60450),diffMultiple:(0,s.$Uj)("diff-multiple",60451),surroundWith:(0,s.$Uj)("surround-with",60452),share:(0,s.$Uj)("share",60453),gitStash:(0,s.$Uj)("git-stash",60454),gitStashApply:(0,s.$Uj)("git-stash-apply",60455),gitStashPop:(0,s.$Uj)("git-stash-pop",60456),vscode:(0,s.$Uj)("vscode",60457),vscodeInsiders:(0,s.$Uj)("vscode-insiders",60458),codeOss:(0,s.$Uj)("code-oss",60459),runCoverage:(0,s.$Uj)("run-coverage",60460),runAllCoverage:(0,s.$Uj)("run-all-coverage",60461),coverage:(0,s.$Uj)("coverage",60462),githubProject:(0,s.$Uj)("github-project",60463),mapVertical:(0,s.$Uj)("map-vertical",60464),foldVertical:(0,s.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,s.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,s.$Uj)("fold-vertical-filled",60465),goToSearch:(0,s.$Uj)("go-to-search",60466),percentage:(0,s.$Uj)("percentage",60467),sortPercentage:(0,s.$Uj)("sort-percentage",60467),attach:(0,s.$Uj)("attach",60468)}}),define(ye[54],Ee([1,0,101,163]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=I;function I(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,s.$Uj)("dialog-error","error"),dialogWarning:(0,s.$Uj)("dialog-warning","warning"),dialogInfo:(0,s.$Uj)("dialog-info","info"),dialogClose:(0,s.$Uj)("dialog-close","close"),treeItemExpanded:(0,s.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,s.$Uj)("tree-item-loading","loading"),menuSelection:(0,s.$Uj)("menu-selection","check"),menuSubmenu:(0,s.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,s.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,s.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.$Uj)("toolbar-more","more"),quickInputBack:(0,s.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,s.$Uj)("drop-down-button",60084),symbolCustomColor:(0,s.$Uj)("symbol-customcolor",60252),exportIcon:(0,s.$Uj)("export",60332),workspaceUnspecified:(0,s.$Uj)("workspace-unspecified",60355),newLine:(0,s.$Uj)("newline",60394),thumbsDownFilled:(0,s.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.$Uj)("thumbsup-filled",60436),gitFetch:(0,s.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...j.$Wj,...e.$Yj}}),define(ye[21],Ee([1,0,10]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=j,e.$8n=I,e.$9n=S,e.$0n=b,e.$$n=$,e.$_n=y,e.$ao=w,e.$bo=v,e.$co=m,e.$do=l,e.$eo=c,e.$fo=u,e.$go=h;function j(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const d=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([E,f])=>{d[E]=f&&typeof f=="object"?j(f):f}),d}function I(g){if(!g||typeof g!="object")return g;const d=[g];for(;d.length>0;){const E=d.shift();Object.freeze(E);for(const f in E)if(D.call(E,f)){const t=E[f];typeof t=="object"&&!Object.isFrozen(t)&&!(0,s.$dg)(t)&&d.push(t)}}return g}const D=Object.prototype.hasOwnProperty;function S(g,d){return P(g,d,new Set)}function P(g,d,E){if((0,s.$jg)(g))return g;const f=d(g);if(typeof f<"u")return f;if(Array.isArray(g)){const t=[];for(const o of g)t.push(P(o,d,E));return t}if((0,s.$cg)(g)){if(E.has(g))throw new Error("Cannot clone recursive data-structure");E.add(g);const t={};for(const o in g)D.call(g,o)&&(t[o]=P(g[o],d,E));return E.delete(g),t}return g}function b(g,d,E=!0){return(0,s.$cg)(g)?((0,s.$cg)(d)&&Object.keys(d).forEach(f=>{f in g?E&&((0,s.$cg)(g[f])&&(0,s.$cg)(d[f])?b(g[f],d[f],E):g[f]=d[f]):g[f]=d[f]}),g):d}function $(g,d){if(g===d)return!0;if(g==null||d===null||d===void 0||typeof g!=typeof d||typeof g!="object"||Array.isArray(g)!==Array.isArray(d))return!1;let E,f;if(Array.isArray(g)){if(g.length!==d.length)return!1;for(E=0;E<g.length;E++)if(!$(g[E],d[E]))return!1}else{const t=[];for(f in g)t.push(f);t.sort();const o=[];for(f in d)o.push(f);if(o.sort(),!$(t,o))return!1;for(E=0;E<t.length;E++)if(!$(g[t[E]],d[t[E]]))return!1}return!0}function y(g){const d=new Set;return JSON.stringify(g,(E,f)=>{if((0,s.$cg)(f)||Array.isArray(f)){if(d.has(f))return"[Circular]";d.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function w(g,d){const E=Object.create(null);return!g||!d||Object.keys(d).forEach(t=>{const o=g[t],r=d[t];$(o,r)||(E[t]=r)}),E}function v(g,d){const E=d.toLowerCase(),f=Object.keys(g).find(t=>t.toLowerCase()===E);return f?g[f]:g[d]}function m(g,d){const E=Object.create(null);for(const[f,t]of Object.entries(g))d(f,t)&&(E[f]=t);return E}function l(g){let d=[];for(;Object.prototype!==g;)d=d.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return d}function c(g){const d=[];for(const E of l(g))typeof g[E]=="function"&&d.push(E);return d}function u(g,d){const E=t=>function(){const o=Array.prototype.slice.call(arguments,0);return d(t,o)},f={};for(const t of g)f[t]=E(t);return f}function h(g,d){const E={};for(const[f,t]of Object.entries(g))E[f]=d(t,f);return E}}),define(ye[76],Ee([1,0,54]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=I;var j;(function(S){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}S.isThemeColor=P})(j||(e.ThemeColor=j={}));function I(S){return{id:S}}var D;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function b(g){const d=P.exec(g.id);if(!d)return b(s.$Zj.error);const[,E,f]=d,t=["codicon","codicon-"+E];return f&&t.push("codicon-modifier-"+f.substring(1)),t}S.asClassNameArray=b;function $(g){return b(g).join(" ")}S.asClassName=$;function y(g){return"."+b(g).join(".")}S.asCSSSelector=y;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||j.isThemeColor(g.color))}S.isThemeIcon=w;const v=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function m(g){const d=v.exec(g);if(!d)return;const[,E]=d;return{id:E}}S.fromString=m;function l(g){return{id:g}}S.fromId=l;function c(g,d){let E=g.id;const f=E.lastIndexOf("~");return f!==-1&&(E=E.substring(0,f)),d&&(E=`${E}~${d}`),{id:E}}S.modify=c;function u(g){const d=g.id.lastIndexOf("~");if(d!==-1)return g.id.substring(d+1)}S.getModifier=u;function h(g,d){return g.id===d.id&&g.color?.id===d.color?.id}S.isEqual=h})(D||(e.ThemeIcon=D={}))}),define(ye[164],Ee([1,0,161,17,76]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=b,e.$Sk=y,e.$Tk=v,e.$Uk=m,e.$Vk=c,e.$Wk=u;const D="$(",S=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${S.source}`,"g");function b(h){return h.replace(P,(g,d)=>d?g:`\\${g}`)}const $=new RegExp(`\\\\${S.source}`,"g");function y(h){return h.replace($,g=>`\\${g}`)}const w=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function v(h){return h.indexOf(D)===-1?h:h.replace(w,(g,d,E,f)=>E?g:d||f||"")}function m(h){return h?h.replace(/\$\((.*?)\)/g,(g,d)=>` ${d} `).trim():""}const l=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(h){l.lastIndex=0;let g="";const d=[];let E=0;for(;;){const f=l.lastIndex,t=l.exec(h),o=h.substring(f,t?.index);if(o.length>0){g+=o;for(let r=0;r<o.length;r++)d.push(E)}if(!t)break;E+=t[0].length}return{text:g,iconOffsets:d}}function u(h,g,d=!1){const{text:E,iconOffsets:f}=g;if(!f||f.length===0)return(0,s.$Ik)(h,E,d);const t=(0,j.$if)(E," "),o=E.length-t.length,r=(0,s.$Ik)(h,t,d);if(r)for(const n of r){const a=f[n.start+o]+o;n.start+=a,n.end+=a}return r}}),define(ye[22],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=j;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(I){return s.test(I)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),S=[];for(let P=0;P<256;P++)S.push(P.toString(16).padStart(2,"0"));return function(){I(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,$="";return $+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$+="-",$+=S[D[b++]],$+=S[D[b++]],$+="-",$+=S[D[b++]],$+=S[D[b++]],$+="-",$+=S[D[b++]],$+=S[D[b++]],$+="-",$+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$+=S[D[b++]],$}}()}),define(ye[165],Ee([1,0,18,41,22]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$cu=void 0,e.$au=D,e.$bu=S,e.$du=$;function D(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function S(w,v,m){const l={id:(0,I.$Wg)(),name:w,uri:v,data:m};return{asString:async()=>"",asFile:()=>l,value:void 0}}class P{constructor(){this.a=new Map}get size(){let v=0;for(const m of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const m=[...this.a.keys()];return j.Iterable.some(this,([l,c])=>c.asFile())&&m.push("files"),y(b(v),m)}get(v){return this.a.get(this.b(v))?.[0]}append(v,m){const l=this.a.get(v);l?l.push(m):this.a.set(this.b(v),[m])}replace(v,m){this.a.set(this.b(v),[m])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,m]of this.a)for(const l of m)yield[v,l]}b(v){return b(v)}}e.$cu=P;function b(w){return w.toLowerCase()}function $(w,v){return y(b(w),v.map(b))}function y(w,v){if(w==="*/*")return v.length>0;if(v.includes(w))return!0;const m=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[l,c,u]=m;return u==="*"?v.some(h=>h.startsWith(c+"/")):!1}e.$eu=Object.freeze({create:w=>(0,s.$Mb)(w.map(v=>v.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.$eu.split(w).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function fe(e,s,j){function I(m){return new Promise(l=>s.exists(m,l))}function D(m){return new Promise((l,c)=>{const u=new Date;s.utimes(m,u,u,h=>h?c(h):l())})}function S(m){return new Promise((l,c)=>s.mkdir(m,{recursive:!0},u=>u&&u.code!=="EEXIST"?c(u):l(m)))}function P(m){return new Promise((l,c)=>s.rm(m,{recursive:!0,force:!0,maxRetries:3},u=>u?c(u):l()))}function b(m){return new Promise((l,c)=>s.readFile(m,"utf8",(u,h)=>u?c(u):l(h)))}function $(m,l){return new Promise((c,u)=>s.writeFile(m,l,"utf8",h=>h?u(h):c()))}async function y(m){const l=e.join(m,"languagepacks.json");try{return JSON.parse(await b(l))}catch{}}function w(m,l){try{for(;l;){if(m[l])return l;{const c=l.lastIndexOf("-");if(c>0)l=l.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function v(m,l,c,u,h){const g=function(E){return j.mark("code/didGenerateNls"),Promise.resolve({locale:E,osLocale:h,availableLanguages:{}})};if(j.mark("code/willGenerateNls"),u==="pseudo")return Promise.resolve({locale:u,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:u,osLocale:h,availableLanguages:{}});if(u&&(u==="en"||u==="en-us"))return Promise.resolve({locale:u,osLocale:h,availableLanguages:{}});const d=u;try{return m?y(l).then(E=>{if(!E)return g(d);const f=w(E,u);if(!f)return g(d);u=f;const t=E[u];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?g(d):I(o).then(r=>{if(!r)return g(d);const n=t.hash+"."+u,a=e.join(l,"clp",n),i=e.join(a,m),p=e.join(a,"tcf.json"),k=e.join(a,"corrupted.info"),C={locale:d,osLocale:h,availableLanguages:{"*":u},_languagePackId:n,_translationsConfigFile:p,_cacheRoot:a,_resolvedLanguagePackCoreLocation:i,_corruptedFile:k};return I(k).then(A=>{let O;return A?O=P(a):O=Promise.resolve(void 0),O.then(()=>I(i).then(N=>N?(D(i).catch(()=>{}),j.mark("code/didGenerateNls"),C):S(i).then(()=>Promise.all([b(c),b(o)])).then(V=>{const ie=JSON.parse(V[0]),ae=JSON.parse(V[1]).contents,te=Object.keys(ie.bundles),ee=[];for(const K of te){const B=ie.bundles[K],Z=Object.create(null);for(const Y of B){const M=ie.keys[Y],z=ie.messages[Y],oe=ae[Y];let se;if(oe){se=[];for(let _=0;_<M.length;_++){const H=M[_],ne=typeof H=="string"?H:H.key;let le=oe[ne];le===void 0&&(le=z[_]),se.push(le)}}else se=z;Z[Y]=se}ee.push($(e.join(i,K.replace(/\//g,"!")+".nls.json"),JSON.stringify(Z)))}return ee.push($(p,JSON.stringify(t.translations))),Promise.all(ee)}).then(()=>(j.mark("code/didGenerateNls"),C)).catch(V=>(console.error("Generating translation files failed.",V),g(u)))))})})}):g(d)}catch(E){return console.error("Generating translation files failed.",E),g(u)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(ye[166],Ee([77,28,44]),function(e,s,j){return fe(e,s,j)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),s=require("fs"),j=require("../common/performance");module.exports=fe(e,s,j)}else throw new Error("Unknown context")}(),define(ye[167],Ee([1,0,31]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=D;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(S){const P=S.replace(/\-/g,":").toLowerCase();return!j.has(P)}function D(){const S=(0,s.networkInterfaces)();for(const P in S){const b=S[P];if(b){for(const{mac:$}of b)if(I($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ye[168],Ee([1,0,78]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=j,e.$1g=D;function j(P,b,$,y=1){let w=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!w)return w=!0,v(0)},$);I(P,b,y,l=>{if(!w)return w=!0,clearTimeout(m),v(l)})})}function I(P,b,$,y){if(b===0)return y(0);const w=new s.Socket;w.once("connect",()=>(S(w),I(P+$,b-1,$,y))),w.once("data",()=>{}),w.once("error",v=>(S(w),v.code!=="ECONNREFUSED"?I(P+$,b-1,$,y):y(P))),w.connect(P,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(P,b,$,y="127.0.0.1"){let w=!1,v,m=1;const l=s.createServer({pauseOnConnect:!0});function c(u,h){w||(w=!0,l.removeAllListeners(),l.close(),v&&clearTimeout(v),h(u))}return new Promise(u=>{v=setTimeout(()=>{c(0,u)},$),l.on("listening",()=>{c(P,u)}),l.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&m<b?(P++,m++,l.listen(P,y)):c(0,u)}),l.on("close",()=>{c(0,u)}),l.listen(P,y)})}function S(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(b){console.error(b)}}}),function(){function fe(){function e(){return process.uncHostAllowlist}function s(b){const $=new Set;if(Array.isArray(b))for(const y of b)typeof y=="string"&&$.add(y);return Array.from($)}function j(){const b=e();return b?Array.from(b):[]}function I(b){if(process.platform!=="win32")return;const $=e();if($)if(typeof b=="string")$.add(b.toLowerCase());else for(const y of s(b))I(y)}function D(b){if(typeof b!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const w of $){if(b.indexOf(w)!==0)continue;const m=b.indexOf("\\",w.length);if(m===-1)continue;const l=b.substring(w.length,m);if(l){y=l;break}}return y}function S(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:j,addUNCHostToAllowlist:I,getUNCHost:D,disableUNCAccessRestrictions:S,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return fe()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=fe():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ye[79],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0;class s{constructor(I,D){this.lineNumber=I,this.column=D}with(I=this.lineNumber,D=this.column){return I===this.lineNumber&&D===this.column?this:new s(I,D)}delta(I=0,D=0){return this.with(this.lineNumber+I,this.column+D)}equals(I){return s.equals(this,I)}static equals(I,D){return!I&&!D?!0:!!I&&!!D&&I.lineNumber===D.lineNumber&&I.column===D.column}isBefore(I){return s.isBefore(this,I)}static isBefore(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<D.column}isBeforeOrEqual(I){return s.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<=D.column}static compare(I,D){const S=I.lineNumber|0,P=D.lineNumber|0;if(S===P){const b=I.column|0,$=D.column|0;return b-$}return S-P}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new s(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$zt=s}),define(ye[45],Ee([1,0,79]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;class j{constructor(D,S,P,b){D>P||D===P&&S>b?(this.startLineNumber=P,this.startColumn=b,this.endLineNumber=D,this.endColumn=S):(this.startLineNumber=D,this.startColumn=S,this.endLineNumber=P,this.endColumn=b)}isEmpty(){return j.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return j.containsPosition(this,D)}static containsPosition(D,S){return!(S.lineNumber<D.startLineNumber||S.lineNumber>D.endLineNumber||S.lineNumber===D.startLineNumber&&S.column<D.startColumn||S.lineNumber===D.endLineNumber&&S.column>D.endColumn)}static strictContainsPosition(D,S){return!(S.lineNumber<D.startLineNumber||S.lineNumber>D.endLineNumber||S.lineNumber===D.startLineNumber&&S.column<=D.startColumn||S.lineNumber===D.endLineNumber&&S.column>=D.endColumn)}containsRange(D){return j.containsRange(this,D)}static containsRange(D,S){return!(S.startLineNumber<D.startLineNumber||S.endLineNumber<D.startLineNumber||S.startLineNumber>D.endLineNumber||S.endLineNumber>D.endLineNumber||S.startLineNumber===D.startLineNumber&&S.startColumn<D.startColumn||S.endLineNumber===D.endLineNumber&&S.endColumn>D.endColumn)}strictContainsRange(D){return j.strictContainsRange(this,D)}static strictContainsRange(D,S){return!(S.startLineNumber<D.startLineNumber||S.endLineNumber<D.startLineNumber||S.startLineNumber>D.endLineNumber||S.endLineNumber>D.endLineNumber||S.startLineNumber===D.startLineNumber&&S.startColumn<=D.startColumn||S.endLineNumber===D.endLineNumber&&S.endColumn>=D.endColumn)}plusRange(D){return j.plusRange(this,D)}static plusRange(D,S){let P,b,$,y;return S.startLineNumber<D.startLineNumber?(P=S.startLineNumber,b=S.startColumn):S.startLineNumber===D.startLineNumber?(P=S.startLineNumber,b=Math.min(S.startColumn,D.startColumn)):(P=D.startLineNumber,b=D.startColumn),S.endLineNumber>D.endLineNumber?($=S.endLineNumber,y=S.endColumn):S.endLineNumber===D.endLineNumber?($=S.endLineNumber,y=Math.max(S.endColumn,D.endColumn)):($=D.endLineNumber,y=D.endColumn),new j(P,b,$,y)}intersectRanges(D){return j.intersectRanges(this,D)}static intersectRanges(D,S){let P=D.startLineNumber,b=D.startColumn,$=D.endLineNumber,y=D.endColumn;const w=S.startLineNumber,v=S.startColumn,m=S.endLineNumber,l=S.endColumn;return P<w?(P=w,b=v):P===w&&(b=Math.max(b,v)),$>m?($=m,y=l):$===m&&(y=Math.min(y,l)),P>$||P===$&&b>y?null:new j(P,b,$,y)}equalsRange(D){return j.equalsRange(this,D)}static equalsRange(D,S){return!D&&!S?!0:!!D&&!!S&&D.startLineNumber===S.startLineNumber&&D.startColumn===S.startColumn&&D.endLineNumber===S.endLineNumber&&D.endColumn===S.endColumn}getEndPosition(){return j.getEndPosition(this)}static getEndPosition(D){return new s.$zt(D.endLineNumber,D.endColumn)}getStartPosition(){return j.getStartPosition(this)}static getStartPosition(D){return new s.$zt(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,S){return new j(this.startLineNumber,this.startColumn,D,S)}setStartPosition(D,S){return new j(D,S,this.endLineNumber,this.endColumn)}collapseToStart(){return j.collapseToStart(this)}static collapseToStart(D){return new j(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return j.collapseToEnd(this)}static collapseToEnd(D){return new j(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new j(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,S=D){return new j(D.lineNumber,D.column,S.lineNumber,S.column)}static lift(D){return D?new j(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,S){return!(D.endLineNumber<S.startLineNumber||D.endLineNumber===S.startLineNumber&&D.endColumn<S.startColumn||S.endLineNumber<D.startLineNumber||S.endLineNumber===D.startLineNumber&&S.endColumn<D.startColumn)}static areIntersecting(D,S){return!(D.endLineNumber<S.startLineNumber||D.endLineNumber===S.startLineNumber&&D.endColumn<=S.startColumn||S.endLineNumber<D.startLineNumber||S.endLineNumber===D.startLineNumber&&S.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,S){if(D&&S){const $=D.startLineNumber|0,y=S.startLineNumber|0;if($===y){const w=D.startColumn|0,v=S.startColumn|0;if(w===v){const m=D.endLineNumber|0,l=S.endLineNumber|0;if(m===l){const c=D.endColumn|0,u=S.endColumn|0;return c-u}return m-l}return w-v}return $-y}return(D?1:0)-(S?1:0)}static compareRangesUsingEnds(D,S){return D.endLineNumber===S.endLineNumber?D.endColumn===S.endColumn?D.startLineNumber===S.startLineNumber?D.startColumn-S.startColumn:D.startLineNumber-S.startLineNumber:D.endColumn-S.endColumn:D.endLineNumber-S.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.$At=j}),define(ye[169],Ee([1,0,45]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;class j{static insert(D,S){return{range:new s.$At(D.lineNumber,D.column,D.lineNumber,D.column),text:S,forceMoveMarkers:!0}}static delete(D){return{range:D,text:null}}static replace(D,S){return{range:D,text:S}}static replaceMove(D,S){return{range:D,text:S,forceMoveMarkers:!0}}}e.$Bt=j}),define(ye[170],Ee([1,0,6,2]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new s.$he,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,b){return this.a.set(P,b),this.handleChange([P]),(0,j.$Sc)(()=>{this.a.get(P)===b&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,b){this.b.get(P)?.dispose();const $=new D(this,P,b);return this.b.set(P,$),(0,j.$Sc)(()=>{const y=this.b.get(P);!y||y!==$||(this.b.delete(P),y.dispose())})}async getOrCreate(P){const b=this.get(P);if(b)return b;const $=this.b.get(P);return!$||$.isResolved?null:(await $.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const $=this.b.get(P);return!!(!$||$.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ju=I;class D extends j.$Uc{get isResolved(){return this.c}constructor(P,b,$){super(),this.f=P,this.g=b,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[171],Ee([8,9]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(ye[172],Ee([1,0,6,2,171]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=y;class D extends j.$Uc{constructor(v,m="",l="",c=!0,u){super(),this.j=this.B(new s.$he),this.onDidChange=this.j.event,this.z=!0,this.m=v,this.n=m,this.w=l,this.z=c,this.D=u}get id(){return this.m}get label(){return this.n}set label(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.j.fire({label:v}))}get tooltip(){return this.u||""}set tooltip(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.j.fire({tooltip:v}))}get class(){return this.w}set class(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.j.fire({class:v}))}get enabled(){return this.z}set enabled(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.j.fire({enabled:v}))}get checked(){return this.C}set checked(v){this.J(v)}J(v){this.C!==v&&(this.C=v,this.j.fire({checked:v}))}async run(v,m){this.D&&await this.D(v)}}e.$fj=D;class S extends j.$Uc{constructor(){super(...arguments),this.f=this.B(new s.$he),this.onWillRun=this.f.event,this.m=this.B(new s.$he),this.onDidRun=this.m.event}async run(v,m){if(!v.enabled)return;this.f.fire({action:v});let l;try{await this.u(v,m)}catch(c){l=c}this.m.fire({action:v,error:l})}async u(v,m){await v.run(m)}}e.$gj=S;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let m=[];for(const l of v)l.length&&(m.length?m=[...m,new P,...l]:m=l);return m}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=P;class b{get actions(){return this.a}constructor(v,m,l,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=m,this.class=c,this.a=l}async run(){}}e.$ij=b;class $ extends D{static{this.ID="vs.actions.empty"}constructor(){super($.ID,I.localize(0,null),void 0,!1)}}e.$jj=$;function y(w){return{id:w.id,label:w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...v)=>w.run(...v),tooltip:w.label}}}),define(ye[173],Ee([8,9]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(ye[174],Ee([1,0,173]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=$,e.$7m=y,e.$8m=w;const j=60,I=j*60,D=I*24,S=D*7,P=D*30,b=D*365;function $(v,m,l,c){typeof v!="number"&&(v=v.getTime());const u=Math.round((new Date().getTime()-v)/1e3);if(u<-30)return(0,s.localize)(0,null,$(new Date().getTime()+u*1e3,!1));if(!c&&u<30)return(0,s.localize)(1,null);let h;return u<j?(h=u,m?h===1?l?(0,s.localize)(2,null,h):(0,s.localize)(3,null,h):l?(0,s.localize)(4,null,h):(0,s.localize)(5,null,h):h===1?l?(0,s.localize)(6,null,h):(0,s.localize)(7,null,h):l?(0,s.localize)(8,null,h):(0,s.localize)(9,null,h)):u<I?(h=Math.floor(u/j),m?h===1?l?(0,s.localize)(10,null,h):(0,s.localize)(11,null,h):l?(0,s.localize)(12,null,h):(0,s.localize)(13,null,h):h===1?l?(0,s.localize)(14,null,h):(0,s.localize)(15,null,h):l?(0,s.localize)(16,null,h):(0,s.localize)(17,null,h)):u<D?(h=Math.floor(u/I),m?h===1?l?(0,s.localize)(18,null,h):(0,s.localize)(19,null,h):l?(0,s.localize)(20,null,h):(0,s.localize)(21,null,h):h===1?l?(0,s.localize)(22,null,h):(0,s.localize)(23,null,h):l?(0,s.localize)(24,null,h):(0,s.localize)(25,null,h)):u<S?(h=Math.floor(u/D),m?h===1?(0,s.localize)(26,null,h):(0,s.localize)(27,null,h):h===1?(0,s.localize)(28,null,h):(0,s.localize)(29,null,h)):u<P?(h=Math.floor(u/S),m?h===1?l?(0,s.localize)(30,null,h):(0,s.localize)(31,null,h):l?(0,s.localize)(32,null,h):(0,s.localize)(33,null,h):h===1?l?(0,s.localize)(34,null,h):(0,s.localize)(35,null,h):l?(0,s.localize)(36,null,h):(0,s.localize)(37,null,h)):u<b?(h=Math.floor(u/P),m?h===1?l?(0,s.localize)(38,null,h):(0,s.localize)(39,null,h):l?(0,s.localize)(40,null,h):(0,s.localize)(41,null,h):h===1?l?(0,s.localize)(42,null,h):(0,s.localize)(43,null,h):l?(0,s.localize)(44,null,h):(0,s.localize)(45,null,h)):(h=Math.floor(u/b),m?h===1?l?(0,s.localize)(46,null,h):(0,s.localize)(47,null,h):l?(0,s.localize)(48,null,h):(0,s.localize)(49,null,h):h===1?l?(0,s.localize)(50,null,h):(0,s.localize)(51,null,h):l?(0,s.localize)(52,null,h):(0,s.localize)(53,null,h))}function y(v,m){const l=Math.abs(v/1e3);return l<1?m?(0,s.localize)(54,null,v):(0,s.localize)(55,null,v):l<j?m?(0,s.localize)(56,null,Math.round(v)/1e3):(0,s.localize)(57,null,Math.round(v)/1e3):l<I?m?(0,s.localize)(58,null,Math.round(v/(1e3*j))):(0,s.localize)(59,null,Math.round(v/(1e3*j))):l<D?m?(0,s.localize)(60,null,Math.round(v/(1e3*I))):(0,s.localize)(61,null,Math.round(v/(1e3*I))):(0,s.localize)(62,null,Math.round(v/(1e3*D)))}function w(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[175],Ee([8,9]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(ye[39],Ee([1,0,18,10,175]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=b,e.$mj=$,e.$nj=y;function D(w,v){return v&&(w.stack||w.stacktrace)?I.localize(0,null,P(w),S(w.stack)||S(w.stacktrace)):P(w)}function S(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?I.localize(1,null,w.message):w.message||I.localize(2,null)}function b(w=null,v=!1){if(!w)return I.localize(3,null);if(Array.isArray(w)){const m=s.$Hb(w),l=b(m[0],v);return m.length>1?I.localize(4,null,l,m.length):l}if(j.$ag(w))return w;if(w.detail){const m=w.detail;if(m.error)return D(m.error,v);if(m.exception)return D(m.exception,v)}return w.stack?D(w,v):w.message?w.message:I.localize(5,null)}function $(w){const v=w;return v instanceof Error&&Array.isArray(v.actions)}function y(w,v){let m;return typeof w=="string"?m=new Error(w):m=w,m.actions=v,m}}),define(ye[176],Ee([8,9]),function(fe,e){return fe.create("vs/base/common/jsonErrorMessages",e)}),define(ye[177],Ee([1,0,176]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=j;function j(I){switch(I){case 1:return(0,s.localize)(0,null);case 2:return(0,s.localize)(1,null);case 3:return(0,s.localize)(2,null);case 4:return(0,s.localize)(3,null);case 5:return(0,s.localize)(4,null);case 6:return(0,s.localize)(5,null);case 7:return(0,s.localize)(6,null);case 8:return(0,s.localize)(7,null);case 9:return(0,s.localize)(8,null);default:return""}}}),define(ye[178],Ee([8,9]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(ye[3],Ee([1,0,178]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=k,e.$J=C,e.$g="en";let j=!1,I=!1,D=!1,S=!1,P=!1,b=!1,$=!1,y=!1,w=!1,v=!1,m,l=e.$g,c=e.$g,u,h;const g=globalThis;let d;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?d=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const E=typeof d?.versions?.electron=="string",f=E&&d?.type==="renderer";if(typeof d=="object"){j=d.platform==="win32",I=d.platform==="darwin",D=d.platform==="linux",S=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,$=E,w=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,l=e.$g;const A=d.env.VSCODE_NLS_CONFIG;if(A)try{const O=JSON.parse(A),N=O.availableLanguages["*"];m=O.locale,c=O.osLocale,l=N||e.$g,u=O._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!f?(h=navigator.userAgent,j=h.indexOf("Windows")>=0,I=h.indexOf("Macintosh")>=0,y=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=h.indexOf("Linux")>=0,v=h?.indexOf("Mobi")>=0,b=!0,m=s.getConfiguredDefaultLocale(s.localize(0,null))||e.$g,l=m,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;I?r=1:j?r=3:D&&(r=2),e.$i=j,e.$j=I,e.$k=D,e.$l=S,e.$m=P,e.$n=$,e.$o=b,e.$p=b&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=y,e.$s=v,e.$t=w,e.$u=r,e.$v=h,e.$w=l;var n;(function(A){function O(){return e.$w}A.value=O;function N(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=N;function V(){return e.$w==="en"}A.isDefault=V})(n||(e.Language=n={})),e.$x=m,e.$y=c,e.$z=u,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const A=[];g.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let V=0,ie=A.length;V<ie;V++){const ae=A[V];if(ae.id===N.data.vscodeScheduleAsyncWork){A.splice(V,1),ae.callback();return}}});let O=0;return N=>{const V=++O;A.push({id:V,callback:N}),g.postMessage({vscodeScheduleAsyncWork:V},"*")}}return A=>setTimeout(A)})();var a;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=I||y?2:j?1:3;let i=!0,p=!1;function k(){if(!p){p=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,i=new Uint16Array(A.buffer)[0]===513}return i}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(A){return parseFloat(A)>=20}}),define(ye[32],Ee([1,0,3]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let j;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const D=I.process;j={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?j={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:j={get platform(){return s.$i?"win32":s.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=j.cwd,e.env=j.env,e.$dc=j.platform,e.$ec=j.arch}),define(ye[7],Ee([1,0,32]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const j=65,I=97,D=90,S=122,P=46,b=47,$=92,y=58,w=63;class v extends Error{constructor(o,r,n){let a;typeof r=="string"&&r.indexOf("not ")===0?(a="must not be",r=r.replace(/^not /,"")):a="must be";const i=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${i} ${a} of type ${r}`;p+=`. Received type ${typeof n}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,o){if(t===null||typeof t!="object")throw new v(o,"Object",t)}function l(t,o){if(typeof t!="string")throw new v(o,"string",t)}const c=s.$dc==="win32";function u(t){return t===b||t===$}function h(t){return t===b}function g(t){return t>=j&&t<=D||t>=I&&t<=S}function d(t,o,r,n){let a="",i=0,p=-1,k=0,C=0;for(let A=0;A<=t.length;++A){if(A<t.length)C=t.charCodeAt(A);else{if(n(C))break;C=b}if(n(C)){if(!(p===A-1||k===1))if(k===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==P||a.charCodeAt(a.length-2)!==P){if(a.length>2){const O=a.lastIndexOf(r);O===-1?(a="",i=0):(a=a.slice(0,O),i=a.length-1-a.lastIndexOf(r)),p=A,k=0;continue}else if(a.length!==0){a="",i=0,p=A,k=0;continue}}o&&(a+=a.length>0?`${r}..`:"..",i=2)}else a.length>0?a+=`${r}${t.slice(p+1,A)}`:a=t.slice(p+1,A),i=A-p-1;p=A,k=0}else C===P&&k!==-1?++k:k=-1}return a}function E(t,o){m(o,"pathObject");const r=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${n}`:`${r}${t}${n}`:n}e.$fc={resolve(...t){let o="",r="",n=!1;for(let a=t.length-1;a>=-1;a--){let i;if(a>=0){if(i=t[a],l(i,"path"),i.length===0)continue}else o.length===0?i=s.cwd():(i=s.env[`=${o}`]||s.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===$)&&(i=`${o}\\`));const p=i.length;let k=0,C="",A=!1;const O=i.charCodeAt(0);if(p===1)u(O)&&(k=1,A=!0);else if(u(O))if(A=!0,u(i.charCodeAt(1))){let N=2,V=N;for(;N<p&&!u(i.charCodeAt(N));)N++;if(N<p&&N!==V){const ie=i.slice(V,N);for(V=N;N<p&&u(i.charCodeAt(N));)N++;if(N<p&&N!==V){for(V=N;N<p&&!u(i.charCodeAt(N));)N++;(N===p||N!==V)&&(C=`\\\\${ie}\\${i.slice(V,N)}`,k=N)}}}else k=1;else g(O)&&i.charCodeAt(1)===y&&(C=i.slice(0,2),k=2,p>2&&u(i.charCodeAt(2))&&(A=!0,k=3));if(C.length>0)if(o.length>0){if(C.toLowerCase()!==o.toLowerCase())continue}else o=C;if(n){if(o.length>0)break}else if(r=`${i.slice(k)}\\${r}`,n=A,A&&o.length>0)break}return r=d(r,!n,"\\",u),n?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){l(t,"path");const o=t.length;if(o===0)return".";let r=0,n,a=!1;const i=t.charCodeAt(0);if(o===1)return h(i)?"\\":t;if(u(i))if(a=!0,u(t.charCodeAt(1))){let k=2,C=k;for(;k<o&&!u(t.charCodeAt(k));)k++;if(k<o&&k!==C){const A=t.slice(C,k);for(C=k;k<o&&u(t.charCodeAt(k));)k++;if(k<o&&k!==C){for(C=k;k<o&&!u(t.charCodeAt(k));)k++;if(k===o)return`\\\\${A}\\${t.slice(C)}\\`;k!==C&&(n=`\\\\${A}\\${t.slice(C,k)}`,r=k)}}}else r=1;else g(i)&&t.charCodeAt(1)===y&&(n=t.slice(0,2),r=2,o>2&&u(t.charCodeAt(2))&&(a=!0,r=3));let p=r<o?d(t.slice(r),!a,"\\",u):"";return p.length===0&&!a&&(p="."),p.length>0&&u(t.charCodeAt(o-1))&&(p+="\\"),n===void 0?a?`\\${p}`:p:a?`${n}\\${p}`:`${n}${p}`},isAbsolute(t){l(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return u(r)||o>2&&g(r)&&t.charCodeAt(1)===y&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let i=0;i<t.length;++i){const p=t[i];l(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let n=!0,a=0;if(typeof r=="string"&&u(r.charCodeAt(0))){++a;const i=r.length;i>1&&u(r.charCodeAt(1))&&(++a,i>2&&(u(r.charCodeAt(2))?++a:n=!1))}if(n){for(;a<o.length&&u(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.$fc.normalize(o)},relative(t,o){if(l(t,"from"),l(o,"to"),t===o)return"";const r=e.$fc.resolve(t),n=e.$fc.resolve(o);if(r===n||(t=r.toLowerCase(),o=n.toLowerCase(),t===o))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===$;)a++;let i=t.length;for(;i-1>a&&t.charCodeAt(i-1)===$;)i--;const p=i-a;let k=0;for(;k<o.length&&o.charCodeAt(k)===$;)k++;let C=o.length;for(;C-1>k&&o.charCodeAt(C-1)===$;)C--;const A=C-k,O=p<A?p:A;let N=-1,V=0;for(;V<O;V++){const ae=t.charCodeAt(a+V);if(ae!==o.charCodeAt(k+V))break;ae===$&&(N=V)}if(V!==O){if(N===-1)return n}else{if(A>O){if(o.charCodeAt(k+V)===$)return n.slice(k+V+1);if(V===2)return n.slice(k+V)}p>O&&(t.charCodeAt(a+V)===$?N=V:V===2&&(N=3)),N===-1&&(N=0)}let ie="";for(V=a+N+1;V<=i;++V)(V===i||t.charCodeAt(V)===$)&&(ie+=ie.length===0?"..":"\\..");return k+=N,ie.length>0?`${ie}${n.slice(k,C)}`:(n.charCodeAt(k)===$&&++k,n.slice(k,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===$){if(o.charCodeAt(1)===$){const r=o.charCodeAt(2);if(r!==w&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===$)return`\\\\?\\${o}`;return t},dirname(t){l(t,"path");const o=t.length;if(o===0)return".";let r=-1,n=0;const a=t.charCodeAt(0);if(o===1)return u(a)?t:".";if(u(a)){if(r=n=1,u(t.charCodeAt(1))){let k=2,C=k;for(;k<o&&!u(t.charCodeAt(k));)k++;if(k<o&&k!==C){for(C=k;k<o&&u(t.charCodeAt(k));)k++;if(k<o&&k!==C){for(C=k;k<o&&!u(t.charCodeAt(k));)k++;if(k===o)return t;k!==C&&(r=n=k+1)}}}}else g(a)&&t.charCodeAt(1)===y&&(r=o>2&&u(t.charCodeAt(2))?3:2,n=r);let i=-1,p=!0;for(let k=o-1;k>=n;--k)if(u(t.charCodeAt(k))){if(!p){i=k;break}}else p=!1;if(i===-1){if(r===-1)return".";i=r}return t.slice(0,i)},basename(t,o){o!==void 0&&l(o,"ext"),l(t,"path");let r=0,n=-1,a=!0,i;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,k=-1;for(i=t.length-1;i>=r;--i){const C=t.charCodeAt(i);if(u(C)){if(!a){r=i+1;break}}else k===-1&&(a=!1,k=i+1),p>=0&&(C===o.charCodeAt(p)?--p===-1&&(n=i):(p=-1,n=k))}return r===n?n=k:n===-1&&(n=t.length),t.slice(r,n)}for(i=t.length-1;i>=r;--i)if(u(t.charCodeAt(i))){if(!a){r=i+1;break}}else n===-1&&(a=!1,n=i+1);return n===-1?"":t.slice(r,n)},extname(t){l(t,"path");let o=0,r=-1,n=0,a=-1,i=!0,p=0;t.length>=2&&t.charCodeAt(1)===y&&g(t.charCodeAt(0))&&(o=n=2);for(let k=t.length-1;k>=o;--k){const C=t.charCodeAt(k);if(u(C)){if(!i){n=k+1;break}continue}a===-1&&(i=!1,a=k+1),C===P?r===-1?r=k:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||a===-1||p===0||p===1&&r===a-1&&r===n+1?"":t.slice(r,a)},format:E.bind(null,"\\"),parse(t){l(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let n=0,a=t.charCodeAt(0);if(r===1)return u(a)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(u(a)){if(n=1,u(t.charCodeAt(1))){let N=2,V=N;for(;N<r&&!u(t.charCodeAt(N));)N++;if(N<r&&N!==V){for(V=N;N<r&&u(t.charCodeAt(N));)N++;if(N<r&&N!==V){for(V=N;N<r&&!u(t.charCodeAt(N));)N++;N===r?n=N:N!==V&&(n=N+1)}}}}else if(g(a)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(n=2,u(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let i=-1,p=n,k=-1,C=!0,A=t.length-1,O=0;for(;A>=n;--A){if(a=t.charCodeAt(A),u(a)){if(!C){p=A+1;break}continue}k===-1&&(C=!1,k=A+1),a===P?i===-1?i=A:O!==1&&(O=1):i!==-1&&(O=-1)}return k!==-1&&(i===-1||O===0||O===1&&i===k-1&&i===p+1?o.base=o.name=t.slice(p,k):(o.name=t.slice(p,i),o.base=t.slice(p,k),o.ext=t.slice(i,k))),p>0&&p!==n?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(c){const t=/\\/g;return()=>{const o=s.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>s.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let n=t.length-1;n>=-1&&!r;n--){const a=n>=0?t[n]:f();l(a,"path"),a.length!==0&&(o=`${a}/${o}`,r=a.charCodeAt(0)===b)}return o=d(o,!r,"/",h),r?`/${o}`:o.length>0?o:"."},normalize(t){if(l(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b,r=t.charCodeAt(t.length-1)===b;return t=d(t,!o,"/",h),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return l(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const n=t[r];l(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(l(t,"from"),l(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,n=t.length,a=n-r,i=1,p=o.length-i,k=a<p?a:p;let C=-1,A=0;for(;A<k;A++){const N=t.charCodeAt(r+A);if(N!==o.charCodeAt(i+A))break;N===b&&(C=A)}if(A===k)if(p>k){if(o.charCodeAt(i+A)===b)return o.slice(i+A+1);if(A===0)return o.slice(i+A)}else a>k&&(t.charCodeAt(r+A)===b?C=A:A===0&&(C=0));let O="";for(A=r+C+1;A<=n;++A)(A===n||t.charCodeAt(A)===b)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(i+C)}`},toNamespacedPath(t){return t},dirname(t){if(l(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b;let r=-1,n=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===b){if(!n){r=a;break}}else n=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&l(o,"ext"),l(t,"path");let r=0,n=-1,a=!0,i;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,k=-1;for(i=t.length-1;i>=0;--i){const C=t.charCodeAt(i);if(C===b){if(!a){r=i+1;break}}else k===-1&&(a=!1,k=i+1),p>=0&&(C===o.charCodeAt(p)?--p===-1&&(n=i):(p=-1,n=k))}return r===n?n=k:n===-1&&(n=t.length),t.slice(r,n)}for(i=t.length-1;i>=0;--i)if(t.charCodeAt(i)===b){if(!a){r=i+1;break}}else n===-1&&(a=!1,n=i+1);return n===-1?"":t.slice(r,n)},extname(t){l(t,"path");let o=-1,r=0,n=-1,a=!0,i=0;for(let p=t.length-1;p>=0;--p){const k=t.charCodeAt(p);if(k===b){if(!a){r=p+1;break}continue}n===-1&&(a=!1,n=p+1),k===P?o===-1?o=p:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||n===-1||i===0||i===1&&o===n-1&&o===r+1?"":t.slice(o,n)},format:E.bind(null,"/"),parse(t){l(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===b;let n;r?(o.root="/",n=1):n=0;let a=-1,i=0,p=-1,k=!0,C=t.length-1,A=0;for(;C>=n;--C){const O=t.charCodeAt(C);if(O===b){if(!k){i=C+1;break}continue}p===-1&&(k=!1,p=C+1),O===P?a===-1?a=C:A!==1&&(A=1):a!==-1&&(A=-1)}if(p!==-1){const O=i===0&&r?1:i;a===-1||A===0||A===1&&a===p-1&&a===i+1?o.base=o.name=t.slice(O,p):(o.name=t.slice(O,a),o.base=t.slice(O,p),o.ext=t.slice(a,p))}return i>0?o.dir=t.slice(0,i-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(ye[35],Ee([1,0,7,3,17,10]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=S,e.$tg=P,e.$ug=b,e.$vg=$,e.$wg=y,e.$xg=l,e.$yg=c,e.$zg=u,e.$Ag=h,e.$Bg=g,e.$Cg=d,e.$Dg=E,e.$Eg=f,e.$Fg=t,e.$Gg=o,e.$Hg=r,e.$Ig=i;function S(p){return p===47||p===92}function P(p){return p.replace(/[\\/]/g,s.$gc.sep)}function b(p){return p.indexOf("/")===-1&&(p=P(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function $(p,k=s.$gc.sep){if(!p)return"";const C=p.length,A=p.charCodeAt(0);if(S(A)){if(S(p.charCodeAt(1))&&!S(p.charCodeAt(2))){let N=3;const V=N;for(;N<C&&!S(p.charCodeAt(N));N++);if(V!==N&&!S(p.charCodeAt(N+1))){for(N+=1;N<C;N++)if(S(p.charCodeAt(N)))return p.slice(0,N+1).replace(/[\\/]/g,k)}}return k}else if(h(A)&&p.charCodeAt(1)===58)return S(p.charCodeAt(2))?p.slice(0,2)+k:p.slice(0,2);let O=p.indexOf("://");if(O!==-1){for(O+=3;O<C;O++)if(S(p.charCodeAt(O)))return p.slice(0,O+1)}return""}function y(p){if(!j.$i||!p||p.length<5)return!1;let k=p.charCodeAt(0);if(k!==92||(k=p.charCodeAt(1),k!==92))return!1;let C=2;const A=C;for(;C<p.length&&(k=p.charCodeAt(C),k!==92);C++);return!(A===C||(k=p.charCodeAt(C+1),isNaN(k)||k===92))}const w=/[\\/:\*\?"<>\|]/g,v=/[/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(p,k=j.$i){const C=k?w:v;return!(!p||p.length===0||/^\s+$/.test(p)||(C.lastIndex=0,C.test(p))||k&&m.test(p)||p==="."||p===".."||k&&p[p.length-1]==="."||k&&p.length!==p.trim().length||p.length>255)}function c(p,k,C){const A=p===k;return!C||A?A:!p||!k?!1:(0,I.$Bf)(p,k)}function u(p,k,C,A=s.sep){if(p===k)return!0;if(!p||!k||k.length>p.length)return!1;if(C){if(!(0,I.$Cf)(p,k))return!1;if(k.length===p.length)return!0;let N=k.length;return k.charAt(k.length-1)===A&&N--,p.charAt(N)===A}return k.charAt(k.length-1)!==A&&(k+=A),p.indexOf(k)===0}function h(p){return p>=65&&p<=90||p>=97&&p<=122}function g(p,k){return j.$i&&p.endsWith(":")&&(p+=s.sep),(0,s.$ic)(p)||(p=(0,s.$jc)(k,p)),p=(0,s.$hc)(p),d(p)}function d(p){return j.$i?(p=(0,I.$jf)(p,s.sep),p.endsWith(":")&&(p+=s.sep)):(p=(0,I.$jf)(p,s.sep),p||(p=s.sep)),p}function E(p){const k=(0,s.$hc)(p);return j.$i?p.length>3?!1:f(k)&&(p.length===2||k.charCodeAt(2)===92):k===s.$gc.sep}function f(p,k=j.$i){return k?h(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function t(p,k=j.$i){return f(p,k)?p[0]:void 0}function o(p,k,C){return k.length>p.length?-1:p===k?0:(C&&(p=p.toLowerCase(),k=k.toLowerCase()),p.indexOf(k))}function r(p){const k=p.split(":");let C,A,O;for(const N of k){const V=Number(N);(0,D.$eg)(V)?A===void 0?A=V:O===void 0&&(O=V):C=C?[C,N].join(":"):N}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(p,k,C=8){let A="";for(let N=0;N<C;N++){let V;N===0&&j.$i&&!k&&(C===3||C===4)?V=a:V=n,A+=V.charAt(Math.floor(Math.random()*V.length))}let O;return k?O=`${k}-${A}`:O=A,p?(0,s.$jc)(p,O):O}}),define(ye[65],Ee([1,0,7]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0,e.$Xs=D,e.$Ys=S,e.$Zs=P,e.$1s=$,e.$Ws=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const j={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(y){const w=(0,s.$oc)(y),v=j[w.toLowerCase()];return v!==void 0?v:S(y)}function S(y){const w=(0,s.$oc)(y);return I[w.toLowerCase()]}function P(y){for(const w in I)if(I[w]===y)return w}const b=/^(.+)\/(.+?)(;.+)?$/;function $(y,w){const v=b.exec(y);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:w?void 0:y}}),define(ye[66],Ee([1,0,3]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=D,e.$rm=S;var j;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(j||(e.Source=j={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function D(P,...b){const $=b.reduce((v,m)=>(v[m]=!0,v),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!$[v]).forEach(v=>{for(let m=0;m<y.length;m++)if(v.search(y[m])!==-1){delete P[v];break}})}function S(P){P&&(delete P.DEBUG,s.$j&&delete P.DYLD_LIBRARY_PATH,s.$k&&delete P.LD_PRELOAD)}}),define(ye[4],Ee([1,0,7,3]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=l,e.$wc=E;const I=/^\w[\w\d+.-]*$/,D=/^\//,S=/^\/\//;function P(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!I.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!D.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(n,a){return!n&&!a?"file":n}function $(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==w&&(a=w+a):a=w;break}return a}const y="",w="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,i,p,k,C,A=!1){typeof a=="object"?(this.scheme=a.scheme||y,this.authority=a.authority||y,this.path=a.path||y,this.query=a.query||y,this.fragment=a.fragment||y):(this.scheme=b(a,A),this.authority=i||y,this.path=$(this.scheme,p||y),this.query=k||y,this.fragment=C||y,P(this,A))}get fsPath(){return E(this,!1)}with(a){if(!a)return this;let{scheme:i,authority:p,path:k,query:C,fragment:A}=a;return i===void 0?i=this.scheme:i===null&&(i=y),p===void 0?p=this.authority:p===null&&(p=y),k===void 0?k=this.path:k===null&&(k=y),C===void 0?C=this.query:C===null&&(C=y),A===void 0?A=this.fragment:A===null&&(A=y),i===this.scheme&&p===this.authority&&k===this.path&&C===this.query&&A===this.fragment?this:new u(i,p,k,C,A)}static parse(a,i=!1){const p=v.exec(a);return p?new u(p[2]||y,r(p[4]||y),r(p[5]||y),r(p[7]||y),r(p[9]||y),i):new u(y,y,y,y,y)}static file(a){let i=y;if(j.$i&&(a=a.replace(/\\/g,w)),a[0]===w&&a[1]===w){const p=a.indexOf(w,2);p===-1?(i=a.substring(2),a=w):(i=a.substring(2,p),a=a.substring(p)||w)}return new u("file",i,a,y,y)}static from(a,i){return new u(a.scheme,a.authority,a.path,a.query,a.fragment,i)}static joinPath(a,...i){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return j.$i&&a.scheme==="file"?p=m.file(s.$fc.join(E(a,!0),...i)).path:p=s.$gc.join(a.path,...i),a.with({path:p})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const i=new u(a);return i._formatted=a.external??null,i._fsPath=a._sep===c?a.fsPath??null:null,i}}else return a}}e.URI=m;function l(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}const c=j.$i?1:void 0;class u extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=c),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(n,a,i){let p,k=-1;for(let C=0;C<n.length;C++){const A=n.charCodeAt(C);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||a&&A===47||i&&A===91||i&&A===93||i&&A===58)k!==-1&&(p+=encodeURIComponent(n.substring(k,C)),k=-1),p!==void 0&&(p+=n.charAt(C));else{p===void 0&&(p=n.substr(0,C));const O=h[A];O!==void 0?(k!==-1&&(p+=encodeURIComponent(n.substring(k,C)),k=-1),p+=O):k===-1&&(k=C)}}return k!==-1&&(p+=encodeURIComponent(n.substring(k))),p!==void 0?p:n}function d(n){let a;for(let i=0;i<n.length;i++){const p=n.charCodeAt(i);p===35||p===63?(a===void 0&&(a=n.substr(0,i)),a+=h[p]):a!==void 0&&(a+=n[i])}return a!==void 0?a:n}function E(n,a){let i;return n.authority&&n.path.length>1&&n.scheme==="file"?i=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?i=n.path.substr(1):i=n.path[1].toLowerCase()+n.path.substr(2):i=n.path,j.$i&&(i=i.replace(/\//g,"\\")),i}function f(n,a){const i=a?d:g;let p="",{scheme:k,authority:C,path:A,query:O,fragment:N}=n;if(k&&(p+=k,p+=":"),(C||k==="file")&&(p+=w,p+=w),C){let V=C.indexOf("@");if(V!==-1){const ie=C.substr(0,V);C=C.substr(V+1),V=ie.lastIndexOf(":"),V===-1?p+=i(ie,!1,!1):(p+=i(ie.substr(0,V),!1,!1),p+=":",p+=i(ie.substr(V+1),!1,!0)),p+="@"}C=C.toLowerCase(),V=C.lastIndexOf(":"),V===-1?p+=i(C,!1,!0):(p+=i(C.substr(0,V),!1,!0),p+=C.substr(V))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const V=A.charCodeAt(1);V>=65&&V<=90&&(A=`/${String.fromCharCode(V+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const V=A.charCodeAt(0);V>=65&&V<=90&&(A=`${String.fromCharCode(V+32)}:${A.substr(2)}`)}p+=i(A,!0,!1)}return O&&(p+="?",p+=i(O,!1,!1)),N&&(p+="#",p+=a?N:g(N,!1,!1)),p}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(o)?n.replace(o,a=>t(a)):n}}),define(ye[179],Ee([1,0,4]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=j,e.$3q=I,e.$4q=D,e.log=P;function j($){const y=$;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function I($){const y=[];let w;try{const v=JSON.parse($.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),w=m.__$stack),y.push(...v)}catch{y.push("Unable to log remote console arguments",$.arguments)}return{args:y,stack:w}}function D($){if(typeof $!="string")return D(I($).stack);const y=$;if(y){const w=S(y),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(v&&v.length===4)return{uri:s.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function S($){if(!$)return $;const y=$.indexOf(`
`);return y===-1?$:$.substring(0,y)}function P($,y){const{args:w,stack:v}=I($),m=typeof w[0]=="string"&&w.length===1;let l=S(v);l&&(l=`(${l.trim()})`);let c=[];if(typeof w[0]=="string"?l&&m?c=[`%c[${y}] %c${w[0]} %c${l}`,b("blue"),b(""),b("grey")]:c=[`%c[${y}] %c${w[0]}`,b("blue"),b(""),...w.slice(1)]:c=[`%c[${y}]%`,b("blue"),...w],l&&!m&&c.push(l),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,c)}function b($){return`color: ${$}`}}),define(ye[46],Ee([1,0,15,4]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=I,e.$9h=D,e.$0h=P;function I(b){return JSON.stringify(b,S)}function D(b){let $=JSON.parse(b);return $=P($),$}function S(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function P(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return j.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof s.$Je||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=P(b[y],$+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=P(b[y],$+1))}return b}}),define(ye[13],Ee([1,0,11,3,17,4,7]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=b,e.$Kg=$,e.$Og=w;var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(P||(e.Schemas=P={}));function b(l,c){return D.URI.isUri(l)?(0,I.$Bf)(l.scheme,c):(0,I.$Cf)(l,c+":")}function $(l,...c){return c.some(u=>b(l,u))}e.$Lg="vscode-tkn",e.$Mg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,u){this.f=w(c,u)}getServerRootPath(){return this.f}get g(){return S.$gc.join(this.f,P.vscodeRemoteResource)}set(c,u,h){this.a[c]=u,this.b[c]=h}setConnectionToken(c,u){this.c[c]=u}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(f){return s.$1(f),c}const u=c.authority;let h=this.a[u];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const g=this.b[u],d=this.c[u];let E=`path=${encodeURIComponent(c.path)}`;return typeof d=="string"&&(E+=`&${e.$Mg}=${encodeURIComponent(d)}`),D.URI.from({scheme:j.$o?this.d:P.vscodeRemoteResource,authority:`${h}:${g}`,path:this.g,query:E})}}e.$Ng=new y;function w(l,c){return S.$gc.join(c??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class v{static{this.a=e.$Tg}asBrowserUri(c){const u=this.b(c,fe);return this.uriToBrowserUri(u)}uriToBrowserUri(c){return c.scheme===P.vscodeRemote?e.$Ng.rewrite(c):c.scheme===P.file&&(j.$m||j.$q===`${P.vscodeFileResource}://${v.a}`)?c.with({scheme:P.vscodeFileResource,authority:c.authority||v.a,query:null,fragment:null}):c}asFileUri(c){const u=this.b(c,fe);return this.uriToFileUri(u)}uriToFileUri(c){return c.scheme===P.vscodeFileResource?c.with({scheme:P.file,authority:c.authority!==v.a?c.authority:null,query:null,fragment:null}):c}b(c,u){return D.URI.isUri(c)?c:D.URI.parse(u.toUrl(c))}}e.$Ug=new v;var m;(function(l){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(c.get("3"));const u="vscode-coi";function h(d){let E;typeof d=="string"?E=new URL(d).searchParams:d instanceof URL?E=d.searchParams:D.URI.isUri(d)&&(E=new URL(d.toString(!0)).searchParams);const f=E?.get(u);if(f)return c.get(f)}l.getHeadersFromQuery=h;function g(d,E,f){if(!globalThis.crossOriginIsolated)return;const t=E&&f?"3":f?"2":"1";d instanceof URLSearchParams?d.set(u,t):d[u]=t}l.addSearchParam=g})(m||(e.COI=m={}))}),define(ye[180],Ee([1,0,97,13,3,4]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=y;class S{constructor(v,m,l){this.id=v,this.dependencies=m,this.callback=l}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,m,l)=>{typeof v!="string"&&(l=m,m=v,v=null),(typeof m!="object"||!Array.isArray(m))&&(l=m,m=null),this.c.push(new S(v,m,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const m=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!m)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(v){return new Promise((m,l)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const u=()=>{c.removeEventListener("load",h),c.removeEventListener("error",g)},h=d=>{u(),m(this.c.pop())},g=d=>{u(),l(d)};c.addEventListener("load",h),c.addEventListener("error",g),this.f&&(v=this.f.createScriptURL(v)),c.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(v){return new Promise((m,l)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),m(this.c.pop())}catch(c){l(c)}})}async j(v){try{const m=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,u=D.URI.parse(v).fsPath,h=m.readFileSync(u).toString(),g=c.wrap(h.replace(/^#!.*/,""));return new l.Script(g).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const b=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function y(w,v,m){if(s.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[w]&&(w=$[w]);const l=`${w}/${v}`;if(b.has(l))return b.get(l);let c;if(/^\w[\w\d+.-]*:\/\//.test(l))c=l;else{const d=`${m&&!I.$o?j.$Rg:j.$Qg}/${l}`;c=j.$Ug.asBrowserUri(d).toString(!0)}const u=P.INSTANCE.load(c);return b.set(l,u),u}else return await new Promise((l,c)=>{fe([w],l,c)})}}),define(ye[19],Ee([1,0,35,13,7,3,17,4]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=b,e.$kh=y,e.$lh=v;function b(m){return(0,P.$wc)(m,!0)}class ${constructor(l){this.a=l}compare(l,c,u=!1){return l===c?0:(0,S.$uf)(this.getComparisonKey(l,u),this.getComparisonKey(c,u))}isEqual(l,c,u=!1){return l===c?!0:!l||!c?!1:this.getComparisonKey(l,u)===this.getComparisonKey(c,u)}getComparisonKey(l,c=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,c,u=!1){if(l.scheme===c.scheme){if(l.scheme===j.Schemas.file)return s.$zg(b(l),b(c),this.a(l))&&l.query===c.query&&(u||l.fragment===c.fragment);if((0,e.$gh)(l.authority,c.authority))return s.$zg(l.path,c.path,this.a(l),"/")&&l.query===c.query&&(u||l.fragment===c.fragment)}return!1}joinPath(l,...c){return P.URI.joinPath(l,...c)}basenameOrAuthority(l){return(0,e.$$g)(l)||l.authority}basename(l){return I.$gc.basename(l.path)}extname(l){return I.$gc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let c;return l.scheme===j.Schemas.file?c=P.URI.file(I.$mc(b(l))).path:(c=I.$gc.dirname(l.path),l.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),c="/")),l.with({path:c})}normalizePath(l){if(!l.path.length)return l;let c;return l.scheme===j.Schemas.file?c=P.URI.file(I.$hc(b(l))).path:c=I.$gc.normalize(l.path),l.with({path:c})}relativePath(l,c){if(l.scheme!==c.scheme||!(0,e.$gh)(l.authority,c.authority))return;if(l.scheme===j.Schemas.file){const g=I.$lc(b(l),b(c));return D.$i?s.$tg(g):g}let u=l.path||"/";const h=c.path||"/";if(this.a(l)){let g=0;for(const d=Math.min(u.length,h.length);g<d&&!(u.charCodeAt(g)!==h.charCodeAt(g)&&u.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);u=h.substr(0,g)+u.substr(g)}return I.$gc.relative(u,h)}resolvePath(l,c){if(l.scheme===j.Schemas.file){const u=P.URI.file(I.$kc(b(l),c));return l.with({authority:u.authority,path:u.path})}return c=s.$ug(c),l.with({path:I.$gc.resolve(l.path,c)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,c){return l===c||l!==void 0&&c!==void 0&&(0,S.$Bf)(l,c)}hasTrailingPathSeparator(l,c=I.sep){if(l.scheme===j.Schemas.file){const u=b(l);return u.length>s.$vg(u).length&&u[u.length-1]===c}else{const u=l.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,c=I.sep){return(0,e.$hh)(l,c)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,c=I.sep){let u=!1;if(l.scheme===j.Schemas.file){const h=b(l);u=h!==void 0&&h.length===s.$vg(h).length&&h[h.length-1]===c}else{c="/";const h=l.path;u=h.length===1&&h.charCodeAt(h.length-1)===47}return!u&&!(0,e.$hh)(l,c)?l.with({path:l.path+"/"}):l}}e.$3g=$,e.$4g=new $(()=>!1),e.$5g=new $(m=>m.scheme===j.Schemas.file?!D.$k:!0),e.$6g=new $(m=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(m,l){const c=[];for(let u=0;u<m.length;u++){const h=l(m[u]);m.some((g,d)=>d===u?!1:(0,e.$8g)(h,l(g)))||c.push(m[u])}return c}var w;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(c){const u=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(d=>{const[E,f]=d.split(":");E&&f&&u.set(E,f)});const g=c.path.substring(0,c.path.indexOf(";"));return g&&u.set(m.META_DATA_MIME,g),u}m.parseMetaData=l})(w||(e.DataUri=w={}));function v(m,l,c){if(l){let u=m.path;return u&&u[0]!==I.$gc.sep&&(u=I.$gc.sep+u),m.with({scheme:c,authority:l,path:u})}return m.with({scheme:c})}}),define(ye[14],Ee([1,0,20,11,6,2,19,3,162,60]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=y,e.$nh=w,e.$oh=v,e.$ph=m,e.$qh=l,e.$rh=c,e.$sh=u,e.$th=h,e.$Bh=i,e.$Ch=p,e.$Dh=k,e.$Eh=C,e.$Fh=A,e.$Uh=z,e.$3h=Q;function y(J){return!!J&&typeof J.then=="function"}function w(J){const T=new s.$se,W=J(T.token),ce=new Promise((ue,we)=>{const de=T.token.onCancellationRequested(()=>{de.dispose(),we(new j.$5)});Promise.resolve(W).then(ge=>{de.dispose(),T.dispose(),ue(ge)},ge=>{de.dispose(),T.dispose(),we(ge)})});return new class{cancel(){T.cancel(),T.dispose()}then(ue,we){return ce.then(ue,we)}catch(ue){return this.then(void 0,ue)}finally(ue){return ce.finally(ue)}}}function v(J,T,W){return new Promise((ce,ue)=>{const we=T.onCancellationRequested(()=>{we.dispose(),ce(W)});J.then(ce,ue).finally(()=>we.dispose())})}function m(J,T){return new Promise((W,ce)=>{const ue=T.onCancellationRequested(()=>{ue.dispose(),ce(new j.$5)});J.then(W,ce).finally(()=>ue.dispose())})}async function l(J){let T=-1;const W=J.map((ce,ue)=>ce.then(we=>(T=ue,we)));try{return await Promise.race(W)}finally{J.forEach((ce,ue)=>{ue!==T&&ce.cancel()})}}function c(J,T,W){let ce;const ue=setTimeout(()=>{ce?.(void 0),W?.()},T);return Promise.race([J.finally(()=>clearTimeout(ue)),new Promise(we=>ce=we)])}function u(J){return new Promise((T,W)=>{const ce=J();y(ce)?ce.then(T,W):T(ce)})}function h(){let J,T;return{promise:new Promise((ce,ue)=>{J=ce,T=ue}),resolve:J,reject:T}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const W=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(W,W).then(ce)})}return new Promise((W,ce)=>{this.b.then(W,ce)})}return this.a=T(),new Promise((W,ce)=>{this.a.then(ue=>{this.a=null,W(ue)},ue=>{this.a=null,ce(ue)})})}dispose(){this.f=!0}}e.$uh=g;class d{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$vh=d;class E{constructor(){this.a=new Map}queue(T,W){const ue=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(T)===ue&&this.a.delete(T)});return this.a.set(T,ue),ue}}e.$wh=E;const f=(J,T)=>{let W=!0;const ce=setTimeout(()=>{W=!1,T()},J);return{isTriggered:()=>W,dispose:()=>{clearTimeout(ce),W=!1}}},t=J=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,J())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class o{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,W=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((ue,we)=>{this.d=ue,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=W===b.$ce?t(ce):f(W,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new j.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=o;class r{constructor(T){this.a=new o(T),this.b=new g}trigger(T,W){return this.a.trigger(()=>this.b.queue(T),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=r;class n{constructor(){this.a=!1,this.b=new Promise((T,W)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=n;class a extends n{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Ah=a;function i(J,T){return T?new Promise((W,ce)=>{const ue=setTimeout(()=>{we.dispose(),W()},J),we=T.onCancellationRequested(()=>{clearTimeout(ue),we.dispose(),ce(new j.$5)})}):w(W=>i(J,W))}function p(J,T=0,W){const ce=setTimeout(()=>{J(),W&&ue.dispose()},T),ue=(0,D.$Sc)(()=>{clearTimeout(ce),W?.deleteAndLeak(ue)});return W?.add(ue),ue}function k(J){const T=[];let W=0;const ce=J.length;function ue(){return W<ce?J[W++]():null}function we(de){de!=null&&T.push(de);const ge=ue();return ge?ge.then(we):Promise.resolve(T)}return Promise.resolve(null).then(we)}function C(J,T=ce=>!!ce,W=null){let ce=0;const ue=J.length,we=()=>{if(ce>=ue)return Promise.resolve(W);const de=J[ce++];return Promise.resolve(de()).then($e=>T($e)?Promise.resolve($e):we())};return we()}function A(J,T=ce=>!!ce,W=null){if(J.length===0)return Promise.resolve(W);let ce=J.length;const ue=()=>{ce=-1;for(const we of J)we.cancel?.()};return new Promise((we,de)=>{for(const ge of J)ge.then($e=>{--ce>=0&&T($e)?(ue(),we($e)):ce===0&&we(W)}).catch($e=>{--ce>=0&&(ue(),de($e))})})}class O{constructor(T){this.a=0,this.b=!1,this.f=T,this.g=[],this.d=0,this.h=new I.$he}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(T){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((W,ce)=>{this.g.push({factory:T,c:W,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const T=this.g.shift();this.d++;const W=T.factory();W.then(T.c,T.e),W.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=O;class N extends O{constructor(){super(1)}}e.$Hh=N;class V{constructor(){this.a=new oe,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$Ih=V;class ie{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new H;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueSize(T,W=S.$4g){const ce=W.getComparisonKey(T);return this.a.get(ce)?.size??0}queueFor(T,W,ce=S.$4g){const ue=ce.getComparisonKey(T);let we=this.a.get(ue);if(!we){we=new N;const de=this.f++,ge=I.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(de,ge),this.a.set(ue,we)}return we.queue(W)}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=ie;class ae{constructor(T,W){this.a=-1,typeof T=="function"&&typeof W=="number"&&this.setIfNotSet(T,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},W)}setIfNotSet(T,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},W))}}e.$Kh=ae;class te{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(T,W,ce=globalThis){this.cancel();const ue=ce.setInterval(()=>{T()},W);this.d=(0,D.$Sc)(()=>{ce.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=te;class ee{constructor(T,W){this.b=-1,this.a=T,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=ee;class K{constructor(T,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=T,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=K;class B extends ee{constructor(T,W){super(T,W),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$Oh=B;class Z extends D.$Uc{constructor(T,W){super(),this.g=T,this.h=W,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of T)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(J,T)=>{(0,P.$B)(()=>{if(W)return;const ce=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$Rh=(J,T,W)=>{const ce=J.requestIdleCallback(T,typeof W=="number"?{timeout:W}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,J.cancelIdleCallback(ce))}}},e.$Qh=J=>(0,e.$Rh)(globalThis,J)}();class Y{constructor(T,W){this.g=!1,this.d=()=>{try{this.j=W()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$Rh)(T,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=Y;class M extends Y{constructor(T){super(globalThis,T)}}e.$Th=M;async function z(J,T,W){let ce;for(let ue=0;ue<W;ue++)try{return await J()}catch(we){ce=we,await i(T)}throw ce}class oe{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,W,ce){return this.a={taskId:T,cancel:()=>ce?.(),promise:W},W.then(()=>this.d(T),()=>this.d(T)),W}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{const{promise:W,resolve:ce,reject:ue}=h();this.b={run:T,promise:W,promiseResolve:ce,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=oe;class se{constructor(T,W=()=>Date.now()){this.d=T,this.f=W,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$Wh=se;var _;(function(J){J[J.Resolved=0]="Resolved",J[J.Rejected=1]="Rejected"})(_||(_={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,W)=>{this.a=T,this.b=W})}complete(T){return new Promise(W=>{this.a(T),this.d={outcome:0,value:T},W()})}error(T){return new Promise(W=>{this.b(T),this.d={outcome:1,value:T},W()})}cancel(){return this.error(new j.$5)}}e.$Xh=H;var ne;(function(J){async function T(ce){let ue;const we=await Promise.all(ce.map(de=>de.then(ge=>ge,ge=>{ue||(ue=ge)})));if(typeof ue<"u")throw ue;return we}J.settled=T;function W(ce){return new Promise(async(ue,we)=>{try{await ce(ue,we)}catch(de){we(de)}})}J.withAsyncBody=W})(ne||(e.Promises=ne={}));class le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(T){this.a=void 0,this.b=void 0,this.d=!1,this.promise=T.then(W=>(this.a=W,this.d=!0,W),W=>{throw this.b=W,this.d=!0,W})}requireValue(){if(!this.d)throw new j.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=le;class F{constructor(T){this.b=T,this.a=new $.$V(()=>new le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=F;var U;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(U||(U={}));class X{static fromArray(T){return new X(W=>{W.emitMany(T)})}static fromPromise(T){return new X(async W=>{W.emitMany(await T)})}static fromPromises(T){return new X(async W=>{await Promise.all(T.map(async ce=>W.emitOne(await ce)))})}static merge(T){return new X(async W=>{await Promise.all(T.map(async ce=>{for await(const ue of ce)W.emitOne(ue)}))})}static{this.EMPTY=X.fromArray([])}constructor(T,W){this.a=0,this.b=[],this.d=null,this.f=W,this.g=new I.$he,queueMicrotask(async()=>{const ce={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(T(ce)),this.k()}catch(ue){this.l(ue)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(T,W){return new X(async ce=>{for await(const ue of T)ce.emitOne(W(ue))})}map(T){return X.map(this,T)}static filter(T,W){return new X(async ce=>{for await(const ue of T)W(ue)&&ce.emitOne(ue)})}filter(T){return X.filter(this,T)}static coalesce(T){return X.filter(T,W=>!!W)}coalesce(){return X.coalesce(this)}static async toPromise(T){const W=[];for await(const ce of T)W.push(ce);return W}toPromise(){return X.toPromise(this)}h(T){this.a===0&&(this.b.push(T),this.g.fire())}j(T){this.a===0&&(this.b=this.b.concat(T),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(T){this.a===0&&(this.a=2,this.d=T,this.g.fire())}}e.$1h=X;class x extends X{constructor(T,W){super(W),this.m=T}cancel(){this.m.cancel()}}e.$2h=x;function Q(J){const T=new s.$se,W=J(T.token);return new x(T,async ce=>{const ue=T.token.onCancellationRequested(()=>{ue.dispose(),T.dispose(),ce.reject(new j.$5)});try{for await(const we of W){if(T.token.isCancellationRequested)return;ce.emitOne(we)}ue.dispose(),T.dispose()}catch(we){ue.dispose(),T.dispose(),ce.reject(we)}})}class G{constructor(T){this.a=new H,this.b=new X(ue=>{if(W){ue.reject(W);return}return ce&&ue.emitMany(ce),this.d=we=>ue.reject(we),this.f=we=>ue.emitOne(we),this.a.p},T);let W,ce;this.f=ue=>{ce||(ce=[]),ce.push(ue)},this.d=ue=>{W||(W=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$4h=G}),define(ye[80],Ee([1,0,18,14,35,24,7,3,17]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=$,e.$sk=l,e.$tk=N,e.$uk=V,e.$vk=ie,e.$wk=ae,e.$xk=te,e.$yk=Z;function $(){return Object.create(null)}e.$qk="**",e.$rk="/";const y="[/\\\\]",w="[^/\\\\]",v=/\//g;function m(Y,M){switch(Y){case 0:return"";case 1:return`${w}*?`;default:return`(?:${y}|${w}+${y}${M?`|${y}${w}+`:""})*?`}}function l(Y,M){if(!Y)return[];const z=[];let oe=!1,se=!1,_="";for(const H of Y){switch(H){case M:if(!oe&&!se){z.push(_),_="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":se=!0;break;case"]":se=!1;break}_+=H}return _&&z.push(_),z}function c(Y){if(!Y)return"";let M="";const z=l(Y,e.$rk);if(z.every(oe=>oe===e.$qk))M=".*";else{let oe=!1;z.forEach((se,_)=>{if(se===e.$qk){if(oe)return;M+=m(2,_===z.length-1)}else{let H=!1,ne="",le=!1,F="";for(const U of se){if(U!=="}"&&H){ne+=U;continue}if(le&&(U!=="]"||!F)){let X;U==="-"?X=U:(U==="^"||U==="!")&&!F?X="^":U===e.$rk?X="":X=(0,b.$df)(U),F+=X;continue}switch(U){case"{":H=!0;continue;case"[":le=!0;continue;case"}":{const x=`(?:${l(ne,",").map(Q=>c(Q)).join("|")})`;M+=x,H=!1,ne="";break}case"]":{M+="["+F+"]",le=!1,F="";break}case"?":M+=w;continue;case"*":M+=m(1);continue;default:M+=(0,b.$df)(U)}}_<z.length-1&&(z[_+1]!==e.$qk||_+2<z.length)&&(M+=y)}oe=se===e.$qk})}return M}const u=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.$Dc(1e4),o=function(){return!1},r=function(){return null};function n(Y,M){if(!Y)return r;let z;typeof Y!="string"?z=Y.pattern:z=Y,z=z.trim();const oe=`${z}_${!!M.trimForExclusions}`;let se=t.get(oe);if(se)return a(se,Y);let _;return u.test(z)?se=p(z.substr(4),z):(_=h.exec(i(z,M)))?se=k(_[1],z):(M.trimForExclusions?d:g).test(z)?se=C(z,M):(_=E.exec(i(z,M)))?se=A(_[1].substr(1),z,!0):(_=f.exec(i(z,M)))?se=A(_[1],z,!1):se=O(z),t.set(oe,se),a(se,Y)}function a(Y,M){if(typeof M=="string")return Y;const z=function(oe,se){return(0,I.$zg)(oe,M.base,!P.$k)?Y((0,b.$if)(oe.substr(M.base.length),S.sep),se):null};return z.allBasenames=Y.allBasenames,z.allPaths=Y.allPaths,z.basenames=Y.basenames,z.patterns=Y.patterns,z}function i(Y,M){return M.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,M){return function(z,oe){return typeof z=="string"&&z.endsWith(Y)?M:null}}function k(Y,M){const z=`/${Y}`,oe=`\\${Y}`,se=function(H,ne){return typeof H!="string"?null:ne?ne===Y?M:null:H===Y||H.endsWith(z)||H.endsWith(oe)?M:null},_=[Y];return se.basenames=_,se.patterns=[M],se.allBasenames=_,se}function C(Y,M){const z=B(Y.slice(1,-1).split(",").map(ne=>n(ne,M)).filter(ne=>ne!==r),Y),oe=z.length;if(!oe)return r;if(oe===1)return z[0];const se=function(ne,le){for(let F=0,U=z.length;F<U;F++)if(z[F](ne,le))return Y;return null},_=z.find(ne=>!!ne.allBasenames);_&&(se.allBasenames=_.allBasenames);const H=z.reduce((ne,le)=>le.allPaths?ne.concat(le.allPaths):ne,[]);return H.length&&(se.allPaths=H),se}function A(Y,M,z){const oe=S.sep===S.$gc.sep,se=oe?Y:Y.replace(v,S.sep),_=S.sep+se,H=S.$gc.sep+Y;let ne;return z?ne=function(le,F){return typeof le=="string"&&(le===se||le.endsWith(_)||!oe&&(le===Y||le.endsWith(H)))?M:null}:ne=function(le,F){return typeof le=="string"&&(le===se||!oe&&le===Y)?M:null},ne.allPaths=[(z?"*/":"./")+Y],ne}function O(Y){try{const M=new RegExp(`^${c(Y)}$`);return function(z){return M.lastIndex=0,typeof z=="string"&&M.test(z)?Y:null}}catch{return r}}function N(Y,M,z){return!Y||typeof M!="string"?!1:V(Y)(M,void 0,z)}function V(Y,M={}){if(!Y)return o;if(typeof Y=="string"||ie(Y)){const z=n(Y,M);if(z===r)return o;const oe=function(se,_){return!!z(se,_)};return z.allBasenames&&(oe.allBasenames=z.allBasenames),z.allPaths&&(oe.allPaths=z.allPaths),oe}return ee(Y,M)}function ie(Y){const M=Y;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}function ae(Y){return Y.allBasenames||[]}function te(Y){return Y.allPaths||[]}function ee(Y,M){const z=B(Object.getOwnPropertyNames(Y).map(ne=>K(ne,Y[ne],M)).filter(ne=>ne!==r)),oe=z.length;if(!oe)return r;if(!z.some(ne=>!!ne.requiresSiblings)){if(oe===1)return z[0];const ne=function(U,X){let x;for(let Q=0,G=z.length;Q<G;Q++){const J=z[Q](U,X);if(typeof J=="string")return J;(0,j.$mh)(J)&&(x||(x=[]),x.push(J))}return x?(async()=>{for(const Q of x){const G=await Q;if(typeof G=="string")return G}return null})():null},le=z.find(U=>!!U.allBasenames);le&&(ne.allBasenames=le.allBasenames);const F=z.reduce((U,X)=>X.allPaths?U.concat(X.allPaths):U,[]);return F.length&&(ne.allPaths=F),ne}const se=function(ne,le,F){let U,X;for(let x=0,Q=z.length;x<Q;x++){const G=z[x];G.requiresSiblings&&F&&(le||(le=(0,S.$nc)(ne)),U||(U=le.substr(0,le.length-(0,S.$oc)(ne).length)));const J=G(ne,le,U,F);if(typeof J=="string")return J;(0,j.$mh)(J)&&(X||(X=[]),X.push(J))}return X?(async()=>{for(const x of X){const Q=await x;if(typeof Q=="string")return Q}return null})():null},_=z.find(ne=>!!ne.allBasenames);_&&(se.allBasenames=_.allBasenames);const H=z.reduce((ne,le)=>le.allPaths?ne.concat(le.allPaths):ne,[]);return H.length&&(se.allPaths=H),se}function K(Y,M,z){if(M===!1)return r;const oe=n(Y,z);if(oe===r)return r;if(typeof M=="boolean")return oe;if(M){const se=M.when;if(typeof se=="string"){const _=(H,ne,le,F)=>{if(!F||!oe(H,ne))return null;const U=se.replace("$(basename)",()=>le),X=F(U);return(0,j.$mh)(X)?X.then(x=>x?Y:null):X?Y:null};return _.requiresSiblings=!0,_}}return oe}function B(Y,M){const z=Y.filter(ne=>!!ne.basenames);if(z.length<2)return Y;const oe=z.reduce((ne,le)=>{const F=le.basenames;return F?ne.concat(F):ne},[]);let se;if(M){se=[];for(let ne=0,le=oe.length;ne<le;ne++)se.push(M)}else se=z.reduce((ne,le)=>{const F=le.patterns;return F?ne.concat(F):ne},[]);const _=function(ne,le){if(typeof ne!="string")return null;if(!le){let U;for(U=ne.length;U>0;U--){const X=ne.charCodeAt(U-1);if(X===47||X===92)break}le=ne.substr(U)}const F=oe.indexOf(le);return F!==-1?se[F]:null};_.basenames=oe,_.patterns=se,_.allBasenames=oe;const H=Y.filter(ne=>!ne.basenames);return H.push(_),H}function Z(Y,M){return(0,s.$ub)(Y,M,(z,oe)=>typeof z=="string"&&typeof oe=="string"?z===oe:typeof z!="string"&&typeof oe!="string"?z.base===oe.base&&z.pattern===oe.pattern:!1)}}),define(ye[102],Ee([1,0,11,164,19,17,4]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=$,e.$Zk=y,e.$1k=w,e.$2k=v,e.$3k=m,e.$4k=l,e.$5k=c,e.$6k=u;var P;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class b{constructor(g="",d=!1){if(this.value=g,typeof this.value!="string")throw(0,s.$7)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(g,d=0){return this.value+=v(this.supportThemeIcons?(0,j.$Rk)(g):g).replace(/([ \t]+)/g,(E,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,d){return this.value+=`
${m(d,g)}
`,this}appendLink(g,d,E){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(g),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(g,d){const E=new RegExp((0,D.$df)(d),"g");return g.replace(E,(f,t)=>g.charAt(t-1)!=="\\"?`\\${f}`:f)}}e.$Xk=b;function $(h){return y(h)?!h.value:Array.isArray(h)?h.every($):!0}function y(h){return h instanceof b?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function w(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,I.$7g)(S.URI.from(h.baseUri),S.URI.from(g.baseUri)))}function v(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(h,g){const d=h.match(/^`+/gm)?.reduce((f,t)=>f.length>t.length?f:t).length??0,E=d>=3?d+1:3;return[`${"`".repeat(E)}${g}`,h,`${"`".repeat(E)}`].join(`
`)}function l(h){return h.replace(/"/g,"&quot;")}function c(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function u(h){const g=[],d=h.split("|").map(f=>f.trim());h=d[0];const E=d[1];if(E){const f=/height=(\d+)/.exec(E),t=/width=(\d+)/.exec(E),o=f?f[1]:"",r=t?t[1]:"",n=isFinite(parseInt(r)),a=isFinite(parseInt(o));n&&g.push(`width="${r}"`),a&&g.push(`height="${o}"`)}return{href:h,dimensions:g}}}),define(ye[181],Ee([1,0,18,35,7,3,19,17]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=b,e.$Kw=y,e.$Lw=v,e.$Mw=m,e.$Nw=h,e.$Ow=d,e.$Pw=E,e.$Qw=f,e.$Rw=t,e.$Sw=o;function b(n,a){const{os:i,tildify:p,relative:k}=a;if(k){const O=$(n,k,i);if(typeof O=="string")return O}let C=n.fsPath;if(i===1&&!D.$i?C=C.replace(/\//g,"\\"):i!==1&&D.$i&&(C=C.replace(/\\/g,"/")),i!==1&&p?.userHome){const O=p.userHome.fsPath;let N;n.scheme!==p.userHome.scheme&&n.path[0]===I.$gc.sep&&n.path[1]!==I.$gc.sep?N=p.userHome.with({path:n.path}).fsPath:N=C,C=v(N,O,i)}return(i===1?I.$fc:I.$gc).normalize(y(C,i===1))}function $(n,a,i){const p=i===1?I.$fc:I.$gc,k=i===3?S.$4g:S.$6g,C=a.getWorkspace(),A=(0,s.$Ob)(C.folders);if(!A)return;n.scheme!==A.uri.scheme&&n.path[0]===I.$gc.sep&&n.path[1]!==I.$gc.sep&&(n=A.uri.with({path:n.path}));const O=a.getWorkspaceFolder(n);if(!O)return;let N;if(k.isEqual(O.uri,n)?N="":N=k.relativePath(O.uri,n)??"",N&&(N=p.normalize(N)),C.folders.length>1&&!a.noPrefix){const V=O.name?O.name:k.basenameOrAuthority(O.uri);N=N?`${V} \u2022 ${N}`:V}return N}function y(n,a=D.$i){return(0,j.$Eg)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}let w=Object.create(null);function v(n,a,i=D.OS){if(i===1||!n||!a)return n;let p=w.original===a?w.normalized:void 0;p||(p=a,D.$i&&(p=(0,j.$tg)(p)),p=`${(0,P.$jf)(p,I.$gc.sep)}${I.$gc.sep}`,w={original:a,normalized:p});let k=n;return D.$i&&(k=(0,j.$tg)(k)),(i===3?k.startsWith(p):(0,P.$Cf)(k,p))?`~/${k.substr(p.length)}`:n}function m(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}const l="\u2026",c="\\\\",u="~";function h(n,a=I.sep){const i=new Array(n.length);let p=!1;for(let k=0;k<n.length;k++){const C=n[k];if(C===""){i[k]=`.${a}`;continue}if(!C){i[k]=C;continue}p=!0;let A="",O=C;O.indexOf(c)===0?(A=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(a)===0?(A=O.substr(0,O.indexOf(a)+a.length),O=O.substr(O.indexOf(a)+a.length)):O.indexOf(u)===0&&(A=O.substr(0,O.indexOf(u)+u.length),O=O.substr(O.indexOf(u)+u.length));const N=O.split(a);for(let V=1;p&&V<=N.length;V++)for(let ie=N.length-V;p&&ie>=0;ie--){p=!1;let ae=N.slice(ie,ie+V).join(a);for(let te=0;!p&&te<n.length;te++)if(te!==k&&n[te]&&n[te].indexOf(ae)>-1){const ee=ie+V===N.length,K=ie>0&&n[te].indexOf(a)>-1?a+ae:ae,B=n[te].endsWith(K);p=!ee||B}if(!p){let te="";(N[0].endsWith(":")||A!=="")&&(ie===1&&(ie=0,V++,ae=N[0]+a+ae),ie>0&&(te=N[0]+a),te=A+te),ie>0&&(te=te+l+a),te=te+ae,ie+V<N.length&&(te=te+a+l),i[k]=te}}p&&(i[k]=C)}return i}var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function d(n,a=Object.create(null)){const i=[];let p=!1,k="";for(const C of n)if(C==="$"||p&&C==="{")k&&i.push({value:k,type:g.TEXT}),k="",p=!0;else if(C==="}"&&p){const A=a[k];if(typeof A=="string")A.length&&i.push({value:A,type:g.VARIABLE});else if(A){const O=i[i.length-1];(!O||O.type!==g.SEPARATOR)&&i.push({value:A.label,type:g.SEPARATOR})}k="",p=!1}else k+=C;return k&&!p&&i.push({value:k,type:g.TEXT}),i.filter((C,A)=>{if(C.type===g.SEPARATOR){const O=i[A-1],N=i[A+1];return[O,N].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(C=>C.value).join("")}function E(n,a){return D.$j||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):n.replace(/&&|&/g,i=>i==="&"?"&&":"&")}function f(n,a){return D.$j||a?n.replace(/\(&&\w\)|&&/g,""):D.$i?n.replace(/&&|&/g,i=>i==="&"?"&&":"&"):n.replace(/&&/g,"_")}function t(n){return n.replace(/&/g,"&&")}function o(n){if(n.endsWith("]")){const a=n.lastIndexOf(" [",n.length-2);if(a!==-1){const i=r(n.substring(0,a)),p=n.substring(a);return{name:i.name+p,parentPath:i.parentPath}}}return r(n)}function r(n){const a=n.indexOf("/")!==-1?I.$gc:I.$fc,i=a.basename(n),p=a.dirname(n);return i.length?{name:i,parentPath:p}:{name:p,parentPath:""}}}),define(ye[55],Ee([1,0,15,4]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=P,e.$Fn=$,e.$Gn=y;function I(w){return w.toJSON()}class D{constructor(v){this.a=v}transformIncoming(v){const m=this.a.transformIncoming(v);return m===v?v:I(j.URI.from(m))}transformOutgoing(v){const m=this.a.transformOutgoing(v);return m===v?v:I(j.URI.from(m))}transformOutgoingURI(v){const m=this.a.transformOutgoing(v);return m===v?v:j.URI.from(m)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Cn=D,e.$Dn=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function S(w,v,m){if(!w||m>200)return null;if(typeof w=="object"){if(w instanceof j.URI)return v.transformOutgoing(w);for(const l in w)if(Object.hasOwnProperty.call(w,l)){const c=S(w[l],v,m+1);c!==null&&(w[l]=c)}}return null}function P(w,v){const m=S(w,v,0);return m===null?w:m}function b(w,v,m,l){if(!w||l>200)return null;if(typeof w=="object"){if(w.$mid===1)return m?j.URI.revive(v.transformIncoming(w)):v.transformIncoming(w);if(w instanceof s.$Je)return null;for(const c in w)if(Object.hasOwnProperty.call(w,c)){const u=b(w[c],v,m,l+1);u!==null&&(w[c]=u)}}return null}function $(w,v){const m=b(w,v,!1,0);return m===null?w:m}function y(w,v){const m=b(w,v,!0,0);return m===null?w:m}}),define(ye[103],Ee([1,0,31,64,22,167,3]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$Jn=b,e.$Kn=w,e.$In=new class{c(v){return this.a||(this.a=j.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,m=0;const l=(0,s.networkInterfaces)();for(const c in l){const u=l[c];if(u)for(const{mac:h,internal:g}of u)g||(m+=1,this.c(h.toUpperCase())&&(v+=1))}this.b=m>0?v/m:0}return this.b}};let P;async function b(v){return P||(P=(async()=>await $(v)||I.$Wg())()),P}async function $(v){try{const m=await new Promise((c,u)=>{fe(["crypto"],c,u)}),l=(0,D.$Hn)();return m.createHash("sha256").update(l,"utf8").digest("hex")}catch(m){v(m);return}}const y="Software\\Microsoft\\SQMClient";async function w(v){if(S.$i){const m=await new Promise((l,c)=>{fe(["@vscode/windows-registry"],l,c)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(l){return v(l),""}}return""}}),define(ye[182],Ee([1,0,28,308,309,3]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=S;async function S(P){if(D.$j||D.$i)return;let b;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,j.open)($,s.constants.R_OK);break}catch{}if(!b){P("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const w of(0,I.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!w.includes("="))continue;const v=w.split("=")[0].toUpperCase().trim();if($.has(v)){const m=w.split("=")[1].replace(/"/g,"").toLowerCase().trim();v==="ID"||v==="DISTRIB_ID"?y.id=m:v==="ID_LIKE"?y.id_like=m:(v==="VERSION_ID"||v==="DISTRIB_RELEASE")&&(y.version_id=m)}}return y}catch($){P($)}}}),define(ye[23],Ee([1,0,28,31,310,14,35,100,7,3,19,4]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=u,e.readdirSync=d,e.whenDeleted=t,e.configureFlushOnWrite=i,e.writeFileSync=k;var v;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function m(K,B=v.UNLINK,Z){if((0,S.$Dg)(K))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?c(K):l(K,Z)}async function l(K,B=(0,S.$Ig)((0,j.tmpdir)())){try{try{await s.promises.rename(K,B)}catch(Z){return Z.code==="ENOENT"?void 0:c(K)}c(B).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function c(K){return(0,I.promisify)(s.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function u(K){if((0,S.$Dg)(K))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function h(K,B){return E(await(B?g(K):(0,I.promisify)(s.readdir)(K)))}async function g(K){try{return await(0,I.promisify)(s.readdir)(K,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const B=[],Z=await h(K);for(const Y of Z){let M=!1,z=!1,oe=!1;try{const se=await e.Promises.lstat((0,b.$jc)(K,Y));M=se.isFile(),z=se.isDirectory(),oe=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}B.push({name:Y,isFile:()=>M,isDirectory:()=>z,isSymbolicLink:()=>oe})}return B}function d(K){return E(s.readdirSync(K))}function E(K){return K.map(B=>typeof B=="string"?$.$j?(0,P.$fm)(B):B:(B.name=$.$j?(0,P.$fm)(B.name):B.name,B))}async function f(K){const B=await h(K),Z=[];for(const Y of B)await o.existsDirectory((0,b.$jc)(K,Y))&&Z.push(Y);return Z}function t(K,B=1e3){return new Promise(Z=>{let Y=!1;const M=setInterval(()=>{Y||(Y=!0,s.access(K,z=>{Y=!1,z&&(clearInterval(M),Z(void 0))}))},B)})}var o;(function(K){async function B(M){let z;try{if(z=await e.Promises.lstat(M),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if($.$i&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw se}throw oe}}K.stat=B;async function Z(M){try{const{stat:z,symbolicLink:oe}=await K.stat(M);return z.isFile()&&oe?.dangling!==!0}catch{}return!1}K.existsFile=Z;async function Y(M){try{const{stat:z,symbolicLink:oe}=await K.stat(M);return z.isDirectory()&&oe?.dangling!==!0}catch{}return!1}K.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new D.$Jh;function n(K,B,Z){return r.queueFor(w.URI.file(K),()=>{const Y=C(Z);return new Promise((M,z)=>p(K,B,Y,oe=>oe?z(oe):M()))},y.$5g)}let a=!0;function i(K){a=K}function p(K,B,Z,Y){if(!a)return s.writeFile(K,B,{mode:Z.mode,flag:Z.flag},Y);s.open(K,Z.flag,Z.mode,(M,z)=>{if(M)return Y(M);s.writeFile(z,B,oe=>{if(oe)return s.close(z,()=>Y(oe));s.fdatasync(z,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),i(!1)),s.close(z,_=>Y(_))))})})}function k(K,B,Z){const Y=C(Z);if(!a)return s.writeFileSync(K,B,{mode:Y.mode,flag:Y.flag});const M=s.openSync(K,Y.flag,Y.mode);try{s.writeFileSync(M,B);try{s.fdatasyncSync(M)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),i(!1)}}finally{s.closeSync(M)}}function C(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function A(K,B,Z=6e4){if(K!==B)try{$.$i&&typeof Z=="number"?await O(K,B,Date.now(),Z):await(0,I.promisify)(s.rename)(K,B)}catch(Y){if(K.toLowerCase()!==B.toLowerCase()&&Y.code==="EXDEV"||K.endsWith("."))await N(K,B,{preserveSymlinks:!1}),await m(K,v.MOVE);else throw Y}}async function O(K,B,Z,Y,M=0){try{return await(0,I.promisify)(s.rename)(K,B)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-Z>=Y)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${z}`),z;if(M===0){let oe=!1;try{const{stat:se}=await o.stat(B);se.isFile()||(oe=!0)}catch{}if(oe)throw z}return await(0,D.$Bh)(Math.min(100,M*10)),O(K,B,Z,Y,M+1)}}async function N(K,B,Z){return ie(K,B,{root:{source:K,target:B},options:Z,handledSourcePaths:new Set})}const V=511;async function ie(K,B,Z){if(Z.handledSourcePaths.has(K))return;Z.handledSourcePaths.add(K);const{stat:Y,symbolicLink:M}=await o.stat(K);if(M){if(Z.options.preserveSymlinks)try{return await ee(K,B,Z)}catch{}if(M.dangling)return}return Y.isDirectory()?ae(K,B,Y.mode&V,Z):te(K,B,Y.mode&V)}async function ae(K,B,Z,Y){await e.Promises.mkdir(B,{recursive:!0,mode:Z});const M=await h(K);for(const z of M)await ie((0,b.$jc)(K,z),(0,b.$jc)(B,z),Y)}async function te(K,B,Z){await e.Promises.copyFile(K,B),await e.Promises.chmod(B,Z)}async function ee(K,B,Z){let Y=await e.Promises.readlink(K);(0,S.$zg)(Y,Z.root.source,!$.$k)&&(Y=(0,b.$jc)(Z.root.target,Y.substr(Z.root.source.length+1))),await e.Promises.symlink(Y,B)}e.Promises=new class{get access(){return(0,I.promisify)(s.access)}get stat(){return(0,I.promisify)(s.stat)}get lstat(){return(0,I.promisify)(s.lstat)}get utimes(){return(0,I.promisify)(s.utimes)}get read(){return(K,B,Z,Y,M)=>new Promise((z,oe)=>{s.read(K,B,Z,Y,M,(se,_,H)=>se?oe(se):z({bytesRead:_,buffer:H}))})}get readFile(){return(0,I.promisify)(s.readFile)}get write(){return(K,B,Z,Y,M)=>new Promise((z,oe)=>{s.write(K,B,Z,Y,M,(se,_,H)=>se?oe(se):z({bytesWritten:_,buffer:H}))})}get appendFile(){return(0,I.promisify)(s.appendFile)}get fdatasync(){return(0,I.promisify)(s.fdatasync)}get truncate(){return(0,I.promisify)(s.truncate)}get copyFile(){return(0,I.promisify)(s.copyFile)}get open(){return(0,I.promisify)(s.open)}get close(){return(0,I.promisify)(s.close)}get symlink(){return(0,I.promisify)(s.symlink)}get readlink(){return(0,I.promisify)(s.readlink)}get chmod(){return(0,I.promisify)(s.chmod)}get mkdir(){return(0,I.promisify)(s.mkdir)}get unlink(){return(0,I.promisify)(s.unlink)}get rmdir(){return(0,I.promisify)(s.rmdir)}get realpath(){return(0,I.promisify)(s.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return f}get writeFile(){return n}get rm(){return m}get rename(){return A}get copy(){return N}}}),define(ye[183],Ee([1,0,28,7,3,17,23]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=P,e.$$q=b,e.$_q=$,e.$ar=y;function P(v){if(I.$k)return v;const m=(0,j.$mc)(v);if(v===m)return v;const l=((0,j.$nc)(v)||v).toLowerCase();try{const u=(0,S.readdirSync)(m).filter(h=>h.toLowerCase()===l);if(u.length===1){const h=P(m);if(h)return(0,j.$jc)(h,u[0])}else if(u.length>1){const h=u.indexOf(l);if(h>=0){const g=P(m);if(g)return(0,j.$jc)(g,u[h])}}}catch{}return null}async function b(v,m){if(I.$k)return v;const l=(0,j.$mc)(v);if(v===l)return v;const c=((0,j.$nc)(v)||v).toLowerCase();try{if(m?.isCancellationRequested)return null;const h=(await S.Promises.readdir(l)).filter(g=>g.toLowerCase()===c);if(h.length===1){const g=await b(l,m);if(g)return(0,j.$jc)(g,h[0])}else if(h.length>1){const g=h.indexOf(c);if(g>=0){const d=await b(l,m);if(d)return(0,j.$jc)(d,h[g])}}}catch{}return null}async function $(v){try{return await S.Promises.realpath(v)}catch{const l=w(v);return await S.Promises.access(l,s.constants.R_OK),l}}function y(v){try{return s.realpathSync(v)}catch{const l=w(v);return s.accessSync(l,s.constants.R_OK),l}}function w(v){return(0,D.$jf)((0,j.$hc)(v),j.sep)}}),define(ye[104],Ee([1,0,31,7,23]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=g,e.$pm=d;const D=/^\d+$/,S=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var b;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(b||(b={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class w{constructor(f,t,o){this.exePath=f,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:E=!1}={}){return E?$===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:E=!1,findPreview:f=!1}={}){const t=v({useAlternateBitness:E});if(!t)return null;const o=j.$jc(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(o))return null;let r=-1,n=null;for(const p of await I.Promises.readdir(o)){let k=-1;if(f){const A=p.indexOf("-");if(A<0)continue;const O=p.substring(0,A);if(!D.test(O)||p.substring(A+1)!=="preview")continue;k=parseInt(O,10)}else{if(!D.test(p))continue;k=parseInt(p,10)}if(k<=r)continue;const C=j.$jc(o,p,"pwsh.exe");await I.SymlinkSupport.existsFile(C)&&(n=C,r=k)}if(!n)return null;const a=t.includes("x86")?" (x86)":"",i=f?" Preview":"";return new w(n,`PowerShell${i}${a}`,!0)}async function l({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const f=j.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const r of await I.Promises.readdir(f))if(t.test(r)){const n=j.$jc(f,r,"pwsh.exe");return new w(n,o)}return null}function c(){const E=j.$jc(s.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function u(){const E=j.$jc(process.env.windir,$===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*h(){let E=await m();E&&(yield E),E=await m({useAlternateBitness:!0}),E&&(yield E),E=await l(),E&&(yield E),E=c(),E&&(yield E),E=await m({findPreview:!0}),E&&(yield E),E=await l({findPreview:!0}),E&&(yield E),E=await m({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=u(),E&&(yield E)}async function*g(){for await(const E of h())await E.exists()&&(yield E)}async function d(){for await(const E of g())return E;return null}}),define(ye[105],Ee([1,0,7,3,32,66,10,23]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=b,e.$tm=$,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function b(w=I.env){return w.comspec||"cmd.exe"}function $(w){let v=[],m=!1;const l=function(c){if(m){v.push(c);return}(!w.send(c,h=>{if(h&&console.error(h),m=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(d=>l(d))}})||j.$i)&&(m=!0)};return{send:l}}var y;(function(w){async function v(m,l,c){if(s.$ic(m))return m;if(l===void 0&&(l=I.cwd()),s.$mc(m)!=="."||(c===void 0&&S.$ag(I.env.PATH)&&(c=I.env.PATH.split(s.$tc)),c===void 0||c.length===0))return s.$jc(l,m);async function h(g){if(await P.Promises.exists(g)){let d;try{d=await P.Promises.stat(g)}catch(E){E.message.startsWith("EACCES")&&(d=await P.Promises.lstat(g))}return d?!d.isDirectory():!1}return!1}for(const g of c){let d;if(s.$ic(g)?d=s.$jc(g,m):d=s.$jc(l,g,m),await h(d))return d;let E=d+".com";if(await h(E)||(E=d+".exe",await h(E)))return E}return s.$jc(l,m)}w.findExecutable=v})(y||(e.win32=y={}))}),define(ye[106],Ee([1,0,56,13]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=I;function I(S){return new Promise((P,b)=>{let $;const y=new Map;function w(m,l,c,u,h){const g=y.get(l);if(m===S||g){const d={name:v(c),cmd:c,pid:m,ppid:l,load:u,mem:h};y.set(m,d),m===S&&($=d),g&&(g.children||(g.children=[]),g.children.push(d),g.children.length>1&&(g.children=g.children.sort((E,f)=>E.pid-f.pid)))}}function v(m){const l=/--utility-sub-type=network/i,c=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(u.exec(m))return"winpty-agent";if(h.exec(m))return"conpty-agent";let d=g.exec(m);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?l.exec(m)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let f="";do d=E.exec(m),d&&(f+=d+" ");while(d);return f&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${f})`:m}if(process.platform==="win32"){const m=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,c)=>{fe(["@vscode/windows-process-tree"],l,c)}).then(l=>{l.getProcessList(S,c=>{if(!c){b(new Error(`Root process ${S} not found`));return}l.getProcessCpuUsage(c,u=>{const h=new Map;u.forEach(g=>{const d=m(g.commandLine||"");h.set(g.pid,{name:v(d),cmd:d,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),$=h.get(S),$?(h.forEach(g=>{const d=h.get(g.ppid);d&&(d.children||(d.children=[]),d.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((d,E)=>d.pid-E.pid))}),P($)):b(new Error(`Root process ${S} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let m=function(){let l=[$];const c=[];for(;l.length;){const h=l.shift();h&&(c.push(h.pid),h.children&&(l=l.concat(h.children)))}let u=JSON.stringify(j.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+c.join(" "),(0,s.exec)(u,{},(h,g,d)=>{if(h||d)b(h||new Error(d.toString()));else{const E=g.toString().split(`
`);for(let f=0;f<c.length;f++){const t=y.get(c[f]);t.load=parseFloat(E[f])}if(!$){b(new Error(`Root process ${S} not found`));return}P($)}})};(0,s.exec)("which ps",{},(l,c,u)=>{if(l||u)if(process.platform!=="linux")b(l||new Error(u.toString()));else{const h=JSON.stringify(j.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,s.exec)(h,{},(g,d,E)=>{g||E?b(g||new Error(E.toString())):(D(d,w),m())})}else{const h=c.toString().trim();(0,s.exec)(`${h} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,E,f)=>{d||f&&!f.includes("screen size is bogus")?b(d||new Error(f.toString())):(D(E,w),process.platform==="linux"?m():$?P($):b(new Error(`Root process ${S} not found`)))})}})}})}function D(S,P){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=S.toString().split(`
`);for(const y of $){const w=b.exec(y.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ye[107],Ee([1,0,31,3,104,105]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=S;async function S(w,v){return w===1?j.$i?y():D.$sm(v):b(w,v)}let P=null;function b(w,v){if(j.$k&&w===2||j.$j&&w===3)return"/bin/bash";if(!P){let m;if(j.$i)m="/bin/bash";else{if(m=v.SHELL,!m)try{m=(0,s.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let $=null;async function y(){return $||($=(await(0,I.$pm)()).exePath),$}});var Le=this&&this.__decorate||function(fe,e,s,j){var I=arguments.length,D=I<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,s):j,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(fe,e,s,j);else for(var P=fe.length-1;P>=0;P--)(S=fe[P])&&(D=(I<3?S(D):I>3?S(e,s,D):S(e,s))||D);return I>3&&D&&Object.defineProperty(e,s,D),D};define(ye[47],Ee([1,0,18,14,15,20,74,11,6,2,46,17,10]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=i,e.$bi=p,e.$gi=V,e.$hi=ie;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m||(m={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c||(c={}));function u(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(h||(h={}));function g(M){let z=0;for(let oe=0;;oe+=7){const se=M.read(1);if(z|=(se.buffer[0]&127)<<oe,!(se.buffer[0]&128))return z}}const d=r(0);function E(M,z){if(z===0){M.write(d);return}let oe=0;for(let _=z;_!==0;_=_>>>7)oe++;const se=I.$Je.alloc(oe);for(let _=0;z!==0;_++)se.buffer[_]=z&127,z=z>>>7,z>0&&(se.buffer[_]|=128);M.write(se)}class f{constructor(z){this.b=z,this.a=0}read(z){const oe=this.b.slice(this.a,this.a+z);return this.a+=oe.byteLength,oe}}e.$$h=f;class t{constructor(){this.a=[]}get buffer(){return I.$Je.concat(this.a)}write(z){this.a.push(z)}}e.$_h=t;var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(o||(o={}));function r(M){const z=I.$Je.alloc(1);return z.writeUInt8(M,0),z}const n={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},a=typeof Buffer<"u";function i(M,z){if(typeof z>"u")M.write(n.Undefined);else if(typeof z=="string"){const oe=I.$Je.fromString(z);M.write(n.String),E(M,oe.byteLength),M.write(oe)}else if(a&&Buffer.isBuffer(z)){const oe=I.$Je.wrap(z);M.write(n.Buffer),E(M,oe.byteLength),M.write(oe)}else if(z instanceof I.$Je)M.write(n.VSBuffer),E(M,z.byteLength),M.write(z);else if(Array.isArray(z)){M.write(n.Array),E(M,z.length);for(const oe of z)i(M,oe)}else if(typeof z=="number"&&(z|0)===z)M.write(n.Uint),E(M,z);else{const oe=I.$Je.fromString(JSON.stringify(z));M.write(n.Object),E(M,oe.byteLength),M.write(oe)}}function p(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(g(M)).toString();case o.Buffer:return M.read(g(M)).buffer;case o.VSBuffer:return M.read(g(M));case o.Array:{const oe=g(M),se=[];for(let _=0;_<oe;_++)se.push(p(M));return se}case o.Object:return JSON.parse(M.read(g(M)).toString());case o.Int:return g(M)}}class k{constructor(z,oe,se=null,_=1e3){this.h=z,this.j=oe,this.k=se,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(H=>this.q(H)),this.m({type:200})}registerChannel(z,oe){this.b.set(z,oe),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const oe=this.o([z.type]);this.k?.logOutgoing(oe,0,1,u(z.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([z.type,z.id],z.data);this.k?.logOutgoing(oe,z.id,1,u(z.type),z.data);return}}}o(z,oe=void 0){const se=new t;return i(se,z),i(se,oe),this.p(se.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const oe=new f(z),se=p(oe),_=p(oe),H=se[0];switch(H){case 100:return this.k?.logIncoming(z.byteLength,se[1],1,`${l(H)}: ${se[2]}.${se[3]}`,_),this.s({type:H,id:se[1],channelName:se[2],name:se[3],arg:_});case 102:return this.k?.logIncoming(z.byteLength,se[1],1,`${l(H)}: ${se[2]}.${se[3]}`,_),this.t({type:H,id:se[1],channelName:se[2],name:se[3],arg:_});case 101:return this.k?.logIncoming(z.byteLength,se[1],1,`${l(H)}`),this.u({type:H,id:se[1]});case 103:return this.k?.logIncoming(z.byteLength,se[1],1,`${l(H)}`),this.u({type:H,id:se[1]})}}s(z){const oe=this.b.get(z.channelName);if(!oe){this.v(z);return}const se=new D.$se;let _;try{_=oe.call(this.j,z.name,z.arg,se.token)}catch(le){_=Promise.reject(le)}const H=z.id;_.then(le=>{this.m({id:H,data:le,type:201})},le=>{le instanceof Error?this.m({id:H,data:{message:le.message,name:le.name,stack:le.stack?le.stack.split?le.stack.split(`
`):le.stack:void 0},type:202}):this.m({id:H,data:le,type:203})}).finally(()=>{ne.dispose(),this.d.delete(z.id)});const ne=(0,$.$Sc)(()=>se.cancel());this.d.set(z.id,ne)}t(z){const oe=this.b.get(z.channelName);if(!oe){this.v(z);return}const se=z.id,H=oe.listen(this.j,z.name,z.arg)(ne=>this.m({id:se,data:ne,type:204}));this.d.set(z.id,H)}u(z){const oe=this.d.get(z.id);oe&&(oe.dispose(),this.d.delete(z.id))}v(z){let oe=this.g.get(z.channelName);oe||(oe=[],this.g.set(z.channelName,oe));const se=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:z,timeoutTimer:se})}w(z){const oe=this.g.get(z);if(oe){for(const se of oe)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$ci=k;var C;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class A{constructor(z,oe=null){this.l=z,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=oe}getChannel(z){const oe=this;return{call(se,_,H){return oe.a?Promise.reject(new P.$5):oe.m(z,se,_,H)},listen(se,_){return oe.a?b.Event.None:oe.o(z,se,_)}}}m(z,oe,se,_=D.CancellationToken.None){const H=this.g++,le={id:H,type:100,channelName:z,name:oe,arg:se};if(_.isCancellationRequested)return Promise.reject(new P.$5);let F;return new Promise((X,x)=>{if(_.isCancellationRequested)return x(new P.$5);const Q=()=>{const W=ce=>{switch(ce.type){case 201:this.f.delete(H),X(ce.data);break;case 202:{this.f.delete(H);const ue=new Error(ce.data.message);ue.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ue.name=ce.data.name,x(ue);break}case 203:this.f.delete(H),x(ce.data);break}};this.f.set(H,W),this.p(le)};let G=null;this.b===h.Idle?Q():(G=(0,j.$nh)(W=>this.u()),G.then(()=>{G=null,Q()}));const J=()=>{G?(G.cancel(),G=null):this.p({id:H,type:101}),x(new P.$5)},T=_.onCancellationRequested(J);F=(0,$.$Rc)((0,$.$Sc)(J),T),this.d.add(F)}).finally(()=>{F.dispose(),this.d.delete(F)})}o(z,oe,se){const _=this.g++,ne={id:_,type:102,channelName:z,name:oe,arg:se};let le=null;const F=new b.$he({onWillAddFirstListener:()=>{le=(0,j.$nh)(X=>this.u()),le.then(()=>{le=null,this.d.add(F),this.p(ne)})},onDidRemoveLastListener:()=>{le?(le.cancel(),le=null):(this.d.delete(F),this.p({id:_,type:103}))}}),U=X=>F.fire(X.data);return this.f.set(_,U),F.event}p(z){switch(z.type){case 100:case 102:{const oe=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(oe,z.id,0,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const oe=this.q([z.type,z.id]);this.j?.logOutgoing(oe,z.id,0,l(z.type));return}}}q(z,oe=void 0){const se=new t;return i(se,z),i(se,oe),this.r(se.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const oe=new f(z),se=p(oe),_=p(oe),H=se[0];switch(H){case 200:return this.j?.logIncoming(z.byteLength,0,0,u(H)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,se[1],0,u(H),_),this.t({type:se[0],id:se[1],data:_})}}t(z){if(z.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}e.$di=A,Le([S.$5h],A.prototype,"onDidInitializePromise",null);class O{get connections(){const z=[];return this.f.forEach(oe=>z.push(oe)),z}constructor(z,oe,se){this.a=new Map,this.f=new Set,this.g=new b.$he,this.onDidAddConnection=this.g.event,this.h=new b.$he,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(z(({protocol:_,onDidClientDisconnect:H})=>{const ne=b.Event.once(_.onMessage);this.j.add(ne(le=>{const F=new f(le),U=p(F),X=new k(_,U,oe,se),x=new A(_,oe);this.a.forEach((G,J)=>X.registerChannel(J,G));const Q={channelServer:X,channelClient:x,ctx:U};this.f.add(Q),this.g.fire(Q),this.j.add(H(()=>{X.dispose(),x.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(z,oe){const se=this;return{call(_,H,ne){let le;if((0,v.$og)(oe)){const U=(0,s.$3b)(se.connections.filter(oe));le=U?Promise.resolve(U):b.Event.toPromise(b.Event.filter(se.onDidAddConnection,oe))}else le=oe.routeCall(se,_,H);const F=le.then(U=>U.channelClient.getChannel(z));return V(F).call(_,H,ne)},listen(_,H){if((0,v.$og)(oe))return se.k(z,oe,_,H);const ne=oe.routeEvent(se,_,H).then(le=>le.channelClient.getChannel(z));return V(ne).listen(_,H)}}}k(z,oe,se,_){const H=this;let ne;const le=new b.$he({onWillAddFirstListener:()=>{ne=new $.$Tc;const F=new b.$ne,U=new Map,X=Q=>{const J=Q.channelClient.getChannel(z).listen(se,_),T=F.add(J);U.set(Q,T)},x=Q=>{const G=U.get(Q);G&&(G.dispose(),U.delete(Q))};H.connections.filter(oe).forEach(X),b.Event.filter(H.onDidAddConnection,oe)(X,void 0,ne),H.onDidRemoveConnection(x,void 0,ne),F.event(le.fire,le,ne),ne.add(F)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return le.event}registerChannel(z,oe){this.a.set(z,oe);for(const se of this.f)se.channelServer.registerChannel(z,oe)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=O;class N{constructor(z,oe,se=null){const _=new t;i(_,oe),z.send(_.buffer),this.a=new A(z,se),this.d=new k(z,oe,se)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,oe){this.d.registerChannel(z,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=N;function V(M){return{call(z,oe,se){return M.then(_=>_.call(z,oe,se))},listen(z,oe){const se=new b.$qe;return M.then(_=>se.input=_.listen(z,oe)),se.event}}}function ie(M){let z=!1;return{call(oe,se,_){return z?M.call(oe,se,_):(0,j.$Bh)(0).then(()=>z=!0).then(()=>M.call(oe,se,_))},listen(oe,se){if(z)return M.listen(oe,se);const _=new b.$qe;return(0,j.$Bh)(0).then(()=>z=!0).then(()=>_.input=M.listen(oe,se)),_.event}}}class ae{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const oe of z.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await b.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ii=ae;var te;(function(M){function z(H,ne,le){const F=H,U=le&&le.disableMarshalling,X=new Map;for(const x in F)se(x)&&X.set(x,b.Event.buffer(F[x],!0,void 0,ne));return new class{listen(x,Q,G){const J=X.get(Q);if(J)return J;const T=F[Q];if(typeof T=="function"){if(_(Q))return T.call(F,G);if(se(Q))return X.set(Q,b.Event.buffer(F[Q],!0,void 0,ne)),X.get(Q)}throw new P.$bb(`Event not found: ${Q}`)}call(x,Q,G){const J=F[Q];if(typeof J=="function"){if(!U&&Array.isArray(G))for(let W=0;W<G.length;W++)G[W]=(0,y.$0h)(G[W]);let T=J.apply(F,G);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new P.$bb(`Method not found: ${Q}`)}}}M.fromService=z;function oe(H,ne){const le=ne&&ne.disableMarshalling;return new Proxy({},{get(F,U){if(typeof U=="string")return ne?.properties?.has(U)?ne.properties.get(U):_(U)?function(X){return H.listen(U,X)}:se(U)?H.listen(U):async function(...X){let x;ne&&!(0,v.$jg)(ne.context)?x=[ne.context,...X]:x=X;const Q=await H.call(U,x);return le?Q:(0,y.$0h)(Q)};throw new P.$bb(`Property not found: ${String(U)}`)}})}M.toService=oe;function se(H){return H[0]==="o"&&H[1]==="n"&&w.$Af(H.charCodeAt(2))}function _(H){return/^onDynamic/.test(H)&&w.$Af(H.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const z=M.toString();if(z!=="[object Object]")return z}return M}function B(M){return Array.isArray(M)?M.map(K):K(M)}function Z(M,z,oe,se,_,H,ne){ne=B(ne);const le=ee[_],F=le[se%le.length];let U=[`%c[${M}]%c[${String(z).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(H)?(U=U.concat(ne),U.push(")")):U.push(ne),console.log.apply(console,U)}class Y{constructor(z,oe){this.d=z,this.f=oe,this.a=0,this.b=0}logOutgoing(z,oe,se,_,H){this.b+=z,Z(this.d,this.b,z,oe,se,_,H)}logIncoming(z,oe,se,_,H){this.a+=z,Z(this.f,this.a,z,oe,se,_,H)}}e.$ji=Y}),define(ye[108],Ee([1,0,15,6,2,47]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(S||(e.SocketDiagnosticsEventType=S={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const a=new WeakMap;let i=0;function p(C,A){if(!a.has(C)){const O=String(++i);a.set(C,O)}return a.get(C)}function k(C,A,O,N){if(!n.enableDiagnostics)return;const V=p(C,A);if(N instanceof s.$Je||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const ie=s.$Je.alloc(N.byteLength);ie.set(N),n.records.push({timestamp:Date.now(),id:V,label:A,type:O,buff:ie})}else n.records.push({timestamp:Date.now(),id:V,label:A,type:O,data:N})}n.traceSocketEvent=k})(P||(e.SocketDiagnostics=P={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let $=null;function y(){return $||($=s.$Je.alloc(0)),$}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,i){if(a===0)return y();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const A=this.a[0];return i&&(this.a.shift(),this.b-=a),A}if(this.a[0].byteLength>a){const A=this.a[0].slice(0,a);return i&&(this.a[0]=this.a[0].slice(a),this.b-=a),A}const p=s.$Je.alloc(a);let k=0,C=0;for(;a>0;){const A=this.a[C];if(A.byteLength>a){const O=A.slice(0,a);p.set(O,k),k+=a,i&&(this.a[C]=A.slice(a),this.b-=a),a-=a}else p.set(A,k),k+=A.byteLength,i?(this.a.shift(),this.b-=A.byteLength):C++,a-=A.byteLength}return p}}e.$ki=w;var v;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(v||(v={}));function m(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var l;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class c{constructor(a,i,p,k){this.type=a,this.id=i,this.ack=p,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends I.$Uc{constructor(a){super(),this.f=this.B(new j.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new w,this.B(this.a.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const i=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=i.readUInt32BE(9),this.g.messageType=i.readUInt8(0),this.g.id=i.readUInt32BE(1),this.g.ack=i.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,k=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",i),this.f.fire(new c(p,k,C,i)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=s.$Je.alloc(13);i.writeUInt8(a.type,0),i.writeUInt32BE(a.id,1),i.writeUInt32BE(a.ack,5),i.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(i,a.data)}g(a,i){const p=this.f===0;return this.d.push(a,i),this.f+=a.byteLength+i.byteLength,p}h(){const a=s.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,i){this.g(a,i)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class g extends I.$Uc{constructor(a){super(),this.f=new j.$he,this.onMessage=this.f.event,this.g=new j.$he,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new h(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(i=>{i.type===1&&this.f.fire(i.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new c(1,0,0,a))}}e.$li=g;class d extends D.$fi{static fromSocket(a,i){return new d(new g(a),i)}get onDidDispose(){return this.b.onDidDispose}constructor(a,i,p=null){super(a,i,p),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$mi=d;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new j.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$ni=E;class f{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,i=this.a;for(;i;)i=i.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let i=0,p=this.a;for(;p;)a[i++]=p.data,p=p.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const i=new f(a);if(!this.a){this.a=i,this.b=i;return}this.b.next=i,this.b=i}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const a=Date.now();for(let i=0;i<o.a;i++)this.c[i]=a-1e3*i;setInterval(()=>{for(let i=o.a;i>=1;i--)this.c[i]=this.c[i-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),i=(1+o.a)*1e3;let p=0;for(let k=0;k<o.a;k++)a-this.c[k]<=i&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??o.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new I.$Tc,this.o=a.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(i=>this.z(i))),this.r.add(this.o.onClose(i=>this.x.fire(i))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new c(5,0,0,y());this.p.write(a),this.p.flush()}sendPause(){const a=new c(7,0,0,y());this.p.write(a)}sendResume(){const a=new c(8,0,0,y());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,i){this.a=!0,this.r.dispose(),this.r=new I.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(i)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new c(3,0,this.h,y());this.p.write(a);const i=this.b.toArray();for(let p=0,k=i.length;p<k;p++)this.p.write(i[p]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const i=this.b.peek();if(i&&i.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const i=Date.now();i-this.m>1e4&&(this.m=i,this.p.write(new c(6,0,0,y())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const i=this.b.toArray();for(let p=0,k=i.length;p<k;p++)this.p.write(i[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const i=++this.c;this.h=this.g;const p=new c(1,i,this.h,a);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(a){const i=new c(2,0,0,a);this.p.write(i)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),i=Date.now()-a.writtenTime,p=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(i>=2e4&&p>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:i,timeSinceLastReceivedSomeData:p});return}const C=Math.max(2e4-i,2e4-p,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new c(3,0,this.h,y());this.p.write(a)}D(){this.h=this.g;const a=new c(9,0,this.h,y());this.p.write(a)}}e.$oi=r}),define(ye[109],Ee([1,0,56,14,15,20,179,11,6,2,21,105,66,47]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class l extends m.$ci{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>I.$Je.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$6q=l;class c{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new b.$he,this.onDidProcessExit=this.h.event;const d=g&&g.timeout?g.timeout:6e4;this.b=new j.$xh(d),this.d=null,this.f=null}getChannel(h){const g=this;return{call(d,E,f){return g.k(h,d,E,f)},listen(d,E){return g.l(h,d,E)}}}k(h,g,d,E=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const f=this.n(h),t=(0,j.$nh)(n=>f.call(g,d,n)),o=E.onCancellationRequested(()=>t.cancel()),r=(0,$.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,g,d){if(!this.b)return b.Event.None;this.b.cancel();let E;const f=new b.$he({onWillAddFirstListener:()=>{E=this.n(h).listen(g,d)(f.fire,f),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,y.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,v.$rm)(g.env),this.d=(0,s.fork)(this.i,h,g);const d=new b.$he,f=b.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,S.$2q)(i)){(0,S.log)(i,`IPC Library: ${this.j.serverName}`);return}d.fire(I.$Je.wrap(Buffer.from(i,"base64")))}),t=this.j.useQueue?(0,w.$tm)(this.d):this.d,o=i=>this.d&&this.d.connected&&t.send(i.buffer.toString("base64")),r=d.event,n={send:o,onMessage:r};this.f=new m.$di(n);const a=()=>this.o();process.once("exit",a),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,p)=>{process.removeListener("exit",a),f.dispose(),this.c.forEach(k=>(0,$.$Pc)(k)),this.c.clear(),i!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+p),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:p})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=c}),define(ye[184],Ee([1,0,14,6,2,46,10]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=b;var P;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function b(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}var $;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})($||(e.StorageState=$={}));class y extends I.$Uc{static{this.a=100}constructor(m,l=Object.create(null)){super(),this.r=m,this.s=l,this.b=this.B(new j.$ke),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new s.$yh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((l,c)=>this.w(c,l)),m.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(m,l){if(this.c===$.Closed)return;let c=!1;(0,S.$jg)(l)?c=this.f.delete(m):this.f.get(m)!==l&&(this.f.set(m,l),c=!0),c&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,l){const c=this.f.get(m);return(0,S.$jg)(c)?l:c}getBoolean(m,l){const c=this.get(m);return(0,S.$jg)(c)?l:c==="true"}getNumber(m,l){const c=this.get(m);return(0,S.$jg)(c)?l:parseInt(c,10)}getObject(m,l){const c=this.get(m);return(0,S.$jg)(c)?l:(0,D.$9h)(c)}async set(m,l,c=!1){if(this.c===$.Closed)return;if((0,S.$jg)(l))return this.delete(m,c);const u=(0,S.$cg)(l)||Array.isArray(l)?(0,D.$8h)(l):String(l);if(this.f.get(m)!==u)return this.f.set(m,u),this.j.set(m,u),this.h.delete(m),this.b.fire({key:m,external:c}),this.D()}async delete(m,l=!1){if(!(this.c===$.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:l}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(!(this.c===$.Closed||this.m))return this.D(m)}async D(m){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$3p=y;class w{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((l,c)=>this.a.set(c,l)),m.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$4p=w}),define(ye[185],Ee([8,9]),function(fe,e){return fe.create("vs/base/node/zip",e)}),define(ye[81],Ee([1,0,28,14,7,10,23,185]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0,e.zip=u,e.$pq=h,e.$qq=d,e.$mq="end of central directory record signature not found";const b=new RegExp(e.$mq);class $ extends Error{constructor(f,t){let o=t.message;switch(f){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=f,this.cause=t}}e.$nq=$;function y(E){const f=E.externalFileAttributes>>16||33188;return[448,56,7].map(t=>f&t).reduce((t,o)=>t+o,f&61440)}function w(E){if(E instanceof $)return E;let f;return b.test(E.message)&&(f="CorruptZip"),new $(f,E)}function v(E,f,t,o,r,n){const a=I.$mc(f),i=I.$jc(o,a);if(!i.startsWith(o))return Promise.reject(new Error(P.localize(0,null,f)));const p=I.$jc(o,f);let k;return n.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(S.Promises.mkdir(i,{recursive:!0})).then(()=>new Promise((C,A)=>{if(!n.isCancellationRequested)try{k=(0,s.createWriteStream)(p,{mode:t}),k.once("close",()=>C()),k.once("error",A),E.once("error",A),E.pipe(k)}catch(O){A(O)}}))}function m(E,f,t,o){let r=(0,j.$nh)(()=>Promise.resolve()),n=0;const a=o.onCancellationRequested(()=>{r.cancel(),E.close()});return new Promise((i,p)=>{const k=new j.$vh,C=A=>{A.isCancellationRequested||(n++,E.readEntry())};E.once("error",p),E.once("close",()=>r.then(()=>{o.isCancellationRequested||E.entryCount===n?i():p(new $("Incomplete",new Error(P.localize(1,null,n,E.entryCount))))},p)),E.readEntry(),E.on("entry",A=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(A.fileName)){C(o);return}const O=A.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(O)){const ie=I.$jc(f,O);r=(0,j.$nh)(ae=>S.Promises.mkdir(ie,{recursive:!0}).then(()=>C(ae)).then(void 0,p));return}const N=c(E,A),V=y(A);r=(0,j.$nh)(ie=>k.queue(()=>N.then(ae=>v(ae,O,V,f,t,ie).then(()=>C(ie)))).then(null,p))})}).finally(()=>a.dispose())}async function l(E,f=!1){const{open:t}=await new Promise((o,r)=>{fe(["yauzl"],o,r)});return new Promise((o,r)=>{t(E,f?{lazyEntries:!0}:void 0,(n,a)=>{n?r(w(n)):o((0,D.$lg)(a))})})}function c(E,f){return new Promise((t,o)=>{E.openReadStream(f,(r,n)=>{r?o(w(r)):t((0,D.$lg)(n))})})}async function u(E,f){const{ZipFile:t}=await new Promise((o,r)=>{fe(["yazl"],o,r)});return new Promise((o,r)=>{const n=new t;f.forEach(i=>{i.contents?n.addBuffer(typeof i.contents=="string"?Buffer.from(i.contents,"utf8"):i.contents,i.path):i.localPath&&n.addFile(i.localPath,i.path)}),n.end();const a=(0,s.createWriteStream)(E);n.outputStream.pipe(a),n.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>o(E))})}function h(E,f,t={},o){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let n=l(E,!0);return t.overwrite&&(n=n.then(a=>S.Promises.rm(f).then(()=>a))),n.then(a=>m(a,f,{sourcePathRegex:r},o))}function g(E,f){return l(E).then(t=>new Promise((o,r)=>{t.on("entry",n=>{n.fileName===f&&c(t,n).then(a=>o(a),a=>r(a))}),t.once("close",()=>r(new Error(P.localize(2,null,f))))}))}function d(E,f){return g(E,f).then(t=>new Promise((o,r)=>{const n=[];t.once("error",r),t.on("data",a=>n.push(a)),t.on("end",()=>o(Buffer.concat(n)))}))}}),define(ye[186],Ee([8,9]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(ye[187],Ee([1,0,54,4,169,45,170,186]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Bu=e.$Au=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$zu=e.$yu=e.SymbolKinds=e.SymbolTag=e.$wu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$uu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$tu=e.$su=e.$ru=void 0,e.$vu=r,e.$xu=a;class b{constructor(z,oe,se){this.offset=z,this.type=oe,this.language=se,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ru=b;class ${constructor(z,oe){this.tokens=z,this.endState=oe,this._tokenizationResultBrand=void 0}}e.$su=$;class y{constructor(z,oe){this.tokens=z,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}e.$tu=y;var w;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(w||(e.HoverVerbosityAction=w={}));var v;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(v||(e.CompletionItemKind=v={}));var m;(function(M){const z=new Map;z.set(0,s.$Zj.symbolMethod),z.set(1,s.$Zj.symbolFunction),z.set(2,s.$Zj.symbolConstructor),z.set(3,s.$Zj.symbolField),z.set(4,s.$Zj.symbolVariable),z.set(5,s.$Zj.symbolClass),z.set(6,s.$Zj.symbolStruct),z.set(7,s.$Zj.symbolInterface),z.set(8,s.$Zj.symbolModule),z.set(9,s.$Zj.symbolProperty),z.set(10,s.$Zj.symbolEvent),z.set(11,s.$Zj.symbolOperator),z.set(12,s.$Zj.symbolUnit),z.set(13,s.$Zj.symbolValue),z.set(15,s.$Zj.symbolEnum),z.set(14,s.$Zj.symbolConstant),z.set(15,s.$Zj.symbolEnum),z.set(16,s.$Zj.symbolEnumMember),z.set(17,s.$Zj.symbolKeyword),z.set(27,s.$Zj.symbolSnippet),z.set(18,s.$Zj.symbolText),z.set(19,s.$Zj.symbolColor),z.set(20,s.$Zj.symbolFile),z.set(21,s.$Zj.symbolReference),z.set(22,s.$Zj.symbolCustomColor),z.set(23,s.$Zj.symbolFolder),z.set(24,s.$Zj.symbolTypeParameter),z.set(25,s.$Zj.account),z.set(26,s.$Zj.issues);function oe(H){let ne=z.get(H);return ne||(console.info("No codicon found for CompletionItemKind "+H),ne=s.$Zj.symbolProperty),ne}M.toIcon=oe;const se=new Map;se.set("method",0),se.set("function",1),se.set("constructor",2),se.set("field",3),se.set("variable",4),se.set("class",5),se.set("struct",6),se.set("interface",7),se.set("module",8),se.set("property",9),se.set("event",10),se.set("operator",11),se.set("unit",12),se.set("value",13),se.set("constant",14),se.set("enum",15),se.set("enum-member",16),se.set("enumMember",16),se.set("keyword",17),se.set("snippet",27),se.set("text",18),se.set("color",19),se.set("file",20),se.set("reference",21),se.set("customcolor",22),se.set("folder",23),se.set("type-parameter",24),se.set("typeParameter",24),se.set("account",25),se.set("issue",26);function _(H,ne){let le=se.get(H);return typeof le>"u"&&!ne&&(le=9),le}M.fromString=_})(m||(e.CompletionItemKinds=m={}));var l;(function(M){M[M.Deprecated=1]="Deprecated"})(l||(e.CompletionItemTag=l={}));var c;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var u;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(u||(e.PartialAcceptTriggerKind=u={}));var h;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var g;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class d{constructor(z,oe,se,_){this.range=z,this.text=oe,this.completionKind=se,this.isSnippetText=_}equals(z){return D.$At.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$uu=d;var E;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(E||(e.CodeActionTriggerType=E={}));var f;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(f||(e.DocumentPasteTriggerKind=f={}));var t;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function r(M){return M&&j.URI.isUri(M.uri)&&D.$At.isIRange(M.range)&&(D.$At.isIRange(M.originSelectionRange)||D.$At.isIRange(M.targetSelectionRange))}var n;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(n||(e.SymbolKind=n={})),e.$wu={17:(0,P.localize)(0,null),16:(0,P.localize)(1,null),4:(0,P.localize)(2,null),13:(0,P.localize)(3,null),8:(0,P.localize)(4,null),9:(0,P.localize)(5,null),21:(0,P.localize)(6,null),23:(0,P.localize)(7,null),7:(0,P.localize)(8,null),0:(0,P.localize)(9,null),11:(0,P.localize)(10,null),10:(0,P.localize)(11,null),19:(0,P.localize)(12,null),5:(0,P.localize)(13,null),1:(0,P.localize)(14,null),2:(0,P.localize)(15,null),20:(0,P.localize)(16,null),15:(0,P.localize)(17,null),18:(0,P.localize)(18,null),24:(0,P.localize)(19,null),3:(0,P.localize)(20,null),6:(0,P.localize)(21,null),14:(0,P.localize)(22,null),22:(0,P.localize)(23,null),25:(0,P.localize)(24,null),12:(0,P.localize)(25,null)};function a(M,z){return(0,P.localize)(26,null,M,e.$wu[z])}var i;(function(M){M[M.Deprecated=1]="Deprecated"})(i||(e.SymbolTag=i={}));var p;(function(M){const z=new Map;z.set(0,s.$Zj.symbolFile),z.set(1,s.$Zj.symbolModule),z.set(2,s.$Zj.symbolNamespace),z.set(3,s.$Zj.symbolPackage),z.set(4,s.$Zj.symbolClass),z.set(5,s.$Zj.symbolMethod),z.set(6,s.$Zj.symbolProperty),z.set(7,s.$Zj.symbolField),z.set(8,s.$Zj.symbolConstructor),z.set(9,s.$Zj.symbolEnum),z.set(10,s.$Zj.symbolInterface),z.set(11,s.$Zj.symbolFunction),z.set(12,s.$Zj.symbolVariable),z.set(13,s.$Zj.symbolConstant),z.set(14,s.$Zj.symbolString),z.set(15,s.$Zj.symbolNumber),z.set(16,s.$Zj.symbolBoolean),z.set(17,s.$Zj.symbolArray),z.set(18,s.$Zj.symbolObject),z.set(19,s.$Zj.symbolKey),z.set(20,s.$Zj.symbolNull),z.set(21,s.$Zj.symbolEnumMember),z.set(22,s.$Zj.symbolStruct),z.set(23,s.$Zj.symbolEvent),z.set(24,s.$Zj.symbolOperator),z.set(25,s.$Zj.symbolTypeParameter);function oe(se){let _=z.get(se);return _||(console.info("No codicon found for SymbolKind "+se),_=s.$Zj.symbolProperty),_}M.toIcon=oe})(p||(e.SymbolKinds=p={}));class k{static asEditOperation(z){return I.$Bt.replace(D.$At.lift(z.range),z.text)}}e.$yu=k;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(z){switch(z){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(z)}constructor(z){this.value=z}}e.$zu=C;var A;(function(M){M[M.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var O;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(O||(e.NewSymbolNameTriggerKind=O={}));var N;(function(M){function z(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}M.is=z})(N||(e.Command=N={}));var V;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(V||(e.CommentThreadCollapsibleState=V={}));var ie;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(ie||(e.CommentThreadState=ie={}));var ae;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(ae||(e.CommentThreadApplicability=ae={}));var te;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(te||(e.CommentMode=te={}));var ee;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(ee||(e.CommentState=ee={}));var K;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(K||(e.InlayHintKind=K={}));class B{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Au=B,e.$Bu=new S.$ju;var Z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(Z||(e.ExternalUriOpenerPriority=Z={}));var Y;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Y||(e.InlineEditTriggerKind=Y={}))}),define(ye[188],Ee([8,9]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[189],Ee([8,9]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[190],Ee([8,9]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(ye[191],Ee([8,9]),function(fe,e){return fe.create("vs/platform/environment/node/argv",e)}),define(ye[192],Ee([8,9]),function(fe,e){return fe.create("vs/platform/environment/node/argvHelper",e)}),define(ye[193],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ye[194],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[195],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ye[196],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ye[197],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ye[198],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ye[199],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ye[200],Ee([8,9]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[201],Ee([8,9]),function(fe,e){return fe.create("vs/platform/files/common/fileService",e)}),define(ye[202],Ee([8,9]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(ye[203],Ee([8,9]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(ye[204],Ee([8,9]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[205],Ee([8,9]),function(fe,e){return fe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ye[206],Ee([8,9]),function(fe,e){return fe.create("vs/platform/log/common/log",e)}),define(ye[207],Ee([8,9]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(ye[208],Ee([8,9]),function(fe,e){return fe.create("vs/platform/request/common/request",e)}),define(ye[209],Ee([8,9]),function(fe,e){return fe.create("vs/platform/shell/node/shellEnv",e)}),define(ye[210],Ee([8,9]),function(fe,e){return fe.create("vs/platform/telemetry/common/telemetryService",e)}),define(ye[211],Ee([8,9]),function(fe,e){return fe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ye[212],Ee([8,9]),function(fe,e){return fe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ye[213],Ee([8,9]),function(fe,e){return fe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[214],Ee([8,9]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(ye[215],Ee([8,9]),function(fe,e){return fe.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ye[216],Ee([8,9]),function(fe,e){return fe.create("vs/server/node/serverEnvironmentService",e)}),define(ye[217],Ee([8,9]),function(fe,e){return fe.create("vs/server/node/serverServices",e)}),define(ye[218],Ee([8,9]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[219],Ee([8,9]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(ye[220],Ee([8,9]),function(fe,e){return fe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[221],Ee([8,9]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[222],Ee([8,9]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ye[223],Ee([1,0,11,190]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var I;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(I||(e.TokenType=I={}));function D(...$){switch($.length){case 1:return(0,j.localize)(0,null,$[0]);case 2:return(0,j.localize)(1,null,$[0],$[1]);case 3:return(0,j.localize)(2,null,$[0],$[1],$[2]);default:return}}const S=(0,j.localize)(3,null),P=(0,j.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,s.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const w=this.d,v=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:v};this.g.push({offset:w,lexeme:v,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const w=this.c.substring(this.d,this.e),v=b.b.get(w);v?this.k(v):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(S);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,w=!1,v=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const l=this.c.charCodeAt(y);if(w)w=!1;else if(l===47&&!v){y++;break}else l===91?v=!0:l===92?w=!0:l===93&&(v=!1);y++}for(;y<this.c.length&&b.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=b}),define(ye[224],Ee([1,0,6,2]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=void 0;class I{constructor(){this.a=new s.$he,this.b=new s.$he,this.c=new s.$he,this.d=new s.$he}static{this.ChannelName="extensionhostdebugservice"}call(P,b,$){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(P,b,$){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$No=I;class D extends j.$Uc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,b,$){this.b.call("attach",[P,b,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,b){this.b.call("terminate",[P,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,b){return this.b.call("openExtensionDevelopmentHostWindow",[P,b])}}e.$Oo=D}),define(ye[225],Ee([1,0,4]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=void 0;class j{constructor(S){this.a=S}listen(S,P,b){throw new Error("Invalid listen")}call(S,P,b){switch(P){case"download":return this.a.download(s.URI.revive(b[0]),s.URI.revive(b[1]))}throw new Error("Invalid call")}}e.$Qo=j;class I{constructor(S,P){this.a=S,this.b=P}async download(S,P){const b=this.b();b&&(S=b.transformOutgoingURI(S),P=b.transformOutgoingURI(P)),await this.a.call("download",[S,P])}}e.$Ro=I}),define(ye[226],Ee([1,0,174,74,13,7,32,19,4]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=y,e.$_m=w,e.$9m=/^([^.]+\..+)[:=](.+)$/;class ${get appRoot(){return(0,D.$mc)(I.$Ug.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$jc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,P.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,s.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$jc)(this.userDataPath,"logs",m)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$bh)(b.URI.file((0,D.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=S.env.VSCODE_PORTABLE;return m?b.URI.file((0,D.$jc)(m,"argv.json")):(0,P.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.$kc)(m):(0,D.$hc)((0,D.$jc)(I.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?b.URI.file((0,D.$kc)(m)):b.URI.file((0,D.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.$kc)(m);const l=S.env.VSCODE_EXTENSIONS;if(l)return l;const c=S.env.VSCODE_PORTABLE;return c?(0,D.$jc)(c,"extensions"):(0,P.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(l=>/^[^:/?#]+?:\/\//.test(l)?b.URI.parse(l):b.URI.file((0,D.$hc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?b.URI.parse(m):b.URI.file((0,D.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$9m.test(m))}get extensionLogLevel(){const m=[];for(const l of this.args.log||[]){const c=e.$9m.exec(l);c&&c[1]&&c[2]&&m.push([c[1],c[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.$bh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=S.env.VSCODE_PORTABLE;return m?b.URI.file((0,D.$jc)(m,"policy.json")):(0,P.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,l,c){this.a=m,this.b=l,this.c=c,this.editSessionId=this.args.editSessionId}}e.$0m=$,Le([j.$5h],$.prototype,"appRoot",null),Le([j.$5h],$.prototype,"userHome",null),Le([j.$5h],$.prototype,"userDataPath",null),Le([j.$5h],$.prototype,"appSettingsHome",null),Le([j.$5h],$.prototype,"tmpDir",null),Le([j.$5h],$.prototype,"cacheHome",null),Le([j.$5h],$.prototype,"stateResource",null),Le([j.$5h],$.prototype,"userRoamingDataHome",null),Le([j.$5h],$.prototype,"userDataSyncHome",null),Le([j.$5h],$.prototype,"sync",null),Le([j.$5h],$.prototype,"machineSettingsResource",null),Le([j.$5h],$.prototype,"workspaceStorageHome",null),Le([j.$5h],$.prototype,"localHistoryHome",null),Le([j.$5h],$.prototype,"keyboardLayoutResource",null),Le([j.$5h],$.prototype,"argvResource",null),Le([j.$5h],$.prototype,"isExtensionDevelopment",null),Le([j.$5h],$.prototype,"untitledWorkspacesHome",null),Le([j.$5h],$.prototype,"builtinExtensionsPath",null),Le([j.$5h],$.prototype,"extensionsPath",null),Le([j.$5h],$.prototype,"extensionDevelopmentLocationURI",null),Le([j.$5h],$.prototype,"extensionDevelopmentKind",null),Le([j.$5h],$.prototype,"extensionTestsLocationURI",null),Le([j.$5h],$.prototype,"debugExtensionHost",null),Le([j.$5h],$.prototype,"logLevel",null),Le([j.$5h],$.prototype,"extensionLogLevel",null),Le([j.$5h],$.prototype,"serviceMachineIdResource",null),Le([j.$5h],$.prototype,"disableTelemetry",null),Le([j.$5h],$.prototype,"disableWorkspaceTrust",null),Le([j.$5h],$.prototype,"useInMemorySecretStorage",null),Le([j.$5h],$.prototype,"policyFile",null);function y(v,m){return w(v["inspect-extensions"],v["inspect-brk-extensions"],5870,m,v.debugId,v.extensionEnvironment)}function w(v,m,l,c,u,h){const d=Number(m||v)||(c?null:l),E=d?!!m:!1;let f;if(h)try{f=JSON.parse(h)}catch{}return{port:d,break:E,debugId:u,env:f}}}),define(ye[67],Ee([1,0,311,3,191]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$xm=P,e.$ym=$,e.$zm=m,e.$Am=l;const D={o:(0,I.localize)(0,null),e:(0,I.localize)(1,null),t:(0,I.localize)(2,null)};e.$vm=["tunnel","serve-web"],e.$wm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,I.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(c,u,h=S){const g=c.find(i=>i.length>0&&i[0]!=="-"),d={},E=["_"],f=[],t={};let o;for(const i in u){const p=u[i];p.type==="subcommand"?i===g&&(o=p):(p.alias&&(d[i]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(i),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(f.push(i),p.deprecates&&f.push(...p.deprecates)),p.global&&(t[i]=p))}if(o&&g){const i=t;for(const A in o.options)i[A]=o.options[A];const p=c.filter(A=>A!==g),k=h.getSubcommandReporter?h.getSubcommandReporter(g):void 0,C=P(p,i,k);return{[g]:C,_:[]}}const r=s(c,{string:E,boolean:f,alias:d}),n={},a=r;n._=r._.map(i=>String(i)).filter(i=>i.length>0),delete a._;for(const i in u){const p=u[i];if(p.type==="subcommand")continue;p.alias&&delete a[p.alias];let k=a[i];if(p.deprecates)for(const C of p.deprecates)a.hasOwnProperty(C)&&(k||(k=a[C],k&&h.onDeprecatedOption(C,p.deprecationMessage||(0,I.localize)(39,null,i))),delete a[C]);if(typeof k<"u"){if(p.type==="string[]"){if(Array.isArray(k)||(k=[k]),!p.allowEmptyValue){const C=k.filter(A=>A.length>0);C.length!==k.length&&(h.onEmptyValue(i),k=C.length>0?C:void 0)}}else p.type==="string"&&(Array.isArray(k)?(k=k.pop(),h.onMultipleValues(i,k)):!k&&!p.allowEmptyValue&&(h.onEmptyValue(i),k=void 0));n[i]=k,p.deprecationMessage&&h.onDeprecatedOption(i,p.deprecationMessage)}delete a[i]}for(const i in a)h.onUnknownOption(i);return n}function b(c,u){let h="";return u.args&&(Array.isArray(u.args)?h=` <${u.args.join("> <")}>`:h=` <${u.args}>`),u.alias?`-${u.alias} --${c}${h}`:`--${c}${h}`}function $(c,u){const h=[];for(const g in c){const d=c[g],E=b(g,d);h.push([E,d.description])}return y(h,u)}function y(c,u){const g=c.reduce((f,t)=>Math.max(f,t[0].length),12)+2+1;if(u-g<25)return c.reduce((f,t)=>f.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=u-g-1,E=[];for(const f of c){const t=f[0],o=v(f[1],d),r=w(g-t.length-2);E.push("  "+t+r+o[0]);for(let n=1;n<o.length;n++)E.push(w(g)+o[n])}return E}function w(c){return" ".repeat(c)}function v(c,u){const h=[];for(;c.length;){const g=c.length<u?c.length:c.lastIndexOf(" ",u),d=c.slice(0,g).trim();c=c.slice(g),h.push(d)}return h}function m(c,u,h,g,d){const E=process.stdout.isTTY&&process.stdout.columns||80,f=d?.noInputFiles!==!0?`[${(0,I.localize)(40,null)}...]`:"",t=[`${c} ${h}`];t.push(""),t.push(`${(0,I.localize)(41,null)}: ${u} [${(0,I.localize)(42,null)}]${f}`),t.push(""),d?.noPipe!==!0&&(j.$i?t.push((0,I.localize)(43,null,u)):t.push((0,I.localize)(44,null,u)),t.push(""));const o={},r=[];for(const n in g){const a=g[n];if(a.type==="subcommand")a.description&&r.push({command:n,description:a.description});else if(a.description&&a.cat){let i=o[a.cat];i||(o[a.cat]=i={}),i[n]=a}}for(const n in o){const a=n,i=o[a];i&&(t.push(D[a]),t.push(...$(i,E)),t.push(""))}return r.length&&(t.push((0,I.localize)(45,null)),t.push(...y(r.map(n=>[n.command,n.description]),E)),t.push("")),t.join(`
`)}function l(c,u){return`${c||(0,I.localize)(46,null)}
${u||(0,I.localize)(47,null)}
${process.arch}`}}),define(ye[227],Ee([1,0,312,192,67]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=P,e.$Cm=b,e.$Dm=$,e.$Em=y;function D(w,v){const m=(d,E)=>{console.warn((0,j.localize)(0,null,d,E))},l=d=>{console.warn((0,j.localize)(1,null,d))},c=(d,E)=>{console.warn((0,j.localize)(2,null,d,E))},u=d=>({onUnknownOption:E=>{I.$vm.includes(d)||console.warn((0,j.localize)(3,null,E,d))},onMultipleValues:m,onEmptyValue:l,onDeprecatedOption:c,getSubcommandReporter:I.$vm.includes(d)?u:void 0}),h={onUnknownOption:d=>{console.warn((0,j.localize)(4,null,d))},onMultipleValues:m,onEmptyValue:l,onDeprecatedOption:c,getSubcommandReporter:u},g=(0,I.$xm)(w,I.$wm,v?h:void 0);return g.goto&&g._.forEach(d=>s(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,j.localize)(5,null))),g}function S(w){const v=w.findIndex(m=>!/^-/.test(m));if(v>-1)return[...w.slice(0,v),...w.slice(v+1)]}function P(w){let[,...v]=w;process.env.VSCODE_DEV&&(v=S(v)||[]);const m=!y(process.env);return D(v,m)}function b(w){let[,,...v]=w;return process.env.VSCODE_DEV&&(v=S(v)||[]),D(v,!0)}function $(w,...v){const m=w.indexOf("--");return m===-1?w.push(...v):w.splice(m,0,...v),w}function y(w){return w.VSCODE_CLI==="1"}}),function(){"use strict";function fe(e,s,j){function I(S,P){const b=D(S,P),$=[b];return e.isAbsolute(b)||$.unshift(j),e.resolve(...$)}function D(S,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,P);const y=S["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(w,"AppData","Roaming")}break;case"darwin":$=e.join(s.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(s.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,P)}return{getUserDataPath:I}}if(typeof define=="function")define(ye[228],Ee([77,31,32]),function(e,s,j){return fe(e,s,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),s=require("os");module.exports=fe(e,s,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ye[110],Ee([1,0,31,226,228]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=S,e.$cn=P;class D extends j.$0m{constructor($,y){super($,{homeDir:(0,s.homedir)(),tmpDir:(0,s.tmpdir)(),userDataDir:(0,I.getUserDataPath)($,y.nameShort)},y)}}e.$an=D;function S(b,$){return(0,j.$_m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,$,b.extensionEnvironment)}function P(b,$){return(0,j.$_m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,$,b.extensionEnvironment)}}),define(ye[229],Ee([1,0,10,196]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=I;function I(S,P,b,$){try{D(S,P,b,$)}catch(y){S.error(y?.message??y)}return P}function D(S,P,b,$){const y=(w,v,m)=>{const l=w[v];if((0,s.$ag)(l)){const c=l,u=c.length;if(u>1&&c[0]==="%"&&c[u-1]==="%"){const h=c.substr(1,u-2);let g=b[h];g===void 0&&$&&(g=$[h]);const d=typeof g=="string"?g:g?.message,E=$?.[h],f=typeof E=="string"?E:E?.message;if(!d){f||S.warn(`[${P.name}]: ${(0,j.localize)(0,null,h)}`);return}if(m&&(v==="title"||v==="category")&&f&&f!==d){const t={value:d,original:f};w[v]=t}else w[v]=d}}else if((0,s.$cg)(l))for(const c in l)l.hasOwnProperty(c)&&(c==="commands"?y(l,c,!0):y(l,c,m));else if(Array.isArray(l))for(let c=0;c<l.length;c++)y(l,c,m)};for(const w in P)P.hasOwnProperty(w)&&y(P,w)}}),define(ye[82],Ee([1,0,19,63,200,57]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=b,e.$Np=$,e.$Op=y,e.$Pp=w,e.$Qp=v,e.$Rp=m,e.$Sp=l;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(h){return h=h.trim(),h==="*"||S.test(h)}function $(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(S);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function y(h){if(!h)return null;const g=h.majorBase,d=h.majorMustEqual,E=h.minorBase;let f=h.minorMustEqual;const t=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(g===0||(f=!1),o=!1);let r=0;if(h.preRelease){const n=P.exec(h.preRelease);if(n){const[,a,i,p]=n;r=Date.UTC(Number(a),Number(i)-1,Number(p))}}return{majorBase:g,majorMustEqual:d,minorBase:E,minorMustEqual:f,patchBase:t,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:r}}function w(h,g,d){let E;typeof h=="string"?E=y($(h)):E=h;let f;g instanceof Date?f=g.getTime():typeof g=="string"&&(f=new Date(g).getTime());let t;if(typeof d=="string"?t=y($(d)):t=d,!E||!t)return!1;const o=E.majorBase,r=E.minorBase,n=E.patchBase;let a=t.majorBase,i=t.minorBase,p=t.patchBase;const k=t.notBefore;let C=t.majorMustEqual,A=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?o>a?!0:o<a?!1:r>i?!0:r<i||f&&f<k?!1:n>=p:(o===1&&a===0&&(!C||!A||!O)&&(a=1,i=0,p=0,C=!0,A=!1,O=!1),o<a?!1:o>a?!C:r<i?!1:r>i?!A:n<p?!1:n>p?!O:!(f&&f<k))}function v(h,g,d,E,f){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([j.default.Error,I.localize(0,null)]),t;if(typeof E.name!="string")return t.push([j.default.Error,I.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([j.default.Error,I.localize(2,null,"version")]),t;if(!E.engines)return t.push([j.default.Error,I.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([j.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!u(E.extensionDependencies))return t.push([j.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!u(E.activationEvents))return t.push([j.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([j.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([j.default.Warning,I.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([j.default.Error,I.localize(9,null,"main")]),t;{const n=(0,s.$bh)(d,E.main);(0,s.$8g)(n,d)||t.push([j.default.Warning,I.localize(10,null,n.path,d.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([j.default.Error,I.localize(11,null,"browser")]),t;{const n=(0,s.$bh)(d,E.browser);(0,s.$8g)(n,d)||t.push([j.default.Warning,I.localize(12,null,n.path,d.path)])}}if(!D.valid(E.version))return t.push([j.default.Error,I.localize(13,null)]),t;const o=[];if(!m(h,g,E,f,o))for(const n of o)t.push([j.default.Error,n]);return t}function m(h,g,d,E,f){return E||typeof d.main>"u"&&typeof d.browser>"u"?!0:c(h,g,d.engines.vscode,f)}function l(h,g,d){return h==="*"||c(g,d,h)}function c(h,g,d,E=[]){const f=y($(d));if(!f)return E.push(I.localize(14,null,d)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return E.push(I.localize(15,null,d)),!1}else if(!f.majorMustEqual)return E.push(I.localize(16,null,d)),!1;return w(h,g,f)?!0:(E.push(I.localize(17,null,h,d)),!1)}function u(h){if(!Array.isArray(h))return!1;for(let g=0,d=h.length;g<d;g++)if(typeof h[g]!="string")return!1;return!0}}),define(ye[230],Ee([1,0,15,22]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=I;async function I(D,S,P){let b=P&&P.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const y=(await S.readFile(D.serviceMachineIdResource)).value.toString();b=(0,j.$Vg)(y)?y:null}catch{b=null}if(!b){b=(0,j.$Wg)();try{await S.writeFile(D.serviceMachineIdResource,s.$Je.fromString(b))}catch{}}return P?.store("storage.serviceMachineId",b,-1,1),b}}),define(ye[68],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class s{constructor(I,D=[],S=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=S}}e.$xi=s}),define(ye[111],Ee([1,0,68]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=D,e.$Es=S;const j=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function D(P,b,$){b instanceof s.$xi||(b=new s.$xi(b,[],!!$)),j.push([P,b])}function S(){return j}}),define(ye[231],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class s{constructor(D,S){this.key=D,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.$gr=s;class j{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const S of this.a.values())S.outgoing.size===0&&D.push(S);return D}insertEdge(D,S){const P=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(S);P.outgoing.set(b.key,b),b.incoming.set(P.key,P)}removeNode(D){const S=this.b(D);this.a.delete(S);for(const P of this.a.values())P.outgoing.delete(S),P.incoming.delete(S)}lookupOrInsertNode(D){const S=this.b(D);let P=this.a.get(S);return P||(P=new s(S,D),this.a.set(S,P)),P}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[S,P]of this.a)D.push(`${S}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,S]of this.a){const P=new Set([D]),b=this.c(S,P);if(b)return b}}c(D,S){for(const[P,b]of D.outgoing){if(S.has(P))return[...S,P].join(" -> ");S.add(P);const $=this.c(b,S);if($)return $;S.delete(P)}}}e.$hr=j}),define(ye[5],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=I,e.$Bi=D;var s;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=P})(s||(e._util=s={})),e.$zi=I("instantiationService");function j(S,P,b){P[s.DI_TARGET]===P?P[s.DI_DEPENDENCIES].push({id:S,index:b}):(P[s.DI_DEPENDENCIES]=[{id:S,index:b}],P[s.DI_TARGET]=P)}function I(S){if(s.serviceIds.has(S))return s.serviceIds.get(S);const P=function(b,$,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");j(P,b,y)};return P.toString=()=>S,s.serviceIds.set(S,P),P}function D(S){return S}}),define(ye[25],Ee([1,0,10,4,5]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=D,e.$9i=S,e.$0i=b,e.$$i=$,e.$_i=y,e.$aj=w,e.$bj=v,e.$cj=l,e.$dj=c,e.$ej=u,e.$7i=(0,I.$Ai)("configurationService");function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof j.URI)}function S(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof j.URI)}var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function b(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function $(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function y(h,g){const d=Object.create(null);for(const E in h)w(d,E,h[E],g);return d}function w(h,g,d,E){const f=g.split("."),t=f.pop();let o=h;for(let r=0;r<f.length;r++){const n=f[r];let a=o[n];switch(typeof a){case"undefined":a=o[n]=Object.create(null);break;case"object":if(a===null){E(`Ignoring ${g} as ${f.slice(0,r+1).join(".")} is null`);return}break;default:E(`Ignoring ${g} as ${f.slice(0,r+1).join(".")} is ${JSON.stringify(a)}`);return}o=a}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{E(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(o)}`)}function v(h,g){const d=g.split(".");m(h,d)}function m(h,g){const d=g.shift();if(g.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const E=h[d];typeof E=="object"&&!Array.isArray(E)&&(m(E,g),Object.keys(E).length===0&&delete h[d])}}function l(h,g,d){function E(o,r){let n=o;for(const a of r){if(typeof n!="object"||n===null)return;n=n[a]}return n}const f=g.split("."),t=E(h,f);return typeof t>"u"?d:t}function c(h,g,d){Object.keys(g).forEach(E=>{E!=="__proto__"&&(E in h?s.$cg(h[E])&&s.$cg(g[E])?c(h[E],g[E],d):d&&(h[E]=g[E]):h[E]=g[E])})}function u(h){return h.replace(/[\[\]]/g,"")}}),define(ye[48],Ee([1,0,3,17,223,5,189,11]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=$,e.$zj=o,e.$Aj=r,e.$Tj=_;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",s.$j),b.set("isLinux",s.$k),b.set("isWindows",s.$i),b.set("isWeb",s.$o),b.set("isMacNative",s.$j&&!s.$o),b.set("isEdge",s.$H),b.set("isFirefox",s.$F),b.set("isChrome",s.$E),b.set("isSafari",s.$G);function $(le,F){if(b.get(le)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(le,F)}const y=Object.prototype.hasOwnProperty;var w;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const v={regexParsingWithErrorRecovery:!0},m=(0,S.localize)(0,null),l=(0,S.localize)(1,null),c=(0,S.localize)(2,null),u=(0,S.localize)(3,null),h=(0,S.localize)(4,null),g=(0,S.localize)(5,null),d=(0,S.localize)(6,null),E=(0,S.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=v){this.k=F,this.d=new I.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:l});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const X=this.D(),x=X.type===17?g:void 0;throw this.h.push({message:h,offset:X.offset,lexeme:I.$vj.getLexeme(X),additionalInfo:x}),f.c}return U}catch(U){if(U!==f.c)throw U;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(16);){const U=this.o();F.push(U)}return F.length===1?F[0]:t.or(...F)}o(){const F=[this.s()];for(;this.y(15);){const U=this.s();F.push(U)}return F.length===1?F[0]:t.and(...F)}s(){if(this.y(2)){const F=this.D();switch(F.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),i.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,u),U?.negate()}case 17:return this.z(),N.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,u),U}case 17:{const U=F.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const Q=x.lexeme,G=Q.lastIndexOf("/"),J=G===Q.length-1?void 0:this.w(Q.substring(G+1));let T;try{T=new RegExp(Q.substring(1,G),J)}catch{throw this.B("REGEX",x)}return K.create(U,T)}switch(x.type){case 10:case 19:{const Q=[x.lexeme];this.z();let G=this.D(),J=0;for(let we=0;we<x.lexeme.length;we++)x.lexeme.charCodeAt(we)===40?J++:x.lexeme.charCodeAt(we)===41&&J--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let we=0;we<G.lexeme.length;we++)G.lexeme.charCodeAt(we)===40?J++:x.lexeme.charCodeAt(we)===41&&J--}if(J<0)break;Q.push(I.$vj.getLexeme(G)),this.z(),G=this.D()}const T=Q.join(""),W=T.lastIndexOf("/"),ce=W===T.length-1?void 0:this.w(T.substring(W+1));let ue;try{ue=new RegExp(T.substring(1,W),ce)}catch{throw this.B("REGEX",x)}return t.regex(U,ue)}case 18:{const Q=x.lexeme;this.z();let G=null;if(!(0,j.$$e)(Q)){const J=Q.indexOf("/"),T=Q.lastIndexOf("/");if(J!==T&&J>=0){const W=Q.slice(J+1,T),ce=Q[T+1]==="i"?"i":"";try{G=new RegExp(W,ce)}catch{throw this.B("REGEX",x)}}}if(G===null)throw this.B("REGEX",x);return K.create(U,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const x=this.u();return t.notIn(U,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return t.equals(U,x);switch(x){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return t.notEquals(U,x);switch(x){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,x)}}case 5:return this.z(),te.create(U,this.u());case 6:return this.z(),ee.create(U,this.u());case 7:return this.z(),ie.create(U,this.u());case 8:return this.z(),ae.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:d,offset:F.offset,lexeme:"",additionalInfo:E}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case 17:case 18:return this.z(),F.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,U){if(this.C(F))return this.z();throw this.B(U,this.D())}B(F,U,X){const x=(0,S.localize)(8,null,F,I.$vj.getLexeme(U)),Q=U.offset,G=I.$vj.getLexeme(U);return this.h.push({message:x,offset:Q,lexeme:G,additionalInfo:X}),f.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=f;class t{static false(){return a.INSTANCE}static true(){return i.INSTANCE}static has(F){return p.create(F)}static equals(F,U){return k.create(F,U)}static notEquals(F,U){return O.create(F,U)}static regex(F,U){return K.create(F,U)}static in(F,U){return C.create(F,U)}static notIn(F,U){return A.create(F,U)}static not(F){return N.create(F)}static and(...F){return Y.create(F,null,!0)}static or(...F){return M.create(F,null,!0)}static greater(F,U){return ie.create(F,U)}static greaterEquals(F,U){return ae.create(F,U)}static smaller(F,U){return te.create(F,U)}static smallerEquals(F,U){return ee.create(F,U)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$yj=t;function o(le){const F=new f({regexParsingWithErrorRecovery:!1});return le.map(U=>(F.parse(U),F.lexingErrors.length>0?F.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,S.localize)(9,null,X.additionalInfo):(0,S.localize)(10,null),offset:X.offset,length:X.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function r(le,F){const U=le?le.substituteConstants():void 0,X=F?F.substituteConstants():void 0;return!U&&!X?!0:!U||!X?!1:U.equals(X)}function n(le,F){return le.cmp(F)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return i.INSTANCE}}e.$Bj=a;class i{static{this.INSTANCE=new i}constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.$Cj=i;class p{static create(F,U=null){const X=b.get(F);return typeof X=="boolean"?X?i.INSTANCE:a.INSTANCE:new p(F,U)}constructor(F,U){this.key=F,this.c=U,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=b.get(this.key);return typeof F=="boolean"?F?i.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Dj=p;class k{static create(F,U,X=null){if(typeof U=="boolean")return U?p.create(F,X):N.create(F,X);const x=b.get(F);return typeof x=="boolean"?U===(x?"true":"false")?i.INSTANCE:a.INSTANCE:new k(F,U,X)}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=b.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?i.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ej=k;class C{static create(F,U){return new C(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:se(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.f),X=F.getValue(this.d);return Array.isArray(U)?U.includes(X):typeof X=="string"&&typeof U=="object"&&U!==null?y.call(U,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Fj=C;class A{static create(F,U){return new A(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=11,this.c=C.create(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=A;class O{static create(F,U,X=null){if(typeof U=="boolean")return U?N.create(F,X):p.create(F,X);const x=b.get(F);return typeof x=="boolean"?U===(x?"true":"false")?a.INSTANCE:i.INSTANCE:new O(F,U,X)}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=b.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?a.INSTANCE:i.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Hj=O;class N{static create(F,U=null){const X=b.get(F);return typeof X=="boolean"?X?a.INSTANCE:i.INSTANCE:new N(F,U)}constructor(F,U){this.c=F,this.d=U,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=b.get(this.c);return typeof F=="boolean"?F?a.INSTANCE:i.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Ij=N;function V(le,F){if(typeof le=="string"){const U=parseFloat(le);isNaN(U)||(le=U)}return typeof le=="string"||typeof le=="number"?F(le):a.INSTANCE}class ie{static create(F,U,X=null){return V(U,x=>new ie(F,x,X))}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class ae{static create(F,U,X=null){return V(U,x=>new ae(F,x,X))}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Kj=ae;class te{static create(F,U,X=null){return V(U,x=>new te(F,x,X))}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Lj=te;class ee{static create(F,U,X=null){return V(U,x=>new ee(F,x,X))}constructor(F,U,X){this.c=F,this.d=U,this.f=X,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:se(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Mj=ee;class K{static create(F,U){return new K(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const U=this.f?this.f.source:"",X=F.f?F.f.source:"";return U<X?-1:U>X?1:0}equals(F){if(F.type===this.type){const U=this.f?this.f.source:"",X=F.f?F.f.source:"";return this.d===F.d&&U===X}return!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Nj=K;class B{static create(F){return new B(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new B(this.c.map(F))}negate(){return this.c}}e.$Oj=B;function Z(le){let F=null;for(let U=0,X=le.length;U<X;U++){const x=le[U].substituteConstants();if(le[U]!==x&&F===null){F=[];for(let Q=0;Q<U;Q++)F[Q]=le[Q]}F!==null&&(F[U]=x)}return F===null?le:F}class Y{static create(F,U,X){return Y.d(F,U,X)}constructor(F,U){this.expr=F,this.c=U,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const x=n(this.expr[U],F.expr[U]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=Z(this.expr);return F===this.expr?this:Y.create(F,this.c,!1)}evaluate(F){for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].evaluate(F))return!1;return!0}static d(F,U,X){const x=[];let Q=!1;for(const G of F)if(G){if(G.type===1){Q=!0;continue}if(G.type===0)return a.INSTANCE;if(G.type===6){x.push(...G.expr);continue}x.push(G)}if(x.length===0&&Q)return i.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(n);for(let G=1;G<x.length;G++)x[G-1].equals(x[G])&&(x.splice(G,1),G--);if(x.length===1)return x[0];for(;x.length>1;){const G=x[x.length-1];if(G.type!==9)break;x.pop();const J=x.pop(),T=x.length===0,W=M.create(G.expr.map(ce=>Y.create([ce,J],null,X)),null,T);W&&(x.push(W),x.sort(n))}if(x.length===1)return x[0];if(X){for(let G=0;G<x.length;G++)for(let J=G+1;J<x.length;J++)if(x[G].negate().equals(x[J]))return a.INSTANCE;if(x.length===1)return x[0]}return new Y(x,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new Y(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());this.c=M.create(F,this,!0)}return this.c}}e.$Pj=Y;class M{static create(F,U,X){return M.d(F,U,X)}constructor(F,U){this.expr=F,this.c=U,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const x=n(this.expr[U],F.expr[U]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=Z(this.expr);return F===this.expr?this:M.create(F,this.c,!1)}evaluate(F){for(let U=0,X=this.expr.length;U<X;U++)if(this.expr[U].evaluate(F))return!0;return!1}static d(F,U,X){let x=[],Q=!1;if(F){for(let G=0,J=F.length;G<J;G++){const T=F[G];if(T){if(T.type===0){Q=!0;continue}if(T.type===1)return i.INSTANCE;if(T.type===9){x=x.concat(T.expr);continue}x.push(T)}}if(x.length===0&&Q)return a.INSTANCE;x.sort(n)}if(x.length!==0){if(x.length===1)return x[0];for(let G=1;G<x.length;G++)x[G-1].equals(x[G])&&(x.splice(G,1),G--);if(x.length===1)return x[0];if(X){for(let G=0;G<x.length;G++)for(let J=G+1;J<x.length;J++)if(x[G].negate().equals(x[J]))return i.INSTANCE;if(x.length===1)return x[0]}return new M(x,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new M(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());for(;F.length>1;){const U=F.shift(),X=F.shift(),x=[];for(const Q of ne(U))for(const G of ne(X))x.push(Y.create([Q,G],null,!1));F.unshift(M.create(x,null,!1))}this.c=M.create(F,this,!0)}return this.c}}e.$Qj=M;class z extends p{static{this.d=[]}static all(){return z.d.values()}constructor(F,U,X){super(F,null),this.f=U,typeof X=="object"?z.d.push({...X,key:F}):X!==!0&&z.d.push({key:F,description:X,type:U!=null?typeof U:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return k.create(this.key,F)}notEqualsTo(F){return O.create(this.key,F)}}e.$Rj=z,e.$Sj=(0,D.$Ai)("contextKeyService");function oe(le,F){return le<F?-1:le>F?1:0}function se(le,F,U,X){return le<U?-1:le>U?1:F<X?-1:F>X?1:0}function _(le,F){if(le.type===0||F.type===1)return!0;if(le.type===9)return F.type===9?H(le.expr,F.expr):!1;if(F.type===9){for(const U of F.expr)if(_(le,U))return!0;return!1}if(le.type===6){if(F.type===6)return H(F.expr,le.expr);for(const U of le.expr)if(_(U,F))return!0;return!1}return le.equals(F)}function H(le,F){let U=0,X=0;for(;U<le.length&&X<F.length;){const x=le[U].cmp(F[X]);if(x<0)return!1;x===0&&U++,X++}return U===le.length}function ne(le){return le.type===9?le.expr:[le]}}),define(ye[232],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$hn=e.ID=void 0,e.$in=j,e.ID="diagnosticsService",e.$hn=(0,s.$Ai)(e.ID);function j(D){return!!D.hostName&&!!D.errorMessage}class I{async getPerformanceInfo(S,P){return{}}async getSystemInfo(S,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,P){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}e.$jn=I}),define(ye[83],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0,e.$Po=(0,s.$Ai)("downloadService")}),define(ye[26],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,s.$Ai)("environmentService"),e.$Ii=(0,s.$Bi)(e.$Hi)}),define(ye[29],Ee([1,0,194,5]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=D,e.$7o=S,e.$8o=P,e.$9o=b,e.$0o=$,e.$$o=y,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var I;(function(d){d.COMMAND="command",d.SETTINGS_SYNC="settingsSync"})(I||(e.ExtensionInstallSource=I={}));function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function S(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(d,E){switch(d){case 3:return E==="x64"?"win32-x64":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(d,E){return E==="web"&&!d.includes("web")}function $(d,E,f){return b(E,f)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===f}function y(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var m;(function(d){d.Install="install",d.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var l;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$_o=(0,j.$Ai)("extensionGalleryService");var c;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed",d.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class u extends Error{constructor(E,f){super(E),this.code=f,this.name=f}}e.$ap=u;var h;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.DownloadFailedWriting="DownloadFailedWriting",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.ScanningExtension="ScanningExtension",d.ReadUninstalled="ReadUninstalled",d.UnsetUninstalled="UnsetUninstalled",d.Delete="Delete",d.Rename="Rename",d.IntializeDefaultProfile="IntializeDefaultProfile",d.AddToProfile="AddToProfile",d.InstalledExtensionNotFound="InstalledExtensionNotFound",d.PostInstall="PostInstall",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Cancelled="Cancelled",d.Unknown="Unknown",d.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));class g extends Error{constructor(E,f){super(E),this.code=f,this.name=f}}e.$bp=g,e.$cp=(0,j.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,j.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,j.$Ai)("IExtensionTipsService"),e.$hp=(0,s.localize2)(0,"Extensions"),e.$ip=(0,s.localize2)(1,"Preferences")}),define(ye[233],Ee([1,0,6,2,21,4,55,29]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=void 0;function b(u,h){return u?D.URI.revive(h?h.transformIncoming(u):u):void 0}function $(u,h){return h?h.transformOutgoingURI(u):u}function y(u,h){h=h||S.$Dn;const g=u.manifest;return{...(0,S.$Gn)({...u,manifest:void 0},h),manifest:g}}function w(u,h){return u?.profileLocation?(0,S.$Gn)(u,h??S.$Dn):u}function v(u,h){return h?(0,I.$9n)(u,g=>g instanceof D.URI?h.transformOutgoingURI(g):void 0):u}class m{constructor(h,g){this.a=h,this.b=g,this.onInstallExtension=s.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=s.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=s.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=s.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=s.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,g){const d=this.b(h);switch(g){case"onInstallExtension":return s.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,d):E.profileLocation}));case"onDidInstallExtensions":return s.Event.map(this.onDidInstallExtensions,E=>E.map(f=>({...f,local:f.local?v(f.local,d):f.local,profileLocation:f.profileLocation?$(f.profileLocation,d):f.profileLocation})));case"onUninstallExtension":return s.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,d):E.profileLocation}));case"onDidUninstallExtension":return s.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?$(E.profileLocation,d):E.profileLocation}));case"onDidUpdateExtensionMetadata":return s.Event.map(this.onDidUpdateExtensionMetadata,E=>v(E,d))}throw new Error("Invalid listen")}async call(h,g,d){const E=this.b(h);switch(g){case"zip":{const f=y(d[0],E),t=await this.a.zip(f);return $(t,E)}case"unzip":return this.a.unzip(b(d[0],E));case"install":return this.a.install(b(d[0],E),w(d[1],E));case"installFromLocation":return this.a.installFromLocation(b(d[0],E),b(d[1],E));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],b(d[1],E),b(d[2],E));case"getManifest":return this.a.getManifest(b(d[0],E));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],w(d[1],E));case"installGalleryExtensions":{const f=d[0];return this.a.installGalleryExtensions(f.map(({extension:t,options:o})=>({extension:t,options:w(o,E)??{}})))}case"uninstall":return this.a.uninstall(y(d[0],E),w(d[1],E));case"reinstallFromGallery":return this.a.reinstallFromGallery(y(d[0],E));case"getInstalled":return(await this.a.getInstalled(d[0],b(d[1],E),d[2])).map(t=>v(t,E));case"toggleAppliationScope":{const f=await this.a.toggleAppliationScope(y(d[0],E),b(d[1],E));return v(f,E)}case"copyExtensions":return this.a.copyExtensions(b(d[0],E),b(d[1],E));case"updateMetadata":{const f=await this.a.updateMetadata(y(d[0],E),d[1],b(d[2],E));return v(f,E)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$jq=m;class l extends j.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new s.$he),this.f=this.B(new s.$he),this.g=this.B(new s.$he),this.h=this.B(new s.$he),this.j=this.B(new s.$he),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?D.URI.revive(g.source):g.source,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(d=>({...d,local:d.local?y(d.local,null):d.local,source:this.r(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(y(g,null))))}n(h,g){h.fire(g)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(d=>(0,P.$0o)(d,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(g=>D.URI.revive(g)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,g){return Promise.resolve(this.m.call("install",[h,g])).then(d=>y(d,null))}installFromLocation(h,g){return Promise.resolve(this.m.call("installFromLocation",[h,g])).then(d=>y(d,null))}async installExtensionsFromProfile(h,g,d){return(await this.m.call("installExtensionsFromProfile",[h,g,d])).map(f=>y(f,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.m.call("installFromGallery",[h,g])).then(d=>y(d,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(d=>({...d,local:d.local?y(d.local,null):d.local,source:this.r(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))}uninstall(h,g){if(h.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(g=>y(g,null))}getInstalled(h=null,g,d){return Promise.resolve(this.m.call("getInstalled",[h,g,d])).then(E=>E.map(f=>y(f,null)))}updateMetadata(h,g,d){return Promise.resolve(this.m.call("updateMetadata",[h,g,d])).then(E=>y(E,null))}toggleAppliationScope(h,g){return this.m.call("toggleAppliationScope",[h,g]).then(d=>y(d,null))}copyExtensions(h,g){return this.m.call("copyExtensions",[h,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,g,d){const E=await this.m.call("download",[h,g,d]);return D.URI.revive(E)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$kq=l;class c{constructor(h){this.a=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,d){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$lq=c}),define(ye[16],Ee([1,0,64,7,17,10,4,202,5,3,13,60]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=v,e.$9k=u,e.$0k=g,e.$$k=d,e.$_k=E,e.$al=f,e.$bl=t,e.$cl=o,e.$dl=r,e.$el=n,e.$fl=a,e.$hl=k,e.$il=C,e.$jl=A,e.$kl=O,e.$ll=N,e.$ol=ee,e.$Al=z,e.$Bl=oe,e.$Dl=_,e.$7k=(0,b.$Ai)("fileService");function v(H){return H.create===!0}var m;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var l;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var c;(function(H){H[H.UPDATED=2]="UPDATED",H[H.ADDED=4]="ADDED",H[H.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function u(H){const ne=H;return!!ne&&typeof ne.onDidChange=="function"}var h;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function g(H){return!!(H.capabilities&2)}function d(H){return!!(H.capabilities&8)}function E(H){return!!(H.capabilities&131072)}function f(H){return!!(H.capabilities&4)}function t(H){return!!(H.capabilities&16)}function o(H){return g(H)?!!(H.capabilities&16384):!1}function r(H){return g(H)?!!(H.capabilities&32768):!1}function n(H){return!!(H.capabilities&65536)}function a(H){return!!(H.capabilities&2048)}var i;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class p extends Error{static create(ne,le){const F=new p(ne.toString(),le);return A(F,le),F}constructor(ne,le){super(ne),this.code=le}}e.$gl=p;function k(H,ne){return p.create(H,ne)}function C(H){return H||k((0,P.localize)(0,null),i.Unknown)}function A(H,ne){return H.name=ne?`${ne} (FileSystemError)`:"FileSystemError",H}function O(H){if(!H)return i.Unknown;if(H instanceof p)return H.code;const ne=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!ne)return i.Unknown;switch(ne[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}function N(H){if(H instanceof K)return H.fileOperationResult;switch(O(H)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}var V;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(V||(e.FileOperation=V={}));class ie{constructor(ne,le,F){this.resource=ne,this.operation=le,this.target=F}isOperation(ne){return this.operation===ne}}e.$ml=ie;var ae;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(ae||(e.FileChangeType=ae={}));class te{static{this.a=null}constructor(ne,le){this.c=le,this.b=void 0,this.d=new w.$V(()=>{const F=s.$Gi.forUris(()=>this.c);return F.fill(this.rawAdded.map(U=>[U,!0])),F}),this.f=new w.$V(()=>{const F=s.$Gi.forUris(()=>this.c);return F.fill(this.rawUpdated.map(U=>[U,!0])),F}),this.g=new w.$V(()=>{const F=s.$Gi.forUris(()=>this.c);return F.fill(this.rawDeleted.map(U=>[U,!0])),F}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const F of ne){switch(F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}this.b!==te.a&&(typeof F.cId=="number"?this.b===void 0?this.b=F.cId:this.b!==F.cId&&(this.b=te.a):this.b!==void 0&&(this.b=te.a))}}contains(ne,...le){return this.h(ne,{includeChildren:!1},...le)}affects(ne,...le){return this.h(ne,{includeChildren:!0},...le)}h(ne,le,...F){if(!ne)return!1;const U=F.length>0;return!!((!U||F.includes(1))&&(this.d.value.get(ne)||le.includeChildren&&this.d.value.findSuperstr(ne))||(!U||F.includes(0))&&(this.f.value.get(ne)||le.includeChildren&&this.f.value.findSuperstr(ne))||(!U||F.includes(2))&&(this.g.value.findSubstr(ne)||le.includeChildren&&this.g.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.b===ne}hasCorrelation(){return typeof this.b=="number"}}e.$nl=te;function ee(H,ne,le){return!H||!ne||H===ne||ne.length>H.length?!1:(ne.charAt(ne.length-1)!==j.sep&&(ne+=j.sep),le?(0,I.$Cf)(H,ne):H.indexOf(ne)===0)}class K extends Error{constructor(ne,le,F){super(ne),this.fileOperationResult=le,this.options=F}}e.$pl=K;class B extends K{constructor(ne,le,F,U){super(ne,le,U),this.fileOperationResult=le,this.size=F}}e.$ql=B;class Z extends K{constructor(ne,le,F){super(ne,2,F),this.stat=le}}e.$rl=Z;var Y;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var M;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$zl="";function z(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}async function oe(H,ne){if(!ne.hasProvider(S.URI.from({scheme:H.scheme})))return new Promise(le=>{const F=ne.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(F.dispose(),le())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(ne){return(0,D.$eg)(ne)||(ne=0),ne<se.KB?(0,P.localize)(1,null,ne.toFixed(0)):ne<se.MB?(0,P.localize)(2,null,(ne/se.KB).toFixed(2)):ne<se.GB?(0,P.localize)(3,null,(ne/se.MB).toFixed(2)):ne<se.TB?(0,P.localize)(4,null,(ne/se.GB).toFixed(2)):(0,P.localize)(5,null,(ne/se.TB).toFixed(2))}}e.$Cl=se;function _(H){const ne=typeof H=="string"||H?.scheme===y.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===y.Schemas.file?1024*se.MB:ne?10*se.MB:$.$o?50*se.MB:1024*se.MB}}),define(ye[112],Ee([1,0,15,11,203,16]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=S;async function S(y,w,v,m,l,c){let u;try{await P(y,w,v,m,l,c)}catch(h){u=h}finally{u&&l.errorTransformer&&(u=l.errorTransformer(u)),typeof u<"u"&&v.error(u),v.end()}}async function P(y,w,v,m,l,c){b(c);const u=await y.open(w,{create:!1});try{b(c);let h=0,g=0,d=l&&typeof l.length=="number"?l.length:void 0,E=s.$Je.alloc(Math.min(l.bufferSize,typeof d=="number"?d:l.bufferSize)),f=l&&typeof l.position=="number"?l.position:0,t=0;do g=await y.read(u,f,E.buffer,t,E.byteLength-t),f+=g,t+=g,h+=g,typeof d=="number"&&(d-=g),t===E.byteLength&&(await v.write(m(E)),E=s.$Je.alloc(Math.min(l.bufferSize,typeof d=="number"?d:l.bufferSize)),t=0);while(g>0&&(typeof d!="number"||d>0)&&b(c)&&$(h,l));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),v.write(m(E.slice(0,o)))}}catch(h){throw(0,D.$il)(h)}finally{await y.close(u)}}function b(y){if(y.isCancellationRequested)throw(0,j.$6)();return!0}function $(y,w){if(typeof w?.limits?.size=="number"&&y>w.limits.size)throw(0,D.$hl)((0,I.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[49],Ee([1,0,80,2,7,3,4,16]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,e.$Pq=b,e.$Qq=$,e.$Uq=m,e.$Vq=l,e.$Wq=c,e.$Xq=u,e.$Yq=g,e.$Zq=d;function b(E){return typeof E.correlationId=="number"}function $(E){return E.recursive===!0}class y extends j.$Uc{static{this.a=3}static{this.b=10}constructor(f,t,o,r){super(),this.m=f,this.n=t,this.r=o,this.s=r,this.f=this.B(new j.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const f=new j.$Tc;this.f.value=f,this.c=this.t(f),this.c.setVerboseLogging(this.r),f.add(this.c.onDidChangeFile(t=>this.m(t))),f.add(this.c.onDidLogMessage(t=>this.n(t))),f.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(f,t){if(this.s.restartOnError&&this.g?.length)if(t){const o=this.h.get(t.path)??0;o<y.a?(this.z(`restarting watcher from error in watch request (retrying request): ${f} (${JSON.stringify(t)})`),this.h.set(t.path,o+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${f} (${JSON.stringify(t)})`),this.y(this.g.filter(r=>r.path!==t.path)))}else this.j<y.b?(this.z(`restarting watcher after unknown global error: ${f}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${f}`);else this.z(f)}y(f){this.u(),this.watch(f)}async watch(f){this.g=f,await this.c?.watch(f)}async setVerboseLogging(f){this.r=f,await this.c?.setVerboseLogging(f)}z(f){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${f}`})}C(f){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${f}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Rq=y;class w extends y{constructor(f,t,o){super(f,t,o,{type:"node.js",restartOnError:!1})}}e.$Sq=w;class v extends y{constructor(f,t,o){super(f,t,o,{type:"universal",restartOnError:!0})}}e.$Tq=v;function m(E){return E.map(f=>({type:f.type,resource:S.URI.revive(f.resource),cId:f.cId}))}function l(E){const f=new h;for(const t of E)f.processEvent(t);return f.coalesce()}function c(E,f){return typeof f=="string"&&!f.startsWith(s.$qk)&&!(0,I.$ic)(f)?{base:E,pattern:f}:f}function u(E,f){const t=[];for(const o of f)t.push((0,s.$uk)(c(E,o)));return t}class h{constructor(){this.a=new Set,this.b=new Map}c(f){return D.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const t=this.b.get(this.c(f));let o=!1;if(t){const r=t.type,n=f.type;t.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?o=!0:r===1&&n===2?(this.b.delete(this.c(f)),this.a.delete(t)):r===2&&n===1?t.type=0:r===1&&n===0||(t.type=n)}else o=!0;o&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],t=[];return Array.from(this.a).filter(o=>o.type!==2?(f.push(o),!1):!0).sort((o,r)=>o.resource.fsPath.length-r.resource.fsPath.length).filter(o=>t.some(r=>(0,P.$ol)(o.resource.fsPath,r,!D.$k))?!1:(t.push(o.resource.fsPath),!0)).concat(f)}}function g(E,f){if(typeof f=="number")switch(E.type){case 1:return(f&4)===0;case 2:return(f&8)===0;case 0:return(f&2)===0}return!1}function d(E){if(typeof E=="number"){const f=[];return E&4&&f.push("Added"),E&8&&f.push("Deleted"),E&2&&f.push("Updated"),f.length===0?"<all>":`[${f.join(", ")}]`}return"<none>"}}),define(ye[234],Ee([1,0,15,39,11,6,2,53,22,16,49]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=void 0,e.$ZP="localFilesystem";class w extends S.$Uc{constructor(m,l){super(),this.a=m,this.b=l,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$he),this.onDidWatchError=this.g.event,this.h=(0,b.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,l){const{buffer:c}=await this.a.call("readFile",[m,l]);return c}readFileStream(m,l,c){const u=(0,P.$xe)(g=>s.$Je.concat(g.map(d=>s.$Je.wrap(d))).buffer),h=new S.$Tc;return h.add(this.a.listen("readFileStream",[m,l])(g=>{if(g instanceof s.$Je)u.write(g.buffer);else{if(g==="end")u.end();else{let d;if(g instanceof Error)d=g;else{const E=g;d=(0,$.$hl)(E.message??(0,j.$lj)(E),E.code??$.FileSystemProviderErrorCode.Unknown)}u.error(d),u.end()}h.dispose()}})),h.add(c.onCancellationRequested(()=>{u.error((0,I.$6)()),u.end(),h.dispose()})),u}writeFile(m,l,c){return this.a.call("writeFile",[m,s.$Je.wrap(l),c])}open(m,l){return this.a.call("open",[m,l])}close(m){return this.a.call("close",[m])}async read(m,l,c,u,h){const[g,d]=await this.a.call("read",[m,l,h]);return c.set(g.buffer.slice(0,d),u),d}write(m,l,c,u,h){return this.a.call("write",[m,l,s.$Je.wrap(c),u,h])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,l){return this.a.call("delete",[m,l])}rename(m,l,c){return this.a.call("rename",[m,l,c])}copy(m,l,c){return this.a.call("copy",[m,l,c])}cloneFile(m,l){return this.a.call("cloneFile",[m,l])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const l=m;this.f.fire((0,y.$Uq)(l))}else{const l=m;this.g.fire(l)}}))}watch(m,l){const c=(0,b.$Wg)();return this.a.call("watch",[this.h,c,m,l]),(0,S.$Sc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$1P=w}),define(ye[235],Ee([1,0,28,2,49,6,4,14]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class b extends j.$Uc{constructor(){super(),this.a=this.B(new D.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=new Set,this.n=5007,this.r=new P.$Xh,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,I.$Pq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new P.$Xh;try{this.h.clear(),this.g.clear();for(const w of y)this.t(w)?this.h.set(w.correlationId,w):this.g.add(w);for(const[w]of this.j)this.h.has(w)||(this.j.deleteAndDispose(w),this.m.delete(w));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const w=new j.$Tc;this.j.set(y.correlationId,w),await this.r.p,!w.isDisposed&&(this.z(y,w),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,w){this.C(y,w)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,w),this.m.add(y.correlationId))}C(y,w){const v=this.M?.subscribe(y.path,(m,l)=>{w.isDisposed||(m?this.z(y,w):l?.type===1&&this.F(y))});return v?(w.add(v),!0):!1}D(y,w){let v=!1;const m=(l,c)=>{if(w.isDisposed)return;const u=this.G(l),h=this.G(c),g=v;v=u,!u&&(h||g)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,s.watchFile)(y.path,{persistent:!1,interval:this.n},m)}catch(l){this.O(`fs.watchFile() failed with error ${l} on path ${y.path} (correlationId: ${y.correlationId})`)}w.add((0,j.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,s.unwatchFile)(y.path,m)}catch(l){this.O(`fs.unwatchFile() failed with error ${l} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const w={resource:S.URI.file(y.path),type:1,cId:y.correlationId};this.a.fire([w]),this.H(w,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,w){if(this.P){const v=` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(v,w)}}I(y,w){this.P&&this.N(`${y}${typeof w.correlationId=="number"?` <${w.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,I.$Zq)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$9q=b}),define(ye[236],Ee([1,0,28,14,20,35,2,100,7,3,19,4,183,23,49]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0,e.$cr=u;class c extends S.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(g,d,E,f,t,o){super(),this.s=g,this.t=d,this.u=E,this.w=f,this.y=t,this.z=o,this.c=this.B(new j.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new j.$Oh(r=>this.M(r),c.b)),this.g=(0,l.$Xq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,l.$Xq)(this.s.path,this.s.includes):void 0,this.j=(0,l.$Pq)(this.s)?this.s.filter:void 0,this.m=new I.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const g=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const d=await m.Promises.stat(g);if(this.m.token.isCancellationRequested)return;this.B(await this.G(g,d.isDirectory()))}catch(g){g.code!=="ENOENT"?this.O(g):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${g})`),this.D()}}D(){this.r=!0,this.w?.()}async F(g){let d=g.path;try{d=await m.Promises.realpath(g.path),g.path===d&&(d=await(0,v.$$q)(g.path,this.m.token)??g.path),g.path!==d&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${d})`)}catch{}return d}async G(g,d){const E=new S.$Tc;return this.H(g,d,E)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(g,d,E)),E}H(g,d,E){if(d)return!1;const f=w.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,r)=>{if(!E.isDisposed)if(o){const n=await this.G(g,d);E.isDisposed?n.dispose():E.add(n)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:f,type:r.type,cId:this.s.correlationId},!0)});return t?(E.add(t),!0):!1}async I(g,d,E){if($.$j&&(0,D.$zg)(g,"/Volumes/",!0)){this.O(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const f=new I.$se(this.m.token);E.add((0,S.$Sc)(()=>f.dispose(!0)));const t=new S.$Tc;E.add(t);try{const o=w.URI.file(this.s.path),r=(0,b.$nc)(g),n=(0,s.watch)(g);t.add((0,S.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${g}'`);const a=new Set;if(d)try{for(const p of await m.Promises.readdir(g))a.add(p)}catch(p){this.O(p)}if(f.token.isCancellationRequested)return;const i=new Map;t.add((0,S.$Sc)(()=>{for(const[,p]of i)p.dispose();i.clear()})),n.on("error",(p,k)=>{f.token.isCancellationRequested||(this.O(`Failed to watch ${g} for changes using fs.watch() (${p}, ${k})`),this.D())}),n.on("change",(p,k)=>{if(f.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${p}"] ${k}`);let C="";if(k&&(C=k.toString(),$.$j&&(C=(0,P.$fm)(C))),!(!C||p!=="change"&&p!=="rename"))if(d)if(p==="rename"){i.get(C)?.dispose();const A=setTimeout(async()=>{if(i.delete(C),C===r&&!await m.Promises.exists(g)){this.J(o);return}if(f.token.isCancellationRequested)return;const O=await this.N((0,b.$jc)(g,C));if(f.token.isCancellationRequested)return;let N;O?a.has(C)?N=0:(N=1,a.add(C)):(a.delete(C),N=2),this.L({resource:(0,y.$bh)(o,C),type:N,cId:this.s.correlationId})},c.a);i.set(C,(0,S.$Sc)(()=>clearTimeout(A)))}else{let A;a.has(C)?A=0:(A=1,a.add(C)),this.L({resource:(0,y.$bh)(o,C),type:A,cId:this.s.correlationId})}else if(p==="rename"||C!==r){const A=setTimeout(async()=>{const O=await m.Promises.exists(g);f.token.isCancellationRequested||(O?(this.L({resource:o,type:0,cId:this.s.correlationId},!0),t.add(await this.G(g,!1))):this.J(o))},c.a);t.clear(),t.add((0,S.$Sc)(()=>clearTimeout(A)))}else this.L({resource:o,type:0,cId:this.s.correlationId},!0)})}catch(o){f.token.isCancellationRequested||this.O(`Failed to watch ${g} for changes using fs.watch() (${o.toString()})`),this.D()}}J(g){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:g,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(g,d=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!d&&this.g.some(E=>E(g.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${g.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(E=>E(g.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}M(g){const d=(0,l.$Vq)(g),E=[];for(const t of d){if((0,l.$Yq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}E.push(t)}if(E.length===0)return;if(this.z)for(const t of E)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(E)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(g){if($.$k)return m.Promises.exists(g);try{const d=(0,b.$nc)(g);return(await m.Promises.readdir((0,b.$mc)(g))).some(f=>f===d)}catch(d){return this.Q(d),!1}}setVerboseLogging(g){this.z=g}O(g){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}P(g){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}Q(g){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}R(g){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${g}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$br=c;async function u(h,g,d,E,f=512){const t=await m.Promises.open(h,"r"),o=Buffer.allocUnsafe(f),r=new I.$se(E);let n,a=!1;const i={path:h,excludes:[],recursive:!1},p=new c(i,void 0,k=>{(async()=>{for(const{type:C}of k)if(C===0){if(a)return;a=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:A}=await m.Promises.read(t,o,0,f,null);if(!A||r.token.isCancellationRequested)break;g(o.slice(0,A))}}catch(A){n=new Error(A),r.dispose(!0)}finally{a=!1}}})()});return await p.ready,d(),new Promise((k,C)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await m.Promises.close(t)}catch(A){n=new Error(A)}n?C(n):k()})})}}),define(ye[237],Ee([1,0,6,80,235,3,236,35]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class b extends I.$9q{constructor(y){super(),this.M=y,this.onDidError=s.Event.None,this.watchers=new Set}async L(y){y=this.X(y);const w=[],v=new Set(Array.from(this.watchers));for(const m of y){const l=this.S(m);l&&(0,j.$yk)(l.request.excludes,m.excludes)&&(0,j.$yk)(l.request.includes,m.includes)?v.delete(l):w.push(m)}w.length&&this.N(`Request to start watching: ${w.map(m=>this.J(m)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map(m=>this.J(m.request)).join(",")}`);for(const m of v)this.W(m);for(const m of w)this.U(m)}S(y){for(const w of this.watchers)if(typeof y.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===y.correlationId)return w}else if((0,P.$yg)(w.request.path,y.path,!D.$k))return w}U(y){const w=new S.$br(y,this.M,m=>this.a.fire(m),()=>this.c.fire(y),m=>this.b.fire(m),this.P),v={request:y,instance:w};this.watchers.add(v)}async stop(){await super.stop();for(const y of this.watchers)this.W(y)}W(y){this.N("stopping file watcher",y),this.watchers.delete(y),y.instance.dispose()}X(y){const w=new Map;for(const v of y){const m=D.$k?v.path:v.path.toLowerCase();let l=w.get(v.correlationId);l||(l=new Map,w.set(v.correlationId,l)),l.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),l.set(m,v)}return Array.from(w.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(y){super.setVerboseLogging(y);for(const w of this.watchers)w.instance.setVerboseLogging(y)}N(y,w){this.P&&this.b.fire({type:"trace",message:this.$(y,w)})}O(y){this.b.fire({type:"warn",message:this.$(y)})}$(y,w){return w?`[File Watcher (node.js)] ${y} (${this.J(w.request)})`:`[File Watcher (node.js)] ${y}`}}e.$dr=b}),define(ye[238],Ee([1,0,49,237]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class I extends s.$Sq{constructor(S,P,b){super(S,P,b),this.u()}t(S){return S.add(new j.$dr(void 0))}}e.$er=I}),define(ye[239],Ee([1,0,13,47,109,49]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class S extends D.$Tq{constructor(b,$,y){super(b,$,y),this.u()}t(b){const $=b.add(new I.$7q(s.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add($.onDidProcessExit(({code:y,signal:w})=>this.w(`terminated by itself with code ${y}, signal: ${w} (ETERM)`))),j.ProxyChannel.toService((0,j.$hi)($.getChannel("watcher")))}}e.$8q=S}),define(ye[84],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class s{constructor(...I){this.a=new Map;for(const[D,S]of I)this.set(D,S)}set(I,D){const S=this.a.get(I);return this.a.set(I,D),S}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$yi=s}),define(ye[113],Ee([1,0,14,11,2,68,231,5,84,99]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const y=!1;class w extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new b.$yi,h=!1,g,d=y){this.i=u,this.j=h,this.k=g,this.l=d,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$zi,this),this._globalGraph=d?g?._globalGraph??new S.$hr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const u of this.g)(0,I.$Oc)(u)&&u.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(u,h){this.m();const g=new class extends v{dispose(){this.h.delete(g),super.dispose()}}(u,this.j,this,this.l);return this.h.add(g),h?.add(g),g}invokeFunction(u,...h){this.m();const g=l.traceInvocation(this.l,u);let d=!1;try{return u({get:f=>{if(d)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(f,g);if(!t)throw new Error(`[invokeFunction] unknown service '${f}'`);return t}},...h)}finally{d=!0,g.stop()}}createInstance(u,...h){this.m();let g,d;return u instanceof D.$xi?(g=l.traceCreation(this.l,u.ctor),d=this.o(u.ctor,u.staticArguments.concat(h),g)):(g=l.traceCreation(this.l,u),d=this.o(u,h,g)),g.stop(),d}o(u,h=[],g){const d=P._util.getServiceDependencies(u).sort((t,o)=>t.index-o.index),E=[];for(const t of d){const o=this.s(t.id,g);o||this.y(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(o)}const f=d.length>0?d[0].index:h.length;if(h.length!==f){console.trace(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${h.length} static arguments`);const t=f-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,f)}return Reflect.construct(u,h.concat(E))}q(u,h){if(this.i.get(u)instanceof D.$xi)this.i.set(u,h);else if(this.k)this.k.q(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(u){const h=this.i.get(u);return!h&&this.k?this.k.r(u):h}s(u,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const g=this.r(u);return g instanceof D.$xi?this.u(u,g,h.branch(u,!0)):(h.branch(u,!1),g)}u(u,h,g){if(this.t.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.t.add(u);try{return this.v(u,h,g)}finally{this.t.delete(u)}}v(u,h,g){const d=new S.$hr(t=>t.id.toString());let E=0;const f=[{id:u,desc:h,_trace:g}];for(;f.length;){const t=f.pop();if(d.lookupOrInsertNode(t),E++>1e3)throw new w(d);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const r=this.r(o.id);if(r||this.y(`[createInstance] ${u} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof D.$xi){const n={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,n),f.push(n)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new w(d);break}for(const{data:o}of t){if(this.r(o.id)instanceof D.$xi){const n=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,n)}d.removeNode(o)}}return this.r(u)}w(u,h,g=[],d,E){if(this.i.get(u)instanceof D.$xi)return this.x(u,h,g,d,E,this.g);if(this.k)return this.k.w(u,h,g,d,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(u,h,g=[],d,E,f){if(d){const t=new v(void 0,this.j,this,this.l);t.c=String(u);const o=new Map,r=new s.$Th(()=>{const n=t.o(h,g,E);for(const[a,i]of o){const p=n[a];if(typeof p=="function")for(const k of i)k.disposable=p.apply(n,k.listener)}return o.clear(),f.add(n),n});return new Proxy(Object.create(null),{get(n,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let k=o.get(a);return k||(k=new $.$5c,o.set(a,k)),(A,O,N)=>{if(r.isInitialized)return r.value[a](A,O,N);{const V={listener:[A,O,N],disposable:void 0},ie=k.push(V);return(0,I.$Sc)(()=>{ie(),V.disposable?.dispose()})}}}if(a in n)return n[a];const i=r.value;let p=i[a];return typeof p!="function"||(p=p.bind(i),n[a]=p),p},set(n,a,i){return r.value[a]=i,!0},getPrototypeOf(n){return h.prototype}})}else{const t=this.o(h,g,E);return f.add(t),t}}y(u,h){if(h&&console.warn(u),this.j)throw new Error(u)}}e.$ir=v;var m;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(m||(m={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,h){return u?new l(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(u,h){return u?new l(1,h.name):l.c}static{this.f=0}constructor(u,h){this.type=u,this.name=h,this.g=Date.now(),this.h=[]}branch(u,h){const g=new l(3,u.toString());return this.h.push([u,h,g]),g}stop(){const u=Date.now()-this.g;l.f+=u;let h=!1;function g(E,f){const t=[],o=new Array(E+1).join("	");for(const[r,n,a]of f.h)if(n&&a){h=!0,t.push(`${o}CREATES -> ${r}`);const i=g(E+1,a);i&&t.push(i)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(u>2||h)&&l.all.add(d.join(`
`))}}e.$jr=l}),define(ye[240],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$cw=void 0,e.$cw=(0,s.$Ai)("labelService");var j;(function(I){I[I.SHORT=0]="SHORT",I[I.MEDIUM=1]="MEDIUM",I[I.LONG=2]="LONG"})(j||(e.Verbosity=j={}))});var Oe=this&&this.__param||function(fe,e){return function(s,j){e(s,j,fe)}};define(ye[85],Ee([1,0,20,2,3,205,29,5]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=void 0,e.$Wr=b;function b(y){return y.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.$Xr=(0,P.$Ai)("languagePackService");let $=class extends j.$Uc{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new s.$se;setTimeout(()=>w.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const l=v.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(u=>u.startsWith("lp-"))).map(c=>{const u=c.properties.localizedLanguages?.[0],h=b(c);return{...this.f(h,u,c),extensionId:c.identifier.id,galleryExtension:c}});return l.push(this.f("en","English")),l}f(w,v,m){const l=v??w;let c;if(l!==w&&(c=`(${w})`),w.toLowerCase()===I.$w.toLowerCase()&&(c??="",c+=(0,D.localize)(0,null)),m?.installCount){c??="";const u=m.installCount;let h;u>1e6?h=`${Math.floor(u/1e5)/10}M`:u>1e3?h=`${Math.floor(u/1e3)}K`:h=String(u),c+=` $(cloud-download) ${h}`}return{id:w,label:l,description:c}}};e.$Yr=$,e.$Yr=$=Le([Oe(0,S.$_o)],$)}),define(ye[12],Ee([1,0,206,39,6,62,2,24,3,19,10,4,48,5]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=c,e.log=h,e.$ik=p,e.$jk=k,e.$kk=C,e.$lk=A,e.$7j=(0,m.$Ai)("logService"),e.$8j=(0,m.$Ai)("loggerService");function l(){return new Date().toISOString()}function c(O){return(0,y.$eg)(O)}var u;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$0j=u.Info;function h(O,N,V){switch(N){case u.Trace:O.trace(V);break;case u.Debug:O.debug(V);break;case u.Info:O.info(V);break;case u.Warning:O.warn(V);break;case u.Error:O.error(V);break;case u.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function g(O,N=!1){let V="";for(let ie=0;ie<O.length;ie++){let ae=O[ie];if(ae instanceof Error&&(ae=(0,j.$lj)(ae,N)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}V+=(ie>0?" ":"")+ae}return V}class d extends S.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new I.$he),this.onDidChangeLogLevel=this.c.event}setLevel(N){this.b!==N&&(this.b=N,this.c.fire(this.b))}getLevel(){return this.b}f(N){return this.b!==u.Off&&this.b<=N}}e.$_j=d;class E extends d{constructor(N){super(),this.h=N}f(N){return this.h||super.f(N)}trace(N,...V){this.f(u.Trace)&&this.g(u.Trace,g([N,...V],!0))}debug(N,...V){this.f(u.Debug)&&this.g(u.Debug,g([N,...V]))}info(N,...V){this.f(u.Info)&&this.g(u.Info,g([N,...V]))}warn(N,...V){this.f(u.Warning)&&this.g(u.Warning,g([N,...V]))}error(N,...V){if(this.f(u.Error))if(N instanceof Error){const ie=Array.prototype.slice.call(arguments);ie[0]=N.stack,this.g(u.Error,g(ie))}else this.g(u.Error,g([N,...V]))}flush(){}}e.$ak=E;class f extends d{constructor(N=e.$0j){super(),this.setLevel(N),this.g=!b.$i}trace(N,...V){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,N,...V):console.log(`[main ${l()}]`,N,...V))}debug(N,...V){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,N,...V):console.log(`[main ${l()}]`,N,...V))}info(N,...V){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,N,...V):console.log(`[main ${l()}]`,N,...V))}warn(N,...V){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,N,...V):console.warn(`[main ${l()}]`,N,...V))}error(N,...V){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,N,...V):console.error(`[main ${l()}]`,N,...V))}flush(){}}e.$bk=f;class t extends d{constructor(N=e.$0j,V=!0){super(),this.g=V,this.setLevel(N)}trace(N,...V){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",N,...V):console.log(N,...V))}debug(N,...V){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",N,...V):console.log(N,...V))}info(N,...V){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",N,...V):console.log(N,...V))}warn(N,...V){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",N,...V):console.log(N,...V))}error(N,...V){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",N,...V):console.error(N,...V))}flush(){}}e.$ck=t;class o extends d{constructor(N,V=e.$0j){super(),this.g=N,this.setLevel(V)}trace(N,...V){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(N),...V])}debug(N,...V){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(N),...V])}info(N,...V){this.f(u.Info)&&this.g.log(u.Info,[this.h(N),...V])}warn(N,...V){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(N),...V])}error(N,...V){this.f(u.Error)&&this.g.log(u.Error,[this.h(N),...V])}h(N){return typeof N=="string"?N:(0,j.$lj)(N,this.f(u.Trace))}flush(){}}e.$dk=o;class r extends d{constructor(N){super(),this.g=N,N.length&&this.setLevel(N[0].getLevel())}setLevel(N){for(const V of this.g)V.setLevel(N);super.setLevel(N)}trace(N,...V){for(const ie of this.g)ie.trace(N,...V)}debug(N,...V){for(const ie of this.g)ie.debug(N,...V)}info(N,...V){for(const ie of this.g)ie.info(N,...V)}warn(N,...V){for(const ie of this.g)ie.warn(N,...V)}error(N,...V){for(const ie of this.g)ie.error(N,...V)}flush(){for(const N of this.g)N.flush()}dispose(){for(const N of this.g)N.dispose();super.dispose()}}e.$ek=r;class n extends S.$Uc{constructor(N,V,ie){if(super(),this.h=N,this.j=V,this.b=new P.$Ac,this.c=this.B(new I.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$he),this.onDidChangeVisibility=this.g.event,ie)for(const ae of ie)this.b.set(ae.resource,{logger:void 0,info:ae})}m(N){return(0,y.$ag)(N)?[...this.b.values()].find(V=>V.info.id===N):this.b.get(N)}getLogger(N){return this.m(N)?.logger}createLogger(N,V){const ie=this.n(N),ae=(0,y.$ag)(N)?N:V?.id??(0,D.$oj)(ie.toString()).toString(16);let te=this.b.get(ie)?.logger;const ee=V?.logLevel==="always"?u.Trace:V?.logLevel;te||(te=this.s(ie,ee??this.getLogLevel(ie)??this.h,{...V,id:ae}));const K={logger:te,info:{resource:ie,id:ae,logLevel:ee,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(K.info),this.b.set(ie,K),te}n(N){return(0,y.$ag)(N)?(0,$.$bh)(this.j,`${N}.log`):N}setLogLevel(N,V){if(w.URI.isUri(N)){const ie=N,ae=V,te=this.b.get(ie);te&&ae!==te.info.logLevel&&(te.info.logLevel=ae===this.h?void 0:ae,te.logger?.setLevel(ae),this.b.set(te.info.resource,te),this.f.fire([ie,ae]))}else{this.h=N;for(const[ie,ae]of this.b.entries())this.b.get(ie)?.info.logLevel===void 0&&ae.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(N,V){const ie=this.m(N);ie&&V!==!ie.info.hidden&&(ie.info.hidden=!V,this.b.set(ie.info.resource,ie),this.g.fire([ie.info.resource,V]))}getLogLevel(N){let V;return N&&(V=this.b.get(N)?.info.logLevel),V??this.h}registerLogger(N){const V=this.b.get(N.resource);V?V.info.hidden!==N.hidden&&this.setVisibility(N.resource,!N.hidden):(this.b.set(N.resource,{info:N,logger:void 0}),this.c.fire({added:[N],removed:[]}))}deregisterLogger(N){const V=this.b.get(N);V&&(V.logger&&V.logger.dispose(),this.b.delete(N),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const N of this.b.values())yield N.info}getRegisteredLogger(N){return this.b.get(N)?.info}dispose(){this.b.forEach(N=>N.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=n;class a{constructor(){this.onDidChangeLogLevel=new I.$he().event}setLevel(N){}getLevel(){return u.Info}trace(N,...V){}debug(N,...V){}info(N,...V){}warn(N,...V){}error(N,...V){}critical(N,...V){}dispose(){}flush(){}}e.$gk=a;class i extends a{}e.$hk=i;function p(O){if(O.verbose)return u.Trace;if(typeof O.logLevel=="string"){const N=A(O.logLevel.toLowerCase());if(N!==void 0)return N}return e.$0j}function k(O){switch(O){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}function C(O){switch(O){case u.Trace:return{original:"Trace",value:s.localize(0,null)};case u.Debug:return{original:"Debug",value:s.localize(1,null)};case u.Info:return{original:"Info",value:s.localize(2,null)};case u.Warning:return{original:"Warning",value:s.localize(3,null)};case u.Error:return{original:"Error",value:s.localize(4,null)};case u.Off:return{original:"Off",value:s.localize(5,null)}}}function A(O){switch(O){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$mk=new v.$Rj("logLevel",k(u.Info))}),define(ye[241],Ee([1,0,18,14,11,6,35,2,7,49,12]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class w extends P.$Uc{constructor(m,l){super(),this.a=m,this.b=l,this.c=this.B(new D.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$yh(0)),this.w=[],this.y=this.B(new j.$yh(0))}watch(m,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(m,l):this.z(m,l)}n(m,l){const c={path:this.J(m),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},u=(0,s.$Tb)(this.j,c);return this.r(),(0,P.$Sc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,I.$1)(m))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,$.$Uq)(l)),l=>this.G(l),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const l of this.j)(0,$.$Qq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const l of this.j)(0,$.$Qq)(l)&&m.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,l){const c={path:this.J(m),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},u=(0,s.$Tb)(this.w,c);return this.C(),(0,P.$Sc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,I.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$Uq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,b.$hc)(m.fsPath)}J(m){const l=this.I(m);return(0,S.$Cg)(l)}}e.$1q=w}),define(ye[114],Ee([1,0,18,14,15,20,6,62,41,2,64,13,44,19,53,201,16,112,12,11]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let f=class extends $.$Uc{static{E=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new S.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new S.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new S.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new S.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new S.$he),this.Y=this.B(new S.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new S.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$Jh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const n=new $.$Tc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),n.add(r.onDidChangeFile(a=>{const i=new u.$nl(a,!this.S(r));this.X.fire(i),i.hasCorrelation()||this.Y.fire(i)})),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(a=>this.Z.fire(new Error(a)))),n.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,$.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,$.$Pc)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(n){r.push(n)}}),!this.h.has(o)&&await j.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return b.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,m.$fh)(o))throw new u.$pl((0,c.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const n=new d.$bb;throw n.message=(0,c.localize)(1,null,o.toString()),n}return r}async m(o){const r=await this.j(o);if((0,u.$al)(r)||(0,u.$0k)(r)||(0,u.$bl)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,u.$al)(r)||(0,u.$0k)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(n){throw(0,u.$kl)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.$pl((0,c.localize)(2,null,this.sb(o)),1):(0,u.$il)(n)}}async s(o,r){const n=await this.j(o),a=this.S(n),i=r?.resolveTo,p=r?.resolveSingleChildDescendants,k=r?.resolveMetadata,C=await n.stat(o);let A;return this.t(n,o,C,void 0,!!k,(O,N)=>(A||(A=y.$Gi.forUris(()=>!a),A.set(o,!0),i&&A.fill(!0,i)),A.get(O.resource)||A.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&p?N===1:!1))}async t(o,r,n,a,i,p){const{providerExtUri:k}=this.R(o),C={resource:r,name:k.basename(r),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&u.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((n.permissions??0)&u.FilePermission.Locked),etag:(0,u.$Al)({mtime:n.mtime,size:n.size}),children:void 0};if(C.isDirectory&&p(C,a)){try{const A=await o.readdir(r),O=await j.Promises.settled(A.map(async([N,V])=>{try{const ie=k.joinPath(r,N),ae=i?await o.stat(ie):{type:V};return await this.t(o,ie,ae,A.length,i,p)}catch(ie){return this.b.trace(ie),null}}));C.children=(0,s.$Hb)(O)}catch(A){this.b.trace(A),C.children=[]}return C}return C}async resolveAll(o){return j.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),n=await r.stat(o);return this.t(r,o,n,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(n){return n}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new u.$pl((0,c.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=I.$Je.fromString(""),n){await this.u(o,n);const a=await this.writeFile(o,r);return this.r.fire(new u.$ml(o,0,a)),a}async writeFile(o,r,n){const a=this.qb(await this.n(o),o),{providerExtUri:i}=this.R(a);let p=n;if((0,u.$dl)(a)&&!p?.atomic){const k=a.enforceAtomicWriteFile?.(o);k&&(p={...n,atomic:k})}try{await this.w(a,o,p)||await this.U(a,i.dirname(o));let C;if((0,u.$0k)(a)&&!(r instanceof I.$Je))if((0,l.$ve)(r)){const A=await(0,l.$Ce)(r,3);A.ended?C=I.$Je.concat(A.buffer):C=A}else C=(0,l.$ze)(r,A=>I.$Je.concat(A),3);else C=r;!(0,u.$al)(a)||(0,u.$0k)(a)&&C instanceof I.$Je||(0,u.$0k)(a)&&(0,u.$dl)(a)&&p?.atomic?await this.hb(a,o,p,C):await this.db(a,o,p,C instanceof I.$Je?(0,I.$Ue)(C):C),this.r.fire(new u.$ml(o,4))}catch(k){throw new u.$pl((0,c.localize)(4,null,this.sb(o),(0,u.$il)(k).toString()),(0,u.$ll)(k),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,n){const a=!!n?.unlock;if(a&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(r)));if(!!n?.atomic){if(!(o.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(r)));if(a)throw new Error((0,c.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&u.FileType.Directory)throw new u.$pl((0,c.localize)(9,null,this.sb(r)),0,n);if(this.rb(r,p),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.$zl&&typeof p.mtime=="number"&&typeof p.size=="number"&&n.mtime<p.mtime&&n.etag!==(0,u.$Al)({mtime:n.mtime,size:p.size}))throw new u.$pl((0,c.localize)(10,null),3,n);return p}async readFile(o,r,n){const a=await this.m(o);return r?.atomic?this.z(a,o,r,n):this.C(a,o,r,n)}async z(o,r,n,a){return new Promise((i,p)=>{this.cb.queueFor(r,async()=>{try{const k=await this.C(o,r,n,a);i(k)}catch(k){p(k)}},this.R(o).providerExtUri)})}async C(o,r,n,a){const i=await this.D(o,r,{...n,preferUnbuffered:!0},a);return{...i,value:await(0,I.$Ve)(i.value)}}async readFileStream(o,r,n){const a=await this.m(o);return this.D(a,o,r,n)}async D(o,r,n,a){const i=new D.$se(a);let p=n;(0,u.$cl)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...n,atomic:!0});const k=this.J(r,p).then(A=>A,A=>{throw i.dispose(!0),A});let C;try{return typeof p?.etag=="string"&&p.etag!==u.$zl&&await k,p?.atomic&&(0,u.$cl)(o)||!((0,u.$al)(o)||(0,u.$bl)(o))||(0,u.$0k)(o)&&p?.preferUnbuffered?C=this.I(o,r,p):(0,u.$bl)(o)?C=this.G(o,r,i.token,p):C=this.H(o,r,i.token,p),C.on("end",()=>i.dispose()),C.on("error",()=>i.dispose()),{...await k,value:C}}catch(A){throw C&&await(0,l.$Ae)(C),this.F(A,r,p)}}F(o,r,n){const a=(0,c.localize)(11,null,this.sb(r),(0,u.$il)(o).toString());return o instanceof u.$rl?new u.$rl(a,o.stat,n):o instanceof u.$ql?new u.$ql(a,o.fileOperationResult,o.size,o.options):new u.$pl(a,(0,u.$ll)(o),n)}G(o,r,n,a=Object.create(null)){const i=o.readFileStream(r,a,n);return(0,l.$Ge)(i,{data:p=>p instanceof I.$Je?p:I.$Je.wrap(p),error:p=>this.F(p,r,a)},p=>I.$Je.concat(p))}H(o,r,n,a=Object.create(null)){const i=(0,I.$Ze)();return(0,h.$Nq)(o,r,i,p=>p,{...a,bufferSize:this.a,errorTransformer:p=>this.F(p,r,a)},n),i}I(o,r,n){const a=(0,l.$xe)(i=>I.$Je.concat(i));return(async()=>{try{let i;n?.atomic&&(0,u.$cl)(o)?i=await o.readFile(r,{atomic:!0}):i=await o.readFile(r),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.L(r,i.byteLength,n),a.end(I.$Je.wrap(i))}catch(i){a.error(i),a.end()}})(),a}async J(o,r){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new u.$pl((0,c.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.$zl&&r.etag===n.etag)throw new u.$rl((0,c.localize)(13,null),n,r);return this.L(o,n.size,r),n}L(o,r,n){if(typeof n?.limits?.size=="number"&&r>n.limits.size)throw new u.$ql((0,c.localize)(14,null,this.sb(o)),7,r,n)}async canMove(o,r,n){return this.M(o,r,"move",n)}async canCopy(o,r,n){return this.M(o,r,"copy",n)}async M(o,r,n,a){if(o.toString()!==r.toString())try{const i=n==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(i,o,p,r,n,a)}catch(i){return i}return!0}async move(o,r,n){const a=this.qb(await this.n(o),o),i=this.qb(await this.n(r),r),p=await this.N(a,o,i,r,"move",!!n),k=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new u.$ml(o,p==="move"?2:3,k)),k}async copy(o,r,n){const a=await this.m(o),i=this.qb(await this.n(r),r),p=await this.N(a,o,i,r,"copy",!!n),k=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new u.$ml(o,p==="copy"?3:2,k)),k}async N(o,r,n,a,i,p){if(r.toString()===a.toString())return i;const{exists:k,isSameResourceWithDifferentPathCase:C}=await this.Q(o,r,n,a,i,p);if(k&&!C&&p&&await this.del(a,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(a)),i==="copy"){if(o===n&&(0,u.$$k)(o))await o.copy(r,a,{overwrite:p});else{const A=await this.resolve(r);A.isDirectory?await this.P(o,A,n,a):await this.O(o,r,n,a)}return i}else return o===n?(await o.rename(r,a,{overwrite:p}),i):(await this.N(o,r,n,a,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,n,a){if((0,u.$al)(o)&&(0,u.$al)(n))return this.jb(o,r,n,a);if((0,u.$al)(o)&&(0,u.$0k)(n))return this.pb(o,r,n,a);if((0,u.$0k)(o)&&(0,u.$al)(n))return this.nb(o,r,n,a);if((0,u.$0k)(o)&&(0,u.$0k)(n))return this.lb(o,r,n,a)}async P(o,r,n,a){await n.mkdir(a),Array.isArray(r.children)&&await j.Promises.settled(r.children.map(async i=>{const p=this.R(n).providerExtUri.joinPath(a,i.name);return i.isDirectory?this.P(o,await this.resolve(i.resource),n,p):this.O(o,i.resource,n,p)}))}async Q(o,r,n,a,i,p){let k=!1;if(o===n){const{providerExtUri:A,isPathCaseSensitive:O}=this.R(o);if(O||(k=A.isEqual(r,a)),k&&i==="copy")throw new Error((0,c.localize)(15,null,this.sb(r),this.sb(a)));if(!k&&A.isEqualOrParent(a,r))throw new Error((0,c.localize)(16,null,this.sb(r),this.sb(a)))}const C=await this.exists(a);if(C&&!k){if(!p)throw new u.$pl((0,c.localize)(17,null,this.sb(r),this.sb(a)),4);if(o===n){const{providerExtUri:A}=this.R(o);if(A.isEqualOrParent(r,a))throw new Error((0,c.localize)(18,null,this.sb(r),this.sb(a)))}}return{exists:C,isSameResourceWithDifferentPathCase:k}}R(o){const r=this.S(o);return{providerExtUri:r?m.$4g:m.$6g,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new u.$ml(o,0,n)),n}async U(o,r){const n=[],{providerExtUri:a}=this.R(o);for(;!a.isEqual(r,a.dirname(r));)try{if(!((await o.stat(r)).type&u.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(r)));break}catch(i){if((0,u.$kl)(i)!==u.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(a.basename(r)),r=a.dirname(r)}for(let i=n.length-1;i>=0;i--){r=a.joinPath(r,n[i]);try{await o.mkdir(r)}catch(p){if((0,u.$kl)(p)!==u.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(n){return n}return!0}async W(o,r){const n=this.qb(await this.j(o),o),a=!!r?.useTrash;if(a&&!(n.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(o)));const i=r?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(o)));if(a&&i)throw new Error((0,c.localize)(22,null,this.sb(o)));let p;try{p=await n.stat(o)}catch{}if(p)this.rb(o,p);else throw new u.$pl((0,c.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const C=await this.resolve(o);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(o)))}return n}async del(o,r){const n=await this.W(o,r);let a=r;if((0,u.$el)(n)&&!a?.atomic){const C=n.enforceAtomicDelete?.(o);C&&(a={...r,atomic:C})}const i=!!a?.useTrash,p=!!a?.recursive,k=a?.atomic??!1;await n.delete(o,{recursive:p,useTrash:i,atomic:k}),this.r.fire(new u.$ml(o,1))}async cloneFile(o,r){const n=await this.j(o),a=this.qb(await this.n(r),r);if(!(n===a&&this.R(n).providerExtUri.isEqual(o,r)))return n===a&&(0,u.$_k)(n)?n.cloneFile(o,r):(await this.U(a,this.R(a).providerExtUri.dirname(r)),n===a&&(0,u.$$k)(n)?this.cb.queueFor(o,()=>n.copy(o,r,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(o,()=>this.O(n,o,a,r),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const n=new $.$Tc;let a=!1,i=()=>{a=!0};n.add((0,$.$Sc)(()=>i())),(async()=>{try{const k=await this.bb(o,r);a?(0,$.$Pc)(k):i=()=>(0,$.$Pc)(k)}catch(k){this.b.error(k)}})();const p=r.correlationId;if(typeof p=="number"){const k=n.add(new S.$he);return n.add(this.X.event(A=>{A.correlates(p)&&k.fire(A)})),{onDidChange:k.event,dispose:()=>n.dispose()}}return n}async bb(o,r){const n=await this.j(o),a=(0,P.$oj)([this.R(n).providerExtUri.getComparisonKey(o),r]);let i=this.$.get(a);return i||(i={count:0,disposable:n.watch(o,r)},this.$.set(a,i)),i.count+=1,(0,$.$Sc)(()=>{i&&(i.count--,i.count===0&&((0,$.$Pc)(i.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,$.$Pc)(o.disposable);this.$.clear()}async db(o,r,n,a){return this.cb.queueFor(r,async()=>{const i=await o.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,l.$ve)(a)||(0,l.$we)(a)?await this.eb(o,i,a):await this.fb(o,i,a)}catch(p){throw(0,u.$il)(p)}finally{await o.close(i)}},this.R(o).providerExtUri)}async eb(o,r,n){let a=0,i;if((0,l.$we)(n)){if(n.buffer.length>0){const p=I.$Je.concat(n.buffer);await this.gb(o,r,p,p.byteLength,a,0),a+=p.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((p,k)=>{(0,l.$Be)(i,{onData:async C=>{i.pause();try{await this.gb(o,r,C,C.byteLength,a,0)}catch(A){return k(A)}a+=C.byteLength,setTimeout(()=>i.resume())},onError:C=>k(C),onEnd:()=>p()})})}async fb(o,r,n){let a=0,i;for(;(i=n.read())!==null;)await this.gb(o,r,i,i.byteLength,a,0),a+=i.byteLength}async gb(o,r,n,a,i,p){let k=0;for(;k<a;){const C=await o.write(r,i+k,n.buffer,p+k,a-k);k+=C}}async hb(o,r,n,a){return this.cb.queueFor(r,()=>this.ib(o,r,n,a),this.R(o).providerExtUri)}async ib(o,r,n,a){let i;a instanceof I.$Je?i=a:(0,l.$ve)(a)?i=await(0,I.$Ve)(a):(0,l.$we)(a)?i=await(0,I.$We)(a):i=(0,I.$Te)(a),await o.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(o,r,n,a){return this.cb.queueFor(a,()=>this.kb(o,r,n,a),this.R(n).providerExtUri)}async kb(o,r,n,a){let i,p;try{i=await o.open(r,{create:!1}),p=await n.open(a,{create:!0,unlock:!1});const k=I.$Je.alloc(this.a);let C=0,A=0,O=0;do O=await o.read(i,C,k.buffer,A,k.byteLength-A),await this.gb(n,p,k,O,C,A),C+=O,A+=O,A===k.byteLength&&(A=0);while(O>0)}catch(k){throw(0,u.$il)(k)}finally{await j.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof p=="number"?n.close(p):Promise.resolve()])}}async lb(o,r,n,a){return this.cb.queueFor(a,()=>this.mb(o,r,n,a),this.R(n).providerExtUri)}async mb(o,r,n,a){return n.writeFile(a,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,n,a){return this.cb.queueFor(a,()=>this.ob(o,r,n,a),this.R(n).providerExtUri)}async ob(o,r,n,a){const i=await n.open(a,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(n,i,I.$Je.wrap(p),p.byteLength,0,0)}catch(p){throw(0,u.$il)(p)}finally{await n.close(i)}}async pb(o,r,n,a){const i=await(0,I.$Ve)(this.H(o,r,D.CancellationToken.None));await this.hb(n,a,void 0,i)}qb(o,r){if(o.capabilities&2048)throw new u.$pl((0,c.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.$pl((0,c.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};e.$Oq=f,e.$Oq=f=E=Le([Oe(0,g.$7j)],f)}),define(ye[69],Ee([1,0,28,313,14,24,15,6,35,2,7,3,19,53,23,204,16,112,241,39,239,238]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0,(()=>{try{(0,j.gracefulify)(s)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$lj)(o)}`)}})();class t extends g.$1q{static{this.L=!1}constructor(r,n){super(r,n),this.onDidChangeCapabilities=P.Event.None,this.P=new D.$Ac(a=>v.$5g.getComparisonKey(a)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,w.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:n,symbolicLink:a}=await l.SymlinkSupport.stat(this.I(r));return{type:this.O(n,a),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:u.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const n=await l.Promises.readdir(this.I(r),{withFileTypes:!0}),a=[];return await Promise.all(n.map(async i=>{try{let p;i.isSymbolicLink()?p=(await this.stat((0,v.$bh)(r,i.name))).type:p=this.O(i),a.push([i.name,p])}catch(p){this.a.trace(p)}})),a}catch(n){throw this.hb(n)}}O(r,n){let a;return n?.dangling?a=u.FileType.Unknown:r.isFile()?a=u.FileType.File:r.isDirectory()?a=u.FileType.Directory:a=u.FileType.Unknown,n&&(a|=u.FileType.SymbolicLink),a}async Q(r){const n=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let a;for(;a=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await a.wait();const i=new I.$zh;return this.P.set(r,i),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,$.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(r)===i&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),i.open()})}async readFile(r,n){let a;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),a=await this.Q(r));const i=this.I(r);return await l.Promises.readFile(i)}catch(i){throw this.hb(i)}finally{a?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,n,a){const i=(0,m.$xe)(p=>S.$Je.concat(p.map(k=>S.$Je.wrap(k))).buffer);return(0,h.$Nq)(this,r,i,p=>p.buffer,{...n,bufferSize:256*1024},a),i}async writeFile(r,n,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.S(r)?this.U(r,(0,v.$bh)((0,v.$ah)(r),`${(0,v.$$g)(r)}${a.atomic.postfix}`),n,a):this.W(r,n,a)}async S(r){try{const n=this.I(r),{symbolicLink:a}=await l.SymlinkSupport.stat(n);if(a)return!1}catch{}return!0}async U(r,n,a,i){const p=new $.$Tc;try{p.add(await this.Q(r)),p.add(await this.Q(n)),await this.W(n,a,i,!0);try{await this.rename(n,r,{overwrite:!0})}catch(k){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{p.dispose()}}async W(r,n,a,i){let p;try{const k=this.I(r);if(!a.create||!a.overwrite){if(await l.Promises.exists(k)){if(!a.overwrite)throw(0,u.$hl)((0,c.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,u.$hl)((0,c.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:a.unlock},i),await this.write(p,0,n,0,n.byteLength)}catch(k){throw await this.ib(r,k)}finally{typeof p=="number"&&await this.close(p)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,n,a){const i=this.I(r);let p;(0,u.$8k)(n)&&!a&&(p=await this.Q(r));let k;try{if((0,u.$8k)(n)&&n.unlock)try{const{stat:A}=await l.SymlinkSupport.stat(i);A.mode&128||await l.Promises.chmod(i,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let C;if((0,u.$8k)(n)){if(w.$i)try{await l.Promises.truncate(i,0),C="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}C||(C="w")}else C="r";k=await l.Promises.open(i,C)}catch(C){throw p?.dispose(),(0,u.$8k)(n)?await this.ib(r,C):this.hb(C)}if(this.X.set(k,0),(0,u.$8k)(n)&&this.Z.set(k,r),p){const C=this.Y.get(k);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${i})`),this.Y.set(k,p),C&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${i})`),C.dispose())}return k}async close(r){const n=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await l.Promises.fdatasync(r)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await l.Promises.close(r)}catch(a){throw this.hb(a)}finally{n&&(this.Y.get(r)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,a,i,p){const k=this.ab(r,n);let C=null;try{C=(await l.Promises.read(r,a,i,p,k)).bytesRead}catch(A){throw this.hb(A)}finally{this.bb(r,k,C)}return C}ab(r,n){return n===this.X.get(r)?null:n}bb(r,n,a){const i=this.X.get(r);typeof i=="number"&&(typeof n=="number"||(typeof a=="number"?this.X.set(r,i+a):this.X.delete(r)))}async write(r,n,a,i,p){return(0,I.$Uh)(()=>this.cb(r,n,a,i,p),100,3)}async cb(r,n,a,i,p){const k=this.ab(r,n);let C=null;try{C=(await l.Promises.write(r,a,i,p,k)).bytesWritten}catch(A){throw await this.ib(this.Z.get(r),A)}finally{this.bb(r,k,C)}return C}async mkdir(r){try{await l.Promises.mkdir(this.I(r))}catch(n){throw this.hb(n)}}async delete(r,n){try{const a=this.I(r);if(n.recursive){let i;n?.atomic!==!1&&n.atomic.postfix&&(i=(0,y.$jc)((0,y.$mc)(a),`${(0,y.$nc)(a)}${n.atomic.postfix}`)),await l.Promises.rm(a,l.RimRafMode.MOVE,i)}else try{await l.Promises.unlink(a)}catch(i){if(i.code==="EPERM"||i.code==="EISDIR"){let p=!1;try{const{stat:k,symbolicLink:C}=await l.SymlinkSupport.stat(a);p=k.isDirectory()&&!C}catch{}if(p)await l.Promises.rmdir(a);else throw i}else throw i}}catch(a){throw this.hb(a)}}async rename(r,n,a){const i=this.I(r),p=this.I(n);if(i!==p)try{await this.db(r,n,"move",a.overwrite),await l.Promises.rename(i,p)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,c.localize)(2,null,(0,y.$nc)(i),(0,y.$nc)((0,y.$mc)(p)),k.toString()))),this.hb(k)}}async copy(r,n,a){const i=this.I(r),p=this.I(n);if(i!==p)try{await this.db(r,n,"copy",a.overwrite),await l.Promises.copy(i,p,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,c.localize)(3,null,(0,y.$nc)(i),(0,y.$nc)((0,y.$mc)(p)),k.toString()))),this.hb(k)}}async db(r,n,a,i){const p=this.I(r),k=this.I(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,b.$yg)(p,k,!0)),C){if(a==="copy")throw(0,u.$hl)((0,c.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const O=await this.N(r);if(!O)throw(0,u.$hl)((0,c.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const N=await this.N(n);if(N){if(!i)throw(0,u.$hl)((0,c.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);O.type&u.FileType.File&&N.type&u.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,n){return this.eb(r,n,!1)}async eb(r,n,a){const i=this.I(r),p=this.I(n),k=!!(this.capabilities&1024);if((0,b.$yg)(i,p,!k))return;const C=new $.$Tc;try{C.add(await this.Q(r)),C.add(await this.Q(n)),a&&await l.Promises.mkdir((0,y.$mc)(p),{recursive:!0}),await l.Promises.copyFile(i,p)}catch(A){if(A.code==="ENOENT"&&!a)return this.eb(r,n,!0);throw this.hb(A)}finally{C.dispose()}}t(r,n,a){return new E.$8q(i=>r(i),i=>n(i),a)}F(r,n,a){return new f.$er(i=>r(i),i=>n(i),a)}hb(r){if(r instanceof u.$gl)return r;let n=r,a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=u.FileSystemProviderErrorCode.Unknown;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.$hl)(n,a)}async ib(r,n){let a=this.hb(n);if(r&&a.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await l.SymlinkSupport.stat(this.I(r));i.mode&128||(a=(0,u.$hl)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.a.trace(i)}return a}}e.$fr=t}),define(ye[242],Ee([1,0,6,69,2,15,53,20]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=void 0;class b extends I.$Uc{constructor(w,v){super(),this.a=w,this.b=v,this.F=new Map,this.G=new Map}call(w,v,m){const l=this.c(w);switch(v){case"stat":return this.g(l,m[0]);case"readdir":return this.h(l,m[0]);case"open":return this.r(l,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(l,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(l,m[0],m[1],m[2]);case"rename":return this.z(l,m[0],m[1],m[2]);case"copy":return this.C(l,m[0],m[1],m[2]);case"cloneFile":return this.D(l,m[0],m[1]);case"mkdir":return this.w(l,m[0]);case"delete":return this.y(l,m[0],m[1]);case"watch":return this.I(l,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${v} not found`)}listen(w,v,m){const l=this.c(w);switch(v){case"fileChange":return this.H(l,m[0]);case"readFileStream":return this.m(l,m[0],m[1])}throw new Error(`Unknown event ${v}`)}g(w,v){const m=this.f(w,v,!0);return this.a.stat(m)}h(w,v){const m=this.f(w,v);return this.a.readdir(m)}async j(w,v,m){const l=this.f(w,v,!0),c=await this.a.readFile(l,m);return D.$Je.wrap(c)}m(w,v,m){const l=this.f(w,v,!0),c=new P.$se,u=new s.$he({onDidRemoveLastListener:()=>{c.cancel()}}),h=this.a.readFileStream(l,m,c.token);return(0,S.$Be)(h,{onData:g=>u.fire(D.$Je.wrap(g)),onError:g=>u.fire(g),onEnd:()=>{u.fire("end"),u.dispose(),c.dispose()}}),u.event}n(w,v,m,l){const c=this.f(w,v);return this.a.writeFile(c,m.buffer,l)}r(w,v,m){const l=this.f(w,v,!0);return this.a.open(l,m)}s(w){return this.a.close(w)}async t(w,v,m){const l=D.$Je.alloc(m),u=await this.a.read(w,v,l.buffer,0,m);return[l,u]}u(w,v,m,l,c){return this.a.write(w,v,m.buffer,l,c)}w(w,v){const m=this.f(w,v);return this.a.mkdir(m)}y(w,v,m){const l=this.f(w,v);return this.a.delete(l,m)}z(w,v,m,l){const c=this.f(w,v),u=this.f(w,m);return this.a.rename(c,u,l)}C(w,v,m,l){const c=this.f(w,v),u=this.f(w,m);return this.a.copy(c,u,l)}D(w,v,m){const l=this.f(w,v),c=this.f(w,m);return this.a.cloneFile(l,c)}H(w,v){const m=new s.$he({onWillAddFirstListener:()=>{this.F.set(v,this.L(w,m))},onDidRemoveLastListener:()=>{(0,I.$Pc)(this.F.get(v)),this.F.delete(v)}});return m.event}async I(w,v,m,l,c){const u=this.F.get(v);if(u){const h=this.f(w,l),g=u.watch(m,h,c);this.G.set(v+m,g)}}async J(w,v){const m=w+v,l=this.G.get(m);l&&((0,I.$Pc)(l),this.G.delete(m))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$Ps=b;class $ extends I.$Uc{constructor(w,v,m,l){super(),this.c=w,this.f=m,this.g=l,this.a=new Map,this.b=this.B(new j.$fr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(w){const v=this.B(new s.$he);this.B(v.event(m=>{w.fire(m.map(l=>({resource:this.c.transformOutgoingURI(l.resource),type:l.type,cId:l.cId})))})),this.B(this.b.onDidChangeFile(m=>v.fire(m))),this.B(this.b.onDidWatchError(m=>w.fire(m)))}j(w){}m(w){}watch(w,v,m){const l=this.m(this.g);return Array.isArray(l)&&(m.excludes=[...m.excludes,...l]),this.a.set(w,this.b.watch(v,m)),(0,I.$Sc)(()=>{(0,I.$Pc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$Qs=$}),define(ye[115],Ee([1,0,4,6,12,2]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0;class S extends I.$fk{constructor(w,v,m,l,c){super(v,m,l),this.r=w,this.t=c,this.B(c.listen("onDidChangeLogLevel",w)(u=>{(0,I.$9j)(u)?super.setLogLevel(u):super.setLogLevel(s.URI.revive(u[0]),u[1])})),this.B(c.listen("onDidChangeVisibility",w)(([u,h])=>super.setVisibility(s.URI.revive(u),h))),this.B(c.listen("onDidChangeLoggers",w)(({added:u,removed:h})=>{for(const g of u)super.registerLogger({...g,resource:s.URI.revive(g.resource)});for(const g of h)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new I.$dk({log:(w,v)=>{this.t.call("consoleLog",[w,v])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,v){super.setLogLevel(w,v),this.t.call("setLogLevel",[w,v])}setVisibility(w,v){super.setVisibility(w,v),this.t.call("setVisibility",[this.n(w),v])}s(w,v,m){return new P(this.t,w,v,m,this.r)}static setLogLevel(w,v,m){return w.call("setLogLevel",[v,m])}}e.$fs=S;class P extends I.$ak{constructor(w,v,m,l,c){super(l?.logLevel==="always"),this.r=w,this.s=v,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[v,l,c]).then(()=>{this.u(this.n),this.m=!0})}g(w,v){const m=[[w,v]];this.m?this.u(m):this.n.push(...m)}u(w){this.r.call("log",[this.s,w])}}class b{constructor(w,v){this.a=w,this.b=v}listen(w,v){const m=this.b(w);switch(v){case"onDidChangeLoggers":return j.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(c=>this.c(c,m)),removed:[...l.removed].map(c=>this.c(c,m))}));case"onDidChangeVisibility":return j.Event.map(this.a.onDidChangeVisibility,l=>[m.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return j.Event.map(this.a.onDidChangeLogLevel,l=>(0,I.$9j)(l)?l:[m.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${v}`)}async call(w,v,m){const l=this.b(w);switch(v){case"setLogLevel":return(0,I.$9j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(s.URI.revive(l.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,l)))}throw new Error(`Call not found: ${v}`)}c(w,v){return{...w,resource:v.transformOutgoingURI(w.resource)}}}e.$gs=b;class $ extends D.$Uc{constructor(w,v){super(),v.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(m=>v.call("setLogLevel",[m]))),v.call("getRegisteredLoggers").then(m=>{for(const l of m)w.registerLogger({...l,resource:s.URI.revive(l.resource)})}),this.B(v.listen("onDidChangeVisibility")(([m,l])=>w.setVisibility(s.URI.revive(m),l))),this.B(v.listen("onDidChangeLoggers")(({added:m,removed:l})=>{for(const c of m)w.registerLogger({...c,resource:s.URI.revive(c.resource)});for(const c of l)w.deregisterLogger(c.resource)}))}}e.$hs=$}),define(ye[116],Ee([1,0,2,12]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class I extends s.$Uc{constructor(S,P=[]){super(),this.a=new j.$ek([S,...P]),this.B(S.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...P){this.a.trace(S,...P)}debug(S,...P){this.a.debug(S,...P)}info(S,...P){this.a.info(S,...P)}warn(S,...P){this.a.warn(S,...P)}error(S,...P){this.a.error(S,...P)}flush(){this.a.flush()}}e.$fQ=I}),define(ye[243],Ee([1,0,16,12]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var I;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(I||(I={}));async function D($,y,w,v,m){try{const l=await new Promise((u,h)=>{fe(["@vscode/spdlog"],u,h)});l.setFlushOn(I.Trace);const c=await l.createAsyncRotatingLogger($,y,w,v);return m?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(l){console.error(l)}return null}function S($,y,w){switch(y){case j.LogLevel.Trace:$.trace(w);break;case j.LogLevel.Debug:$.debug(w);break;case j.LogLevel.Info:$.info(w);break;case j.LogLevel.Warning:$.warn(w);break;case j.LogLevel.Error:$.error(w);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P($,y){switch(y){case j.LogLevel.Trace:$.setLevel(I.Trace);break;case j.LogLevel.Debug:$.setLevel(I.Debug);break;case j.LogLevel.Info:$.setLevel(I.Info);break;case j.LogLevel.Warning:$.setLevel(I.Warning);break;case j.LogLevel.Error:$.setLevel(I.Error);break;case j.LogLevel.Off:$.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class b extends j.$ak{constructor(y,w,v,m,l){super(),this.m=[],this.setLevel(l),this.n=this.s(y,w,v,m),this.B(this.onDidChangeLogLevel(c=>{this.r&&P(this.r,c)}))}async s(y,w,v,m){const l=v?6:1,c=30/l*s.$Cl.MB,u=await D(y,w,c,l,m);if(u){this.r=u,P(this.r,this.getLevel());for(const{level:h,message:g}of this.m)S(this.r,h,g);this.m=[]}}g(y,w){this.r?S(this.r,y,w):this.getLevel()<=y&&this.m.push({level:y,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=b}),define(ye[117],Ee([1,0,22,12,243]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;class D extends j.$fk{s(P,b,$){return new I.$7P((0,s.$Wg)(),P.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,b)}}e.$8P=D}),define(ye[244],Ee([1,0,63,207,5]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(D||(e.MarkerTag=D={}));var S;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(S||(e.MarkerSeverity=S={})),function(b){function $(l,c){return c-l}b.compare=$;const y=Object.create(null);y[b.Error]=(0,j.localize)(0,null),y[b.Warning]=(0,j.localize)(1,null),y[b.Info]=(0,j.localize)(2,null);function w(l){return y[l]||""}b.toString=w;function v(l){switch(l){case s.default.Error:return b.Error;case s.default.Warning:return b.Warning;case s.default.Info:return b.Info;case s.default.Ignore:return b.Hint}}b.fromSeverity=v;function m(l){switch(l){case b.Error:return s.default.Error;case b.Warning:return s.default.Warning;case b.Info:return s.default.Info;case b.Hint:return s.default.Ignore}}b.toSeverity=m}(S||(e.MarkerSeverity=S={}));var P;(function(b){const $="";function y(v){return w(v,!0)}b.makeKey=y;function w(v,m){const l=[$];return v.source?l.push(v.source.replace("\xA6","\\\xA6")):l.push($),v.code?typeof v.code=="string"?l.push(v.code.replace("\xA6","\\\xA6")):l.push(v.code.value.replace("\xA6","\\\xA6")):l.push($),v.severity!==void 0&&v.severity!==null?l.push(S.toString(v.severity)):l.push($),v.message&&m?l.push(v.message.replace("\xA6","\\\xA6")):l.push($),v.startLineNumber!==void 0&&v.startLineNumber!==null?l.push(v.startLineNumber.toString()):l.push($),v.startColumn!==void 0&&v.startColumn!==null?l.push(v.startColumn.toString()):l.push($),v.endLineNumber!==void 0&&v.endLineNumber!==null?l.push(v.endLineNumber.toString()):l.push($),v.endColumn!==void 0&&v.endColumn!==null?l.push(v.endColumn.toString()):l.push($),l.push($),l.join("\xA6")}b.makeKeyOptionalMessage=w})(P||(e.IMarkerData=P={})),e.$qu=(0,I.$Ai)("markerService")}),define(ye[70],Ee([1,0,6,41,2,5]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=void 0,e.$jo=(0,D.$Ai)("policy");class S extends I.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new s.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const y=Object.keys(this.f).length;return this.f={...$,...this.f},y!==Object.keys(this.f).length&&await this.j($),j.Iterable.reduce(this.g.entries(),(w,[v,m])=>({...w,[v]:m}),{})}getPolicyValue($){return this.g.get($)}serialize(){return j.Iterable.reduce(Object.entries(this.f),($,[y,w])=>({...$,[y]:{definition:w,value:this.g.get(y)}}),{})}}e.$ko=S;class P{constructor(){this.onDidChange=s.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$lo=P}),define(ye[58],Ee([1,0,32]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const D=I.context.configuration();if(D)j=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,s.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:D.version})}}else j={nameShort:"Code - Insiders",nameLong:"Visual Studio Code - Insiders",applicationName:"code-insiders",win32x64AppId:"{{1287CAD5-7C8D-410D-88B9-0D1EE4A83FF2}",win32arm64AppId:"{{0AEDB616-9614-463B-97D7-119DD86CCA64}",win32x64UserAppId:"{{217B4C08-948D-4276-BFBB-BEE930AE5A2C}",win32arm64UserAppId:"{{69BD8F7B-65EB-4C6F-A14E-44CFA83712C0}",win32NameVersion:"Microsoft Visual Studio Code Insiders",win32DirName:"Microsoft VS Code Insiders",win32SetupExeBasename:"VSCodeInsidersSetup",win32AppUserModelId:"Microsoft.VisualStudioCodeInsiders",win32ShellNameShort:"Code Insiders",win32MutexName:"vscodeinsiders",win32RegValueName:"VSCodeInsiders",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCodeInsiders",darwinExecutable:"VSCodeInsiders",linuxIconName:"vscode-insiders",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server-insiders",urlProtocol:"vscode-insiders",dataFolderName:".vscode-insiders",serverDataFolderName:".vscode-server-insiders",downloadUrl:"https://code.visualstudio.com/insiders",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://insiders.vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"insider",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",searchUrl:"https://marketplace.visualstudio.com/_apis/public/gallery/searchrelevancy/extensionquery",servicePPEUrl:"https://marketplace.vsallin.net/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code-insiders?aid=f047834f-d0e1-4aef-8870-5805ee483b2d","win32-arm64":"appcenter://code-insiders?aid=fb1c1670-432e-43dc-a88e-8c5ed7293213","linux-x64":"appcenter://code-insiders?aid=a04472a4-f4ea-4854-bf12-95bb0f2dd01a",darwin:"appcenter://code-insiders?aid=5e4c15d3-0a3c-4c3b-a294-2a40850616a2","darwin-arm64":"appcenter://code-insiders?aid=d6599f8f-6aee-4013-b47c-1e1269faa19a","darwin-universal":"appcenter://code-insiders?aid=9198980f-302c-4143-9ddf-29914b57be2e"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkId=724002",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=761088",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions","interactive","terminalDataWriteEvent"],"GitHub.copilot-nightly":["inlineCompletionsAdditions","interactive","terminalDataWriteEvent"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatProvider","chatParticipant","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"GitHub.copilot-nes":["inlineEdit"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipant","chatParticipantAdditions","embeddings","languageModels","languageModelSystem"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatParticipant","languageModels"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.git","vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.git","vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["vscode.git","ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["vscode.git","ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync-insiders.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!0,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},enableSyncingProfiles:!0,"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel-insiders",tunnelApplicationConfig:{editorWebUrl:"https://insiders.vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscodeinsiders-tunnelservice",win32TunnelMutex:"vscodeinsiders-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to GitHub Copilot, an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://code.visualstudio.com/docs/copilot/overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%2C%7B%22installPreReleaseVersion%22%3Atrue%7D%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.90.0-insider",commit:"f209ce35ef894bd32c12057724e8d1f1139c433f",date:"2024-05-17T17:05:01.315Z"},Object.keys(j).length===0&&Object.assign(j,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(ye[30],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,s.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(ye[36],Ee([1,0,98,10]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class I{constructor(){this.a=new Map}add(S,P){s.ok(j.$ag(S)),s.ok(j.$cg(P)),s.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,P)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.$ho=new I}),define(ye[245],Ee([1,0,6,36]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this.b=new s.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[I(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const S=new D;j.$ho.add(e.$io.JSONContribution,S)}),define(ye[50],Ee([1,0,18,6,10,188,25,245,36]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=c,e.$yo=u,e.$zo=h,e.$Ao=d,e.$Bo=E;var $;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$mo={Configuration:"base.contributions.configuration"};var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const w=b.$ho.as(P.$io.JSONContribution);class v{constructor(){this.h=new Set,this.i=new j.$he,this.onDidSchemaChange=this.i.event,this.j=new j.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$to,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),w.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),w.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),w.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:n,source:a}of t)for(const i in n)if(o.add(i),e.$wo.test(i)){const p=this.a.get(i),k=p?.valuesSources??new Map;if(a)for(const N of Object.keys(n[i]))k.set(N,a);const C={...p?.value||{},...n[i]};this.a.set(i,{source:a,value:C,valuesSources:k});const A=(0,S.$ej)(i),O={type:"object",default:C,description:D.localize(1,null,A),$ref:e.$to,defaultDefaultValue:C,source:I.$ag(a)?void 0:a,defaultValueSource:a};r.push(...c(i)),this.d[i]=O,this.b.properties[i]=O}else{this.a.set(i,{value:n[i],source:a});const p=this.d[i];p&&(this.w(i,p),this.r(i,p))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:n}of t)for(const a in r){const i=this.a.get(a),p=I.$ag(n)?n:n?.id,k=I.$ag(i?.source)?i?.source:i?.source?.id;if(p===k)if(o.add(a),this.a.delete(a),e.$wo.test(a))delete this.d[a],delete this.b.properties[a];else{const C=this.d[a];C&&(this.w(a,C),this.r(a,C))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,r),this.c.push(n),this.q(n)})}o(t,o){const r=n=>{if(n.properties)for(const a in n.properties){o.add(a);const i=this.d[a];i?.policy?.name&&this.e.delete(i.policy.name),delete this.d[a],this.s(a,n.properties[a])}n.allOf?.forEach(a=>r(a))};for(const n of t){r(n);const a=this.c.indexOf(n);a!==-1&&this.c.splice(a,1)}}p(t,o=!0,r,n,a=3,i){a=I.$jg(t.scope)?a:t.scope;const p=t.properties;if(p)for(const C in p){const A=p[C];if(o&&d(C,A)){delete p[C];continue}if(A.source=r,A.defaultDefaultValue=p[C].default,this.w(C,A),e.$wo.test(C)?A.scope=void 0:(A.scope=I.$jg(A.scope)?a:A.scope,A.restricted=I.$jg(A.restricted)?!!n?.includes(C):A.restricted),p[C].hasOwnProperty("included")&&!p[C].included){this.f[C]=p[C],delete p[C];continue}else this.d[C]=p[C],p[C].policy?.name&&this.e.set(p[C].policy.name,C);!p[C].deprecationMessage&&p[C].markdownDeprecationMessage&&(p[C].deprecationMessage=p[C].markdownDeprecationMessage),i.add(C)}const k=t.allOf;if(k)for(const C of k)this.p(C,o,r,n,a,i)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const n=r.properties;if(n)for(const i in n)this.r(i,n[i]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$no.properties[t]=o,o.scope){case 1:e.$oo.properties[t]=o;break;case 2:e.$po.properties[t]=o;break;case 6:e.$qo.properties[t]=o;break;case 3:e.$ro.properties[t]=o;break;case 4:e.$so.properties[t]=o;break;case 5:e.$so.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$no.properties[t],o.scope){case 1:delete e.$oo.properties[t];break;case 2:delete e.$po.properties[t];break;case 6:delete e.$qo.properties[t];break;case 3:delete e.$ro.properties[t];break;case 4:case 5:delete e.$so.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$to};this.w(o,r),e.$no.properties[o]=r,e.$oo.properties[o]=r,e.$po.properties[o]=r,e.$qo.properties[o]=r,e.$ro.properties[o]=r,e.$so.properties[o]=r}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=t,e.$oo.patternProperties[e.$vo]=t,e.$po.patternProperties[e.$vo]=t,e.$qo.patternProperties[e.$vo]=t,e.$ro.patternProperties[e.$vo]=t,e.$so.patternProperties[e.$vo]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let n=r?.value,a=r?.source;I.$hg(n)&&(n=o.defaultDefaultValue,a=void 0),I.$hg(n)&&(n=h(o.type)),o.default=n,o.defaultValueSource=a}}const m="\\[([^\\]]+)\\]",l=new RegExp(m,"g");e.$vo=`^(${m})+$`,e.$wo=new RegExp(e.$vo);function c(f){const t=[];if(e.$wo.test(f)){let o=l.exec(f);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=l.exec(f)}}return(0,s.$Mb)(t)}function u(f){return f.reduce((t,o)=>`${t}[${o}]`,"")}function h(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new v;b.$ho.add(e.$mo.Configuration,g);function d(f,t){return f.trim()?e.$wo.test(f)?D.localize(7,null,f):g.getConfigurationProperties()[f]!==void 0?D.localize(8,null,f):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,f,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function E(){const f=[],t=g.getConfigurationProperties();for(const o of Object.keys(t))f.push([o,t[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}}),define(ye[118],Ee([1,0,18,6,43,2,24,21,10,4,25,50,36]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=d;function m(o){return Object.isFrozen(o)?o:P.$8n(o)}class l{static createEmptyModel(r){return new l({},[],[],void 0,r)}constructor(r,n,a,i,p){this.b=r,this.c=n,this.d=a,this.raw=i,this.f=p,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof l)return n;const a=new c("",this.f);return a.parseRaw(n),a.configurationModel});this.g=r.reduce((n,a)=>a===n?a:n.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$cj)(this.contents,r):this.contents}inspect(r,n){const a=this;return{get value(){return m(a.rawConfiguration.getValue(r))},get override(){return n?m(a.rawConfiguration.getOverrideValue(r,n)):void 0},get merged(){return m(n?a.rawConfiguration.override(n).getValue(r):a.rawConfiguration.getValue(r))},get overrides(){const i=[];for(const{contents:p,identifiers:k,keys:C}of a.rawConfiguration.overrides){const A=new l(p,C,[],void 0,a.f).getValue(r);A!==void 0&&i.push({identifiers:k,value:A})}return i.length?m(i):void 0}}}getOverrideValue(r,n){const a=this.j(n);return a?r?(0,y.$cj)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const a of this.overrides)a.identifiers.includes(r)&&n.push(...a.keys);return s.$Mb(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return s.$Mb(r)}override(r){let n=this.a.get(r);return n||(n=this.h(r),this.a.set(r,n)),n}merge(...r){const n=P.$7n(this.contents),a=P.$7n(this.overrides),i=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const k of r)if(p.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(n,k.contents);for(const C of k.overrides){const[A]=a.filter(O=>s.$ub(O.identifiers,C.identifiers));A?(this.i(A.contents,C.contents),A.keys.push(...C.keys),A.keys=s.$Mb(A.keys)):a.push(P.$7n(C))}for(const C of k.keys)i.indexOf(C)===-1&&i.push(C)}return new l(n,i,a,p.every(k=>k instanceof l)?void 0:p,this.f)}h(r){const n=this.j(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const i of s.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let p=this.contents[i];const k=n[i];k&&(typeof p=="object"&&typeof k=="object"?(p=P.$7n(p),this.i(p,k)):p=k),a[i]=p}return new l(a,this.keys,this.overrides,void 0,this.f)}i(r,n){for(const a of Object.keys(n)){if(a in r&&b.$cg(r[a])&&b.$cg(n[a])){this.i(r[a],n[a]);continue}r[a]=P.$7n(n[a])}}j(r){let n=null,a=null;const i=p=>{p&&(a?this.i(a,p):a=P.$7n(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?n=p.contents:p.identifiers.includes(r)&&i(p.contents);return i(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,n){this.k(r,n,!0)}setValue(r,n){this.k(r,n,!1)}removeValue(r){const n=this.keys.indexOf(r);n!==-1&&(this.keys.splice(n,1),(0,y.$bj)(this.contents,r),w.$wo.test(r)&&this.overrides.splice(this.overrides.findIndex(a=>s.$ub(a.identifiers,(0,w.$xo)(r))),1))}k(r,n,a){(0,y.$aj)(this.contents,r,n,i=>this.f.error(i)),a=a||this.keys.indexOf(r)===-1,a&&this.keys.push(r),w.$wo.test(r)&&this.overrides.push({identifiers:(0,w.$xo)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$_i)(this.contents[r],i=>this.f.error(i))})}}e.$Co=l;class c{constructor(r,n){this.f=r,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||l.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!b.$jg(r)){const a=this.h(r);this.parseRaw(a,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:a,keys:i,overrides:p,restricted:k,hasExcludedProperties:C}=this.i(r,n);this.b=new l(a,i,p,C?[r]:void 0,this.g),this.c=k||[]}h(r){let n={},a=null,i=[];const p=[],k=[];function C(O){Array.isArray(i)?i.push(O):a!==null&&(i[a]=O)}const A={onObjectBegin:()=>{const O={};C(O),p.push(i),i=O,a=null},onObjectProperty:O=>{a=O},onObjectEnd:()=>{i=p.pop()},onArrayBegin:()=>{const O=[];C(O),p.push(i),i=O,a=null},onArrayEnd:()=>{i=p.pop()},onLiteralValue:C,onError:(O,N,V)=>{k.push({error:O,offset:N,length:V})}};if(r)try{I.$Un(r,A),n=i[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}i(r,n){const a=v.$ho.as(w.$mo.Configuration).getConfigurationProperties(),i=this.j(r,a,!0,n);r=i.raw;const p=(0,y.$_i)(r,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),k=Object.keys(r),C=this.l(r,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:p,keys:k,overrides:C,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}j(r,n,a,i){let p=!1;if(!i?.scopes&&!i?.skipRestricted&&!i?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const k={},C=[];for(const A in r)if(w.$wo.test(A)&&a){const O=this.j(r[A],n,!1,i);k[A]=O.raw,p=p||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=n[A],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(A),!i.exclude?.includes(A)&&(i.include?.includes(A)||(N===void 0||i.scopes===void 0||i.scopes.includes(N))&&!(i.skipRestricted&&O?.restricted))?k[A]=r[A]:p=!0}return{raw:k,restricted:C,hasExcludedProperties:p}}l(r,n){const a=[];for(const i of Object.keys(r))if(w.$wo.test(i)){const p={};for(const k in r[i])p[k]=r[i][k];a.push({identifiers:(0,w.$xo)(i),keys:Object.keys(p),contents:(0,y.$_i)(p,n)})}return a}}e.$Do=c;class u extends D.$Uc{constructor(r,n,a,i,p){super(),this.c=r,this.f=n,this.g=i,this.h=p,this.b=this.B(new j.$he),this.onDidChange=this.b.event,this.a=new c(this.c.toString(),p),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&a.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return l.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=u;class h{constructor(r,n,a,i,p,k,C,A,O,N,V,ie,ae){this.a=r,this.b=n,this.c=a,this.overrideIdentifiers=i,this.d=p,this.f=k,this.g=C,this.h=A,this.i=O,this.j=N,this.k=V,this.l=ie,this.m=ae}get value(){return m(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(r,n,a,i,p,k,C,A,O,N){this.j=r,this.l=n,this.m=a,this.n=i,this.p=p,this.q=k,this.r=C,this.s=A,this.t=O,this.u=N,this.h=null,this.i=new S.$Ac,this.v=null}getValue(r,n,a){return this.w(r,n,a).getValue(r)}updateValue(r,n,a={}){let i;a.resource?(i=this.t.get(a.resource),i||(i=l.createEmptyModel(this.u),this.t.set(a.resource,i))):i=this.s,n===void 0?i.removeValue(r):i.setValue(r,n),a.resource||(this.h=null)}inspect(r,n,a){const i=this.w(r,n,a),p=this.A(n.resource,a),k=n.resource?this.t.get(n.resource)||this.s:this.s,C=new Set;for(const A of i.overrides)for(const O of A.identifiers)i.getOverrideValue(r,O)!==void 0&&C.add(O);return new h(r,n,i.getValue(r),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.q:void 0,p||void 0,k)}keys(r){const n=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,n){this.r.set(r,n),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const a=[];if(!n){const{added:i,updated:p,removed:k}=f(this.j,r);n=[...i,...p,...k]}for(const i of n)for(const p of(0,w.$xo)(i)){const k=this.j.getKeysForOverrideIdentifier(p),C=r.getKeysForOverrideIdentifier(p),A=[...C.filter(O=>k.indexOf(O)===-1),...k.filter(O=>C.indexOf(O)===-1),...k.filter(O=>!P.$$n(this.j.override(p).getValue(O),r.override(p).getValue(O)))];a.push([p,A])}return this.updateDefaultConfiguration(r),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:a,removed:i}=f(this.l,r),p=[...n,...a,...i];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:a,removed:i,overrides:p}=f(this.applicationConfiguration,r),k=[...n,...a,...i];return k.length&&this.updateApplicationConfiguration(r),{keys:k,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:a,removed:i,overrides:p}=f(this.localUserConfiguration,r),k=[...n,...a,...i];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:a,removed:i,overrides:p}=f(this.remoteUserConfiguration,r),k=[...n,...a,...i];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:a,removed:i,overrides:p}=f(this.workspaceConfiguration,r),k=[...n,...a,...i];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:p}}compareAndUpdateFolderConfiguration(r,n){const a=this.folderConfigurations.get(r),{added:i,updated:p,removed:k,overrides:C}=f(a,n),A=[...i,...p,...k];return(A.length||!a)&&this.updateFolderConfiguration(r,n),{keys:A,overrides:C}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:i,removed:p,overrides:k}=f(n,void 0);return{keys:[...a,...i,...p],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,n,a){let i=this.x(n,a);return n.overrideIdentifier&&(i=i.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(i=i.merge(this.l)),i}x({resource:r},n){let a=this.y();if(n&&r){const i=n.getFolder(r);i&&(a=this.z(i.uri)||a);const p=this.t.get(r);p&&(a=a.merge(p))}return a}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let n=this.i.get(r);if(!n){const a=this.y(),i=this.r.get(r);i?(n=a.merge(i),this.i.set(r,n)):n=a}return n}A(r,n){if(n&&r){const a=n.getFolder(r);if(a)return this.r.get(a.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,n)=>{const{contents:a,overrides:i,keys:p}=this.r.get(n);return r.push([n,{contents:a,overrides:i,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(n=>r.add(n)),this.userConfiguration.keys.forEach(n=>r.add(n)),this.q.keys.forEach(n=>r.add(n)),this.r.forEach(n=>n.keys.forEach(a=>r.add(a))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}D(r){const n=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.q.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.r.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i))),[...n.values()]}static parse(r,n){const a=this.E(r.defaults,n),i=this.E(r.policy,n),p=this.E(r.application,n),k=this.E(r.user,n),C=this.E(r.workspace,n),A=r.folders.reduce((O,N)=>(O.set($.URI.revive(N[0]),this.E(N[1],n)),O),new S.$Ac);return new g(a,i,p,k,l.createEmptyModel(n),C,A,l.createEmptyModel(n),new S.$Ac,n)}static E(r,n){return new l(r.contents,r.keys,r.overrides,void 0,n)}}e.$Fo=g;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,n=new Map;for(const i of o)i.keys.forEach(p=>r.add(p)),i.overrides.forEach(([p,k])=>{const C=(0,S.$xc)(n,p,new Set);k.forEach(A=>C.add(A))});const a=[];return n.forEach((i,p)=>a.push([p,[...i.values()]])),{keys:[...r.values()],overrides:a}}class E{constructor(r,n,a,i,p){this.change=r,this.f=n,this.g=a,this.h=i,this.i=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=g.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,n){const a=this.a+r,i=this.d.indexOf(a);if(i<0)return!1;const p=i+a.length;if(p>=this.d.length)return!1;const k=this.d.charCodeAt(p);if(k!==this.b&&k!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.f?.workspace):void 0,A=this.g.getValue(r,n,this.h);return!P.$$n(C,A)}return!0}}e.$Ho=E;function f(o,r){const{added:n,removed:a,updated:i}=t(r?.rawConfiguration,o?.rawConfiguration),p=[],k=o?.getAllOverrideIdentifiers()||[],C=r?.getAllOverrideIdentifiers()||[];if(r){const A=C.filter(O=>!k.includes(O));for(const O of A)p.push([O,r.getKeysForOverrideIdentifier(O)])}if(o){const A=k.filter(O=>!C.includes(O));for(const O of A)p.push([O,o.getKeysForOverrideIdentifier(O)])}if(r&&o){for(const A of k)if(C.includes(A)){const O=t({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)});p.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:a,updated:i,overrides:p}}function t(o,r){const n=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],a=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],i=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const k=(0,y.$cj)(r.contents,p),C=(0,y.$cj)(o.contents,p);P.$$n(k,C)||i.push(p)}}return{added:n,removed:a,updated:i}}}),define(ye[246],Ee([1,0,18,6,2,21,10,118,50,12,70,36]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=void 0;class v extends I.$Uc{get configurationModel(){return this.b}constructor(u){super(),this.c=u,this.a=this.B(new j.$he),this.onDidChangeConfiguration=this.a.event,this.b=P.$Co.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(w.$ho.as(b.$mo.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:h})=>this.f(Array.from(u),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(u,h){this.j(u,w.$ho.as(b.$mo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}g(){return{}}h(){this.b=P.$Co.createEmptyModel(this.c);const u=w.$ho.as(b.$mo.Configuration).getConfigurationProperties();this.j(Object.keys(u),u)}j(u,h){const g=this.g();for(const d of u){const E=g[d],f=h[d];E!==void 0?this.b.addValue(d,E):f?this.b.addValue(d,f.default):this.b.removeValue(d)}}}e.$Io=v;class m{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=P.$Co.createEmptyModel(new $.$hk)}async initialize(){return this.configurationModel}}e.$Jo=m;let l=class extends I.$Uc{get configurationModel(){return this.b}constructor(u,h,g){super(),this.c=u,this.f=h,this.g=g,this.a=this.B(new j.$he),this.onDidChangeConfiguration=this.a.event,this.b=P.$Co.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.j(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.m(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const h={},g=[],d=w.$ho.as(b.$mo.Configuration).getConfigurationProperties();for(const E of u){const f=d[E];if(!f){g.push(E);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}g.push(E),h[f.policy.name]={type:f.type}}}return(0,S.$ng)(h)||await this.f.updatePolicyDefinitions(h),g}j(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const h=w.$ho.as(b.$mo.Configuration).getPolicyConfigurations(),g=(0,s.$Hb)(u.map(d=>h.get(d)));this.m(g,!0)}m(u,h){this.g.trace("PolicyConfiguration#update",u);const g=w.$ho.as(b.$mo.Configuration).getConfigurationProperties(),d=[],E=this.b.isEmpty();for(const f of u){const t=g[f]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(E?o!==void 0:!(0,D.$$n)(this.b.getValue(f),o))&&d.push([f,o])}else this.b.getValue(f)!==void 0&&d.push([f,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const f=this.b;this.b=P.$Co.createEmptyModel(this.g);for(const t of f.keys)this.b.setValue(t,f.getValue(t));for(const[t,o]of d)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);h&&this.a.fire(this.b)}}};e.$Ko=l,e.$Ko=l=Le([Oe(1,y.$jo),Oe(2,$.$7j)],l)}),define(ye[119],Ee([1,0,18,14,15,6,43,151,2,24,21,3,19,25,118,50,246,70]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=void 0;class g extends b.$Uc{constructor(f,t,o,r){super(),this.m=f,this.n=r,this.h=this.B(new D.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Io(r)),this.c=o instanceof h.$lo?new u.$Jo:this.B(new u.$Ko(this.b,o,r)),this.f=this.B(new l.$Eo(this.m,{},v.$5g,t,r)),this.a=new l.$Fo(this.b.configurationModel,this.c.configurationModel,l.$Co.createEmptyModel(r),l.$Co.createEmptyModel(r),l.$Co.createEmptyModel(r),l.$Co.createEmptyModel(r),new $.$Ac,l.$Co.createEmptyModel(r),new $.$Ac,r),this.j=new d(f,t,this),this.g=this.B(new j.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:a})=>this.s(n,a))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Fo(f,t,l.$Co.createEmptyModel(this.n),o,l.$Co.createEmptyModel(this.n),l.$Co.createEmptyModel(this.n),new $.$Ac,l.$Co.createEmptyModel(this.n),new $.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(f,t){const o=typeof f=="string"?f:void 0,r=(0,m.$8i)(f)?f:(0,m.$8i)(t)?t:{};return this.a.getValue(o,r,void 0)}async updateValue(f,t,o,r,n){const a=(0,m.$9i)(o)?o:(0,m.$8i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,i=a?r:o;if(i!==void 0&&i!==3&&i!==2)throw new Error(`Unable to write ${f} to target ${i}.`);a?.overrideIdentifiers&&(a.overrideIdentifiers=(0,s.$Mb)(a.overrideIdentifiers),a.overrideIdentifiers=a.overrideIdentifiers.length?a.overrideIdentifiers:void 0);const p=this.inspect(f,{resource:a?.resource,overrideIdentifier:a?.overrideIdentifiers?a.overrideIdentifiers[0]:void 0});if(p.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,y.$$n)(t,p.defaultValue)&&(t=void 0),a?.overrideIdentifiers?.length&&a.overrideIdentifiers.length>1){const C=a.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,s.$ub)([...O.identifiers].sort(),C));A&&(a.overrideIdentifiers=A.identifiers)}const k=a?.overrideIdentifiers?.length?[(0,c.$yo)(a.overrideIdentifiers),f]:[f];await this.j.write(k,t),await this.reloadConfiguration()}inspect(f,t={}){return this.a.inspect(f,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.r(f)}r(f){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(f);this.u(o,t,2)}s(f,t){const o=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(f,t);this.u(r,o,7)}t(f){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(f);this.u(o,t,7)}u(f,t,o){const r=new l.$Ho(f,{data:t},this.a,void 0,this.n);r.source=o,this.h.fire(r)}}e.$Lo=g;class d{constructor(f,t,o){this.b=f,this.c=t,this.d=o,this.a=new j.$Hh}write(f,t){return this.a.queue(()=>this.e(f,t))}async e(f,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(a){if(a.fileOperationResult===1)o="{}";else throw a}const r=[];if((0,S.$Nn)(o,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(o,f,t);o=(0,P.$6n)(o,n),await this.c.writeFile(this.b,I.$Je.fromString(o))}f(f,t,o){const{tabSize:r,insertSpaces:n,eol:a}=this.h;if(!t.length){const i=JSON.stringify(o,null,n?" ".repeat(r):"	");return[{content:i,length:i.length,offset:0}]}return(0,P.$3n)(f,t,o,{tabSize:r,insertSpaces:n,eol:a})}get h(){if(!this.g){let f=w.OS===3||w.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(f=t),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ye[120],Ee([1,0,11,5]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=$,e.$Ll=(0,j.$Ai)("remoteAuthorityResolverService");var I;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class D{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ml=D;class S{constructor(w,v){this.host=w,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=S;var P;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class b extends s.$bb{static isNotAvailable(w){return w instanceof b&&w._code===P.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof b&&w._code===P.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof b&&w._code===P.NoResolverFound}static isInvalidAuthority(w){return w instanceof b&&w._code===P.InvalidAuthority}static isHandled(w){return w instanceof b&&w.isHandled}constructor(w,v=P.Unknown,m){super(w),this._message=w,this._code=v,this._detail=m,this.isHandled=v===P.NotAvailable&&m===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Ol=b;function $(y){const w=y.indexOf("+");return w===-1?y:y.substring(0,w)}}),define(ye[247],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0,e.$hQ=(0,s.$Ai)("IRemoteExtensionsScannerService"),e.$iQ="remoteExtensionsScanner"}),define(ye[86],Ee([1,0,13]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=j,e.$Mm=I,e.$Nm=D,e.$Om=S;function j(b){return b.scheme===s.Schemas.vscodeRemote?b.authority:void 0}function I(b){if(!b)return;const $=b.indexOf("+");return $<0?b:b.substr(0,$)}function D(b){const{host:$,port:y}=P(b);if(typeof y>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:$,port:y}}function S(b,$){let{host:y,port:w}=P(b);return typeof w>"u"&&(w=$),{host:y,port:w}}function P(b){const $=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const y=b.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const w=b.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:b,port:void 0}}}),define(ye[40],Ee([1,0,17,5,86]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=D,e.$Ym=w,e.$Zm=v,e.$1m=m,e.$2m=l,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S||(e.ExtensionType=S={}));var P;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class b{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,h){if(typeof u>"u"||u===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof u=="string"||typeof h=="string"){const g=typeof u=="string"?u:u.value,d=typeof h=="string"?h:h.value;return s.$Bf(g,d)}return u._lower===h._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$Vm=b;class ${get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const h of u)this.add(h)}add(u){this.c.add(b.toKey(u))}delete(u){return this.c.delete(b.toKey(u))}has(u){return this.c.has(b.toKey(u))}}e.$Wm=$;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(b.toKey(u))}get(u){return this.c.get(b.toKey(u))}has(u){return this.c.has(b.toKey(u))}set(u,h){this.c.set(b.toKey(u),h)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=y;function w(c){return v(c)}function v(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function m(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function l(c,u){if(u){const h=`onResolveRemoteAuthority:${(0,I.$Mm)(u)}`;return!!c.activationEvents?.includes(h)}return!1}e.$3m=(0,j.$Ai)("IBuiltinExtensionsScannerService")}),define(ye[248],Ee([1,0,2,40,16]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class D extends s.$Uc{constructor(P,b,$,y,w){super(),this.a=P,this.b=b,this.c=$,this.f=w,this.B(y.onDidInstallExtensions(v=>this.g(v))),this.B(y.onDidUninstallExtension(v=>this.h(v)))}g(P){for(const b of P)b.local&&this.invalidate(b.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,P)&&await this.j(b);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,j.$Pm))}catch(b){(0,I.$ll)(b)!==1&&this.f.error(b)}}}e.$Iq=D}),define(ye[42],Ee([1,0,15,11,2,208,50,5,12,36]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=v,e.$Wp=m,e.$Xp=l,e.$Yp=c,e.$Zp=u,e.$1p=h,e.$Tp=(0,P.$Ai)("requestService");class y{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?f[t]="*****":f[t]=this.b[t];this.a=f}return this.a}}class w extends I.$Uc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,D.localize)(0,null),when:b.$mk.isEqualTo((0,b.$jk)(b.LogLevel.Trace)).serialize()})}async c(f,t,o){const r=`${f} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const n=await o();return this.a.trace(`${r} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${r} - error`,t.type,(0,j.$0)(n)),n}}}e.$Up=w;function v(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function m(E){return E.res.statusCode===204}async function l(E){return m(E)?null:(await(0,s.$Ve)(E.stream)).toString()}async function c(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);return l(E)}async function u(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);if(m(E))return null;const t=(await(0,s.$Ve)(E.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function h(E){d(E)}let g;function d(E){const f=$.$ho.as(S.$mo.Configuration),t=g;g={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[g],remove:t?[t]:[]})}d(1)}),define(ye[249],Ee([1,0,20,13,16,42]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let S=class{constructor(b,$){this.a=b,this.b=$}async download(b,$,y=s.CancellationToken.None){if(b.scheme===j.Schemas.file||b.scheme===j.Schemas.vscodeRemote){await this.b.copy(b,$);return}const w={type:"GET",url:b.toString(!0)},v=await this.a.request(w,y);if(v.res.statusCode===200)await this.b.writeFile($,v.stream);else{const m=await(0,D.$Yp)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${m}`)}}};e.$uQ=S,e.$uQ=S=Le([Oe(0,D.$Tp),Oe(1,I.$7k)],S)}),define(ye[250],Ee([1,0,15,20]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0;class I{constructor(P){this.a=P}listen(P,b){throw new Error("Invalid listen")}call(P,b,$,y=j.CancellationToken.None){switch(b){case"request":return this.a.request($[0],y).then(async({res:w,stream:v})=>{const m=await(0,s.$Ve)(v);return[{statusCode:w.statusCode,headers:w.headers},m]});case"resolveProxy":return this.a.resolveProxy($[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$1r=I;class D{constructor(P){this.a=P}async request(P,b){const[$,y]=await this.a.call("request",[P],b);return{res:$,stream:(0,s.$Xe)(y)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$2r=D}),define(ye[251],Ee([1,0,87,10]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=D;function I(S,P){return S.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:S.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function D(S,P,b={}){const $=(0,s.parse)(S),y=b.proxyUrl||I($,P);if(!y)return null;const w=(0,s.parse)(y);if(!/^https?:$/.test(w.protocol||""))return null;const v={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,j.$gg)(b.strictSSL)?b.strictSSL:!0};return $.protocol==="http:"?new(await new Promise((m,l)=>{fe(["http-proxy-agent"],m,l)})).HttpProxyAgent(y,v):new(await new Promise((m,l)=>{fe(["https-proxy-agent"],m,l)})).HttpsProxyAgent(y,v)}}),define(ye[88],Ee([1,0,56,7,209,20,39,11,3,22,107,227,14,154]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=c;let l;async function c(h,g,d,E){return d["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$i?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Em)(E)&&!d["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Em)(E)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=v.Promises.withAsyncBody(async(f,t)=>{const o=new D.$se;let r=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(r=(0,m.$Fm)(n,1,120)*1e3);const a=setTimeout(()=>{o.dispose(!0),t(new Error((0,I.localize)(0,null)))},r);try{f(await u(g,o.token))}catch(i){!(0,P.$4)(i)&&!o.token.isCancellationRequested?t(new Error((0,I.localize)(1,null,(0,S.$lj)(i)))):f({})}finally{clearTimeout(a),o.dispose()}})),l)}async function u(h,g){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",E);const f=(0,$.$Wg)().replace(/-/g,"").substr(0,12),t=new RegExp(f+"({.*})"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$um)(b.OS,o);return h.trace("getUnixShellEnvironment#shell",r),new Promise((n,a)=>{if(g.isCancellationRequested)return a(new P.$5);const i=(0,j.$nc)(r);let p,k;const C="";/^pwsh(-preview)?$/.test(i)?(p=`& '${process.execPath}' ${C} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,k=["-Login","-Command"]):i==="nu"?(p=`^'${process.execPath}' ${C} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,k=["-i","-l","-c"]):i==="xonsh"?(p=`import os, json; print("${f}", json.dumps(dict(os.environ)), "${f}")`,k=["-i","-l","-c"]):(p=`'${process.execPath}' ${C} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,i==="tcsh"||i==="csh"?k=["-ic"]:k=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),p);const A=(0,s.spawn)(r,[...k,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(A.kill(),a(new P.$5))),A.on("error",V=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,S.$lj)(V)),a(V)});const O=[];A.stdout.on("data",V=>O.push(V));const N=[];A.stderr.on("data",V=>N.push(V)),A.on("close",(V,ie)=>{const ae=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",ae);const te=Buffer.concat(N).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),V||ie)return a(new Error((0,I.localize)(2,null,V,ie)));const ee=t.exec(ae),K=ee?ee[1]:"{}";try{const B=JSON.parse(K);d?B.ELECTRON_RUN_AS_NODE=d:delete B.ELECTRON_RUN_AS_NODE,E?B.ELECTRON_NO_ATTACH_CONSOLE=E:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.VSCODE_RESOLVING_ENVIRONMENT,delete B.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",B),n(B)}catch(B){h.error("getUnixShellEnvironment#errorCaught",(0,S.$lj)(B)),a(B)}})})}}),define(ye[252],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=void 0,e.$9P=(0,s.$Ai)("stateReadService"),e.$0P=(0,s.$Ai)("stateService")}),define(ye[253],Ee([1,0,14,15,2,10,26,16,12]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=e.$$P=e.SaveStrategy=void 0;var $;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})($||(e.SaveStrategy=$={}));class y extends I.$Uc{constructor(l,c,u,h){super(),this.h=l,this.j=c,this.m=u,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new s.$yh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(l){l.fileOperationResult!==1&&this.m.error(l)}}getItem(l,c){const u=this.a[l];return(0,D.$jg)(u)?c:u}setItem(l,c){this.setItems([{key:l,data:c}])}setItems(l){let c=!1;for(const{key:u,data:h}of l)this.a[u]!==h&&((0,D.$jg)(h)?(0,D.$hg)(this.a[u])||(this.a[u]=void 0,c=!0):(this.a[u]=h,c=!0));c&&this.s()}removeItem(l){(0,D.$hg)(this.a[l])||(this.a[l]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const l=JSON.stringify(this.a,null,4);if(l!==this.b)try{await this.n.writeFile(this.h,j.$Je.fromString(l),{atomic:{postfix:".vsctmp"}}),this.b=l}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$$P=y;let w=class extends I.$Uc{constructor(l,c,u,h){super(),this.a=this.B(new y(c.stateResource,l,u,h))}async init(){await this.a.init()}getItem(l,c){return this.a.getItem(l,c)}};e.$_P=w,e.$_P=w=Le([Oe(1,S.$Hi),Oe(2,b.$7j),Oe(3,P.$7k)],w);class v extends w{setItem(l,c){this.a.setItem(l,c)}setItems(l){this.a.setItems(l)}removeItem(l){this.a.removeItem(l)}close(){return this.a.close()}}e.$aQ=v}),define(ye[121],Ee([1,0,3,32,22]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=S,e.$kp=P;function D(b){if(s.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function S(b,$,y,w,v,m,l,c,u){const h=Object.create(null);h["common.machineId"]=m,h["common.sqmId"]=l,h.sessionID=(0,I.$Wg)()+Date.now(),h.commitHash=w,h.version=v,h["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,s.$h)(s.$u),h["common.nodePlatform"]=j.$dc,h["common.nodeArch"]=y,h["common.product"]=u||"desktop",c&&(h["common.msftInternal"]=c);let g=0;const d=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),s.$l&&(h["common.snap"]="true");const E=D($);return E&&(h["common.platformDetail"]=E),h}function P(b){const $=j.env.USERDNSDOMAIN;if(!$)return!1;const y=$.toLowerCase();return b.some(w=>y===w)}}),define(ye[254],Ee([1,0,18,11,2,21,16]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function($){function y(w,v){return w.callstack<v.callstack?-1:w.callstack>v.callstack?1:0}$.compare=y})(P||(e.ErrorEvent=P={}));class b{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(y,w=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new I.$Tc,this.c=y,this.d=w;const v=j.$X.addListener(m=>this.j(m));this.h.add((0,I.$Sc)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(y){if(!y||y.code||(y.detail&&y.detail.stack&&(y=y.detail),j.$bb.isErrorNoTelemetry(y)||y instanceof S.$pl||typeof y?.message=="string"&&y.message.includes("Unable to read file")))return;const w=Array.isArray(y.stack)?y.stack.join(`
`):y.stack,v=y.message?y.message:(0,D.$_n)(y);w&&this.k({msg:v,callstack:w})}k(y){const w=(0,s.$wb)(this.g,y,P.compare);w<0?(y.count=1,this.g.splice(~w,0,y)):(this.g[w].count||(this.g[w].count=0),this.g[w].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const y of this.g)this.c.publicLogError2("UnhandledError",y);this.g.length=0}}e.default=b}),define(ye[255],Ee([1,0,2]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class j extends s.$Uc{constructor(D,S){super(),this.a=D,this.b=S}async call(D,S,P){switch(S){case"updateTelemetryLevel":{const{telemetryLevel:b}=P;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:$}=P;return this.b?this.b.log(b,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${S} not found`)}listen(D,S,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Vs=j}),define(ye[27],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,s.$Ai)("telemetryService"),e.$7l=(0,s.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var j;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var I;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(ye[256],Ee([1,0,31,14,43,13,7,3,4,103,23,106,232,16,30,27]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ks=h,e.$Ls=d,e.$Ms=E;const u=new Map;async function h(t,o){const r=`${t}::${o.join(":")}`,n=u.get(r);if(n)return n;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,p=new Map,k=2e4;function C(O,N,V,ie){const ae=N.substring(O.length+1);return j.Promises.withAsyncBody(async te=>{let ee;try{ee=await y.Promises.readdir(N,{withFileTypes:!0})}catch{te();return}if(ie.count>=k){ie.count+=ee.length,ie.maxReached=!0,te();return}let K=ee.length;if(K===0){te();return}let B=ee;ie.count+ee.length>k&&(ie.maxReached=!0,K=k-ie.count,B=ee.slice(0,K)),ie.count+=ee.length;for(const Z of B)if(Z.isDirectory()){if(V.includes(Z.name)||await C(O,(0,S.$jc)(N,Z.name),V,ie),--K===0){te();return}}else{const Y=Z.name.lastIndexOf(".");if(Y>=0){const M=Z.name.substring(Y+1);M&&i.set(M,(i.get(M)??0)+1)}for(const M of a)M.relativePathPattern?.test(ae)!==!1&&M.filePattern.test(Z.name)&&p.set(M.tag,(p.get(M.tag)??0)+1);if(--K===0){te();return}}})}const A=j.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1};await C(t,t,o,N);const V=await E(t);O({configFiles:g(p),fileTypes:g(i),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:V})});return u.set(r,A),A}function g(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function d(){const t={os:`${s.type()} ${s.arch()} ${s.release()}`,memory:`${(s.totalmem()/m.$Cl.GB).toFixed(2)}GB (${(s.freemem()/m.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$In.value()*100)}%`},o=s.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function E(t){try{const o=new Map,r=(0,S.$jc)(t,".vscode","launch.json"),n=await y.Promises.readFile(r),a=[],i=(0,I.$Nn)(n.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,I.$Wn)(i)==="object"&&i.configurations)for(const p of i.configurations){const k=p.type;k&&(o.has(k)?o.set(k,o.get(k)+1):o.set(k,1))}return g(o)}catch{return[]}}let f=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${s.type()} ${s.arch()} ${s.release()}`);const n=s.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(s.totalmem()/m.$Cl.GB).toFixed(2)}GB (${(s.freemem()/m.$Cl.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${s.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round($.$In.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,w.$Js)(o.mainPID),this.k(o)]).then(async n=>{let[a,i]=n,p=this.m(o,a);return r.forEach(k=>{if((0,v.$in)(k))p+=`
${k.errorMessage}`,i+=`
${k.errorMessage}`;else if(p+=`

Remote: ${k.hostName}`,k.processes&&(p+=`
${this.m(o,k.processes)}`),k.workspaceMetadata){i+=`
|  Remote: ${k.hostName}`;for(const C of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[C];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),i+=`|    Folder (${C}): ${O}`,i+=this.h(A)}}}),{processInfo:p,workspaceInfo:i}})}async getSystemInfo(o,r){const{memory:n,vmHint:a,os:i,cpus:p}=d(),k={os:i,memory:n,cpus:p,vmHint:a,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(k.load=`${s.loadavg().map(C=>Math.round(C)).join(", ")}`),P.$k&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(o,r){const n=[];return(0,w.$Js)(o.mainPID).then(async a=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,a)),o.windows.some(i=>i.folderURIs&&i.folderURIs.length>0&&!i.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),r.forEach(i=>{if((0,v.$in)(i))n.push(`
${i.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${i.hostName}`),n.push(this.f(i.machineInfo)),i.processes&&n.push(this.m(o,i.processes)),i.workspaceMetadata)for(const p of Object.keys(i.workspaceMetadata)){const k=i.workspaceMetadata[p];let C=`${k.fileCount} files`;k.maxFilesReached&&(C=`more than ${C}`),n.push(`Folder (${p}): ${C}`),n.push(this.h(k))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const r=[];let a=0;const i=(A,O)=>{const N=` ${A}(${O})`;a+N.length>60?(r.push(p),p="|                 ",a=p.length):a+=N.length,p+=N};let p="|      File types:";const k=10,C=o.fileTypes.length>k?k:o.fileTypes.length;for(let A=0;A<C;A++){const O=o.fileTypes[A];i(O.name,O.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",a=0,o.configFiles.forEach(A=>{i(A.name,A.count)}),r.push(p)),o.launchConfigFiles.length>0){let A="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{const N=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;A+=N}),r.push(A)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const r=[],n=[];return o.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(i=>{const p=b.URI.revive(i);if(p.scheme===D.Schemas.file){const k=p.fsPath;n.push(h(k,["node_modules",".git"]).then(C=>{let A=`${C.fileCount} files`;C.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,S.$nc)(k)}): ${A}`),r.push(this.h(C))}).catch(C=>{r.push(`|      Error: Unable to collect workspace stats for folder ${k} (${C.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(o,r){const n=new Map;o.windows.forEach(i=>n.set(i.pid,`window [${i.id}] (${i.title})`)),o.pidToNames.forEach(({pid:i,name:p})=>n.set(i,p));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,n,a,r,0),a.join(`
`)}n(o,r,n,a,i){const p=i===0;let k;p?k=a.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(a.pid)?k=r.get(a.pid):k=`${"  ".repeat(i)} ${a.name}`;const C=process.platform==="win32"?a.mem:s.totalmem()*(a.mem/100);n.push(`${a.load.toFixed(0).padStart(5," ")}	${(C/m.$Cl.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(A=>this.n(o,r,n,A,i+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:n}of o.folders){const a=b.URI.revive(n);if(a.scheme!==D.Schemas.file)continue;const i=a.fsPath;try{(await h(i,["node_modules",".git"])).fileTypes.forEach(k=>r.add(k.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const n=b.URI.revive(r);if(n.scheme!==D.Schemas.file)continue;const a=n.fsPath;try{const i=await h(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),i.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),i.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),i.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Ns=f,e.$Ns=f=Le([Oe(0,c.$6l),Oe(1,l.$nk)],f)}),define(ye[89],Ee([1,0,11,5,12,27]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.ExtensionSignatureVerificationCode=e.$fq=void 0,e.$fq=(0,j.$Ai)("IExtensionSignatureVerificationService");var S;(function($){$.None="None",$.RequiredArgumentMissing="RequiredArgumentMissing",$.InvalidArgument="InvalidArgument",$.PackageIsUnreadable="PackageIsUnreadable",$.UnhandledException="UnhandledException",$.SignatureManifestIsMissing="SignatureManifestIsMissing",$.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",$.SignatureIsMissing="SignatureIsMissing",$.SignatureIsUnreadable="SignatureIsUnreadable",$.CertificateIsUnreadable="CertificateIsUnreadable",$.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",$.FileAlreadyExists="FileAlreadyExists",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",$.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",$.Success="Success",$.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",$.SignatureIsInvalid="SignatureIsInvalid",$.SignatureManifestIsInvalid="SignatureManifestIsInvalid",$.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",$.EntryIsMissing="EntryIsMissing",$.EntryIsTampered="EntryIsTampered",$.Untrusted="Untrusted",$.CertificateRevoked="CertificateRevoked",$.SignatureIsNotValid="SignatureIsNotValid",$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(S||(e.ExtensionSignatureVerificationCode=S={}));class P extends Error{constructor(y){super(y),this.code=y}}e.$gq=P;let b=class{constructor(y,w){this.b=y,this.c=w}d(){return this.a||(this.a=new Promise((y,w)=>fe(["@vscode/vsce-sign"],async v=>y(v),w))),this.a}async verify(y,w,v,m){let l;const c=y.identifier.id;try{l=await this.d()}catch(d){return this.b.error("Could not load vsce-sign module",(0,s.$0)(d)),this.b.info(`Extension signature verification is not done: ${c}`),!1}const u=new Date().getTime();let h;try{this.b.trace(`Verifying extension signature for ${c}...`),h=await l.verify(w,v,this.b.getLevel()===I.LogLevel.Trace)}catch(d){h={code:"UnknownError",didExecute:!1,output:(0,s.$0)(d)}}const g=new Date().getTime()-u;if(this.b.info(`Extension signature verification result for ${c}: ${h.code}. Executed: ${h.didExecute}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${c}:
${h.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:c,extensionVersion:y.version,code:h.code,internalCode:h.internalCode,duration:g,didExecute:h.didExecute,clientTargetPlatform:m}),h.code==="Success")return!0;throw new P(h.code)}};e.$hq=b,e.$hq=b=Le([Oe(0,I.$7j),Oe(1,D.$6l)],b)}),define(ye[37],Ee([1,0,21,10,86,121,27]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=y,e.$tp=w,e.$up=v,e.$vp=m,e.$wp=c,e.$xp=h,e.$yp=g,e.$zp=f;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$lp=P;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=b,e.$np=new b;class ${async publicLog(o,r,n){}async publicLogError(o,r,n){}}e.$op=$,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function w(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const o=t.getValue(S.$bm),r=t.getValue(S.$cm);if(t.getValue(S.$dm)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const o={},r={},n={};u(t,n);for(let a in n){a=a.length>150?a.substr(a.length-149):a;const i=n[a];typeof i=="number"?r[a]=i:typeof i=="boolean"?r[a]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${i.length}`),o[a]=i.substring(0,8191)):typeof i<"u"&&i!==null&&(o[a]=i)}return{properties:o,measurements:r}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const o=(0,I.$Mm)(t);return l.has(o)?o:"other"}function u(t,o,r=0,n){if(t)for(const a of Object.getOwnPropertyNames(t)){const i=t[a],p=n?n+a:a;Array.isArray(i)?o[p]=(0,s.$_n)(i):i instanceof Date?o[p]=i.toISOString():(0,j.$cg)(i)?r<2?u(i,o,r+1,p+"."):o[p]=(0,s.$_n)(i):o[p]=i}}function h(t,o){const r=t.msftInternalDomains||[],n=o.getValue("telemetry.internalTesting");return(0,D.$kp)(r)||n}function g(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function d(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const n=[];for(const k of o)for(;;){const C=k.exec(t);if(!C)break;n.push([C.index,k.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const k=i.exec(t);if(!k)break;const C=n.some(([A,O])=>k.index<O&&A<i.lastIndex);!a.test(k[0])&&!C&&(r+=t.substring(p,k.index)+"<REDACTED: user-file-path>",p=i.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function E(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function f(t,o){return(0,s.$9n)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let n=r.replaceAll("%20"," ");n=d(n,o);for(const a of o)n=n.replace(a,"");return n=E(n),n}})}}),define(ye[38],Ee([1,0,17,29,40,3,4,11,32,37]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=y,e.$Cp=l,e.$Dp=c,e.$Ep=u,e.$Fp=h,e.$Gp=g,e.$Hp=d,e.$Ip=E,e.$Kp=f,e.$Lp=o;function y(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,s.$wf)(r.id,n.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const a=n.manifest?n.manifest.version:n.version,i=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,a,i)}static parse(n){const a=w.exec(n);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,i="undefined"){this.identifier=n,this.version=a,this.targetPlatform=i,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Bp=v;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(r){const n=m.exec(r);return n&&n[1]?[u(n[1]),n[2]]:[u(r),void 0]}function c(r,n){return`${r}.${n}`}function u(r){return r.toLowerCase()}function h(r,n){return u(c(r??I.$Rm,n))}function g(r,n){const a=[],i=p=>{for(const k of a)if(k.some(C=>y(n(C),n(p))))return k;return null};for(const p of r){const k=i(p);k?k.push(p):a.push([p])}return a}function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function E(r){return{id:new $.$lp(r.identifier.id),name:new $.$lp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Jp=new I.$Vm("pprice.better-merge");function f(r,n){const a=[],i=n.manifest.extensionDependencies?.slice(0)??[];for(;i.length;){const p=i.shift();if(p&&a.every(k=>!y(k.identifier,{id:p}))){const k=r.filter(C=>y(C.identifier,{id:p}));k.length===1&&(a.push(k[0]),i.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function t(r,n){if(!D.$k)return!1;let a;try{a=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){n.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,n){const a=await t(r,n),i=(0,j.$8o)(a?"alpine":D.$u,b.$ec);return n.debug("ComputeTargetPlatform:",i),i}}),define(ye[122],Ee([1,0,20,11,13,19,57,4,195,29,38,40]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;const v=c=>(0,b.localize)(0,null,c),m=(0,b.localize)(1,null,"ms-dotnettools.csharp");let l=class{constructor(u,h,g){this.a=u,this.b=h,this.d=g}get f(){}async listExtensions(u,h,g){let d=await this.b.getInstalled(1,g);const E=w.$Um.map(t=>t.toLowerCase());if(h&&h!==""){if(E.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(t=>t.manifest.categories?t.manifest.categories.map(r=>r.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),E.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),d=d.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let f;for(const t of d)f!==t.identifier.id&&(f=t.identifier.id,this.a.info(u?`${f}@${t.manifest.version}`:f))}async installExtensions(u,h,g,d){const E=[];try{u.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const f=[],t=[],o=(n,a,i)=>{t.push({id:n,version:a!=="prerelease"?a:void 0,installOptions:{...g,isBuiltin:i,installPreReleaseVersion:a==="prerelease"||g.installPreReleaseVersion}})};for(const n of u)if(n instanceof P.URI)f.push({vsix:n,installOptions:g});else{const[a,i]=(0,y.$Cp)(n);o(a,i,!1)}for(const n of h)if(n instanceof P.URI)f.push({vsix:n,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[a,i]=(0,y.$Cp)(n);o(a,i,!0)}const r=await this.b.getInstalled(void 0,g.profileLocation);if(f.length&&await Promise.all(f.map(async({vsix:n,installOptions:a})=>{try{await this.h(n,a,d,r)}catch(i){this.a.error(i),E.push(n.toString())}})),t.length){const n=await this.g(t,r,d);E.push(...n)}}catch(f){throw this.a.error((0,b.localize)(5,null,(0,j.$0)(f))),f}if(E.length)throw new Error((0,b.localize)(6,null,E.join(", ")))}async updateExtensions(u){const h=await this.b.getInstalled(1,u),g=[];for(const t of h)t.identifier.uuid&&g.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,b.localize)(7,null,g.length));const d=await this.d.getExtensions(g,{compatible:!0},s.CancellationToken.None),E=[];for(const t of d)for(const o of h)(0,y.$Ap)(o.identifier,t.identifier)&&(0,S.gt)(t.version,o.manifest.version)&&E.push({extension:t,options:{operation:3,installPreReleaseVersion:o.preRelease,profileLocation:u}});if(!E.length){this.a.info((0,b.localize)(8,null));return}this.a.info((0,b.localize)(9,null,E.map(t=>t.extension.identifier.id).join(", ")));const f=await this.b.installGalleryExtensions(E);for(const t of f)t.error?this.a.error((0,b.localize)(10,null,t.identifier.id,(0,j.$0)(t.error))):this.a.info((0,b.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(u,h,g){if(u=u.filter(({id:t,version:o})=>{const r=h.find(n=>(0,y.$Ap)(n.identifier,{id:t}));if(r){if(!g&&(!o||o==="prerelease"&&r.preRelease))return this.a.info((0,b.localize)(12,null,t,r.manifest.version,t)),!1;if(o&&r.manifest.version===o)return this.a.info((0,b.localize)(13,null,`${t}@${o}`)),!1}return!0}),!u.length)return[];const d=[],E=[],f=await this.j(u);if(await Promise.all(u.map(async({id:t,version:o,installOptions:r})=>{const n=f.get(t.toLowerCase());if(!n){this.a.error(`${v(o?`${t}@${o}`:t)}
${m}`),d.push(t);return}try{const i=await this.d.getManifest(n,s.CancellationToken.None);if(i&&!this.k(i))return}catch(i){this.a.error(i.message||i.stack||i),d.push(t);return}const a=h.find(i=>(0,y.$Ap)(i.identifier,n.identifier));if(a){if(n.version===a.manifest.version){this.a.info((0,b.localize)(14,null,o?`${t}@${o}`:t));return}this.a.info((0,b.localize)(15,null,t,n.version))}r.isBuiltin?this.a.info(o?(0,b.localize)(16,null,t,o):(0,b.localize)(17,null,t)):this.a.info(o?(0,b.localize)(18,null,t,o):(0,b.localize)(19,null,t)),E.push({extension:n,options:{...r,installGivenVersion:!!o}})})),E.length){const t=await this.b.installGalleryExtensions(E);for(const o of t)o.error?(this.a.error((0,b.localize)(20,null,o.identifier.id,(0,j.$0)(o.error))),d.push(o.identifier.id)):this.a.info((0,b.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return d}async h(u,h,g,d){const E=await this.b.getManifest(u);if(!E)throw new Error("Invalid vsix");if(await this.l(E,g,h.profileLocation,d))try{await this.b.install(u,h),this.a.info((0,b.localize)(22,null,(0,D.$$g)(u)))}catch(t){if((0,j.$4)(t))this.a.info((0,b.localize)(23,null,(0,D.$$g)(u)));else throw t}}async j(u){const h=new Map,g=u.some(f=>f.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),E=[];for(const f of u)$.$Zo.test(f.id)&&E.push({...f,preRelease:g});if(E.length){const f=await this.d.getExtensions(E,{targetPlatform:d},s.CancellationToken.None);for(const t of f)h.set(t.identifier.id.toLowerCase(),t)}return h}k(u){return!0}async l(u,h,g,d){if(!h){const E={id:(0,y.$Fp)(u.publisher,u.name)},f=d.find(t=>(0,y.$Ap)(E,t.identifier)&&(0,S.gt)(t.manifest.version,u.version));if(f)return this.a.info((0,b.localize)(24,null,f.identifier.id,f.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,h,g){const d=async f=>{if(f instanceof P.URI){const t=await this.b.getManifest(f);return(0,y.$Dp)(t.publisher,t.name)}return f},E=[];for(const f of u){const t=await d(f),r=(await this.b.getInstalled(void 0,g)).filter(n=>(0,y.$Ap)(n.identifier,{id:t}));if(!r.length)throw new Error(`${this.m(t)}
${m}`);if(r.some(n=>n.type===0)){this.a.info((0,b.localize)(25,null,t));return}if(!h&&r.some(n=>n.isBuiltin)){this.a.info((0,b.localize)(26,null,t));return}this.a.info((0,b.localize)(27,null,t));for(const n of r)await this.b.uninstall(n,{profileLocation:g}),E.push(n);this.f?this.a.info((0,b.localize)(28,null,t,this.f)):this.a.info((0,b.localize)(29,null,t))}}async locateExtension(u){const h=await this.b.getInstalled();u.forEach(g=>{h.forEach(d=>{if(d.identifier.id===g&&d.location.scheme===I.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(u){return this.f?(0,b.localize)(30,null,u,this.f):(0,b.localize)(31,null,u)}};e.$iq=l,e.$iq=l=Le([Oe(1,$.$cp),Oe(2,$.$_o)],l)}),define(ye[257],Ee([1,0,6,2,24,38,40]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class P extends j.$Uc{constructor($,y,w,v,m,l,c){super(),this.f=$,this.g=y,this.h=w,this.j=v,this.m=m,this.n=l,this.r=c,this.a=this.B(new s.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$4c),this.s().then(null,u=>c.error(u))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(y=>(this.c.set(y.id,(0,j.$Rc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w($){for(const y of $.extensions)this.I(this.L(y.identifier,y.version),$.profileLocation)}async y($){for(const y of $.extensions){const w=this.L(y.identifier,y.version);$.error?this.J(w,$.profileLocation):this.I(w,$.profileLocation)}}async z($){for(const y of $.extensions)this.J(this.L(y.identifier,y.version),$.profileLocation)}async C($){const y=[],w=[];for(const v of $.extensions){const m=this.L(v.identifier,v.version);$.error?this.I(m,$.profileLocation):(this.J(m,$.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),w.push(this.f.scanInstalledExtensionAtLocation(v.location).then(l=>{l?y.push(l):this.r.info("Extension not found at the location",v.location.toString())},l=>this.r.error(l)))))}try{await Promise.all(w),y.length&&await this.H(y)}catch(v){this.r.error(v)}}D($){for(const y of this.h.profiles)$.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F($){const y=[],w=[],v=await this.j.scanProfileExtensions($),m=new Set,l=new Set;for(const[c,u]of this.b)u.has($)&&l.add(c);for(const c of v){const u=this.L(c.identifier,c.version);m.add(u),l.has(u)||(y.push(c.identifier),this.I(u,$))}for(const c of l)if(!m.has(c)){const u=this.M(c);u&&(w.push(u.identifier),this.J(c,$))}(y.length||w.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:$}:void 0,removed:w.length?{extensions:w,profileLocation:$}:void 0})}async G($){const y=await this.j.scanProfileExtensions($);for(const w of y)this.I(this.L(w.identifier,w.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.L(w.identifier,w.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,y){let w=this.b.get($);w||this.b.set($,w=new I.$Bc(v=>this.m.extUri.getComparisonKey(v))),w.add(y)}J($,y){const w=this.b.get($);w&&w.delete(y),w?.size||this.b.delete($)}L($,y){return`${S.$Vm.toKey($.id)}@${y}`}M($){const[y,w]=(0,D.$Cp)($);return w?{identifier:{id:y},version:w}:void 0}}e.$Jq=P}),define(ye[258],Ee([1,0,230,37]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=I;async function I(D,S,P,b,$,y,w){const v={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${S.nameShort})`};if((0,j.$sp)(S,P)&&(0,j.$up)(b)===3){const m=await(0,s.$aq)(P,$,y);v["X-Market-User-Id"]=m,v["VSCode-SessionId"]=w.machineId||m}return v}}),define(ye[123],Ee([1,0,90,18,14,2,13,7,23,26,29,38,12,85,4]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let c=class extends m.$Yr{constructor(d,E,f,t){super(f),this.h=d,this.j=t,this.g=this.B(new u(E,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(d,E){const t=(await this.g.getLanguagePacks())[E];if(!t){this.j.warn(`No language pack found for ${E}`);return}const o=t.translations[d];return o?l.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),E=Object.keys(d).map(f=>{const t=d[f];return{...this.f(f,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((f,t)=>f.label.localeCompare(t.label)),E}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const E=await this.g.getLanguagePacks();Object.keys(E).some(f=>E[f]&&E[f].extensions.some(t=>(0,w.$Ap)(t.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),f=await this.g.update(E);return!(0,j.$ub)(Object.keys(d),Object.keys(f))}};e.$Zr=c,e.$Zr=c=Le([Oe(0,y.$cp),Oe(1,$.$Ii),Oe(2,y.$_o),Oe(3,v.$7j)],c);let u=class extends D.$Uc{constructor(d,E){super(),this.j=E,this.c={},this.f=(0,P.$jc)(d.userDataPath,"languagepacks.json"),this.g=new I.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(E=>{Object.keys(E).forEach(f=>delete E[f]),this.m(E,...d)}).then(()=>this.c)}m(d,...E){for(const f of E)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.n(d,f);Object.keys(d).forEach(f=>this.r(d[f]))}n(d,E){const f=E.identifier,t=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of t)if(E.location.scheme===S.Schemas.file&&h(o)){let r=d[o.languageId];r||(r={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},d[o.languageId]=r);const n=r.extensions.filter(a=>(0,w.$Ap)(a.extensionIdentifier,f))[0];n?n.version=E.manifest.version:r.extensions.push({extensionIdentifier:f,version:E.manifest.version});for(const a of o.translations)r.translations[a.id]=(0,P.$jc)(E.location.fsPath,a.path)}}r(d){if(d){const E=(0,s.createHash)("md5");for(const f of d.extensions)E.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);d.hash=E.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let E=null;return b.Promises.readFile(this.f,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(E=d(f),f)).then(f=>{for(const o of Object.keys(f))f[o]||delete f[o];this.c=f,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>E,f=>this.j.error(f))})}};u=Le([Oe(0,$.$Ii),Oe(1,v.$7j)],u);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const d of g.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(ye[259],Ee([1,0,180,11,21,37]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;const S="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function b(y,w,v){const m=await(0,s.$bE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,s.$bE)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new m.AppInsightsCore,u=new l.PostChannel,h={instrumentationKey:y,endpointUrl:S,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[u]]};if(v){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:v};h.extensionConfig[u.identifier]=g}return c.initialize(h,[]),c.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',w&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),c}class ${constructor(w,v,m,l,c){this.e=w,this.f=v,this.g=m,this.h=c,this.c=S,this.d=P,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(w){if(this.a){if(typeof this.a!="string"){w(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(v=>{w(v)},v=>{(0,j.$1)(v),console.error(v)})}}log(w,v){if(!this.a)return;v=(0,I.$0n)(v,this.g),v=(0,D.$vp)(v);const m=this.f+"/"+w;try{this.i(l=>{l.pluginVersionString=v?.properties.version??"Unknown",l.track({name:m,baseData:{name:m,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(w=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.$5P=$}),define(ye[260],Ee([1,0,2,21,3,17,210,25,50,58,30,36,27,37]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,g,d){this.k=g,this.l=d,this.d={},this.i=new s.$Tc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,D.$df)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$df)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(v.$bm)||E.affectsConfiguration(v.$dm)||E.affectsConfiguration(v.$cm))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,m.$up)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const d=g.usage?3:g.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,d){this.g<g||(d=(0,j.$0n)(d,this.d),d=(0,m.$zp)(d,this.j),d=(0,j.$0n)(d,this.c),this.b.forEach(E=>E.log(h,d)))}publicLog(h,g){this.n(h,3,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,2,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$6r=l,e.$6r=l=Le([Oe(1,P.$7i),Oe(2,y.$nk)],l);function c(){const u=(0,S.localize)(0,null,$.default.nameLong),h=$.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=I.$o?"":(0,S.localize)(3,null),d=(0,S.localize)(4,null),E=(0,S.localize)(5,null),f=(0,S.localize)(6,null),t=(0,S.localize)(7,null),o=`
|       | ${d} | ${E} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,S.localize)(8,null);return`
${u} ${h} ${g}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}w.$ho.as(b.$mo.Configuration).registerConfiguration({id:v.$am,order:1,type:"object",title:(0,S.localize)(9,null),properties:{[v.$bm]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$ho.as(b.$mo.Configuration).registerConfiguration({id:v.$am,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[v.$dm]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,S.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,S.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${v.$bm}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ye[261],Ee([1,0,25,5,30,27,260,37]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=void 0;let b=class extends S.$6r{constructor(y,w,v,m){super(y,v,m),this.o=w}publicLog(y,w){if(!(this.o<3))return super.publicLog(y,w)}publicLog2(y,w){return this.publicLog(y,w)}publicLogError(y,w){return this.o<2?Promise.resolve(void 0):super.publicLogError(y,w)}publicLogError2(y,w){return this.publicLogError(y,w)}async updateInjectedTelemetryLevel(y){if(y===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,y):y,this.o===0&&this.dispose()}};e.$Ss=b,e.$Ss=b=Le([Oe(2,s.$7i),Oe(3,I.$nk)],b),e.$Ts=new class extends P.$mp{async updateInjectedTelemetryLevel(){}},e.$Us=(0,j.$Bi)(D.$6l)}),define(ye[262],Ee([1,0,15,20,314,259]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;async function S(y,w){const v=await w.request(y,j.CancellationToken.None),m=(await(0,s.$Ve)(v.stream)).toString(),l=v.res.statusCode??200;return{headers:v.res.headers,statusCode:l,responseData:m}}async function P(y){const w={method:y.type,headers:y.headers};return new Promise((m,l)=>{const c=I.request(y.url??"",w,u=>{u.on("data",function(h){m({headers:u.headers,statusCode:u.statusCode??200,responseData:h.toString()})}),u.on("error",function(h){l(h)})});c.write(y.data,u=>{u&&l(u)}),c.end()})}async function b(y,w,v){const m=typeof w.data=="string"?w.data:new TextDecoder().decode(w.data),l={type:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data).toString()},url:w.urlString,data:m};try{const c=y?await S(l,y):await P(l);v(c.statusCode,c.headers,c.responseData)}catch{v(0,{})}}class $ extends D.$5P{constructor(w,v,m,l,c){const u={sendPOST:(h,g)=>{b(w,h,g)}};super(v,m,l,c,u)}}e.$6P=$}),define(ye[263],Ee([1,0,11,254]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class I extends j.default{i(){(0,s.setUnexpectedErrorHandler)(P=>console.error(P));const S=[];process.on("unhandledRejection",(P,b)=>{S.push(b),setTimeout(()=>{const $=S.indexOf(b);$>=0&&b.catch(y=>{S.splice($,1),(0,s.$4)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y.stack&&console.warn(`stack trace: ${y.stack}`),P&&(0,s.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const b=S.indexOf(P);b>=0&&S.splice(b,1)}),process.on("uncaughtException",P=>{(0,s.$Z)(P)||(0,s.$1)(P)})}}e.default=I}),define(ye[124],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var s;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(s||(e.EnvironmentVariableMutatorType=s={}))}),define(ye[125],Ee([1,0,3,124]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;const I=new Map([[j.EnvironmentVariableMutatorType.Append,"APPEND"],[j.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[j.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((w,v)=>{this.d(w,v);const m=w.map.entries();let l=m.next();for(;!l.done;){const c=l.value[1],u=l.value[0];let h=this.a.get(u);if(h||(h=[],this.a.set(u,h)),h.length>0&&h[0].type===j.EnvironmentVariableMutatorType.Replace){l=m.next();continue}const g={extensionIdentifier:v,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};g.scope||delete g.scope,h.unshift(g),l=m.next()}})}async applyToProcessEnvironment(y,w,v){let m;s.$i&&(m={},Object.keys(y).forEach(l=>m[l.toLowerCase()]=l));for(const[l,c]of this.getVariableMap(w)){const u=s.$i&&m[l.toLowerCase()]||l;for(const h of c){const g=v?await v(h.value):h.value;if(h.options?.applyAtProcessCreation??!0)switch(h.type){case j.EnvironmentVariableMutatorType.Append:y[u]=(y[u]||"")+g;break;case j.EnvironmentVariableMutatorType.Prepend:y[u]=g+(y[u]||"");break;case j.EnvironmentVariableMutatorType.Replace:y[u]=g;break}if(h.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${I.get(h.type)}`;y[d]=(y[d]?y[d]+":":"")+l+"="+this.c(g)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,w){const v=new Map,m=new Map,l=new Map;if(y.getVariableMap(w).forEach((c,u)=>{const h=this.getVariableMap(w).get(u),g=P(c,h);g&&v.set(u,g)}),this.getVariableMap(w).forEach((c,u)=>{const h=y.getVariableMap(w).get(u),g=P(c,h);g&&l.set(u,g)}),this.getVariableMap(w).forEach((c,u)=>{const h=y.getVariableMap(w).get(u),g=b(c,h);g&&m.set(u,g)}),!(v.size===0&&m.size===0&&l.size===0))return{added:v,changed:m,removed:l}}getVariableMap(y){const w=new Map;for(const v of this.a.values()){const m=v.filter(l=>S(l,y));m.length>0&&w.set(m[0].variable,m)}return w}getDescriptionMap(y){const w=new Map;for(const v of this.b.values()){const m=v.filter(l=>S(l,y,!0));for(const l of m)w.set(l.extensionIdentifier,l.description)}return w}d(y,w){if(!y.descriptionMap)return;const v=y.descriptionMap.entries();let m=v.next();for(;!m.done;){const l=m.value[1],c=m.value[0];let u=this.b.get(c);u||(u=[],this.b.set(c,u));const h={extensionIdentifier:w,scope:l.scope,description:l.description};h.scope||delete h.scope,u.push(h),m=v.next()}}}e.$xs=D;function S($,y,w=!1){return $.scope?!!($.scope.workspaceFolder&&y?.workspaceFolder&&$.scope.workspaceFolder.index===y.workspaceFolder.index):w?y===$.scope:!0}function P($,y){if(!y)return $;const w=new Set;y.forEach(m=>w.add(m.extensionIdentifier));const v=[];return $.forEach(m=>{w.has(m.extensionIdentifier)||v.push(m)}),v.length===0?void 0:v}function b($,y){if(!y)return;const w=new Map;y.forEach(m=>w.set(m.extensionIdentifier,m));const v=[];return $.forEach(m=>{const l=w.get(m.extensionIdentifier);l&&(m.type!==l.type||m.value!==l.value||m.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&v.push(l)}),v.length===0?void 0:v}}),define(ye[91],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=s,e.$ss=j,e.$ts=I,e.$us=D,e.$vs=S,e.$ws=P;function s(b){return[...b.entries()]}function j(b){return b?[...b.entries()]:[]}function I(b){return new Map(b)}function D(b){return new Map(b??[])}function S(b){return Array.from(b.entries()).map($=>[$[0],s($[1].map),j($[1].descriptionMap)])}function P(b){return new Map(b.map($=>[$[0],{map:I($[1]),descriptionMap:D($[2])}]))}}),define(ye[264],Ee([1,0,14,20,6,2,12]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;let P=class extends D.$Uc{constructor($,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new I.$he),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$,this.B((0,D.$Sc)(()=>{for(const w of this.f.values())(0,D.$Pc)(w)}))}createRequest($){return new Promise((y,w)=>{const v=++this.a;this.c.set(v,y),this.g.fire({requestId:v,...$});const m=new j.$se;(0,s.$Bh)(this.b,m.token).then(()=>w(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,D.$Sc)(()=>m.cancel())])})}acceptReply($,y){const w=this.c.get($);w?(this.c.delete($),(0,D.$Pc)(this.f.get($)||[]),this.f.delete($),w(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$is=P,e.$is=P=Le([Oe(1,S.$7j)],P)}),define(ye[92],Ee([1,0,5,48,36]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$bs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$as=void 0,e.$as=new j.$Rj("terminalTabFocusMode",!1,!0);var D;(function(f){f.AutomationProfile="terminal.integrated.automationProfile.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var S;(function(f){f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorStyleInactive="terminal.integrated.cursorStyleInactive",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.MiddleClickBehavior="terminal.integrated.middleClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.EnableVisualBell="terminal.integrated.enableVisualBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.HideOnStartup="terminal.integrated.hideOnStartup",f.CustomGlyphs="terminal.integrated.customGlyphs",f.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.EnableImages="terminal.integrated.enableImages",f.SmoothScrolling="terminal.integrated.smoothScrolling",f.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",f.FocusAfterRun="terminal.integrated.focusAfterRun",f.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",f.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",f.DevMode="terminal.integrated.developer.devMode"})(S||(e.TerminalSettingId=S={}));var P;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh",f.Python="python"})(P||(e.PosixShellType=P={}));var b;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash",f.Python="python"})(b||(e.WindowsShellType=b={}));var $;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})($||(e.TitleEventSource=$={}));var y;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.PtyHostWindow="ptyHostWindow",f.Logger="logger",f.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var w;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$bs=(0,s.$Ai)("ptyService");var v;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var m;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var l;(function(f){f.TerminalView="view",f.Editor="editor"})(l||(e.TerminalLocationString=l={}));var c;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var u;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(u||(e.FlowControlConstants=u={}));var h;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var g;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var d;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$cs={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}I.$ho.add(e.$cs.Backend,new E),e.$ds=(0,s.$Ai)("localPtyService"),e.$es=(0,s.$Ai)("terminalLogService")}),define(ye[126],Ee([1,0,3]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=j,e.$IP=I,e.$JP=D,e.$KP=S;function j(P){let b=P;b.includes("\\")&&(b=b.replace(/\\/g,"\\\\"));const $=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return b=b.replace($,""),`'${b}'`}function I(P,b,$){if(!P)return"";if(!b)return P;b.match(/[\/\\]$/)&&(b=b.slice(0,b.length-1));const y=P.replace(/\\/g,"/").toLowerCase(),w=b.replace(/\\/g,"/").toLowerCase();return y.includes(w)?`~${$}${P.slice(b.length+1)}`:P}function D(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),s.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function S(P){return!P.strictEnv}}),define(ye[265],Ee([1,0,54,4,212,76]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=S,e.$ks=$,e.$ls=y,e.$ms=w;function S(v,m){const l=[{name:null,description:(0,I.localize)(0,null)}];return l.push(...v.map(c=>({name:c.profileName,description:P(c)}))),m&&l.push(...m.map(c=>({name:c.title,description:b(c)}))),{values:l.map(c=>c.name),markdownDescriptions:l.map(c=>c.description)}}function P(v){let m=`$(${D.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:s.$Zj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?m+=`
- args: "${v.args}"`:m+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(m+=`
- overrideName: ${v.overrideName}`),v.color&&(m+=`
- color: ${v.color}`),v.env&&(m+=`
- env: ${JSON.stringify(v.env)}`),m}function b(v){return`$(${D.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:s.$Zj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function $(v,m){if(!v&&!m)return!0;if(typeof v=="string"&&typeof m=="string")return v===m;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let l=0;l<v.length;l++)if(v[l]!==m[l])return!1;return!0}return!1}function y(v,m){if(!v&&!m)return!0;if(!v||!m)return!1;if(D.ThemeIcon.isThemeIcon(v)&&D.ThemeIcon.isThemeIcon(m))return v.id===m.id&&v.color===m.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof m=="object"&&"light"in m&&"dark"in m){const l=v,c=m;if((j.URI.isUri(l.light)||w(l.light))&&(j.URI.isUri(l.dark)||w(l.dark))&&(j.URI.isUri(c.light)||w(c.light))&&(j.URI.isUri(c.dark)||w(c.dark)))return l.light.path===c.light.path&&l.dark.path===c.dark.path}if(j.URI.isUri(v)&&j.URI.isUri(m)||w(v)||w(m)){const l=v,c=m;return l.path===c.path&&l.scheme===c.scheme}return!1}function w(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(ye[266],Ee([1,0,54,3,211,50,36,265]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=void 0,e.$ps=m,e.$qs=c,e.$ns={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$os={type:"string",enum:Array.from((0,s.$Xj)(),u=>u.id),markdownEnumDescriptions:Array.from((0,s.$Xj)(),u=>`$(${u.id})`)};const b={args:{description:(0,I.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,I.localize)(1,null),type:"boolean"},icon:{description:(0,I.localize)(2,null),...e.$os},color:{description:(0,I.localize)(3,null),...e.$ns},env:{markdownDescription:(0,I.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},y={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function w(u){const h=u===2?"linux":u===1?"osx":"windows";return(0,I.localize)(7,null,(0,j.$h)(u),'```json\n"terminal.integrated.profile.'+h+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,I.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,I.localize)(12,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(13,null),type:"string"},id:{description:(0,I.localize)(14,null),type:"string"},title:{description:(0,I.localize)(15,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(16,null),type:"string"},id:{description:(0,I.localize)(17,null),type:"string"},title:{description:(0,I.localize)(18,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(19,null),type:"string"},id:{description:(0,I.localize)(20,null),type:"string"},title:{description:(0,I.localize)(21,null),type:"string"},...b}},{type:"null"},$]}},"terminal.integrated.useWslProfiles":{description:(0,I.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,I.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,I.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,I.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,I.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){S.$ho.as(D.$mo.Configuration).registerConfiguration(v),c()}let l;function c(u,h){const g=S.$ho.as(D.$mo.Configuration);let d;u&&(d=(0,P.$js)(u?.profiles,h));const E=l;l={id:"terminal",order:100,title:(0,I.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(28,null),type:["string","null"],default:null,enum:u?.os===3?d?.values:void 0,markdownEnumDescriptions:u?.os===3?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(29,null),type:["string","null"],default:null,enum:u?.os===2?d?.values:void 0,markdownEnumDescriptions:u?.os===2?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(30,null),type:["string","null"],default:null,enum:u?.os===1?d?.values:void 0,markdownEnumDescriptions:u?.os===1?d?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[l],remove:E?[E]:[]})}}),define(ye[267],Ee([1,0,2,13,109,26,110]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;let P=class extends s.$Uc{constructor($,y){super(),this.a=$,this.b=y}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:j.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},y=(0,S.$bn)(this.b.args,this.b.isBuilt);y&&(y.break&&y.port?$.debugBrk=y.port:!y.break&&y.port&&($.debug=y.port));const w=new I.$7q(j.$Ug.asFileUri("bootstrap-fork").fsPath,$),v=new s.$Tc;return v.add(w),{client:w,store:v,onDidProcessExit:w.onDidProcessExit}}};e.$nQ=P,e.$nQ=P=Le([Oe(1,D.$Hi)],P)}),define(ye[268],Ee([1,0,31,13,21,7,3,32,17,10,23,124,91,125]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=l,e.$zs=c,e.$As=u;function l(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(s.release());let p=0;return i&&i.length===4&&(p=parseInt(i[3])),p}async function c(i,p,k,C=P.env,A=y.Promises.exists){if(D.$ic(i))return await A(i)?i:void 0;if(p===void 0&&(p=P.cwd()),D.$mc(i)!=="."){const ie=D.$jc(p,i);return await A(ie)?ie:void 0}const N=(0,I.$bo)(C,"PATH");if(k===void 0&&(0,$.$ag)(N)&&(k=N.split(D.$tc)),k===void 0||k.length===0){const ie=D.$jc(p,i);return await A(ie)?ie:void 0}for(const ie of k){let ae;if(D.$ic(ie)?ae=D.$jc(ie,i):ae=D.$jc(p,ie,i),await A(ae))return ae;if(S.$i){let te=ae+".com";if(await A(te)||(te=ae+".exe",await A(te)))return te}}const V=D.$jc(p,i);return await A(V)?V:void 0}function u(i,p,k,C,A){const O=S.$i&&(!p.windowsEnableConpty||l()<18309);if(!p.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.ignoreShellIntegration||O)return;const N=i.args,V=P.$dc==="win32"?D.$nc(i.executable).toLowerCase():D.$nc(i.executable),ie=D.$mc(j.$Ug.asFileUri("").fsPath);let ae;const te={VSCODE_INJECTION:"1"};if(p.shellIntegration.nonce&&(te.VSCODE_NONCE=p.shellIntegration.nonce),S.$i){if(V==="pwsh.exe"||V==="powershell.exe")return!N||n(N)?ae=d.get(g.WindowsPwsh):r(N)&&(ae=d.get(g.WindowsPwshLogin)),ae?(ae=[...ae],ae[ae.length-1]=(0,b.$_e)(ae[ae.length-1],ie,""),p.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),{newArgs:ae,envMixin:te}):void 0;if(V==="bash.exe")return!N||N.length===0?ae=d.get(g.Bash):a(N)&&(te.VSCODE_SHELL_LOGIN="1",h(p,te),ae=d.get(g.Bash)),ae?(ae=[...ae],ae[ae.length-1]=(0,b.$_e)(ae[ae.length-1],ie),{newArgs:ae,envMixin:te}):void 0;C.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(V){case"bash":return!N||N.length===0?ae=d.get(g.Bash):a(N)&&(te.VSCODE_SHELL_LOGIN="1",h(p,te),ae=d.get(g.Bash)),ae?(ae=[...ae],ae[ae.length-1]=(0,b.$_e)(ae[ae.length-1],ie),{newArgs:ae,envMixin:te}):void 0;case"fish":{const ee=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",K=D.$jc(ie,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return te.XDG_DATA_DIRS=`${ee}:${K}`,h(p,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!N||n(N)?ae=d.get(g.Pwsh):r(N)&&(ae=d.get(g.PwshLogin)),ae?(p.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),ae=[...ae],ae[ae.length-1]=(0,b.$_e)(ae[ae.length-1],ie,""),{newArgs:ae,envMixin:te}):void 0;case"zsh":{if(!N||N.length===0?ae=d.get(g.Zsh):a(N)?(ae=d.get(g.ZshLogin),h(p,te)):(N===d.get(g.Zsh)||N===d.get(g.ZshLogin))&&(ae=N),!ae)return;ae=[...ae],ae[ae.length-1]=(0,b.$_e)(ae[ae.length-1],ie);let ee;try{ee=s.userInfo().username}catch{ee="unknown"}const K=D.$jc(s.tmpdir(),`${ee}-${A.applicationName}-zsh`);te.ZDOTDIR=K;const B=k?.ZDOTDIR??s.homedir()??"~";te.USER_ZDOTDIR=B;const Z=[];return Z.push({source:D.$jc(ie,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$jc(K,".zshrc")}),Z.push({source:D.$jc(ie,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$jc(K,".zprofile")}),Z.push({source:D.$jc(ie,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$jc(K,".zshenv")}),Z.push({source:D.$jc(ie,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$jc(K,".zlogin")}),{newArgs:ae,envMixin:te,filesToCopy:Z}}}C.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function h(i,p){if(S.$j&&i.environmentVariableCollections){const k=(0,v.$ws)(i.environmentVariableCollections),A=new m.$xs(k).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),O=[];if(A)for(const N of A)N.type===w.EnvironmentVariableMutatorType.Prepend&&O.push(N.value);O.length>0&&(p.VSCODE_PATH_PREFIX=O.join(""))}}var g;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(g||(g={}));const d=new Map;d.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(g.Zsh,["-i"]),d.set(g.ZshLogin,["-il"]),d.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],f=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function r(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(o.includes(i[0].toLowerCase())||o.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?o.includes(i.toLowerCase()):i.length===0||i?.length===1&&o.includes(i[0].toLowerCase())}function a(i){return typeof i!="string"&&(i=i.filter(p=>!t.includes(p.toLowerCase()))),i==="string"&&f.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&f.includes(i[0].toLowerCase())}}),define(ye[269],Ee([1,0,56,54,7,3,10,23,104,268,77]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=l;var w;(function(i){i.UnixShellsPath="/etc/shells"})(w||(w={}));let v,m=!0;function l(i,p,k,C,A=process.env,O,N,V,ie){return O=O||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},D.$i?c(k,O,A,N,C.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:C.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:C.getValue("terminal.integrated.defaultProfile.windows"),ie,V):r(O,N,k,i&&typeof i=="object"?{...i}:C.getValue(D.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:C.getValue(D.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),ie,V,A)}async function c(i,p,k,C,A,O,N,V,ie){const ae=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),te=`${process.env.windir}\\${ae?"Sysnative":"System32"}`;let ee=!1;(0,$.$ys)()>=16299&&(ee=!0),await d(V);const K=new Map;if(i){K.set("PowerShell",{source:"PowerShell",icon:j.$Zj.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${te}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:j.$Zj.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),K.set("Command Prompt",{path:`${te}\\cmd.exe`,icon:j.$Zj.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:j.$Zj.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${te}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}n(O,K);const B=await u(K.entries(),N,p,k,C,ie);if(i&&A)try{const Z=await t(`${te}\\${ee?"wsl":"bash"}.exe`,N);for(const Y of Z)(!O||!(Y.profileName in O))&&B.push(Y)}catch{m&&(C?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return B}async function u(i,p,k,C=process.env,A,O){const N=[];for(const[V,ie]of i)N.push(h(V,ie,p,k,C,A,O));return(await Promise.all(N)).filter(V=>!!V)}async function h(i,p,k,C,A=process.env,O,N){if(p===null)return;let V,ie,ae;if("source"in p&&!("path"in p)){const B=v?.get(p.source);if(!B)return;V=B.paths,ie=p.args||B.args,p.icon?ae=g(p.icon):B.icon&&(ae=B.icon)}else V=Array.isArray(p.path)?p.path:[p.path],ie=D.$i||Array.isArray(p.args)?p.args:void 0,ae=g(p.icon);let te;if(N){const B=V.map(Y=>typeof Y=="string"?Y:Y.path),Z=await N(B);te=new Array(V.length);for(let Y=0;Y<V.length;Y++)typeof V[Y]=="string"?te[Y]=Z[Y]:te[Y]={path:Z[Y],isUnsafe:!0}}else te=V.slice();let ee;if(p.requiresPath){let B;if((0,S.$ag)(p.requiresPath)?B=p.requiresPath:(B=p.requiresPath.path,p.requiresPath.isUnsafe&&(ee=B)),!await C.existsFile(B))return}const K=await a(i,k,te,C,A,ie,p.env,p.overrideName,p.isAutoDetected,ee);if(!K){O?.debug("Terminal profile not validated",i,V);return}return K.isAutoDetected=p.isAutoDetected,K.icon=ae,K.color=p.color,K}function g(i){return typeof i=="string"?{id:i}:i}async function d(i){if(v&&!i)return;const[p,k]=await Promise.all([E(),i||f()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:k,icon:j.$Zj.terminalPowershell})}async function E(){const i=new Set,p=await(0,$.$zs)("git.exe");if(p){const A=(0,y.dirname)(p);i.add((0,y.resolve)(A,"../.."))}function k(A,O){O&&A.add(O)}k(i,process.env.ProgramW6432),k(i,process.env.ProgramFiles),k(i,process.env["ProgramFiles(X86)"]),k(i,`${process.env.LocalAppData}\\Program`);const C=[];for(const A of i)C.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function f(){const i=[];for await(const p of(0,b.$om)())i.push(p.exePath);return i}async function t(i,p){const k=[],C=await new Promise((N,V)=>{s.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ie,ae)=>{if(ie)return V("Problem occurred when getting wsl distros");N(ae)})});if(!C)return[];const A=new RegExp(/[\r?\n]/),O=C.split(A).filter(N=>N.trim().length>0&&N!=="");for(const N of O){if(N===""||N.startsWith("docker-desktop"))continue;const V=`${N} (WSL)`,ie={profileName:V,path:i,args:["-d",`${N}`],isDefault:V===p,icon:o(N),isAutoDetected:!1};k.push(ie)}return k}function o(i){return i.includes("Ubuntu")?j.$Zj.terminalUbuntu:i.includes("Debian")?j.$Zj.terminalDebian:j.$Zj.terminalLinux}async function r(i,p,k,C,A,O,N,V){const ie=new Map;if(k&&await i.existsFile("/etc/shells")){const ae=(await i.readFile("/etc/shells")).toString(),te=(O||ae.split(`
`)).map(K=>{const B=K.indexOf("#");return B===-1?K:K.substring(0,B)}).filter(K=>K.trim().length>0),ee=new Map;for(const K of te){let B=(0,I.$nc)(K),Z=ee.get(B)||0;Z++,Z>1&&(B=`${B} (${Z})`),ee.set(B,Z),ie.set(B,{path:K,isAutoDetected:!0})}}return n(C,ie),await u(ie.entries(),A,i,V,p,N)}function n(i,p){if(i)for(const[k,C]of Object.entries(i))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?p.delete(k):(C.icon=C.icon||p.get(k)?.icon,p.set(k,C))}async function a(i,p,k,C,A,O,N,V,ie,ae){if(k.length===0)return Promise.resolve(void 0);const te=k.shift();if(te==="")return a(i,p,k,C,A,O,N,V,ie);const ee=typeof te!="string"&&te.isUnsafe,K=typeof te=="string"?te:te.path,B={profileName:i,path:K,args:O,env:N,overrideName:V,isAutoDetected:ie,isDefault:i===p,isUnsafePath:ee,requiresUnsafePath:ae};if((0,I.$nc)(K)===K){const Y=A.PATH?A.PATH.split(I.$tc):void 0,M=await(0,$.$zs)(K,void 0,Y,void 0,C.existsFile);return M?(B.path=M,B.isFromPath=!0,B):a(i,p,k,C,A,O)}return await C.existsFile((0,I.$hc)(K))?B:a(i,p,k,C,A,O,N,V,ie)}}),define(ye[270],Ee([1,0,6,2,3,47,25,12,115,88,264,92,266,269,107,61]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;var u;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let h=class extends j.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,E,f,t){super(),this.M=d,this.N=E,this.O=f,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new s.$he),this.onPtyHostExit=this.u.event,this.w=this.B(new s.$he),this.onPtyHostStart=this.w.event,this.y=this.B(new s.$he),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new s.$he),this.onPtyHostResponsive=this.z.event,this.C=this.B(new s.$he),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new s.$he),this.onProcessData=this.D.event,this.F=this.B(new s.$he),this.onProcessReady=this.F.event,this.G=this.B(new s.$he),this.onProcessReplay=this.G.event,this.H=this.B(new s.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new s.$he),this.onDidRequestDetach=this.I.event,this.J=this.B(new s.$he),this.onDidChangeProperty=this.J.event,this.L=this.B(new s.$he),this.onProcessExit=this.L.event,(0,v.$ps)(),this.B(this.M),this.B((0,j.$Sc)(()=>this.W())),this.j=this.B(new y.$is(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&s.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(I.$i)return process.env;try{return await(0,$.$Km)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),E=d.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=u.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=D.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new b.$hs(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=d,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[d,t]}async createProcess(d,E,f,t,o,r,n,a,i,p,k){const C=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),A=await this.f.createProcess(d,E,f,t,o,r,n,a,i,p,k);return clearTimeout(C),A}updateTitle(d,E,f){return this.f.updateTitle(d,E,f)}updateIcon(d,E,f,t){return this.f.updateIcon(d,E,f,t)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,E){return this.f.detachFromProcess(d,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,E){return this.f.shutdown(d,E)}input(d,E){return this.f.input(d,E)}processBinary(d,E){return this.f.processBinary(d,E)}resize(d,E,f){return this.f.resize(d,E,f)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,E){return this.f.acknowledgeDataEvent(d,E)}setUnicodeVersion(d,E){return this.f.setUnicodeVersion(d,E)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new c.$be,E=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...E]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,E){return this.f.installAutoReply(d,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,l.$um)(d??I.OS,process.env)}async getProfiles(d,E,f,t=!1){const o=await this.S();return(0,m.$Bs)(E,f,t,this.N,o,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,E){return this.f.getWslPath(d,E)}getRevivedPtyNewId(d,E){return this.f.getRevivedPtyNewId(d,E)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,E){return this.f.requestDetachInstance(d,E)}async acceptDetachInstanceReply(d,E){return this.f.acceptDetachInstanceReply(d,E)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,E,f){return this.f.reviveTerminalProcesses(d,E,f)}async refreshProperty(d,E){return this.f.refreshProperty(d,E)}async updateProperty(d,E,f){return this.f.updateProperty(d,E,f)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,E){return this.j.createRequest({workspaceId:d,originalText:E})}async acceptPtyHostResolvedVariables(d,E){this.j.acceptReply(d,E)}};e.$Cs=h,e.$Cs=h=Le([Oe(1,S.$7i),Oe(2,P.$7j),Oe(3,P.$8j)],h)}),define(ye[34],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,s.$Ai)("IUriIdentityService")}),define(ye[127],Ee([1,0,34,111,16,19,159,6,2]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class ${static{this._clock=0}constructor(v){this.uri=v,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let y=class{constructor(v){this.g=v,this.c=new b.$Tc,this.f=2**16;const m=new Map,l=c=>{let u=m.get(c.scheme);return u===void 0&&(u=v.hasProvider(c)&&!this.g.hasCapability(c,1024),m.set(c.scheme,u)),u};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(c=>{m.delete(c.scheme)})),this.extUri=new D.$3g(l),this.d=new S.$Fs((c,u)=>this.extUri.compare(c,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,D.$ch)(v));const m=this.d.get(v);return m?m.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new $(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((l,c)=>l[1].time<c[1].time?1:l[1].time>c[1].time?-1:0);$._clock=0,this.d.clear();const m=this.f*.5;for(let l=0;l<m;l++)this.d.set(v[l][0],v[l][1].touch())}};e.$Gs=y,e.$Gs=y=Le([Oe(0,I.$7k)],y),(0,j.$Ds)(s.$El,y,1)}),define(ye[93],Ee([1,0,214,7,64,19,4,5,13]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=$,e.$Li=y,e.$Oi=w,e.$Pi=v,e.$Qi=m,e.$Ri=c,e.$Si=u,e.$Vi=d,e.$1i=E,e.$2i=f,e.$4i=t,e.$5i=o,e.$6i=r,e.$Ji=(0,P.$Ai)("contextService");function $(n){const a=n;return typeof a?.id=="string"&&S.URI.isUri(a.uri)}function y(n){return typeof n?.id=="string"&&!$(n)&&!v(n)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function w(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,j.$nc)(n)}:a?e.$Mi:e.$Ni;const i=n;return i.configuration?{id:i.id,configPath:i.configuration}:i.folders.length===1?{id:i.id,uri:i.folders[0].uri}:{id:i.id}}function v(n){const a=n;return typeof a?.id=="string"&&S.URI.isUri(a.configPath)}function m(n){const a=n;if(a?.uri)return{id:a.id,uri:S.URI.revive(a.uri)};const i=n;if(i?.configPath)return{id:i.id,configPath:S.URI.revive(i.configPath)};if(n?.id)return{id:n.id}}var l;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function c(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function u(n){const a=n;return!!(a&&typeof a=="object"&&S.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class h{constructor(a,i,p,k,C){this.h=a,this.j=p,this.k=k,this.l=C,this.c=I.$Gi.forUris(this.l,()=>!0),this.folders=i}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=I.$Gi.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=h;class g{constructor(a,i){this.raw=i,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,D.$bh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=g;function d(n){return new g({uri:n,index:0,name:(0,D.$0g)(n)},{uri:n.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,s.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function E(n,a){return D.$5g.isEqualOrParent(n,a.untitledWorkspacesHome)}function f(n){let a;return S.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===b.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$3i}function o(n,a){return!E(n,a)&&!f(n)}function r(n){return(typeof n=="string"?(0,j.$oc)(n):(0,D.$_g)(n))===e.$Xi}}),define(ye[33],Ee([1,0,62,6,2,19,4,213,26,16,5,12,93,24,34,14,22,17,10]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=E,e.$Hl=f,e.$Il=t;var d;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function E(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&S.URI.isUri(a.location)&&S.URI.isUri(a.globalStorageHome)&&S.URI.isUri(a.settingsResource)&&S.URI.isUri(a.keybindingsResource)&&S.URI.isUri(a.tasksResource)&&S.URI.isUri(a.snippetsHome)&&S.URI.isUri(a.extensionsResource))}e.$Gl=(0,y.$Ai)("IUserDataProfilesService");function f(n,a){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:S.URI.revive(n.location).with({scheme:a}),globalStorageHome:S.URI.revive(n.globalStorageHome).with({scheme:a}),settingsResource:S.URI.revive(n.settingsResource).with({scheme:a}),keybindingsResource:S.URI.revive(n.keybindingsResource).with({scheme:a}),tasksResource:S.URI.revive(n.tasksResource).with({scheme:a}),snippetsHome:S.URI.revive(n.snippetsHome).with({scheme:a}),extensionsResource:S.URI.revive(n.extensionsResource).with({scheme:a}),cacheHome:S.URI.revive(n.cacheHome).with({scheme:a}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,a,i,p,k,C){return{id:n,name:a,location:i,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:C&&k?.useDefaultFlags?.globalState?C.globalStorageHome:(0,D.$bh)(i,"globalStorage"),settingsResource:C&&k?.useDefaultFlags?.settings?C.settingsResource:(0,D.$bh)(i,"settings.json"),keybindingsResource:C&&k?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,D.$bh)(i,"keybindings.json"),tasksResource:C&&k?.useDefaultFlags?.tasks?C.tasksResource:(0,D.$bh)(i,"tasks.json"),snippetsHome:C&&k?.useDefaultFlags?.snippets?C.snippetsHome:(0,D.$bh)(i,"snippets"),extensionsResource:C&&k?.useDefaultFlags?.extensions?C.extensionsResource:(0,D.$bh)(i,"extensions.json"),cacheHome:(0,D.$bh)(p,n),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}let o=class extends I.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,i,p,k){super(),this.t=a,this.u=i,this.w=p,this.y=k,this.f=!0,this.h=this.B(new j.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,D.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),i=[a];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,g.$ag)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}i.push(t((0,D.$$g)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},a))}}catch(C){this.y.error(C)}const p=new m.$Ac,k=new Map;if(i.length)try{const C=this.Q();if(C.workspaces)for(const[A,O]of Object.entries(C.workspaces)){const N=S.URI.parse(A),V=i.find(ie=>ie.id===O);V&&p.set(N,V)}if(C.emptyWindows)for(const[A,O]of Object.entries(C.emptyWindows)){const N=i.find(V=>V.id===O);N&&k.set(A,N)}}catch(C){this.y.error(C)}this.z={profiles:i,workspaces:p,emptyWindows:k}}return this.z}D(){const a=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const i="Temp",p=new RegExp(`${(0,h.$df)(i)}\\s(\\d+)`);let k=0;for(const A of this.profiles){const O=p.exec(A.name),N=O?parseInt(O[1]):0;k=N>k?N:k}const C=`${i} ${k+1}`;return this.createProfile((0,s.$oj)((0,u.$Wg)()).toString(16),C,{transient:!0},a)}async createNamedProfile(a,i,p){return this.createProfile((0,s.$oj)((0,u.$Wg)()).toString(16),a,i,p)}async createProfile(a,i,p,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(a,i,p);return k&&await this.setProfileForWorkspace(k,C),C}async F(a,i,p){if(!(0,g.$ag)(i)||!i)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(i);return k||(k=(async()=>{try{if(this.profiles.find(N=>N.name===i||N.id===a))throw new Error(`Profile with ${i} name already exists`);const A=t(a,i,(0,D.$bh)(this.profilesHome,a),this.g,p,this.defaultProfile);await this.u.createFolder(A.location);const O=[];return this.j.fire({profile:A,join(N){O.push(N)}}),await c.Promises.settled(O),this.I([A],[],[]),A}finally{this.r.delete(i)}})(),this.r.set(i,k)),k}async updateProfile(a,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(k=>k.id===a.id);if(!p)throw new Error(`Profile '${a.name}' does not exist`);return p=t(p.id,i.name??p.name,p.location,this.g,{shortName:i.shortName??p.shortName,icon:i.icon===null?void 0:i.icon??p.icon,transient:i.transient??p.isTransient,useDefaultFlags:i.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(k=>k.id===a.id);if(!i)throw new Error(`Profile '${a.name}' does not exist`);const p=[];this.m.fire({profile:i,join(k){p.push(k)}});try{await Promise.allSettled(p)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])i.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])i.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[i],[]);try{await this.u.del(i.cacheHome,{recursive:!0})}catch(k){(0,$.$ll)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(a,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(k=>k.id===i.id);if(!p)throw new Error(`Profile '${i.name}' does not exist`);this.L(a,p)}unsetWorkspace(a,i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,i)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(i=>i.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,i.resource))).map(i=>this.u.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(i=>!this.H(i));await Promise.allSettled(a.map(i=>this.removeProfile(i)))}getProfileForWorkspace(a){const i=this.G(a);return S.URI.isUri(i)?this.s.workspaces.get(i)??this.C.workspaces.get(i):this.s.emptyWindows.get(i)??this.C.emptyWindows.get(i)}G(a){return(0,v.$Ki)(a)?a.uri:(0,v.$Pi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(i=>this.w.extUri.isEqual(i.location,a.location))||[...this.s.workspaces.values()].some(i=>this.w.extUri.isEqual(i.location,a.location))||[...this.C.emptyWindows.values()].some(i=>this.w.extUri.isEqual(i.location,a.location))||[...this.C.workspaces.values()].some(i=>this.w.extUri.isEqual(i.location,a.location)))}I(a,i,p){const k=[...this.profiles,...a],C=[];this.s.profiles=[];for(let A of k)A.isDefault||i.some(O=>A.id===O.id)||(A=p.find(O=>A.id===O.id)??A,A.isTransient?this.s.profiles.push(A):C.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags}));this.P(C),this.z=void 0,this.J(a,i,p)}J(a,i,p){this.h.fire({added:a,removed:i,updated:p,all:this.profiles})}L(a,i,p){p=i?.isTransient?!0:p,p||this.L(a,void 0,!0);const k=this.G(a),C=p?this.s:this.C;S.URI.isUri(k)?(C.workspaces.delete(k),i&&C.workspaces.set(k,i)):(C.emptyWindows.delete(k),i&&C.emptyWindows.set(k,i)),p||this.M()}M(){const a={};for(const[p,k]of this.C.workspaces.entries())a[p.toString()]=k.id;const i={};for(const[p,k]of this.C.emptyWindows.entries())i[p.toString()]=k.id;this.R({workspaces:a,emptyWindows:i}),this.z=void 0}N(a){const i={},p=this.D();if(a.workspaces)for(const[C,A]of Object.entries(a.workspaces)){const O=S.URI.parse(A);i[C]=this.w.extUri.isEqual(O,p.location)?p.id:this.w.extUri.basename(O)}const k={};if(a.emptyWindows)for(const[C,A]of Object.entries(a.emptyWindows)){const O=S.URI.parse(A);k[C]=this.w.extUri.isEqual(O,p.location)?p.id:this.w.extUri.basename(O)}return{workspaces:i,emptyWindows:k}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Jl=o,e.$Jl=o=Le([Oe(0,b.$Hi),Oe(1,$.$7k),Oe(2,l.$El),Oe(3,w.$7j)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Kl=r}),define(ye[94],Ee([1,0,18,14,20,11,6,2,3,10,4,193,29,38,40,12,30,27,34,33]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$rq=void 0,e.$sq=f;let E=class extends P.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,a,i,p,k,C){super(),this.z=n,this.C=a,this.D=i,this.F=p,this.G=k,this.H=C,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new S.$he),this.s=this.B(new S.$he),this.t=this.B(new S.$he),this.u=this.B(new S.$he),this.w=this.B(new S.$he),this.y=[],this.B((0,P.$Sc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const a=await this.getTargetPlatform();return n.allTargetPlatforms.some(i=>(0,v.$0o)(i,n.allTargetPlatforms,a))}async installFromGallery(n,a={}){try{const p=(await this.installGalleryExtensions([{extension:n,options:a}])).find(({identifier:k})=>(0,m.$Ap)(k,n.identifier));if(p?.local)return p?.local;throw p?.error?p.error:new v.$bp(`Unknown error while installing extension ${n.identifier.id}`,"Unknown")}catch(i){throw f(i)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new v.$bp(w.localize(0,null),"NotAllowed");const a=[],i=[];return await Promise.allSettled(n.map(async({extension:p,options:k})=>{try{const C=await this.N(p,!!k?.installGivenVersion,!!k?.installPreReleaseVersion,k.productVersion??{version:this.G.version,date:this.G.date});i.push({...C,options:k})}catch(C){a.push({identifier:p.identifier,operation:2,source:p,error:C})}})),i.length&&a.push(...await this.I(i)),a}async uninstall(n,a={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,a)}async toggleAppliationScope(n,a){if((0,l.$Ym)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let i=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(i=await this.$(n,this.H.defaultProfile.extensionsResource,a));for(const p of this.H.profiles){const k=(await this.getInstalled(1,p.extensionsResource)).find(C=>(0,m.$Ap)(C.identifier,n.identifier));k?this.w.fire(k):this.u.fire({identifier:n.identifier,profileLocation:p.extensionsResource})}return i}else{const i=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:i.identifier,operation:2,local:i,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),i}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const a=new Map,i=new Map,p=[],k=(A,O)=>`${m.$Bp.create(A).toString()}-${O.toString()}`,C=(A,O,N,V)=>{const ie=this.Y(A,O,N),ae=`${(0,m.$Fp)(A.publisher,A.name)}-${N.profileLocation.toString()}`;i.set(ae,{task:ie,root:V}),this.n.fire({identifier:ie.identifier,source:O,profileLocation:N.profileLocation}),this.F.info("Installing extension:",ie.identifier.id,N.profileLocation.toString()),y.URI.isUri(O)||this.j.set(k(O,N.profileLocation),{task:ie,waitingTasks:[]})};try{for(const{manifest:A,extension:O,options:N}of n){const V=N.isApplicationScoped||N.isBuiltin||(0,l.$Ym)(A),ie={...N,installOnlyNewlyAddedFromExtensionPack:N.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(O),isApplicationScoped:V,profileLocation:V?this.H.defaultProfile.extensionsResource:N.profileLocation??this.X(),productVersion:N.productVersion??{version:this.G.version,date:this.G.date}},ae=y.URI.isUri(O)?void 0:this.j.get(k(O,ie.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,ie.profileLocation.toString()),p.push(ae.task.waitUntilTaskIsFinished())):C(A,O,ie,void 0)}return await Promise.all([...i.values()].map(async({task:A})=>{if(A.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const O=await this.M(A.identifier,A.manifest,!!A.options.installOnlyNewlyAddedFromExtensionPack,!!A.options.installPreReleaseVersion,A.options.profileLocation,A.options.productVersion),N=await this.getInstalled(void 0,A.options.profileLocation,A.options.productVersion),V={...A.options,context:{...A.options.context,[v.$4o]:!0}};for(const{gallery:ie,manifest:ae}of(0,s.$Mb)(O,({gallery:te})=>te.identifier.id)){if(i.has(`${ie.identifier.id.toLowerCase()}-${V.profileLocation.toString()}`))continue;const te=this.j.get(k(ie,V.profileLocation));if(te){if(this.J(A,te.task)){const ee=te.task.identifier;this.F.info("Waiting for already requested installing extension",ee.id,A.identifier.id,V.profileLocation.toString()),te.waitingTasks.push(A),p.push(S.Event.toPromise(S.Event.filter(this.onDidInstallExtensions,K=>K.some(B=>(0,m.$Ap)(B.identifier,ee)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",ee.id,A.identifier.id,V.profileLocation.toString()),!K.find(Z=>(0,m.$Ap)(Z.identifier,ee))?.local)throw new Error(`Extension ${ee.id} is not installed`)}))}}else N.some(({identifier:ee})=>(0,m.$Ap)(ee,ie.identifier))||C(ae,ie,V,A)}}catch(O){if(y.URI.isUri(A.source))(0,s.$Lb)(A.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",A.identifier.id,O.message),(0,s.$Lb)(A.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",A.identifier.id,O.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),O}})),await this.L([...i.entries()].map(async([A,{task:O}])=>{const N=new Date().getTime();let V;try{V=await O.run(),await this.L(this.y.map(ie=>ie.postInstall(V,O.source,O.options,I.CancellationToken.None)),"PostInstall")}catch(ie){const ae=f(ie);throw y.URI.isUri(O.source)||t(this.C,O.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Ip)(O.source),error:ae,source:O.options.context?.[v.$3o]}),a.set(A,{error:ae,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:O.options.isApplicationScoped}),this.F.error("Error while installing the extension",O.identifier.id,(0,D.$0)(ae),O.options.profileLocation.toString()),ae}if(!y.URI.isUri(O.source)){const ie=O.operation===3,ae=ie?void 0:(new Date().getTime()-O.source.lastUpdated)/1e3;if(t(this.C,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Ip)(O.source),verificationStatus:O.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:ae,source:O.options.context?.[v.$3o]}),b.$o&&O.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}a.set(A,{local:V,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:V.isApplicationScoped})})),p.length&&await this.L(p),[...a.values()]}catch(A){const O=(ie,ae,te)=>{const ee=[];ie.manifest.extensionDependencies?.length&&ee.push(...ie.manifest.extensionDependencies),ie.manifest.extensionPack?.length&&ee.push(...ie.manifest.extensionPack);for(const K of ee){if(te.includes(K.toLowerCase()))continue;te.push(K.toLowerCase());const B=a.get(`${K.toLowerCase()}-${ae.toString()}`);B?.local&&(te=O(B.local,ae,te))}return te},N=ie=>({identifier:ie.identifier,operation:2,source:ie.source,context:ie.options.context,profileLocation:ie.options.profileLocation,error:A}),V=[];for(const[ie,{task:ae,root:te}]of i){const ee=a.get(ie);ee?ee.local&&te&&!a.get(`${te.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(V.push(this.Z(ee.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),a.set(ie,N(ae))):(ae.cancel(),a.set(ie,N(ae)))}for(const[ie,{task:ae}]of i){const te=a.get(ie);if(!te?.local||ae.options.donotIncludePackAndDependencies)continue;O(te.local,ae.options.profileLocation,[te.local.identifier.id.toLowerCase()]).slice(1).some(K=>i.has(`${K.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!a.get(`${K.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(V.push(this.Z(te.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),a.set(ie,N(ae)))}throw V.length&&await Promise.allSettled(V.map(async ie=>{try{await ie.run(),this.F.info("Rollback: Uninstalled extension",ie.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",ie.extension.identifier.id,(0,D.$0)(ae))}})),A}finally{for(const{task:A}of i.values())A.source&&!y.URI.isUri(A.source)&&this.j.delete(k(A.source,A.options.profileLocation));if(a.size){const A=[...a.values()];for(const O of A)O.local&&this.F.info("Extension installed successfully:",O.identifier.id,O.profileLocation.toString());this.s.fire(A)}}}J(n,a){for(const[,{task:i,waitingTasks:p}]of this.j.entries())if(i===n&&(p.includes(a)||p.some(k=>this.J(k,a)))||i===a&&p[0]&&!this.J(n,p[0]))return!1;return!0}async L(n,a){const i=[],p=[],k=await Promise.allSettled(n);for(const A of k)A.status==="fulfilled"?i.push(A.value):p.push(f(A.reason,a));if(!p.length)return i;if(p.length===1)throw p[0];let C=new v.$bp("","Unknown");for(const A of p)C=new v.$bp(C.message?`${C.message}, ${A.message}`:A.message,A.code!=="Unknown"&&A.code!=="Internal"?A.code:C.code);throw C}async M(n,a,i,p,k,C){if(!this.z.isEnabled())return[];const A=await this.getInstalled(void 0,k,C),O=[],N=[],V=async(ie,ae)=>{O.push(ie);const te=ae.extensionDependencies||[],ee=[...te];if(ae.extensionPack){const K=i?A.find(B=>(0,m.$Ap)(B.identifier,ie)):void 0;for(const B of ae.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(Z=>(0,m.$Ap)({id:Z},{id:B}))||ee.every(Z=>!(0,m.$Ap)({id:Z},{id:B}))&&ee.push(B)}if(ee.length){const K=ee.filter(B=>O.every(Z=>!(0,m.$Ap)(Z,{id:B})));if(K.length){const B=await this.z.getExtensions(K.map(Z=>({id:Z,preRelease:p})),I.CancellationToken.None);for(const Z of B){if(O.find(z=>(0,m.$Ap)(z,Z.identifier)))continue;const Y=te.some(z=>(0,m.$Ap)({id:z},Z.identifier));let M;try{M=await this.N(Z,!1,p,C)}catch(z){if(Y)throw z;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,D.$0)(z));continue}N.push({gallery:M.extension,manifest:M.manifest}),await V(M.extension.identifier,M.manifest)}}}};return await V(n,a),N}async N(n,a,i,p){let k;const C=await this.getExtensionsControlManifest();if(C.malicious.some(N=>(0,m.$Ap)(n.identifier,N)))throw new v.$bp(w.localize(1,null,n.identifier.id),"Malicious");const A=C.deprecated[n.identifier.id.toLowerCase()];if(A?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${A.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:A.extension.id,preRelease:A.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:p},I.CancellationToken.None))[0],!k)throw new v.$bp(w.localize(2,null,n.identifier.id,A.extension.id),"Deprecated")}else{if(!await this.canInstall(n)){const N=await this.getTargetPlatform();throw new v.$bp(w.localize(3,null,n.identifier.id,this.G.nameLong,(0,v.$6o)(N)),"IncompatibleTargetPlatform")}if(k=await this.O(n,a,i,p),!k)throw!i&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],I.CancellationToken.None))[0]?new v.$bp(w.localize(4,null,n.displayName??n.identifier.id),"ReleaseVersionNotFound"):new v.$bp(w.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,I.CancellationToken.None);if(O===null)throw new v.$bp(`Missing manifest for extension ${k.identifier.id}`,"Invalid");if(O.version!==k.version)throw new v.$bp(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:k,manifest:O}}async O(n,a,i,p){const k=await this.getTargetPlatform();let C=null;return!a&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==i&&(C=(await this.z.getExtensions([{...n.identifier,preRelease:i}],{targetPlatform:k,compatible:!0,productVersion:p},I.CancellationToken.None))[0]||null),!C&&await this.z.isExtensionCompatible(n,i,k,p)&&(C=n),C||(a?C=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0,productVersion:p},I.CancellationToken.None))[0]||null:C=await this.z.getCompatibleExtension(n,i,k,p)),C}async P(n,a){const i={...a,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.X()},p=V=>`${V.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,k=this.m.get(p(n.identifier));if(k)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),k.waitUntilTaskIsFinished();const C=V=>{const ie=this.Z(V,i);return this.m.set(p(ie.extension.identifier),ie),i.profileLocation?this.F.info("Uninstalling extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,i.profileLocation.toString()):this.F.info("Uninstalling extension:",`${V.identifier.id}@${V.manifest.version}`),this.t.fire({identifier:V.identifier,profileLocation:i.profileLocation,applicationScoped:V.isApplicationScoped}),ie},A=(V,ie)=>{ie?i.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,i.profileLocation.toString(),ie.message):this.F.error("Failed to uninstall extension:",`${V.identifier.id}@${V.manifest.version}`,ie.message):i.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${V.identifier.id}@${V.manifest.version}`,i.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${V.identifier.id}@${V.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Hp)(V),error:ie}),this.u.fire({identifier:V.identifier,error:ie?.code,profileLocation:i.profileLocation,applicationScoped:V.isApplicationScoped})},O=[],N=[];try{O.push(C(n));const V=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ie=this.S(n,V);for(const ae of ie)this.m.has(p(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):O.push(C(ae))}i.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(O.map(ie=>ie.extension),V,n),await this.L(O.map(async ie=>{try{if(await ie.run(),await this.L(this.y.map(ae=>ae.postUninstall(ie.extension,i,I.CancellationToken.None))),ie.extension.identifier.uuid)try{await this.z.reportStatistic(ie.extension.manifest.publisher,ie.extension.manifest.name,ie.extension.manifest.version,"uninstall")}catch{}A(ie.extension)}catch(ae){const te=f(ae);throw A(ie.extension,te),te}finally{N.push(ie)}}))}catch(V){const ie=f(V);for(const ae of O){try{ae.cancel()}catch{}N.includes(ae)||A(ae.extension,ie)}throw ie}finally{for(const V of O)this.m.delete(p(V.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",V.extension.identifier.id)}}Q(n,a,i){for(const p of n){const k=this.U(p,a);if(k.length){const C=k.filter(A=>!n.some(O=>(0,m.$Ap)(O.identifier,A.identifier)));if(C.length)throw new Error(this.R(p,C,i))}}}R(n,a,i){return i===n?a.length===1?w.localize(6,null,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?w.localize(7,null,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):w.localize(8,null,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?w.localize(9,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?w.localize(10,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):w.localize(11,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}S(n,a,i=[]){if(i.indexOf(n)!==-1)return[];i.push(n);const p=n.manifest.extensionPack?n.manifest.extensionPack:[];if(p.length){const k=a.filter(A=>!A.isBuiltin&&p.some(O=>(0,m.$Ap)({id:O},A.identifier))),C=[];for(const A of k)C.push(...this.S(A,a,i));return[...k,...C]}return[]}U(n,a){return a.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(p=>(0,m.$Ap)({id:p},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.$0)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$rq=E,e.$rq=E=Le([Oe(0,v.$_o),Oe(1,h.$6l),Oe(2,g.$El),Oe(3,c.$7j),Oe(4,u.$nk),Oe(5,d.$Gl)],E);function f(r,n){if(r instanceof v.$bp)return r;let a;return r instanceof v.$ap?a=new v.$bp(r.message,r.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):a=new v.$bp(r.message,(0,D.$4)(r)?"Cancelled":n??"Internal"),a.stack=r.stack,a}function t(r,n,{extensionData:a,verificationStatus:i,duration:p,error:k,source:C,durationSinceUpdate:A}){let O,N;(0,$.$ig)(i)&&(i===!0?i="Verified":(i===!1||(O="Signature",N=i),i="Unverified")),k&&(O=k.code,k.code==="Signature"&&(N=k.message)),r.publicLog(n,{...a,verificationStatus:i,success:!k,duration:p,errorcode:O,errorcodeDetail:N,durationSinceUpdate:A,source:C})}class o{constructor(){this.d=new j.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,j.$nh)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$nh)(n=>new Promise((a,i)=>{const p=n.onCancellationRequested(()=>{p.dispose(),i(new D.$5)})})),this.d.open()),this.g.cancel()}}e.$tq=o}),define(ye[51],Ee([1,0,14,15,2,6,24,4,29,38,16,5,12,33,34,10,11,27]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class d extends Error{constructor(r,n){super(r),this.code=n}}e.$uq=d,e.$vq=(0,w.$Ai)("IExtensionsProfileScannerService");let E=class extends I.$Uc{constructor(r,n,a,i,p,k){super(),this.j=r,this.m=n,this.n=a,this.r=i,this.s=p,this.t=k,this.b=this.B(new D.$he),this.onAddExtensions=this.b.event,this.c=this.B(new D.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$he),this.onDidRemoveExtensions=this.g.event,this.h=new S.$Ac}scanProfileExtensions(r,n){return this.u(r,void 0,n)}async addExtensionsToProfile(r,n,a){const i=[],p=[];try{return await this.u(n,k=>{const C=[];if(a)C.push(...k);else for(const A of k)r.some(([O])=>(0,$.$Ap)(O.identifier,A.identifier)&&O.manifest.version!==A.version)?i.push(A):C.push(A);for(const[A,O]of r){const N=C.findIndex(ie=>(0,$.$Ap)(ie.identifier,A.identifier)&&ie.version===A.manifest.version),V={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:O};N===-1?(p.push(V),C.push(V)):C.splice(N,1,V)}return p.length&&this.b.fire({extensions:p,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),C}),p.length&&this.c.fire({extensions:p,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),p}catch(k){throw p.length&&this.c.fire({extensions:p,error:k,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:k,profileLocation:n}),k}}async updateMetadata(r,n){const a=[];return await this.u(n,i=>{const p=[];for(const k of i){const C=r.find(([A])=>(0,$.$Ap)(A.identifier,k.identifier)&&A.manifest.version===k.version);C&&(k.metadata={...k.metadata,...C[1]},a.push(k)),p.push(k)}return p}),a}async removeExtensionFromProfile(r,n){const a=[];try{await this.u(n,i=>{const p=[];for(const k of i)(0,$.$Ap)(k.identifier,r.identifier)?a.push(k):p.push(k);return a.length&&this.f.fire({extensions:a,profileLocation:n}),p}),a.length&&this.g.fire({extensions:a,profileLocation:n})}catch(i){throw a.length&&this.g.fire({extensions:a,error:i,profileLocation:n}),i}}async u(r,n,a){return this.F(r).queue(async()=>{let i=[],p;try{const k=await this.m.readFile(r);p=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,y.$ll)(k)!==1)throw k;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&a?.bailOutWhenFileNotFound)throw new d((0,u.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let k=!1;for(const C of p){f(C)||this.w(r);let A;if((0,c.$ag)(C.relativeLocation)&&C.relativeLocation)A=this.z(C.relativeLocation);else if((0,c.$ag)(C.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${C.location}`);continue}else{A=P.URI.revive(C.location);const O=this.y(A);O&&(k=!0,C.relativeLocation=O)}(0,c.$hg)(C.metadata?.hasPreReleaseVersion)&&C.metadata?.preRelease&&(k=!0,C.metadata.hasPreReleaseVersion=!0),i.push({identifier:C.identifier,location:A,version:C.version,metadata:C.metadata})}k&&await this.m.writeFile(r,j.$Je.fromString(JSON.stringify(p)))}if(n){i=n(i);const k=i.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(r,j.$Je.fromString(JSON.stringify(k)))}return i})}w(r){const n=new d(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(r)).value.toString()}catch(p){if((0,y.$ll)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let i;try{const p=JSON.parse(a);Array.isArray(p)&&p.every(k=>f(k))?i=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(i)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$Je.fromString(JSON.stringify(i)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,y.$ll)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,y.$ll)(p)!==1&&this.t.error(p)}try{await this.m.del(n)}catch(p){(0,y.$ll)(p)!==1&&this.t.error(p)}return i})()),this.C}F(r){let n=this.h.get(r);return n||(n=new s.$Hh,this.h.set(r,n)),n}};e.$wq=E,e.$wq=E=Le([Oe(1,y.$7k),Oe(2,m.$Gl),Oe(3,l.$El),Oe(4,h.$6l),Oe(5,v.$7j)],E);function f(o){return(0,c.$cg)(o)&&(0,b.$$o)(o.identifier)&&(t(o.location)||(0,c.$ag)(o.location)&&o.location)&&((0,c.$hg)(o.relativeLocation)||(0,c.$ag)(o.relativeLocation))&&o.version&&(0,c.$ag)(o.version)}function t(o){return o?(0,c.$ag)(o.path)&&(0,c.$ag)(o.scheme):!1}}),define(ye[59],Ee([1,0,18,14,21,15,11,43,177,2,13,7,3,19,57,63,10,4,197,26,38,40,82,16,5,12,30,6,46,51,33,34,229]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=e.$Aq=e.$zq=e.Translations=void 0,e.$Cq=ee;var N;(function(B){function Z(Y,M){if(Y===M)return!0;const z=Object.keys(Y),oe=new Set;for(const se of Object.keys(M))oe.add(se);if(z.length!==oe.size)return!1;for(const se of z){if(Y[se]!==M[se])return!1;oe.delete(se)}return oe.size===0}B.equals=Z})(N||(e.Translations=N={})),e.$zq=(0,r.$Ai)("IExtensionsScannerService");let V=class extends $.$Uc{constructor(Z,Y,M,z,oe,se,_,H,ne,le,F,U){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Y,this.r=M,this.s=z,this.t=oe,this.u=se,this.w=_,this.y=H,this.z=ne,this.C=le,this.D=F,this.F=U,this.g=this.B(new i.$he),this.onDidChangeCache=this.g.event,this.h=(0,m.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ae,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Lp)(this.w,this.y)),this.G}async scanAllExtensions(Z,Y,M){const[z,oe]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Y)]),se=M?await this.scanExtensionsUnderDevelopment(Z,[...z,...oe]):[];return this.L(z,oe,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Y=[];Y.push(this.M(!!Z.useCache,Z.language)),Y.push(this.N(Z.language,!!Z.checkControlFile));const[M,z]=await Promise.all(Y);return this.J([...M,...z],0,Z,!1)}async scanUserExtensions(Z){const Y=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const M=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(Y,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,M,Z.productVersion??this.R()),oe=Z.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let se;try{se=await oe.scanExtensions(z)}catch(_){if(_ instanceof k.$uq&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await oe.scanExtensions(z);else throw _}return se=await this.J(se,1,Z,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(Z,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const oe=await this.P(z,!1,1,!0,Z.language,!1,void 0,Z.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(oe)).map(_=>(_.type=Y.find(H=>(0,E.$Ap)(H.identifier,_.identifier))?.type??_.type,this.n.validate(_,oe)))}))).flat();return this.J(M,"development",Z,!0)}return[]}async scanExistingExtension(Z,Y,M){const z=await this.P(Z,!1,Y,!0,M.language,!0,void 0,M.productVersion??this.R()),oe=await this.n.scanExtension(z);return!oe||!M.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(Z,Y,M){const z=await this.P(Z,!1,Y,!0,M.language,!0,void 0,M.productVersion??this.R()),oe=await this.n.scanOneOrMultipleExtensions(z);return this.J(oe,Y,M,!0)}async scanMultipleExtensions(Z,Y,M){const z=[];return await Promise.all(Z.map(async oe=>{const se=await this.scanOneOrMultipleExtensions(oe,Y,M);z.push(...se)})),this.J(z,Y,M,!0)}async scanMetadata(Z){const Y=(0,m.$bh)(Z,"package.json"),M=(await this.w.readFile(Y)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(Z,Y){const M=(0,m.$bh)(Z,"package.json"),z=(await this.w.readFile(M)).value.toString(),oe=JSON.parse(z);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,oe.__metadata={...oe.__metadata,...Y},await this.w.writeFile((0,m.$bh)(Z,"package.json"),D.$Je.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof k.$uq&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Je.fromString(JSON.stringify([])))}catch(Y){(0,o.$ll)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,S.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Y,M,z){return M.includeAllVersions||(Z=this.L(Y===0?Z:void 0,Y===1?Z:void 0,Y==="development"?Z:void 0,await this.getTargetPlatform(),z)),M.includeInvalid||(Z=Z.filter(oe=>oe.isValid)),Z.sort((oe,se)=>{const _=w.$nc(oe.location.fsPath),H=w.$nc(se.location.fsPath);return _<H?-1:_>H?1:0})}L(Z,Y,M,z,oe){const se=(H,ne,le)=>{if(H.isValid&&!ne.isValid)return!1;if(H.isValid===ne.isValid){if(oe&&l.gt(H.manifest.version,ne.manifest.version))return this.y.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(l.eq(H.manifest.version,ne.manifest.version)){if(H.type===0)return this.y.debug(`Skipping extension ${ne.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===z)return this.y.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`),!1}}return le?this.y.warn(`Overwriting user extension ${H.location.path} with ${ne.location.path}.`):this.y.debug(`Overwriting user extension ${H.location.path} with ${ne.location.path}.`),!0},_=new f.$Xm;return Z?.forEach(H=>{const ne=_.get(H.identifier.id);(!ne||se(ne,H,!1))&&_.set(H.identifier.id,H)}),Y?.forEach(H=>{const ne=_.get(H.identifier.id);if(!ne&&Z&&H.type===0){this.y.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!ne||se(ne,H,!1))&&_.set(H.identifier.id,H)}),M?.forEach(H=>{const ne=_.get(H.identifier.id);(!ne||se(ne,H,!0))&&_.set(H.identifier.id,H),_.set(H.identifier.id,H)}),[..._.values()]}async M(Z,Y){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.R()),oe=await(Z&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(Z,Y){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const z=Y?await this.O():{},oe=[],se=h.URI.file(w.$hc(w.$jc(y.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of M){const ne=z[H.name]||"marketplace";switch(ne){case"disabled":break;case"marketplace":oe.push((0,m.$bh)(se,H.name));break;default:oe.push(h.URI.file(ne));break}}const _=await Promise.all(oe.map(async H=>this.n.scanExtension(await this.P(H,!1,0,!0,Z,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",_.length),(0,s.$Hb)(_)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Y,M,z,oe,se,_,H){const ne=await this.f(oe??v.$w),le=await this.Q(Z),F=Y&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=F?await this.Q(F):void 0;return new ie(Z,le,F,U,Y,_,M,z,se,H.version,H.date,this.C.commit,!this.z.isBuilt,oe,ne)}async Q(Z){try{const Y=await this.w.stat(Z);if(typeof Y.mtime=="number")return Y.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Aq=V,e.$Aq=V=Le([Oe(4,C.$Gl),Oe(5,k.$vq),Oe(6,o.$7k),Oe(7,n.$7j),Oe(8,d.$Hi),Oe(9,a.$nk),Oe(10,A.$El),Oe(11,r.$zi)],V);class ie{constructor(Z,Y,M,z,oe,se,_,H,ne,le,F,U,X,x,Q){this.location=Z,this.mtime=Y,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=z,this.profile=oe,this.profileScanOptions=se,this.type=_,this.excludeObsolete=H,this.validate=ne,this.productVersion=le,this.productDate=F,this.productCommit=U,this.devMode=X,this.language=x,this.translations=Q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Y){return(0,m.$7g)(Z.location,Y.location)&&Z.mtime===Y.mtime&&(0,m.$7g)(Z.applicationExtensionslocation,Y.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Z.profile===Y.profile&&I.$$n(Z.profileScanOptions,Y.profileScanOptions)&&Z.type===Y.type&&Z.excludeObsolete===Y.excludeObsolete&&Z.validate===Y.validate&&Z.productVersion===Y.productVersion&&Z.productDate===Y.productDate&&Z.productCommit===Y.productCommit&&Z.devMode===Y.devMode&&Z.language===Y.language&&N.equals(Z.translations,Y.translations)}}e.$Bq=ie;let ae=class extends $.$Uc{constructor(Z,Y,M,z,oe){super(),this.f=Z,this.g=Y,this.h=M,this.j=z,this.m=oe}async scanExtensions(Z){const Y=Z.profile?await this.r(Z):await this.n(Z);let M={};if(Z.excludeObsolete&&Z.type===1)try{const z=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(z)}catch{}return(0,u.$ng)(M)?Y:Y.filter(z=>!M[E.$Bp.create(z).toString()])}async n(Z){const Y=await this.j.resolve(Z.location);if(!Y.children?.length)return[];const M=await Promise.all(Y.children.map(async z=>{if(!z.isDirectory||Z.type===1&&(0,m.$$g)(z.resource).indexOf(".")===0)return null;const oe=new ie(z.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(oe)}));return(0,s.$Hb)(M).sort((z,oe)=>z.location.path<oe.location.path?-1:1)}async r(Z){let Y=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Y=Y.filter(z=>!z.metadata?.isApplicationScoped);const M=await this.s(Z.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,Z);Y.push(...M)}return Y}async s(Z,Y,M){const z=await this.g.scanProfileExtensions(Z,M.profileScanOptions);if(!z.length)return[];const oe=await Promise.all(z.map(async se=>{if(Y(se)){const _=new ie(se.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(_,se.metadata)}return null}));return(0,s.$Hb)(oe)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,m.$bh)(Z.location,"package.json"))){const Y=await this.scanExtension(Z);return Y?[Y]:[]}else return await this.scanExtensions(Z)}catch(Y){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,S.$0)(Y)),[]}}async scanExtension(Z,Y){try{let M=await this.scanExtensionManifest(Z.location);if(M){M.publisher||(M.publisher=f.$Rm),Y=Y??M.__metadata,delete M.__metadata;const z=(0,E.$Fp)(M.publisher,M.name),oe=Y?.id?{id:z,uuid:Y.id}:{id:z},se=Y?.isSystem?0:Z.type,_=se===0||!!Y?.isBuiltin;M=await this.t(Z.location,M,ie.createNlsConfiguration(Z));const H={type:se,identifier:oe,manifest:M,location:Z.location,isBuiltin:_,targetPlatform:Y?.targetPlatform??"undefined",publisherDisplayName:Y?.publisherDisplayName,metadata:Y,isValid:!0,validations:[]};return Z.validate?this.validate(H,Z):H}}catch(M){Z.type!==0&&this.m.error(M)}return null}validate(Z,Y){let M=!0;const z=(0,t.$Qp)(Y.productVersion,Y.productDate,Y.location,Z.manifest,Z.isBuiltin);for(const[oe,se]of z)oe===c.default.Error&&(M=!1,this.m.error(this.z(Y.location,se)));return Z.isValid=M,Z.validations=z,Z}async scanExtensionManifest(Z){const Y=(0,m.$bh)(Z,"package.json");let M;try{M=(await this.j.readFile(Y)).value.toString()}catch(oe){return(0,o.$ll)(oe)!==1&&this.m.error(this.z(Z,(0,g.localize)(0,null,Y.path,oe.message))),null}let z;try{z=JSON.parse(M)}catch{const se=[];(0,P.$Nn)(M,se);for(const _ of se)this.m.error(this.z(Z,(0,g.localize)(1,null,Y.path,_.offset,_.length,(0,b.$xq)(_.error))));return null}return(0,P.$Wn)(z)!=="object"?(this.m.error(this.z(Z,(0,g.localize)(2,null,Y.path))),null):z}async t(Z,Y,M){const z=await this.u(Z,Y,M);if(z)try{const oe=[],se=await this.w(z.default,oe);if(oe.length>0)return oe.forEach(H=>{this.m.error(this.z(Z,(0,g.localize)(3,null,z.default?.path,(0,b.$xq)(H.error))))}),Y;if((0,P.$Wn)(z)!=="object")return this.m.error(this.z(Z,(0,g.localize)(4,null,z.default?.path))),Y;const _=z.values||Object.create(null);return(0,O.$yq)(this.m,Y,_,se)}catch{}return Y}async u(Z,Y,M){const z=(0,m.$bh)(Z,"package.nls.json"),oe=(ne,le)=>{le.forEach(F=>{this.m.error(this.z(Z,(0,g.localize)(5,null,ne?.path,(0,b.$xq)(F.error))))})},se=ne=>{this.m.error(this.z(Z,(0,g.localize)(6,null,ne?.path)))},_=`${Y.publisher}.${Y.name}`,H=M.translations[_];if(H)try{const ne=h.URI.file(H),le=(await this.j.readFile(ne)).value.toString(),F=[],U=(0,P.$Nn)(le,F);return F.length>0?(oe(ne,F),{values:void 0,default:z}):(0,P.$Wn)(U)!=="object"?(se(ne),{values:void 0,default:z}):{values:U.contents?U.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let le;try{le=await this.y(Z,M)}catch{return}if(!le.localized)return{values:void 0,default:le.original};try{const F=(await this.j.readFile(le.localized)).value.toString(),U=[],X=(0,P.$Nn)(F,U);return U.length>0?(oe(le.localized,U),{values:void 0,default:le.original}):(0,P.$Wn)(X)!=="object"?(se(le.localized),{values:void 0,default:le.original}):{values:X,default:le.original}}catch{return{values:void 0,default:le.original}}}}async w(Z,Y){if(Z)try{const M=(await this.j.readFile(Z)).value.toString();return(0,P.$Nn)(M,Y)}catch{}}y(Z,Y){return new Promise((M,z)=>{const oe=se=>{const _=(0,m.$bh)(Z,`package.nls.${se}.json`);this.j.exists(_).then(H=>{H&&M({localized:_,original:(0,m.$bh)(Z,"package.nls.json")});const ne=se.lastIndexOf("-");ne===-1?M({localized:(0,m.$bh)(Z,"package.nls.json"),original:null}):(se=se.substring(0,ne),oe(se))})};if(Y.devMode||Y.pseudo||!Y.language)return M({localized:(0,m.$bh)(Z,"package.nls.json"),original:null});oe(Y.language)})}z(Z,Y){return`[${Z.path}]: ${Y}`}};ae=Le([Oe(1,k.$vq),Oe(2,A.$El),Oe(3,o.$7k),Oe(4,n.$7j)],ae);let te=class extends ae{constructor(Z,Y,M,z,oe,se,_){super(Y,z,oe,se,_),this.G=Z,this.H=M,this.D=this.B(new j.$yh(3e3)),this.F=this.B(new i.$he),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Y=this.M(Z),M=await this.I(Y);if(this.C=Z,M&&M.input&&ie.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),M.result.map(oe=>(oe.location=h.URI.revive(oe.location),oe));const z=await super.scanExtensions(Z);return await this.J(Y,{input:Z,result:z}),z}async I(Z){try{const Y=await this.j.readFile(Z),M=JSON.parse(Y.value.toString());return{result:M.result,input:(0,p.$0h)(M.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Z.path,(0,S.$0)(Y))}return null}async J(Z,Y){try{await this.j.writeFile(Z,D.$Je.fromString(JSON.stringify(Y)))}catch(M){this.m.debug("Error while writing the extension cache file:",Z.path,(0,S.$0)(M))}}async L(){if(!this.C)return;const Z=this.M(this.C),Y=await this.I(Z);if(!Y)return;const M=Y.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!I.$$n(z,M))try{this.m.info("Invalidating Cache",M,z),await this.j.del(Z),this.F.fire()}catch(oe){this.m.error(oe)}}M(Z){const Y=this.N(Z);return this.h.extUri.joinPath(Y.cacheHome,Z.type===0?f.$Qm:f.$Pm)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Z.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};te=Le([Oe(2,C.$Gl),Oe(3,k.$vq),Oe(4,A.$El),Oe(5,o.$7k),Oe(6,n.$7j)],te);function ee(B,Z){const Y=(0,E.$Dp)(B.manifest.publisher,B.manifest.name);return{id:Y,identifier:new f.$Vm(Y),isBuiltin:B.type===0,isUserBuiltin:B.type===1&&B.isBuiltin,isUnderDevelopment:Z,extensionLocation:B.location,uuid:B.identifier.uuid,targetPlatform:B.targetPlatform,publisherDisplayName:B.publisherDisplayName,...B.manifest}}class K extends V{constructor(Z,Y,M,z,oe,se,_,H,ne,le,F,U){super(Z,Y,(0,m.$bh)(M,".vscode-oss-dev","extensions","control.json"),z,oe,se,_,H,ne,le,F,U),this.S=(async()=>{if(v.$z)try{const X=await this.w.readFile(h.URI.file(v.$z));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.S}}e.$Dq=K}),define(ye[271],Ee([1,0,56,14,39,6,2,13,7,23,12,33]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let v=class extends S.$Uc{constructor(l,c){super(),this.b=l,this.f=c,this.a=new j.$Gh(5)}async postUninstall(l){const c=this.g(l,"uninstall");c&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(u)}}));try{await $.Promises.rm(this.m(l))}catch(u){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(u)}}g(l,c){const u=`vscode:${c}`;if(l.location.scheme===P.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[u]=="string"){const h=l.manifest.scripts[u].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${u} should be a node script`),null):{script:(0,b.$jc)(l.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(l,c,u,h,g){return new Promise((d,E)=>{const f=this.j(l,c,u,g);let t;const o=r=>{t&&(clearTimeout(t),t=null),r?E(r):d(void 0)};f.on("error",r=>{o((0,I.$lj)(r)||"Unknown")}),f.on("exit",(r,n)=>{o(r?`post-${c} process exited with code ${r}`:void 0)}),h&&(t=setTimeout(()=>{t=null,f.kill(),E("timed out")},5e3))})}j(l,c,u,h){const g={silent:!0,execArgv:void 0},d=(0,s.fork)(l,[`--type=extension-post-${c}`,...u],g);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const E=D.Event.fromNodeEventEmitter(d.stdout,"data"),f=D.Event.fromNodeEventEmitter(d.stderr,"data");this.B(E(r=>this.f.info(h.identifier.id,h.manifest.version,`post-${c}`,r))),this.B(f(r=>this.f.error(h.identifier.id,h.manifest.version,`post-${c}`,r)));const t=D.Event.any(D.Event.map(E,r=>({data:`%c${r}`,format:[""]}),this.q),D.Event.map(f,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return D.Event.debounce(t,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(h.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),d}m(l){return(0,b.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Hq=v,e.$Hq=v=Le([Oe(0,w.$Gl),Oe(1,y.$7j)],v)}),define(ye[128],Ee([1,0,81,199,94,29]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=S,e.$Fq=P;function S(b){let $="Extract";return b instanceof s.$nq&&(b.type==="CorruptZip"?$="CorruptZip":b.type==="Incomplete"&&($="IncompleteZip")),(0,I.$sq)(b,$)}async function P(b){let $;try{$=await(0,s.$qq)(b,"extension/package.json")}catch(y){throw S(y)}try{return JSON.parse($.toString("utf8"))}catch{throw new D.$bp((0,j.localize)(0,null),"Invalid")}}}),define(ye[272],Ee([1,0,14,11,2,13,19,57,10,22,23,81,25,26,94,29,38,128,89,16,12,27]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;let o=class extends I.$Uc{static{t=this}static{this.c=".sigzip"}constructor(n,a,i,p,k,C,A){super(),this.h=a,this.j=i,this.m=p,this.n=k,this.r=C,this.t=A,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(n,a,i,p){await this.g;const k=await this.w(n,a);let C=!1;if(i&&this.u(n)){let A;try{A=await this.y(n)}catch(O){try{await this.delete(k)}catch(N){this.t.error(N)}throw O}try{C=await this.n.verify(n,k.fsPath,A.fsPath,p)}catch(O){if(C=O.code,C==="PackageIsInvalidZip"||C==="SignatureArchiveIsInvalidZip"){try{await this.delete(k)}catch(N){this.t.error(N)}throw new c.$bp(w.$mq,"CorruptZip")}}finally{try{await this.delete(A)}catch(O){this.t.error(O)}}}return{location:k,verificationStatus:C}}u(n){if(!n.isSigned)return this.t.info(`Extension is not signed: ${n.identifier.id}`),!1;const a=this.m.getValue("extensions.verifySignature");return(0,b.$gg)(a)?a:!0}async w(n,a){try{const i=(0,S.$bh)(this.extensionsDownloadDir,this.G(n)),p=await this.C(n,"vsix",async()=>{await this.z(n,i,k=>this.j.download(n,k,a));try{await this.D(i.fsPath,"extension/package.json")}catch(k){try{await this.h.del(i)}catch(C){this.t.warn(`Error while deleting: ${i.path}`,(0,j.$0)(C))}throw k}},2);return p>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:p}),i}catch(i){throw(0,l.$sq)(i,"Download")}}async y(n){try{const a=(0,S.$bh)(this.extensionsDownloadDir,`.${(0,$.$Wg)()}`),i=await this.C(n,"sigzip",async()=>{await this.j.downloadSignatureArchive(n,a);try{await this.D(a.fsPath,".signature.p7s")}catch(p){try{await this.h.del(a)}catch(k){this.t.warn(`Error while deleting: ${a.path}`,(0,j.$0)(k))}throw p}},2);return i>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:i}),a}catch(a){throw(0,l.$sq)(a,"DownloadSignature")}}async z(n,a,i){if(await this.h.exists(a))return;if(a.scheme!==D.Schemas.file){await i(a);return}const p=(0,S.$bh)(this.extensionsDownloadDir,`.${(0,$.$Wg)()}`);try{await i(p)}catch(k){try{await this.h.del(p)}catch{}throw k}try{await y.Promises.rename(p.fsPath,a.fsPath,2*60*1e3)}catch(k){try{await this.h.del(p)}catch{}let C=!1;try{C=await this.h.exists(a)}catch{}if(C)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,a.path);else throw this.t.info(`Rename failed because of ${(0,j.$0)(k)}. Deleted the file from downloaded location`,p.path),k}}async C(n,a,i,p){let k=1;for(;;)try{return await i(),k}catch(C){if(k++>p)throw C;this.t.warn(`Failed downloading ${a}. ${(0,j.$0)(C)}. Retry again...`,n.identifier.id)}}async D(n,a){try{await(0,w.$qq)(n,a)}catch(i){throw(0,h.$Eq)(i)}}async delete(n){await this.g,await this.h.del(n)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const a=[],i=[],p=[];for(const A of n.children)if(A.name.endsWith(t.c))p.push(A.resource);else{const O=u.$Bp.parse(A.name);O&&i.push([O,A])}const k=(0,u.$Gp)(i,([A])=>A),C=[];for(const A of k)A.sort((O,N)=>P.rcompare(O[0].version,N[0].version)),a.push(...A.slice(1).map(O=>O[1].resource)),C.push(A[0][1]);C.sort((A,O)=>A.mtime-O.mtime),a.push(...C.slice(0,Math.max(0,C.length-this.f)).map(A=>A.resource)),a.push(...p),await s.Promises.settled(a.map(A=>(this.t.trace("Deleting from cache",A.path),this.h.del(A))))}}catch(n){this.t.error(n)}}G(n){return this.f?u.$Bp.create(n).toString().toLowerCase():(0,$.$Wg)()}};e.$Gq=o,e.$Gq=o=t=Le([Oe(0,m.$Ii),Oe(1,d.$7k),Oe(2,c.$_o),Oe(3,v.$7i),Oe(4,g.$fq),Oe(5,f.$6l),Oe(6,E.$7j)],o)}),define(ye[129],Ee([1,0,14,15,20,39,11,6,62,2,24,13,7,19,57,10,4,22,23,81,198,83,26,94,29,38,51,59,272,271,128,248,257,82,16,5,12,30,27,34,33]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A,O,N,V,ie,ae,te,ee,K,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Kq=(0,ie.$Bi)(r.$cp);const Z=".vsctmp";let Y=class extends o.$rq{constructor(_,H,ne,le,F,U,X,x,Q,G,J,T){super(_,H,J,ne,G,T),this.eb=F,this.fb=U,this.gb=X,this.hb=x,this.ib=Q,this.db=new Map,this.tb=new y.$Bc;const W=this.B(x.createInstance(k.$Hq));this.ab=this.B(x.createInstance(M,ue=>W.postUninstall(ue))),this.bb=this.B(new A.$Iq(T,Q,J,this,this.F)),this.cb=this.B(x.createInstance(p.$Gq));const ce=this.B(new O.$Jq(this,this.eb,T,U,J,Q,ne));this.B(ce.onDidChangeExtensionsByAnotherSource(ue=>this.sb(ue))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Lp)(this.ib,this.F)),this.jb}async zip(_){this.F.trace("ExtensionManagementService#zip",_.identifier.id);const H=await this.rb(_),ne=await(0,d.zip)((0,m.$bh)(this.cb.extensionsDownloadDir,(0,h.$Wg)()).fsPath,H);return u.URI.file(ne)}async unzip(_){return this.F.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const{location:H,cleanup:ne}=await this.lb(_),le=v.$kc(H.fsPath);try{return await(0,C.$Fq)(le)}finally{await ne()}}getInstalled(_,H=this.H.defaultProfile.extensionsResource,ne={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(_??null,H,ne)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(_){return this.ab.scanUserExtensionAtLocation(_)}async install(_,H={}){this.F.trace("ExtensionManagementService#install",_.toString());const{location:ne,cleanup:le}=await this.lb(_);try{const F=await(0,C.$Fq)(v.$kc(ne.fsPath)),U=(0,n.$Fp)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,N.$Sp)(F.engines.vscode,this.G.version,this.G.date))throw new Error(E.localize(0,null,U,this.G.version));const x=(await this.I([{manifest:F,extension:ne,options:H}])).find(({identifier:Q})=>(0,n.$Ap)(Q,{id:U}));if(x?.local)return x.local;throw x?.error?x.error:(0,o.$sq)(new Error(`Unknown error while installing extension ${U}`))}finally{await le()}}async installFromLocation(_,H){this.F.trace("ExtensionManagementService#installFromLocation",_.toString());const ne=await this.ab.scanUserExtensionAtLocation(_);if(!ne||!ne.manifest.name||!ne.manifest.version)throw new Error(`Cannot find a valid extension from the location ${_.toString()}`);return await this.wb([[ne,{source:"resource"}]],H),this.F.info("Successfully installed extension",ne.identifier.id,H.toString()),ne}async installExtensionsFromProfile(_,H,ne){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",_,H.toString(),ne.toString());const le=(await this.getInstalled(1,H)).filter(F=>_.some(U=>(0,n.$Ap)(U,F.identifier)));if(le.length){const F=await Promise.all(le.map(U=>this.ab.scanMetadata(U,H)));await this.wb(le.map((U,X)=>[U,F[X]]),ne),this.F.info("Successfully installed extensions",le.map(U=>U.identifier.id),ne.toString())}return le}async updateMetadata(_,H,ne=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",_.identifier.id),H.isPreReleaseVersion&&(H.preRelease=!0,H.hasPreReleaseVersion=!0),H.isMachineScoped===!1&&(H.isMachineScoped=void 0),H.isBuiltin===!1&&(H.isBuiltin=void 0),H.pinned===!1&&(H.pinned=void 0),_=await this.ab.updateMetadata(_,H,ne),this.bb.invalidate(ne),this.w.fire(_),_}async reinstallFromGallery(_){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",_.identifier.id),!this.z.isEnabled())throw new Error(E.localize(1,null));const H=await this.getTargetPlatform(),[ne]=await this.z.getExtensions([{..._.identifier,preRelease:_.preRelease}],{targetPlatform:H,compatible:!0},I.CancellationToken.None);if(!ne)throw new Error(E.localize(2,null));await this.ab.setUninstalled(_);try{await this.ab.removeUninstalledExtension(_)}catch(le){throw new Error(E.localize(3,null,(0,D.$lj)(le)))}return this.installFromGallery(ne)}$(_,H,ne,le){return this.ab.copyExtension(_,H,ne,le)}copyExtensions(_,H){return this.ab.copyExtensions(_,H,{version:this.G.version,date:this.G.date})}markAsUninstalled(..._){return this.ab.setUninstalled(..._)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(_){this.F.error(_)}}async download(_,H,ne){const{location:le}=await this.cb.download(_,H,!ne);return le}async lb(_){if(_.scheme===w.Schemas.file)return{location:_,async cleanup(){}};this.F.trace("Downloading extension from",_.toString());const H=(0,m.$bh)(this.cb.extensionsDownloadDir,(0,h.$Wg)());return await this.gb.download(_,H),this.F.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.ib.del(H)}catch(le){this.F.error(le)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(_,H,ne){const le=H instanceof u.URI?new n.$Bp({id:(0,n.$Fp)(_.publisher,_.name)},_.version):n.$Bp.create(H);return this.hb.createInstance(z,le,_,H,ne,(F,U)=>{if(H instanceof u.URI)return this.qb(le,H,ne,U);let X=this.db.get(le.toString());return X||(this.db.set(le.toString(),X=this.pb(le,H,F,ne,U)),X.finally(()=>this.db.delete(le.toString()))),X},this.ab)}Z(_,H){return new oe(_,H.profileLocation,this.fb)}async pb(_,H,ne,le,F){const{verificationStatus:U,location:X}=await this.cb.download(H,ne,!le.donotVerifySignature,le.context?.[r.$5o]);try{if(F.isCancellationRequested)throw new S.$5;return await(0,C.$Fq)(X.fsPath),{local:await this.ab.extractUserExtension(_,X.fsPath,{id:H.identifier.uuid,publisherId:H.publisherId,publisherDisplayName:H.publisherDisplayName,targetPlatform:H.properties.targetPlatform,isApplicationScoped:le.isApplicationScoped,isMachineScoped:le.isMachineScoped,isBuiltin:le.isBuiltin,isPreReleaseVersion:H.properties.isPreReleaseVersion,hasPreReleaseVersion:H.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:le.installGivenVersion?!0:!!le.pinned,preRelease:(0,c.$gg)(le.preRelease)?le.preRelease:le.installPreReleaseVersion||H.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:U}}catch(x){try{await this.cb.delete(X)}catch(Q){this.F.warn("Error while deleting the downloaded file",X.toString(),(0,S.$0)(Q))}throw(0,o.$sq)(x)}}async qb(_,H,ne,le){return{local:await this.ab.extractUserExtension(_,v.$kc(H.fsPath),{isApplicationScoped:ne.isApplicationScoped,isMachineScoped:ne.isMachineScoped,isBuiltin:ne.isBuiltin,installedTimestamp:Date.now(),pinned:ne.installGivenVersion?!0:!!ne.pinned,source:"vsix"},!0,le)}}async rb(_){const H=async le=>{let F=await g.Promises.readdir(le);F=F.map(x=>v.$jc(le,x));const U=await Promise.all(F.map(x=>g.Promises.stat(x)));let X=Promise.resolve([]);return U.forEach((x,Q)=>{const G=F[Q];x.isFile()&&(X=X.then(J=>[...J,G])),x.isDirectory()&&(X=X.then(J=>H(G).then(T=>[...J,...T])))}),X};return(await H(_.location.fsPath)).map(le=>({path:`extension/${v.$lc(_.location.fsPath,le)}`,localPath:le}))}async sb({added:_,removed:H}){if(H){const ne=_&&this.D.extUri.isEqual(H.profileLocation,_.profileLocation)?H.extensions.filter(le=>_.extensions.every(F=>!(0,n.$Ap)(F,le))):H.extensions;for(const le of ne)this.F.info("Extensions removed from another source",le.id,H.profileLocation.toString()),this.u.fire({identifier:le,profileLocation:H.profileLocation})}if(_){const le=(await this.getInstalled(1,_.profileLocation)).filter(F=>_.extensions.some(U=>(0,n.$Ap)(U,F.identifier)));this.s.fire(le.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,_.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:_.profileLocation,operation:1})))}}async ub(){this.B(this.ab.onExtract(H=>this.tb.add(H)));const _=await this.ib.resolve(this.eb.userExtensionsLocation);for(const H of _.children??[])H.isDirectory&&this.tb.add(H.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(H=>this.vb(H)))}async vb(_){if(!_.affects(this.eb.userExtensionsLocation,1))return;const H=[];for(const ne of _.rawAdded){if(this.tb.has(ne)||!this.D.extUri.isEqual(this.D.extUri.dirname(ne),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(ne,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(ne).startsWith(".")||!(await this.ib.stat(ne)).isDirectory)continue;const le=await this.ab.scanUserExtensionAtLocation(ne);le&&le.installedTimestamp===void 0&&(this.tb.add(ne),H.push(le))}H.length&&(await this.wb(H.map(ne=>[ne,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",H.map(ne=>ne.identifier.id)))}async wb(_,H){const ne=_.map(le=>le[0]);await this.xb(ne),await this.fb.addExtensionsToProfile(_,H),this.s.fire(ne.map(le=>({local:le,identifier:le.identifier,operation:1,profileLocation:H})))}async xb(_){const H=await this.ab.getUninstalledExtensions();for(const ne of _){const le=n.$Bp.create(ne);H[le.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",le.id),await this.ab.setInstalled(le),this.F.info("Removed the extension from uninstalled list:",le.id))}}};e.$Lq=Y,e.$Lq=Y=Le([Oe(0,r.$_o),Oe(1,ee.$6l),Oe(2,ae.$7j),Oe(3,t.$Ii),Oe(4,i.$zq),Oe(5,a.$vq),Oe(6,f.$Po),Oe(7,ie.$zi),Oe(8,V.$7k),Oe(9,te.$nk),Oe(10,K.$El),Oe(11,B.$Gl)],Y);let M=class extends $.$Uc{constructor(_,H,ne,le,F,U){super(),this.j=_,this.m=H,this.n=ne,this.s=le,this.t=F,this.u=U,this.h=this.B(new P.$he),this.onExtract=this.h.event,this.c=(0,m.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new s.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(_,H,ne){try{const le={includeInvalid:!0,profileLocation:H,productVersion:ne};let F=[];return _===null||_===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},le,!1)):_===1&&F.push(...await this.n.scanUserExtensions(le)),F=_!==null?F.filter(U=>U.type===_):F,await Promise.all(F.map(U=>this.F(U)))}catch(le){throw(0,o.$sq)(le,"Scanning")}}async scanAllUserExtensions(_){try{const H=await this.n.scanUserExtensions({includeAllVersions:!_,includeInvalid:!0});return await Promise.all(H.map(ne=>this.F(ne)))}catch(H){throw(0,o.$sq)(H,"Scanning")}}async scanUserExtensionAtLocation(_){try{const H=await this.n.scanExistingExtension(_,1,{includeInvalid:!0});if(H)return await this.F(H)}catch(H){this.u.error(H)}return null}async extractUserExtension(_,H,ne,le,F){const U=_.toString(),X=u.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$Wg)()}`)),x=u.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,U));let Q=await this.m.exists(x);if(Q&&le){try{await this.y(_.id,x,"removeExisting")}catch{throw new r.$bp(E.localize(4,null,x.fsPath,_.id),"Delete")}Q=!1}if(Q)try{await this.n.updateMetadata(x,ne)}catch(G){throw(0,o.$sq)(G,"UpdateMetadata")}else try{if(F.isCancellationRequested)throw new S.$5;try{this.u.trace(`Started extracting the extension from ${H} to ${x.fsPath}`),await(0,d.$pq)(H,X.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${x}:`,_.id)}catch(G){throw(0,C.$Eq)(G)}try{await this.n.updateMetadata(X,ne)}catch(G){throw(0,o.$sq)(G,"UpdateMetadata")}if(F.isCancellationRequested)throw new S.$5;try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${x.fsPath}`),await this.C(X.fsPath,x.fsPath),this.u.info("Renamed to",x.fsPath)}catch(G){if(G.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",_.id);else throw this.u.info(`Rename failed because of ${(0,S.$0)(G)}. Deleted from extracted location`,X),G}this.h.fire(x)}catch(G){try{await this.m.del(X,{recursive:!0})}catch{}throw G}return this.D(x,1)}async scanMetadata(_,H){return H?(await this.w(_,H))?.metadata:this.n.scanMetadata(_.location)}async w(_,H){return(await this.s.scanProfileExtensions(H)).find(le=>(0,n.$Ap)(le.identifier,_.identifier))}async updateMetadata(_,H,ne){try{ne?await this.s.updateMetadata([[_,H]],ne):await this.n.updateMetadata(_.location,H)}catch(le){throw(0,o.$sq)(le,"UpdateMetadata")}return this.D(_.location,_.type,ne)}async getUninstalledExtensions(){try{return await this.z()}catch(_){throw(0,o.$sq)(_,"ReadUninstalled")}}async setUninstalled(..._){const H=_.map(ne=>n.$Bp.create(ne));await this.z(ne=>H.forEach(le=>{ne[le.toString()]=!0,this.u.info("Marked extension as uninstalled",le.toString())}))}async setInstalled(_){try{await this.z(H=>delete H[_.toString()])}catch(H){throw(0,o.$sq)(H,"UnsetUninstalled")}}async removeExtension(_,H){if(this.t.extUri.isEqualOrParent(_.location,this.n.userExtensionsLocation))return this.y(_.identifier.id,_.location,H)}async removeUninstalledExtension(_){await this.removeExtension(_,"uninstalled"),await this.z(H=>delete H[n.$Bp.create(_).toString()])}async copyExtension(_,H,ne,le){const F=await this.w(_,H),U=await this.w(_,ne);if(le={...F?.metadata,...le},U)if(this.t.extUri.isEqual(U.location,_.location))await this.s.updateMetadata([[_,{...U.metadata,...le}]],ne);else{const X=await this.D(U.location,_.type,ne);await this.s.removeExtensionFromProfile(X,ne),await this.s.addExtensionsToProfile([[_,{...U.metadata,...le}]],ne)}else await this.s.addExtensionsToProfile([[_,le]],ne);return this.D(_.location,_.type,ne)}async copyExtensions(_,H,ne){const le=await this.scanExtensions(1,_,ne),F=await Promise.all(le.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,_)]));await this.s.addExtensionsToProfile(F,H)}async y(_,H,ne){this.u.trace(`Deleting ${ne} extension from disk`,_,H.fsPath);const le=this.t.extUri.joinPath(this.t.extUri.dirname(H),`${this.t.extUri.basename(H)}.${(0,b.$oj)((0,h.$Wg)()).toString(16)}${Z}`);await this.C(H.fsPath,le.fsPath),await this.m.del(le,{recursive:!0}),this.u.info(`Deleted ${ne} extension from disk`,_,H.fsPath)}z(_){return this.g.queue(async()=>{let H;try{H=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(le){if((0,V.$ll)(le)!==1)throw le}let ne={};if(H)try{ne=JSON.parse(H)}catch{}return _&&(_(ne),Object.keys(ne).length?await this.m.writeFile(this.c,j.$Je.fromString(JSON.stringify(ne))):await this.m.del(this.c)),ne})}async C(_,H){try{await g.Promises.rename(_,H,2*60*1e3)}catch(ne){throw(0,o.$sq)(ne,"Rename")}}async D(_,H,ne){try{if(ne){const F=(await this.n.scanUserExtensions({profileLocation:ne})).find(U=>this.t.extUri.isEqual(U.location,_));if(F)return await this.F(F)}else{const le=await this.n.scanExistingExtension(_,H,{includeInvalid:!0});if(le)return await this.F(le)}throw new r.$bp(E.localize(5,null,_.path),"ScanningExtension")}catch(le){throw(0,o.$sq)(le,"ScanningExtension")}}async F(_){const H=await this.m.resolve(_.location);let ne,le;return H.children&&(ne=H.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,le=H.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:_.identifier,type:_.type,isBuiltin:_.isBuiltin||!!_.metadata?.isBuiltin,location:_.location,manifest:_.manifest,targetPlatform:_.targetPlatform,validations:_.validations,isValid:_.isValid,readmeUrl:ne,changelogUrl:le,publisherDisplayName:_.metadata?.publisherDisplayName,publisherId:_.metadata?.publisherId||null,isApplicationScoped:!!_.metadata?.isApplicationScoped,isMachineScoped:!!_.metadata?.isMachineScoped,isPreReleaseVersion:!!_.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!_.metadata?.hasPreReleaseVersion,preRelease:!!_.metadata?.preRelease,installedTimestamp:_.metadata?.installedTimestamp,updated:!!_.metadata?.updated,pinned:!!_.metadata?.pinned,isWorkspaceScoped:!1,source:_.metadata?.source??(_.identifier.uuid?"gallery":"vsix")}}async G(){const _=await this.getUninstalledExtensions();if(Object.keys(_).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(_));const H=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),ne=new Set;for(const F of H)_[n.$Bp.create(F).toString()]||ne.add(F.identifier.id.toLowerCase());try{const F=(0,n.$Gp)(H,U=>U.identifier);await s.Promises.settled(F.map(async U=>{const X=U.sort((x,Q)=>l.rcompare(x.manifest.version,Q.manifest.version))[0];ne.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(F){this.u.error(F)}const le=H.filter(F=>F.metadata&&_[n.$Bp.create(F).toString()]);await Promise.allSettled(le.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let _;try{_=await this.m.resolve(this.n.userExtensionsLocation)}catch(H){(0,V.$ll)(H)!==1&&this.u.error(H);return}if(_?.children)try{await Promise.allSettled(_.children.map(async H=>{if(!(!H.isDirectory||!H.name.endsWith(Z))){this.u.trace("Deleting the temporarily deleted folder",H.resource.toString());try{await this.m.del(H.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",H.resource.toString())}catch(ne){(0,V.$ll)(ne)!==1&&this.u.error(ne)}}}))}catch{}}};e.$Mq=M,e.$Mq=M=Le([Oe(1,V.$7k),Oe(2,i.$zq),Oe(3,a.$vq),Oe(4,K.$El),Oe(5,ae.$7j)],M);let z=class extends o.$tq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(_,H,ne,le,F,U,X,x,Q,G,J,T){super(),this.l=_,this.manifest=H,this.source=ne,this.options=le,this.m=F,this.n=U,this.o=X,this.p=x,this.q=Q,this.s=G,this.t=J,this.u=T,this.j=2,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(H=>(0,n.$Ap)(H.identifier,this.identifier))}async h(_){const H=await this.v();H&&(this.j=3);const ne={isApplicationScoped:this.options.isApplicationScoped||H?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||H?.isMachineScoped,isBuiltin:this.options.isBuiltin||H?.isBuiltin,isSystem:H?.type===0?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??H?.pinned,source:this.source instanceof u.URI?"vsix":"gallery"};if(this.source instanceof u.URI)if(H){if(this.l.equals(new n.$Bp(H.identifier,H.manifest.version)))try{await this.n.removeExtension(H,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const X=await this.x(this.l);if(X)try{await this.n.removeExtension(X,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(ne.id=this.source.identifier.uuid,ne.publisherId=this.source.publisherId,ne.publisherDisplayName=this.source.publisherDisplayName,ne.targetPlatform=this.source.properties.targetPlatform,ne.updated=!!H,ne.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,ne.hasPreReleaseVersion=H?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,ne.preRelease=(0,c.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||H?.preRelease,H&&H.type!==0&&H.manifest.version===this.source.version)return this.n.updateMetadata(H,ne);const X=await this.x(this.l);if(X)return X}if(_.isCancellationRequested)throw(0,o.$sq)(new S.$5);const{local:le,verificationStatus:F}=await this.m(this.operation,_);if(this.k=F,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(X){throw(0,o.$sq)(X,"IntializeDefaultProfile")}if(_.isCancellationRequested)throw(0,o.$sq)(new S.$5);try{await this.t.addExtensionsToProfile([[le,ne]],this.options.profileLocation,!le.isValid)}catch(X){throw(0,o.$sq)(X,"AddToProfile")}const U=await this.v();if(!U)throw new r.$bp("Cannot find the installed extension","InstalledExtensionNotFound");return this.source instanceof u.URI&&this.y(le,_),U}async x(_){return(await this.n.getUninstalledExtensions())[_.toString()]?(this.u.trace("Removing the extension from uninstalled list:",_.id),await this.n.setInstalled(_),this.u.info("Removed the extension from uninstalled list:",_.id),(await this.n.scanAllUserExtensions(!0)).find(le=>n.$Bp.create(le).equals(_))):void 0}async y(_,H){try{let[ne]=await this.p.getExtensions([{id:_.identifier.id,version:_.manifest.version}],H);if(ne||([ne]=await this.p.getExtensions([{id:_.identifier.id}],H)),ne){const le={id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId,isPreReleaseVersion:ne.properties.isPreReleaseVersion,hasPreReleaseVersion:_.hasPreReleaseVersion||ne.properties.isPreReleaseVersion,preRelease:ne.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(_,le,this.options.profileLocation)}}catch{}}};z=Le([Oe(6,K.$El),Oe(7,r.$_o),Oe(8,B.$Gl),Oe(9,i.$zq),Oe(10,a.$vq),Oe(11,ae.$7j)],z);class oe extends o.$tq{constructor(_,H,ne){super(),this.extension=_,this.j=H,this.k=ne}async h(_){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ye[130],Ee([1,0,12,33,34,27,51,16,26,4]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;let y=class extends S.$wq{constructor(v,m,l,c,u,h){super($.URI.file(v.extensionsPath),m,l,c,u,h)}};e.$eQ=y,e.$eQ=y=Le([Oe(0,b.$Ii),Oe(1,P.$7k),Oe(2,j.$Gl),Oe(3,I.$El),Oe(4,D.$6l),Oe(5,s.$7j)],y)}),define(ye[131],Ee([1,0,14,6,2,44,10,184,5,33]),function(fe,e,s,j,I,D,S,P,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=m,e.$0p=c,e.$_p=h,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,b.$Ai)("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function m(g){const d=g.get(e.$6p);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}class l extends I.$Uc{static{this.a=60*1e3}constructor(d={flushInterval:l.a}){super(),this.m=d,this.b=this.B(new j.$ke),this.c=this.B(new j.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$he),this.onWillSaveState=this.f.event,this.h=this.B(new s.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,E,f){return j.Event.filter(this.b.event,t=>t.scope===d&&(E===void 0||t.key===E),f)}n(){this.j.value=(0,s.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,E){const{key:f,external:t}=E;if(f===e.$6p){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:f,target:this.J(d)[f],external:t})}w(d){this.f.fire({reason:d})}get(d,E,f){return this.P(E)?.get(d,f)}getBoolean(d,E,f){return this.P(E)?.getBoolean(d,f)}getNumber(d,E,f){return this.P(E)?.getNumber(d,f)}getObject(d,E,f){return this.P(E)?.getObject(d,f)}storeAll(d,E){this.y(()=>{for(const f of d)this.store(f.key,f.value,f.scope,f.target,E)})}store(d,E,f,t,o=!1){if((0,S.$jg)(E)){this.remove(d,f,o);return}this.y(()=>{this.z(d,f,t),this.P(f)?.set(d,E,o)})}remove(d,E,f=!1){this.y(()=>{this.z(d,E,void 0),this.P(E)?.delete(d,f)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,E){const f=[],t=this.J(d);for(const o of Object.keys(t))t[o]===E&&f.push(o);return f}z(d,E,f,t=!1){const o=this.J(E);typeof f=="number"?o[d]!==f&&(o[d]=f,this.P(E)?.set(e.$6p,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.P(E)?.set(e.$6p,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const E=this.P(d);return E?m(E):Object.create(null)}isNew(d){return this.getBoolean(e.$5p,d)===!0}async flush(d=y.NONE){this.f.fire({reason:d});const E=this.P(-1),f=this.P(0),t=this.P(1);switch(d){case y.NONE:await s.Promises.settled([E?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await s.Promises.settled([E?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return h(d,E,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,E){return this.w(y.NONE),(0,$.$Fl)(d)?this.R(d,E):this.S(d,E)}M(d,E){return!(d.id===E.id||c(E)&&c(d))}N(d,E,f){this.y(()=>{const t=new Set;for(const[o,r]of d)t.add(o),E.get(o)!==r&&this.u(f,{key:o,external:!0});for(const[o]of E.items)t.has(o)||this.u(f,{key:o,external:!0})})}}e.$9p=l;function c(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class u extends l{constructor(){super(),this.U=this.B(new P.$3p(new P.$4p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$3p(new P.$4p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$3p(new P.$4p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$$p=u;async function h(g,d,E,f,t,o){const r=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,a=new Map;g.forEach((N,V)=>{n.set(V,N),a.set(V,r(N))});const i=new Map,p=new Map;d.forEach((N,V)=>{i.set(V,N),p.set(V,r(N))});const k=new Map,C=new Map;E.forEach((N,V)=>{k.set(V,N),C.set(V,r(N))}),console.group(f!==t?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const A=[];if(n.forEach((N,V)=>{A.push({key:V,value:N})}),console.table(A),console.groupEnd(),console.log(a),f!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];i.forEach((V,ie)=>{N.push({key:ie,value:V})}),console.table(N),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const O=[];k.forEach((N,V)=>{O.push({key:V,value:N})}),console.table(O),console.groupEnd(),console.log(C)}}),define(ye[132],Ee([1,0,18,20,11,3,32,10,4,25,26,29,38,82,16,12,30,42,258,131,27,61]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$cq=se;const t=D.$o?"web":(0,w.$8o)(D.$u,S.$ec),o="X-Market-Search-Activity-Id";var r;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...U){return String(U.reduce((X,x)=>X|x,0))}var a;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},p={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class A{constructor(X=C){this.d=X}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(X,x=this.d.pageSize){return new A({...this.d,pageNumber:X,pageSize:x})}withFilter(X,...x){const Q=[...this.d.criteria,...x.length?x.map(G=>({filterType:X,value:G})):[{filterType:X}]];return new A({...this.d,criteria:Q})}withSortBy(X){return new A({...this.d,sortBy:X})}withSortOrder(X){return new A({...this.d,sortOrder:X})}withFlags(...X){return new A({...this.d,flags:X.reduce((x,Q)=>x|Q,0)})}withAssetTypes(...X){return new A({...this.d,assetTypes:X})}withSource(X){return new A({...this.d,source:X})}get raw(){const{criteria:X,pageNumber:x,pageSize:Q,sortBy:G,sortOrder:J,flags:T,assetTypes:W}=this.d;return{filters:[{criteria:X,pageNumber:x,pageSize:Q,sortBy:G,sortOrder:J}],assetTypes:W,flags:T}}get searchText(){const X=this.d.criteria.filter(x=>x.filterType===a.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(X=>String(X.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(U,X){const x=(U||[]).filter(Q=>Q.statisticName===X)[0];return x?x.value:0}function N(U){const X="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(Q=>Q.assetType.indexOf(X)===0).reduce((Q,G)=>{const J=ae(U,G.assetType);return J&&Q.push([G.assetType.substring(X.length),J]),Q},[])}function V(U){if(U.properties){const X=U.properties.filter(G=>G.key===i.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=X.filter(G=>x.test(G.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return ae(U,i.Repository)}function ie(U){return{uri:`${U.fallbackAssetUri}/${i.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${i.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ae(U,X){return U.files.filter(Q=>Q.assetType===X)[0]?{uri:`${U.assetUri}/${X}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${X}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function te(U,X){const x=U.properties?U.properties.filter(G=>G.key===X):[],Q=x.length>0&&x[0].value;return Q?Q.split(",").map(G=>(0,v.$Ep)(G)):[]}function ee(U){const X=U.properties?U.properties.filter(x=>x.key===p.Engine):[];return X.length>0&&X[0].value||""}function K(U){const X=U.properties?U.properties.filter(x=>x.key===p.PreRelease):[];return X.length>0&&X[0].value==="true"}function B(U){const X=U.properties?U.properties.filter(Q=>Q.key===p.LocalizedLanguages):[],x=X.length>0&&X[0].value||"";return x?x.split(","):[]}function Z(U){return U.properties?.find(X=>X.key===p.SponsorLink)?.value}function Y(U){return U.properties?.find(X=>X.key===p.SupportLink)?.value}function M(U){return U.indexOf("preview")!==-1}function z(U){return U.targetPlatform?(0,w.$7o)(U.targetPlatform):"undefined"}function oe(U){const X=(0,s.$Mb)(U.versions.map(z)),x=!!U.tags?.includes(w.$1o),Q=X.indexOf("web");return x?Q===-1&&X.push("web"):Q!==-1&&X.splice(Q,1),X}function se(U,X){for(let x=0;x<U.length;x++){const Q=U[x];if(Q.version===U[x-1]?.version){let G=x;if(z(Q)===X)for(;G>0&&U[G-1].version===Q.version;)G--;G!==x&&(U.splice(x,1),U.splice(G,0,Q))}}return U}function _(U,X,x){U.telemetryData={index:X,querySource:x,queryActivityId:U.queryContext?.[o]}}function H(U,X,x,Q){const G=U.versions[0],J={manifest:ae(X,i.Manifest),readme:ae(X,i.Details),changelog:ae(X,i.Changelog),license:ae(X,i.License),repository:V(X),download:ie(X),icon:ae(X,i.Icon),signature:ae(X,i.Signature),coreTranslations:N(X)};return{type:"gallery",identifier:{id:(0,v.$Fp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:X.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(G),description:U.shortDescription??"",installCount:O(U.statistics,"install"),rating:O(U.statistics,"averagerating"),ratingCount:O(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:x,assets:J,properties:{dependencies:te(X,p.Dependency),extensionPack:te(X,p.ExtensionPack),engine:ee(X),localizedLanguages:B(X),targetPlatform:z(X),isPreReleaseVersion:K(X)},hasPreReleaseVersion:K(G),hasReleaseVersion:!0,preview:M(U.flags),isSigned:!!J.signature,queryContext:Q,supportLink:Y(G)}}let ne=class{constructor(X,x,Q,G,J,T,W,ce){this.k=x,this.l=Q,this.n=G,this.o=J,this.q=T,this.u=W,this.w=ce;const ue=W.extensionsGallery,we=ue?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=we?ue.servicePPEUrl:ue?.serviceUrl,this.g=we?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,g.$bq)(W.version,W,this.n,this.w,this.q,X,this.o)}x(X=""){return`${this.d}${X}`}isEnabled(){return!!this.d}async getExtensions(X,x,Q){const G=j.CancellationToken.isCancellationToken(x)?{}:x,J=j.CancellationToken.isCancellationToken(x)?x:Q,T=[],W=[],ce=[],ue=[];let we=!0;for(const $e of X){$e.uuid?W.push($e.uuid):T.push($e.id);const Ce=!!($e.version||$e.preRelease);ce.push({id:$e.id,uuid:$e.uuid,includePreRelease:Ce}),$e.version&&ue.push({id:$e.id,uuid:$e.uuid,version:$e.version}),we=we&&!!$e.hasPreRelease&&!Ce}if(!W.length&&!T.length)return[];let de=new A().withPage(1,X.length);W.length&&(de=de.withFilter(a.ExtensionId,...W)),T.length&&(de=de.withFilter(a.ExtensionName,...T)),(G.queryAllVersions||we)&&(de=de.withFlags(de.flags,r.IncludeVersions)),G.source&&(de=de.withSource(G.source));const{extensions:ge}=await this.z(de,{targetPlatform:G.targetPlatform??t,includePreRelease:ce,versions:ue,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},J);return G.source&&ge.forEach(($e,Ce)=>_($e,Ce,G.source)),ge}async getCompatibleExtension(X,x,Q,G={version:this.u.version,date:this.u.date}){if((0,w.$9o)(X.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(X,x,Q))return X;const J=new A().withFlags(r.IncludeVersions).withPage(1,1).withFilter(a.ExtensionId,X.identifier.uuid),{extensions:T}=await this.z(J,{targetPlatform:Q,compatible:!0,includePreRelease:x,productVersion:G},j.CancellationToken.None);return T[0]||null}async isExtensionCompatible(X,x,Q,G={version:this.u.version,date:this.u.date}){if(!(0,w.$0o)(X.properties.targetPlatform,X.allTargetPlatforms,Q)||!x&&X.properties.isPreReleaseVersion)return!1;let J=X.properties.engine;if(!J){const T=await this.getManifest(X,j.CancellationToken.None);if(!T)throw new Error("Manifest was not found");J=T.engines.vscode}return(0,m.$Sp)(J,G.version,G.date)}async y(X,x,Q,G,J,T,W={version:this.u.version,date:this.u.date}){if(!(0,w.$0o)(z(x),J,T)||Q!=="any"&&K(x)!==(Q==="prerelease"))return!1;if(G)try{const ce=await this.E(X,x);if(!(0,m.$Sp)(ce,W.version,W.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,I.$0)(ce)),!1}return!0}async query(X,x){let Q=X.text||"";const G=X.pageSize??50;let J=new A().withPage(1,G);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,de,ge)=>(J=J.withFilter(a.Category,ge||de),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,de,ge)=>(J=J.withFilter(a.Tag,ge||de),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(a.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),J=J.withFilter(a.SearchText,Q)),J=J.withSortBy(0)):X.ids?J=J.withFilter(a.ExtensionId,...X.ids):X.names?J=J.withFilter(a.ExtensionName,...X.names):J=J.withSortBy(4),typeof X.sortBy=="number"&&(J=J.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(J=J.withSortOrder(X.sortOrder)),X.source&&(J=J.withSource(X.source));const T=async(we,de)=>{const{extensions:ge,total:$e}=await this.z(we,{targetPlatform:t,compatible:!1,includePreRelease:!!X.includePreRelease,productVersion:X.productVersion??{version:this.u.version,date:this.u.date}},de);return ge.forEach((Ce,Ae)=>_(Ce,(we.pageNumber-1)*we.pageSize+Ae,X.source)),{extensions:ge,total:$e}},{extensions:W,total:ce}=await T(J,x),ue=async(we,de)=>{if(de.isCancellationRequested)throw new I.$5;const{extensions:ge}=await T(J.withPage(we+1),de);return ge};return{firstPage:W,total:ce,pageSize:J.pageSize,getPage:ue}}async z(X,x,Q){const G=X.flags;X.flags&r.IncludeLatestVersionOnly&&X.flags&r.IncludeVersions&&(X=X.withFlags(X.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(X.flags&r.IncludeLatestVersionOnly)&&!(X.flags&r.IncludeVersions)&&(X=X.withFlags(X.flags,r.IncludeLatestVersionOnly)),x.versions?.length&&(X=X.withFlags(X.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),X=X.withFlags(X.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:J,total:T,context:W}=await this.B(X,Q);if(!(X.flags&r.IncludeLatestVersionOnly)){const de=[];for(const ge of J){const $e=await this.A(ge,x,W);$e&&de.push($e)}return{extensions:de,total:T}}const ue=[],we=new Map;for(let de=0;de<J.length;de++){const ge=J[de],$e={id:(0,v.$Fp)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ce=(0,P.$gg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(he=>(0,v.$Ap)(he,$e))?.includePreRelease;if(x.compatible&&(0,w.$9o)(oe(ge),x.targetPlatform))continue;const Ae=await this.A(ge,x,W);!Ae||Ae.properties.isPreReleaseVersion&&(!Ce||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==x.targetPlatform&&Ae.hasPreReleaseVersion?we.set(ge.extensionId,de):ue.push([de,Ae])}if(we.size){const de=new f.$be,ge=new A().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,we.size).withFilter(a.ExtensionId,...we.keys()),{extensions:$e}=await this.z(ge,x,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:we.size});for(const Ce of $e){const Ae=we.get(Ce.identifier.uuid);ue.push([Ae,Ce])}}return{extensions:ue.sort((de,ge)=>de[0]-ge[0]).map(([,de])=>de),total:T}}async A(X,x,Q){const G={id:(0,v.$Fp)(X.publisher.publisherName,X.extensionName),uuid:X.extensionId},J=x.versions?.find(ue=>(0,v.$Ap)(ue,G))?.version,T=(0,P.$gg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ue=>(0,v.$Ap)(ue,G))?.includePreRelease,W=oe(X),ce=se(X.versions,x.targetPlatform);if(x.compatible&&(0,w.$9o)(W,x.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const we=ce[ue];if(!(J&&we.version!==J)){if(await this.y((0,v.$Fp)(X.publisher.publisherName,X.extensionName),we,T?"any":"release",x.compatible,W,x.targetPlatform,x.productVersion))return H(X,we,W,Q);if(J&&we.version===J)return null}}return J||x.compatible?null:H(X,X.versions[0],W)}async B(X,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,r.ExcludeNonValidated).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExcludeWithFlags,n(r.Unpublished));const Q=await this.j,G=JSON.stringify(X.raw),J={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},T=new f.$be;let W,ce,ue=0;try{if(W=await this.k.request({type:"POST",url:this.g&&X.criteria.some(de=>de.filterType===a.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:J},x),W.res.statusCode&&W.res.statusCode>=400&&W.res.statusCode<500)return{galleryExtensions:[],total:ue};const we=await(0,h.$Zp)(W);if(we){const de=we.results[0],ge=de.extensions,$e=de.resultMetadata&&de.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ue=$e&&$e.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ue,context:{[o]:W.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(we){const de=(0,I.$4)(we)?"Cancelled":(0,I.$0)(we).startsWith("XHR timeout")?"Timeout":"Failed";throw ce=new w.$ap((0,I.$0)(we),de),ce}finally{this.o.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(G.length),duration:T.elapsed(),success:!!W&&(0,h.$Vp)(W),responseBodySize:W?.res.headers["Content-Length"],statusCode:W?String(W.res.statusCode):void 0,errorCode:ce?.code,count:String(ue)})}}async reportStatistic(X,x,Q,G){if(!this.isEnabled())return;const J=D.$o?this.x(`/itemName/${X}.${x}/version/${Q}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${X}/extensions/${x}/${Q}/stats?statType=${G}`),T=D.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:T};try{await this.k.request({type:"POST",url:J,headers:ce},j.CancellationToken.None)}catch{}}async download(X,x,Q){this.l.trace("ExtensionGalleryService#download",X.identifier.id);const G=(0,v.$Ip)(X),J=new Date().getTime(),T=Q===2?"install":Q===3?"update":"",W=T?{uri:`${X.assets.download.uri}${b.URI.parse(X.assets.download.uri).query?"&":"?"}${T}=true`,fallbackUri:`${X.assets.download.fallbackUri}${b.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${T}=true`}:X.assets.download,ce=X.queryContext?.[o]?{[o]:X.queryContext[o]}:void 0,ue=await this.D(X.identifier.id,W,i.VSIX,ce?{headers:ce}:void 0);try{await this.q.writeFile(x,ue.stream)}catch(we){try{await this.q.del(x)}catch(de){this.l.warn(`Error while deleting the file ${x.toString()}`,(0,I.$0)(de))}throw new w.$ap((0,I.$0)(we),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...G,duration:new Date().getTime()-J})}async downloadSignatureArchive(X,x){if(!X.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",X.identifier.id);const Q=await this.D(X.identifier.id,X.assets.signature,i.Signature);try{await this.q.writeFile(x,Q.stream)}catch(G){try{await this.q.del(x)}catch(J){this.l.warn(`Error while deleting the file ${x.toString()}`,(0,I.$0)(J))}throw new w.$ap((0,I.$0)(G),"DownloadFailedWriting")}}async getReadme(X,x){if(X.assets.readme){const Q=await this.D(X.identifier.id,X.assets.readme,i.Details,{},x);return await(0,h.$Yp)(Q)||""}return""}async getManifest(X,x){if(X.assets.manifest){const Q=await this.D(X.identifier.id,X.assets.manifest,i.Manifest,{},x),G=await(0,h.$Yp)(Q);return G?JSON.parse(G):null}return null}async C(X,x,Q){const G=ae(x,i.Manifest);if(!G)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},T=await this.D(X,G,i.Manifest,{headers:J});return await(0,h.$Zp)(T)}async getCoreTranslation(X,x){const Q=X.assets.coreTranslations.filter(G=>G[0]===x.toUpperCase())[0];if(Q){const G=await this.D(X.identifier.id,Q[1],Q[0]),J=await(0,h.$Yp)(G);return J?JSON.parse(J):null}return null}async getChangelog(X,x){if(X.assets.changelog){const Q=await this.D(X.identifier.id,X.assets.changelog,i.Changelog,{},x);return await(0,h.$Yp)(Q)||""}return""}async getAllCompatibleVersions(X,x,Q){let G=new A().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);X.identifier.uuid?G=G.withFilter(a.ExtensionId,X.identifier.uuid):G=G.withFilter(a.ExtensionName,X.identifier.id);const{galleryExtensions:J}=await this.B(G,j.CancellationToken.None);if(!J.length)return[];const T=oe(J[0]);if((0,w.$9o)(T,Q))return[];const W=[];await Promise.all(J[0].versions.map(async we=>{try{await this.y(X.identifier.id,we,x?"any":"release",!0,T,Q)&&W.push(we)}catch{}}));const ce=[],ue=new Set;for(const we of se(W,Q))ue.has(we.version)||(ue.add(we.version),ce.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:K(we)}));return ce}async D(X,x,Q,G={},J=j.CancellationToken.None){const T=await this.j,W={type:"GET"},ce={...T,...G.headers||{}};G={...G,...W,headers:ce};const ue=x.uri,we=x.fallbackUri,de={...G,url:ue};try{const ge=await this.k.request(de,J);if(ge.res.statusCode===200)return ge;const $e=await(0,h.$Yp)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${$e}`)}catch(ge){if((0,I.$4)(ge))throw ge;const $e=(0,I.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{extension:X,assetType:Q,message:$e});const Ce={...G,url:we};return this.k.request(Ce,J)}}async E(X,x){let Q=ee(x);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:X,version:x.version});const G=await this.C(X,x,j.CancellationToken.None);if(!G)throw new Error("Manifest was not found");Q=G.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const X=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,h.$Zp)(X),Q=[],G={},J=[];if(x){for(const T of x.malicious)Q.push({id:T});if(x.migrateToPreRelease)for(const[T,W]of Object.entries(x.migrateToPreRelease))(!W.engine||(0,m.$Sp)(W.engine,this.u.version,this.u.date))&&(G[T.toLowerCase()]={disallowInstall:!0,extension:{id:W.id,displayName:W.displayName,autoMigrate:{storage:!!W.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[T,W]of Object.entries(x.deprecated))W&&(G[T.toLowerCase()]=(0,P.$gg)(W)?{}:W);if(x.search)for(const T of x.search)J.push(T)}return{malicious:Q,deprecated:G,search:J}}};ne=Le([Oe(1,h.$Tp),Oe(2,c.$7j),Oe(3,y.$Hi),Oe(4,E.$6l),Oe(5,l.$7k),Oe(6,u.$nk),Oe(7,$.$7i)],ne);let le=class extends ne{constructor(X,x,Q,G,J,T,W,ce){super(X,x,Q,G,J,T,W,ce)}};e.$dq=le,e.$dq=le=Le([Oe(0,d.$7p),Oe(1,h.$Tp),Oe(2,c.$7j),Oe(3,y.$Hi),Oe(4,E.$6l),Oe(5,l.$7k),Oe(6,u.$nk),Oe(7,$.$7i)],le);let F=class extends ne{constructor(X,x,Q,G,J,T,W){super(void 0,X,x,Q,G,J,T,W)}};e.$eq=F,e.$eq=F=Le([Oe(0,h.$Tp),Oe(1,c.$7j),Oe(2,y.$Hi),Oe(3,E.$6l),Oe(4,l.$7k),Oe(5,u.$nk),Oe(6,$.$7i)],F)}),define(ye[273],Ee([1,0,6,2,33,55]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=void 0;class S{constructor($,y){this.a=$,this.b=y}listen($,y){const w=this.b($);switch(y){case"onDidChangeProfiles":return s.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(m=>(0,D.$En)({...m},w)),added:v.added.map(m=>(0,D.$En)({...m},w)),removed:v.removed.map(m=>(0,D.$En)({...m},w)),updated:v.updated.map(m=>(0,D.$En)({...m},w))}))}throw new Error(`Invalid listen ${y}`)}async call($,y,w){const v=this.b($);switch(y){case"createProfile":{const m=await this.a.createProfile(w[0],w[1],w[2]);return(0,D.$En)({...m},v)}case"updateProfile":{let m=(0,I.$Hl)((0,D.$Fn)(w[0],v),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,w[1]),(0,D.$En)({...m},v)}case"removeProfile":{const m=(0,I.$Hl)((0,D.$Fn)(w[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${y}`)}}e.$lQ=S;class P extends j.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,y,w){super(),this.profilesHome=y,this.f=w,this.a=[],this.b=this.B(new s.$he),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(v=>(0,I.$Hl)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const m=v.added.map(u=>(0,I.$Hl)(u,this.profilesHome.scheme)),l=v.removed.map(u=>(0,I.$Hl)(u,this.profilesHome.scheme)),c=v.updated.map(u=>(0,I.$Hl)(u,this.profilesHome.scheme));this.a=v.all.map(u=>(0,I.$Hl)(u,this.profilesHome.scheme)),this.b.fire({added:m,removed:l,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,y,w){const v=await this.f.call("createNamedProfile",[$,y,w]);return(0,I.$Hl)(v,this.profilesHome.scheme)}async createProfile($,y,w,v){const m=await this.f.call("createProfile",[$,y,w,v]);return(0,I.$Hl)(m,this.profilesHome.scheme)}async createTransientProfile($){const y=await this.f.call("createTransientProfile",[$]);return(0,I.$Hl)(y,this.profilesHome.scheme)}async setProfileForWorkspace($,y){await this.f.call("setProfileForWorkspace",[$,y])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,y){const w=await this.f.call("updateProfile",[$,y]);return(0,I.$Hl)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$mQ=P}),define(ye[133],Ee([1,0,4,26,16,12,252,34,33,10,253]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";var w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=void 0;let m=class extends b.$Jl{static{w=this}static{this.a="profileAssociationsMigration"}constructor(h,g,d,E,f){super(d,E,g,f),this.U=h,this.W=d}O(){return this.U.getItem(w.b,[]).map(g=>({...g,location:(0,$.$ag)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):s.URI.revive(g.location)}))}Q(){const h=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(s.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$bQ=m,e.$bQ=m=w=Le([Oe(0,S.$9P),Oe(1,P.$El),Oe(2,j.$Ii),Oe(3,I.$7k),Oe(4,D.$7j)],m);let l=v=class extends m{constructor(h,g,d,E,f){super(h,g,d,E,f),this.$=h}P(h){h.length?this.$.setItem(v.b,h.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(v.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(v.c,h):this.$.removeItem(v.c)}Q(){const h="workspaceAndProfileInfo",g=this.$.getItem(h,void 0);if(g){this.$.removeItem(h);const E=g.reduce((f,{workspace:t,profile:o})=>(f[s.URI.revive(t).toString()]=s.URI.revive(o).toString(),f),{});this.$.setItem(v.c,{workspaces:E})}const d=super.Q();return this.$.getItem(v.a,!1)||(this.R(d),this.$.setItem(v.a,!0)),d}};e.$cQ=l,e.$cQ=l=v=Le([Oe(0,S.$0P),Oe(1,P.$El),Oe(2,j.$Ii),Oe(3,I.$7k),Oe(4,D.$7j)],l);let c=class extends l{constructor(h,g,d,E){super(new y.$aQ(0,g,E,d),h,g,d,E)}async init(){return await this.$.init(),super.init()}};e.$dQ=c,e.$dQ=c=Le([Oe(0,P.$El),Oe(1,j.$Ii),Oe(2,I.$7k),Oe(3,D.$7j)],c)}),define(ye[134],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=void 0,e.$mn=(0,s.$Ai)("extensionHostStatusService");class j{constructor(){this.a=new Map}setExitInfo(D,S){this.a.set(D,S)}getExitInfo(D){return this.a.get(D)||null}}e.$nn=j}),define(ye[274],Ee([1,0,6,14]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0;function I(S){let P=0,b=0,$=0;S>=1e3&&($=Math.floor(S/1e3),S-=$*1e3),$>=60&&(b=Math.floor($/60),$-=b*60),b>=60&&(P=Math.floor(b/60),b-=P*60);const y=P?`${P}h`:"",w=b?`${b}m`:"",v=$?`${$}s`:"",m=S?`${S}ms`:"";return`${y}${w}${v}${m}`}class D{constructor(P,b,$,y){this.i=P,this.j=b,this.a=new s.$he,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=y,this.e=!1,this.f=new j.$Nh(()=>{this.k(`The reconnection grace time of ${I(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new j.$Nh(()=>{this.k(`The reconnection short grace time of ${I(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${I(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${I(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,b,$){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,$),this.protocol.endAcceptReconnection()}}e.$vn=D}),define(ye[135],Ee([1,0,28,13,7,166,58]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.$em=y;const P=I.$jc(j.$Ug.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function $(v){return new Promise(m=>s.exists(v,m))}function y(v,m){return $(P).then(l=>{if(!l||!S.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const c=`${v}||${m}`;let u=b.get(c);return u||(u=D.getNLSConfiguration(S.default.commit,m,P,v,v).then(h=>(w.is(h)&&(h._languagePackSupport=!0),h)),b.set(c,u)),u})}var w;(function(v){function m(l){const c=l;return c&&typeof c._languagePackId=="string"}v.is=m})(w||(e.InternalNLSConfiguration=w={}))}),define(ye[136],Ee([1,0,19,4,26,51,59,16,5,12,30,34,33,135]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;let l=class extends S.$Aq{constructor(u,h,g,d,E,f,t,o){super(j.URI.file(E.builtinExtensionsPath),j.URI.file(E.extensionsPath),(0,s.$bh)(E.userHome,".vscode-oss-dev","extensions","control.json"),u.defaultProfile,u,h,g,d,E,f,t,o),this.S=E}async f(u){const h=await(0,m.$em)(u,this.S.userDataPath);if(m.InternalNLSConfiguration.is(h))try{const g=await this.w.readFile(j.URI.file(h._translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};e.$4P=l,e.$4P=l=Le([Oe(0,v.$Gl),Oe(1,D.$vq),Oe(2,P.$7k),Oe(3,$.$7j),Oe(4,I.$Ii),Oe(5,y.$nk),Oe(6,w.$El),Oe(7,b.$zi)],l)}),define(ye[275],Ee([1,0,276,28,7,22,13,23]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.ServerConnectionTokenType=void 0,e.$zn=m,e.$An=l,e.$Bn=c;const b=/^[0-9A-Za-z_-]+$/;var $;(function(u){u[u.None=0]="None",u[u.Optional=1]="Optional",u[u.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class y{constructor(){this.type=0}validate(h){return!0}}e.$wn=y;class w{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.$xn=w;class v{constructor(h){this.message=h}}e.$yn=v;async function m(u,h){const g=u["without-connection-token"],d=u["connection-token"],E=u["connection-token-file"];if(g)return typeof d<"u"||typeof E<"u"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new y;if(typeof E<"u"){if(typeof d<"u")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let f;try{f=j.readFileSync(E).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${E}'.`)}return b.test(f)?new w(f):new v(`The connection token defined in '${E} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof d<"u"?b.test(d)?new w(d):new v(`The connection token '${d} does not adhere to the characters 0-9, a-z, A-Z or -.`):new w(await h())}async function l(u){return m(u,async()=>{if(!u["user-data-dir"])return(0,D.$Wg)();const g=I.$jc(u["user-data-dir"],"token");try{const f=(await P.Promises.readFile(g)).toString().replace(/\r?\n$/,"");if(b.test(f))return f}catch{}const d=(0,D.$Wg)();try{await P.Promises.writeFile(g,d,{mode:384})}catch{}return d})}function c(u,h,g){if(u.validate(g.query[S.$Mg]))return!0;const d=s.parse(h.headers.cookie||"");return u.validate(d[S.$Lg])}}),define(ye[52],Ee([1,0,216,110,67,5,26,74]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=void 0,e.$dn={host:{type:"string",cat:"o",args:"ip-address",description:s.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:s.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:s.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:s.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:s.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:s.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:s.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:s.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:s.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:s.localize(9,null)},"user-data-dir":I.$wm["user-data-dir"],"enable-smoke-test-driver":I.$wm["enable-smoke-test-driver"],"disable-telemetry":I.$wm["disable-telemetry"],"disable-workspace-trust":I.$wm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:I.$wm.log,logsPath:I.$wm.logsPath,"force-disable-user-env":I.$wm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:s.localize(10,null)},"default-workspace":{type:"string",description:s.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":I.$wm["extensions-dir"],"extensions-download-dir":I.$wm["extensions-download-dir"],"builtin-extensions-dir":I.$wm["builtin-extensions-dir"],"install-extension":I.$wm["install-extension"],"install-builtin-extension":I.$wm["install-builtin-extension"],"update-extensions":I.$wm["update-extensions"],"uninstall-extension":I.$wm["uninstall-extension"],"list-extensions":I.$wm["list-extensions"],"locate-extension":I.$wm["locate-extension"],"show-versions":I.$wm["show-versions"],category:I.$wm.category,force:I.$wm.force,"do-not-sync":I.$wm["do-not-sync"],"pre-release":I.$wm["pre-release"],"start-server":{type:"boolean",cat:"e",description:s.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:I.$wm.help,version:I.$wm.version,"locate-shell-integration-path":I.$wm["locate-shell-integration-path"],compatibility:{type:"string"},_:I.$wm._},e.$en=(0,D.$Bi)(S.$Hi);class b extends j.$an{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$fn=b,Le([P.$5h],b.prototype,"userRoamingDataHome",null)}),define(ye[277],Ee([1,0,28,23,77,87,276,90,35,65,3,12,52,7,13,22,30,42,20,4,15,10]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.CacheControl=void 0,e.$qQ=o,e.$rQ=n;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(p,k,C,A){k.writeHead(C,{"Content-Type":"text/plain"}),k.end(A)}var r;(function(p){p[p.NO_CACHING=0]="NO_CACHING",p[p.ETAG=1]="ETAG",p[p.NO_EXPIRY=2]="NO_EXPIRY"})(r||(e.CacheControl=r={}));async function n(p,k,C,A,O,N){try{const V=await j.Promises.stat(p);if(k===1){const ie=`W/"${[V.ino,V.size,V.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===ie)return O.writeHead(304),void O.end();N.Etag=ie}else k===2?N["Cache-Control"]="public, max-age=31536000":k===0&&(N["Cache-Control"]="no-store");N["Content-Type"]=t[(0,m.$oc)(p)]||(0,$.$Ys)(p)||"text/plain",O.writeHead(200,N),(0,s.createReadStream)(p).pipe(O)}catch(V){return V.code!=="ENOENT"?(C.error(V),console.error(V.toString())):console.error(`File not found: ${p}`),O.writeHead(404,{"Content-Type":"text/plain"}),void O.end("Not found")}}const a=(0,m.$mc)(l.$Ug.asFileUri("").fsPath);let i=class{constructor(k,C,A,O,N,V,ie){this.f=k,this.g=C,this.serverRootPath=A,this.h=O,this.i=N,this.j=V,this.k=ie,this.a=this.k.extensionsGallery?.resourceUrlTemplate?d.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${A}/static`,this.c=`${A}/callback`,this.d=`${A}/web-extension-resource`}async handle(k,C,A){try{const O=A.pathname;return O.startsWith(this.b)&&O.charCodeAt(this.b.length)===47?this.l(k,C,A):O===this.g?this.o(k,C,A):O===this.c?this.q(C):O.startsWith(this.d)&&O.charCodeAt(this.d.length)===47?this.n(k,C,A):o(k,C,404,"Not found.")}catch(O){return this.i.error(O),console.error(O.toString()),o(k,C,500,"Internal Server Error.")}}async l(k,C,A){const O=Object.create(null),V=decodeURIComponent(A.pathname).substring(this.b.length+1),ie=(0,m.$jc)(a,V);return(0,b.$zg)(ie,a,!y.$k)?n(ie,this.h.isBuilt?2:1,this.i,k,C,O):o(k,C,400,"Bad request.")}m(k){const C=k.authority.indexOf(".");return C!==-1?k.authority.substring(C+1):void 0}async n(k,C,A){if(!this.a)return o(k,C,500,"No extension gallery service configured.");const O=decodeURIComponent(A.pathname),N=(0,m.$hc)(O.substring(this.d.length+1)),V=d.URI.parse(N).with({scheme:this.a.scheme,authority:N.substring(0,N.indexOf("/")),path:N.substring(N.indexOf("/")+1)});if(this.m(this.a)!==this.m(V))return o(k,C,403,"Request Forbidden");const ie={},ae=Y=>{const M=k.headers[Y];M&&((0,f.$ag)(M)||M[0])?ie[Y]=(0,f.$ag)(M)?M:M[0]:Y!==Y.toLowerCase()&&ae(Y.toLowerCase())};ae("X-Client-Name"),ae("X-Client-Version"),ae("X-Machine-Id"),ae("X-Client-Commit");const te=await this.j.request({type:"GET",url:V.toString(!0),headers:ie},g.CancellationToken.None),ee=te.res.statusCode||500;if(ee!==200){let Y=null;try{Y=await(0,h.$Yp)(te)}catch{}return o(k,C,ee,Y||`Request failed with status ${ee}`)}const K=Object.create(null),B=Y=>{const M=te.res.headers[Y];M?K[Y]=M:Y!==Y.toLowerCase()&&B(Y.toLowerCase())};B("Cache-Control"),B("Content-Type"),C.writeHead(200,K);const Z=await(0,E.$Ve)(te.stream);return void C.end(Z.buffer)}async o(k,C,A){const O=A.query[l.$Mg];if(typeof O=="string"){const ne=Object.create(null);ne["Set-Cookie"]=S.serialize(l.$Lg,O,{sameSite:"lax",maxAge:60*60*24*7});const le=Object.create(null);for(const U in A.query)U!==l.$Mg&&(le[U]=A.query[U]);const F=D.format({pathname:A.pathname,query:le});return ne.Location=F,C.writeHead(302,ne),void C.end()}const N=ne=>{const le=k.headers[ne];return Array.isArray(le)?le[0]:le},V=!this.h.isBuilt&&this.h.args["use-test-resolver"],ie=V?"test+test":N("x-original-host")||N("x-forwarded-host")||k.headers.host;if(!ie)return o(k,C,400,"Bad request.");function ae(ne){return JSON.stringify(ne).replace(/"/g,"&quot;")}let te;this.h.args["enable-smoke-test-driver"]&&(te=!1);const ee=ne=>ne&&d.URI.file(I.resolve(ne)).with({scheme:l.Schemas.vscodeRemote,authority:ie}),K=l.$Ug.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,B=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,c.$Wg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,Z={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:ie,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const ne=JSON.parse((await j.Promises.readFile((0,m.$jc)(a,"product.overrides.json"))).toString());Object.assign(Z,ne)}catch{}const Y={remoteAuthority:ie,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:te,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:ee(this.h.args["default-folder"]),workspaceUri:ee(this.h.args["default-workspace"]),productConfiguration:Z,callbackRoute:this.c},M=this.k.extensionsGallery?.nlsBaseUrl,z={WORKBENCH_WEB_CONFIGURATION:ae(Y),WORKBENCH_AUTH_SESSION:B?ae(B):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:M?`${M}${M.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""};if(V){const ne=[];for(const le of["vscode-test-resolver","github-authentication"]){const F=JSON.parse((await j.Promises.readFile(l.$Ug.asFileUri(`${l.$Pg}/${le}/package.json`).fsPath)).toString());ne.push({extensionPath:le,packageJSON:F})}z.WORKBENCH_BUILTIN_EXTENSIONS=ae(ne)}let oe;try{oe=(await j.Promises.readFile(K)).toString().replace(/\{\{([^}]+)\}\}/g,(le,F)=>z[F]??"undefined")}catch{return C.writeHead(404,{"Content-Type":"text/plain"}),void C.end("Not found")}const H={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(oe).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${V?"":`http://${ie}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(H["Set-Cookie"]=S.serialize(l.$Lg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),C.writeHead(200,H),void C.end(oe)}p(k){const C=/<script>([\s\S]+?)<\/script>/img,A=[];let O;for(;O=C.exec(k);){const N=P.createHash("sha256"),V=O[1].replace(/\r\n/g,`
`),ie=N.update(Buffer.from(V)).digest().toString("base64");A.push(`'sha256-${ie}'`)}return A}async q(k){const C=l.$Ug.asFileUri("vs/code/browser/workbench/callback.html").fsPath,A=(await j.Promises.readFile(C)).toString(),O=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return k.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":O}),void k.end(A)}};e.$sQ=i,e.$sQ=i=Le([Oe(3,v.$en),Oe(4,w.$7j),Oe(5,h.$Tp),Oe(6,u.$nk)],i)}),define(ye[278],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=void 0,e.$8O=(0,s.$Ai)("IExtHostInitDataService")}),define(ye[279],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$RO=(0,s.$Ai)("IExtHostRpcService");class j{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.$SO=j}),define(ye[71],Ee([1,0,55]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=I;function j(D){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:D,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function I(D){return new s.$Cn(j(D))}}),define(ye[280],Ee([1,0,3,44,4,71,55,106,256,7,19]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;class w{static{this.a=1}constructor(m,l,c,u){this.b=m,this.c=l,this.d=c,this.e=u}async call(m,l,c){switch(l){case"getEnvironmentData":{const u=c,h=(0,D.$Hs)(u.remoteAuthority);let g=await this.f(u.profile);return g=(0,S.$En)(g,h),g}case"getExtensionHostExitInfo":{const u=c;return this.e.getExitInfo(u.reconnectionToken)}case"getDiagnosticInfo":{const u=c,h={machineInfo:(0,b.$Ls)()},g=u.includeProcesses?(0,P.$Js)(process.pid):Promise.resolve();let d=[];const E={};if(u.folders){const f=(0,D.$Hs)("");d=u.folders.map(o=>I.URI.revive(f.transformIncoming(o))).filter(o=>o.scheme==="file").map(o=>(0,b.$Ks)(o.fsPath,["node_modules",".git"]).then(r=>{E[(0,$.$nc)(o.fsPath)]=r}))}return Promise.all([g,...d]).then(([f,t])=>(h.processes=f||void 0,h.workspaceMetadata=u.folders?E:void 0,h))}}throw new Error(`IPC Command ${l} not found`)}listen(m,l,c){throw new Error("Not supported")}async f(m){m&&!this.d.profiles.some(c=>c.id===m)&&await this.d.createProfile(m,m);let l=!1;if(process.platform==="linux"){const c=process.glibcVersion;l=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:I.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$bh)(this.c.logsHome,`exthost${w.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:s.OS,arch:process.arch,marks:j.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:l}}}e.$Os=w}),define(ye[281],Ee([1,0,4,71,69,7,242]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class P extends S.$Ps{constructor(y,w){super(new I.$fr(y),y),this.N=w,this.M=new Map,this.B(this.a)}c(y){let w=this.M.get(y.remoteAuthority);return w||(w=(0,j.$Hs)(y.remoteAuthority),this.M.set(y.remoteAuthority,w)),w}f(y,w,v=!1){if(v&&w.path==="/vscode-resource"&&w.query){const m=JSON.parse(w.query).requestResourcePath;return s.URI.from({scheme:"file",path:m})}return s.URI.revive(y.transformIncoming(w))}L(y,w){return new b(y,w,this.b,this.N)}}e.$Rs=P;class b extends S.$Qs{constructor(y,w,v,m){super(y,w,v,m)}j(y){const w=y.args["file-watcher-polling"];if(w){const v=w.split(D.$tc),m=Number(v[0]);if(m>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:m}}}m(y){if(y.extensionsPath)return[D.$gc.join(y.extensionsPath,"**")]}}}),define(ye[95],Ee([1,0,219,10,4,2,5,36,16,13,39,172,63]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$YF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$OF=e.EditorInputCapabilities=e.$NF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0,e.$EF=c,e.$FF=u,e.$GF=h,e.$HF=g,e.$IF=d,e.$JF=E,e.$KF=f,e.$LF=t,e.$MF=o,e.$PF=k,e.$QF=A,e.$RF=O,e.$SF=N,e.$TF=V,e.$UF=ie,e.$VF=ae,e.$WF=te,e.$XF=M,e.$ZF=se,e.$1F=H,e.$2F=ne,e.$3F=le,e.$zF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$AF={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.$BF="workbench.editor.sidebysideEditor",e.$CF="workbench.editors.textDiffEditor",e.$DF="workbench.editors.binaryResourceDiffEditor";var m;(function(F){F[F.PROGRAMMATIC=1]="PROGRAMMATIC",F[F.USER=2]="USER",F[F.EDIT=3]="EDIT",F[F.NAVIGATION=4]="NAVIGATION",F[F.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var l;(function(F){F[F.IDENTICAL=1]="IDENTICAL",F[F.SIMILAR=2]="SIMILAR",F[F.DIFFERENT=3]="DIFFERENT"})(l||(e.EditorPaneSelectionCompareResult=l={}));function c(F){const U=F;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function u(F){const U=F;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function h(F,U,X){for(const x of X.visibleEditorPanes)if(x.group.id===U&&F.matches(x.input))return x.getViewState()}function g(F){if(k(F))return!1;const U=F;return I.URI.isUri(U?.resource)}function d(F){if(k(F))return!1;const U=F;return U?.original!==void 0&&U.modified!==void 0}function E(F){if(k(F))return!1;const U=F;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function f(F){if(k(F)||d(F))return!1;const U=F;return U?.primary!==void 0&&U.secondary!==void 0}function t(F){if(k(F))return!1;const U=F;return U?U.resource===void 0||U.resource.scheme===$.Schemas.untitled||U.forceUntitled===!0:!1}function o(F){if(k(F))return!1;const U=F;return I.URI.isUri(U?.base?.resource)&&I.URI.isUri(U?.input1?.resource)&&I.URI.isUri(U?.input2?.resource)&&I.URI.isUri(U?.result?.resource)}var r;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var n;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class a{constructor(){this.a=new Map}registerSource(U,X){let x=this.a.get(U);return x||(x={source:U,label:X},this.a.set(U,x)),x.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$NF=new a;var i;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription",F[F.CanDropIntoEditor=128]="CanDropIntoEditor",F[F.MultipleEditors=256]="MultipleEditors",F[F.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class p extends D.$Uc{}e.$OF=p;function k(F){return F instanceof p}function C(F){const U=F;return I.URI.isUri(U?.preferredResource)}function A(F){const U=F;return k(U?.primary)&&k(U?.secondary)}function O(F){const U=F;return k(U?.modified)&&k(U?.original)}function N(F,U,X,x,Q){return le(x,[(0,w.$kj)({id:"workbench.action.openLargeFile",label:(0,s.localize)(2,null),run:()=>{const G={...X,limits:{size:Number.MAX_VALUE}};F.openEditor(U,G)}}),(0,w.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(3,null),run:()=>Q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}function V(F){return k(F?.editor)}function ie(F){const U=F;return V(F)&&U?.group!==void 0}function ae(F){const U=F;return typeof U?.groupId=="number"&&k(U.editor)}function te(F){return typeof F?.groupId=="number"}var ee;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(ee||(e.EditorCloseContext=ee={}));var K;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LABEL=2]="GROUP_LABEL",F[F.GROUP_LOCKED=3]="GROUP_LOCKED",F[F.EDITOR_OPEN=4]="EDITOR_OPEN",F[F.EDITOR_CLOSE=5]="EDITOR_CLOSE",F[F.EDITOR_MOVE=6]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=8]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=10]="EDITOR_PIN",F[F.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",F[F.EDITOR_SELECTION=12]="EDITOR_SELECTION",F[F.EDITOR_STICKY=13]="EDITOR_STICKY",F[F.EDITOR_DIRTY=14]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(K||(e.GroupModelChangeKind=K={}));var B;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class Z{getOriginalUri(U,X){if(!U)return;if(o(U))return e.$YF.getOriginalUri(U.result,X);if(X?.supportSideBySide){const{primary:Q,secondary:G}=this.a(U);if(Q&&G){if(X?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===B.ANY)return this.getOriginalUri(Q,{filterByScheme:X.filterByScheme})??this.getOriginalUri(G,{filterByScheme:X.filterByScheme});U=X.supportSideBySide===B.PRIMARY?Q:G}}if(d(U)||E(U)||f(U)||o(U))return;const x=C(U)?U.preferredResource:U.resource;return!x||!X||!X.filterByScheme?x:this.b(x,X.filterByScheme)}a(U){return A(U)||f(U)?{primary:U.primary,secondary:U.secondary}:O(U)||d(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,X){if(!U)return;if(o(U))return e.$YF.getCanonicalUri(U.result,X);if(X?.supportSideBySide){const{primary:Q,secondary:G}=this.a(U);if(Q&&G){if(X?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===B.ANY)return this.getCanonicalUri(Q,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:X.filterByScheme});U=X.supportSideBySide===B.PRIMARY?Q:G}}if(d(U)||E(U)||f(U)||o(U))return;const x=U.resource;return!x||!X||!X.filterByScheme?x:this.b(x,X.filterByScheme)}b(U,X){if(Array.isArray(X)){if(X.some(x=>U.scheme===x))return U}else if(X===U.scheme)return U}}var Y;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.KEYBOARD=1]="KEYBOARD",F[F.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function M(F,U,X,x){if(!F.isSticky(U))return!1;switch(x.preventPinnedEditorClose){case"keyboardAndMouse":return X===Y.MOUSE||X===Y.KEYBOARD;case"mouse":return X===Y.MOUSE;case"keyboard":return X===Y.KEYBOARD}return!1}e.$YF=new Z;var z;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(z||(e.CloseDirection=z={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(U){const X=this.a=U.get(S.$zi);for(const[x,Q]of this.c)this.e(x,Q,X);this.c.clear()}e(U,X,x){const Q=x.createInstance(X);this.d.set(U,Q)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,j.$lg)(this.b)}registerEditorSerializer(U,X){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,X,this.a):this.c.set(U,X),(0,D.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}P.$ho.add(e.$zF.EditorFactory,new oe);async function se(F,U,X){return!F||!F.length?[]:await Promise.all(F.map(async x=>{const Q=I.URI.revive(x.fileUri);if(!Q){X.info("Cannot resolve the path because it is not valid.",x);return}if(!await U.canHandleResource(Q)){X.info("Cannot resolve the path because it cannot be handled",x);return}let J=x.exists,T=x.type;if(typeof J!="boolean"||typeof T!="number")try{T=(await U.stat(Q)).isDirectory?b.FileType.Directory:b.FileType.Unknown,J=!0}catch(ce){X.error(ce),J=!1}if(!J&&x.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",x);return}if(T===b.FileType.Directory){X.info("Cannot resolve the path because it is a directory",x);return}const W={...x.options,pinned:!0};return J?{resource:Q,options:W}:{resource:Q,options:W,forceUntitled:!0}}))}var _;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(_||(e.EditorsOrder=_={}));function H(F){const U=F;if(!U)return!1;const X=U;if(X.modified)return H(X.modified);const x=U;return!!(x.contributionsState&&x.viewState&&Array.isArray(x.cursorState))}function ne(F){return(0,y.$mj)(F)}function le(F,U,X){const x=(0,y.$nj)(F,U);return x.forceMessage=X?.forceMessage,x.forceSeverity=X?.forceSeverity,x.allowDialog=X?.allowDialog,x}}),define(ye[282],Ee([1,0,220,48]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0,e.$cG=new j.$Rj("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(0,null)}),e.$dG=new j.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(1,null)}),e.$eG=new j.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(2,null)}),e.$fG=new j.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(3,null)}),e.$gG=new j.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4,null)}),e.$hG=new j.$Rj("chatResponse",!1,{type:"boolean",description:(0,s.localize)(5,null)}),e.$iG=new j.$Rj("chatRequest",!1,{type:"boolean",description:(0,s.localize)(6,null)}),e.$jG=new j.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(7,null)}),e.$kG=new j.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(8,null)}),e.$lG=new j.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(9,null)}),e.$mG=new j.$Rj("inChatInput",!1,{type:"boolean",description:(0,s.localize)(10,null)}),e.$nG=new j.$Rj("inChat",!1,{type:"boolean",description:(0,s.localize)(11,null)}),e.$oG=new j.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(12,null)}),e.$pG=new j.$Rj("chatCursorAtTop",!1),e.$qG=new j.$Rj("chatInputHasAgent",!1),e.$rG=new j.$Rj("chatLocation",void 0)}),define(ye[283],Ee([1,0,14,20,6,41,2,46,157,17,48,5,12,30,42,131,282]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.ChatAgentLocation=void 0,e.$vH=t,e.$wH=o;var g;(function(r){r.Panel="panel",r.Terminal="terminal",r.Notebook="notebook",r.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(r){function n(a){switch(a){case"panel":return r.Panel;case"terminal":return r.Terminal;case"notebook":return r.Notebook;case"editor":return r.Editor}return r.Panel}r.fromRaw=n}(g||(e.ChatAgentLocation=g={})),e.$qH=(0,w.$Ai)("chatAgentService");let d=class{static{this.AGENT_LEADER="@"}constructor(n){this.f=n,this.b=[],this.d=new I.$he,this.onDidChangeAgents=this.d.event,this.e=u.$oG.bindTo(this.f)}registerAgent(n,a){if(this.getAgent(n))throw new Error(`Agent already registered: ${JSON.stringify(n)}`);const p=this,k=a.slashCommands;a={...a,get slashCommands(){return k.filter(A=>!A.when||p.f.contextMatchesRules(y.$yj.deserialize(A.when)))}};const C={data:a};return this.b.push(C),(0,S.$Sc)(()=>{this.b=this.b.filter(A=>A!==C),this.d.fire(void 0)})}registerAgentImplementation(n,a){const i=this.g(n);if(!i)throw new Error(`Unknown agent: ${JSON.stringify(n)}`);if(i.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(n)}`);return i.data.isDefault&&this.e.set(!0),i.impl=a,this.d.fire(new E(i.data,a)),(0,S.$Sc)(()=>{i.impl=void 0,this.d.fire(void 0),i.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(n,a){n.isDynamic=!0;const i={data:n,impl:a};return this.b.push(i),this.d.fire(new E(n,a)),(0,S.$Sc)(()=>{this.b=this.b.filter(p=>p!==i),this.d.fire(void 0)})}updateAgent(n,a){const i=this.g(n);if(!i?.impl)throw new Error(`No activated agent with id ${JSON.stringify(n)} registered`);i.data.metadata={...i.data.metadata,...a},this.d.fire(new E(i.data,i.impl))}getDefaultAgent(n){return this.getActivatedAgents().find(a=>!!a.isDefault&&a.locations.includes(n))}getContributedDefaultAgent(n){return this.getAgents().find(a=>!!a.isDefault&&a.locations.includes(n))}getSecondaryAgent(){return D.Iterable.find(this.b.values(),n=>!!n.data.metadata.isSecondary)?.data}g(n){return this.b.find(a=>a.data.id===n)}getAgent(n){return this.g(n)?.data}getAgentByFullyQualifiedId(n){return this.b.find(a=>t(a.data)===n)?.data}getAgents(){return this.b.map(n=>n.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(n=>!!n.impl).map(n=>new E(n.data,n.impl))}getAgentsByName(n){return this.getAgents().filter(a=>a.name===n)}async invokeAgent(n,a,i,p,k){const C=this.g(n);if(!C?.impl)throw new Error(`No activated agent with id ${n}`);return await C.impl.invoke(a,i,p,k)}async getFollowups(n,a,i,p,k){const C=this.g(n);if(!C?.impl)throw new Error(`No activated agent with id ${n}`);return C.impl?.provideFollowups?C.impl.provideFollowups(a,i,p,k):[]}};e.$rH=d,e.$rH=d=Le([Oe(0,y.$Sj)],d);class E{constructor(n,a){this.b=n,this.d=a}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(n,a,i,p){return this.d.invoke(n,a,i,p)}async provideFollowups(n,a,i,p){return this.d.provideFollowups?this.d.provideFollowups(n,a,i,p):[]}provideWelcomeMessage(n,a){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(n,a)}provideSampleQuestions(n,a){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(n,a)}}e.$sH=E,e.$tH=(0,w.$Ai)("chatAgentNameService");let f=class{static{h=this}static{this.b="chat.participantNameRegistry"}constructor(n,a,i,p){if(this.g=a,this.h=i,this.i=p,this.e=(0,b.$3d)(this,Object.create(null)),this.f=!1,!n.chatParticipantRegistry)return;this.d=n.chatParticipantRegistry;const k=p.get(h.b,-1);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{p.remove(h.b,-1)}this.j()}j(){this.f||this.k().catch(n=>this.h.warn("Failed to fetch chat participant registry",n)).then(()=>(0,s.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const n=await this.g.request({type:"GET",url:this.d},j.CancellationToken.None);if(n.res.statusCode!==200)throw new Error("Could not get extensions report.");const a=await(0,l.$Zp)(n);if(!a||a.version!==1)throw new Error("Unexpected chat participant registry response.");const i=a.restrictedChatParticipants;this.e.set(i,void 0),this.i.store(h.b,JSON.stringify(i),-1,1)}getAgentNameRestriction(n){const a=this.l(n.name,n).get(),i=!n.fullName||this.l(n.fullName.replace(/\s/g,""),n).get();return a&&i}l(n,a){return this.e.map(p=>p[n.toLowerCase()]).map(p=>p?p.some(k=>(0,$.$Bf)(k,k.includes(".")?a.extensionId.value:a.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$uH=f,e.$uH=f=h=Le([Oe(0,m.$nk),Oe(1,l.$Tp),Oe(2,v.$7j),Oe(3,c.$7p)],f);function t(r){return`${r.extensionId.value}.${r.id}`}function o(r){const n="name"in r?r:{...r,name:r.id};return"extensionPublisherId"in n||(n.extensionPublisherId=n.extensionPublisher??""),"extensionDisplayName"in n||(n.extensionDisplayName=""),(0,P.$0h)(n)}}),define(ye[284],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=void 0,e.$iP=(0,s.$Ai)("environmentVariableService")}),define(ye[285],Ee([1,0,7,4,66,3,126,10]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=b,e.$NP=y,e.$OP=m,e.$PP=l,e.$QP=c,e.$RP=h,e.$SP=g,e.$TP=d,e.$UP=E;function b(f,t){if(t)if(D.$i)for(const o in t){let r=o;for(const a in f)if(o.toLowerCase()===a.toLowerCase()){r=a;break}const n=t[o];n!==void 0&&$(f,r,n)}else Object.keys(t).forEach(o=>{const r=t[o];r!==void 0&&$(f,o,r)})}function $(f,t,o){typeof o=="string"?f[t]=o:delete f[t]}function y(f,t,o,r){f.TERM_PROGRAM="vscode",t&&(f.TERM_PROGRAM_VERSION=t),m(f,r)&&(f.LANG=l(o)),f.COLORTERM="truecolor"}function w(f,t){if(t)for(const o of Object.keys(t)){const r=t[o];r!=null&&(f[o]=r)}}async function v(f,t){return await Promise.all(Object.entries(t).map(async([o,r])=>{if(typeof r=="string")try{t[o]=await f(r)}catch{t[o]=r}})),t}function m(f,t){if(t==="on")return!0;if(t==="auto"){const o=f.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}function l(f){const t=f?f.split("-"):[],o=t.length;if(o===0)return"en_US.UTF-8";if(o===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}async function c(f,t,o,r,n,a){if(f.cwd){const p=typeof f.cwd=="object"?f.cwd.fsPath:f.cwd,k=await u(p,o);return(0,S.$JP)(k||p)}let i;return!f.ignoreConfigurationCwd&&n&&(o&&(n=await u(n,o,a)),n&&(s.$ic(n)?i=n:r&&(i=s.$jc(r.fsPath,n)))),i||(i=r?r.fsPath:t||""),(0,S.$JP)(i)}async function u(f,t,o){if(t)try{return await t(f)}catch(r){o?.error("Could not resolve terminal cwd",r);return}return f}function h(f,t,o){if(o)return r=>o.resolveWithEnvironment(t,f,r)}async function g(f,t,o,r,n,a){const i={};if(f.strictEnv)w(i,f.env);else{w(i,a);const p={...t};o&&(p&&await v(o,p),f.env&&await v(o,f.env)),D.$j&&(i.VSCODE_NODE_OPTIONS&&(i.NODE_OPTIONS=i.VSCODE_NODE_OPTIONS,delete i.VSCODE_NODE_OPTIONS),i.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(i.NODE_REPL_EXTERNAL_MODULE=i.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete i.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,I.$qm)(i,"VSCODE_IPC_HOOK_CLI"),b(i,p),b(i,f.env),y(i,r,D.$w,n)}return i}async function d(f,t,o,r,n,a,i=D.$i){let p;if((0,P.$ag)(f)?p=f:(p=f.fsPath,i&&a!==1?p=p.replace(/\\/g,"/"):!i&&a===1&&(p=p.replace(/\//g,"\\"))),!t)return p;const k=p.includes(" "),C=p.includes("(")||p.includes(")"),A=s.$nc(t,".exe"),O=A==="pwsh"||o==="pwsh"||A==="powershell"||o==="powershell";if(O&&(k||p.includes("'")))return`& '${p.replace(/'/g,"''")}'`;if(C&&O)return`& '${p}'`;if(a===1){if(r!==void 0)return r==="gitbash"?(0,S.$HP)(p.replace(/\\/g,"/")):r==="wsl"?n?.getWslPath(p,"win-to-unix")||p:k?`"${p}"`:p;const N=t.toLowerCase();return N.includes("wsl")||N.includes("bash.exe")&&!N.toLowerCase().includes("git")?n?.getWslPath(p,"win-to-unix")||p:k?`"${p}"`:p}return(0,S.$HP)(p)}function E(f,t,o){const r=typeof f=="string"?j.URI.parse(f):f;let n=r?t.getWorkspaceFolder(r)??void 0:void 0;if(!n){const a=o.getLastActiveWorkspaceRoot();n=a?t.getWorkspaceFolder(a)??void 0:void 0}return n}}),define(ye[72],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(D){D.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var j;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(j||(e.TestPosition=j={}));class I{static fromExtHostTestItem(S,P,b=S.parent){if(S._isRoot)return new I([P]);const $=[S.id];for(let y=b;y&&y.id!==P;y=y.parent)$.push(y.id);return $.push(P),new I($.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const P=S.indexOf("\0");return P===-1?S:S.slice(0,P)}static fromString(S){return new I(S.split("\0"))}static join(S,P){return new I([...S.path,P])}static joinToString(S,P){return S.toString()+"\0"+P}static parentId(S){const P=S.lastIndexOf("\0");return P===-1?void 0:S.slice(0,P)}static localId(S){const P=S.lastIndexOf("\0");return P===-1?S:S.slice(P+1)}static isChild(S,P){return P.startsWith(S)&&P[S.length]==="\0"}static compare(S,P){return S===P?0:I.isChild(S,P)?2:I.isChild(P,S)?3:1}static getLengthOfCommonPrefix(S,P){if(S===0)return 0;let b=0;for(;b<S-1;){for(let $=1;$<S;$++){const y=P($-1),w=P($);if(y.path[b]!==w.path[b])return b}b++}return b}constructor(S,P=S.length){if(this.path=S,this.d=P,S.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new I(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new I(this.path,S)}compare(S){if(typeof S=="string")return I.compare(this.toString(),S);for(let P=0;P<S.d&&P<this.d;P++)if(S.path[P]!==this.path[P])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.$_K=I}),define(ye[96],Ee([1,0,4,79,45,72]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$hL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$gL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$fL=e.$eL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$dL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$cL=e.$bL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$aL=e.TestResultState=void 0;var S;(function(ee){ee[ee.Unset=0]="Unset",ee[ee.Queued=1]="Queued",ee[ee.Running=2]="Running",ee[ee.Passed=3]="Passed",ee[ee.Failed=4]="Failed",ee[ee.Skipped=5]="Skipped",ee[ee.Errored=6]="Errored"})(S||(e.TestResultState=S={})),e.$aL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var P;(function(ee){ee[ee.Run=1]="Run",ee[ee.Debug=2]="Debug",ee[ee.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var b;(function(ee){ee[ee.Run=2]="Run",ee[ee.Debug=4]="Debug",ee[ee.Coverage=8]="Coverage",ee[ee.HasNonDefaultProfile=16]="HasNonDefaultProfile",ee[ee.HasConfigurable=32]="HasConfigurable",ee[ee.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$bL=[2,4,8,16,32,64];const $=ee=>"runId"in ee;e.$cL=$;var y;(function(ee){ee.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),ee.deserialize=(K,B)=>({range:I.$At.lift(B.range),uri:K.asCanonicalUri(s.URI.revive(B.uri))})})(y||(e.IRichLocation=y={}));var w;(function(ee){ee[ee.Error=0]="Error",ee[ee.Output=1]="Output"})(w||(e.TestMessageType=w={}));var v;(function(ee){ee.serialize=K=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&y.serialize(K.location)}),ee.deserialize=(K,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&y.deserialize(K,B.location)})})(v||(e.ITestErrorMessage=v={}));const m=(ee,K)=>`${K?"s":"e"}${ee}`;e.$dL=m;var l;(function(ee){ee.serialize=K=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&y.serialize(K.location)}),ee.deserialize=(K,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&y.deserialize(K,B.location)})})(l||(e.ITestOutputMessage=l={}));var c;(function(ee){ee.serialize=K=>K.type===0?v.serialize(K):l.serialize(K),ee.deserialize=(K,B)=>B.type===0?v.deserialize(K,B):l.deserialize(K,B)})(c||(e.ITestMessage=c={}));var u;(function(ee){ee.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),ee.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(c.serialize)}),ee.deserialize=(K,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(Z=>c.deserialize(K,Z))})})(u||(e.ITestTaskState=u={}));const h="\0",g=(ee,K)=>ee+h+K;e.$eL=g;const d=ee=>{const K=ee.indexOf(h);return{ctrlId:ee.slice(0,K),tagId:ee.slice(K+1)}};e.$fL=d;var E;(function(ee){ee.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),ee.deserialize=(K,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?K.asCanonicalUri(s.URI.revive(B.uri)):void 0,range:B.range?I.$At.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(E||(e.ITestItem=E={}));var f;(function(ee){ee[ee.NotExpandable=0]="NotExpandable",ee[ee.Expandable=1]="Expandable",ee[ee.BusyExpanding=2]="BusyExpanding",ee[ee.Expanded=3]="Expanded"})(f||(e.TestItemExpandState=f={}));var t;(function(ee){ee.serialize=K=>({expand:K.expand,item:E.serialize(K.item)}),ee.deserialize=(K,B)=>({controllerId:D.$_K.root(B.item.extId),expand:B.expand,item:E.deserialize(K,B.item)})})(t||(e.InternalTestItem=t={}));var o;(function(ee){ee.serialize=K=>{let B;return K.item&&(B={},K.item.label!==void 0&&(B.label=K.item.label),K.item.tags!==void 0&&(B.tags=K.item.tags),K.item.busy!==void 0&&(B.busy=K.item.busy),K.item.uri!==void 0&&(B.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(B.range=K.item.range?.toJSON()),K.item.description!==void 0&&(B.description=K.item.description),K.item.error!==void 0&&(B.error=K.item.error),K.item.sortText!==void 0&&(B.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:B}},ee.deserialize=K=>{let B;return K.item&&(B={},K.item.label!==void 0&&(B.label=K.item.label),K.item.tags!==void 0&&(B.tags=K.item.tags),K.item.busy!==void 0&&(B.busy=K.item.busy),K.item.range!==void 0&&(B.range=K.item.range?I.$At.lift(K.item.range):null),K.item.description!==void 0&&(B.description=K.item.description),K.item.error!==void 0&&(B.error=K.item.error),K.item.sortText!==void 0&&(B.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:B}}})(o||(e.ITestItemUpdate=o={}));const r=(ee,K)=>{K.expand!==void 0&&(ee.expand=K.expand),K.item!==void 0&&(ee.item=ee.item?Object.assign(ee.item,K.item):K.item)};e.$gL=r;var n;(function(ee){ee.serializeWithoutMessages=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(u.serializeWithoutMessages)}),ee.serialize=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(u.serialize)}),ee.deserialize=(K,B)=>({...t.deserialize(K,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(Z=>u.deserialize(K,Z)),retired:!0})})(n||(e.TestResultItem=n={}));var a;(function(ee){ee.empty=()=>({covered:0,total:0}),ee.sum=(K,B)=>{K.covered+=B.covered,K.total+=B.total}})(a||(e.ICoverageCount=a={}));var i;(function(ee){ee.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testId:K.testId?.toString(),uri:K.uri.toJSON()}),ee.deserialize=(K,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testId:B.testId?D.$_K.fromString(B.testId):void 0,uri:K.asCanonicalUri(s.URI.revive(B.uri))}),ee.empty=(K,B)=>({id:K,uri:B,testId:void 0,statement:a.empty()})})(i||(e.IFileCoverage=i={}));function p(ee){return{...ee,location:ee.location?.toJSON()}}function k(ee){return ee.location=ee.location?j.$zt.isIPosition(ee.location)?j.$zt.lift(ee.location):I.$At.lift(ee.location):void 0,ee}e.$hL=3;var C;(function(ee){ee[ee.Declaration=0]="Declaration",ee[ee.Statement=1]="Statement",ee[ee.Branch=2]="Branch"})(C||(e.DetailType=C={}));var A;(function(ee){ee.serialize=K=>K.type===0?N.serialize(K):V.serialize(K),ee.deserialize=K=>K.type===0?N.deserialize(K):V.deserialize(K)})(A||(e.CoverageDetails=A={}));var O;(function(ee){ee.serialize=p,ee.deserialize=k})(O||(e.IBranchCoverage=O={}));var N;(function(ee){ee.serialize=p,ee.deserialize=k})(N||(e.IDeclarationCoverage=N={}));var V;(function(ee){ee.serialize=K=>({...p(K),branches:K.branches?.map(O.serialize)}),ee.deserialize=K=>({...k(K),branches:K.branches?.map(O.deserialize)})})(V||(e.IStatementCoverage=V={}));var ie;(function(ee){ee[ee.Add=0]="Add",ee[ee.Update=1]="Update",ee[ee.DocumentSynced=2]="DocumentSynced",ee[ee.Remove=3]="Remove",ee[ee.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ee[ee.Retire=5]="Retire",ee[ee.AddTag=6]="AddTag",ee[ee.RemoveTag=7]="RemoveTag"})(ie||(e.TestDiffOpType=ie={}));var ae;(function(ee){ee.deserialize=(K,B)=>B.op===0?{op:B.op,item:t.deserialize(K,B.item)}:B.op===1?{op:B.op,item:o.deserialize(B.item)}:B.op===2?{op:B.op,uri:K.asCanonicalUri(s.URI.revive(B.uri)),docv:B.docv}:B,ee.serialize=K=>K.op===0?{op:K.op,item:t.serialize(K.item)}:K.op===1?{op:K.op,item:o.serialize(K.item)}:K})(ae||(e.TestsDiffOp=ae={}));class te{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const B=this.v();for(const Z of K)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),B);break;case 1:this.o(o.deserialize(Z.item),B);break;case 3:this.p(Z.itemId,B);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}B.complete?.()}l(K,B){const Z=D.$_K.parentId(K.item.extId)?.toString();let Y;if(!Z)Y=this.w(K),this.g.add(Y),this.f.set(K.item.extId,Y);else if(this.f.has(Z)){const M=this.f.get(Z);M.children.add(K.item.extId),Y=this.w(K,M),this.f.set(K.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return B.add?.(Y),K.expand===2&&this.h++,Y}o(K,B){const Z=this.f.get(K.extId);if(Z)return K.expand!==void 0&&(Z.expand===2&&this.h--,K.expand===2&&this.h++),(0,e.$gL)(Z,K),B.update?.(Z),Z}p(K,B){const Z=this.f.get(K);if(!Z)return;const Y=D.$_K.parentId(Z.item.extId)?.toString();Y?this.f.get(Y).children.delete(Z.item.extId):this.g.delete(Z);const M=[[K]];for(;M.length;)for(const z of M.pop()){const oe=this.f.get(z);oe&&(M.push(oe.children),this.f.delete(z),B.remove?.(oe,oe!==Z),oe.expand===2&&this.h--)}}q(K){}updatePendingRoots(K){this.j+=K}v(){return{}}}e.$iL=te}),define(ye[137],Ee([1,0,14,6,2,98,96,72]),function(fe,e,s,j,I,D,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TestItemEventOp=void 0;var b;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const $=(g,d)=>g===d,w=Object.entries({range:(g,d)=>g===d?!0:!g||!d?!1:g.equalsRange(d),busy:$,label:$,description:$,error:$,sortText:$,tags:(g,d)=>!(g.length!==d.length||g.some(E=>!d.includes(E)))}),v=(g,d)=>{let E;for(const[f,t]of w)t(g[f],d[f])||(E?E[f]=d[f]:E={[f]:d[f]});return E};class m extends I.$Uc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new s.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new j.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(d){this.h=d;for(const E of this.tree.values())this.J(E)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===d.uri){E.docv=d.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===d.item.extId){(0,S.$gL)(E.item,d.item);return}if(E.op===0&&E.item.item.extId===d.item.extId){(0,S.$gL)(E.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,E){const f=this.tree.get(d);if(f){if((f.expandLevels===void 0||E>f.expandLevels)&&(f.expandLevels=E),f.expand===1){const t=this.M(f);return t.isOpen()?this.L(f,E-1):t.wait().then(()=>this.L(f,E-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.L(f,E-1)):this.L(f,E-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(d,E){switch(E.op){case 3:this.O(P.$_K.joinToString(d.fullId,E.id));break;case 0:this.z(E.item,d);break;case 5:for(const f of E.ops)this.w(d,f);break;case 1:this.C(E.new,E.old,d.fullId.toString());break;case 2:this.J(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:E.update}});break;case 6:this.y(d.actual.uri);break;default:(0,D.$ed)(E)}}y(d){d&&this.pushDiff({op:2,uri:d,docv:this.s.getDocumentVersion(d)})}z(d,E){const f=P.$_K.fromExtHostTestItem(d,this.root.id,E?.actual),t=this.s.getApiFor(d);t.parent&&t.parent!==E?.actual&&this.s.getChildren(t.parent).delete(d.id);let o=this.tree.get(f.toString());if(!o){o={fullId:f,actual:d,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},d.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G(d,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(d)}}),this.I(d,o,E);return}if(o.actual===d){this.H(d,o,E);return}if(o.actual.uri?.toString()!==d.uri?.toString())return this.O(f.toString()),this.z(d,E);const r=this.s.getChildren(o.actual),n=o.actual,a=v(this.s.toITestItem(n),this.s.toITestItem(d));this.s.getApiFor(n).listener=void 0,o.actual=d,o.resolveBarrier=void 0,o.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(d.tags,n.tags,f.toString()),delete a.tags),this.w(o,{op:4,update:a})),this.I(d,o,E);for(const[p,k]of r)this.s.getChildren(d).get(k.id)||this.O(P.$_K.joinToString(f,k.id));const i=o.expandLevels;i!==void 0&&queueMicrotask(()=>{o.expand===1&&(o.expandLevels=void 0,this.expand(f.toString(),i))}),this.y(o.actual.uri)}C(d,E,f){const t=new Set(E.map(o=>o.id));for(const o of d)t.delete(o.id)||this.D(o);this.pushDiff({op:1,item:{extId:f,item:{tags:d.map(o=>(0,S.$eL)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D(d){const E=this.j.get(d.id);E?E.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.$eL)(this.s.controllerId,d.id)}}))}F(d){const E=this.j.get(d);E&&!--E.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,S.$eL)(this.s.controllerId,d)}))}G(d,E){this.s.getApiFor(d).parent=E&&E.actual!==this.root?E.actual:void 0}H(d,E,f){this.G(d,f);const t=this.s.getApiFor(d);t.parent=f?.actual,t.listener=o=>this.w(E,o),this.J(E)}I(d,E,f){this.H(d,E,f);for(const[t,o]of this.s.getChildren(d))this.z(o,E)}J(d){let E;this.h?d.resolveBarrier?E=d.resolveBarrier.isOpen()?3:2:E=d.actual.canResolveChildren?1:0:E=0,E!==d.expand&&(d.expand=E,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:E}}),E===1&&d.expandLevels!==void 0&&this.M(d))}L(d,E){if(E<0)return;const f=[];for(const[t,o]of this.s.getChildren(d.actual)){const r=this.expand(P.$_K.joinToString(d.fullId,o.id),E);(0,s.$mh)(r)&&f.push(r)}if(f.length)return Promise.all(f).then(()=>{})}M(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const o=new s.$zh;return o.open(),o}d.expand=2,this.N(d);const E=d.resolveBarrier=new s.$zh,f=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(o){f(o)}return(0,s.$mh)(t)?t.catch(f).then(()=>{E.open(),this.J(d)}):(E.open(),this.J(d)),d.resolveBarrier}N(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}O(d){const E=this.tree.get(d);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const f=[E];for(;f.length;){const t=f.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,r]of this.s.getChildren(t.actual))f.push(this.tree.get(P.$_K.joinToString(t.fullId,r.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$HO=m;class l extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$IO=l;class c extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JO=c;class u extends Error{constructor(d,E,f){super(`TestItem with ID "${d}" is from controller "${E}" and cannot be added as a child of an item from controller "${f}".`)}}e.$KO=u;const h=(g,d,E)=>{let f=new Map;return{get size(){return f.size},forEach(t,o){for(const r of f.values())t.call(o,r,this)},[Symbol.iterator](){return f.entries()},replace(t){const o=new Map,r=new Set(f.keys()),n={op:5,ops:[]};for(const a of t){if(!(a instanceof E))throw new c(a.id);const i=d(a).controllerId;if(i!==g.controllerId)throw new u(a.id,i,g.controllerId);if(o.has(a.id))throw new l(a.id);o.set(a.id,a),r.delete(a.id),n.ops.push({op:0,item:a})}for(const a of r.keys())n.ops.push({op:3,id:a});g.listener?.(n),f=o},add(t){if(!(t instanceof E))throw new c(t.id);f.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){f.delete(t)&&g.listener?.({op:3,id:t})},get(t){return f.get(t)},toJSON(){return Array.from(f.values())}}};e.$LO=h}),define(ye[138],Ee([1,0,137]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;const j=new WeakMap,I=(S,P)=>{const b={controllerId:P};return j.set(S,b),b};e.$MO=I;const D=S=>{const P=j.get(S);if(!P)throw new s.$JO(S?.id||"<unknown>");return P};e.$NO=D}),define(ye[286],Ee([1,0,25,5]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0,e.$VE=".vscode",e.$WE="settings",e.$XE=`${e.$VE}/${e.$WE}.json`,e.$YE="vscode://schemas/settings/default",e.$ZE="vscode://schemas/settings/user",e.$1E="vscode://schemas/settings/profile",e.$2E="vscode://schemas/settings/machine",e.$3E="vscode://schemas/settings/workspace",e.$4E="vscode://schemas/settings/folder",e.$5E="vscode://schemas/launch",e.$6E="vscode://schemas/tasks",e.$7E=[1],e.$8E=[2,3,4,5,6],e.$9E=[3,4,5],e.$0E=[1,...e.$9E],e.$$E=[2,3,4,5,6],e.$_E=[3,4,5,6],e.$aF=[4,5,6],e.$bF="tasks",e.$cF="launch",e.$dF=Object.create(null),e.$dF[e.$bF]=`${e.$VE}/${e.$bF}.json`,e.$dF[e.$cF]=`${e.$VE}/${e.$cF}.json`,e.$eF=Object.create(null),e.$eF[e.$bF]=`${e.$bF}.json`,e.$fF=(0,j.$Bi)(s.$7i),e.$gF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$hF="workbench.settings.applyToAllProfiles"}),define(ye[139],Ee([1,0,5]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.VariableKind=e.$FP=void 0,e.$FP=(0,s.$Ai)("configurationResolverService");var j;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(j||(e.VariableKind=j={}));class I extends Error{constructor(S,P){super(P),this.variable=S}}e.$GP=I}),define(ye[287],Ee([1,0,7,32,10,21,3,181,221,139,17]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(m,l,c,u){this.h=new Map,this.a=m,this.b=l,this.g=c,u&&(this.c=u.then(h=>this.i(h)))}i(m){if(S.$i){const l=Object.create(null);return Object.keys(m).forEach(c=>{l[c.toLowerCase()]=m[c]}),l}return m}resolveWithEnvironment(m,l,c){return this.l({env:this.i(m),userHome:void 0},l?l.uri:void 0,c)}async resolveAsync(m,l){const c={env:await this.c,userHome:await this.g};return this.l(c,m?m.uri:void 0,l)}async j(m,l,c,u){const h=D.$7n(l);S.$i&&h.windows?Object.keys(h.windows).forEach(d=>h[d]=h.windows[d]):S.$j&&h.osx?Object.keys(h.osx).forEach(d=>h[d]=h.osx[d]):S.$k&&h.linux&&Object.keys(h.linux).forEach(d=>h[d]=h.linux[d]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,m?m.uri:void 0,h,c,u)}async resolveAnyAsync(m,l,c){return this.j(m,l,c)}async resolveAnyMap(m,l,c){const u=new Map;return{newConfig:await this.j(m,l,c,u),resolvedVariables:u}}resolveWithInteractionReplace(m,l,c,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,l,c,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,l){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,l)}async l(m,l,c,u,h){if(I.$ag(c))return this.m(m,l,c,u,h);if(Array.isArray(c))return Promise.all(c.map(g=>this.l(m,l,g,u,h)));if(I.$cg(c)){const g=Object.create(null),d=await Promise.all(Object.keys(c).map(async E=>[await this.m(m,l,E,u,h),await this.l(m,l,c[E],u,h)]));for(const[E,f]of d)g[E]=f;return g}return c}m(m,l,c,u,h){return(0,y.$tf)(c,w.VARIABLE_REGEXP,async(g,d)=>{if(d.includes(w.VARIABLE_LHS))return g;let E=await this.o(m,g,d,l,u);return h?.set(d,E),E!==g&&I.$ag(E)&&E.match(w.VARIABLE_REGEXP)&&(E=await this.m(m,l,E,u,h)),E})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,l,c,u,h){let g;const d=c.split(":");d.length>1&&(c=d[0],g=d[1]);const E=o=>{const r=this.a.getFilePath();if(r)return(0,P.$Kw)(r);throw new $.$GP(o,(0,b.localize)(0,null,l))},f=o=>{const r=E(o);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,P.$Kw)(n)}throw new $.$GP(o,(0,b.localize)(1,null,l,s.$nc(r)))},t=o=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new $.$GP(o,(0,b.localize)(2,null,l,g))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new $.$GP(o,(0,b.localize)(3,null,l)):new $.$GP(o,(0,b.localize)(4,null,l))};switch(c){case"env":if(g){if(m.env){const o=m.env[S.$i?g.toLowerCase():g];if(I.$ag(o))return o}return""}throw new $.$GP($.VariableKind.Env,(0,b.localize)(5,null,l));case"config":if(g){const o=this.a.getConfigurationValue(u,g);if(I.$jg(o))throw new $.$GP($.VariableKind.Config,(0,b.localize)(6,null,l,g));if(I.$cg(o))throw new $.$GP($.VariableKind.Config,(0,b.localize)(7,null,l,g));return o}throw new $.$GP($.VariableKind.Config,(0,b.localize)(8,null,l));case"command":return this.p($.VariableKind.Command,l,g,h,"command");case"input":return this.p($.VariableKind.Input,l,g,h,"input");case"extensionInstallFolder":if(g){const o=await this.a.getExtension(g);if(!o)throw new $.$GP($.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,l,g));return this.n(o.extensionLocation)}throw new $.$GP($.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,l));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,P.$Kw)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return u||g?(0,P.$Kw)(this.n(t($.VariableKind.Cwd))):j.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$Kw)(s.$nc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new $.$GP($.VariableKind.UserHome,(0,b.localize)(11,null,l))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new $.$GP($.VariableKind.LineNumber,(0,b.localize)(12,null,l))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new $.$GP($.VariableKind.SelectedText,(0,b.localize)(13,null,l))}case"file":return E($.VariableKind.File);case"fileWorkspaceFolder":return f($.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.$nc(f($.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||g?s.$lc(this.n(t($.VariableKind.RelativeFile)),E($.VariableKind.RelativeFile)):E($.VariableKind.RelativeFile);case"relativeFileDirname":{const o=s.$mc(E($.VariableKind.RelativeFileDirname));if(u||g){const r=s.$lc(this.n(t($.VariableKind.RelativeFileDirname)),o);return r.length===0?".":r}return o}case"fileDirname":return s.$mc(E($.VariableKind.FileDirname));case"fileExtname":return s.$oc(E($.VariableKind.FileExtname));case"fileBasename":return s.$nc(E($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=s.$nc(E($.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-s.$oc(o).length)}case"fileDirnameBasename":return s.$nc(s.$mc(E($.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||l}case"execInstallFolder":{const o=this.a.getAppRoot();return o||l}case"pathSeparator":case"/":return s.sep;default:try{const o=g?`${c}:${g}`:c;return this.p($.VariableKind.Unknown,l,o,h,void 0)}catch{return l}}}}p(m,l,c,u,h){if(c&&u){const g=h===void 0?u[c]:u[h+":"+c];if(typeof g=="string")return g;throw new $.$GP(m,(0,b.localize)(14,null,l))}return l}}e.$VP=w}),define(ye[288],Ee([1,0,5,95]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$5D=void 0,e.$6D=$,e.$7D=v,e.$8D=m,e.$5D=(0,s.$Ai)("editorGroupsService");var I;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var D;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(D||(e.GroupOrientation=D={}));var S;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(S||(e.GroupLocation=S={}));var P;(function(l){l[l.MAXIMIZE=0]="MAXIMIZE",l[l.EXPAND=1]="EXPAND",l[l.EVEN=2]="EVEN"})(P||(e.GroupsArrangement=P={}));var b;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function $(l){const c=l;return(0,j.$PF)(c?.editor)&&(0,j.$PF)(c?.replacement)}var y;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y||(e.GroupsOrder=y={}));var w;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function v(l){const c=l;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function m(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ye[140],Ee([1,0,5,288]),function(fe,e,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=I,e.$9D=(0,s.$Ai)("editorService"),e.$0D=-1,e.$$D=-2,e.$_D=-3;function I(D){const S=D;return typeof D=="number"||(0,j.$7D)(S)}}),define(ye[289],Ee([1,0,286,120,93,91,139,95,140,13,240,284,92]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=e.$XP=void 0,e.$XP="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,u,h,g,d,E,f,t,o,r){this.a=c,this.b=u,this.c=h,this.d=g,this.e=d,this.f=E,this.g=f,this.h=t,this.i=o,this.j=r}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,u,h,g,d,E,f,t){await this.c.whenRemoteConfigurationLoaded();const o=Object.create(null),r=h?this.d.getWorkspaceFolder(h)??void 0:void 0;let n;try{n=(await this.e.resolveAnyMap(r,{shellLaunchConfig:c,configuration:u})).resolvedVariables}catch(V){this.h.error(V)}if(n)for(const[V,ie]of n.entries())(/^config:/.test(V)||V==="selectedText"||V==="lineNumber")&&(o[V]=ie);const a=[];for(const[V,ie]of this.f.collections.entries())a.push([V,(0,D.$rs)(ie.map),(0,D.$ss)(ie.descriptionMap)]);const i=await this.g.resolveAuthority(this.a),p=i.options&&i.options.extensionHostEnv,k=this.d.getWorkspace(),C=k.folders,A=h?this.d.getWorkspaceFolder(h):null,O=P.$YF.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),N={configuration:u,resolvedVariables:o,envVariableCollections:a,shellLaunchConfig:c,workspaceId:k.id,workspaceName:this.j.getWorkspaceLabel(k),workspaceFolders:C,activeWorkspaceFolder:A,activeFileResource:O,shouldPersistTerminal:d,options:g,cols:E,rows:f,unicodeVersion:t,resolverEnv:p};return await this.b.call("$createProcess",N)}requestDetachInstance(c,u){return this.b.call("$requestDetachInstance",[c,u])}acceptDetachInstanceReply(c,u){return this.b.call("$acceptDetachInstanceReply",[c,u])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,u){return this.b.call("$detachFromProcess",[c,u])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,u){return this.b.call("$processBinary",[c,u])}start(c){return this.b.call("$start",[c])}input(c,u){return this.b.call("$input",[c,u])}acknowledgeDataEvent(c,u){return this.b.call("$acknowledgeDataEvent",[c,u])}setUnicodeVersion(c,u){return this.b.call("$setUnicodeVersion",[c,u])}shutdown(c,u){return this.b.call("$shutdown",[c,u])}resize(c,u,h){return this.b.call("$resize",[c,u,h])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,u,h){return this.b.call("$sendCommandResult",[c,u,h])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,u){return this.b.call("$installAutoReply",[c,u])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,u,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,u,h])}acceptPtyHostResolvedVariables(c,u){return this.b.call("$acceptPtyHostResolvedVariables",[c,u])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,u){return this.b.call("$getWslPath",[c,u])}setTerminalLayoutInfo(c){const h={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(c,u,h){return this.b.call("$updateTitle",[c,u,h])}updateIcon(c,u,h,g){return this.b.call("$updateIcon",[c,u,h,g])}refreshProperty(c,u){return this.b.call("$refreshProperty",[c,u])}updateProperty(c,u,h){return this.b.call("$updateProperty",[c,u,h])}getTerminalLayoutInfo(){const u={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",u)}reviveTerminalProcesses(c,u,h){return this.b.call("$reviveTerminalProcesses",[c,u,h])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$YP=m,e.$YP=m=Le([Oe(2,s.$fF),Oe(3,I.$Ji),Oe(4,S.$FP),Oe(5,w.$iP),Oe(6,j.$Ll),Oe(7,v.$es),Oe(8,b.$9D),Oe(9,y.$cw)],m)}),define(ye[290],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.ExtHostConnectionType=void 0,e.$rn=P,e.$sn=b;var s;(function(y){y[y.IPC=1]="IPC",y[y.Socket=2]="Socket",y[y.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class j{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(w){this.pipeName=w,this.type=1}serialize(w){w[j.ENV_KEY]=this.pipeName}}e.$on=j;class I{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(w){w[I.ENV_KEY]="1"}}e.$pn=I;class D{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(w){w[D.ENV_KEY]="1"}}e.$qn=D;function S(y){delete y[j.ENV_KEY],delete y[I.ENV_KEY],delete y[D.ENV_KEY]}function P(y,w){S(w),y.serialize(w)}function b(y){if(y[j.ENV_KEY])return $(y,new j(y[j.ENV_KEY]));if(y[I.ENV_KEY])return $(y,new I);if(y[D.ENV_KEY])return $(y,new D);throw new Error("No connection information defined in environment!")}function $(y,w){return S(y),w}}),define(ye[291],Ee([1,0,15]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$4m=S,e.$5m=P;var j;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(j||(e.UIKind=j={}));var I;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var D;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(D||(e.MessageType=D={}));function S($){const y=s.$Je.alloc(1);switch($){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}function P($,y){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}var b;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ye[292],Ee([1,0,5,6,12,278,291,86,37,21,4,2,218]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$0O=e.$9O=void 0,e.$$O=c;let m=class extends w.$Uc{constructor(h,g){super(),this.s=h,this.t=g,this.a=this.B(new j.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new j.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=g.createLogger(this.m,{id:b.$qp,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(g.onDidChangeLogLevel(d=>{(0,I.$9j)(d)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,g,d){const E=this.getTelemetryDetails(),f=new l(g,d,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...t,f]),f.apiTelemetryLogger}$initializeTelemetryLevel(h,g,d){this.f=h,this.g=g,this.c=d??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const g=Object.create(null);switch(g["common.extname"]=`${h.publisher}.${h.name}`,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.s.telemetryInfo.machineId,g["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,g["common.sqmid"]=this.s.telemetryInfo.sqmId,g["common.vscodeversion"]=this.s.version,g["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),g["common.product"]=this.s.environment.appHost,this.s.uiKind){case S.UIKind.Web:g["common.uikind"]="web";break;case S.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.$Mm)((0,b.$wp)(this.s.remote.authority)),g}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const g=this.getTelemetryDetails();this.r.forEach((d,E)=>{const f=d.filter(t=>!t.isDisposed);f.length===0?this.r.delete(E):this.r.set(E,f)}),this.r.forEach(d=>{for(const E of d)E.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,g){const E=this.r.get(h.value)?.filter(t=>!t.isDisposed);if(!E)return this.r.delete(h.value),!1;let f=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(g),f=!0);return f}};e.$9O=m,e.$9O=m=Le([Oe(0,D.$8O),Oe(1,I.$8j)],m);class l{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,g,d,E,f,t,o){this.g=d,this.h=E,this.i=f,this.j=t,this.a=new j.$he,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(h,g){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let g="properties"in h?h.properties??{}:h;return g=(0,b.$zp)(g,[]),this.c&&(g=(0,$.$0n)(g,this.c)),this.b||(g=(0,$.$0n)(g,this.j)),"properties"in h?h.properties=g:h=g,h}k(h,g){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(h,g),this.h.trace(h,g))}logUsage(h,g){this.d.isUsageEnabled&&this.k(h,g)}logError(h,g){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,g);else{const d={name:h.name,message:h.message,stack:h.stack,cause:h.cause},E=(0,b.$zp)(d,[]),f=new Error(E.message,{cause:E.cause});f.stack=E.stack,f.name=E.name,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f.sendErrorData(f,g),this.h.trace("exception",g)}}get apiTelemetryLogger(){if(!this.e){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(g)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$0O=l;function c(u){const h=Date.now()-new Date(u).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$_O=(0,s.$Ai)("IExtHostTelemetry")}),define(ye[293],Ee([1,0,40,222,57]),function(fe,e,s,j,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=D;function D(S,P,b,$){const y=new s.$Xm;return S.forEach(w=>{const v=y.get(w.identifier);v&&$.warn((0,j.localize)(0,null,v.extensionLocation.fsPath,w.extensionLocation.fsPath)),y.set(w.identifier,w)}),P.forEach(w=>{const v=y.get(w.identifier);if(v)if(v.isBuiltin){if(I.gte(v.version,w.version)){$.warn(`Skipping extension ${w.extensionLocation.path} in favour of the builtin extension ${v.extensionLocation.path}.`);return}w.isBuiltin=!0}else $.warn((0,j.localize)(1,null,v.extensionLocation.fsPath,w.extensionLocation.fsPath));else if(w.isBuiltin){$.warn(`Skipping obsolete builtin extension ${w.extensionLocation.path}`);return}y.set(w.identifier,w)}),b.forEach(w=>{$.info((0,j.localize)(2,null,w.extensionLocation.fsPath));const v=y.get(w.identifier);v&&v.isBuiltin&&(w.isBuiltin=!0),y.set(w.identifier,w)}),Array.from(y.values())}}),define(ye[294],Ee([1,0,7,3,32,4,44,55,48,59,293,13]),function(fe,e,s,j,I,D,S,P,b,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0;class v{constructor(c,u,h,g,d,E,f){this.c=c,this.d=h,this.f=g,this.g=d,this.h=E,this.i=f,this.a=Promise.resolve(),this.b=Promise.resolve();const t=u.args["install-builtin-extension"];if(t){d.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!u.args["do-not-sync"],installPreReleaseVersion:!!u.args["pre-release"]};S.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),r,!!u.args.force).then(()=>{S.mark("code/server/didInstallBuiltinExtensions"),d.trace("Finished installing builtin extensions")},n=>{d.error(n)})}const o=u.args["install-extension"];o&&(d.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(o),[],{isMachineScoped:!!u.args["do-not-sync"],installPreReleaseVersion:!!u.args["pre-release"],isApplicationScoped:!0},!!u.args.force)).then(()=>{d.trace("Finished installing extensions")},r=>{d.error(r)}))}j(c){return c.map(u=>/\.vsix$/i.test(u)?D.URI.file((0,s.$ic)(u)?u:(0,s.$jc)((0,I.cwd)(),u)):u)}whenExtensionsReady(){return this.b}async scanExtensions(c,u,h,g,d){S.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const E=g?g.filter(t=>t.scheme===w.Schemas.file).map(t=>t.fsPath):void 0;u=u??this.d.defaultProfile.extensionsResource;const f=await this.k(u,c??j.$w,h,E,d);return this.g.trace("Scanned Extensions",f),this.s(f),S.mark("code/server/didScanExtensions"),f}async scanSingleExtension(c,u,h){await this.a;const g=c.scheme===w.Schemas.file?c.fsPath:null;if(!g)return null;const d=await this.q(g,u,h??j.$w);return d?(this.s([d]),d):null}async k(c,u,h,g,d){await this.r(u,d);const[E,f,t,o]=await Promise.all([this.n(u),this.o(c,u),this.m(u,h),this.l(u,g)]);return(0,y.$gQ)(E,[...f,...t],o,this.g)}async l(c,u){return u?(await Promise.all(u.map(h=>this.f.scanOneOrMultipleExtensions(D.URI.file((0,s.$kc)(h)),1,{language:c})))).flat().map(h=>(0,$.$Cq)(h,!0)):[]}async m(c,u){const h=[];if(u?.length){const g=await Promise.all(u.map(d=>this.f.scanExistingExtension(d,1,{language:c})));for(const d of g)d&&h.push((0,$.$Cq)(d,!1))}return h}async n(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(h=>(0,$.$Cq)(h,!1))}async o(c,u){return(await this.f.scanUserExtensions({profileLocation:c,language:u,useCache:!0})).map(g=>(0,$.$Cq)(g,!1))}async q(c,u,h){const g=D.URI.file((0,s.$kc)(c)),d=u?0:1,E=await this.f.scanExistingExtension(g,d,{language:h});return E?(0,$.$Cq)(E,!1):null}async r(c,u){if(!(c===j.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(g=>g.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(h){this.g.error(h)}if(!u){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${u} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([u],[],{isMachineScoped:!0},!0)}catch(h){this.g.error(h)}}}s(c){const u=(t,o)=>t.replace(/file/g,"vscode-remote"),h=t=>{let o="";return o+=t.global?"g":"",o+=t.ignoreCase?"i":"",o+=t.multiline?"m":"",new RegExp(u(t.source,!0),o)},g=new class{mapDefined(t){return b.$Dj.create(t)}mapNot(t){return b.$Ij.create(t)}mapEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?b.$Ej.create(t,u(o,!1)):b.$Ej.create(t,o)}mapNotEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?b.$Hj.create(t,u(o,!1)):b.$Hj.create(t,o)}mapGreater(t,o){return b.$Jj.create(t,o)}mapGreaterEquals(t,o){return b.$Kj.create(t,o)}mapSmaller(t,o){return b.$Lj.create(t,o)}mapSmallerEquals(t,o){return b.$Mj.create(t,o)}mapRegex(t,o){return t==="resourceScheme"&&o?b.$Nj.create(t,h(o)):b.$Nj.create(t,o)}mapIn(t,o){return b.$Fj.create(t,o)}mapNotIn(t,o){return b.$Gj.create(t,o)}},d=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const o=b.$yj.deserialize(t.when);if(!o)return;const r=o.map(g);t.when=r.serialize()},E=t=>{if(Array.isArray(t))for(const o of t)d(o);else d(t)},f=t=>{for(const o in t)E(t[o])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&f(t.contributes.menus),t.contributes.keybindings&&E(t.contributes.keybindings),t.contributes.views&&f(t.contributes.views))})}}e.$jQ=v;class m{constructor(c,u){this.a=c,this.b=u}listen(c,u){throw new Error("Invalid listen")}async call(c,u,h){const g=this.b(c);switch(u){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const d=h[0],E=h[1]?D.URI.revive(g.transformIncoming(h[1])):void 0,f=Array.isArray(h[2])?h[2].map(n=>D.URI.revive(g.transformIncoming(n))):void 0,t=Array.isArray(h[3])?h[3].map(n=>D.URI.revive(g.transformIncoming(n))):void 0,o=h[4];return(await this.a.scanExtensions(d,E,f,t,o)).map(n=>(0,P.$En)(n,g))}case"scanSingleExtension":{const d=await this.a.scanSingleExtension(D.URI.revive(g.transformIncoming(h[0])),h[1],h[2]);return d?(0,P.$En)(d,g):null}}throw new Error("Invalid call")}}e.$kQ=m}),define(ye[141],Ee([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Ew=void 0,e.$Fw=I,e.$Gw=D;class s{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++s.count}}e.$Ew=s;const j=[];function I(P){const b=new s(P);return j[b.nid]=b,b}function D(P){return j[P].sid}class S{constructor(b){this.value=b}}e.$Hw=S}),define(ye[295],Ee([1,0,141]),function(fe,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$mM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var j;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(j||(e.TextEditorRevealType=j={}));var I;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var D;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var S;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(S||(e.WebviewEditorCapabilities=S={}));var P;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var $;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var y;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(y||(e.CandidatePortSource=y={}));class w{static{this.a=0}static mixin(u){return u._id=w.a++,u}}e.$mM=w;var v;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var m;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var l;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(l||(e.ExtHostTestingResource=l={})),e.$nM={MainThreadAuthentication:(0,s.$Fw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.$Fw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.$Fw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.$Fw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.$Fw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.$Fw)("MainThreadChatVariables"),MainThreadClipboard:(0,s.$Fw)("MainThreadClipboard"),MainThreadCommands:(0,s.$Fw)("MainThreadCommands"),MainThreadComments:(0,s.$Fw)("MainThreadComments"),MainThreadConfiguration:(0,s.$Fw)("MainThreadConfiguration"),MainThreadConsole:(0,s.$Fw)("MainThreadConsole"),MainThreadDebugService:(0,s.$Fw)("MainThreadDebugService"),MainThreadDecorations:(0,s.$Fw)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.$Fw)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.$Fw)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.$Fw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.$Fw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.$Fw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.$Fw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.$Fw)("MainThreadEditorTabs"),MainThreadErrors:(0,s.$Fw)("MainThreadErrors"),MainThreadTreeViews:(0,s.$Fw)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.$Fw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.$Fw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.$Fw)("MainThreadLanguages"),MainThreadLogger:(0,s.$Fw)("MainThreadLogger"),MainThreadMessageService:(0,s.$Fw)("MainThreadMessageService"),MainThreadOutputService:(0,s.$Fw)("MainThreadOutputService"),MainThreadProgress:(0,s.$Fw)("MainThreadProgress"),MainThreadQuickDiff:(0,s.$Fw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.$Fw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.$Fw)("MainThreadStatusBar"),MainThreadSecretState:(0,s.$Fw)("MainThreadSecretState"),MainThreadStorage:(0,s.$Fw)("MainThreadStorage"),MainThreadSpeech:(0,s.$Fw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.$Fw)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.$Fw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.$Fw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.$Fw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.$Fw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.$Fw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.$Fw)("MainThreadCustomEditors"),MainThreadUrls:(0,s.$Fw)("MainThreadUrls"),MainThreadUriOpeners:(0,s.$Fw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.$Fw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.$Fw)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.$Fw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.$Fw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.$Fw)("MainThreadExtensionService"),MainThreadSCM:(0,s.$Fw)("MainThreadSCM"),MainThreadSearch:(0,s.$Fw)("MainThreadSearch"),MainThreadShare:(0,s.$Fw)("MainThreadShare"),MainThreadTask:(0,s.$Fw)("MainThreadTask"),MainThreadWindow:(0,s.$Fw)("MainThreadWindow"),MainThreadLabelService:(0,s.$Fw)("MainThreadLabelService"),MainThreadNotebook:(0,s.$Fw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.$Fw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.$Fw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.$Fw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.$Fw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.$Fw)("MainThreadInteractive"),MainThreadTheming:(0,s.$Fw)("MainThreadTheming"),MainThreadTunnelService:(0,s.$Fw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.$Fw)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.$Fw)("MainThreadTimeline"),MainThreadTesting:(0,s.$Fw)("MainThreadTesting"),MainThreadLocalization:(0,s.$Fw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.$Fw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.$Fw)("MainThreadAiEmbeddingVector")},e.$oM={ExtHostCommands:(0,s.$Fw)("ExtHostCommands"),ExtHostConfiguration:(0,s.$Fw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.$Fw)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.$Fw)("ExtHostDebugService"),ExtHostDecorations:(0,s.$Fw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.$Fw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.$Fw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.$Fw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.$Fw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.$Fw)("ExtHostEditors"),ExtHostTreeViews:(0,s.$Fw)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.$Fw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.$Fw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.$Fw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.$Fw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.$Fw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.$Fw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.$Fw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.$Fw)("ExtHostStatusBar"),ExtHostShare:(0,s.$Fw)("ExtHostShare"),ExtHostExtensionService:(0,s.$Fw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.$Fw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.$Fw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.$Fw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.$Fw)("ExtHostSCM"),ExtHostSearch:(0,s.$Fw)("ExtHostSearch"),ExtHostTask:(0,s.$Fw)("ExtHostTask"),ExtHostWorkspace:(0,s.$Fw)("ExtHostWorkspace"),ExtHostWindow:(0,s.$Fw)("ExtHostWindow"),ExtHostWebviews:(0,s.$Fw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.$Fw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.$Fw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.$Fw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.$Fw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.$Fw)("ExtHostEditorTabs"),ExtHostProgress:(0,s.$Fw)("ExtHostProgress"),ExtHostComments:(0,s.$Fw)("ExtHostComments"),ExtHostSecretState:(0,s.$Fw)("ExtHostSecretState"),ExtHostStorage:(0,s.$Fw)("ExtHostStorage"),ExtHostUrls:(0,s.$Fw)("ExtHostUrls"),ExtHostUriOpeners:(0,s.$Fw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.$Fw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.$Fw)("ExtHostOutputService"),ExtHostLabelService:(0,s.$Fw)("ExtHostLabelService"),ExtHostNotebook:(0,s.$Fw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.$Fw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.$Fw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.$Fw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.$Fw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.$Fw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.$Fw)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.$Fw)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.$Fw)("ExtHostChatVariables"),ExtHostChatProvider:(0,s.$Fw)("ExtHostChatProvider"),ExtHostSpeech:(0,s.$Fw)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.$Fw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.$Fw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.$Fw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.$Fw)("ExtHostTheming"),ExtHostTunnelService:(0,s.$Fw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.$Fw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.$Fw)("ExtHostAuthentication"),ExtHostTimeline:(0,s.$Fw)("ExtHostTimeline"),ExtHostTesting:(0,s.$Fw)("ExtHostTesting"),ExtHostTelemetry:(0,s.$Fw)("ExtHostTelemetry"),ExtHostLocalization:(0,s.$Fw)("ExtHostLocalization")}}),define(ye[296],Ee([1,0,15,24,13,111,5]),function(fe,e,s,j,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$1J=void 0,e.$2J=y,e.$3J=w,e.$1J=(0,S.$Ai)("notebookDocumentService");const P=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${P.join("")}]+`),$=7;function y(m){if(m.scheme!==I.Schemas.vscodeNotebookCell)return;const l=m.fragment.indexOf("s");if(l<0)return;const c=parseInt(m.fragment.substring(0,l).replace(b,""),$),u=(0,s.$3e)(m.fragment.substring(l+1)).toString();if(!isNaN(c))return{handle:c,notebook:m.with({scheme:u,fragment:null})}}function w(m,l){const c=l.toString($),h=`${c.length<P.length?P[c.length-1]:"z"}${c}s${(0,s.$4e)(s.$Je.fromString(m.scheme),!0,!0)}`;return m.with({scheme:I.Schemas.vscodeNotebookCell,fragment:h})}class v{constructor(){this.a=new j.$Ac}getNotebook(l){if(l.scheme===I.Schemas.vscodeNotebookCell){const c=y(l);if(c){const u=this.a.get(c.notebook);if(u)return u}}return this.a.get(l)}addNotebookDocument(l){this.a.set(l.uri,l)}removeNotebookDocument(l){this.a.delete(l.uri)}}e.$4J=v,(0,D.$Ds)(e.$1J,v,1)}),define(ye[142],Ee([1,0,15,80,41,65,13,7,3,48,296]),function(fe,e,s,j,I,D,S,P,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$iK=e.CellStatusbarAlignment=e.$hK=e.NotebookEditorPriority=e.$eK=e.$dK=e.$bK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aK=e.$_J=e.$$J=e.$0J=e.CellKind=e.$9J=e.$8J=e.$7J=void 0,e.$cK=o,e.$fK=n,e.$gK=a,e.$jK=k,e.$kK=A,e.$7J="workbench.editor.notebook",e.$8J="workbench.editor.notebookTextDiffEditor",e.$9J="workbench.editor.interactive";var w;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(w||(e.CellKind=w={})),e.$0J=["application/json","application/javascript","text/html","image/svg+xml",D.$Ws.latex,D.$Ws.markdown,"image/png","image/jpeg",D.$Ws.text],e.$$J=[D.$Ws.latex,D.$Ws.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",D.$Ws.text],e.$_J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aK="_notAvailable";var v;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var m;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var l;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(l||(e.NotebookExecutionState=l={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var u;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var h;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var E;(function(B){B.scheme=S.Schemas.vscodeNotebookCell;function Z(_,H){return(0,y.$3J)(_,H)}B.generate=Z;function Y(_){return(0,y.$2J)(_)}B.parse=Y;function M(_,H){return _.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${_.scheme!==S.Schemas.file?_.scheme:""}`})}B.generateCellOutputUri=M;function z(_){if(_.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!H)return;const ne=H[1]&&H[1]!==""?H[1]:void 0,le=H[2];return{outputId:ne,notebook:_.with({scheme:le||S.Schemas.file,fragment:null})}}B.parseCellOutputUri=z;function oe(_,H,ne){return B.generate(_,H).with({scheme:ne})}B.generateCellPropertyUri=oe;function se(_,H){if(_.scheme===H)return B.parse(_.with({scheme:B.scheme}))}B.parseCellPropertyUri=se})(E||(e.CellUri=E={}));const f=B=>b.$i?B.replace(/\//g,"\\"):B;class t{constructor(Z=[],Y=e.$0J){this.e=Y,this.d=[...new Set(Z)].map(M=>({pattern:M,matches:j.$uk(f(M))}))}sort(Z){const Y=new Map(I.Iterable.map(Z,z=>[z,f(z)]));let M=[];for(const{matches:z}of this.d)for(const[oe,se]of Y)if(z(se)){M.push(oe),Y.delete(oe);break}return Y.size&&(M=M.concat([...Y.keys()].sort((z,oe)=>this.e.indexOf(z)-this.e.indexOf(oe)))),M}prioritize(Z,Y){const M=this.f(Z);if(M===-1){this.d.unshift({pattern:Z,matches:j.$uk(f(Z))});return}const z=new Set(Y.map(se=>this.f(se,M)));z.delete(-1);const oe=Array.from(z).sort();this.d.splice(M+1,0,...oe.map(se=>this.d[se]));for(let se=oe.length-1;se>=0;se--)this.d.splice(oe[se],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,Y=this.d.length){const M=f(Z);for(let z=0;z<Y;z++)if(this.d[z].matches(M))return z;return-1}}e.$bK=t;function o(B,Z,Y,M=(z,oe)=>z===oe){const z=[];function oe(H,ne,le){if(ne===0&&le.length===0)return;const F=z[z.length-1];F&&F.start+F.deleteCount===H?(F.deleteCount+=ne,F.toInsert.push(...le)):z.push({start:H,deleteCount:ne,toInsert:le})}let se=0,_=0;for(;;){if(se===B.length){oe(se,0,Z.slice(_));break}if(_===Z.length){oe(se,B.length-se,[]);break}const H=B[se],ne=Z[_];if(M(H,ne)){se+=1,_+=1;continue}Y(ne)?(oe(se,1,[]),se+=1):(oe(se,0,[ne]),_+=1)}return z}e.$dK=new $.$Rj("notebookEditorCursorAtBoundary","none"),e.$eK=new $.$Rj("notebookEditorCursorAtLineBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r||(e.NotebookEditorPriority=r={}));function n(B){const Z=B;return!!((typeof Z.include=="string"||j.$vk(Z.include))&&(typeof Z.exclude=="string"||j.$vk(Z.exclude)))}function a(B,Z,Y){if(Array.isArray(B.viewType)&&B.viewType.indexOf(Z)>=0||B.viewType===Z)return!0;if(B.filenamePattern){const M=n(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,z=n(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(j.$tk(M,(0,P.$nc)(Y.fsPath).toLowerCase()))return!(z&&j.$tk(z,(0,P.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$hK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(i||(e.CellStatusbarAlignment=i={}));class p{static{this.d="notebook/"}static create(Z){return`${p.d}${Z}`}static parse(Z){if(Z.startsWith(p.d))return Z.substring(p.d.length)}}e.$iK=p;function k(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const C=new TextDecoder;function A(B){const Z=[];let Y=!1;for(const se of B)(Z.length===0||Y)&&(Z.push(se),Y=!0);let M=V(Z);const z=s.$Je.concat(Z.map(se=>s.$Je.wrap(se))),oe=K(z);return M=M||oe.byteLength!==z.byteLength,{data:oe,didCompression:M}}e.$lK="\x1B[A";const O=e.$lK.split("").map(B=>B.charCodeAt(0)),N=10;function V(B){let Z=!1;return B.forEach((Y,M)=>{if(M===0||Y.length<e.$lK.length)return;const z=B[M-1],oe=Y.subarray(0,e.$lK.length);if(oe[0]===O[0]&&oe[1]===O[1]&&oe[2]===O[2]){const se=z.lastIndexOf(N);if(se===-1)return;Z=!0,B[M-1]=z.subarray(0,se),B[M]=Y.subarray(e.$lK.length)}}),Z}function ie(B){let Z=B;do B=Z,Z=B.replace(/[^\n]\x08/gm,"");while(Z.length<B.length);return B}function ae(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const Z=B.match(/^(.*)\r+/m)[1];let Y=B.match(/\r+(.*)$/m)[1];Y=Y+Z.slice(Y.length,Z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return B}const te=8,ee=13;function K(B){return!B.buffer.includes(te)&&!B.buffer.includes(ee)?B:s.$Je.fromString(ae(ie(C.decode(B.buffer))))}}),define(ye[143],Ee([1,0,18,11,102,24,65,17,10,4,22,40,16,120,142]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l){"use strict";var c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$FO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$lO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$$N=e.$0N=e.$9N=e.$8N=e.$6N=e.$5N=e.$4N=e.$3N=e.TestRunProfileKind=e.TestResultState=e.$2N=e.$1N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$ZN=e.NotebookVariablesRequestKind=e.$YN=e.$XN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$WN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.ColorThemeKind=e.$QN=e.$PN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ON=e.$NN=e.DebugConsoleMode=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$HN=e.$GN=e.FileChangeType=e.$FN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$EN=e.$DN=e.$CN=e.$BN=e.InlineCompletionTriggerKind=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$oN=e.ConfigurationTarget=e.$nN=e.$mN=e.$lN=e.$kN=e.DocumentPasteTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dN=e.ViewBadge=e.ProgressLocation=e.$cN=e.$bN=e.TaskScope=e.ShellQuoting=e.$aN=e.$_M=e.$$M=e.TaskPanelKind=e.TaskRevealKind=e.$0M=e.TerminalLocation=e.$9M=e.$8M=e.$7M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6M=e.$5M=e.$4M=e.$3M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$1M=e.$ZM=e.$YM=e.$XM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WM=e.$VM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.LanguageStatusSeverity=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CodeActionTriggerKind=e.$JM=e.$IM=e.SymbolTag=e.SymbolKind=e.$HM=e.$GM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.DiagnosticSeverity=e.DiagnosticTag=e.$AM=e.$zM=e.FileEditType=e.$yM=e.$xM=e.$wM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$2M=ct,e.$pN=Se,e.$7N=ci;function O(L){return Object.assign(L,{apply:function(...re){if(re.length===0)return Reflect.construct(L,[]);{const ve=re.length===1?[]:re[1];return Reflect.construct(L,ve,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(L,[]);{const[ve,...ze]=re;return Reflect.construct(L,ze,ve.constructor)}}})}var N;(function(L){L[L.Top=0]="Top",L[L.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var V;(function(L){L[L.TerminalCommand=0]="TerminalCommand",L[L.Opener=1]="Opener",L[L.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let ie=c=class{static from(...R){let re=R;return new c(function(){if(re){for(const ve of re)ve&&typeof ve.dispose=="function"&&ve.dispose();re=void 0}})}#e;constructor(R){this.#e=R}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$pM=ie,e.$pM=ie=c=Le([O],ie);let ae=u=class{static Min(...R){if(R.length===0)throw new TypeError;let re=R[0];for(let ve=1;ve<R.length;ve++){const ze=R[ve];ze.isBefore(re)&&(re=ze)}return re}static Max(...R){if(R.length===0)throw new TypeError;let re=R[0];for(let ve=1;ve<R.length;ve++){const ze=R[ve];ze.isAfter(re)&&(re=ze)}return re}static isPosition(R){if(!R)return!1;if(R instanceof u)return!0;const{line:re,character:ve}=R;return typeof re=="number"&&typeof ve=="number"}static of(R){if(R instanceof u)return R;if(this.isPosition(R))return new u(R.line,R.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(R,re){if(R<0)throw(0,j.$7)("line must be non-negative");if(re<0)throw(0,j.$7)("character must be non-negative");this.c=R,this.e=re}isBefore(R){return this.c<R.c?!0:R.c<this.c?!1:this.e<R.e}isBeforeOrEqual(R){return this.c<R.c?!0:R.c<this.c?!1:this.e<=R.e}isAfter(R){return!this.isBeforeOrEqual(R)}isAfterOrEqual(R){return!this.isBefore(R)}isEqual(R){return this.c===R.c&&this.e===R.e}compareTo(R){return this.c<R.c?-1:this.c>R.line?1:this.e<R.e?-1:this.e>R.e?1:0}translate(R,re=0){if(R===null||re===null)throw(0,j.$7)();let ve;return typeof R>"u"?ve=0:typeof R=="number"?ve=R:(ve=typeof R.lineDelta=="number"?R.lineDelta:0,re=typeof R.characterDelta=="number"?R.characterDelta:0),ve===0&&re===0?this:new u(this.line+ve,this.character+re)}with(R,re=this.character){if(R===null||re===null)throw(0,j.$7)();let ve;return typeof R>"u"?ve=this.line:typeof R=="number"?ve=R:(ve=typeof R.line=="number"?R.line:this.line,re=typeof R.character=="number"?R.character:this.character),ve===this.line&&re===this.character?this:new u(ve,re)}toJSON(){return{line:this.line,character:this.character}}};e.$qM=ae,e.$qM=ae=u=Le([O],ae);let te=h=class{static isRange(R){return R instanceof h?!0:R?ae.isPosition(R.start)&&ae.isPosition(R.end):!1}static of(R){if(R instanceof h)return R;if(this.isRange(R))return new h(R.start,R.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(R,re,ve,ze){let We,Ke;if(typeof R=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"?(We=new ae(R,re),Ke=new ae(ve,ze)):ae.isPosition(R)&&ae.isPosition(re)&&(We=ae.of(R),Ke=ae.of(re)),!We||!Ke)throw new Error("Invalid arguments");We.isBefore(Ke)?(this.c=We,this.e=Ke):(this.c=Ke,this.e=We)}contains(R){return h.isRange(R)?this.contains(R.start)&&this.contains(R.end):ae.isPosition(R)?!(ae.of(R).isBefore(this.c)||this.e.isBefore(R)):!1}isEqual(R){return this.c.isEqual(R.c)&&this.e.isEqual(R.e)}intersection(R){const re=ae.Max(R.start,this.c),ve=ae.Min(R.end,this.e);if(!re.isAfter(ve))return new h(re,ve)}union(R){if(this.contains(R))return this;if(R.contains(this))return R;const re=ae.Min(R.start,this.c),ve=ae.Max(R.end,this.end);return new h(re,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(R,re=this.end){if(R===null||re===null)throw(0,j.$7)();let ve;return R?ae.isPosition(R)?ve=R:(ve=R.start||this.start,re=R.end||this.end):ve=this.start,ve.isEqual(this.c)&&re.isEqual(this.end)?this:new h(ve,re)}toJSON(){return[this.start,this.end]}};e.$rM=te,e.$rM=te=h=Le([O],te);let ee=g=class extends te{static isSelection(R){return R instanceof g?!0:R?te.isRange(R)&&ae.isPosition(R.anchor)&&ae.isPosition(R.active)&&typeof R.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(R,re,ve,ze){let We,Ke;if(typeof R=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"?(We=new ae(R,re),Ke=new ae(ve,ze)):ae.isPosition(R)&&ae.isPosition(re)&&(We=ae.of(R),Ke=ae.of(re)),!We||!Ke)throw new Error("Invalid arguments");super(We,Ke),this.f=We,this.g=Ke}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$sM=ee,e.$sM=ee=g=Le([O],ee);const K=L=>{if(typeof L!="string"||L.length===0||!/^[0-9A-Za-z_\-]+$/.test(L))throw(0,j.$7)("connectionToken")};class B{static isResolvedAuthority(R){return R&&typeof R=="object"&&typeof R.host=="string"&&typeof R.port=="number"&&(R.connectionToken===void 0||typeof R.connectionToken=="string")}constructor(R,re,ve){if(typeof R!="string"||R.length===0)throw(0,j.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,j.$7)("port");typeof ve<"u"&&K(ve),this.host=R,this.port=Math.round(re),this.connectionToken=ve}}e.$tM=B;class Z{static isManagedResolvedAuthority(R){return R&&typeof R=="object"&&typeof R.makeConnection=="function"&&(R.connectionToken===void 0||typeof R.connectionToken=="string")}constructor(R,re){this.makeConnection=R,this.connectionToken=re,typeof re<"u"&&K(re)}}e.$uM=Z;class Y extends Error{static NotAvailable(R,re){return new Y(R,m.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(R){return new Y(R,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(R,re=m.RemoteAuthorityResolverErrorCode.Unknown,ve){super(R),this._message=R,this._code=re,this._detail=ve,Object.setPrototypeOf(this,Y.prototype)}}e.$vM=Y;var M;(function(L){L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(M||(e.EndOfLine=M={}));var z;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let oe=d=class{static isTextEdit(R){return R instanceof d?!0:R?te.isRange(R)&&typeof R.newText=="string":!1}static replace(R,re){return new d(R,re)}static insert(R,re){return d.replace(new te(R,R),re)}static delete(R){return d.replace(R,"")}static setEndOfLine(R){const re=new d(new te(new ae(0,0),new ae(0,0)),"");return re.newEol=R,re}get range(){return this.c}set range(R){if(R&&!te.isRange(R))throw(0,j.$7)("range");this.c=R}get newText(){return this.e||""}set newText(R){if(R&&typeof R!="string")throw(0,j.$7)("newText");this.e=R}get newEol(){return this.f}set newEol(R){if(R&&typeof R!="number")throw(0,j.$7)("newEol");this.f=R}constructor(R,re){this.c=R,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$wM=oe,e.$wM=oe=d=Le([O],oe);let se=E=class{static isNotebookCellEdit(R){return R instanceof E?!0:R?Bt.isNotebookRange(R)&&Array.isArray(R.newCells):!1}static replaceCells(R,re){return new E(R,re)}static insertCells(R,re){return new E(new Bt(R,R),re)}static deleteCells(R){return new E(R,[])}static updateCellMetadata(R,re){const ve=new E(new Bt(R,R),[]);return ve.newCellMetadata=re,ve}static updateNotebookMetadata(R){const re=new E(new Bt(0,0),[]);return re.newNotebookMetadata=R,re}constructor(R,re){this.range=R,this.newCells=re}};e.$xM=se,e.$xM=se=E=Le([O],se);class _{static isSnippetTextEdit(R){return R instanceof _?!0:R?te.isRange(R.range)&&le.isSnippetString(R.snippet):!1}static replace(R,re){return new _(R,re)}static insert(R,re){return _.replace(new te(R,R),re)}constructor(R,re){this.range=R,this.snippet=re}}e.$yM=_;var H;(function(L){L[L.File=1]="File",L[L.Text=2]="Text",L[L.Cell=3]="Cell",L[L.CellReplace=5]="CellReplace",L[L.Snippet=6]="Snippet"})(H||(e.FileEditType=H={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(R,re,ve,ze){this.c.push({_type:1,from:R,to:re,options:ve,metadata:ze})}createFile(R,re,ve){this.c.push({_type:1,from:void 0,to:R,options:re,metadata:ve})}deleteFile(R,re,ve){this.c.push({_type:1,from:R,to:void 0,options:re,metadata:ve})}e(R,re,ve){this.c.push({_type:3,metadata:ve,uri:R,edit:{editType:5,metadata:re},notebookMetadata:re})}f(R,re,ve,ze){const We=re.start,Ke=re.end;(We!==Ke||ve.length>0)&&this.c.push({_type:5,uri:R,index:We,count:Ke-We,cells:ve,metadata:ze})}g(R,re,ve,ze){this.c.push({_type:3,metadata:ze,uri:R,edit:{editType:3,index:re,metadata:ve}})}replace(R,re,ve,ze){this.c.push({_type:2,uri:R,edit:new oe(re,ve),metadata:ze})}insert(R,re,ve,ze){this.replace(R,new te(re,re),ve,ze)}delete(R,re,ve){this.replace(R,re,"",ve)}has(R){return this.c.some(re=>re._type===2&&re.uri.toString()===R.toString())}set(R,re){if(re)for(const ve of re){if(!ve)continue;let ze,We;Array.isArray(ve)?(ze=ve[0],We=ve[1]):ze=ve,se.isNotebookCellEdit(ze)?ze.newCellMetadata?this.g(R,ze.range.start,ze.newCellMetadata,We):ze.newNotebookMetadata?this.e(R,ze.newNotebookMetadata,We):this.f(R,ze.range,ze.newCells,We):_.isSnippetTextEdit(ze)?this.c.push({_type:6,uri:R,range:ze.range,edit:ze.snippet,metadata:We}):this.c.push({_type:2,uri:R,edit:ze,metadata:We})}else{for(let ve=0;ve<this.c.length;ve++){const ze=this.c[ve];switch(ze._type){case 2:case 6:case 3:case 5:ze.uri.toString()===R.toString()&&(this.c[ve]=void 0);break}}(0,s.$Ib)(this.c)}}get(R){const re=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===R.toString()&&re.push(ve.edit);return re}entries(){const R=new D.$Ac;for(const re of this.c)if(re._type===2){let ve=R.get(re.uri);ve||(ve=[re.uri,[]],R.set(re.uri,ve)),ve[1].push(re.edit)}return[...R.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$zM=ne,e.$zM=ne=Le([O],ne);let le=f=class{static isSnippetString(R){return R instanceof f?!0:R?typeof R.value=="string":!1}static c(R){return R.replace(/\$|}|\\/g,"\\$&")}constructor(R){this.e=1,this.value=R||""}appendText(R){return this.value+=f.c(R),this}appendTabstop(R=this.e++){return this.value+="$",this.value+=R,this}appendPlaceholder(R,re=this.e++){if(typeof R=="function"){const ve=new f;ve.e=this.e,R(ve),this.e=ve.e,R=ve.value}else R=f.c(R);return this.value+="${",this.value+=re,this.value+=":",this.value+=R,this.value+="}",this}appendChoice(R,re=this.e++){const ve=R.map(ze=>ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(R,re){if(typeof re=="function"){const ve=new f;ve.e=this.e,re(ve),this.e=ve.e,re=ve.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=R,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$AM=le,e.$AM=le=f=Le([O],le);var F;(function(L){L[L.Unnecessary=1]="Unnecessary",L[L.Deprecated=2]="Deprecated"})(F||(e.DiagnosticTag=F={}));var U;(function(L){L[L.Hint=3]="Hint",L[L.Information=2]="Information",L[L.Warning=1]="Warning",L[L.Error=0]="Error"})(U||(e.DiagnosticSeverity=U={}));let X=t=class{static isLocation(R){return R instanceof t?!0:R?te.isRange(R.range)&&$.URI.isUri(R.uri):!1}constructor(R,re){if(this.uri=R,re)if(te.isRange(re))this.range=te.of(re);else if(ae.isPosition(re))this.range=new te(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$BM=X,e.$BM=X=t=Le([O],X);let x=class{static is(R){return R?typeof R.message=="string"&&R.location&&te.isRange(R.location.range)&&$.URI.isUri(R.location.uri):!1}constructor(R,re){this.location=R,this.message=re}static isEqual(R,re){return R===re?!0:!R||!re?!1:R.message===re.message&&R.location.range.isEqual(re.location.range)&&R.location.uri.toString()===re.location.uri.toString()}};e.$CM=x,e.$CM=x=Le([O],x);let Q=class{constructor(R,re,ve=U.Error){if(!te.isRange(R))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=R,this.message=re,this.severity=ve}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(R,re){return R===re?!0:!R||!re?!1:R.message===re.message&&R.severity===re.severity&&R.code===re.code&&R.severity===re.severity&&R.source===re.source&&R.range.isEqual(re.range)&&(0,s.$ub)(R.tags,re.tags)&&(0,s.$ub)(R.relatedInformation,re.relatedInformation,x.isEqual)}};e.$DM=Q,e.$DM=Q=Le([O],Q);let G=class{constructor(R,re){if(!R)throw new Error("Illegal argument, contents must be defined");Array.isArray(R)?this.contents=R:this.contents=[R],this.range=re}};e.$EM=G,e.$EM=G=Le([O],G);let J=class extends G{constructor(R,re,ve,ze){super(R,re),this.canIncreaseHover=ve,this.canDecreaseHover=ze}};e.$FM=J,e.$FM=J=Le([O],J);var T;(function(L){L[L.Increase=0]="Increase",L[L.Decrease=1]="Decrease"})(T||(e.HoverVerbosityAction=T={}));var W;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(W||(e.DocumentHighlightKind=W={}));let ce=class{constructor(R,re=W.Text){this.range=R,this.kind=re}toJSON(){return{range:this.range,kind:W[this.kind]}}};e.$GM=ce,e.$GM=ce=Le([O],ce);let ue=class{constructor(R,re){this.uri=R,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(R=>R.toJSON())}}};e.$HM=ue,e.$HM=ue=Le([O],ue);var we;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(we||(e.SymbolKind=we={}));var de;(function(L){L[L.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let ge=o=class{static validate(R){if(!R.name)throw new Error("name must not be falsy")}constructor(R,re,ve,ze,We){this.name=R,this.kind=re,this.containerName=We,typeof ve=="string"&&(this.containerName=ve),ze instanceof X?this.location=ze:ve instanceof te&&(this.location=new X(ze,ve)),o.validate(this)}toJSON(){return{name:this.name,kind:we[this.kind],location:this.location,containerName:this.containerName}}};e.$IM=ge,e.$IM=ge=o=Le([O],ge);let $e=r=class{static validate(R){if(!R.name)throw new Error("name must not be falsy");if(!R.range.contains(R.selectionRange))throw new Error("selectionRange must be contained in fullRange");R.children?.forEach(r.validate)}constructor(R,re,ve,ze,We){this.name=R,this.detail=re,this.kind=ve,this.range=ze,this.selectionRange=We,this.children=[],r.validate(this)}};e.$JM=$e,e.$JM=$e=r=Le([O],$e);var Ce;(function(L){L[L.Invoke=1]="Invoke",L[L.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Ae=class{constructor(R,re){this.title=R,this.kind=re}};e.$KM=Ae,e.$KM=Ae=Le([O],Ae);let he=class{static{n=this}static{this.c="."}constructor(R){this.value=R}append(R){return new n(this.value?this.value+n.c+R:R)}intersects(R){return this.contains(R)||R.contains(this)}contains(R){return this.value===R.value||R.value.startsWith(this.value+n.c)}};e.$LM=he,e.$LM=he=n=Le([O],he),he.Empty=new he(""),he.QuickFix=he.Empty.append("quickfix"),he.Refactor=he.Empty.append("refactor"),he.RefactorExtract=he.Refactor.append("extract"),he.RefactorInline=he.Refactor.append("inline"),he.RefactorMove=he.Refactor.append("move"),he.RefactorRewrite=he.Refactor.append("rewrite"),he.Source=he.Empty.append("source"),he.SourceOrganizeImports=he.Source.append("organizeImports"),he.SourceFixAll=he.Source.append("fixAll"),he.Notebook=he.Empty.append("notebook");let De=class{constructor(R,re){if(this.range=R,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$MM=De,e.$MM=De=Le([O],De);class ke{constructor(R,re,ve,ze,We,Ke){this.kind=R,this.name=re,this.detail=ve,this.uri=ze,this.range=We,this.selectionRange=Ke}}e.$NM=ke;class Me{constructor(R,re){this.fromRanges=re,this.from=R}}e.$OM=Me;class Fe{constructor(R,re){this.fromRanges=re,this.to=R}}e.$PM=Fe;var He;(function(L){L[L.Information=0]="Information",L[L.Warning=1]="Warning",L[L.Error=2]="Error"})(He||(e.LanguageStatusSeverity=He={}));let Be=class{constructor(R,re){this.range=R,this.command=re}get isResolved(){return!!this.command}};e.$QM=Be,e.$QM=Be=Le([O],Be);let Ge=a=class{#e;static isMarkdownString(R){return R instanceof a?!0:R&&R.appendCodeblock&&R.appendMarkdown&&R.appendText&&R.value!==void 0}constructor(R,re=!1){this.#e=new I.$Xk(R,{supportThemeIcons:re})}get value(){return this.#e.value}set value(R){this.#e.value=R}get isTrusted(){return this.#e.isTrusted}set isTrusted(R){this.#e.isTrusted=R}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(R){this.#e.supportThemeIcons=R}get supportHtml(){return this.#e.supportHtml}set supportHtml(R){this.#e.supportHtml=R}get baseUri(){return this.#e.baseUri}set baseUri(R){this.#e.baseUri=R}appendText(R){return this.#e.appendText(R),this}appendMarkdown(R){return this.#e.appendMarkdown(R),this}appendCodeblock(R,re){return this.#e.appendCodeblock(re??"",R),this}};e.$RM=Ge,e.$RM=Ge=a=Le([O],Ge);let Ze=class{constructor(R,re){this.label=R,this.documentation=re}};e.$SM=Ze,e.$SM=Ze=Le([O],Ze);let _e=class{constructor(R,re){this.label=R,this.documentation=re,this.parameters=[]}};e.$TM=_e,e.$TM=_e=Le([O],_e);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UM=tt,e.$UM=tt=Le([O],tt);var Qe;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(Qe||(e.SignatureHelpTriggerKind=Qe={}));var Je;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(Je||(e.InlayHintKind=Je={}));let xe=class{constructor(R){this.value=R}};e.$VM=xe,e.$VM=xe=Le([O],xe);let pe=class{constructor(R,re,ve){this.position=R,this.label=re,this.kind=ve}};e.$WM=pe,e.$WM=pe=Le([O],pe);var Pe;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pe||(e.CompletionTriggerKind=Pe={}));var je;(function(L){L[L.Text=0]="Text",L[L.Method=1]="Method",L[L.Function=2]="Function",L[L.Constructor=3]="Constructor",L[L.Field=4]="Field",L[L.Variable=5]="Variable",L[L.Class=6]="Class",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Unit=10]="Unit",L[L.Value=11]="Value",L[L.Enum=12]="Enum",L[L.Keyword=13]="Keyword",L[L.Snippet=14]="Snippet",L[L.Color=15]="Color",L[L.File=16]="File",L[L.Reference=17]="Reference",L[L.Folder=18]="Folder",L[L.EnumMember=19]="EnumMember",L[L.Constant=20]="Constant",L[L.Struct=21]="Struct",L[L.Event=22]="Event",L[L.Operator=23]="Operator",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue"})(je||(e.CompletionItemKind=je={}));var Ne;(function(L){L[L.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let Ue=class{constructor(R,re){this.label=R,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XM=Ue,e.$XM=Ue=Le([O],Ue);let Ve=class{constructor(R=[],re=!1){this.items=R,this.isIncomplete=re}};e.$YM=Ve,e.$YM=Ve=Le([O],Ve);let nt=class{constructor(R,re,ve){this.insertText=R,this.range=re,this.command=ve}};e.$ZM=nt,e.$ZM=nt=Le([O],nt);let Ye=class{constructor(R){this.commands=void 0,this.suppressSuggestions=void 0,this.items=R}};e.$1M=Ye,e.$1M=Ye=Le([O],Ye);var it;(function(L){L[L.Unknown=0]="Unknown",L[L.Word=1]="Word",L[L.Line=2]="Line",L[L.Suggest=3]="Suggest"})(it||(e.PartialAcceptTriggerKind=it={}));var at;(function(L){L[L.Active=-1]="Active",L[L.Beside=-2]="Beside",L[L.One=1]="One",L[L.Two=2]="Two",L[L.Three=3]="Three",L[L.Four=4]="Four",L[L.Five=5]="Five",L[L.Six=6]="Six",L[L.Seven=7]="Seven",L[L.Eight=8]="Eight",L[L.Nine=9]="Nine"})(at||(e.ViewColumn=at={}));var ot;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function ct(L,R){return`${w.$Vm.toKey(L)}.${R}`}var lt;(function(L){L[L.Off=0]="Off",L[L.On=1]="On",L[L.Relative=2]="Relative",L[L.Interval=3]="Interval"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var ft;(function(L){L[L.Manual=1]="Manual",L[L.AfterDelay=2]="AfterDelay",L[L.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var $t;(function(L){L[L.Default=0]="Default",L[L.InCenter=1]="InCenter",L[L.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",L[L.AtTop=3]="AtTop"})($t||(e.TextEditorRevealType=$t={}));var vt;(function(L){L[L.Keyboard=1]="Keyboard",L[L.Mouse=2]="Mouse",L[L.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Lt;(function(L){L[L.Undo=1]="Undo",L[L.Redo=2]="Redo"})(Lt||(e.TextDocumentChangeReason=Lt={}));var St;(function(L){L[L.OpenOpen=0]="OpenOpen",L[L.ClosedClosed=1]="ClosedClosed",L[L.OpenClosed=2]="OpenClosed",L[L.ClosedOpen=3]="ClosedOpen"})(St||(e.DecorationRangeBehavior=St={})),function(L){function R(re){switch(re){case"keyboard":return L.Keyboard;case"mouse":return L.Mouse;case"api":return L.Command}}L.fromValue=R}(vt||(e.TextEditorSelectionChangeKind=vt={}));var It;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(It||(e.SyntaxTokenType=It={})),function(L){function R(re){switch(re){case L.Other:return"other";case L.Comment:return"comment";case L.String:return"string";case L.RegEx:return"regex"}return"other"}L.toString=R}(It||(e.SyntaxTokenType=It={}));let Mt=class{constructor(R,re){if(re&&!$.URI.isUri(re))throw(0,j.$7)("target");if(!te.isRange(R)||R.isEmpty)throw(0,j.$7)("range");this.range=R,this.target=re}};e.$3M=Mt,e.$3M=Mt=Le([O],Mt);let mt=class{constructor(R,re,ve,ze){this.red=R,this.green=re,this.blue=ve,this.alpha=ze}};e.$4M=mt,e.$4M=mt=Le([O],mt);let Rt=class{constructor(R,re){if(re&&!(re instanceof mt))throw(0,j.$7)("color");if(!te.isRange(R)||R.isEmpty)throw(0,j.$7)("range");this.range=R,this.color=re}};e.$5M=Rt,e.$5M=Rt=Le([O],Rt);let pt=class{constructor(R){if(!R||typeof R!="string")throw(0,j.$7)("label");this.label=R}};e.$6M=pt,e.$6M=pt=Le([O],pt);var rt;(function(L){L[L.RGB=0]="RGB",L[L.HEX=1]="HEX",L[L.HSL=2]="HSL"})(rt||(e.ColorFormat=rt={}));var gt;(function(L){L[L.Error=0]="Error",L[L.Warning=1]="Warning",L[L.Information=2]="Information"})(gt||(e.SourceControlInputBoxValidationType=gt={}));var bt;(function(L){L[L.Unknown=0]="Unknown",L[L.Shutdown=1]="Shutdown",L[L.Process=2]="Process",L[L.User=3]="User",L[L.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Ht;(function(L){L[L.Low=0]="Low",L[L.Medium=1]="Medium",L[L.High=2]="High"})(Ht||(e.TerminalShellExecutionCommandLineConfidence=Ht={}));class _t{constructor(R,re,ve){if(this.startIndex=R,this.length=re,this.tooltip=ve,typeof R!="number"||R<0)throw(0,j.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,j.$7)("length");if(ve!==void 0&&typeof ve!="string")throw(0,j.$7)("tooltip")}}e.$7M=_t;class en{constructor(R){this.uri=R}}e.$8M=en;class Tt{constructor(R){this.terminalCommand=R}}e.$9M=Tt;var Ut;(function(L){L[L.Panel=1]="Panel",L[L.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class Vt{constructor(R){if(this.options=R,typeof R!="object")throw(0,j.$7)("options")}}e.$0M=Vt;var Wt;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(Wt||(e.TaskRevealKind=Wt={}));var Dt;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(Dt||(e.TaskPanelKind=Dt={}));let Gt=class{static{i=this}static{this.Clean=new i("clean","Clean")}static{this.Build=new i("build","Build")}static{this.Rebuild=new i("rebuild","Rebuild")}static{this.Test=new i("test","Test")}static from(R){switch(R){case"clean":return i.Clean;case"build":return i.Build;case"rebuild":return i.Rebuild;case"test":return i.Test;default:return}}constructor(R,re){if(this.label=re,typeof R!="string"||typeof re!="string")throw(0,j.$7)("name");this.c=R}get id(){return this.c}};e.$$M=Gt,e.$$M=Gt=i=Le([O],Gt);function tn(L){let R="";for(let re=0;re<L.length;re++)R+=L[re].replace(/,/g,",,")+",";return R}let xt=class{constructor(R,re,ve){if(typeof R!="string")throw(0,j.$7)("process");this.e=[],this.c=R,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=ve):this.f=re)}get process(){return this.c}set process(R){if(typeof R!="string")throw(0,j.$7)("process");this.c=R}get args(){return this.e}set args(R){Array.isArray(R)||(R=[]),this.e=R}get options(){return this.f}set options(R){this.f=R}computeId(){const R=[];if(R.push("process"),this.c!==void 0&&R.push(this.c),this.e&&this.e.length>0)for(const re of this.e)R.push(re);return tn(R)}};e.$_M=xt,e.$_M=xt=Le([O],xt);let Nt=class{constructor(R,re,ve){if(this.f=[],Array.isArray(re)){if(!R)throw(0,j.$7)("command can't be undefined or null");if(typeof R!="string"&&typeof R.value!="string")throw(0,j.$7)("command");this.e=R,this.f=re,this.g=ve}else{if(typeof R!="string")throw(0,j.$7)("commandLine");this.c=R,this.g=re}}get commandLine(){return this.c}set commandLine(R){if(typeof R!="string")throw(0,j.$7)("commandLine");this.c=R}get command(){return this.e?this.e:""}set command(R){if(typeof R!="string"&&typeof R.value!="string")throw(0,j.$7)("command");this.e=R}get args(){return this.f}set args(R){this.f=R||[]}get options(){return this.g}set options(R){this.g=R}computeId(){const R=[];if(R.push("shell"),this.c!==void 0&&R.push(this.c),this.e!==void 0&&R.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)R.push(typeof re=="string"?re:re.value);return tn(R)}};e.$aN=Nt,e.$aN=Nt=Le([O],Nt);var Jt;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var zt;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace"})(zt||(e.TaskScope=zt={}));class nn{constructor(R){this.c=R}computeId(){return"customExecution"+(0,y.$Wg)()}set callback(R){this.c=R}get callback(){return this.c}}e.$bN=nn;let rn=class{static{p=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(R,re,ve,ze,We,Ke){this.k=!1,this.l=this.definition=R;let et;typeof re=="string"?(this.o=this.name=re,this.w=this.source=ve,this.execution=ze,et=We,this.k=!0):re===zt.Global||re===zt.Workspace?(this.target=re,this.o=this.name=ve,this.w=this.source=ze,this.execution=We,et=Ke):(this.target=re,this.o=this.name=ve,this.w=this.source=ze,this.execution=We,et=Ke),typeof et=="string"?(this.r=[et],this.t=!0):Array.isArray(et)?(this.r=et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(R){this.j=R}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof xt?this.l={type:p.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:p.f,id:this.q.computeId()}:this.q instanceof nn?this.l={type:p.c,id:this.q.computeId()}:this.l={type:p.g,id:(0,y.$Wg)()}}get definition(){return this.l}set definition(R){if(R==null)throw(0,j.$7)("Kind can't be undefined or null");this.B(),this.l=R}get scope(){return this.m}set target(R){this.B(),this.m=R}get name(){return this.o}set name(R){if(typeof R!="string")throw(0,j.$7)("name");this.B(),this.o=R}get execution(){return this.q}set execution(R){R===null&&(R=void 0),this.B(),this.q=R;const re=this.l.type;(p.g===re||p.e===re||p.f===re||p.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(R){if(Array.isArray(R))this.B(),this.r=R,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(R){R!==!0&&R!==!1&&(R=!1),this.B(),this.u=R}get source(){return this.w}set source(R){if(typeof R!="string"||R.length===0)throw(0,j.$7)("source must be a string of length > 0");this.B(),this.w=R}get group(){return this.x}set group(R){R===null&&(R=void 0),this.B(),this.x=R}get detail(){return this.A}set detail(R){R===null&&(R=void 0),this.A=R}get presentationOptions(){return this.y}set presentationOptions(R){R==null&&(R=Object.create(null)),this.B(),this.y=R}get runOptions(){return this.z}set runOptions(R){R==null&&(R=Object.create(null)),this.B(),this.z=R}};e.$cN=rn,e.$cN=rn=p=Le([O],rn);var an;(function(L){L[L.SourceControl=1]="SourceControl",L[L.Window=10]="Window",L[L.Notification=15]="Notification"})(an||(e.ProgressLocation=an={}));var Qt;(function(L){function R(re){const ve=re;return(0,b.$eg)(ve.value)?ve.tooltip&&!(0,b.$ag)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}L.isViewBadge=R})(Qt||(e.ViewBadge=Qt={}));let Zt=k=class{static isTreeItem(R,re){const ve=R;if(ve.checkboxState!==void 0){const ze=(0,b.$eg)(ve.checkboxState)?ve.checkboxState:(0,b.$cg)(ve.checkboxState)&&(0,b.$eg)(ve.checkboxState.state)?ve.checkboxState.state:void 0,We=!(0,b.$eg)(ve.checkboxState)&&(0,b.$cg)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(ze===void 0||ze!==Xt.Checked&&ze!==Xt.Unchecked||We!==void 0&&!(0,b.$ag)(We))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(R instanceof k)return!0;if(ve.label!==void 0&&!(0,b.$ag)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,b.$ag)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,b.$ag)(ve.iconPath)&&!$.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,b.$ag)(ve.iconPath.id))){const ze=ve.iconPath;if(!ze||!(0,b.$ag)(ze.light)&&!$.URI.isUri(ze.light)&&!(0,b.$ag)(ze.dark)&&!$.URI.isUri(ze.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,b.$ag)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!$.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,b.$ag)(ve.tooltip)&&!(ve.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<Ct.None&&ve.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,b.$ag)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(R,re=Ct.None){this.collapsibleState=re,$.URI.isUri(R)?this.resourceUri=R:this.label=R}};e.$dN=Zt,e.$dN=Zt=k=Le([O],Zt);var Ct;(function(L){L[L.None=0]="None",L[L.Collapsed=1]="Collapsed",L[L.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Xt;(function(L){L[L.Unchecked=0]="Unchecked",L[L.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(R){this.value=R}};e.$eN=Yt,e.$eN=Yt=Le([O],Yt);class sn extends Yt{}e.$fN=sn;class cn extends sn{#e;constructor(R){super(""),this.#e=R}asFile(){return this.#e}}e.$gN=cn;class dn{constructor(R,re,ve,ze){this.name=R,this.uri=re,this._itemId=ve,this.c=ze}data(){return this.c()}}e.$hN=dn;let Kt=class{#e=new Map;constructor(R){for(const[re,ve]of R??[]){const ze=this.#e.get(this.#t(re));ze?ze.push(ve):this.#e.set(this.#t(re),[ve])}}get(R){return this.#e.get(this.#t(R))?.[0]}set(R,re){this.#e.set(this.#t(R),[re])}forEach(R,re){for(const[ve,ze]of this.#e)for(const We of ze)R.call(re,We,ve,this)}*[Symbol.iterator](){for(const[R,re]of this.#e)for(const ve of re)yield[R,ve]}#t(R){return R.toLowerCase()}};e.$iN=Kt,e.$iN=Kt=Le([O],Kt);let on=class{constructor(R,re,ve){this.insertText=R,this.title=re,this.kind=ve}};e.$jN=on,e.$jN=on=Le([O],on);var ln;(function(L){L[L.Automatic=0]="Automatic",L[L.PasteAs=1]="PasteAs"})(ln||(e.DocumentPasteTriggerKind=ln={}));class At{static{this.c="."}constructor(R){this.value=R}append(...R){return new At((this.value?[this.value,...R]:R).join(At.c))}intersects(R){return this.contains(R)||R.contains(this)}contains(R){return this.value===R.value||R.value.startsWith(this.value+At.c)}}e.$kN=At,At.Empty=new At("");class un{constructor(R,re,ve){this.title=re,this.insertText=R,this.kind=ve}}e.$lN=un;let yt=class{constructor(R,re){this.id=R,this.color=re}static isThemeIcon(R){return typeof R.id!="string"?(console.log("INVALID ThemeIcon, invalid id",R.id),!1):!0}};e.$mN=yt,e.$mN=yt=Le([O],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let be=class{constructor(R){this.id=R}};e.$nN=be,e.$nN=be=Le([O],be);var Ie;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.WorkspaceFolder=3]="WorkspaceFolder"})(Ie||(e.ConfigurationTarget=Ie={}));let me=class{get base(){return this.c}set base(R){this.c=R,this.e=$.URI.file(R)}get baseUri(){return this.e}set baseUri(R){this.e=R,this.c=R.fsPath}constructor(R,re){if(typeof R!="string"&&(!R||!$.URI.isUri(R)&&!$.URI.isUri(R.uri)))throw(0,j.$7)("base");if(typeof re!="string")throw(0,j.$7)("pattern");typeof R=="string"?this.baseUri=$.URI.file(R):$.URI.isUri(R)?this.baseUri=R:this.baseUri=R.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oN=me,e.$oN=me=Le([O],me);const q=new WeakMap;function Se(L,R){q.set(L,R)}let Re=class{constructor(R,re,ve,ze,We){this.enabled=typeof R=="boolean"?R:!0,typeof re=="string"&&(this.condition=re),typeof ve=="string"&&(this.hitCondition=ve),typeof ze=="string"&&(this.logMessage=ze),typeof We=="string"&&(this.mode=We)}get id(){return this.c||(this.c=q.get(this)??(0,y.$Wg)()),this.c}};e.$qN=Re,e.$qN=Re=Le([O],Re);let qe=class extends Re{constructor(R,re,ve,ze,We,Ke){if(super(re,ve,ze,We,Ke),R===null)throw(0,j.$7)("location");this.location=R}};e.$rN=qe,e.$rN=qe=Le([O],qe);let Te=class extends Re{constructor(R,re,ve,ze,We,Ke){super(re,ve,ze,We,Ke),this.functionName=R}};e.$sN=Te,e.$sN=Te=Le([O],Te);let Xe=class extends Re{constructor(R,re,ve,ze,We,Ke,et,ht){if(super(ze,We,Ke,et,ht),!re)throw(0,j.$7)("dataId");this.label=R,this.dataId=re,this.canPersist=ve}};e.$tN=Xe,e.$tN=Xe=Le([O],Xe);let st=class{constructor(R,re,ve){this.command=R,this.args=re||[],this.options=ve}};e.$uN=st,e.$uN=st=Le([O],st);let dt=class{constructor(R,re){this.port=R,this.host=re}};e.$vN=dt,e.$vN=dt=Le([O],dt);let wt=class{constructor(R){this.path=R}};e.$wN=wt,e.$wN=wt=Le([O],wt);let ut=class{constructor(R){this.implementation=R}};e.$xN=ut,e.$xN=ut=Le([O],ut);class Et{constructor(R,re,ve){this.session=R,this.threadId=re,this.frameId=ve}}e.$yN=Et;class Di{constructor(R,re){this.session=R,this.threadId=re}}e.$zN=Di;let wn=class{constructor(R,re){this.range=R,this.expression=re}};e.$AN=wn,e.$AN=wn=Le([O],wn);var Ln;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(Ln||(e.InlineCompletionTriggerKind=Ln={}));let vn=class{constructor(R,re){this.range=R,this.text=re}};e.$BN=vn,e.$BN=vn=Le([O],vn);let yn=class{constructor(R,re,ve=!0){this.range=R,this.variableName=re,this.caseSensitiveLookup=ve}};e.$CN=yn,e.$CN=yn=Le([O],yn);let En=class{constructor(R,re){this.range=R,this.expression=re}};e.$DN=En,e.$DN=En=Le([O],En);let kn=class{constructor(R,re){this.frameId=R,this.stoppedLocation=re}};e.$EN=kn,e.$EN=kn=Le([O],kn);var Mn;(function(L){L[L.AIGenerated=1]="AIGenerated"})(Mn||(e.NewSymbolNameTag=Mn={}));var Tn;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(Tn||(e.NewSymbolNameTriggerKind=Tn={}));class Pi{constructor(R,re){this.newSymbolName=R,this.tags=re}}e.$FN=Pi;var Un;(function(L){L[L.Changed=1]="Changed",L[L.Created=2]="Created",L[L.Deleted=3]="Deleted"})(Un||(e.FileChangeType=Un={}));let Dn=C=class extends Error{static FileExists(R){return new C(R,v.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(R){return new C(R,v.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(R){return new C(R,v.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(R){return new C(R,v.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(R){return new C(R,v.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(R){return new C(R,v.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(R,re=v.FileSystemProviderErrorCode.Unknown,ve){super($.URI.isUri(R)?R.toString(!0):R),this.code=ve?.name??"Unknown",(0,v.$jl)(this,re),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.$GN=Dn,e.$GN=Dn=C=Le([O],Dn);let Pn=class{constructor(R,re,ve){this.start=R,this.end=re,this.kind=ve}};e.$HN=Pn,e.$HN=Pn=Le([O],Pn);var zn;(function(L){L[L.Comment=1]="Comment",L[L.Imports=2]="Imports",L[L.Region=3]="Region"})(zn||(e.FoldingRangeKind=zn={}));var Bn;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(Bn||(e.CommentThreadCollapsibleState=Bn={}));var qn;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(qn||(e.CommentMode=qn={}));var Hn;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(Hn||(e.CommentState=Hn={}));var Vn;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})(Vn||(e.CommentThreadState=Vn={}));var Wn;(function(L){L[L.Current=0]="Current",L[L.Outdated=1]="Outdated"})(Wn||(e.CommentThreadApplicability=Wn={}));class Si{constructor(R,re=[]){this.tokenTypes=R,this.tokenModifiers=re}}e.$IN=Si;function Ii(L){return typeof L>"u"||(0,b.$bg)(L)}class Sn{constructor(R){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,R){this.m=!0;for(let re=0,ve=R.tokenTypes.length;re<ve;re++)this.k.set(R.tokenTypes[re],re);for(let re=0,ve=R.tokenModifiers.length;re<ve;re++)this.l.set(R.tokenModifiers[re],re)}}push(R,re,ve,ze,We){if(typeof R=="number"&&typeof re=="number"&&typeof ve=="number"&&typeof ze=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.q(R,re,ve,ze,We);if(te.isRange(R)&&typeof re=="string"&&Ii(ve))return this.o(R,re,ve);throw(0,j.$7)()}o(R,re,ve){if(!this.m)throw new Error("Legend must be provided in constructor");if(R.start.line!==R.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const ze=R.start.line,We=R.start.character,Ke=R.end.character-R.start.character,et=this.k.get(re);let ht=0;if(ve)for(const kt of ve){if(!this.l.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this.l.get(kt);ht|=1<<Pt>>>0}this.q(ze,We,Ke,et,ht)}q(R,re,ve,ze,We){if(this.f&&(R<this.c||R===this.c&&re<this.e)){this.f=!1;const ht=this.g.length/5|0;let kt=0,Pt=0;for(let Ot=0;Ot<ht;Ot++){let Ft=this.g[5*Ot],hn=this.g[5*Ot+1];Ft===0?(Ft=kt,hn+=Pt):Ft+=kt,this.g[5*Ot]=Ft,this.g[5*Ot+1]=hn,kt=Ft,Pt=hn}}let Ke=R,et=re;this.f&&this.j>0&&(Ke-=this.c,Ke===0&&(et-=this.e)),this.g[this.j++]=Ke,this.g[this.j++]=et,this.g[this.j++]=ve,this.g[this.j++]=ze,this.g[this.j++]=We,this.c=R,this.e=re}static r(R){const re=[],ve=R.length/5|0;for(let et=0;et<ve;et++)re[et]=et;re.sort((et,ht)=>{const kt=R[5*et],Pt=R[5*ht];if(kt===Pt){const Ot=R[5*et+1],Ft=R[5*ht+1];return Ot-Ft}return kt-Pt});const ze=new Uint32Array(R.length);let We=0,Ke=0;for(let et=0;et<ve;et++){const ht=5*re[et],kt=R[ht+0],Pt=R[ht+1],Ot=R[ht+2],Ft=R[ht+3],hn=R[ht+4],ki=kt-We,br=ki===0?Pt-Ke:Pt,fn=5*et;ze[fn+0]=ki,ze[fn+1]=br,ze[fn+2]=Ot,ze[fn+3]=Ft,ze[fn+4]=hn,We=kt,Ke=Pt}return ze}build(R){return this.f?new In(new Uint32Array(this.g),R):new In(Sn.r(this.g),R)}}e.$JN=Sn;class In{constructor(R,re){this.resultId=re,this.data=R}}e.$KN=In;class Ci{constructor(R,re,ve){this.start=R,this.deleteCount=re,this.data=ve}}e.$LN=Ci;class Ai{constructor(R,re){this.resultId=re,this.edits=R}}e.$MN=Ai;var Gn;(function(L){L[L.Separate=0]="Separate",L[L.MergeWithParent=1]="MergeWithParent"})(Gn||(e.DebugConsoleMode=Gn={}));class ji{constructor(R){this.name=R}}e.$NN=ji;let Cn=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$ON=Cn,e.$ON=Cn=Le([O],Cn);var xn;(function(L){L[L.Separator=-1]="Separator",L[L.Default=0]="Default"})(xn||(e.QuickPickItemKind=xn={}));var Jn;(function(L){L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(Jn||(e.InputBoxValidationSeverity=Jn={}));var Qn;(function(L){L[L.UI=1]="UI",L[L.Workspace=2]="Workspace"})(Qn||(e.ExtensionKind=Qn={}));class Oi{static validate(R){if(typeof R.badge=="string"){let re=(0,P.$Lf)(R.badge,0);if(re<R.badge.length&&(re+=(0,P.$Lf)(R.badge,re)),R.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(R.badge&&!yt.isThemeIcon(R.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!R.color&&!R.badge&&!R.tooltip)throw new Error("The decoration is empty");return!0}constructor(R,re,ve){this.badge=R,this.tooltip=re,this.color=ve}}e.$PN=Oi;let An=class{constructor(R){this.kind=R}};e.$QN=An,e.$QN=An=Le([O],An);var Zn;(function(L){L[L.Light=1]="Light",L[L.Dark=2]="Dark",L[L.HighContrast=3]="HighContrast",L[L.HighContrastLight=4]="HighContrastLight"})(Zn||(e.ColorThemeKind=Zn={}));class Bt{static isNotebookRange(R){return R instanceof Bt?!0:R?typeof R.start=="number"&&typeof R.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(R,re){if(R<0)throw(0,j.$7)("start must be positive");if(re<0)throw(0,j.$7)("end must be positive");R<=re?(this.c=R,this.e=re):(this.c=re,this.e=R)}with(R){let re=this.c,ve=this.e;return R.start!==void 0&&(re=R.start),R.end!==void 0&&(ve=R.end),re===this.c&&ve===this.e?this:new Bt(re,ve)}}e.$RN=Bt;class mn{static validate(R){if(typeof R.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof R.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof R.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(R){return Array.isArray(R)&&R.every(re=>mn.isNotebookCellData(re))}static isNotebookCellData(R){return!0}constructor(R,re,ve,ze,We,Ke,et){this.kind=R,this.value=re,this.languageId=ve,this.mime=ze,this.outputs=We??[],this.metadata=Ke,this.executionSummary=et,mn.validate(this)}}e.$SN=mn;class Ri{constructor(R){this.cells=R}}e.$TN=Ri;class jt{static isNotebookCellOutputItem(R){return R instanceof jt?!0:R?typeof R.mime=="string"&&R.data instanceof Uint8Array:!1}static error(R){const re={name:R.name,message:R.message,stack:R.stack};return jt.json(re,"application/vnd.code.notebook.error")}static stdout(R){return jt.text(R,"application/vnd.code.notebook.stdout")}static stderr(R){return jt.text(R,"application/vnd.code.notebook.stderr")}static bytes(R,re="application/octet-stream"){return new jt(R,re)}static#e=new TextEncoder;static text(R,re=S.$Ws.text){const ve=jt.#e.encode(String(R));return new jt(ve,re)}static json(R,re="text/x-json"){const ve=JSON.stringify(R,void 0,"	");return jt.text(ve,re)}constructor(R,re){this.data=R,this.mime=re;const ve=(0,S.$1s)(re,!0);if(!ve)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.$UN=jt;class gn{static isNotebookCellOutput(R){return R instanceof gn?!0:!R||typeof R!="object"?!1:typeof R.id=="string"&&Array.isArray(R.items)}static ensureUniqueMimeTypes(R,re=!1){const ve=new Set,ze=new Set;for(let We=0;We<R.length;We++){const Ke=R[We],et=(0,S.$1s)(Ke.mime);if(!ve.has(et)||(0,l.$jK)(et)){ve.add(et);continue}ze.add(We),re&&console.warn(`DUPLICATED mime type '${Ke.mime}' will be dropped`)}return ze.size===0?R:R.filter((We,Ke)=>!ze.has(Ke))}constructor(R,re,ve){this.items=gn.ensureUniqueMimeTypes(R,!0),typeof re=="string"?(this.id=re,this.metadata=ve):(this.id=(0,y.$Wg)(),this.metadata=re??ve)}}e.$VN=gn;var Xn;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Yn;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(Yn||(e.NotebookCellExecutionState=Yn={}));var Kn;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(Kn||(e.NotebookCellStatusBarAlignment=Kn={}));var _n;(function(L){L[L.Default=0]="Default",L[L.InCenter=1]="InCenter",L[L.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",L[L.AtTop=3]="AtTop"})(_n||(e.NotebookEditorRevealType=_n={}));class Ni{constructor(R,re){this.text=R,this.alignment=re}}e.$WN=Ni;var ei;(function(L){L[L.Default=1]="Default",L[L.Preferred=2]="Preferred"})(ei||(e.NotebookControllerAffinity=ei={}));var ti;(function(L){L[L.Default=1]="Default",L[L.Preferred=2]="Preferred",L[L.Hidden=-1]="Hidden"})(ti||(e.NotebookControllerAffinity2=ti={}));class Fi{constructor(R,re=[]){this.uri=R,this.provides=(0,s.$2b)(re)}}e.$XN=Fi;class Li{constructor(R){this.label=R}}e.$YN=Li;var ni;(function(L){L[L.Named=1]="Named",L[L.Indexed=2]="Indexed"})(ni||(e.NotebookVariablesRequestKind=ni={}));let jn=class{constructor(R,re){this.label=R,this.timestamp=re}};e.$ZN=jn,e.$ZN=jn=Le([O],jn);var ii;(function(L){L[L.Production=1]="Production",L[L.Development=2]="Development",L[L.Test=3]="Test"})(ii||(e.ExtensionMode=ii={}));var ri;(function(L){L[L.Node=1]="Node",L[L.Webworker=2]="Webworker"})(ri||(e.ExtensionRuntime=ri={}));var si;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(si||(e.StandardTokenType=si={}));class Mi{constructor(R,re){this.ranges=R,this.wordPattern=re}}e.$1N=Mi;class Ti{constructor(R){this.c=R}get autoForwardAction(){return this.c}}e.$2N=Ti;var oi;(function(L){L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(oi||(e.TestResultState=oi={}));var ai;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(ai||(e.TestRunProfileKind=ai={}));let On=class{constructor(R=void 0,re=void 0,ve=void 0,ze=!1,We=!0){this.include=R,this.exclude=re,this.profile=ve,this.continuous=ze,this.preserveFocus=We}};e.$3N=On,e.$3N=On=Le([O],On);let Rn=A=class{static diff(R,re,ve){const ze=new A(R);return ze.expectedOutput=re,ze.actualOutput=ve,ze}constructor(R){this.message=R}};e.$4N=Rn,e.$4N=Rn=A=Le([O],Rn);let Nn=class{constructor(R){this.id=R}};e.$5N=Nn,e.$5N=Nn=Le([O],Nn);class $n{constructor(R,re){this.covered=R,this.total=re,ci(this)}}e.$6N=$n;function ci(L){if(L){if(L.covered>L.total)throw new Error(`The total number of covered items (${L.covered}) cannot be greater than the total (${L.total})`);if(L.total<0)throw new Error(`The number of covered items (${L.total}) cannot be negative`)}}class Fn{static fromDetails(R,re){const ve=new $n(0,0),ze=new $n(0,0),We=new $n(0,0);for(const et of re)if("branches"in et){ve.total+=1,ve.covered+=et.executed?1:0;for(const ht of et.branches)ze.total+=1,ze.covered+=ht.executed?1:0}else We.total+=1,We.covered+=et.executed?1:0;const Ke=new Fn(R,ve,ze.total>0?ze:void 0,We.total>0?We:void 0);return Ke.detailedCoverage=re,Ke}constructor(R,re,ve,ze,We){this.uri=R,this.statementCoverage=re,this.branchCoverage=ve,this.declarationCoverage=ze,this.testItem=We}}e.$8N=Fn;class Ui{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,re,ve=[]){this.executed=R,this.location=re,this.branches=ve}}e.$9N=Ui;class zi{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,re,ve){this.executed=R,this.location=re,this.label=ve}}e.$0N=zi;class Bi{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,re,ve){this.name=R,this.executed=re,this.location=ve}}e.$$N=Bi;var li;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(li||(e.ExternalUriOpenerPriority=li={}));var ui;(function(L){L[L.Untrusted=0]="Untrusted",L[L.Trusted=1]="Trusted",L[L.Unspecified=2]="Unspecified"})(ui||(e.WorkspaceTrustState=ui={}));var hi;(function(L){L[L.Notify=1]="Notify",L[L.OpenBrowser=2]="OpenBrowser",L[L.OpenPreview=3]="OpenPreview",L[L.Silent=4]="Silent",L[L.Ignore=5]="Ignore",L[L.OpenBrowserOnce=6]="OpenBrowserOnce"})(hi||(e.PortAutoForwardAction=hi={}));class qi{constructor(R,re,ve,ze,We,Ke){this.kind=R,this.name=re,this.detail=ve,this.uri=ze,this.range=We,this.selectionRange=Ke}}e.$_N=qi;class Hi{constructor(R){this.uri=R}}e.$aO=Hi;class Vi{constructor(R,re){this.original=R,this.modified=re}}e.$bO=Vi;class Wi{constructor(R,re,ve,ze){this.base=R,this.input1=re,this.input2=ve,this.result=ze}}e.$cO=Wi;class Gi{constructor(R,re){this.uri=R,this.viewType=re}}e.$dO=Gi;class xi{constructor(R){this.viewType=R}}e.$eO=xi;class Ji{constructor(R,re){this.uri=R,this.notebookType=re}}e.$fO=Ji;class Qi{constructor(R,re,ve){this.original=R,this.modified=re,this.notebookType=ve}}e.$gO=Qi;class Zi{constructor(){}}e.$hO=Zi;class Xi{constructor(R,re){this.uri=R,this.inputBoxUri=re}}e.$iO=Xi;class Yi{constructor(){}}e.$jO=Yi;class Ki{constructor(R){this.textDiffs=R}}e.$kO=Ki;var fi;(function(L){L[L.Down=0]="Down",L[L.Up=1]="Up"})(fi||(e.InteractiveSessionVoteDirection=fi={}));var di;(function(L){L[L.Action=1]="Action",L[L.Toolbar=2]="Toolbar"})(di||(e.ChatCopyKind=di={}));var mi;(function(L){L[L.Short=1]="Short",L[L.Medium=2]="Medium",L[L.Full=3]="Full"})(mi||(e.ChatVariableLevel=mi={}));class _i{constructor(R,re,ve){this.id=R,this.label=re,this.values=ve}}e.$lO=_i;var gi;(function(L){L[L.Unhelpful=0]="Unhelpful",L[L.Helpful=1]="Helpful",L[L.Undone=2]="Undone",L[L.Accepted=3]="Accepted",L[L.Bug=4]="Bug"})(gi||(e.InteractiveEditorResponseFeedbackKind=gi={}));var $i;(function(L){L[L.Unhelpful=0]="Unhelpful",L[L.Helpful=1]="Helpful"})($i||(e.ChatResultFeedbackKind=$i={}));class er{constructor(R){if(typeof R!="string"&&R.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof R=="string"?new Ge(R):R}}e.$mO=er;class tr{constructor(R,re){if(typeof R!="string"&&R.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof R=="string"?new Ge(R):R,this.vulnerabilities=re}}e.$nO=tr;class nr{constructor(R,re){this.participant=R,this.command=re}}e.$oO=nr;class ir{constructor(R,re,ve){this.title=R,this.message=re,this.data=ve}}e.$pO=ir;class rr{constructor(R,re){this.value=R,this.baseUri=re}}e.$qO=rr;class sr{constructor(R,re){this.value=R,this.title=re}}e.$rO=sr;class or{constructor(R){this.value=R}}e.$sO=or;class ar{constructor(R,re){this.value=R,this.task=re}}e.$tO=ar;class cr{constructor(R){if(typeof R!="string"&&R.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof R=="string"?new Ge(R):R}}e.$uO=cr;class lr{constructor(R){this.value=R}}e.$vO=lr;class ur{constructor(R,re){this.value=R,this.iconPath=re}}e.$wO=ur;class hr{constructor(R,re){this.uri=R,this.edits=Array.isArray(re)?re:[re]}}e.$xO=hr;class fr{constructor(R,re,ve,ze){this.prompt=R,this.command=re,this.references=ve,this.participant=ze}}e.$yO=fr;class dr{constructor(R,re,ve,ze){this.response=R,this.result=re,this.participant=ve,this.command=ze}}e.$zO=dr;var pi;(function(L){L[L.Panel=1]="Panel",L[L.Terminal=2]="Terminal",L[L.Notebook=3]="Notebook",L[L.Editor=4]="Editor"})(pi||(e.ChatLocation=pi={}));var pn;(function(L){L[L.User=1]="User",L[L.Assistant=2]="Assistant",L[L.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class bn{static User(R,re){return new bn(pn.User,R,re)}static Assistant(R,re){return new bn(pn.Assistant,R,re)}constructor(R,re,ve){this.role=R,this.content=re,this.name=ve}}e.$AO=bn;class mr{constructor(R){this.content=R}}e.$BO=mr;class gr{constructor(R,re){this.content=R,this.name=re}}e.$CO=gr;class $r{constructor(R,re){this.content=R,this.name=re}}e.$DO=$r;class qt extends Error{static NotFound(R){return new qt(R,qt.NotFound.name)}static NoPermissions(R){return new qt(R,qt.NoPermissions.name)}static Blocked(R){return new qt(R,qt.Blocked.name)}constructor(R,re,ve){super(R,{cause:ve}),this.name="LanguageModelError",this.code=re??""}}e.$EO=qt;var bi;(function(L){L[L.SymbolInformation=1]="SymbolInformation",L[L.CommandInformation=2]="CommandInformation",L[L.SearchInformation=3]="SearchInformation",L[L.SettingInformation=4]="SettingInformation"})(bi||(e.RelatedInformationType=bi={}));var wi;(function(L){L[L.Started=1]="Started",L[L.Recognizing=2]="Recognizing",L[L.Recognized=3]="Recognized",L[L.Stopped=4]="Stopped",L[L.Error=5]="Error"})(wi||(e.SpeechToTextStatus=wi={}));var vi;(function(L){L[L.Started=1]="Started",L[L.Stopped=2]="Stopped",L[L.Error=3]="Error"})(vi||(e.TextToSpeechStatus=vi={}));var yi;(function(L){L[L.Recognized=1]="Recognized",L[L.Stopped=2]="Stopped"})(yi||(e.KeywordRecognitionStatus=yi={}));class pr{constructor(R,re){this.text=R,this.range=re}}e.$FO=pr;var Ei;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(Ei||(e.InlineEditTriggerKind=Ei={}))}),define(ye[144],Ee([1,0,18,15,165,75,102,24,152,46,65,21,158,19,76,10,4,45,187,244,138,95,283,142,72,96,140,143]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$OO=B,e.$PO=Y,e.$QO=M;var p;(function(be){function Ie(q){const{selectionStartLineNumber:Se,selectionStartColumn:Re,positionLineNumber:qe,positionColumn:Te}=q,Xe=new i.$qM(Se-1,Re-1),st=new i.$qM(qe-1,Te-1);return new i.$sM(Xe,st)}be.to=Ie;function me(q){const{anchor:Se,active:Re}=q;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}be.from=me})(p||(e.Selection=p={}));var k;(function(be){function Ie(q){if(!q)return;const{start:Se,end:Re}=q;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}be.from=Ie;function me(q){if(!q)return;const{startLineNumber:Se,startColumn:Re,endLineNumber:qe,endColumn:Te}=q;return new i.$rM(Se-1,Re-1,qe-1,Te-1)}be.to=me})(k||(e.Range=k={}));var C;(function(be){function Ie(q){return{uri:q.uri,range:k.from(q.range)}}be.from=Ie;function me(q){return new i.$BM(u.URI.revive(q.uri),k.to(q.range))}be.to=me})(C||(e.Location=C={}));var A;(function(be){function Ie(me){switch(me){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}be.to=Ie})(A||(e.TokenType=A={}));var O;(function(be){function Ie(q){return new i.$qM(q.lineNumber-1,q.column-1)}be.to=Ie;function me(q){return{lineNumber:q.line+1,column:q.character+1}}be.from=me})(O||(e.Position=O={}));var N;(function(be){function Ie(Se,Re,qe){return(0,s.$Hb)((0,s.$2b)(Se).map(Te=>me(Te,Re,qe)))}be.from=Ie;function me(Se,Re,qe){if(typeof Se=="string")return{$serialized:!0,language:Se,isBuiltin:qe?.isBuiltin};if(Se)return{$serialized:!0,language:Se.language,scheme:q(Se.scheme,Re),pattern:Ve.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType,isBuiltin:qe?.isBuiltin}}function q(Se,Re){return Re&&typeof Se=="string"?Re.transformOutgoingScheme(Se):Se}})(N||(e.DocumentSelector=N={}));var V;(function(be){function Ie(q){switch(q){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}be.from=Ie;function me(q){switch(q){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}be.to=me})(V||(e.DiagnosticTag=V={}));var ie;(function(be){function Ie(q){let Se;return q.code&&((0,c.$ag)(q.code)||(0,c.$eg)(q.code)?Se=String(q.code):Se={value:String(q.code.value),target:q.code.target}),{...k.from(q.range),message:q.message,source:q.source,code:Se,severity:te.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(ae.from),tags:Array.isArray(q.tags)?(0,s.$Hb)(q.tags.map(V.from)):void 0}}be.from=Ie;function me(q){const Se=new i.$DM(k.to(q),q.message,te.to(q.severity));return Se.source=q.source,Se.code=(0,c.$ag)(q.code)?q.code:q.code?.value,Se.relatedInformation=q.relatedInformation&&q.relatedInformation.map(ae.to),Se.tags=q.tags&&(0,s.$Hb)(q.tags.map(V.to)),Se}be.to=me})(ie||(e.Diagnostic=ie={}));var ae;(function(be){function Ie(q){return{...k.from(q.location.range),message:q.message,resource:q.location.uri}}be.from=Ie;function me(q){return new i.$CM(new i.$BM(q.resource,k.to(q)),q.message)}be.to=me})(ae||(e.DiagnosticRelatedInformation=ae={}));var te;(function(be){function Ie(q){switch(q){case i.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}be.from=Ie;function me(q){switch(q){case d.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}be.to=me})(te||(e.DiagnosticSeverity=te={}));var ee;(function(be){function Ie(q){return typeof q=="number"&&q>=i.ViewColumn.One?q-1:q===i.ViewColumn.Beside?a.$$D:a.$0D}be.from=Ie;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=me})(ee||(e.ViewColumn=ee={}));function K(be){return typeof be.range<"u"}function B(be){return be.length===0?!0:!!K(be[0])}var Z;(function(be){function Ie(Te){return Te.map(be.from)}be.fromMany=Ie;function me(Te){return Te&&typeof Te=="object"&&typeof Te.language=="string"&&typeof Te.value=="string"}function q(Te){let Xe;if(me(Te)){const{language:ut,value:Et}=Te;Xe={value:"```"+ut+`
`+Et+"\n```\n"}}else i.$RM.isMarkdownString(Te)?Xe={value:Te.value,isTrusted:Te.isTrusted,supportThemeIcons:Te.supportThemeIcons,supportHtml:Te.supportHtml,baseUri:Te.baseUri}:typeof Te=="string"?Xe={value:Te}:Xe={value:""};const st=Object.create(null);Xe.uris=st;const dt=ut=>{try{let Et=u.URI.parse(ut,!0);Et=Et.with({query:Se(Et.query,st)}),st[ut]=Et}catch{}return""},wt=new b.marked.Renderer;return wt.link=dt,wt.image=ut=>typeof ut=="string"?dt(S.$6k(ut).href):"",(0,b.marked)(Xe.value,{renderer:wt}),Xe}be.from=q;function Se(Te,Xe){if(!Te)return Te;let st;try{st=(0,$.$9h)(Te)}catch{}if(!st)return Te;let dt=!1;return st=(0,w.$9n)(st,wt=>{if(u.URI.isUri(wt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[ut]=wt,dt=!0,ut}else return}),dt?JSON.stringify(st):Te}function Re(Te){const Xe=new i.$RM(Te.value,Te.supportThemeIcons);return Xe.isTrusted=Te.isTrusted,Xe.supportHtml=Te.supportHtml,Xe.baseUri=Te.baseUri?u.URI.from(Te.baseUri):void 0,Xe}be.to=Re;function qe(Te){if(Te)return typeof Te=="string"?Te:be.from(Te)}be.fromStrict=qe})(Z||(e.MarkdownString=Z={}));function Y(be){return B(be)?be.map(Ie=>({range:k.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Z.fromMany(Ie.hoverMessage):Ie.hoverMessage?Z.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):be.map(Ie=>({range:k.from(Ie)}))}function M(be){return typeof be>"u"?be:typeof be=="string"?u.URI.file(be):be}var z;(function(be){function Ie(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?M(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}be.from=Ie})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var oe;(function(be){function Ie(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?M(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?z.from(me.before):void 0,after:me.after?z.from(me.after):void 0}}be.from=Ie})(oe||(e.ThemableDecorationRenderOptions=oe={}));var se;(function(be){function Ie(me){if(typeof me>"u")return me;switch(me){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Ie})(se||(e.DecorationRangeBehavior=se={}));var _;(function(be){function Ie(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?se.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?oe.from(me.light):void 0,dark:me.dark?oe.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?M(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?z.from(me.before):void 0,after:me.after?z.from(me.after):void 0}}be.from=Ie})(_||(e.DecorationRenderOptions=_={}));var H;(function(be){function Ie(q){return{text:q.newText,eol:q.newEol&&pe.from(q.newEol),range:k.from(q.range)}}be.from=Ie;function me(q){const Se=new i.$wM(k.to(q.range),q.text);return Se.newEol=typeof q.eol>"u"?void 0:pe.to(q.eol),Se}be.to=me})(H||(e.TextEdit=H={}));var ne;(function(be){function Ie(q,Se){const Re={edits:[]};if(q instanceof i.$zM){const qe=new P.$Bc;for(const Te of q._allEntries())Te._type===1&&u.URI.isUri(Te.to)&&Te.from===void 0&&qe.add(Te.to);for(const Te of q._allEntries())if(Te._type===1){let Xe;Te.options?.contents&&(ArrayBuffer.isView(Te.options.contents)?Xe={type:"base64",value:(0,j.$4e)(j.$Je.wrap(Te.options.contents))}:Xe={type:"dataTransferItem",id:Te.options.contents._itemId}),Re.edits.push({oldResource:Te.from,newResource:Te.to,options:{...Te.options,contents:Xe},metadata:Te.metadata})}else Te._type===2?Re.edits.push({resource:Te.uri,textEdit:H.from(Te.edit),versionId:qe.has(Te.uri)?void 0:Se?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===6?Re.edits.push({resource:Te.uri,textEdit:{range:k.from(Te.range),text:Te.edit.value,insertAsSnippet:!0},versionId:qe.has(Te.uri)?void 0:Se?.getTextDocumentVersion(Te.uri),metadata:Te.metadata}):Te._type===3?Re.edits.push({metadata:Te.metadata,resource:Te.uri,cellEdit:Te.edit,notebookMetadata:Te.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(Te.uri)}):Te._type===5&&Re.edits.push({metadata:Te.metadata,resource:Te.uri,notebookVersionId:Se?.getNotebookDocumentVersion(Te.uri),cellEdit:{editType:1,index:Te.index,count:Te.count,cells:Te.cells.map(ft.from)}})}return Re}be.from=Ie;function me(q){const Se=new i.$zM,Re=new P.$Ac;for(const qe of q.edits)if(qe.textEdit){const Te=qe,Xe=u.URI.revive(Te.resource),st=k.to(Te.textEdit.range),dt=Te.textEdit.text,wt=Te.textEdit.insertAsSnippet;let ut;wt?ut=i.$yM.replace(st,new i.$AM(dt)):ut=i.$wM.replace(st,dt);const Et=Re.get(Xe);Et?Et.push(ut):Re.set(Xe,[ut])}else Se.renameFile(u.URI.revive(qe.oldResource),u.URI.revive(qe.newResource),qe.options);for(const[qe,Te]of Re)Se.set(qe,Te);return Se}be.to=me})(ne||(e.WorkspaceEdit=ne={}));var le;(function(be){const Ie=Object.create(null);Ie[i.SymbolKind.File]=0,Ie[i.SymbolKind.Module]=1,Ie[i.SymbolKind.Namespace]=2,Ie[i.SymbolKind.Package]=3,Ie[i.SymbolKind.Class]=4,Ie[i.SymbolKind.Method]=5,Ie[i.SymbolKind.Property]=6,Ie[i.SymbolKind.Field]=7,Ie[i.SymbolKind.Constructor]=8,Ie[i.SymbolKind.Enum]=9,Ie[i.SymbolKind.Interface]=10,Ie[i.SymbolKind.Function]=11,Ie[i.SymbolKind.Variable]=12,Ie[i.SymbolKind.Constant]=13,Ie[i.SymbolKind.String]=14,Ie[i.SymbolKind.Number]=15,Ie[i.SymbolKind.Boolean]=16,Ie[i.SymbolKind.Array]=17,Ie[i.SymbolKind.Object]=18,Ie[i.SymbolKind.Key]=19,Ie[i.SymbolKind.Null]=20,Ie[i.SymbolKind.EnumMember]=21,Ie[i.SymbolKind.Struct]=22,Ie[i.SymbolKind.Event]=23,Ie[i.SymbolKind.Operator]=24,Ie[i.SymbolKind.TypeParameter]=25;function me(Se){return typeof Ie[Se]=="number"?Ie[Se]:6}be.from=me;function q(Se){for(const Re in Ie)if(Ie[Re]===Se)return Number(Re);return i.SymbolKind.Property}be.to=q})(le||(e.SymbolKind=le={}));var F;(function(be){function Ie(q){switch(q){case i.SymbolTag.Deprecated:return 1}}be.from=Ie;function me(q){switch(q){case 1:return i.SymbolTag.Deprecated}}be.to=me})(F||(e.SymbolTag=F={}));var U;(function(be){function Ie(q){return{name:q.name,kind:le.from(q.kind),tags:q.tags&&q.tags.map(F.from),containerName:q.containerName,location:J.from(q.location)}}be.from=Ie;function me(q){const Se=new i.$IM(q.name,le.to(q.kind),q.containerName,J.to(q.location));return Se.tags=q.tags&&q.tags.map(F.to),Se}be.to=me})(U||(e.WorkspaceSymbol=U={}));var X;(function(be){function Ie(q){const Se={name:q.name||"!!MISSING: name!!",detail:q.detail,range:k.from(q.range),selectionRange:k.from(q.selectionRange),kind:le.from(q.kind),tags:q.tags?.map(F.from)??[]};return q.children&&(Se.children=q.children.map(Ie)),Se}be.from=Ie;function me(q){const Se=new i.$JM(q.name,q.detail,le.to(q.kind),k.to(q.range),k.to(q.selectionRange));return(0,s.$Lb)(q.tags)&&(Se.tags=q.tags.map(F.to)),q.children&&(Se.children=q.children.map(me)),Se}be.to=me})(X||(e.DocumentSymbol=X={}));var x;(function(be){function Ie(q){const Se=new i.$NM(le.to(q.kind),q.name,q.detail||"",u.URI.revive(q.uri),k.to(q.range),k.to(q.selectionRange));return Se._sessionId=q._sessionId,Se._itemId=q._itemId,Se}be.to=Ie;function me(q,Se,Re){if(Se=Se??q._sessionId,Re=Re??q._itemId,Se===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Re,name:q.name,detail:q.detail,kind:le.from(q.kind),uri:q.uri,range:k.from(q.range),selectionRange:k.from(q.selectionRange),tags:q.tags?.map(F.from)}}be.from=me})(x||(e.CallHierarchyItem=x={}));var Q;(function(be){function Ie(me){return new i.$OM(x.to(me.from),me.fromRanges.map(q=>k.to(q)))}be.to=Ie})(Q||(e.CallHierarchyIncomingCall=Q={}));var G;(function(be){function Ie(me){return new i.$PM(x.to(me.to),me.fromRanges.map(q=>k.to(q)))}be.to=Ie})(G||(e.CallHierarchyOutgoingCall=G={}));var J;(function(be){function Ie(q){return{range:q.range&&k.from(q.range),uri:q.uri}}be.from=Ie;function me(q){return new i.$BM(u.URI.revive(q.uri),k.to(q.range))}be.to=me})(J||(e.location=J={}));var T;(function(be){function Ie(q){const Se=q,Re=q;return{originSelectionRange:Se.originSelectionRange?k.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Re.uri,range:k.from(Se.targetRange?Se.targetRange:Re.range),targetSelectionRange:Se.targetSelectionRange?k.from(Se.targetSelectionRange):void 0}}be.from=Ie;function me(q){return{targetUri:u.URI.revive(q.uri),targetRange:k.to(q.range),targetSelectionRange:q.targetSelectionRange?k.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?k.to(q.originSelectionRange):void 0}}be.to=me})(T||(e.DefinitionLink=T={}));var W;(function(be){function Ie(q){return{range:k.from(q.range),contents:Z.fromMany(q.contents),canIncreaseVerbosity:q.canIncreaseVerbosity,canDecreaseVerbosity:q.canDecreaseVerbosity}}be.from=Ie;function me(q){const Se=q.contents.map(Z.to),Re=k.to(q.range),qe=q.canIncreaseVerbosity,Te=q.canDecreaseVerbosity;return new i.$FM(Se,Re,qe,Te)}be.to=me})(W||(e.Hover=W={}));var ce;(function(be){function Ie(q){return{range:k.from(q.range),expression:q.expression}}be.from=Ie;function me(q){return new i.$AN(k.to(q.range),q.expression)}be.to=me})(ce||(e.EvaluatableExpression=ce={}));var ue;(function(be){function Ie(q){if(q instanceof i.$BN)return{type:"text",range:k.from(q.range),text:q.text};if(q instanceof i.$CN)return{type:"variable",range:k.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof i.$DN)return{type:"expression",range:k.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Ie;function me(q){switch(q.type){case"text":return{range:k.to(q.range),text:q.text};case"variable":return{range:k.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:k.to(q.range),expression:q.expression}}}be.to=me})(ue||(e.InlineValue=ue={}));var we;(function(be){function Ie(q){return{frameId:q.frameId,stoppedLocation:k.from(q.stoppedLocation)}}be.from=Ie;function me(q){return new i.$EN(q.frameId,k.to(q.stoppedLocation))}be.to=me})(we||(e.InlineValueContext=we={}));var de;(function(be){function Ie(q){return{range:k.from(q.range),kind:q.kind}}be.from=Ie;function me(q){return new i.$GM(k.to(q.range),q.kind)}be.to=me})(de||(e.DocumentHighlight=de={}));var ge;(function(be){function Ie(q){return{uri:q.uri,highlights:q.highlights.map(de.from)}}be.from=Ie;function me(q){return new i.$HM(u.URI.revive(q.uri),q.highlights.map(de.to))}be.to=me})(ge||(e.MultiDocumentHighlight=ge={}));var $e;(function(be){function Ie(me){switch(me){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}be.to=Ie})($e||(e.CompletionTriggerKind=$e={}));var Ce;(function(be){function Ie(me){return{triggerKind:$e.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}be.to=Ie})(Ce||(e.CompletionContext=Ce={}));var Ae;(function(be){function Ie(q){switch(q){case i.CompletionItemTag.Deprecated:return 1}}be.from=Ie;function me(q){switch(q){case 1:return i.CompletionItemTag.Deprecated}}be.to=me})(Ae||(e.CompletionItemTag=Ae={}));var he;(function(be){const Ie=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function me(Re){return Ie.get(Re)??9}be.from=me;const q=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Se(Re){return q.get(Re)??i.CompletionItemKind.Property}be.to=Se})(he||(e.CompletionItemKind=he={}));var De;(function(be){function Ie(me,q){const Se=new i.$XM(me.label);return Se.insertText=me.insertText,Se.kind=he.to(me.kind),Se.tags=me.tags?.map(Ae.to),Se.detail=me.detail,Se.documentation=S.$Zk(me.documentation)?Z.to(me.documentation):me.documentation,Se.sortText=me.sortText,Se.filterText=me.filterText,Se.preselect=me.preselect,Se.commitCharacters=me.commitCharacters,h.$At.isIRange(me.range)?Se.range=k.to(me.range):typeof me.range=="object"&&(Se.range={inserting:k.to(me.range.insert),replacing:k.to(me.range.replace)}),Se.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Se.insertText=new i.$AM(me.insertText):(Se.insertText=me.insertText,Se.textEdit=Se.range instanceof i.$rM?new i.$wM(Se.range,Se.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Se.additionalTextEdits=me.additionalTextEdits.map(Re=>H.to(Re))),Se.command=q&&me.command?q.fromInternal(me.command):void 0,Se}be.to=Ie})(De||(e.CompletionItem=De={}));var ke;(function(be){function Ie(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:Z.fromStrict(q.documentation)}}be.from=Ie;function me(q){return{label:q.label,documentation:S.$Zk(q.documentation)?Z.to(q.documentation):q.documentation}}be.to=me})(ke||(e.ParameterInformation=ke={}));var Me;(function(be){function Ie(q){return{label:q.label,documentation:Z.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(ke.from):[],activeParameter:q.activeParameter}}be.from=Ie;function me(q){return{label:q.label,documentation:S.$Zk(q.documentation)?Z.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ke.to):[],activeParameter:q.activeParameter}}be.to=me})(Me||(e.SignatureInformation=Me={}));var Fe;(function(be){function Ie(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Me.from):[]}}be.from=Ie;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Me.to):[]}}be.to=me})(Fe||(e.SignatureHelp=Fe={}));var He;(function(be){function Ie(me,q){const Se=new i.$WM(O.to(q.position),typeof q.label=="string"?q.label:q.label.map(Be.to.bind(void 0,me)),q.kind&&Ge.to(q.kind));return Se.textEdits=q.textEdits&&q.textEdits.map(H.to),Se.tooltip=S.$Zk(q.tooltip)?Z.to(q.tooltip):q.tooltip,Se.paddingLeft=q.paddingLeft,Se.paddingRight=q.paddingRight,Se}be.to=Ie})(He||(e.InlayHint=He={}));var Be;(function(be){function Ie(me,q){const Se=new i.$VM(q.label);return Se.tooltip=S.$Zk(q.tooltip)?Z.to(q.tooltip):q.tooltip,g.Command.is(q.command)&&(Se.command=me.fromInternal(q.command)),q.location&&(Se.location=J.to(q.location)),Se}be.to=Ie})(Be||(e.InlayHintLabelPart=Be={}));var Ge;(function(be){function Ie(q){return q}be.from=Ie;function me(q){return q}be.to=me})(Ge||(e.InlayHintKind=Ge={}));var Ze;(function(be){function Ie(q){return{range:k.from(q.range),url:q.target,tooltip:q.tooltip}}be.from=Ie;function me(q){let Se;if(q.url)try{Se=typeof q.url=="string"?u.URI.parse(q.url,!0):u.URI.revive(q.url)}catch{}return new i.$3M(k.to(q.range),Se)}be.to=me})(Ze||(e.DocumentLink=Ze={}));var _e;(function(be){function Ie(q){const Se=new i.$6M(q.label);return q.textEdit&&(Se.textEdit=H.to(q.textEdit)),q.additionalTextEdits&&(Se.additionalTextEdits=q.additionalTextEdits.map(Re=>H.to(Re))),Se}be.to=Ie;function me(q){return{label:q.label,textEdit:q.textEdit?H.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Se=>H.from(Se)):void 0}}be.from=me})(_e||(e.ColorPresentation=_e={}));var tt;(function(be){function Ie(q){return new i.$4M(q[0],q[1],q[2],q[3])}be.to=Ie;function me(q){return[q.red,q.green,q.blue,q.alpha]}be.from=me})(tt||(e.Color=tt={}));var Qe;(function(be){function Ie(q){return{range:k.from(q.range)}}be.from=Ie;function me(q){return new i.$MM(k.to(q.range))}be.to=me})(Qe||(e.SelectionRange=Qe={}));var Je;(function(be){function Ie(me){switch(me){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}be.to=Ie})(Je||(e.TextDocumentSaveReason=Je={}));var xe;(function(be){function Ie(q){switch(q){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.Interval:return 3;case i.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Ie;function me(q){switch(q){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 3:return i.TextEditorLineNumbersStyle.Interval;case 1:default:return i.TextEditorLineNumbersStyle.On}}be.to=me})(xe||(e.TextEditorLineNumbersStyle=xe={}));var pe;(function(be){function Ie(q){if(q===i.EndOfLine.CRLF)return 1;if(q===i.EndOfLine.LF)return 0}be.from=Ie;function me(q){if(q===1)return i.EndOfLine.CRLF;if(q===0)return i.EndOfLine.LF}be.to=me})(pe||(e.EndOfLine=pe={}));var Pe;(function(be){function Ie(me){if(typeof me=="object")return me.viewId;switch(me){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Ie})(Pe||(e.ProgressLocation=Pe={}));var je;(function(be){function Ie(q){const Se={start:q.start+1,end:q.end+1};return q.kind&&(Se.kind=Ne.from(q.kind)),Se}be.from=Ie;function me(q){const Se={start:q.start-1,end:q.end-1};return q.kind&&(Se.kind=Ne.to(q.kind)),Se}be.to=me})(je||(e.FoldingRange=je={}));var Ne;(function(be){function Ie(q){if(q)switch(q){case i.FoldingRangeKind.Comment:return g.$zu.Comment;case i.FoldingRangeKind.Imports:return g.$zu.Imports;case i.FoldingRangeKind.Region:return g.$zu.Region}}be.from=Ie;function me(q){if(q)switch(q.value){case g.$zu.Comment.value:return i.FoldingRangeKind.Comment;case g.$zu.Imports.value:return i.FoldingRangeKind.Imports;case g.$zu.Region.value:return i.FoldingRangeKind.Region}}be.to=me})(Ne||(e.FoldingRangeKind=Ne={}));var Ue;(function(be){function Ie(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?k.from(me.selection):void 0,override:typeof me.override=="boolean"?f.$AF.id:void 0}}be.from=Ie})(Ue||(e.TextEditorOpenOptions=Ue={}));var Ve;(function(be){function Ie(Re){return Re instanceof i.$oN?Re.toJSON():typeof Re=="string"?Re:me(Re)||q(Re)?new i.$oN(Re.baseUri??Re.base,Re.pattern).toJSON():Re}be.from=Ie;function me(Re){const qe=Re;return qe?u.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function q(Re){const qe=Re;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function Se(Re){return typeof Re=="string"?Re:new i.$oN(u.URI.revive(Re.baseUri),Re.pattern)}be.to=Se})(Ve||(e.GlobPattern=Ve={}));var nt;(function(be){function Ie(me){if(me){if(Array.isArray(me))return me.map(Ie);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:Ve.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}be.from=Ie})(nt||(e.LanguageSelector=nt={}));var Ye;(function(be){function Ie(q){return!!q&&typeof q=="object"&&"documents"in q&&Array.isArray(q.documents)&&q.documents.every(Se=>Array.isArray(Se)&&Se.every(Re=>Re&&typeof Re=="object"&&"uri"in Re&&u.URI.isUri(Re.uri)&&"version"in Re&&typeof Re.version=="number"&&"ranges"in Re&&Array.isArray(Re.ranges)&&Re.ranges.every(qe=>qe instanceof i.$rM)))}be.is=Ie;function me(q){return{documents:q.documents.map(Se=>Se.map(Re=>({uri:u.URI.from(Re.uri),version:Re.version,ranges:Re.ranges.map(qe=>k.from(qe))})))}}be.from=me})(Ye||(e.MappedEditsContext=Ye={}));var it;(function(be){function Ie(q){return{start:q.start,end:q.end}}be.from=Ie;function me(q){return new i.$RN(q.start,q.end)}be.to=me})(it||(e.NotebookRange=it={}));var at;(function(be){function Ie(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}be.to=Ie;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}be.from=me})(at||(e.NotebookCellExecutionSummary=at={}));var ot;(function(be){function Ie(me){if(me===o.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(me===o.NotebookCellExecutionState.Pending)return;if(me===o.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}be.to=Ie})(ot||(e.NotebookCellExecutionState=ot={}));var ct;(function(be){function Ie(q){switch(q){case i.NotebookCellKind.Markup:return o.CellKind.Markup;case i.NotebookCellKind.Code:default:return o.CellKind.Code}}be.from=Ie;function me(q){switch(q){case o.CellKind.Markup:return i.NotebookCellKind.Markup;case o.CellKind.Code:default:return i.NotebookCellKind.Code}}be.to=me})(ct||(e.NotebookCellKind=ct={}));var lt;(function(be){function Ie(q){const Se={metadata:q.metadata??Object.create(null),cells:[]};for(const Re of q.cells)i.$SN.validate(Re),Se.cells.push(ft.from(Re));return Se}be.from=Ie;function me(q){const Se=new i.$TN(q.cells.map(ft.to));return(0,c.$ng)(q.metadata)||(Se.metadata=q.metadata),Se}be.to=me})(lt||(e.NotebookData=lt={}));var ft;(function(be){function Ie(q){return{cellKind:ct.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:at.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(vt.from):[]}}be.from=Ie;function me(q){return new i.$SN(ct.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(vt.to):void 0,q.metadata,q.internalMetadata?at.to(q.internalMetadata):void 0)}be.to=me})(ft||(e.NotebookCellData=ft={}));var $t;(function(be){function Ie(q){return{mime:q.mime,valueBytes:j.$Je.wrap(q.data)}}be.from=Ie;function me(q){return new i.$UN(q.valueBytes.buffer,q.mime)}be.to=me})($t||(e.NotebookCellOutputItem=$t={}));var vt;(function(be){function Ie(q){return{outputId:q.id,items:q.items.map($t.from),metadata:q.metadata}}be.from=Ie;function me(q){const Se=q.items.map($t.to);return new i.$VN(Se,q.outputId,q.metadata)}be.to=me})(vt||(e.NotebookCellOutput=vt={}));var Lt;(function(be){function Ie(Se){return q(Se)?{include:Ve.from(Se.include)??void 0,exclude:Ve.from(Se.exclude)??void 0}:Ve.from(Se)??void 0}be.from=Ie;function me(Se){return q(Se)?{include:Ve.to(Se.include),exclude:Ve.to(Se.exclude)}:Ve.to(Se)}be.to=me;function q(Se){const Re=Se;return Re?!(0,c.$jg)(Re.include)&&!(0,c.$jg)(Re.exclude):!1}})(Lt||(e.NotebookExclusiveDocumentPattern=Lt={}));var St;(function(be){function Ie(me,q,Se){const Re=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Re,Se),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}be.from=Ie})(St||(e.NotebookStatusBarItem=St={}));var It;(function(be){function Ie(me,q,Se){const Re=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:q.toInternal(Re,Se),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}be.from=Ie})(It||(e.NotebookKernelSourceAction=It={}));var Mt;(function(be){function Ie(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}be.from=Ie})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var mt;(function(be){function Ie(q){return{uri:q.uri,provides:q.provides}}be.from=Ie;function me(q){return new i.$XN(u.URI.revive(q.uri),q.provides)}be.to=me})(mt||(e.NotebookRendererScript=mt={}));var Rt;(function(be){function Ie(q){return{message:Z.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,contextValue:q.contextValue,location:q.location&&{range:k.from(q.location.range),uri:q.location.uri}}}be.from=Ie;function me(q){const Se=new i.$4N(typeof q.message=="string"?q.message:Z.to(q.message));return Se.actualOutput=q.actual,Se.expectedOutput=q.expected,Se.contextValue=q.contextValue,Se.location=q.location?J.to(q.location):void 0,Se}be.to=me})(Rt||(e.TestMessage=Rt={}));var pt;(function(be){be.namespace=n.$eL,be.denamespace=n.$fL})(pt||(e.TestTag=pt={}));var rt;(function(be){function Ie(q){const Se=(0,E.$NO)(q).controllerId;return{extId:r.$_K.fromExtHostTestItem(q,Se).toString(),label:q.label,uri:u.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Re=>pt.namespace(Se,Re.id)),range:h.$At.lift(k.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&Z.fromStrict(q.error)||null}}be.from=Ie;function me(q){return{parent:void 0,error:void 0,id:r.$_K.fromString(q.extId).localId,label:q.label,uri:u.URI.revive(q.uri),tags:(q.tags||[]).map(Se=>{const{tagId:Re}=pt.denamespace(Se);return new i.$5N(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:k.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}be.toPlain=me})(rt||(e.TestItem=rt={})),function(be){function Ie(q){return{id:q.id}}be.from=Ie;function me(q){return new i.$5N(q.id)}be.to=me}(pt||(e.TestTag=pt={}));var gt;(function(be){const Ie=(q,Se)=>{const Re=q.value;if(!Re)return;const qe={...rt.toPlain(Re.item),parent:Se,taskStates:Re.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.filter(Xe=>Xe.type===0).map(Rt.to)})),children:[]};if(q.children)for(const Te of q.children.values()){const Xe=Ie(Te,qe);Xe&&qe.children.push(Xe)}return qe};function me(q){const Se=new v.$GO;for(const Te of q.items)Se.insert(r.$_K.fromString(Te.item.extId).path,Te);const Re=[Se.nodes],qe=[];for(;Re.length;)for(const Te of Re.pop())Te.value?qe.push(Te):Te.children&&Re.push(Te.children.values());return{completedAt:q.completedAt,results:qe.map(Te=>Ie(Te)).filter(c.$ig)}}be.to=me})(gt||(e.TestResults=gt={}));var bt;(function(be){function Ie(Re){return{covered:Re.covered,total:Re.total}}function me(Re){return"line"in Re?O.from(Re):k.from(Re)}function q(Re){if(typeof Re.executed=="number"&&Re.executed<0)throw new Error(`Invalid coverage count ${Re.executed}`);return"branches"in Re?{count:Re.executed,location:me(Re.location),type:1,branches:Re.branches.length?Re.branches.map(qe=>({count:qe.executed,location:qe.location&&me(qe.location),label:qe.label})):void 0}:{type:0,name:Re.name,count:Re.executed,location:me(Re.location)}}be.fromDetails=q;function Se(Re,qe,Te){return i.$7N(Te.statementCoverage),i.$7N(Te.branchCoverage),i.$7N(Te.declarationCoverage),{id:qe,uri:Te.uri,statement:Ie(Te.statementCoverage),branch:Te.branchCoverage&&Ie(Te.branchCoverage),declaration:Te.declarationCoverage&&Ie(Te.declarationCoverage),testId:Te instanceof i.$8N&&Te.testItem?r.$_K.fromExtHostTestItem(Te.testItem,Re).toString():void 0}}be.fromFile=Se})(bt||(e.TestCoverage=bt={}));var Ht;(function(be){function Ie(me){switch(me){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}be.to=Ie})(Ht||(e.CodeActionTriggerKind=Ht={}));var _t;(function(be){function Ie(q){const Se=new i.$_N(le.to(q.kind),q.name,q.detail||"",u.URI.revive(q.uri),k.to(q.range),k.to(q.selectionRange));return Se._sessionId=q._sessionId,Se._itemId=q._itemId,Se}be.to=Ie;function me(q,Se,Re){if(Se=Se??q._sessionId,Re=Re??q._itemId,Se===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Re,kind:le.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:k.from(q.range),selectionRange:k.from(q.selectionRange),tags:q.tags?.map(F.from)}}be.from=me})(_t||(e.TypeHierarchyItem=_t={}));var en;(function(be){function Ie(me){if(me)return{value:me.value,tooltip:me.tooltip}}be.from=Ie})(en||(e.ViewBadge=en={}));var Tt;(function(be){function Ie(Re,qe,Te){const Xe=qe.fileData;return Xe?new i.$gN(new i.$hN(Xe.name,u.URI.revive(Xe.uri),Xe.id,(0,D.$db)(()=>Te(Xe.id)))):Re===y.$Ws.uriList&&qe.uriListData?new i.$fN(Se(qe.uriListData)):new i.$fN(qe.asString)}be.to=Ie;async function me(Re,qe){const Te=await qe.asString();if(Re===y.$Ws.uriList)return{asString:Te,fileData:void 0,uriListData:q(Te)};const Xe=qe.asFile();return{asString:Te,fileData:Xe?{name:Xe.name,uri:Xe.uri,id:Xe._itemId??Xe.id}:void 0}}be.from=me;function q(Re){return I.$eu.split(Re).map(qe=>{if(qe.startsWith("#"))return qe;try{return u.URI.parse(qe)}catch{}return qe})}function Se(Re){return I.$eu.create(Re.map(qe=>typeof qe=="string"?qe:u.URI.revive(qe)))}})(Tt||(e.DataTransferItem=Tt={}));var Ut;(function(be){function Ie(q,Se){const Re=q.items.map(([qe,Te])=>[qe,Tt.to(qe,Te,Se)]);return new i.$iN(Re)}be.toDataTransfer=Ie;async function me(q){const Se={items:[]},Re=[];for(const[qe,Te]of q)Re.push((async()=>{Se.items.push([qe,await Tt.from(qe,Te)])})());return await Promise.all(Re),Se}be.from=me})(Ut||(e.DataTransfer=Ut={}));var Vt;(function(be){function Ie(q,Se){return{kind:"reply",agentId:q.participant??Se?.agentId??"",subCommand:q.command??Se?.command,message:q.prompt,title:q.label}}be.from=Ie;function me(q){return{prompt:q.message,label:q.title,participant:q.agentId,command:q.subCommand}}be.to=me})(Vt||(e.ChatFollowup=Vt={}));var Wt;(function(be){function Ie(q){switch(q.role){case 0:return new i.$AO(i.LanguageModelChatMessageRole.System,q.content);case 1:return new i.$AO(i.LanguageModelChatMessageRole.User,q.content);case 2:return new i.$AO(i.LanguageModelChatMessageRole.Assistant,q.content)}}be.to=Ie;function me(q){switch(q.role){case i.LanguageModelChatMessageRole.System:return{role:0,content:q.content};case i.LanguageModelChatMessageRole.User:return{role:1,content:q.content};case i.LanguageModelChatMessageRole.Assistant:return{role:2,content:q.content}}}be.from=me})(Wt||(e.LanguageModelChatMessage=Wt={}));var Dt;(function(be){function Ie(q){return{kind:"markdownContent",content:Z.from(q.value)}}be.from=Ie;function me(q){return new i.$mO(Z.to(q.content))}be.to=me})(Dt||(e.ChatResponseMarkdownPart=Dt={}));var Gt;(function(be){function Ie(q){return{kind:"markdownVuln",content:Z.from(q.value),vulnerabilities:q.vulnerabilities}}be.from=Ie;function me(q){return new i.$nO(Z.to(q.content),q.vulnerabilities)}be.to=me})(Gt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Gt={}));var tn;(function(be){function Ie(q){return{kind:"agentDetection",agentId:q.participant,command:q.command}}be.from=Ie;function me(q){return new i.$oO(q.agentId,q.command)}be.to=me})(tn||(e.ChatResponseDetectedParticipantPart=tn={}));var xt;(function(be){function Ie(me){return{kind:"confirmation",title:me.title,message:me.message,data:me.data}}be.from=Ie})(xt||(e.ChatResponseConfirmationPart=xt={}));var Nt;(function(be){function Ie(q){const{value:Se,baseUri:Re}=q;function qe(Te,Xe){return Te.map(st=>{const dt=u.URI.joinPath(Xe,st.name);return{label:st.name,uri:dt,children:st.children&&qe(st.children,dt)}})}return{kind:"treeData",treeData:{label:(0,m.$$g)(Re),uri:Re,children:qe(Se,Re)}}}be.from=Ie;function me(q){const Se=(0,$.$0h)(q.treeData);function Re(Xe){return Xe.map(st=>({name:st.label,children:st.children&&Re(st.children)}))}const qe=Se.uri,Te=Se.children?Re(Se.children):[];return new i.$qO(Te,qe)}be.to=me})(Nt||(e.ChatResponseFilesPart=Nt={}));var Jt;(function(be){function Ie(q){const Se=Re=>u.URI.isUri(Re);return{kind:"inlineReference",name:q.title,inlineReference:Se(q.value)?q.value:C.from(q.value)}}be.from=Ie;function me(q){const Se=(0,$.$0h)(q);return new i.$rO(u.URI.isUri(Se.inlineReference)?Se.inlineReference:C.to(Se.inlineReference),q.name)}be.to=me})(Jt||(e.ChatResponseAnchorPart=Jt={}));var zt;(function(be){function Ie(q){return{kind:"progressMessage",content:Z.from(q.value)}}be.from=Ie;function me(q){return new i.$sO(q.content.value)}be.to=me})(zt||(e.ChatResponseProgressPart=zt={}));var nn;(function(be){function Ie(q){return{kind:"warning",content:Z.from(q.value)}}be.from=Ie;function me(q){return new i.$uO(q.content.value)}be.to=me})(nn||(e.ChatResponseWarningPart=nn={}));var rn;(function(be){function Ie(me){return{kind:"progressTask",content:Z.from(me.value)}}be.from=Ie})(rn||(e.ChatTask=rn={}));var an;(function(be){function Ie(me){return{kind:"progressTaskResult",content:typeof me=="string"?Z.from(me):void 0}}be.from=Ie})(an||(e.ChatTaskResult=an={}));var Qt;(function(be){function Ie(q,Se,Re){return{kind:"command",command:Se.toInternal(q.value,Re)??{command:q.value.command,title:q.value.title}}}be.from=Ie;function me(q,Se){return new i.$vO(Se.fromInternal(q.command)??{command:q.command.id,title:q.command.title})}be.to=me})(Qt||(e.ChatResponseCommandButtonPart=Qt={}));var Zt;(function(be){function Ie(q){return{kind:"textEdit",uri:q.uri,edits:q.edits.map(Se=>H.from(Se))}}be.from=Ie;function me(q){return new i.$xO(u.URI.revive(q.uri),q.edits.map(Se=>H.to(Se)))}be.to=me})(Zt||(e.ChatResponseTextEditPart=Zt={}));var Ct;(function(be){function Ie(q){const Se=l.ThemeIcon.isThemeIcon(q.iconPath)?q.iconPath:u.URI.isUri(q.iconPath)?{light:u.URI.revive(q.iconPath)}:q.iconPath&&"light"in q.iconPath&&"dark"in q.iconPath&&u.URI.isUri(q.iconPath.light)&&u.URI.isUri(q.iconPath.dark)?{light:u.URI.revive(q.iconPath.light),dark:u.URI.revive(q.iconPath.dark)}:void 0;return"variableName"in q.value?{kind:"reference",reference:{variableName:q.value.variableName,value:u.URI.isUri(q.value.value)||!q.value.value?q.value.value:C.from(q.value.value)},iconPath:Se}:{kind:"reference",reference:u.URI.isUri(q.value)?q.value:C.from(q.value),iconPath:Se}}be.from=Ie;function me(q){const Se=(0,$.$0h)(q),Re=qe=>u.URI.isUri(qe)?qe:C.to(qe);return new i.$wO("variableName"in Se.reference?{variableName:Se.reference.variableName,value:Se.reference.value&&Re(Se.reference.value)}:Re(Se.reference))}be.to=me})(Ct||(e.ChatResponseReferencePart=Ct={}));var Xt;(function(be){function Ie(Se,Re,qe){return Se instanceof i.$mO?Dt.from(Se):Se instanceof i.$rO?Jt.from(Se):Se instanceof i.$wO?Ct.from(Se):Se instanceof i.$sO?zt.from(Se):Se instanceof i.$qO?Nt.from(Se):Se instanceof i.$vO?Qt.from(Se,Re,qe):Se instanceof i.$xO?Zt.from(Se):Se instanceof i.$nO?Gt.from(Se):Se instanceof i.$oO?tn.from(Se):Se instanceof i.$uO?nn.from(Se):{kind:"markdownContent",content:Z.from("")}}be.from=Ie;function me(Se,Re){switch(Se.kind){case"reference":return Ct.to(Se);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return q(Se,Re)}}be.to=me;function q(Se,Re){switch(Se.kind){case"markdownContent":return Dt.to(Se);case"inlineReference":return Jt.to(Se);case"progressMessage":return;case"treeData":return Nt.to(Se);case"command":return Qt.to(Se,Re)}}be.toContent=q})(Xt||(e.ChatResponsePart=Xt={}));var Yt;(function(be){function Ie(me){return{prompt:me.message,command:me.command,attempt:me.attempt??0,enableCommandDetection:me.enableCommandDetection??!0,references:me.variables.variables.map(cn.to),location:sn.to(me.location),acceptedConfirmationData:me.acceptedConfirmationData,rejectedConfirmationData:me.rejectedConfirmationData}}be.to=Ie})(Yt||(e.ChatAgentRequest=Yt={}));var sn;(function(be){function Ie(me){switch(me){case t.ChatAgentLocation.Notebook:return i.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return i.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return i.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return i.ChatLocation.Editor}}be.to=Ie})(sn||(e.ChatLocation=sn={}));var cn;(function(be){function Ie(me){const q=me.value;if(!q)throw new Error("Invalid value reference");return{id:me.id,name:me.name,range:me.range&&[me.range.start,me.range.endExclusive],value:(0,u.$vc)(q)?u.URI.revive(q):q,modelDescription:me.modelDescription}}be.to=Ie})(cn||(e.ChatAgentValueReference=cn={}));var dn;(function(be){function Ie(me,q,Se){return{id:me.id,label:me.label,value:me.values[0].value,insertText:me.insertText,detail:me.detail,documentation:me.documentation,command:q.toInternal(me.command,Se)}}be.from=Ie})(dn||(e.ChatAgentCompletionItem=dn={}));var Kt;(function(be){function Ie(me){return{errorDetails:me.errorDetails,metadata:me.metadata}}be.to=Ie})(Kt||(e.ChatAgentResult=Kt={}));var on;(function(be){function Ie(me,q,Se){if(q.action.kind==="vote")return;const Re=Kt.to(me);if(q.action.kind==="command"){const qe=q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Se.fromInternal(qe)??{command:qe.id,title:qe.title}}},result:Re}}else return q.action.kind==="followUp"?{action:{kind:"followUp",followup:Vt.to(q.action.followup)},result:Re}:q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:q.action.action==="accepted"},result:Re}:{action:q.action,result:Re}}be.to=Ie})(on||(e.ChatAgentUserActionEvent=on={}));var ln;(function(be){function Ie(me,q,Se){return"terminalCommand"in me?{terminalCommand:me.terminalCommand,shouldExecute:me.shouldExecute}:"uri"in me?{uri:me.uri}:q.toInternal(me,Se)}be.from=Ie})(ln||(e.TerminalQuickFix=ln={}));var At;(function(be){function Ie(me){return{kind:un.to(me.kind)}}be.to=Ie})(At||(e.PartialAcceptInfo=At={}));var un;(function(be){function Ie(me){switch(me){case 0:return i.PartialAcceptTriggerKind.Word;case 1:return i.PartialAcceptTriggerKind.Line;case 2:return i.PartialAcceptTriggerKind.Suggest;default:return i.PartialAcceptTriggerKind.Unknown}}be.to=Ie})(un||(e.PartialAcceptTriggerKind=un={}));var yt;(function(be){function Ie(me,q){return{id:q,label:me.label,description:me.description,canEdit:me.canEdit,collapsibleState:me.collapsibleState||0,contextValue:me.contextValue}}be.from=Ie})(yt||(e.DebugTreeItem=yt={}))}),define(ye[297],Ee([1,0,45,138,72,137,96,144,4]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=void 0;const $=(d,E,f,t)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(r){if(!f(o,r)){const n=o;o=r,d.listener?.(t(r,n))}}}},y=(d,E)=>d===E,w={range:(d,E)=>d===E?!0:!d||!E?!1:d.isEqual(E),label:y,description:y,sortText:y,busy:y,error:y,canResolveChildren:y,tags:(d,E)=>!(d.length!==E.length||d.some(f=>!E.find(t=>f.id===t.id)))},v=d=>E=>({op:4,update:d(E)}),m=(d,E)=>({range:(()=>{let f;const t=v(o=>({range:s.$At.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return f},set(o){d.listener?.({op:6}),w.range(f,o)||(f=o,d.listener?.(t(o)))}}})(),label:$(d,E,w.label,v(f=>({label:f}))),description:$(d,void 0,w.description,v(f=>({description:f}))),sortText:$(d,void 0,w.sortText,v(f=>({sortText:f}))),canResolveChildren:$(d,!1,w.canResolveChildren,f=>({op:2,state:f})),busy:$(d,!1,w.busy,v(f=>({busy:f}))),error:$(d,void 0,w.error,v(f=>({error:P.MarkdownString.fromStrict(f)||null}))),tags:$(d,[],w.tags,(f,t)=>({op:1,new:f.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),l=d=>{const E=I.$_K.fromString(d.extId),f=new u(E.controllerId,E.localId,d.label,b.URI.revive(d.uri)||void 0);return f.range=P.Range.to(d.range||void 0),f.description=d.description||void 0,f.sortText=d.sortText||void 0,f.tags=d.tags.map(t=>P.TestTag.to({id:(0,S.$fL)(t).tagId})),f},c=d=>{let E;for(const f of d.tests){const t=l(f.item);(0,j.$NO)(t).parent=E,E=t}return E};e.$4O=c;class u{constructor(E,f,t,o){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const r=(0,j.$MO)(this,E);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,D.$LO)(r,j.$NO,u),enumerable:!0,writable:!1},...m(r,t)})}}e.$5O=u;class h extends u{constructor(E,f){super(E,E,f,void 0),this._isRoot=!0}}e.$6O=h;class g extends D.$HO{constructor(E,f,t){super({controllerId:E,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:j.$NO,getChildren:o=>o.children,root:new h(E,f),toITestItem:P.TestItem.from})}}e.$7O=g}),define(ye[298],Ee([1,0,10,143,144,21,295,18,12,46,45,79,4,2,5,279,297,15,141,39,61,37,292,22]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=void 0;let r=class{#e;#t;#n;constructor(C,A,O){this.b=new Map,this.c=new Map,this.#e=C.getProxy(S.$nM.MainThreadCommands),this.d=A,this.#n=O,this.#t=C.getProxy(S.$nM.MainThreadTelemetry),this.converter=new n(this,N=>{const V=this.c.get(N);return V?.result===i.Void?V:void 0},A),this.f=[{processArgument(N){return(0,$.$0h)(N)}},{processArgument(N){return(0,D.$9n)(N,function(V){if(y.$At.isIRange(V))return I.Range.to(V);if(w.$zt.isIPosition(V))return I.Position.to(V);if(y.$At.isIRange(V.range)&&v.URI.isUri(V.uri))return I.location.to(V);if(V instanceof h.$Je)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const A=this.registerCommand(!1,C.id,async(...O)=>{const N=C.args.map((ie,ae)=>{if(!ie.validate(O[ae]))throw new Error(`Invalid argument '${ie.name}' when running '${C.id}', received: ${typeof O[ae]=="object"?JSON.stringify(O[ae],null,"	"):O[ae]} `);return ie.convert(O[ae])}),V=await this.executeCommand(C.internalId,...N);return C.result.convert(V,O,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new j.$pM(()=>{A.dispose(),this.c.delete(C.id)})}registerCommand(C,A,O,N,V,ie){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:O,thisArg:N,metadata:V,extension:ie}),C&&this.#e.$registerCommand(A),new j.$pM(()=>{this.b.delete(A)&&C&&this.#e.$unregisterCommand(A)})}executeCommand(C,...A){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,A,!0)}async g(C,A,O){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,A,!1);{let N=!1;const V=(0,D.$9n)(A,function(ie){if(ie instanceof j.$qM)return I.Position.from(ie);if(ie instanceof j.$rM)return I.Range.from(ie);if(ie instanceof j.$BM)return I.location.from(ie);if(j.$RN.isNotebookRange(ie))return I.NotebookRange.from(ie);if(ie instanceof ArrayBuffer)return N=!0,h.$Je.wrap(new Uint8Array(ie));if(ie instanceof Uint8Array)return N=!0,h.$Je.wrap(ie);if(ie instanceof h.$Je)return N=!0,ie;if(!Array.isArray(ie))return ie});try{const ie=await this.#e.$executeCommand(C,N?new g.$Hw(V):V,O);return(0,$.$0h)(ie)}catch(ie){if(ie instanceof Error&&ie.message==="$executeCommand:retry")return this.g(C,A,!1);throw ie}}}async h(C,A,O){const N=this.b.get(C);if(!N)throw new Error("Unknown command");const{callback:V,thisArg:ie,metadata:ae}=N;if(ae?.args)for(let ee=0;ee<ae.args.length;ee++)try{(0,s.$rg)(A[ee],ae.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${ae.args[ee].name}' - ${ae.args[ee].description}`)}const te=E.$be.create();try{return await V.apply(ie,A)}catch(ee){if(C===this.converter.delegatingCommandId){const K=this.converter.getActualCommand(...A);K&&(C=K.command)}if(this.d.error(ee,C,N.extension?.identifier),!O)throw ee;if(N.extension?.identifier){const K=this.#n.onExtensionError(N.extension.identifier,ee);this.d.trace("forwarded error to extension?",K,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$lj)(ee)),this.id=C,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,C,te.elapsed())}}j(C,A,O){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new f.$lp(A),duration:O})}$executeContributedCommand(C,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const O=this.b.get(C);return O?(A=A.map(N=>this.f.reduce((V,ie)=>ie.processArgument(V,O.extension?.identifier),N)),this.h(C,A,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(A=>(C&&(A=A.filter(O=>O[0]!=="_")),A))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[A,O]of this.b){const{metadata:N}=O;N&&(C[A]=N)}return Promise.resolve(C)}};e.$aP=r,e.$aP=r=Le([Oe(0,c.$RO),Oe(1,b.$7j),Oe(2,t.$_O)],r),e.$bP=(0,l.$Ai)("IExtHostCommands");class n{constructor(C,A,O){this.d=C,this.f=A,this.g=O,this.delegatingCommandId=`__vsc${(0,o.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,A){if(!C)return;const O={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return O;const N=this.f(C.command);if(N)O.id=N.internalId,O.arguments=N.args.map((V,ie)=>V.convert(C.arguments&&C.arguments[ie]));else if((0,P.$Lb)(C.arguments)){const V=`${C.command} /${++this.c}`;this.b.set(V,C),A.add((0,m.$Sc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),O.$ident=V,O.id=this.delegatingCommandId,O.arguments=[V],this.g.trace("CommandsConverter#CREATE",C.command,V)}return O}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const A=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$cP=n;class a{static{this.Uri=new a("uri","Uri of a text document",C=>v.URI.isUri(C),C=>C)}static{this.Position=new a("position","A position in a text document",C=>j.$qM.isPosition(C),I.Position.from)}static{this.Range=new a("range","A range in a text document",C=>j.$rM.isRange(C),I.Range.from)}static{this.Selection=new a("selection","A selection in a text document",C=>j.$sM.isSelection(C),I.Selection.from)}static{this.Number=new a("number","",C=>typeof C=="number",C=>C)}static{this.String=new a("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=a.Arr(a.String)}static Arr(C){return new a(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,A=>Array.isArray(A)&&A.every(O=>C.validate(O)),A=>A.map(O=>C.convert(O)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",C=>C instanceof j.$NM,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",C=>C instanceof j.$_N,I.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",C=>C instanceof u.$5O,I.TestItem.from)}constructor(C,A,O,N){this.name=C,this.description=A,this.validate=O,this.convert=N}optional(){return new a(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,A){return new a(C??this.name,A??this.description,this.validate,this.convert)}}e.$dP=a;class i{static{this.Void=new i("no result",C=>C)}constructor(C,A){this.description=C,this.convert=A}}e.$eP=i;class p{constructor(C,A,O,N,V){this.id=C,this.internalId=A,this.description=O,this.args=N,this.result=V}}e.$fP=p}),define(ye[299],Ee([1,0,11,2,13,234]),function(fe,e,s,j,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0,e.$2P="remoteFilesystem";class S extends D.$1P{static register(b,$,y){const w=b.getConnection();if(!w)return j.$Uc.None;const v=new j.$Tc,m=(async()=>{try{const l=await b.getRawEnvironment();l?$.registerProvider(I.Schemas.vscodeRemote,v.add(new S(l,w))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(l){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,s.$0)(l))}})();return v.add($.onWillActivateFileSystemProvider(l=>{l.scheme===I.Schemas.vscodeRemote&&l.join(m)})),v}constructor(b,$){super($.getChannel(e.$2P),{pathCaseSensitive:b.os===3})}}e.$3P=S}),define(ye[73],Ee([1,0,90,78,31,300,15,11,6,2,7,3,22,47,108]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=r,e.$ti=n,e.$vi=p,e.$wi=k;class c{traceSocketEvent(A,O){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,P.$1)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=N=>{this.traceSocketEvent("read",N),A(S.$Je.wrap(N))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=N=>{A({type:0,hadError:N,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),A();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),A()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$pi=c;var u;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var h;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(h||(h={}));class g extends $.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,N,V){super(),this.f=this.B(new b.$he),this.g=this.B(new b.$he),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:N?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new d(this,O,N,V,this.f,(ie,ae)=>this.m(ie,ae))),this.B(this.a.onError(ie=>{console.error(ie),(0,P.$1)(ie),this.g.fire({type:0,hadError:!0,error:ie})})),this.b=new l.$ki,this.B(this.socket.onData(ie=>this.n(ie))),this.B(this.socket.onClose(async ie=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ie)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+262144,A.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(A,{compressed:O,opcode:N}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",A);let V=2;A.byteLength<126?V+=0:A.byteLength<2**16?V+=2:V+=8;const ie=S.$Je.alloc(V),ae=O?64:0,te=N&15;if(ie.writeUInt8(128|ae|te,0),A.byteLength<126)ie.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){ie.writeUInt8(126,1);let ee=1;ie.writeUInt8(A.byteLength>>>8&255,++ee),ie.writeUInt8(A.byteLength>>>0&255,++ee)}else{ie.writeUInt8(127,1);let ee=1;ie.writeUInt8(0,++ee),ie.writeUInt8(0,++ee),ie.writeUInt8(0,++ee),ie.writeUInt8(0,++ee),ie.writeUInt8(A.byteLength>>>24&255,++ee),ie.writeUInt8(A.byteLength>>>16&255,++ee),ie.writeUInt8(A.byteLength>>>8&255,++ee),ie.writeUInt8(A.byteLength>>>0&255,++ee)}this.socket.write(S.$Je.concat([ie,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),N=O.readUInt8(0),V=(N&128)>>>7,ie=(N&64)>>>6,ae=N&15,te=O.readUInt8(1),ee=(te&128)>>>7,K=te&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!ie),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),N=O.readUInt8(1),V=(N&128)>>>7;let ie=N&127,ae=1;ie===126?ie=O.readUInt8(++ae)*2**8+O.readUInt8(++ae):ie===127&&(ie=O.readUInt8(++ae)*0+O.readUInt8(++ae)*0+O.readUInt8(++ae)*0+O.readUInt8(++ae)*0+O.readUInt8(++ae)*2**24+O.readUInt8(++ae)*2**16+O.readUInt8(++ae)*2**8+O.readUInt8(++ae));let te=0;V&&(te=O.readUInt8(++ae)*2**24+O.readUInt8(++ae)*2**16+O.readUInt8(++ae)*2**8+O.readUInt8(++ae)),this.j.state=3,this.j.readLen=ie,this.j.mask=te,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qi=g;class d extends $.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.$Je.alloc(0)}constructor(A,O,N,V,ie,ae){super(),this.n=A,this.r=ie,this.s=ae,this.a=this.B(new b.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new E(this.n,V,N,{windowBits:15})),this.f=this.B(new f(this.n,{windowBits:15})),this.B(this.b.onError(te=>this.a.fire(te))),this.B(this.f.onError(te=>this.a.fire(te)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const N=await this.w(this.f,A);this.s(N,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((N,V)=>{A.write(O),A.flush(ie=>N(ie))})}acceptFrame(A,O,N){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,N){return new Promise((V,ie)=>{A.write(O),N&&A.write(S.$Je.fromByteArray([0,0,255,255])),A.flush(ae=>V(ae))})}}class E extends $.$Uc{get recordedInflateBytes(){return this.j?S.$Je.concat(this.f):S.$Je.alloc(0)}constructor(A,O,N,V){super(),this.h=A,this.j=O,this.a=this.B(new b.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(V),this.b.on("error",ie=>{this.h.traceSocketEvent("zlibInflateError",{message:ie?.message,code:ie?.code}),this.a.fire(ie)}),this.b.on("data",ie=>{this.h.traceSocketEvent("zlibInflateData",ie),this.g.push(S.$Je.wrap(ie))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent("zlibInflateWrite",A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=S.$Je.concat(this.g);this.g.length=0,A(O)})}}class f extends $.$Uc{constructor(A,O){super(),this.g=A,this.a=this.B(new b.$he),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(S.$Je.wrap(N))})}write(A){this.g.traceSocketEvent("zlibDeflateWrite",A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=S.$Je.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function t(C,A){if(A===0)return;const O=C.byteLength>>>2;for(let ee=0;ee<O;ee++){const K=C.readUInt32BE(ee*4);C.writeUInt32BE(K^A,ee*4)}const N=O*4,V=C.byteLength-N,ie=A>>>24&255,ae=A>>>16&255,te=A>>>8&255;V>=1&&C.writeUInt8(C.readUInt8(N)^ie,N),V>=2&&C.writeUInt8(C.readUInt8(N+1)^ae,N+1),V>=3&&C.writeUInt8(C.readUInt8(N+2)^te,N+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const C=(0,v.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const A=process.platform!=="darwin"&&e.$ri?e.$ri:(0,I.tmpdir)(),O=(0,y.$jc)(A,`vscode-ipc-${C}.sock`);return a(O),O}function n(C,A,O){const V=(0,s.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${O}-${A}-sock`;const ie=O.substr(0,4),ae=A.substr(0,6);let te;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?te=(0,y.$jc)(e.$ri,`vscode-${V}-${ie}-${ae}.sock`):te=(0,y.$jc)(C,`${ie}-${ae}.sock`),a(te),te}function a(C){const A=o[w.$u];typeof A=="number"&&C.length>=A&&console.warn(`WARNING: IPC handle "${C}" is longer than ${A} chars, try a shorter --user-data-dir`)}class i extends m.$ei{static b(A){const O=b.Event.fromNodeEventEmitter(A,"connection");return b.Event.map(O,N=>({protocol:new l.$li(new c(N,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(N,"close"))}))}constructor(A){super(i.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=i;function p(C){return new Promise((A,O)=>{const N=(0,j.createServer)();N.on("error",O),N.listen(C,()=>{N.removeListener("error",O),A(new i(N))})})}function k(C,A){return new Promise((O,N)=>{const V=(0,j.createConnection)(C,()=>{V.removeListener("error",N),O(l.$mi.fromSocket(new c(V,`ipc-client${A}`),A))});V.once("error",N)})}}),define(ye[145],Ee([1,0,87,14,15,11,10,25,26,88,12,42,251,300]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$5r=u;let l=class extends w.$Up{constructor(g,d,E,f){super(f),this.m=g,this.n=d,this.r=E,this.s(),this.B(g.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,d){const{f:E,g:f}=this;let t;try{t=await(0,$.$Km)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$0)(n)))}const o={...process.env,...t},r=g.agent?g.agent:await(0,v.$3r)(g.url||"",o,{proxyUrl:E,strictSSL:f});return g.agent=r,g.strictSSL=f,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>u(g,d))}async resolveProxy(g){}async loadCertificates(){return(await new Promise((d,E)=>{fe(["@vscode/proxy-agent"],d,E)})).loadSystemCertificates({log:this.r})}};e.$4r=l,e.$4r=l=Le([Oe(0,P.$7i),Oe(1,b.$Ii),Oe(2,y.$7j),Oe(3,y.$8j)],l);async function c(h){return((0,s.parse)(h.url).protocol==="https:"?await new Promise((E,f)=>{fe(["https"],E,f)}):await new Promise((E,f)=>{fe(["http"],E,f)})).request}async function u(h,g){return j.Promises.withAsyncBody(async(d,E)=>{const f=(0,s.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await c(h),o={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,S.$gg)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const r=t(o,n=>{const a=(0,S.$eg)(h.followRedirects)?h.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)u({...h,url:n.headers.location,followRedirects:a-1},g).then(d,E);else{let i=n;!h.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(i=n.pipe((0,m.createGunzip)())),d({res:n,stream:(0,I.$Ye)(i)})}});r.on("error",E),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),g.onCancellationRequested(()=>{r.abort(),E(new D.$5)})})}}),define(ye[146],Ee([1,0,56,78,135,13,7,15,6,73,88,12,52,3,66,134,2,290,25]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$tn=d;async function d(n={},a,i,p,k,C){const A=await(0,I.$em)(i,p.userDataPath);let O={};if(a)try{O=await(0,y.$Km)(C,k,p.args,process.env)}catch(ee){k.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const V={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(A,void 0,0),...n},ie=p.isBuilt?(0,S.$jc)(p.appRoot,"bin"):(0,S.$jc)(p.appRoot,"resources","server","bin-dev"),ae=(0,S.$jc)(ie,"remote-cli");let te=t(V,"PATH");return te?te=ae+S.$tc+te:te=ae,o(V,"PATH",te),p.args["without-browser-env-var"]||(V.BROWSER=(0,S.$jc)(ie,"helpers",m.$i?"browser.cmd":"browser.sh")),r(V),V}class E{constructor(a,i){this.socket=a,this.initialDataChunk=i}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,i,p;return this.socket instanceof $.$pi?(a=!0,i=!1,p=P.$Je.alloc(0)):(a=!1,i=this.socket.permessageDeflate,p=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:i,inflateBytes:p.buffer.toString("base64")}}}let f=class{constructor(a,i,p,k,C,A,O,N){this.i=a,this.j=C,this.l=A,this.m=O,this.n=N,this.b=new b.$he,this.onClose=this.b.event,this.c=!m.$i||!this.j.args["socket-path"],this.d=!1,this.f=i,this.g=null,this.h=new E(p,k),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(a){this.l.info(`${this.o}${a}`)}q(a){this.l.error(`${this.o}${a}`)}async r(a,i){const p=new u.$Tc;p.add(i.socket),p.add((0,u.$Sc)(()=>{a.destroy()}));const k=()=>{p.dispose()};p.add(i.socket.onEnd(k)),p.add(i.socket.onClose(k)),p.add(b.Event.fromNodeEventEmitter(a,"end")(k)),p.add(b.Event.fromNodeEventEmitter(a,"close")(k)),p.add(b.Event.fromNodeEventEmitter(a,"error")(k)),p.add(i.socket.onData(C=>a.write(C.buffer))),p.add(b.Event.fromNodeEventEmitter(a,"data")(C=>{i.socket.write(P.$Je.wrap(C))})),i.initialDataChunk.byteLength>0&&a.write(i.initialDataChunk.buffer)}async s(a,i){await i.socketDrain();const p=i.toIExtHostSocketMessage();let k;i.socket instanceof $.$pi?k=i.socket.socket:k=i.socket.socket.socket,a.send(p,k)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(a)}acceptReconnection(a,i,p){this.f=a,this.p("The client has reconnected.");const k=new E(i,p);if(!this.g){this.h=k;return}this.s(this.g,k)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(a){try{let i=process.execArgv?process.execArgv.filter(ae=>!/^--inspect(-brk)?=/.test(ae)):[];a.port&&!process.pkg&&(i=[`--inspect${a.break?"-brk":""}=${a.port}`]);const p=await d(a.env,!0,a.language,this.j,this.l,this.n);(0,l.$rm)(p);let k;if(this.c)(0,h.$rn)(new h.$pn,p),k=null;else{const{namedPipeServer:ae,pipeName:te}=await this.u();(0,h.$rn)(new h.$on(te),p),k=ae}const C={env:p,execArgv:i,silent:!0};C.execArgv.unshift("--dns-result-order=ipv4first");const A=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];A.push(`--useHostProxy=${O?"true":"false"}`),this.g=s.fork(D.$Ug.asFileUri("bootstrap-fork").fsPath,A,C);const N=this.g.pid;this.p(`<${N}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const V=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),ie=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if(V(ae=>this.p(`<${N}> ${ae}`)),ie(ae=>this.p(`<${N}><stderr> ${ae}`)),this.g.on("error",ae=>{this.q(`<${N}> Extension Host Process had an error`),this.l.error(ae),this.t()}),this.g.on("exit",(ae,te)=>{this.m.setExitInfo(this.i,{code:ae,signal:te}),this.p(`<${N}> Extension Host Process exited with code: ${ae}, signal: ${te}.`),this.t()}),k)k.on("connection",ae=>{k.close(),this.r(ae,this.h)});else{const ae=te=>{te.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ae),this.s(this.g,this.h),this.h=null)};this.g.on("message",ae)}}catch(i){console.error("ExtensionHostConnection errored"),i&&console.error(i)}}u(){return new Promise((a,i)=>{const p=(0,$.$si)(),k=j.createServer();k.on("error",i),k.listen(p,()=>{k?.removeListener("error",i),a({pipeName:p,namedPipeServer:k})})})}};e.$un=f,e.$un=f=Le([Oe(4,v.$en),Oe(5,w.$7j),Oe(6,c.$mn),Oe(7,g.$7i)],f);function t(n,a){const i=Object.keys(n).filter(k=>k.toLowerCase()===a.toLowerCase()),p=i.length>0?i[0]:a;return n[p]}function o(n,a,i){const p=Object.keys(n).filter(C=>C.toLowerCase()===a.toLowerCase()),k=p.length>0?p[0]:a;n[k]=i}function r(n){for(const a of Object.keys(n))n[a]===null&&delete n[a]}}),define(ye[301],Ee([1,0,84,12,68,119,25,42,145,37,27,29,132,129,89,113,58,2,114,69,13,16,30,52,122,85,123,11,4,7,32,249,83,34,127,67,3,59,136,33,51,70,133,130,116,117,215,302]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A,O,N,V,ie,ae,te,ee,K,B,Z,Y,M,z,oe,se,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=le;class H extends h.$Uc{constructor(U,X){super(),this.a=U,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const U=await this.f();await U.invokeFunction(async X=>{const x=X.get(S.$7i),Q=X.get(j.$7j);ae.$i&&(x.getValue("security.restrictUNCAccess")===!1?(0,_.disableUNCAccessRestrictions)():(0,_.addUNCHostToAllowlist)(x.getValue("security.allowedUNCHosts")));try{await this.g(U.createInstance(r.$iq,new j.$ck(Q.getLevel(),!1)))}catch(G){throw Q.error(G),console.error((0,i.$0)(G)),G}})}async f(){const U=new s.$yi,X={_serviceBrand:void 0,...u.default};U.set(t.$nk,X);const x=new o.$fn(this.a,X);U.set(o.$en,x);const Q=new oe.$8P((0,j.$ik)(x),x.logsHome);U.set(j.$8j,Q);const G=new z.$fQ(this.B(Q.createLogger("remoteCLI",{name:(0,se.localize)(0,null)})));U.set(j.$7j,G),G.trace(`Remote configuration data at ${this.b}`),G.trace("process arguments:",this.a);const J=this.B(new g.$Oq(G));U.set(f.$7k,J),J.registerProvider(E.Schemas.file,this.B(new d.$fr(G)));const T=new V.$Gs(J);U.set(N.$El,T);const W=this.B(new Y.$dQ(T,x,J,G));U.set(K.$Gl,W);const ce=this.B(new D.$Lo(W.defaultProfile.settingsResource,J,new Z.$lo,G));return U.set(S.$7i,ce),await Promise.all([ce.initialize(),W.init()]),U.set(P.$Tp,new I.$xi(b.$4r)),U.set(O.$Po,new I.$xi(A.$uQ)),U.set(y.$6l,$.$np),U.set(w.$_o,new I.$xi(v.$eq)),U.set(B.$vq,new I.$xi(M.$eQ)),U.set(te.$zq,new I.$xi(ee.$4P)),U.set(l.$fq,new I.$xi(l.$hq)),U.set(m.$Kq,new I.$xi(m.$Lq)),U.set(n.$Xr,new I.$xi(a.$Zr)),new c.$ir(U)}async g(U){if(this.a["list-extensions"])return U.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return U.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return U.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return U.updateExtensions();if(this.a["locate-extension"])return U.locateExtension(this.a["locate-extension"])}}h(U){return U.map(X=>/\.vsix$/i.test(X)?p.URI.file((0,k.$ic)(X)?X:(0,k.$jc)((0,C.cwd)(),X)):X)}}function ne(F){setTimeout(()=>process.exit(F),0)}async function le(F,U,X){if(F.help){const Q=u.default.serverApplicationName+(ae.$i?".cmd":"");console.log((0,ie.$zm)(u.default.nameLong,Q,u.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(F.version){console.log((0,ie.$Am)(u.default.version,u.default.commit));return}const x=new H(F,U);try{await x.run(),ne(0)}catch{ne(1)}finally{x.dispose()}}}),define(ye[303],Ee([1,0,73,315,28,298,4,12,93]),function(fe,e,s,j,I,D,S,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$gP=void 0;class ${constructor(v,m,l){this.b=v,this.c=m,this.f=l,this.a=j.createServer((c,u)=>this.h(c,u)),this.g().catch(c=>(m.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,m){const l=(u,h)=>{m.writeHead(u,{"content-type":"application/json"}),m.end(JSON.stringify(h||null),g=>g&&this.c.error(g))},c=[];v.setEncoding("utf8"),v.on("data",u=>c.push(u)),v.on("end",async()=>{try{const u=JSON.parse(c.join(""));let h;switch(u.type){case"open":h=await this.i(u);break;case"openExternal":h=await this.j(u);break;case"status":h=await this.l(u);break;case"extensionManagement":h=await this.k(u);break;default:l(404,`Unknown message type: ${u.type}`);break}l(200,h)}catch(u){const h=u instanceof Error?u.message:JSON.stringify(u);l(500,h),this.c.error("Error while processing pipe request",u)}})}async i(v){const{fileURIs:m,folderURIs:l,forceNewWindow:c,diffMode:u,mergeMode:h,addMode:g,forceReuseWindow:d,gotoLineMode:E,waitMarkerFilePath:f,remoteAuthority:t}=v,o=[];if(Array.isArray(l))for(const i of l)try{o.push({folderUri:S.URI.parse(i)})}catch{}if(Array.isArray(m))for(const i of m)try{(0,b.$6i)(i)?o.push({workspaceUri:S.URI.parse(i)}):o.push({fileUri:S.URI.parse(i)})}catch{}const r=f?S.URI.file(f):void 0,a={forceNewWindow:c,diffMode:u,mergeMode:h,addMode:g,gotoLineMode:E,forceReuseWindow:d,preferNewWindow:!d&&!r&&!g,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,a)}async j(v){for(const m of v.uris){const l=S.URI.parse(m),c=l.scheme==="file"?l:m;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(v){const m=c=>c?.map(u=>/\.vsix$/i.test(u)?S.URI.parse(u):u),l={list:v.list,install:m(v.install),uninstall:m(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",l)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.$gP=$;let y=class extends ${constructor(v,m){super(v,m,(0,s.$si)())}};e.$hP=y,e.$hP=y=Le([Oe(0,D.$bP),Oe(1,P.$7j)],y)}),define(ye[304],Ee([1,0,31,6,21,2,7,3,4,73,71,303,125,91,285,287,146,14,126]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=void 0;class d extends c.$VP{constructor(t,o,r,n,a){super({getFolderUri:i=>{const p=o.filter(k=>k.name===i);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(i,p)=>n[`config:${p}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(r)return S.$hc(r.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber,getExtension:async i=>{const k=(await a.getInstalled()).find(C=>C.identifier.id===i);return k&&{extensionLocation:k.location}}},void 0,Promise.resolve(s.homedir()),Promise.resolve(t))}}class E extends D.$Uc{constructor(t,o,r,n,a,i){super(),this.g=t,this.h=o,this.j=r,this.m=n,this.n=a,this.r=i,this.a=0,this.b=new Map,this.c=this.B(new j.$he),this.onExecuteCommand=this.c.event}async call(t,o,r){switch(o){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,r);case"$createProcess":{const n=(0,y.$Hs)(t.remoteAuthority);return this.s(n,r)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,r);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,r);case"$listProcesses":return this.j.listProcesses.apply(this.j,r);case"$getLatency":return this.j.getLatency.apply(this.j,r);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,r);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,r);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case"$start":return this.j.start.apply(this.j,r);case"$input":return this.j.input.apply(this.j,r);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,r);case"$shutdown":return this.j.shutdown.apply(this.j,r);case"$resize":return this.j.resize.apply(this.j,r);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,r);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,r);case"$getCwd":return this.j.getCwd.apply(this.j,r);case"$processBinary":return this.j.processBinary.apply(this.j,r);case"$sendCommandResult":return this.u(r[0],r[1],r[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,r);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,r);case"$getDefaultSystemShell":return this.w.apply(this,r);case"$getProfiles":return this.y.apply(this,r);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(r[0],r[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,r);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,r);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,r);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,r);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,r);case"$updateTitle":return this.j.updateTitle.apply(this.j,r);case"$updateProperty":return this.j.updateProperty.apply(this.j,r);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,r);case"$requestDetachInstance":return this.j.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,r);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${o} not found`)}listen(t,o,r){switch(o){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||j.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||j.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||j.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||j.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||j.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||j.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${o} not found`)}async s(t,o){const r={name:o.shellLaunchConfig.name,executable:o.shellLaunchConfig.executable,args:o.shellLaunchConfig.args,cwd:typeof o.shellLaunchConfig.cwd=="string"||typeof o.shellLaunchConfig.cwd>"u"?o.shellLaunchConfig.cwd:b.URI.revive(t.transformIncoming(o.shellLaunchConfig.cwd)),env:o.shellLaunchConfig.env,useShellEnvironment:o.shellLaunchConfig.useShellEnvironment,reconnectionProperties:o.shellLaunchConfig.reconnectionProperties,type:o.shellLaunchConfig.type,isFeatureTerminal:o.shellLaunchConfig.isFeatureTerminal},n=await(0,u.$tn)(o.resolverEnv,!!o.shellLaunchConfig.useShellEnvironment,P.$w,this.g,this.h,this.r);this.h.trace("baseEnv",n);const a=B=>({uri:b.URI.revive(t.transformIncoming(B.uri)),name:B.name,index:B.index,toResource:()=>{throw new Error("Not implemented")}}),i=o.workspaceFolders.map(a),p=o.activeWorkspaceFolder?a(o.activeWorkspaceFolder):void 0,k=o.activeFileResource?b.URI.revive(t.transformIncoming(o.activeFileResource)):void 0,C=new d(n,i,k,o.resolvedVariables,this.n),A=l.$RP(p,process.env,C),O=await l.$QP(r,s.homedir(),A,p?.uri,o.configuration["terminal.integrated.cwd"],this.h);r.cwd=O;const N=P.$i?"terminal.integrated.env.windows":P.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",V=o.configuration[N],ie=await l.$SP(r,V,A,this.m.version,o.configuration["terminal.integrated.detectLocale"],n);if((0,g.$KP)(r)){const B=[];for(const[z,oe,se]of o.envVariableCollections)B.push([z,{map:(0,m.$ts)(oe),descriptionMap:(0,m.$us)(se)}]);const Z=new Map(B),Y=new v.$xs(Z),M=p?p??void 0:void 0;await Y.applyToProcessEnvironment(ie,{workspaceFolder:M},A)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:O,cols:o.cols,rows:o.rows,env:ie});const ae=(0,$.$si)();ie.VSCODE_IPC_HOOK_CLI=ae;const te=await this.j.createProcess(r,O,o.cols,o.rows,o.unicodeVersion,ie,n,o.options,o.shouldPersistTerminal,o.workspaceId,o.workspaceName),ee={executeCommand:(B,...Z)=>this.t(te,B,Z,t)},K=new w.$gP(ee,this.h,ae);return this.j.onProcessExit(B=>B.id===te&&K.dispose()),{persistentTerminalId:te,resolvedShellLaunchConfig:r}}t(t,o,r,n){const{resolve:a,reject:i,promise:p}=(0,h.$th)(),k=++this.a;this.b.set(k,{resolve:a,reject:i,uriTransformer:n});const C=(0,I.$9n)(r,A=>{if(A&&A.$mid===1)return n.transformOutgoing(A);if(A&&A instanceof b.URI)return n.transformOutgoingURI(A)});return this.c.fire({reqId:k,persistentProcessId:t,commandId:o,commandArgs:C}),p}u(t,o,r){const n=this.b.get(t);if(!n)return;this.b.delete(t);const a=(0,I.$9n)(r,i=>{if(i&&i.$mid===1)return n.uriTransformer.transformIncoming(i)});o?n.reject(a):n.resolve(a)}w(t){return this.j.getDefaultSystemShell(t)}async y(t,o,r,n){return this.j.getProfiles(t,o,r,n)||[]}z(){return{...process.env}}C(t,o){return this.j.getWslPath(t,o)}D(){return this.j.reduceConnectionGraceTime()}}e.$WP=E}),define(ye[305],Ee([1,0,31,6,2,13,7,103,23,47,25,119,224,83,225,26,132,29,89,122,233,129,16,114,69,68,113,84,85,123,12,58,30,42,250,145,121,27,37,263,92,270,34,127,280,281,255,261,304,71,52,289,299,134,59,136,51,33,70,262,117,133,130,116,115,217,294,247,273,267]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A,O,N,V,ie,ae,te,ee,K,B,Z,Y,M,z,oe,se,_,H,ne,le,F,U,X,x,Q,G,J,T,W,ce,ue,we,de,ge,$e,Ce,Ae,he,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=void 0,e.$oQ=Me;const ke="monacoworkbench";async function Me(Qe,Je,xe,pe){const Pe=new i.$yi,je=new Be,Ne={_serviceBrand:void 0,...A.default};Pe.set(O.$nk,Ne);const Ue=new le.$fn(Je,Ne);Pe.set(c.$Hi,Ue),Pe.set(c.$Ii,Ue);const Ve=new ce.$8P((0,C.$ik)(Ue),Ue.logsHome);Pe.set(C.$8j,Ve),je.registerChannel("logger",new ge.$gs(Ve,rt=>He(rt.remoteAuthority)));const nt=Ve.createLogger("remoteagent",{name:(0,$e.localize)(0,null)}),Ye=new de.$fQ(nt,[new Ge((0,C.$ik)(Ue))]);Pe.set(C.$7j,Ye),setTimeout(()=>tt(Ue.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,rt=>Ye.error(rt)),1e4),Ye.onDidChangeLogLevel(rt=>(0,C.log)(Ye,rt,`Log level changed to ${(0,C.$jk)(Ye.getLevel())}`)),Ye.trace(`Remote configuration data at ${xe}`),Ye.trace("process arguments:",Ue.args),Array.isArray(Ne.serverGreeting)&&Ye.info(`

${Ne.serverGreeting.join(`
`)}

`),je.registerChannel(v.$No.ChannelName,new v.$No);const it=new $.$ii(rt=>rt.clientId==="renderer"),at=pe.add(new o.$Oq(Ye));Pe.set(t.$7k,at),at.registerProvider(D.Schemas.file,pe.add(new r.$fr(Ye)));const ot=new M.$Gs(at);Pe.set(Y.$El,ot);const ct=new w.$Lo(Ue.machineSettingsResource,at,new T.$lo,Ye);Pe.set(y.$7i,ct);const lt=new ue.$dQ(ot,Ue,at,Ye);Pe.set(J.$Gl,lt),je.registerChannel("userDataProfiles",new he.$lQ(lt,rt=>He(rt.remoteAuthority)));const[,,ft,$t]=await Promise.all([ct.initialize(),lt.init(),(0,P.$Jn)(Ye.error.bind(Ye)),(0,P.$Kn)(Ye.error.bind(Ye))]),vt=new X.$nn;Pe.set(X.$mn,vt);const Lt=new ie.$4r(ct,Ue,Ye,Ve);Pe.set(N.$Tp,Lt);let St=ee.$rp;const It=(0,ee.$xp)(Ne,ct);if((0,ee.$sp)(Ne,Ue)){!(0,ee.$tp)(Ne,Ue)&&Ne.aiConfig?.ariaKey&&(St=new W.$6P(Lt,It,ke,null,Ne.aiConfig.ariaKey),pe.add((0,I.$Sc)(()=>St?.flush())));const rt={appenders:[St],commonProperties:(0,ae.$jp)((0,s.release)(),(0,s.hostname)(),process.arch,Ne.commit,Ne.version+"-remote",ft,$t,It,"remoteAgent"),piiPaths:(0,ee.$yp)(Ue)},gt=Ue.args["telemetry-level"];let bt=3;gt==="all"?bt=3:gt==="error"?bt=2:gt==="crash"?bt=1:gt!==void 0&&(bt=0),Pe.set(_.$Us,new n.$xi(_.$Ss,[rt,bt]))}else Pe.set(_.$Us,_.$Ts);Pe.set(h.$_o,new n.$xi(u.$eq));const Mt=je.getChannel("download",it);Pe.set(m.$Po,new l.$Ro(Mt,()=>He("renderer"))),Pe.set(G.$vq,new n.$xi(we.$eQ)),Pe.set(x.$zq,new n.$xi(Q.$4P)),Pe.set(g.$fq,new n.$xi(g.$hq)),Pe.set(f.$Kq,new n.$xi(f.$Lq));const mt=new a.$ir(Pe);Pe.set(p.$Xr,mt.createInstance(k.$Zr));const Rt=mt.createInstance(De.$nQ,{graceTime:108e5,shortGraceTime:3e5,scrollback:ct.getValue("terminal.integrated.persistentSessionScrollback")??100}),pt=mt.createInstance(Z.$Cs,Rt);return Pe.set(B.$bs,pt),mt.invokeFunction(rt=>{const gt=rt.get(f.$Kq),bt=rt.get(x.$zq),Ht=rt.get(h.$_o),_t=rt.get(p.$Xr),en=new z.$Os(Qe,Ue,lt,vt);je.registerChannel("remoteextensionsenvironment",en);const Tt=new se.$Vs(rt.get(_.$Us),St);je.registerChannel("telemetry",Tt),je.registerChannel(F.$XP,new H.$WP(Ue,Ye,pt,Ne,gt,ct));const Ut=new Ce.$jQ(mt.createInstance(d.$iq,Ye),Ue,lt,bt,Ye,Ht,_t);je.registerChannel(Ae.$iQ,new Ce.$kQ(Ut,Dt=>He(Dt.remoteAuthority)));const Vt=pe.add(new oe.$Rs(Ye,Ue));je.registerChannel(U.$2P,Vt),je.registerChannel("request",new V.$1r(rt.get(N.$Tp)));const Wt=new E.$jq(gt,Dt=>He(Dt.remoteAuthority));return je.registerChannel("extensions",Wt),Ut.whenExtensionsReady().then(()=>gt.cleanUp()),pe.add(new K.default(rt.get(te.$6l))),{telemetryService:rt.get(te.$6l)}}),{socketServer:je,instantiationService:mt}}const Fe=Object.create(null);function He(Qe){return Fe[Qe]||(Fe[Qe]=(0,ne.$Hs)(Qe)),Fe[Qe]}class Be extends $.$ei{constructor(){const Je=new j.$he;super(Je.event),this.b=Je}acceptConnection(Je,xe){this.b.fire({protocol:Je,onDidClientDisconnect:xe})}}e.$pQ=Be;class Ge extends C.$_j{constructor(Je=C.$0j){super(),this.setLevel(Je),this.g=!!process.stdout.isTTY}trace(Je,...xe){this.f(C.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Je,...xe):console.log(`[${Ze()}]`,Je,...xe))}debug(Je,...xe){this.f(C.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Je,...xe):console.log(`[${Ze()}]`,Je,...xe))}info(Je,...xe){this.f(C.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Je,...xe):console.log(`[${Ze()}]`,Je,...xe))}warn(Je,...xe){this.f(C.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ze()}]\x1B[0m`,Je,...xe):console.warn(`[${Ze()}]`,Je,...xe))}error(Je,...xe){this.f(C.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ze()}]\x1B[0m`,Je,...xe):console.error(`[${Ze()}]`,Je,...xe))}flush(){}}function Ze(){const Qe=new Date;return`${_e(Qe.getHours())}:${_e(Qe.getMinutes())}:${_e(Qe.getSeconds())}`}function _e(Qe){return Qe<10?`0${Qe}`:String(Qe)}async function tt(Qe){const Je=S.$nc(Qe),xe=S.$mc(Qe),je=(await b.Promises.readdir(xe)).filter(Ue=>/^\d{8}T\d{6}$/.test(Ue)).sort().filter(Ue=>Ue!==Je),Ne=je.slice(0,Math.max(0,je.length-9));await Promise.all(Ne.map(Ue=>b.Promises.rm(S.$jc(xe,Ue))))}}),define(ye[306],Ee([1,0,90,28,78,307,87,97,15,11,35,2,13,7,44,3,17,4,22,182,168,302,108,73,25,5,12,30,27,146,274,275,52,305,277]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v,m,l,c,u,h,g,d,E,f,t,o,r,n,a,i,p,k,C,A,O,N,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=te;const ie=5*60*1e3;let ae=class extends w.$Uc{constructor(B,Z,Y,M,z,oe,se,_,H){super(),this.n=B,this.r=Z,this.s=Y,this.t=oe,this.u=se,this.w=_,this.y=H,this.h=ee.create(this.u),this.j=(0,v.$Og)(se,z),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=M?this.y.createInstance(V.$sQ,this.r,z??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(B,Z){if(B.method!=="GET")return(0,V.$qQ)(B,Z,405,`Unsupported method ${B.method}`);if(!B.url)return(0,V.$qQ)(B,Z,400,"Bad request.");const Y=S.parse(B.url,!0);let M=Y.pathname;if(!M)return(0,V.$qQ)(B,Z,400,"Bad request.");if(M.startsWith(this.j)&&M.charCodeAt(this.j.length)===47&&(M=M.substring(this.j.length)),M==="/version")return Z.writeHead(200,{"Content-Type":"text/plain"}),void Z.end(this.u.commit||"");if(M==="/delay-shutdown")return this.N(),Z.writeHead(200),void Z.end("OK");if(!(0,A.$Bn)(this.r,B,Y))return(0,V.$qQ)(B,Z,403,"Forbidden.");if(M==="/vscode-remote-resource"){const z=Y.query.path;if(typeof z!="string")return(0,V.$qQ)(B,Z,400,"Bad request.");let oe;try{oe=h.URI.from({scheme:v.Schemas.file,path:z}).fsPath}catch{return(0,V.$qQ)(B,Z,400,"Bad request.")}const se=Object.create(null);this.t.isBuilt&&((0,y.$zg)(oe,this.t.builtinExtensionsPath,!c.$k)||(0,y.$zg)(oe,this.t.extensionsPath,!c.$k))&&(se["Cache-Control"]="public, max-age=31536000"),se.Vary="Origin";const _=B.headers.origin;return _&&this.h.matches(_)&&(se["Access-Control-Allow-Origin"]=_),(0,V.$rQ)(oe,1,this.w,B,Z,se)}if(this.g){this.g.handle(B,Z,Y);return}return Z.writeHead(404,{"Content-Type":"text/plain"}),void Z.end("Not found")}handleUpgrade(B,Z){let Y=(0,g.$Wg)(),M=!1,z=!1;if(B.url){const le=S.parse(B.url,!0).query;typeof le.reconnectionToken=="string"&&(Y=le.reconnectionToken),le.reconnection==="true"&&(M=!0),le.skipWebSocketFrames==="true"&&(z=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){Z.end("HTTP/1.1 400 Bad Request");return}const oe=B.headers["sec-websocket-key"],se=s.createHash("sha1");se.update(oe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const H=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se.digest("base64")}`];let ne=!1;if(!z&&!this.t.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const le=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const F of le)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(F)){if(/\b(permessage-deflate)\b/.test(F)){ne=!0,H.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(F)){ne=!0,H.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}Z.write(H.join(`\r
`)+`\r
\r
`),Z.setTimeout(0),Z.setNoDelay(!0),z?this.D(new o.$pi(Z,`server-connection-${Y}`),M,Y):this.D(new o.$qi(new o.$pi(Z,`server-connection-${Y}`),ne,null,!0),M,Y)}handleServerError(B){this.w.error("Error occurred in server"),this.w.error(B)}z(B){let Z;return B instanceof o.$pi?Z=B.socket:Z=B.socket.socket,Z.remoteAddress||"<unknown>"}async C(B,Z,Y){const M=Z.getSocket();this.w.error(`${B} ${Y}.`);const z={type:"error",reason:Y};Z.sendControl(b.$Je.fromString(JSON.stringify(z))),Z.dispose(),await M.drain(),M.dispose()}D(B,Z,Y){const M=this.z(B),z=`[${M}][${Y.substr(0,8)}]`,oe=new t.$oi({socket:B}),se=this.s?new this.s.validator:null,_=this.s?new this.s.signer:null;let H;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(H||(H={}));let ne=0;const le=U=>{ne=3,F.dispose(),this.C(z,oe,U)},F=oe.onControlMessage(U=>{if(ne===0){let X;try{X=JSON.parse(U.toString())}catch{return le("Malformed first message")}if(X.type!=="auth")return le("Invalid first message");if(this.r.type===2&&!this.r.validate(X.auth))return le("Unauthorized client refused: auth mismatch");let x=(0,g.$Wg)();if(_)try{x=_.sign(X.data)}catch{}let Q=(0,g.$Wg)();if(se)try{Q=se.createNewMessage(Q)}catch{}const G={type:"sign",data:Q,signedData:x};oe.sendControl(b.$Je.fromString(JSON.stringify(G))),ne=1}else if(ne===1){let X;try{X=JSON.parse(U.toString())}catch{return le("Malformed second message")}if(X.type!=="connectionType")return le("Invalid second message");if(typeof X.signedData!="string")return le("Invalid second message field type");const x=X.commit,Q=this.u.commit;if(x&&Q&&x!==Q)return le("Client refused: version mismatch");let G=!1;if(!se)G=!0;else if(this.r.validate(X.signedData))G=!0;else try{G=se.validate(X.signedData)==="ok"}catch{}if(!G){if(this.t.isBuilt)return le("Unauthorized client refused");this.w.error(`${z} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const J in this.b)this.b[J].shortenReconnectionGraceTimeIfNecessary();for(const J in this.a)this.a[J].shortenReconnectionGraceTimeIfNecessary();ne=2,F.dispose(),this.F(M,z,oe,B,Z,Y,X)}})}async F(B,Z,Y,M,z,oe,se){const _=se.desiredConnectionType===1?`${Z}[ManagementConnection]`:se.desiredConnectionType===2?`${Z}[ExtensionHostConnection]`:Z;if(se.desiredConnectionType===1)if(z){if(!this.b[oe])return this.f.has(oe)?this.C(_,Y,"Unknown reconnection token (seen before)"):this.C(_,Y,"Unknown reconnection token (never seen)");Y.sendControl(b.$Je.fromString(JSON.stringify({type:"ok"})));const H=Y.readEntireBuffer();Y.dispose(),this.b[oe].acceptReconnection(B,M,H)}else{if(this.b[oe])return this.C(_,Y,"Duplicate reconnection token");Y.sendControl(b.$Je.fromString(JSON.stringify({type:"ok"})));const H=new C.$vn(this.w,oe,B,Y);this.n.acceptConnection(H.protocol,H.onClose),this.b[oe]=H,this.f.add(oe),H.onClose(()=>{delete this.b[oe]})}else if(se.desiredConnectionType===2){const H=se.args||{language:"en"},ne=await this.I(H);if(ne.port&&this.w.trace(`${_} - startParams debug port ${ne.port}`),this.w.trace(`${_} - startParams language: ${ne.language}`),this.w.trace(`${_} - startParams env: ${JSON.stringify(ne.env)}`),z){if(!this.a[oe])return this.f.has(oe)?this.C(_,Y,"Unknown reconnection token (seen before)"):this.C(_,Y,"Unknown reconnection token (never seen)");Y.sendPause(),Y.sendControl(b.$Je.fromString(JSON.stringify(ne.port?{debugPort:ne.port}:{})));const le=Y.readEntireBuffer();Y.dispose(),this.a[oe].acceptReconnection(B,M,le)}else{if(this.a[oe])return this.C(_,Y,"Duplicate reconnection token");Y.sendPause(),Y.sendControl(b.$Je.fromString(JSON.stringify(ne.port?{debugPort:ne.port}:{})));const le=Y.readEntireBuffer();Y.dispose();const F=this.y.createInstance(k.$un,oe,B,M,le);this.a[oe]=F,this.f.add(oe),F.onClose(()=>{delete this.a[oe],this.J()}),F.start(ne)}}else if(se.desiredConnectionType===3){const H=se.args;this.G(Y,H)}else return this.C(_,Y,"Unknown initial data received")}async G(B,Z){const Y=B.getSocket().socket,M=B.readEntireBuffer();B.dispose(),Y.pause();const z=await this.H(Z.host,Z.port);M.byteLength>0&&z.write(M.buffer),z.on("end",()=>Y.end()),z.on("close",()=>Y.end()),z.on("error",()=>Y.destroy()),Y.on("end",()=>z.end()),Y.on("close",()=>z.end()),Y.on("error",()=>z.destroy()),z.pipe(Y),Y.pipe(z)}H(B,Z){return new Promise((Y,M)=>{const z=I.createConnection({host:B,port:Z,autoSelectFamily:!0},()=>{z.removeListener("error",M),z.pause(),Y(z)});z.once("error",M)})}I(B){return typeof B.port=="number"?(0,E.$Yg)(B.port,10,5e3).then(Z=>(B.port=Z,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(B=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!B?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},ie))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ae=Le([Oe(5,O.$en),Oe(6,i.$nk),Oe(7,a.$7j),Oe(8,n.$zi)],ae);async function te(K,B,Z){const Y=await(0,A.$An)(B);Y instanceof A.$yn&&(console.warn(Y.message),process.exit(1));function M(J){(0,$.setUnexpectedErrorHandler)(T=>{(0,$.$Z)(T)&&T.stack&&/unexpectedErrorHandler/.test(T.stack)||J(T)})}const z=[];M(J=>{z.push(J),console.error(J)});let oe=!1;process.on("SIGPIPE",()=>{oe||(oe=!0,(0,$.$1)(new Error("Unexpected SIGPIPE")))});const se=new w.$Tc,{socketServer:_,instantiationService:H}=await(0,N.$oQ)(Y,B,Z,se);H.invokeFunction(J=>{const T=J.get(a.$7j);z.forEach(W=>T.error(W)),z.length=0,M(W=>T.error(W))}),H.invokeFunction(J=>{const T=J.get(r.$7i);c.$i&&(T.getValue("security.restrictUNCAccess")===!1?(0,f.disableUNCAccessRestrictions)():(0,f.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")))}),H.invokeFunction(J=>{const T=J.get(a.$7j);if(c.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const W=(0,m.$jc)(process.env.HOMEDRIVE,"node_modules"),ce=(0,m.$mc)((0,m.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ue=(0,m.$jc)(ce,"node_modules");if(j.existsSync(W)||j.existsSync(ue)){const we=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${W}
* ${ue}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;T.warn(we),console.warn(we),process.exit(0)}}});const ne=H.invokeFunction(J=>{const T=J.get(a.$7j);if(j.existsSync((0,m.$jc)(v.$Ug.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ce){T.error(ce)}return null});let le=B["server-base-path"];le&&!le.startsWith("/")&&(le=`/${le}`);const F=j.existsSync(v.$Ug.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(F&&K&&typeof K!="string"){const J=Y.type!==0?`?${v.$Mg}=${Y.value}`:"";console.log(`Web UI available at http://localhost${K.port===80?"":`:${K.port}`}${le??""}${J}`)}const U=H.createInstance(ae,_,Y,ne,F,le);l.mark("code/server/ready");const X=D.performance.now(),x=global.vscodeServerStartTime,Q=global.vscodeServerListenTime,G=global.vscodeServerCodeLoadedTime;if(H.invokeFunction(async J=>{const T=J.get(p.$6l);if(T.publicLog2("serverStart",{startTime:x,startedTime:Q,codeLoadedTime:G,readyTime:X}),c.$k){const W=J.get(a.$7j),ce=await(0,d.$Xg)(W.error.bind(W));ce&&T.publicLog2("serverPlatformInfo",{platformId:ce.id,platformVersionId:ce.version_id,platformIdLike:ce.id_like})}}),B["print-startup-performance"]){const J=P.$U.get();let T="";T+=`

### Load AMD-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],J.amdLoad),T+=`

### Load commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],J.nodeRequire),T+=`

### Invoke AMD-module factory
`,T+=P.$U.toMarkdownTable(["Module","Duration"],J.amdInvoke),T+=`

### Invoke commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],J.nodeEval),T+=`Start-up time: ${Q-x}
`,T+=`Code loading time: ${G-x}
`,T+=`Initialized time: ${X-x}
`,T+=`
`,console.log(T)}return U}class ee{static create(B){const Z=B.webEndpointUrlTemplate,Y=B.commit,M=B.quality;if(!Z||!Y||!M)return new ee(null);const z=(0,g.$Wg)(),se=new URL(Z.replace("{{uuid}}",z).replace("{{commit}}",Y).replace("{{quality}}",M)).origin,_=(0,u.$df)(se).replace(z,"[a-zA-Z0-9\\-]+");try{const H=(0,u.$mf)(`^${_}$`,!0,{matchCase:!1});return new ee(H)}catch{return new ee(null)}}constructor(B){this.a=B}matches(B){return this.a?this.a.test(B):!1}}}),define(ye[316],Ee([1,0,31,28,13,301,306,67,7,307,52,58,44]),function(fe,e,s,j,I,D,S,P,b,$,y,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=o,e.createServer=r,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const m={onMultipleValues:(n,a)=>{console.error(`Option '${n}' can only be defined once. Using value ${a}.`)},onEmptyValue:n=>{console.error(`Ignoring option '${n}': Value must not be empty.`)},onUnknownOption:n=>{console.error(`Ignoring option '${n}': not supported for server.`)},onDeprecatedOption:(n,a)=>{console.warn(`Option '${n}' is deprecated: ${a}`)}},l=(0,P.$xm)(process.argv.slice(2),y.$dn,m),c=l["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.$jc)(s.homedir(),w.default.serverDataFolderName||".vscode-remote"),u=(0,b.$jc)(c,"data"),h=(0,b.$jc)(u,"User"),g=(0,b.$jc)(h,"globalStorage"),d=(0,b.$jc)(h,"History"),E=(0,b.$jc)(u,"Machine");l["user-data-dir"]=u;const f=(0,b.$mc)(I.$Ug.asFileUri("").fsPath),t=(0,b.$jc)(f,"extensions");l["builtin-extensions-dir"]=t,l["extensions-dir"]=l["extensions-dir"]||(0,b.$jc)(c,"extensions"),[c,l["extensions-dir"],u,h,E,g,d].forEach(n=>{try{j.existsSync(n)||j.mkdirSync(n,{mode:448})}catch(a){console.error(a)}});function o(){(0,D.run)(l,c,y.$dn)}function r(n){return(0,S.$tQ)(n,l,c)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/server/node/server.main.js.map
